<?php

class Automation extends Controller {

	function Automation(){
		parent::Controller();
		$this->load->helper('file');
	}
	
	function Index(){
		$this->load->view('header');
		$this->load->view('automation/index');
		$this->load->view('footer');
	}
	
	function Process(){
		$module->name = "Healthcare";
		$module->short_name = "hms";
		
		$submodule1->name = 'Admissions';
		$submodule1->short_name = "admission";
		$submodule1->table_structure = array(
			'id'			=> 'display:ID,type:primary',
			'name'			=> 'display:Name,type:name',
			'agent_id'		=> 'display:Agent,type:id,relations:contacts.id,dropdown:contacts.id|contacts.contact_person',
			'phone'			=> 'display:Phone,type:phone',
			'dob'			=> 'display:Date of Birth,type:date',
			'email'			=> 'display:Email,type:email,nonchangeable:1',
			'address1'		=> 'display:Address 1,type:text',
			'address2'		=> 'display:Address 2,type:text',
			'postcode'		=> 'display:Postcode,type:shorttext',
			'city'			=> 'display:City,type:text',
			'state'			=> 'display:State,type:state',
			'country'		=> 'display:Country,type:country',
			'credit_limit'	=> 'display:Credit Limit,type:decimal_currency',
			'rank'			=> 'display:Rank,type:shorttext',
			'remarks'		=> 'display:Remarks,type:text',
			'points'		=> 'display:Points,type:integer,nonentry:1'
		);
		
		$submodule1->grid_view = array(
			'name'			=> 'width:auto',
			'agent_id'		=> 'width:200px',
			'phone'			=> 'width:100px',
			'email'			=> 'width:100px',
			'dob'			=> 'width:100px,format_date:d/m/Y',
			'state'			=> 'width:100px'
		);
		
		$submodule1->new_view = "
			#Header > Member Information
			#Form-Dual > 
				name-mandatory|email-mandatory
				phone-mandatory|dob-mandatory
				address1-mandatory|address2-
				city-mandatory|postcode-mandatory
				state-mandatory|country-mandatory
				rank-mandatory,dropdown:{'1'='Admin';'2'='Subadmin';'3'='User'}|agent_id-mandatory
			#Header > Remarks
			#Form-Single >
				remarks-textarea";
				
		$submodule1->edit_view = "
			#Header > Member Information
			#Form-Dual > 
				name-mandatory|email-mandatory
				phone-mandatory|dob-mandatory
				address1-mandatory|address2-
				city-mandatory|postcode-mandatory
				state-mandatory|country-mandatory
			#Header > Remarks
			#Form-Single > 
				remarks-textarea";
				
		$submodule1->detail_view = "
			#Header > Member Information
			#Form-Dual >
				name-mandatory|email-mandatory
				phone-mandatory|dob-mandatory
				address1-mandatory|address2-
				city-mandatory|postcode-mandatory
				state-mandatory|country-mandatory
			#Header > Remarks
			#Form-Single >
				remarks-textarea";
				
				
				
				
$module->name		= "Todolist";
$module->short_name	= "todo";

$submodule1->name 		= "Tasks";
$submodule1->short_name	= "task";
$submodule1->table_structure = array(
		'id'				=> 'display:ID,type:primary',
		'task'				=> 'display:Task,type:shorttext',
		'description'		=> 'display:Description,type:text',
		'deadline'			=> 'display:Deadline,type:date',
		'assigned_to'		=> 'display:Assigned To,type:shortext,dropdown:contacts.contact_person|contacts.contact_person'
	);
	
	$submodule1->grid_view = array(
		'task'			=> 'width:auto',
		'deadline'		=> 'width:100px',
		'assigned_to'	=> 'width:100px'
	);
	
	$submodule1->new_view = "
		#Header > Task Information
		#Form-Single >
			task-mandatory
			description-mandatory
			assigned_to-mandatory
	";
	
	$submodule1->edit_view = "
		#Header > Task Information
		#Form-Single >
			task-mandatory
			description-mandatory
			assigned_to-mandatory
	";
				
		
		// $data->submodules = array($submodule1);
		
		
$module->name = 'Registry';
$module->short_name = 'reg';

// LEAST DEPENDENT TO MOST DEPENDENT


$submodule1->name			= 'Providers';
$submodule1->short_name		= 'provider';
$submodule1->table_structure= array(
	'id'			=> 'display:ID,type:primary',
	'name'			=> 'display:Name,type:name',
	'reg_no'		=> 'display:Registration No.,type:shorttext',
	'type'			=> 'display:Type,type:shorttext',
	'phone'			=> 'display:Phone,type:phone',
	'fax'			=> 'display:Fax,type:phone',
	'email'			=> 'display:Email,type:email',
	'address1'		=> 'display:Address 1,type:text',
	'address2'		=> 'display:Address 2,type:text',
	'postcode'		=> 'display:Postcode,type:shorttext',
	'city'			=> 'display:City,type:shorttext',
	'state'			=> 'display:State,type:state',
	'country'		=> 'display:Country,type:country',
	'remarks'		=> 'display:Remarks,type:text',
	'manager'		=> 'display:Manager,type:dropdown:users.id|users.firstname users.lastname'
);
$submodule1->grid_view = array(
	'name'			=> 'width:auto',
	'reg_no'		=> 'width:200px',
	'phone'			=> 'width:100px',
	'email'			=> 'width:100px',
	'state'			=> 'width:100px'
);

$submodule1->add_view = "
	#Header > Provider Information
	#Form-Dual >
		name-mandatory|reg_no-mandatory
		type-mandatory,dropdown:{'Hospital'=>'Hospital','Clinic'=>'Clinic'}|email-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
	#Form-Single >
		manager-mandatory
	#Header > Remarks
		remarks-textarea
";

$submodule1->edit_view = "
	#Header > Provider Information
	#Form Dual >
		name-mandatory|reg_no-mandatory
		type-mandatory,dropdown:{'Hospital'=>'Hospital','Clinic'=>'Clinic'}|email-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
	#Form-Single >
		manager-mandatory
	#Header > Remarks
		remarks-textarea
";

$submodule1->detail_view = "
Header > Provider Information
	#Form Dual >
		name-mandatory|reg_no-mandatory
		type-mandatory,dropdown:{'Hospital'=>'Hospital','Clinic'=>'Clinic'}|email-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
	#Form-Single >
		manager-mandatory
	#Header > Remarks
		remarks-textarea
";

$submodule2->name			= 'Agents';
$submodule2->short_name		= 'agent';
$submodule2->table_structure= array(
	'id'			=> 'display:ID,type:primary',
	'name'			=> 'display:Name,type:name',
	'reg_no'		=> 'display:Registration No.,type:shorttext',
	'type'			=> 'display:Type,type:shorttext',
	'phone'			=> 'display:Phone,type:phone',
	'fax'			=> 'display:Fax,type:phone',
	'email'			=> 'display:Email,type:email',
	'address1'		=> 'display:Address 1,type:text',
	'address2'		=> 'display:Address 2,type:text',
	'postcode'		=> 'display:Postcode,type:shorttext',
	'city'			=> 'display:City,type:shorttext',
	'state'			=> 'display:State,type:state',
	'country'		=> 'display:Country,type:country',
	'remarks'		=> 'display:Remarks,type:text',
	'manager'		=> 'display:Manager,type:dropdown:users.id|users.firstname users.lastname'
);

$submodule2->grid_view = array(
	'name'			=> 'width:auto',
	'reg_no'		=> 'width: 100px',
	'phone'			=> 'width: 100px',
	'email'			=> 'width: 100px',
	'state'			=> 'width: 80px'
);

$submodule2->add_view = "
	#Header > Agent Information
	#Form-Dual >
		name-mandatory|reg_no-mandatory
		type-|email-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
	#Form-Single >
		manager-mandatory
	#Header > Remarks
		remarks-textarea
";

$submodule2->edit_view = "
	#Header > Agent Information
	#Form-Dual >
		name-mandatory|reg_no-mandatory
		type-|email-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
	#Form-Single >
		manager-mandatory
	#Header > Remarks
		remarks-textarea
";

$submodule2->detail_view = "
	#Header > Agent Information
	#Form-Dual >
		name-mandatory|reg_no-mandatory
		type-|email-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
	#Form-Single >
		manager-mandatory
	#Header > Remarks
		remarks-textarea
";

$submodule3->name 			= 'Corporations';
$submodule3->short_name 	= 'corporation';
$submodule3->table_structure= array(
	'id'			=> 'display:ID,type:primary',
	'agent_id'		=> 'display:Agent,type:dropdown:agent.id|agent.name',
	'name'			=> 'display:Name,type:name',
	'reg_no'		=> 'display:Registration No.,type:shorttext',
	'type'			=> 'display:Type,type:shorttext',
	'phone'			=> 'display:Phone,type:phone',
	'fax'			=> 'display:Fax,type:phone',
	'email'			=> 'display:Email,type:email',
	'address1'		=> 'display:Address 1,type:text',
	'address2'		=> 'display:Address 2,type:text',
	'postcode'		=> 'display:Postcode,type:shorttext',
	'city'			=> 'display:City,type:shorttext',
	'state'			=> 'display:State,type:state',
	'country'		=> 'display:Country,type:country',
	'remarks'		=> 'display:Remarks,type:text',
	'manager'		=> 'display:Manager,type:dropdown:users.id|users.firstname users.lastname'
);

$submodule3->grid_view = array(
	'name'			=> 'width:auto',
	'phone'			=> 'width:100px',
	'fax'			=> 'width:100px',
	'email'			=> 'width:100px',
	'city'			=> 'width:100px',
	'state'			=> 'width:100px'
);

$submodule3->add_view = "
	#Header > Corporation Information
	#Form-Dual >
		name-mandatory|reg_no-mandatory
		email-mandatory|agent_id-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
		manager-mandantory
	#Header > Remarks
		remarks-textarea
";

$submodule3->edit_view = "
	#Header > Corporation Information
	#Form-Dual >
		name-mandatory|reg_no-mandatory
		email-mandatory|agent_id-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
		manager-mandantory
	#Header > Remarks
		remarks-textarea
";

$submodule3->detail_view = "
	#Header > Corporation Information
	#Form-Dual >
		name-mandatory|reg_no-mandatory
		email-mandatory|agent_id-mandatory
		phone-mandatory|fax-
		address1-mandatory|address2-
		postcode-mandatory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Account Manager
		manager-mandantory
	#Header > Remarks
		remarks-textarea
";



$submodule4->name 			= 'Members';
$submodule4->short_name 	= 'member';
$submodule4->table_structure= array(
	'id'			=> 'display:ID,type:primary',
	'corporation_id'=> 'display:Corporation,type:dropdown:corporation.id|corporation.name',
	'name'			=> 'display:Name,type:name',
	'dob'			=> 'display:Date of Birth,type:date',
	'nric'			=> 'display:IC,type:shorttext',
	'gender'		=> 'display:Gender,type:shorttext',
	'plan'			=> 'display:Plan,type:shorttext',
	'phone'			=> 'display:Phone,type:phone',
	'email'			=> 'display:Email,type:email',
	'address1'		=> 'display:Address 1,type:text',
	'address2'		=> 'display:Address 2,type:text',
	'postcode'		=> 'display:Postcode,type:shorttext',
	'city'			=> 'display:City,type:shorttext',
	'state'			=> 'display:State,type:state',
	'country'		=> 'display:Country,type:country',
	'remarks'		=> 'display:Remarks,type:text'
);

$submodule4->grid_view 		= array(
	'name'			=> 'width:auto',
	'corporation'	=> 'width:200px',
	'nric'			=> 'width:100px',
	'phone'			=> 'width:100px'
);

$submodule4->add_view = "
	#Header > Employer
	#Form-Single >
		corporation_id-mandatory
	#Header > Member Information
	#Form-Dual >
		name-mandantory|nric-mandatory
		gender-mandatory|plan-mandantory
		phone-mandantory|email-
		address1-mandatory|address2-
		postcode-mandantory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Remarks
		remarks-textarea
";

$submodule4->edit_view = "
	#Header > Employer
	#Form-Single >
		corporation_id-mandatory
	#Header > Member Information
	#Form-Dual >
		name-mandantory|nric-mandatory
		gender-mandatory|plan-mandantory
		phone-mandantory|email-
		address1-mandatory|address2-
		postcode-mandantory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Remarks
		remarks-textarea
";

$submodule4->detail_view = "
	#Header > Employer
	#Form-Single >
		corporation_id-mandatory
	#Header > Member Information
	#Form-Dual >
		name-mandantory|nric-mandatory
		gender-mandatory|plan-mandantory
		phone-mandantory|email-
		address1-mandatory|address2-
		postcode-mandantory|city-mandatory
		state-mandatory|country-mandatory
	#Header > Remarks
		remarks-textarea
";



$data->submodules = array($submodule1, $submodule2, $submodule3, $submodule4);
		
		// CREATE CONTROLLER
		
		mkdir('./_AUTOMATION/'.$module->name);
		mkdir('./_AUTOMATION/'.$module->name.'/controllers');
		mkdir('./_AUTOMATION/'.$module->name.'/models');
		mkdir('./_AUTOMATION/'.$module->name.'/views');
		mkdir('./_AUTOMATION/'.$module->name.'/views/'.$module->short_name);
		
		$controller = "<?php \n\n";
		$controller .= 'class '.$module->name.' extends Controller {';
		$controller .= "\n";
		
		$controller .= '
		
	function '.$module->name.'(){
		parent::Controller();
		$this->load->model("'.$module->short_name.'");
	}
		
	function Index(){
		$this->load->view("header");
		$this->load->view("'.$module->short_name.'/index", $this->d);
		$this->load->view("footer");
	}
';
		
		foreach ($data->submodules as $submodule){
		
		$controller .= '
	
	function '.$submodule->name.'(){
		$this->d["'.$submodule->short_name.'s"] = $this->'.$module->short_name.'->get_'.$submodule->short_name.'();
		$this->load->view(\''.$module->short_name.'/'.$submodule->short_name.'\', $this->d);
	}
	
	function Filter_'.$submodule->short_name.'(){
		$this->d["'.$submodule->short_name.'s"] = $this->'.$module->short_name.'->get_'.$submodule->short_name.'();	
		$this->load->view(\''.$module->short_name.'/'.$submodule->short_name.'-filtered\');
	}
	
	function New_'.$submodule->short_name.'($do){
		if ($do == \'do\'){
			$this->'.$module->short_name.'->add_'.$submodule->short_name.'();
	 		echo \'<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>\';	
		} else {
			$this->load->view(\''.$module->short_name.'/'.$submodule->short_name.'-new\', $this->d);
		}
	}
	
	function Edit_'.$submodule->short_name.'($id, $do){
		if ($do == \'do\'){
			$this->'.$module->short_name.'->edit_'.$submodule->short_name.'($id);
			echo \'<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>\';	
		} else {
			$this->d["'.$submodule->short_name.'"] = $this->'.$module->short_name.'->get_'.$submodule->short_name.'_by_id($id);
			$this->load->view(\''.$module->short_name.'/'.$submodule->short_name.'-edit\', $this->d);
		}
	}
	
	function View_'.$submodule->short_name.'($id){
		$this->d["'.$submodule->short_name.'"] = $this->'.$module->short_name.'->get_'.$submodule->short_name.'_by_id($id);
		$this->load->view(\''.$module->short_name.'/'.$submodule->short_name.'-view\', $this->d);	
	}
	
	function Process_'.$submodule->short_name.'(){
	
	}
	
	function Delete_'.$submodule->short_name.'($id, $do){
		if ($do == \'do\'){
			$this->'.$module->short_name.'->delete_'.$submodule->short_name.'($id);
			echo \'ok\';
		}
	}
	
	function Config(){
		$this->load->view("'.$module->name.'/config");
	}
	
	';
		}
		
		$controller .= "\n}";
		
		echo "<h1>Controller</h1>";
		echo "<pre>";
		echo htmlentities($controller);
		echo "</pre>";
		
		write_file('./_AUTOMATION/'.$module->name.'/controllers/'.strtolower($module->name).'.php', $controller);
		
		
		
		// CREATE MODEL
		
		$model = "<?php \n\n";
		$model .= 'class '.strtoupper($module->short_name).' extends Model {';
		$model .= "\n";
		
		foreach ($data->submodules as $submodule){
		
			$add_rows = null;
			$edit_rows = null;
		
			foreach ($submodule->table_structure as $field => $opt){
				$row = $this->add_rows_processing($field, $opt);
				if ($row) $add_rows[] = $row;
				
				$row = $this->edit_rows_processing($field, $opt);
				if ($row) $edit_rows[] = $row;
			}
			
			$add_rows_string = implode("\n", $add_rows);
			$edit_rows_string = implode("\n", $edit_rows);
		
		
		$model .= '
		
	function Get_'.$submodule->short_name.'($where, $sort_n_limit){
		if ($where) $where = " WHERE " . $where;
		$query = $this->db->query("SELECT * FROM `'.$module->short_name.'_'.$submodule->short_name.'` {$where} {$sort_n_limit}");
		return $query->result();
	}
	
	function Get_'.$submodule->short_name.'_by_id(){
		$query = $this->db->query("SELECT * FROM `'.$module->short_name.'_'.$submodule->short_name.'` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Add_'.$submodule->short_name.'(){
		$query = $this->db->insert("'.$module->short_name.'_'.$submodule->short_name.'", array(	
'.$add_rows_string.'
			"added_on"			=> date("Y-m-d H:i:s"),
			"added_by"			=> $this->user->data("username")
		));
		
		return $query->insert_id;
	}	
	
	function Edit_'.$submodule->short_name.'($id){
		$query = $this->db->update("'.$module->short_name.'_'.$submodule->short_name.'", array(	
'.$edit_rows_string.'
			"modified_on"		=> date("Y-m-d H:i:s"),
			"modified_by"		=> $this->user->data("username")
		),"`id` = \'{$id}\'");
		
	}
	
	function Delete_'.$submodule->short_name.'($id){
		$this->db->query("DELETE FROM `hms_'.$submodule->short_name.'` WHERE `id` = ?", array($id));
	}
		
		';
		
		}
				
		$model .= "\n}";
		
		echo "<h1>Model</h1>";
		echo "<pre>";
		echo htmlentities($model);
		echo "</pre>";
		

		write_file('./_AUTOMATION/'.$module->name.'/models/'.strtolower($module->short_name).'.php', $model);
		
		
		// CREATE VIEWS
		
		echo "<h1>Views</h1>";
		
		$index_view = '
<?php if (!$this->user->has_access("'.$module->name.'")) die("You do not have the permissions to access this area."); ?>	

<div>
	<div id="global-sidebar">
		<ul id="global-sidebar-list">
			<div class="global-sidebar-control">
				<?php if ($this->user->has_permission("to_view_settings","'.$module->name.'")): ?>
				<a style="margin-right: 5px;" href="'.$module->name.'/config" class="target_main settings-button"><img src="<?=base_url()?>images/settings_button.gif" /></a>
				<?php endif; ?>
			</div>

				<li class="current"><a href="'.$module->name.'/overview" class="overview">Overview</a></li>
		';
		
		foreach ($data->submodules as $submodule){
		
			$index_view .= '
			<?php if ($this->user->has_permission("to_view_'.$submodule->short_name.'","'.$module->name.'")): ?>
				<li><a href="'.$module->name.'/'.$submodule->short_name.'s" class="'.$module->short_name.'-'.$submodule->short_name.'">'.$submodule->name.'</a></li>
			<?php endif; ?>
			';
		}
		
		$index_view .= '
		</ul>
	</div>
	<div id="global-content">	
	
	</div>
</div>
';
		echo "<h3>".$module->name." Index View</h3>";
		echo "<pre>";
		echo htmlentities($index_view);
		echo "</pre>";
		
		
		write_file('./_AUTOMATION/'.$module->name.'/views/'.$module->short_name.'/index.php', $index_view);
		
		foreach ($data->submodules as $submodule){

		$grid_view = '
<script type="text/javascript">
	$(document).ready(function(){
		$("table.grid_data tr:even").addClass("alt");
	})
</script>		
<div class="toolbar">
	<h3 class="grid-title">
		<?php if ($this->user->has_permission("to_create_'.$submodule->short_name.'","'.$module->name.'")): ?><a href="'.$module->name.'/new_'.$submodule->short_name.'" class="v-btn target_main float_right" style="padding:0 10px; font-weight: normal">New '.$submodule->name.'</a><?php endif; ?>
		'.$submodule->name.'
	</h3>
	<div class="global-tabs" style="padding: 5px; font-size: 10pt">
		<a class="v-btn show-filter-controls icon-search">Search</a>
	</div>
	<table class="grid">
		<thead>
			<tr>
';
			
			$x = 0;
			foreach ($submodule->grid_view as $column => $opt){
				$x++;
				$cols[] = $this->grid_column_processing($submodule, $x, $column, $opt);
			}
			$grid_view .= "\t\t\t\t" . implode("\n\t\t\t\t", $cols);
    			
			$grid_view .='
				<th class="grid-action" style="text-align: center; width: 75px; padding: 0"><img src="<?=base_url()?>images/email-action.gif" alt="Action"></th>
				<th style="width: 15px; padding: 0;"></th>
			</tr>
		</thead>
	</table>
</div>    
<div class="main_full">
	<table class="grid grid_data">	
		<tbody>
			<?php $x = 0; foreach ($'.$submodule->short_name.'s as $'.$submodule->short_name.'): $x++; ?>
';
			$x = 0;
			$rows = array();
			foreach ($submodule->grid_view as $column => $opt){
				$x++;
				$rows[] = $this->grid_row_processing($submodule, $x, $column, $opt);
			}
			$rows[] = '<td style="width: 75px; padding:0">
					<?php if ($this->user->has_permission("to_view_'.$submodule->short_name.'","'.$module->name.'")): ?><a class="grid-action grid-action-view target_main" href="'.$module->name.'/view_'.$submodule->short_name.'/<?=$'.$submodule->short_name.'->id?>"><span>View</span></a><?php endif; ?>
					<?php if ($this->user->has_permission("to_edit_'.$submodule->short_name.'","'.$module->name.'")): ?><a class="grid-action grid-action-edit target_main" href="'.$module->name.'/edit_'.$submodule->short_name.'/<?=$'.$submodule->short_name.'->id?>"><span>Edit</span></a><?php endif; ?>
					<?php if ($this->user->has_permission("to_delete_'.$submodule->short_name.'", "'.$module->name.'")): ?><a class="grid-action grid-action-delete" href="'.$module->name.'/delete_'.$submodule->short_name.'/<?=$'.$submodule->short_name.'->id?>/do"><span>Delete</span></a><?php endif; ?>
				</td>';
			$grid_view .= "\n\t\t\t<tr>\n\t\t\t\t" . implode("\n\t\t\t\t", $rows) . "\n\t\t\t</tr>";
    			
			
			$grid_view .= '			
			<?php endforeach; ?>
		</tbody>
	</table>
</div>
';

			echo "<h3>".$submodule->name." Grid View</h3>";
			echo "<pre>";
			echo htmlentities($grid_view);
			echo "</pre>";
			
			write_file('./_AUTOMATION/'.$module->name.'/views/'.$module->short_name.'/'.strtolower($submodule->short_name).'.php', $grid_view);			
			
			$filtered_view = '
<script type="text/javascript">
	$(document).ready(function(){
		$("table.grid_data tr:even").addClass("alt");
	})
</script>
	<table class="grid grid_data">	
		<tbody>
			<?php $x = 0; foreach ($'.$submodule->short_name.'s as $'.$submodule->short_name.'): $x++; ?>
';
			$x = 0;
			$rows = array();
			foreach ($submodule->grid_view as $column => $opt){
				$x++;
				$rows[] = $this->grid_row_processing($submodule, $x, $column, $opt);
			}
			$rows[] = '<td style="width: 75px; padding:0">
					<?php if ($this->user->has_permission("to_view_'.$submodule->short_name.'","'.$module->name.'")): ?><a class="grid-action grid-action-view target_main" href="'.$module->name.'/view_'.$submodule->short_name.'/<?=$'.$submodule->short_name.'->id?>"><span>View</span></a><?php endif; ?>
					<?php if ($this->user->has_permission("to_edit_'.$submodule->short_name.'","'.$module->name.'")): ?><a class="grid-action grid-action-edit target_main" href="'.$module->name.'/edit_'.$submodule->short_name.'/<?=$'.$submodule->short_name.'->id?>"><span>Edit</span></a><?php endif; ?>
					<?php if ($this->user->has_permission("to_delete_'.$submodule->short_name.'", "'.$module->name.'")): ?><a class="grid-action grid-action-delete" href="'.$module->name.'/delete_'.$submodule->short_name.'/<?=$'.$submodule->short_name.'->id?>/do"><span>Delete</span></a><?php endif; ?>
				</td>';
			$filtered_view .= "\n\t\t\t<tr>\n\t\t\t\t" . implode("\n\t\t\t\t", $rows) . "\n\t\t\t</tr>";
    			
			
			$filtered_view .= '			
			<?php endforeach; ?>
		</tbody>
	</table>
';		
		
			echo "<h3>".$submodule->name." Filtered View</h3>";
			echo "<pre>";
			echo htmlentities($filtered_view);
			echo "</pre>";
			
			write_file('./_AUTOMATION/'.$module->name.'/views/'.$module->short_name.'/'.strtolower($submodule->short_name).'-filtered.php', $filtered_view);
			
			$add_view = '
<?php if (!$this->user->has_permission("to_create_'.$submodule->short_name.'","'.$module->name.'")) die("You do not have the permissions to access this area."); ?>
<script type="text/javascript">
function readyAdd(status){
	if (status == 1){
		$("div.main_full").show();
		$("div.status").hide();
		$("form").clearForm();
		showDialog("ok","'.$submodule->name.'","New '.$submodule->name.' has been added.");
		form_warning = false;
	}
}

$(document).ready(function(){
	$("a.insert").click(function(event){
		$("form.insert").submit();
		event.preventDefault();
	});
	
	$("form").submit(function(){	
		var ok = true;
		$("input.mandatory").each(function(){
			if (!$(this).val()) ok = false;
		});		
		if (!ok){
			showDialog("ok","Form Error","Please make sure you have filled the form correctly.");
			return false;
		}
		$("div.main_full").hide();
		$("div.status").html("<p><img src=\"images/loading.gif\" /> Loading</p>").show();
	});
	

})
</script>
<div class="toolbar">
	<h3 class="grid-title"><a href="'.$module->name.'/'.$submodule->short_name.'" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn back_btn">Back</a>New '.$submodule->name.'</h3>
	<div class="global-tabs" style="padding: 5px">
		<a class="v-btn insert">Save '.$submodule->name.'</a>
	</div>
</div>
<div class="status">	
</div>
<div class="main_full">
	<div class="main-container">
	<iframe id="postframe" name="postframe" src="nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>
	<form class="insert" method="post" action="'.$module->name.'/new_'.$submodule->short_name.'/do" target="postframe">						
			';
			
			$add_view .= $this->parse_form($submodule, $submodule->new_view);
			
			$add_view .= '
	</form>
	</div>
</div>
';
		
			echo "<h3>".$submodule->name." Add View</h3>";
			echo "<pre>";
			echo htmlentities($add_view);
			echo "</pre>";	
		
			write_file('./_AUTOMATION/'.$module->name.'/views/'.$module->short_name.'/'.strtolower($submodule->short_name).'-new.php', $add_view);
		
			$edit_view = '
<?php if (!$this->user->has_permission("to_edit_'.$submodule->short_name.'","'.$module->name.'")) die("You do not have the permissions to access this area."); ?>
<script type="text/javascript">
function readyAdd(status){
	if (status == 1){
		$("div.main_full").show();
		$("div.status").hide();
		showDialog("ok","'.$submodule->name.'","'.$submodule->name.' information has been updated.");
		form_warning = false;
	}
}

$(document).ready(function(){
	$("a.update").click(function(event){
		$("form.update").submit();
		event.preventDefault();
	});
	
	$("form").submit(function(){	
		var ok = true;
		$("input.mandatory").each(function(){
			if (!$(this).val()) ok = false;
		});		
		if (!ok){
			showDialog("ok","Form Error","Please make sure you have filled the form correctly.");
			return false;
		}
		$("div.main_full").hide();
		$("div.status").html("<p><img src=\"images/loading.gif\" /> Loading</p>").show();
	});
	

})
</script>
<div class="toolbar">
	<h3 class="grid-title"><a href="'.$module->name.'/'.$submodule->short_name.'" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn back_btn">Back</a>New '.$submodule->name.'</h3>
	<div class="global-tabs" style="padding: 5px">
		<a class="v-btn update">Save '.$submodule->name.'</a>
	</div>
</div>
<div class="status">	
</div>
<div class="main_full">
	<div class="main-container">
	<iframe id="postframe" name="postframe" src="nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>
	<form class="update" method="post" action="'.$module->name.'/edit_'.$submodule->short_name.'/<?php echo $'.$submodule->short_name.'->id; ?>/do" target="postframe">
			';
			
			$edit_view .= $this->parse_form($submodule, $submodule->edit_view, 'EDIT_MODE');
			
			$edit_view .= '
	</form>
	</div>
</div>
';
		
			echo "<h3>".$submodule->name." Edit View</h3>";
			echo "<pre>";
			echo htmlentities($edit_view);
			echo "</pre>";
		
			write_file('./_AUTOMATION/'.$module->name.'/views/'.$module->short_name.'/'.strtolower($submodule->short_name).'-edit.php', $edit_view);
		
		
			$detail_view = '
<?php if (!$this->user->has_permission("to_view_'.$submodule->short_name.'","'.$module->name.'")) die("You do not have the permissions to access this area."); ?>
<div class="toolbar">
	<h3 class="grid-title"><a href="'.$module->short_name.'/'.$submodule->short_name.'" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn back_btn">Back</a>New '.$submodule->name.'</h3>
	<div class="global-tabs" style="padding: 5px">
		<a class="v-btn update">Save '.$submodule->name.'</a>
	</div>
</div>
<div class="status">	
</div>
<div class="main_full">
	<div class="main-container">
			';
			
			$detail_view .= $this->parse_form($submodule, $submodule->detail_view, 'VIEW_MODE');
			
			$detail_view .= '
	</div>
</div>
';
		
			echo "<h3>".$submodule->name." Detailed View</h3>";
			echo "<pre>";
			echo htmlentities($detail_view);
			echo "</pre>";


			write_file('./_AUTOMATION/'.$module->name.'/views/'.$module->short_name.'/'.strtolower($submodule->short_name).'-view.php', $detail_view);		
		}
		

		
		// CREATE SQL 
		
		foreach ($data->submodules as $submodule){
			$table .= '
CREATE TABLE `'.$module->short_name.'_'.$submodule->short_name.'` (
';
			
			foreach ($submodule->table_structure as $col => $opt){
				
				$table .= '	' . $this->parse_db_field($col, $opt) . "\n";
				
			}
			
			$table .= 
'	`added_on` datetime DEFAULT NULL,
	`added_by` varchar(128) DEFAULT NULL,
	`modified_on` datetime DEFAULT NULL,
	`modified_by` varchar(128) DEFAULT NULL,	
	PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;';

			echo "<h3>".$submodule->name." Table SQL</h3>";
			echo "<pre>";
			echo htmlentities($table);
			echo "</pre>";
			
			$tables .= $table . "\n\n";
			$table = '';
			
		}
		
		write_file('./_AUTOMATION/'.$module->name.'/tables.sql', $tables);
	}
	
	function Parse_db_field($col, $opt){
		switch (strtoupper($this->get_attr($opt,'type'))){
			case "PRIMARY":
				return '`id` int(11) NOT NULL AUTO_INCREMENT,';
				break;
			case "NAME":
			case "PHONE":
			case "EMAIL":
			case "SHORTTEXT":
			case "COUNTRY":
			case "STATE":
				return '`'.$col.'` varchar(255) DEFAULT NULL,';				
				break;
			case "TEXT":
				return '`'.$col.'` text,';
				break;
			case "DECIMAL_CURRENCY":
				return '`'.$col.'` float(10,2) DEFAULT NULL,';
				break;
			case "DATE":
				return '`'.$col.'` date DEFAULT NULL,';
				break;
			case "DATETIME":
				return '`'.$col.'` datetime DEFAULT NULL,';			
				break;
			case "TIME":
				return '`'.$col.'` time DEFAULT NULL,';
				break;
			case "INTEGER":
			case "ID":
				return '`'.$col.'` int(11) DEFAULT NULL,';
				break;
			
			
		}
	}
	
	
	function Grid_column_processing($submodule, $serial, $column, $options){
		$table = $submodule->table_structure;
		$column_display = $this->get_field_attr($table, $column, 'display');
		$width = $this->get_attr($options, 'width');
		return '<th class="sortable" rel="'.$serial.'" style="width:'.$width.'">'.$column_display.'</th>';
	}
	
	function Grid_row_processing($submodule, $serial, $column, $options){
		$table = $submodule->table_structure;
		$column_display = $this->get_field_attr($table, $column, 'display');
		$width = $this->get_attr($options, 'width');
		$date_format = $this->get_attr($options, 'format_date');
		if ($date_format){
			$echo = 'date("'.$date_format.'",strtotime($'.$submodule->short_name.'->'.$column.'))';
		} else {
			$echo = '$'.$submodule->short_name.'->'.$column;
		}
		return '<td rel="'.$serial.'" style="width:'.$width.'"><?php echo '.$echo.'; ?></td>';
	}

	
	function Add_rows_processing($field, $options){
		$opts = explode(',', $options);
		
		$ok = true;
		
		foreach ($opts as $opt){
			$opt = trim($opt);
			if ($this->get_attr($opt, 'type') == 'primary') $ok = false;
			if ($this->get_attr($opt, 'nonentry')) $ok = false;
		}
		
		if ($ok){
			return '			"'.$field.'"		=> $this->input->post("'.$field.'"),';
		}
	}
	
	function Edit_rows_processing($field, $options){
		$opts = explode(',', $options);
		
		$ok = true;
		
		foreach ($opts as $opt){
			$opt = trim($opt);
			if ($this->get_attr($opt, 'type') == 'primary') $ok = false;
			if ($this->get_attr($opt, 'nonentry')) $ok = false;
			if ($this->get_attr($opt, 'nonchangeable')) $ok = false;
		}
		
		if ($ok){
			return '			"'.$field.'"		=> $this->input->post("'.$field.'"),';
		}
		
	}
	
	function Get_field_attr($table, $field, $attr){		
		$opts = explode(',',$table[$field]);
		foreach ($opts as $opt){
			list($attr_name, $attr_value) = explode(':', $opt);
			if ($attr_name == $attr) return $attr_value;
		}
	}
	
	function Get_attr($string, $attr){
		$opts = explode(',',$string);
		foreach ($opts as $opt){
			list($attr_name, $attr_value) = explode(':', $opt);
			if ($attr_name == $attr) return $attr_value;
		}
	}
	
	function Parse_form($submodule, $form, $mode){
		$blocks = explode('#',trim($form));
		
		
		foreach ($blocks as $block){ if ($block){
		
			list($type, $data) = explode('>', $block);
			$type = strtoupper(trim($type));
			
			if ($type == 'HEADER'){
				$data = trim($data);
				$block_lines[] = "
		<h3>{$data}</h3>
";

			}
			
			if ($type == 'TEXT'){
				$data = trim($data);
				$block_lines[] = "
		{$data}
";
				
			}
			
			if ($type == 'FORM-DUAL'){
			
				$form = '			
		<table class="general-form">
			<tbody>';
			

				$fields = explode("\n", trim($data));
				
				
				foreach ($fields as $field){
				

					list($field1, $field2) = explode('|', trim($field));
					

					
					list($col1,$opt1) = explode('-', $field1);
					$label1 = $this->get_field_attr($submodule->table_structure, $col1, 'display');

					list($col2,$opt2) = explode('-', $field2);
					$label2 = $this->get_field_attr($submodule->table_structure, $col2, 'display');
					
					$opt1_array = explode(',', trim($opt1));
					$opt2_array = explode(',', trim($opt2));
					
					if (in_array('mandatory',$opt1_array)){
						$mandatory1 = ' <span class="red">*</span>';
					} else {
						$mandatory1 = '';
					}

					if (in_array('mandatory', $opt2_array)){
						$mandatory2 = ' <span class="red">*</span>';
					} else {
						$mandatory2 = '';
					}
					

					
					$input1 = $this->parse_input($submodule, $col1, $opt1, $mode);
					$input2 = $this->parse_input($submodule, $col2, $opt2, $mode);

					
					$form .= '
				<tr class="four">
					<td class="label">'.$label1.$mandatory1.'</td>
					<td class="input">'.$input1.'</td>
					<td class="label">'.$label2.$mandatory2.'</td>
					<td class="input">'.$input2.'</td>
				</tr>
						';		
				}
				
				
				$form .= '
			</tbody>
		</table>
';
					
				$block_lines[] = $form;
				
			}
			
			if ($type == 'FORM-SINGLE'){

			
				$form = '			
		<table class="general-form">
			<tbody>';

				$fields = explode("\n", trim($data));
				
				foreach ($fields as $field){

					
					list($col,$opt) = explode('-', trim($field));
					$label = $this->get_field_attr($submodule->table_structure, $col, 'display');
					

					$opt_array = explode(',', trim($opt));
										
					if (in_array('mandatory',$opt_array)){
						$mandatory = ' <span class="red">*</span>';
					} else {
						$mandatory = '';
					}
					
					$input = $this->parse_input($submodule, $col, $opt, $mode);

					
					$form .= '
				<tr class="two">
					<td class="label">'.$label.$mandatory.'</td>
					<td class="input">'.$input.'</td>
				</tr>
						';		
				}
				
				
				$form .= '
			</tbody>
		</table>
';				
				$block_lines[] = $form;
			}
			
		}}
		
		return implode('',$block_lines);
	}
	
	
	function Parse_input($submodule, $col, $opt, $mode){
		$table = $submodule->table_structure;
		
		
		$type = $this->get_field_attr($table, $col, 'type');
		$opt_array = explode(',', trim($opt));
		
		if (in_array('mandatory',$opt_array)) $mandatory = 'mandatory';
		if (in_array('textarea', $opt_array)) $type = 'MULTILINE';
		
		if ($mode == 'EDIT_MODE'){
			if ($this->get_field_attr($table, $col, 'nonchangeable')) $readonly = 'readonly';

			$date_format = $this->get_attr($opt, 'format_date');
			if ($date_format){
				$value = 'date("'.$date_format.'",strtotime($'.$submodule->short_name.'->'.$col.'))';
			} else {
				$value = '$'.$submodule->short_name.'->'.$col;
			}
		}
		
		if ($mode == 'VIEW_MODE'){
			$date_format = $this->get_attr($opt, 'format_date');
			if ($date_format){
				$value = 'date("'.$date_format.'",strtotime($'.$submodule->short_name.'->'.$col.'))';
			} else {
				$value = '$'.$submodule->short_name.'->'.$col;
			}

			return '<?php echo ' . $value . '; ?>';
		}
		
		$rel_dropdown = $this->get_field_attr($table, $col, 'dropdown');
		if ($rel_dropdown){
			$type = 'REL_DROPDOWN';
		}
		
		
		$dropdown = $this->get_attr($opt,'dropdown');
		
		if ($dropdown){
			$type = 'DROPDOWN';

		}

		
		switch (strtoupper($type)){
			case "DROPDOWN":
				if (!$value) $value = 'NULL';
				$dropdown = str_replace('=',':',$dropdown);
				$dropdown = str_replace(';', ',', $dropdown);
				$dropdown = str_replace("'", '"', $dropdown);
				$list = json_decode($dropdown);
				
				foreach ($list as $val => $display){
					$item[] = '"'.$val.'" => "'.$display.'"';
				}
				$array_string = implode(', ', $item);
				return '<?php echo form_dropdown("'.$col.'", array('.$array_string.'), '.$value.', \'class="v-dropdown" '.$readonly.' \'); ?>';
			
				break;
			case "REL_DROPDOWN":
				if (!$value) $value = 'NULL';
				list($id, $display) = explode('|',$rel_dropdown);
				return '<?php echo form_dropdown("'.$col.'", $this->system->dropdown_list("'.$id.'","'.$display.'"), '.$value.', \'class="v-dropdown" '.$readonly.' \'); ?>';
				break;
			case "STATE":
				if (!$value) $value = 'NULL';
				return '<?php echo form_dropdown("'.$col.'", $this->system->state_list($this->system->config("country")), '.$value.', \'class="v-city v-dropdown" '.$readonly.' \'); ?>';
				break;
			case "COUNTRY":
				if (!$value) $value = '$this->system->config("country")';
				return '<?php echo form_dropdown("'.$col.'", $this->system->country_list(), '.$value.', \'class="v-country v-dropdown" '.$readonly.' \'); ?>';
				break;
			case "DECIMAL_CURRENCY":
				if ($value) $value = '<?php echo ' . $value . '; ?>';
				return '<input value="'.$value.'" '.$readonly.' type="text" name="'.$col.'" class="v-text v-number-decimal '.$mandatory.'" />';
				break;
			case "INTEGER":
				if ($value) $value = '<?php echo ' . $value . '; ?>';
				return '<input value="'.$value.'" '.$readonly.' type="text" name="'.$col.'" class="v-text v-number '.$mandatory.'" />';				
				break;
			case "DATE":
				if ($value) $value = '<?php echo ' . $value . '; ?>';
				return '<input value="'.$value.'" '.$readonly.' type="text" name="'.$col.'" class="v-text date '.$mandatory.'" />';			
				break;
			case "EMAIL":
				if ($value) $value = '<?php echo ' . $value . '; ?>';
				return '<input value="'.$value.'" '.$readonly.' type="email" name="'.$col.'" class="v-text '.$mandatory.'" />';
				break;
			case "MULTILINE":
				return '<textarea '.$readonly.' name="'.$col.'" class="v-textarea '.$mandatory.'">'.$value.'</textarea>';
				break;
			default:
				if ($value) $value = '<?php echo ' . $value . '; ?>';
				return '<input value="'.$value.'" '.$readonly.' type="text" name="'.$col.'" class="v-text '.$mandatory.'" />';
		}
	}
}




