<?php

class Clinic extends Controller {

	function Clinic(){
		parent::Controller();

		$this->d['user'] = $this->user->data();
		$this->load->model('im');

		
		$this->load->model('inv');
		$this->load->model('calendar');
		$this->load->model('charts');
		$this->load->model('klinik');

		if (!$this->system->uses('Contacts')){
			die('This module requires Contacts module to operate.');
		} 
		
		$this->load->model('contact');

		
		$this->d['system'] = $this->system->config();
	}
	
	function Config($do){
		if ($do == 'do'){
			
			$config['upload_path'] = './assets/img/';
			$config['allowed_types'] = 'gif|jpg|png';
			$config['max_size']	= '1024';
			$config['remove_spaces'] = true;
			
			$this->load->library('upload', $config);
			
			if ($this->upload->do_upload('company_logo')){
				$image_data = $this->upload->data('company_logo');
				$logo = $image_data['file_name']; 					
				// $this->system->set_config('company_logo',$logo);
			} 
			
			$this->system->set_config('po_tnc',$this->input->post('po_tnc'));
			$this->system->set_config('dn_tnc',$this->input->post('dn_tnc'));
			$this->system->set_config('warehouse_enabled', $this->input->post('warehouse_enabled'));
			$this->system->set_config('cost_update_method', $this->input->post('cost_update_method'));
			
			
 			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
 		} else {
 			$this->load->view('inventory/config');
 		}
	}

	
	function Index(){
		$this->d['items'] = $this->inv->alert_items();
		$this->d['total_items'] = $this->inv->total_items();
		$this->d['total_categories'] = $this->inv->total_categories();
		$this->d['total_subcategories'] = $this->inv->total_subcategories();
		$this->d['total_brands'] = $this->inv->total_brands();
		$this->d['title'] = 'Inventory';		
		
		if ($this->system->config('warehouse_enabled')){
			$this->d['current_warehouse'] = $this->session->userdata('inventory_warehouse');
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown();
			
			$userdata = json_decode($this->user->data('data'));
			if ($userdata->Inventory->warehouse){
				$this->d['fixed_inventory'] = true;
			}
		}
		
		$this->session->userdata('inventory_warehouse');
		$this->load->view('header', $this->d);
		$this->load->view('clinic/index', $this->d);
		$this->load->view('footer', $this->d);
	}
	
	function Overview(){
		$this->d['items'] = $this->inv->alert_items();
		$this->d['total_items'] = $this->inv->total_items();
		$this->d['total_categories'] = $this->inv->total_categories();
		$this->d['total_subcategories'] = $this->inv->total_subcategories();
		$this->d['total_brands'] = $this->inv->total_brands();
		$this->load->view('clinic/overview', $this->d);
	}
	
	function Patients(){
		$this->d['patients'] = $this->klinik->get_patients("1=1 LIMIT 100");
		
		$this->load->view('clinic/patients',$this->d);
	}
	
	function Patients_filter(){
		if ($ic = $this->input->post('ic')) $filter[] = "contacts.ic = ".$this->db->escape($ic);
		if ($name = $this->input->post('name')) $filter[] = "contacts.contact_person LIKE ".$this->db->escape('%'.$name.'%');
		if ($tel = $this->input->post('tel')) $filter[] = "contacts.contact_number LIKE ".$this->db->escape('%'.$tel.'%');
		
		$filter_string = implode(' AND ', $filter);

		if ($filter_string) $filter_string = ' ' . $filter_string;
		else $filter_string = ' 1=1 ';

		$this->d['patients'] = $this->klinik->get_patients($filter_string);
		
		$this->load->view('clinic/patients-filtered',$this->d);

	}
	
	function Patient_add($do, $option){
		if ($do == 'do'){
			$item = $this->klinik->get_patient_by_ic($this->input->post('ic'));
			
			if ($item->ic){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(0);</script>';		
			} else {
				$this->klinik->add_patient();
				echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';		
			}
	 			
		} else {
			$this->load->view('clinic/patient-add',$this->d);
		}
	}
	
	
	function Patient_edit($id,$do){
		if ($do == 'do'){
			$this->klinik->edit_patient($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['patient'] = $patient = $this->klinik->get_patient_by_id($id);
			$this->d['contact']	= $contact = $this->contact->get_contact_by_id($patient->contact_id);
			
			$this->load->view('clinic/patient-edit',$this->d);
		}
		
	}
	
	function Patient_view($id){
		$this->d['patient'] = $patient = $this->klinik->get_patient_by_id($id);
		$this->d['contact']	= $contact = $this->contact->get_contact_by_id($patient->contact_id);
		$this->d['patient_history']	= $history = $this->klinik->get_patient_history($patient->id);
		
		$meds = $this->klinik->get_meds_history($contact->id);
		foreach ($meds as $med){
			$meds_by_id[$med->sale_id][] = $med;
		}

		$this->d['meds'] = $meds_by_id;

		$this->load->view('clinic/patient-view',$this->d);
	}
	
	function Patient_delete($id,$do){
		if ($do == 'do'){
			$this->klinik->delete_patient($id);
			echo 'ok';
		}
	}
	
	function Check_ic($ic){
				
		$this->system->event_log('check','edit','item','','');
		$item	=	$this->contact->get_contact_by_ic($ic);
		if($item->ic){
			$result->status = 'registered';
		}else {
			$result->status = 'unregistered';				
		}
		
		echo json_encode($result);
				
	}
	
	function Appointments(){
		$filter[] = '`branch` = ' . $this->db->escape($this->user->data('branch'));
		$filter[] = '`start` >= ' . $this->db->escape(date('Y-m-d 00:00:00'));
		
		$filter_string = implode(' AND ', $filter);
				
		$this->d['patients_dropdown'] = $this->klinik->patients_dropdown(true);
		
		$this->d['appointments'] = $this->klinik->get_appointments($filter_string);
		$this->load->view('clinic/appointments', $this->d);
	}
	
	function Appointments_filter(){
		
		list($day, $month, $year) = explode('/',$this->input->post('from_date'));
		$from_date = $year . '-' . $month . '-' . $day . ' ' . date('H:i:s', strtotime($this->input->post('from_time')));
		
		list($day, $month, $year) = explode('/',$this->input->post('to_date'));
		$to_date = $year . '-' . $month . '-' . $day . ' ' . date('H:i:s', strtotime($this->input->post('to_time')));

		
		if ($from_date) $filter[] = "`start` >= ".$this->db->escape($from_date);
		if ($to_date) $filter[] = "`end` <= ".$this->db->escape($to_date);
		if ($patient = $this->input->post('patient')) $filter[] = "`module_id` = ".$this->db->escape($patient);
		
		$filter[] = '`branch` = ' . $this->db->escape($this->user->data('branch'));
		
		$filter_string = implode(' AND ', $filter);
		
		$this->d['appointments'] = $this->klinik->get_appointments($filter_string);
		$this->load->view('clinic/appointments-filtered', $this->d);
		
	}
	
	function Appointment_add($do){
		if ($do == 'do'){
			$this->klinik->add_appointment();
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->load->view('clinic/appointment-add', $this->d);
		}
	}
	
	function Appointment_edit($id, $do){
		if ($do == 'do'){
			$this->klinik->edit_appointment($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['appointment'] = $this->klinik->get_appointment_by_id($id);
			$this->load->view('clinic/appointment-edit', $this->d);
		}
	}
	
	function Appointment_delete($id, $do){
		if ($do == 'do'){
			$this->klinik->delete_appointment($id);
			echo 'ok';
		}
	}
}