<?php

class Contacts extends Controller {

	function Contacts(){
		parent::Controller();
		$this->d['user'] = $this->user->data();
		$this->d['system'] = $this->system->config();
		
		if ($this->system->uses('Sales')) $this->load->model('sale');
		if ($this->system->uses('Services')) $this->load->model('service');
		if ($this->system->uses('Inventory')) $this->load->model('inv');
		if ($this->system->uses('Accounts')){
			$this->load->model('account');
			$this->d['payment_accounts_list'] = $this->account->cash_postable_account_list();
			$this->d['default_bank_account'] = $this->account->get_default_bank_account();
		}

		$this->load->model('contact');
		
	}
	
	function Index(){
		$this->d['title'] = 'Contacts';
		$this->d['contacts'] = $this->contact->get_contacts();
	
		$this->load->view('header', $this->d);
		$this->load->view('contacts/index', $this->d);
		$this->load->view('footer');
	}
	
	function Overview(){
		$query = $this->db->query("SELECT * FROM `contacts`");
		foreach ($query->result() as $contact){
			if ($contact->is_customer) $data['Customer']++;
			if ($contact->is_supplier) $data['Supplier']++;
			if ($contact->is_member) $data['Member']++;
			if ($contact->is_stakeholder) $data['Stakeholder']++;
			if ($contact->is_franchise) $data['Franchise']++;
			if ($contact->is_agent) $data['Agent']++;
			if ($contact->is_prospect) $data['Prospect']++;
		}
		foreach ($data as $field => $count){
			$cdata = null;
			$cdata->label = $field;
			$cdata->data = (int) $count;
			$chartdata[] = $cdata;
		}
		$this->d['chartdata'] = $chartdata;
		
		
		$query = $this->db->query("SELECT COUNT(`id`) AS `count`, `status` FROM `contact_cases` GROUP BY `status`");
		foreach ($query->result() as $status){
			$sdata = null;
			$sdata->label = $status->status;
			$sdata->data = (int) $status->count;
			$schartdata[] = $sdata;
		}
		$this->d['schartdata'] = $schartdata;
		
		
		
		
		$this->load->view('contacts/overview', $this->d);
	}
	
	
	function Elist(){
		$this->d['contacts'] = $this->contact->get_contacts();	
		$this->load->view('contacts/list', $this->d);
	}
	
	function Add($do){
		if ($do == 'do'){
			if (trim($this->input->post('email'))){
				if (strlen(trim($this->input->post('password'))) < 6){
					echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(2);</script>';
					return;
				}
			}

			$contact = $this->contact->add();
			$this->system->event_log('contacts','add','contact',$contact->id, $contact);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['ranks'] = $this->contact->get_ranks(true);
			$this->load->view('contacts/add', $this->d);
		}
	}
	
	function Edit($id, $do){
		if ($do == 'do'){
			$contact = $this->contact->edit($id);
			if (trim($this->input->post('email')) && trim($this->input->post('password'))){
				if (strlen(trim($this->input->post('password'))) < 6){
					echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(2);</script>';
					return;
				}
			}
			$this->system->event_log('contacts','edit','contact',$contact->id, $contact);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
	 		
	 		if ($this->system->uses('Clinic')){
		 		$this->db->update('patients', array(
		 			'ic'	=> $this->input->post('ic')
		 		), "`contact_id` = '{$id}'");
	 		}
		
		} else {
			$this->d['contact'] = $this->contact->get_contact_by_id($id);
			$this->d['ranks'] = $this->contact->get_ranks(true);
			$this->load->view('contacts/edit', $this->d);
		}
	}
	
	
	
	function Contacts_filter(){

		if ($company = $this->input->post('company')) 				$filter[] = "`company_name` LIKE ".$this->db->escape('%'.$company.'%');
		if ($contact = $this->input->post('contact')) 				$filter[] = "`contact_person` LIKE ".$this->db->escape('%'.$contact.'%');
		if ($number = $this->input->post('number')) 				$filter[] = "`contact_number` LIKE ".$this->db->escape('%'.$number.'%');
		if ($rank = $this->input->post('rank'))						$filter[] = "`rank` = ".$this->db->escape($rank);
		if ($is_supplier = $this->input->post('is_supplier'))		$or_filter[] = "`is_supplier` = 1";
		if ($is_customer = $this->input->post('is_customer'))		$or_filter[] = "`is_customer` = 1";
		if ($is_agent = $this->input->post('is_agent')) 			$or_filter[] = "`is_agent` = 1";
		if ($is_prospect = $this->input->post('is_prospect')) 		$or_filter[] = "`is_prospect` = 1";
		if ($is_member = $this->input->post('is_member')) 			$or_filter[] = "`is_member` = 1";
		if ($is_stakeholder = $this->input->post('is_stakeholder')) $or_filter[] = "`is_stakeholder` = 1";
		if ($is_franchise = $this->input->post('is_franchise')) 	$or_filter[] = "`is_franchise` = 1";

		
		$filter_string = implode(' AND ', $filter);
		if ($filter_string) $filter_string = $filter_string;
		
		$or_filter_string = implode(' OR ', $or_filter);
		if ($or_filter_string){
			if ($filter_string) $filter_string .= ' AND (' . $or_filter_string . ') ';
			else $filter_string = $or_filter_string;
		}
		if (!$filter_string) $filter_string .= "1=1 ORDER BY `id` ASC";
		else $filter_string .= " ORDER BY `id` ASC";
		
		$this->d['contacts'] = $this->contact->get_contacts($filter_string);
		$this->load->view('contacts/filtered', $this->d);

	}

	
	
	
	function View($id){
		$this->d['contact'] = $this->contact->get_contact_by_id($id);
		
		$date_from = date('Y-m-1');
		$date_to = date('Y-m-t');
		
		


		if ($this->system->uses('Sales')){
			$this->d['receivables']	= $this->sale->get_pending_invoices_by_contact($id);
			$invoices 				= $this->sale->get_invoices_by_contact($id, $date_from,$date_to);
			$credit_notes 			= $this->sale->get_credit_notes_by_contact($id, $date_from,$date_to);
			
			$this->d['invoices'] 	= $this->sale->get_invoices_by_contact($id);
			$this->d['cns'] 		= $this->sale->get_credit_notes_by_contact($id);
			
			
			
			$this->d['points'] = $this->contact->get_points_by_contact($id);
			

		}

		if ($this->system->uses('Inventory')){
			$this->d['payables']	= $this->inv->get_pending_po_by_contact($id);
			$purchase_orders 	= $this->inv->get_purchase_orders_by_contact($id,$date_from,$date_to);
			$debit_notes 		= $this->inv->get_debit_notes_by_contact($id,$date_from,$date_to);
			
			$this->d['purchases'] = $this->inv->get_purchase_orders_by_contact($id);
			$this->d['dns'] = $this->inv->get_debit_notes_by_contact($id);

		}
		
		if ($this->system->uses('Accounts')){
			$payment_vouchers	= $this->account->get_pv_by_contact($id, $date_from, $date_to);
			$receipts			= $this->account->get_receipts_by_contact($id, $date_from, $date_to);
		}

		$balance 			= 0 + $invoices->opening_balance 
								- $purchase_orders->opening_balance
								+ $debit_notes->opening_balance 
								- $credit_notes->opening_balance
								+ $payment_vouchers->opening_balance 
								- $receipts->opening_balance;
								

		$opening_balance_timeint = strtotime($date_from) - (60 * 60 * 24);
		
		$opening_balance->balance = $balance;
		$opening_balance->type = 'Balance';
		
		$transactions[$opening_balance_timeint][] = $opening_balance;
		
		foreach ($invoices->invoices as $invoice){
			$invoice->type = 'Invoice';
			$invoice->debit = $invoice->total;
			$invoice->ref = 'INV-' . $invoice->id;
			
			$debit += $invoice->total;
			$transactions[strtotime($invoice->date)][] = $invoice;
		}

		foreach ($purchase_orders->purchase_orders as $po){
			$po->type = 'Purchase Order';
			$po->credit = $po->total;
			$po->ref = 'PO-' . $po->id;

			$credit += $po->total;
			$transactions[strtotime($po->date)][] = $po;			
		}
		
		foreach ($credit_notes->credit_notes as $cn){
			$cn->type = 'Credit Note';
			$cn->credit = $cn->total;
			$cn->ref = 'CN-' . $cn->id;
			
			$credit += $cn->total;
			$transactions[strtotime($cn->date)][] = $cn;
		}
		
		foreach ($debit_notes->debit_notes as $dn){
			$dn->type = 'Debit Note';
			$dn->debit = $dn->total;
			$dn->ref = 'DN-' . $dn->id;
			
			$debit += $dn->total;
			$transactions[strtotime($dn->date)][] = $dn;
		}

		foreach ($payment_vouchers->pvs as $pv){
			$pv->type = 'Payment';
			$pv->debit = $pv->amount;
			$pv->ref = 'PV-' . $pv->id;
			
			$debit += $pb->amount;
			$transactions[strtotime($pv->datetime)][] = $pv;
		}

		foreach ($receipts->receipts as $rc){
			$rc->type = 'Receipt';
			$rc->credit = $rc->amount;
			$rc->ref = 'RC-' . $rc->id;
			
			$debit += $rc->amount;
			$transactions[strtotime($rc->datetime)][] = $rc;
		}


		ksort($transactions);
		
		$this->d['oustanding'] = $debit - $credit;

		$this->d['cases'] 	= $this->contact->get_cases_by_contact($id);
		$this->d['transactions'] = $transactions;
		

		$this->load->view('contacts/view', $this->d);
	}
	
	function View_filter($id){
	
	
		$this->d['contact'] = $this->contact->get_contact_by_id($id);
		
		list($day, $month, $year) = explode('/', $this->input->post('date_from'));
		$date_from = $year . '-' . $month . '-' . $day;
		
		list($day, $month, $year) = explode('/', $this->input->post('date_to'));
		$date_to = $year . '-' . $month . '-' . $day;

		if ($this->system->uses('Sales')){
			$invoices 			= $this->sale->get_invoices_by_contact($id, $date_from,$date_to);
			$credit_notes 		= $this->sale->get_credit_notes_by_contact($id, $date_from,$date_to);
			$this->d['invoices'] = $this->sale->get_invoices_by_contact($id);
			$this->d['cns'] = $this->sale->get_credit_notes_by_contact($id);

		}

		if ($this->system->uses('Inventory')){
			$purchase_orders 	= $this->inv->get_purchase_orders_by_contact($id,$date_from,$date_to);
			$debit_notes 		= $this->inv->get_debit_notes_by_contact($id,$date_from,$date_to);
			$this->d['dns'] = $this->inv->get_debit_notes_by_contact($id);
			$this->d['purchases'] = $this->inv->get_purchase_orders_by_contact($id);

		}
		
		if ($this->system->uses('Accounts')){
			$payment_vouchers	= $this->account->get_pv_by_contact($id, $date_from, $date_to);
			$receipts			= $this->account->get_receipts_by_contact($id, $date_from, $date_to);
		}

		$balance 			= 0 + $invoices->opening_balance 
								- $purchase_orders->opening_balance
								+ $debit_notes->opening_balance 
								- $credit_notes->opening_balance
								+ $payment_vouchers->opening_balance 
								- $receipts->opening_balance;

		$opening_balance_timeint = strtotime($date_from) - (60 * 60 * 24);
		
		$opening_balance->balance = $balance;
		$opening_balance->type = 'Balance';
		
		$transactions[$opening_balance_timeint][] = $opening_balance;
		foreach ($invoices->invoices as $invoice){
			$invoice->type = 'Invoice';
			$invoice->debit = $invoice->total;
			$invoice->ref = 'INV-' . $invoice->id;
			
			$transactions[strtotime($invoice->date)][] = $invoice;
		}
		
		foreach ($purchase_orders->purchase_orders as $po){
			$po->type = 'Purchase Order';
			$po->credit = $po->total;
			$po->ref = 'PO-' . $po->id;
			
			$transactions[strtotime($po->date)][] = $po;			
		}
		
		foreach ($credit_notes->credit_notes as $cn){
			$cn->type = 'Credit Note';
			$cn->credit = $cn->total;
			$cn->ref = 'CN-' . $cn->id;
			
			$transactions[strtotime($cn->date)][] = $cn;
		}
		
		foreach ($debit_notes->debit_notes as $dn){
			$dn->type = 'Debit Note';
			$dn->debit = $dn->total;
			$dn->ref = 'DN-' . $dn->id;
			
			$transactions[strtotime($dn->date)][] = $dn;
		}

		foreach ($payment_vouchers->pvs as $pv){
			$pv->type = 'Payment';
			$pv->debit = $pv->amount;
			$pv->ref = 'PV-' . $pv->id;
			
			$transactions[strtotime($pv->datetime)][] = $pv;
		}

		foreach ($receipts->receipts as $rc){
			$rc->type = 'Receipt';
			$rc->credit = $rc->amount;
			$rc->ref = 'RC-' . $rc->id;
			
			$transactions[strtotime($rc->datetime)][] = $rc;
		}


		ksort($transactions);
		

		$this->d['transactions'] = $transactions;
		
		
			
		$this->load->view('contacts/view-filter', $this->d);
	}
	
	function Delete($id){
		$contact = $this->contact->delete($id);
		$this->system->event_log('contacts','delete','contact',$contact->id, $contact);
		echo 'ok';
	}
	
	function Delete_case_file($id){
		$this->db->update('contact_logs', array(
			'file'	=> ''
		),"`id` = '{$id}'");
		
		echo 'ok';
	}
	
	function Set_case_file($id){
		$log = $this->contact->get_log_by_id($id);
		$this->db->update('contact_logs', array(
			'current_file'	=> ''
		),"`case_id` = '{$log->case_id}'");
		
		$this->db->update('contact_logs', array(
			'current_file'	=> 1
		),"`id` = '{$log->id}'");
		
		echo 'ok';
	}
	
	function Ajax($request){
		switch ($request){
		
			case "add_log":
				$id = $this->input->post('id');
			
				$case = $this->contact->get_case_by_id($id);
				$log = $this->contact->add_log($id, $case->contact_id);
		
				echo '<script language="javascript" type="text/javascript">window.top.window.readyLog('.json_encode($log).');</script>';
			break;
				
			case "delete_log":
			
				$id = $this->input->post('id');
				$this->contact->delete_log($id);
				
				echo 'ok';
			break;
				
			case "get_contact_by_id":
				
				$id = $this->input->post('id');
				$contact = $this->contact->get_contact_by_id($id);
				
				echo json_encode($contact);
			
			break;
		
		}
	}	
	
	function Case_list(){
	
		$from = date('Y-m-d 00:00:00', time() - (60 * 60 * 24 * 100));
		$to = date('Y-m-d 23:59:59');
		
		$filter[] = "`log_date` >= " . $this->db->escape($from);
		$filter[] = "`log_date` <= " . $this->db->escape($to);
		
		$filter_string = implode(' AND ', $filter);
		if ($filter_string) $filter_string = $filter_string;
		
		$filter_string .= " ORDER BY `log_date` DESC";
		
	
		$this->d['cases'] = $this->contact->get_cases($filter_string);
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('contacts/case-list', $this->d);
	}
	
	function Case_list_filter(){
		
		

		if ($from = $this->input->post('date_from')){
			list($day, $month, $year) = explode('/', $from);
			$from = $year . '-' . $month . '-' . $day . ' 00:00:00';
			$filter[] = "`log_date` >= " . $this->db->escape($from);
		}
		if ($to = $this->input->post('date_to')){
			list($day, $month, $year) = explode('/', $to);
			$to = $year . '-' . $month . '-' . $day . ' 23:59:59';
			$filter[] = "`log_date` <= " . $this->db->escape($to);
		}
		
		if ($contact = $this->input->post('contact')) $filter[] = "`contact_id` = " . $this->db->escape($contact);
		if ($status = $this->input->post('status')) $filter[] = "`status` = " . $this->db->escape($status);
		
		
		$filter_string = implode(' AND ', $filter);
		
		$filter_string .= " ORDER BY `log_date` DESC";
	
		$this->d['cases'] = $this->contact->get_cases($filter_string);
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('contacts/case-filtered', $this->d);
		
		
	}
	
	function Cases($id){
		
		$this->d['contact']	= $this->contact->get_contact_by_id($id);
		$this->d['cases'] 	= $this->contact->get_cases_by_contact($id);
		
		$this->load->view('contacts/cases', $this->d);
	}
	
	function Add_case($id, $do){
		if ($do == 'do'){
			$this->contact->add_case($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['contact'] = $this->contact->get_contact_by_id($id);
			$this->load->view('contacts/add-case', $this->d);
		}
	}
	
	function New_case($do){
		if ($do == 'do'){
			$id = $this->input->post('id');
			$this->contact->add_case($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {		
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->load->view('contacts/new-case', $this->d);
		}
	}
	
	function Edit_case($id, $do){
		if ($do == 'do'){
			$this->contact->edit_case($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else { 
			$this->d['case'] = $case = $this->contact->get_case_by_id($id);
			$this->d['contact'] = $this->contact->get_contact_by_id($case->contact_id);
			$this->load->view('contacts/edit-case', $this->d);
		}
	}
	
	function Case_logs($id){
		$this->d['case'] = $case = $this->contact->get_case_by_id($id);
		$this->d['logs'] = $this->contact->get_logs_by_case($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($case->contact_id);
		$this->load->view('contacts/logs', $this->d);
	}
	
	function Case_files($id){
		$this->d['logs'] = $this->contact->get_logs_by_case($id);
		$this->load->view('contacts/case-file-list', $this->d);		
	}
	
	function Case_logs_update($id){
		$this->d['case'] = $case = $this->contact->get_case_by_id($id);
		$this->d['logs'] = $this->contact->get_logs_by_case($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($case->contact_id);
		$this->load->view('contacts/logs-update', $this->d);		
	}

	
	function Edit_log($id, $do){
		if ($do == 'do'){
			$this->contact->edit_log($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->load->view('contacts/edit-log');
		}
		
	}
	
	function Case_barcode($id){
		$case = $this->contact->get_case_by_id($id);
		echo "<img src=\"../../../barcode/1D.php?text={$case->reference_no}\" />";
	}
	
	function Delete_case($id, $do){
		if ($do == 'do'){
			$this->db->query("DELETE FROM `contact_cases` WHERE `id` = ?", array($id));
			echo 'ok';
		}
	}
	
	function Get_contact_details($contact_id){	
		$contact = $this->contact->get_contact_by_id($contact_id);

		$details->name 		= $contact->company_name ? $contact->company_name : $contact->contact_person;
		$details->mobile	= $contact->tel ? $contact->tel : $contact->contact_number;
		$details->address1	= $contact->address1;
		$details->address2	= $contact->address2;
		$details->zipcode	= $contact->zipcode;
		$details->city		= $contact->city;
		$details->state		= $contact->state;
		$details->country	= $contact->country;
		$details->tel		= $contact->tel;
		$details->fax		= $contact->fax;
		$details->email		= $contact->general_email;

		echo json_encode($details);

	}
	
	function File_movement(){
		$this->load->view('contacts/file-movement');
	}
	
	function File_movement_case_select(){
		$ref = $this->input->post('ref');
		echo json_encode($this->contact->get_case_by_ref($ref));
		
	}
	
	function File_movement_update(){
		$id = $this->input->post('id');
		$location = $this->input->post('location');
		
		$case = $this->contact->get_case_by_id($id);
		
		$this->db->update('contact_cases',array(
			'file_location'	=> $location
		),"`id` = '{$case->id}'");
		
		$this->db->insert('contact_logs', array(
			'case_id'		=> $case->id,
			'contact_id'	=> $case->contact_id,
			'subject'		=> 'File Location Update',
			'description'	=> 'File location changed to ' . $location,
			'status'		=> '',
			'added_by'		=> $this->user->data('username'),
			'added_on'		=> date('Y-m-d H:i:s')
		));
		
		echo 'ok';
	}

	
}