<?php

class Dashboard extends Controller {

	function Dashboard(){
		parent::Controller();

		$this->d['user'] = $this->user->data();
		$this->load->model('im');
		$this->load->model('calendar');
		$this->load->model('charts');
		$this->load->model('memo');
		
		if ($this->system->uses('Sales')) $this->load->model('sale');
		if ($this->system->uses('Inventory')) $this->load->model('inv');
		if ($this->system->uses('HR')) $this->load->model('employee');
		
		$this->d['system'] = $this->system->config();
		
		$this->update();
	}
	
	function Index(){
		$this->d['title'] = 'Dashboard';

		if ($this->system->uses('Reports')){
			$this->load->model('report');
			$this->d['widgets'] = $this->report->get_widgets();
			
		}
		// Sales
		if ($this->system->uses('Sales') && $this->user->has_access('sales')){
			$sales_data = $this->sale->daily_chart_data();
			$saleschart_data['title'] = '';
			$saleschart_data['values'] = $sales_data;
			$_SESSION['saleschart'] = $saleschart_data;
			$this->d['sales_chart'] = $this->charts->output(base_url().'ledger/line_chart/saleschart/time', "100%", 250);
		
			$today = date('Y-m-d');
			$tomorrow = date('Y-m-d',strtotime(date('Y-m-d')) + (60 * 60 * 24));

			$this->d['sales'] = $this->sale->get_sales_by_date($today, $tomorrow);
		}
		
		// Contacts 
		if ($this->system->uses('Inventory') && $this->user->has_access('inventory')){
			$this->d['items'] = $this->inv->alert_items();
		}
		
		// Inventory
		if ($this->system->uses('Contacts') && $this->user->has_access('contacts')){
		
		}
		
		// Services 
		if ($this->system->uses('Services') && $this->user->has_access('services')){
		
		}
		
		// Assets 
		if ($this->system->uses('Assets') && $this->user->has_access('assets')){
		
		}
		
		// Employees
		if ($this->system->uses('HR') && $this->user->has_access('employees')){
		
		}
		
		
		$this->load->view('header', $this->d);
		$this->load->view('dashboard/index', $this->d);
		$this->load->view('footer', $this->d);
	}
	
	function Overview(){
	
		if ($this->system->uses('Reports')){
			$this->load->model('report');
			$this->d['widgets'] = $this->report->get_widgets();			
		}
		
		$this->load->view('dashboard/overview', $this->d);
	}
	
	function Jobsheet(){
		$this->d['task_list'] = $this->calendar->task_list(null,array('orderby'=>'start','order'=>'desc'));
		$this->d['assigned_list'] = $this->calendar->assigned_list(null,array('orderby'=>'start','order'=>'desc'));
		$this->load->view('dashboard/jobsheet',$this->d);
		
	}
	
	function Schedule(){

		$this->d['schedule_list'] = $this->calendar->schedule_list(null,array('orderby'=>'start','order'=>'desc','type'=>'schedule'));
		$this->d['meeting_list'] = $this->calendar->schedule_list(null,array('orderby'=>'start','order'=>'desc','type'=>'meeting'));
		$this->d['appointment_list'] = $this->calendar->schedule_list(null,array('orderby'=>'start','order'=>'desc','type'=>'appointment'));
		$this->load->view('dashboard/schedule', $this->d);
	}
	
	function Calendar(){
		$this->load->view('dashboard/calendar', $this->d);
	}
	
	function IM(){
		$this->d['im_list'] = $this->im->im_list(null,array(
			'to'		=> $this->user->data('username'),
			'user_copy'	=> 0,
			'status'	=> 'sent,read'
		));
		
		$this->d['im_draft_list'] = $this->im->im_list(null,array(
			'from'		=> $this->user->data('username'),
			'status'	=> 'draft'
		));
		
		$this->d['im_sent_list'] = $this->im->im_list(null,array(
			'from'		=> $this->user->data('username'),
			'user_copy'=>'1'
		));
		
		$this->load->view('dashboard/im', $this->d);
	}
	
	function Compose_IM($id){
		if ($id){
			$this->d['im'] = $this->im->get_im($id);
			$this->load->view('dashboard/im-compose');
		} else {
			$this->load->view('dashboard/im-compose');
		}
	}
	
	function Send_IM(){
		$action = $this->input->post('action');
		$id = $this->input->post('id');
		if ($action != 'discard'){
			if ($action == 'save') $draft = true;
			else $draft = false;
			$success = $this->im->send_im($draft);
		} else {
			$success = 1;
		}
		echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",'.$success.',"'.$id.'");</script>';
	}
	
	function View_IM($id){

		if ($im = $this->im->get_im($id)){

			
			if (strpos($im->to, ',')){
				$ids = explode(',', $im->to);
				foreach ($ids as $id){
					$to_array[] = $this->user->get_acname_by_username($id);
				}
			} else {
				$to_array[] = $this->user->get_acname_by_username($im->to);
			}
			$this->d['to_json'] = str_replace('"',"'",json_encode($to_array));
			$this->d['im'] = $im;
			
			if ($im->status != 'draft'){
				$this->im->mark_as_read($id);
				$this->load->view('dashboard/im-view',$this->d);
			} else {
				$this->d['im'] = $this->im->get_im($id);
				$this->load->view('dashboard/im-compose', $this->d);
			}
		} else {
			echo "<p><i>No message selected.</i></p>";
		}
	}
	
	function Reply_IM($id){
		if ($im = $this->im->get_reply_im($id)){
			$data['im'] = $im;
			$this->load->view('dashboard/im-compose',$data);
			$this->im->mark_as_read($id);
		} else {
			echo "<p><i>No message selected.</i></p>";
		}
	}
	
	function Delete_IM($id){
		if ($this->im->delete($id)) echo 'ok';
	}
	
	function Delete_IM_redir($id){
		$this->im->delete($id);
		$this->d['global_js'] = "showDialog('ok','Instant Message','Message has been deleted');";
		$this->d['im_list'] = $this->im->im_list(10,array('to'=>$this->user->data('username')));
		$this->load->view('dashboard/im', $this->d);
	}
	
	function Mark_IM_unread($id){
		$this->im->mark_as_unread($id);
	}
	
	function New_event(){
		$success = $this->calendar->add_event();
		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd('.$success.');</script>';	
	}
	
	function Edit_event(){
		$success = $this->calendar->edit_event();
		echo '<script language="javascript" type="text/javascript">window.top.window.readyEdit('.$success.');</script>';	
	}
	
	function Calendar_event_resize(){
		$this->calendar->resize_event();
	}
	
	function Calendar_event_shift(){
		$this->calendar->shift_event();
	}
	
	function Calendar_event_delete($id){
		$post_id = $this->input->post('id');
		if ($post_id) $id = $post_id;
		$this->calendar->delete_event($id);
	}
	
	function Calendar_json(){
		header('Content Type: application/json');
		echo $this->calendar->json_data();
	}
		
	function Add_task(){
		$success = $this->calendar->add_task();
		if (!$success) $success = '0';
		else $success = '1';
		$action = 'save';
		echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",'.$success.');</script>';	
	}
	
	function Add_schedule(){
		$success = $this->calendar->add_event();
		if (!$success) $success = '0';
		else $success = '1';
		$action = 'save';
		echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",'.$success.');</script>';	
		
	}
	
	function New_schedule(){
		$this->load->view('dashboard/new-schedule');
	}
	
	function New_task(){
		$this->load->view('dashboard/new-task');
	}
	
	function View_task($id){
		$this->d['task'] = $this->calendar->get_event($id);
		$this->load->view('dashboard/view-task', $this->d);
	}
	
	function View_schedule($id){
		$this->d['schedule'] = $this->calendar->get_event($id);
		$this->load->view('dashboard/view-schedule', $this->d);
	}
	
	function Delete_task($id){
		if ($this->calendar->delete_event($id)) echo 'ok';
	}
	
	function Delete_schedule($id){
		if ($this->calendar->delete_event($id)) echo 'ok';
	}
	
	function Update(){
		/*
		if ($this->system->config('version') < 1.01){
			$this->db->query("ALTER TABLE  `sales` ADD  `customer_phone` VARCHAR( 128 ) NULL");
			$this->db->query("UPDATE `config` SET `value` = '1.01' WHERE `config` = 'version'");
		} 
		*/
	}
	
	function Memo(){
		$to = date('Y-m-d 23:59:59');
		$from = date('Y-m-d 00:00:00', time() - (60 * 60 * 24 * 60));
	
		$filter[] = " `added_on` >= " . $this->db->escape($from);
		$filter[] = " `added_on` <= " . $this->db->escape($to);
		
		$filter_string = implode(' AND ', $filter);
		
		$this->d['to'] = $to;
		$this->d['from'] = $from;
		
		$this->d['memos'] = $this->memo->get_memos($filter_string);
		
		$this->load->view('dashboard/memo', $this->d);
	}
	
	function Memo_filter(){
		
		list($day, $month, $year) = explode('/', $this->input->post('date_from'));
		$from = $year . '-' . $month . '-' . $day;
		
		list($day, $month, $year) = explode('/', $this->input->post('date_to'));
		$to = $year . '-' . $month . '-' . $day;
		
		if (strtotime($from) > strtotime($to)){
			$a = $from;
			$to = $from;
			$from = $a;
		}
		
		$from = $from . ' 00:00:00';
		$to = $to . ' 23:59:59';
		
		$filter[] = " `added_on` >= " . $this->db->escape($from);
		$filter[] = " `added_on` <= " . $this->db->escape($to);
		
		$filter_string = implode(' AND ', $filter);
		
		$this->d['memos'] = $this->memo->get_memos($filter_string);
		
		$this->load->view('dashboard/memo-filtered', $this->d);
		
	}
	
	function Add_memo($do){
		if ($do == 'do'){
			$this->memo->add_memo();
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';				
		} else {
			$this->load->view('dashboard/memo-add');
		}
	}
	
	function Edit_memo($id){
		if ($do == 'do'){
			$this->memo->edit_memo($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['memo'] = $this->memo->get_memo_by_id($id);
			$this->load->view('dashboard/memo-edit', $this->d);
		}
	}
	
	function View_memo($id){
		$this->d['memo'] = $this->memo->get_memo_by_id($id);
		$this->load->view('dashboard/memo-view', $this->d);
	}
	
	function Delete_memo($id, $do){
		if ($do == 'do'){
			$this->memo->delete_memo($id);
			echo 'ok';
		}
	}
		
}

