<?php

class Editor extends Controller {

	var $editor_types = array(
		'r', 'c', 'd', 'h', 'm', 
		'pl', 'sh', 'rb', 'pm', 'py', 'cs', 'cc', 'as', 'js',
		'eml', 'rss', 'tcl', 'cbl', 'cpp', 'cfm', 'cob', 
		'clj', 'cls', 'bat', 'pyc', 'pyo', 'sql', 'cmd', 
		'cgi', 'xml', 'vbs', 'csv', 'inc', 'asp', 'jsp', 
		'txt', 'htm', 'css', 'css', 'php', 'ini', 'conf',
		'html', 'aspx', 'php4', 'php5', 'java', 'atom', 'vhdl',
		'xhtml', 'plist', 'phtml', 'coffee', 'htaccess', ''
	);
	
	var $viewer_types = array(
		'gif', 'jpg', 'png', 'bmp', 'ico', 'icns', 'icon', 'jpeg'
	);
	
	var $modes = array(
		'c' 		=> 'clike',
		'cpp'		=> 'clike',
		'h'			=> 'clike',
		'java'		=> 'clike',
		'sh'		=> 'shell',
		'htaccess'	=> 'shell',
		'pl'		=> 'application/x-httpd-php',
		'pyo'		=> 'python',
		'css'		=> 'css',
		'js'		=> 'javascript',
		'asp'		=> 'application/x-aspx',
		'jsp'		=> 'application/x-jsp',
		'php'		=> 'application/x-httpd-php',
		'php4'		=> 'application/x-httpd-php',
		'php5'		=> 'application/x-httpd-php',
		'html'		=> 'text/html',
		'xml'		=> 'xml',
		'atom'		=> 'xml',
		'rss'		=> 'xml'
		
	);

	function Editor(){
		parent::Controller();
		

		$this->d['user'] = $this->user->data();
		$this->d['system'] = $this->system->config();
		
		$this->load->model('texteditor');
		
	}
	
	function Index(){
		$this->d['title'] = 'Editor';
		
		$this->d['profiles'] = $this->texteditor->get_profiles("ORDER BY `name` ASC");
	
		$this->load->view('editor/editor-header', $this->d);
		$this->load->view('editor/index', $this->d);
		$this->load->view('footer');
	}
	
	
	function Profile_list(){

		$this->d['profiles'] = $this->texteditor->get_profiles("ORDER BY `name` ASC");
		$this->load->view('editor/profiles', $this->d);
		
	}
	
	function Add($do){
		if ($do == 'do'){
			$api_key 		= md5($this->input->post('hostname').date('Ymd').$_SERVER['HOST_ADDR']);
			$linker_file 	= md5($api_key.'plexsvn_linker') . '.php';
			$root_path 		= $this->input->post('root_path');
			$this->texteditor->add_profile($api_key, $linker_file);
			
			
$file = '

<?php
 
 error_reporting(E_ERROR);

$allowed_ip 	= "'.$_SERVER['SERVER_ADDR'].'";
$api_key 		= "'.$api_key.'";
$ip				= $_SERVER["REMOTE_ADDR"];
$current_file	= $_SERVER["SCRIPT_FILENAME"];
$string			= decrypt(file_get_contents("php://input"), $api_key);
$postdata		= json_decode($string);

if ($ip == $allowed_ip && $api_key == $postdata->api_key){
	
	switch ($postdata->action){
		case "test":

			$data->status 	= "Success";
			$data->message 	= "Test OK!";
			$data->postdata	= $postdata->mydata;
			echo encrypt(json_encode($data), $api_key);

			break;
		case "write_to_file":
		
			$filename = $postdata->filename;
			$contents = stripslashes($postdata->contents);
		
			$handle = fopen($filename, "w+");
			$data->length = fwrite($handle, $contents);
			fclose($handle);
			
			$data->filename = $filename;
			$data->status = "ok";
			
			echo encrypt(json_encode($data), $api_key);
			
			break;
		case "read_file":

			$filename = $postdata->filename;
		
			$handle = fopen($filename, "r");
			$contents = fread($handle, filesize($filename));
			fclose($handle);
			
			$data->status = "ok";
			$data->contents = $contents;
			$data->filename = $filename;
			
			echo encrypt(json_encode($data), $api_key);
		
			break;
		case "file_list":
			
			$path = $postdata->path;
			
			if ($path[strlen($path)-1] != "/") $path .= "/";
			
			if ($handle = opendir($path)) {
			    while (false !== ($entry = readdir($handle))) {
			        if ($entry != "." && $entry != "..") {
			        	if (is_dir($path . $entry)) $directories[] = $entry;
			        	else {
			        		if ($current_file != $path . $entry)
			        		$files[] = $entry;
			        	}
			        }
			    }
			    closedir($handle);
			}
			
			$data->status = "ok";
			$data->hasfile = is_array($files) ? "true" : "false";
			$data->hasdir = is_array($directories) ? "true" : "false";
			$data->files = $files;
			$data->directories = $directories;
			
			echo encrypt(json_encode($data), $api_key);
			
			break;
		case "rename_file":
			rename($filename, $new_filename);	
			break;		
		
	}
}


function delete_file($filename){
	delete($filename);
}

function encrypt($str, $pass){
	$pass = str_split(str_pad("", strlen($str), $pass, STR_PAD_RIGHT));
	$stra = str_split($str);
	
	foreach($stra as $k=>$v){
		$tmp = ord($v)+ord($pass[$k]);
		$stra[$k] = chr( $tmp > 255 ?($tmp-256):$tmp);
	}   
	
	return join("", $stra);
}

function decrypt($str, $pass){
	$pass = str_split(str_pad("", strlen($str), $pass, STR_PAD_RIGHT));
	$stra = str_split($str);
	
	foreach($stra as $k=>$v){
		$tmp = ord($v)-ord($pass[$k]);
		$stra[$k] = chr( $tmp < 0 ?($tmp+256):$tmp);
	}
	
	return join("", $stra);
}

';
			$file = str_replace("\n",'',$file);
			$file = str_replace("\r",'',$file);
			$file = str_replace("\t",'',$file);
			
			$ftp_server 	= $this->input->post('ftp_server');
			$ftp_port 		= $this->input->post('ftp_port');
			$ftp_username	= $this->input->post('ftp_username');
			$ftp_password	= $this->input->post('ftp_password');
			
			
			$handle = fopen('linkers/'.$linker_file, 'w+');
			fwrite($handle, $file);
			fclose($handle);
			
			$fp = fopen('linkers/'.$linker_file, 'r');
			
			
			$ftp_ok = false;
			$ftp_error = 0;
			if ($conn_id = ftp_connect($ftp_server, $ftp_port)){
				if (@ftp_login($conn_id, $ftp_username, $ftp_password)) {
					if (ftp_fput($conn_id, $root_path . $linker_file, $fp, FTP_BINARY)) {
						$ftp_ok = true;
					} else {
						$ftp_error = 3;
					}
				} else {
					$ftp_error = 2;
				}
			} else {
				$ftp_error = 1;
			}
			
			
			ftp_close($conn_id);
			
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1,"'.$api_key.'" ,"'.$linker_file.'" ,\''.$file.'\','.($ftp_ok ? '1' : '0').','.$ftp_error.');</script>';	
		} else {	
			$this->load->view('editor/add', $this->d);
		}

	}
	
	
	function Edit($id, $do){
		if ($do == 'do'){
			$api_key 		= md5($this->input->post('hostname').date('Ymd').$_SERVER['HOST_ADDR']);
			$linker_file 	= md5($api_key.'plexsvn_linker') . '.php';
			$this->texteditor->edit_profile($id, $api_key, $linker_file);
			
			
$file = '

<?php
 
 error_reporting(E_ERROR);

$allowed_ip 	= "'.$_SERVER['SERVER_ADDR'].'";
$api_key 		= "'.$api_key.'";
$ip				= $_SERVER["REMOTE_ADDR"];
$current_file	= $_SERVER["SCRIPT_FILENAME"];
$string			= decrypt(file_get_contents("php://input"), $api_key);
$postdata		= json_decode($string);

if ($ip == $allowed_ip && $api_key == $postdata->api_key){
	
	switch ($postdata->action){
		case "test":

			$data->status 	= "Success";
			$data->message 	= "Test OK!";
			$data->postdata	= $postdata->mydata;
			echo encrypt(json_encode($data), $api_key);

			break;
		case "write_to_file":
		
			$filename = $postdata->filename;
			$contents = stripslashes($postdata->contents);
		
			$handle = fopen($filename, "w+");
			$data->length = fwrite($handle, $contents);
			fclose($handle);
			
			$data->filename = $filename;
			$data->status = "ok";
			
			echo encrypt(json_encode($data), $api_key);
			
			break;
		case "read_file":

			$filename = $postdata->filename;
		
			$handle = fopen($filename, "r");
			$contents = fread($handle, filesize($filename));
			fclose($handle);
			
			$data->status = "ok";
			$data->contents = $contents;
			$data->filename = $filename;
			
			echo encrypt(json_encode($data), $api_key);
		
			break;
		case "file_list":
			
			$path = $postdata->path;
			
			if ($path[strlen($path)-1] != "/") $path .= "/";
			
			if ($handle = opendir($path)) {
			    while (false !== ($entry = readdir($handle))) {
			        if ($entry != "." && $entry != "..") {
			        	if (is_dir($path . $entry)) $directories[] = $entry;
			        	else {
			        		if ($current_file != $path . $entry)
			        		$files[] = $entry;
			        	}
			        }
			    }
			    closedir($handle);
			}
			
			$data->status = "ok";
			$data->hasfile = is_array($files) ? "true" : "false";
			$data->hasdir = is_array($directories) ? "true" : "false";
			$data->files = $files;
			$data->directories = $directories;
			
			echo encrypt(json_encode($data), $api_key);
			
			break;
		case "rename_file":
			rename($filename, $new_filename);	
			break;		
		
	}
}


function delete_file($filename){
	delete($filename);
}

function encrypt($str, $key){
    $block = mcrypt_get_block_size("des", "ecb");
    $pad = $block - (strlen($str) % $block);
    $str .= str_repeat(chr($pad), $pad);

    return mcrypt_encrypt(MCRYPT_DES, $key, $str, MCRYPT_MODE_ECB);
}

function decrypt($str, $key){   
    $str = mcrypt_decrypt(MCRYPT_DES, $key, $str, MCRYPT_MODE_ECB);

    $block = mcrypt_get_block_size("des", "ecb");
    $pad = ord($str[($len = strlen($str)) - 1]);
    return substr($str, 0, strlen($str) - $pad);
}

';
			$file = str_replace("\n",'',$file);
			$file = str_replace("\r",'',$file);
			$file = str_replace("\t",'',$file);
			
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1,"'.$api_key.'" ,"'.$linker_file.'" ,\''.$file.'\');</script>';	
		} else {	
			$this->d['profile'] = $this->texteditor->get_profile_by_id($id);
			$this->load->view('editor/edit', $this->d);
		}

	}
	
	function Scratchpad(){
		$this->load->view('editor/scratchpad');
	}
	

	
	function Ajax($request){
		switch ($request){
			case "scratchpad_check":
				
				$username = $this->user->data('username');
				$query = $this->db->query("SELECT * FROM `editor_sessions` WHERE `username` = ? AND `item` = ?", array($username, 'scratchpad'));
				if ($query->num_rows()){
					$this->db->update('editor_sessions', array(
						'last_change'	=> time()
					), "`username` = '{$username}' AND `item` = 'scratchpad'");
				} else {
					$this->db->insert('editor_sessions',array(
						'last_change'	=> time(),
						'username'		=> $username,
						'item'			=> 'scratchpad'
					));
				}
				
				$query = $this->db->query("SELECT * FROM `editor_sessions` WHERE `item` = 'scratchpad' AND `last_change` >= ?", array(time() - 30));
				$sessions = $query->result();


				$data->text 	= $this->system->config('scratchpad');
				$data->sessions	= $sessions;
				
				echo json_encode($data);
				
				break;
			case "scratchpad_change":
				echo $_REQUEST['text'];
				
				$username = $this->user->data('username');
				$query = $this->db->query("SELECT * FROM `editor_sessions` WHERE `username` = ? AND `item` = ?", array($username, 'scratchpad'));
				if ($query->num_rows()){
					$this->db->update('editor_sessions', array(
						'last_change'	=> time()
					), "`username` = '{$username}' AND `item` = 'scratchpad'");
				} else {
					$this->db->insert('editor_sessions',array(
						'last_change'	=> time(),
						'username'		=> $username,
						'item'			=> 'scratchpad'
					));
				}
				
				
				$this->system->set_config('scratchpad', $_REQUEST['text']);
				break;
				
			case "open_profile":
				$id = $this->input->post('id');
				$profile = $this->texteditor->get_profile_by_id($id);


				$postdata->path = $profile->root_path;
				$data = $this->texteditor->plexsvn_request($profile, 'file_list', $postdata);

				
				echo json_encode($data);
				
				break;
				
			case "commit":
			
				break;
				
				
			case "delete_file":
			
				$id			= $this->input->post('id');
				$filename	= $this->input->post('filename');
				$profile 	= $this->texteditor->get_profile_by_id($id);
				
				if ($profile->root_path[strlen($profile->root_path)-1] != '/') $path = $profile->root_path . '/' . $filename;
				else $path = $profile->root_path . $filename;


				$postdata->filename = $path;
				$data = $this->texteditor->plexsvn_request($profile, 'delete_file', $postdata);
				
				echo json_encode($data);
				
				
			case "new_file":
			
				$id			= $this->input->post('id');
				$filename	= $this->input->post('filename');
				$profile 	= $this->texteditor->get_profile_by_id($id);

				$postdata->filename = $filename;
				$data = $this->texteditor->plexsvn_request($profile, 'new_file', $postdata);
				
				echo json_encode($data);
			
				break;
				
			case "save_file":
			
				$id			= $this->input->post('id');
				$filename	= $this->input->post('filename');
				$profile 	= $this->texteditor->get_profile_by_id($id);
				$contents	= stripslashes($_REQUEST['contents']);
				
				
				$postdata->filename = $filename;
				$postdata->contents = $contents;
				$data = $this->texteditor->plexsvn_request($profile, 'write_to_file', $postdata);
				
							
				$this->db->insert('editor_revisions', array(
					'profile_id'	=> $profile->id,
					'item'			=> $path,
					'contents'		=> $contents,
					'datetime'		=> date('Y-m-d H:i:s'),
					'user'			=> $this->user->data('username')
				));
				
				
				
				echo json_encode($data);
				
				break;
				
				
			case "get_file":
				$id			= $this->input->post('id');
				$filename	= $this->input->post('filename');
				$profile	= $this->texteditor->get_profile_by_id($id);
				
				$parts 		= explode('.',$filename);
				$type 		= $parts[count($parts)-1];
					
				if ($profile->root_path[strlen($profile->root_path)-1] != '/') $path = $profile->root_path . '/' . $filename;
				else $path = $profile->root_path . $filename;
				
				$query = $this->db->query("SELECT * FROM `editor_sessions` WHERE `profile_id` = ? AND `item` = ? AND `last_change` >= ?", array($profile->id, $path, time() - 90));
				if ($query->num_rows()){
					$session = $query->row();
					if ($session->username == $this->user->data('username')){
						$data->in_use = false;
					} else {
						$data->in_use = true;
					}
					
				} else {
					$this->db->insert('editor_sessions', array(
						'profile_id'	=> $profile->id,
						'username'		=> $this->user->data('username'),
						'last_change'	=> time(),
						'item'			=> $path
					));
				}
				
				
				if (in_array($type, $this->editor_types) || !$type){
					
					
					$postdata->filename = $path;
					$data = $this->texteditor->plexsvn_request($profile, 'read_file', $postdata);	
					
					
					$data->editor = true;
					
					$query = $this->db->query("SELECT * FROM `editor_revisions` WHERE `profile_id` = ? AND `item` = ? ORDER BY `datetime` DESC LIMIT 1", array($profile->id, $path));
					$last_revision = $query->row();
					
					if ($last_revision->contents != $data->contents){
						$this->db->insert('editor_revisions', array(
							'profile_id'	=> $profile->id,
							'item'			=> $path,
							'contents'		=> $data->contents,
							'datetime'		=> date('Y-m-d H:i:s'),
							'user'			=> $this->user->data('username')
						));
					}
					
					$data->mode = $this->modes[$type];
					
				} else {
					$data->editor = false;
				}
				
				echo json_encode($data);
				
				break;
				
				
				
			case "file_list":
				$id = $this->input->post('id');
				$path = $this->input->post('path');
				
				$profile = $this->texteditor->get_profile_by_id($id);
				
				if ($profile->root[strlen($profile->root)-1] != '/') $path = $profile->root_path . '/' . $path;
				else $path = $profile->root_path . $path;
				
				
				$postdata->path = $path;
				$data = $this->texteditor->plexsvn_request($profile, 'file_list', $postdata);
				
				
				echo json_encode($data);
				
				break;
				
			
		}
		
	}
	
	function Delete($id, $do){
		if ($do == 'do'){
			$this->db->query("DELETE FROM `editor_profiles` WHERE `id` = ?", array($id));
			echo 'ok';
		}
	}
		
	function TestIP(){
		echo $_SERVER['REMOTE_ADDR'];
	}
	
	
}