<?php

class FNB extends Controller {

	function FNB(){
		parent::Controller();


		$this->d['user'] = $this->user->data();
		$this->d['system'] = $this->system->config();

		$this->load->model('fb');
		$this->load->model('inv');

	}

	
	function Index(){

		$this->d['items'] = $this->fb->get_items("ORDER BY `category` ASC, `order` ASC");
		$this->d['categories_dropdown'] = $this->fb->get_categories(true);
		$this->d['subcategories_dropdown'] = $this->fb->get_subcategories(true);

		$this->d['title'] = 'Food &amp; Beverage';		
		
		$this->load->view('header', $this->d);
		$this->load->view('fnb/index', $this->d);
		$this->load->view('footer', $this->d);
	}
	
	function Items(){
		$this->d['items'] = $this->fb->get_items("ORDER BY `category` ASC, `order` ASC");
		$this->d['categories_dropdown'] = $this->fb->get_categories(true);
		$this->d['subcategories_dropdown'] = $this->fb->get_subcategories(true);
		
		$this->load->view('fnb/items',$this->d);
	}
	
	function Items_filter(){
		if ($sku = $this->input->post('sku')) $filter[] = "`sku` = ".$this->db->escape($sku);
		if ($name = $this->input->post('name')) $filter[] = "`name` LIKE ".$this->db->escape('%'.$name.'%');
		if ($category = $this->input->post('category')) $filter[] = "`category` = ".$this->db->escape($category);
		if ($subcategory = $this->input->post('subcategory')) $filter[] = "`subcategory` = ".$this->db->escape($subcategory);
		
		$filter_string = implode(' AND ', $filter);
		

		if ($filter_string) $filter_string = 'WHERE ' . $filter_string;
		
		$this->d['items'] = $this->fb->get_items($filter_string . " ORDER BY `order` ASC");
		
		$this->load->view('fnb/items-filtered',$this->d);

	}

	function Item_view($id){
		$this->d['item'] = $this->fb->get_item_by_id($id);
		$this->d['pos'] = $this->fb->get_purchase_order_by_item($id);
		
		$this->load->view('fnb/item-view',$this->d);
	}
	
	function Item_add($do){
		if ($do == 'do'){
			$item = $this->fb->get_item_by_sku($this->input->post('sku'));
			if ($item->id){
		 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(0);</script>';				
			} else {
				$this->fb->add_item();
		 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		 	}
		} else {
			$this->d['categories_dropdown'] = $this->fb->get_categories(true);
			$this->d['subcategories_dropdown'] = $this->fb->get_subcategories(true);
			$this->load->view('fnb/item-add',$this->d);
		}
	}
	
	function Item_edit($id, $do){
		$this->d['item'] = $item =  $this->fb->get_item_by_id($id);
		if ($do == 'do'){
			if ($item->sku == $this->input->post('sku')){
				$this->fb->edit_item($id);
		 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		 	} else {
		 		$other_item = $this->fb->get_item_by_sku($this->input->post('sku'));
		 		if ($other_item->id){
		 			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(0);</script>';
		 		} else {
			 		$this->fb->edit_item($id);
			 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		 		}
		 	}
		} else {
			$this->d['categories_dropdown'] = $this->fb->get_categories(true);
			$this->d['subcategories_dropdown'] = $this->fb->get_subcategories(true);

			$this->load->view('fnb/item-edit',$this->d);
		}
	}

	function Item_delete($id){
		$this->fb->delete_item($id);
		echo 'ok';
	}
	
	function Search_product($q, $t = 'name', $contact_id){
		
		$cell = 'name';
		if ($t == 'Product Name') $cell = 'name';
		elseif ($t == 'SKU') $cell = 'sku';
		
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' AND `warehouse_id` = ? ORDER BY `name` ASC", array($this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' ORDER BY `name` ASC");
		}

		if ($query->num_rows() < 1){
			echo "<tr><td colspan=\"3\"><strong>No item found</strong>. <a href=\"inventory/item_add/x/po\" class=\"target_dialog\">Create new item record</a>?</td></tr>";
			return;
		}
		$x = 0;
		echo '<tbody>';
		foreach ($query->result() as $product){
			$qty = $this->inv->get_item_quantity($product->id);
						
			$prices = null;
		
			$prices[$product->price] = $product->price;
			if ($product->price_2 != 0) $prices[$product->price_2] = $product->price_2 . ' (Price2)';
			if ($product->price_3 != 0) $prices[$product->price_3] = $product->price_3 . ' (Price3)';
			
			$price_dropdown = form_dropdown('price',$prices,$contact_price,'class="item-price-select" style="width: 100%"');
		
			$class = $x%2 == 0 ? 'class="alt"' : ''; 
			echo "<tr {$class} rel=\"{$product->id}\" weight=\"{$product->weight}\" weight_unit=\"{$product->weight_unit}\" volume=\"{$product->volume}\" volume_unit=\"{$product->volume_unit}\" name=\"{$product->name}\" sku=\"{$product->sku}\">
				<td class=\"checkbox\" rel=\"1\" title=\"{$product->name}\"><input type=\"radio\" name=\"product-item\" class=\"product-item\" value=\"{$product->id}\" /> <span class=\"product-name\">{$product->name}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>{$product->sku}</strong></span></td>
				<td rel=\"2\" style=\"width: 100px\" class=\"category\">{$product->category}</td>
				<td rel=\"3\" style=\"width: 100px\" class=\"subcategory\">{$product->subcategory}</td>
				<td rel=\"4\" style=\"width: 60px; text-align: right\"><span class=\"quantity-in-stock\">{$qty}</span></td>
				<td rel=\"5\" style=\"width: 100px; text-align: right\">{$price_dropdown}<span class=\"product-price\" style=\"display:none\">{$product->price}</span><span class=\"selling-price\" style=\"display:none\">{$product->price}</span></td></tr>";
			$x++;
		}
		echo '</tbody>';
	}

	function Get_item_options(){
		$sku = $this->input->post('sku');
		if ($item = $this->fb->get_item_by_sku($sku)){
			$this->d['item'] = $item;
			$this->load->view('fnb/item-options', $this->d);
		} else {
			echo 'false';
		}
	}
	
	function Get_customer_item_options(){
		$sku = $this->input->post('sku');
		if ($item = $this->fb->get_item_by_sku($sku)){
			$this->d['item'] = $item;
			$this->load->view('fnb/customer-item-options', $this->d);
		} else {
			echo 'false';
		}
	}

	
	function Printers(){

		$this->d['printers'] = $this->fb->get_printers();
		$this->load->view('fnb/printers',$this->d);
	}
	
	function Printer_add($do){
		if ($do == 'do'){
			$this->fb->add_printer();
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['categories'] = $this->fb->get_categories();
			$this->load->view('fnb/printer-add',$this->d);
		}

	}
	
	function Printer_edit($id, $do){
		if ($do == 'do'){
			$this->fb->edit_printer($id);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['printer'] = $this->fb->get_printer_by_id($id);
			$this->d['categories'] = $this->fb->get_categories();
			$this->load->view('fnb/printer-edit',$this->d);
		}
	
	}
	
	function Printer_delete($id){
		$this->fb->delete_printer($id);
		echo 'ok';	
	}
	
	function Ss_terminal(){

		$this->d['ssts'] = $this->fb->get_sst();
		$this->load->view('fnb/sst',$this->d);
	}
	
	function Sst_add($do){
		if ($do == 'do'){
			$this->fb->add_sst();
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$query = $this->db->query("SELECT * FROM `terminals`");
			foreach ($query->result() as $terminal){
				$terminals[$terminal->id] = $terminal->name;
			}
			$this->d['terminals']	= $terminals;
			$this->d['categories'] = $this->fb->get_categories();
			$this->load->view('fnb/sst-add',$this->d);
		}

	}
	
	function Sst_edit($id, $do){
		if ($do == 'do'){
			$this->fb->edit_sst($id);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$query = $this->db->query("SELECT * FROM `terminals`");
			foreach ($query->result() as $terminal){
				$terminals[$terminal->id] = $terminal->name;
			}
			$this->d['terminals']	= $terminals;
			$this->d['sst'] 		= $this->fb->get_sst_by_id($id);
			$this->d['categories'] 	= $this->fb->get_categories();
			$this->load->view('fnb/sst-edit',$this->d);
		}
	
	}
	
	function Sst_delete($id){
		$this->fb->delete_stt($id);
		echo 'ok';	
	}
	
	function Categories(){
		$query = $this->db->query("SELECT `category`, `iphone`,`category_order` FROM `fnb_inventory` GROUP BY `category` ORDER BY `category_order`");
		$this->d['categories'] = $query->result();
		
		$this->load->view('fnb/categories', $this->d);
	}
	
	function Edit_category($cat, $do){

		if ($do == 'do'){

			$old_cat = $this->input->post('old_cat');
			$new_cat = $this->input->post('new_cat');
			$iphone	= $this->input->post('iphone');
			
			$sql = $this->db->update_string('fnb_inventory', array(
				'category'			=> $new_cat,
				'iphone'			=> $iphone,
				'category_order'	=> $this->input->post('order'),
				'grouped'			=> $grouped
			), "`category` = '$old_cat'");
			$this->db->query($sql);
			
			$query = $this->db->query("SELECT * FROM `fnb_category_options` WHERE `name` = ?", array($old_cat));
			if ($query->num_rows()){
				$this->db->update('fnb_category_options', array(
					'name'			=> $new_cat,
					'options'		=> json_encode($this->input->post('option')),
					'price'			=> json_encode($this->input->post('price'))
				),"`name` = '{$old_cat}'");
				
			} else {
			
				$this->db->insert('fnb_category_options', array(
					'name'			=> $new_cat,
					'options'		=> json_encode($this->input->post('option')),
					'price'			=> json_encode($this->input->post('price'))
				));				
			}
			
			echo $sql;
			
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
			
		} else {
			
			$query = $this->db->query("SELECT `iphone`, `category_order` FROM `fnb_inventory` WHERE `category` = ? LIMIT 1", array($cat));
			$category = $query->row();
			
			$query = $this->db->query("SELECT `subcategory` FROM `fnb_inventory` WHERE `category` = ? GROUP BY `subcategory` ORDER BY `subcategory` ASC", array($cat));
			$this->d['subcategories'] 	= $query->result();
			
			$query = $this->db->query("SELECT * FROM `fnb_category_options` WHERE `name` = ?", array($cat));
			$this->d['options']			= $query->row();
			
			$this->d['iphone'] 			= $category->iphone;
			$this->d['order'] 			= $category->category_order;
			$this->d['old_cat'] 		= $cat;
			
			$this->load->view('fnb/edit-category',$this->d);

		}
	}
	
	
	
	function Subcategories(){
		$query = $this->db->query("SELECT `category`, `subcategory`, `iphone`,`category_order` FROM `fnb_inventory` GROUP BY `subcategory` ORDER BY `category_order`");
		$this->d['subcategories'] = $query->result();
		
		$this->load->view('fnb/subcategories', $this->d);
	}
	
	function Edit_subcategory($cat, $subcat, $do){

		if ($do == 'do'){

			$old_cat = $this->input->post('old_cat');
			$new_cat = $this->input->post('new_cat');
			$iphone	= $this->input->post('iphone');
			
			$sql = $this->db->update_string('fnb_inventory', array(
				'category'			=> $new_cat,
				'iphone'			=> $iphone,
				'category_order'	=> $this->input->post('order'),
				'grouped'			=> $grouped
			), "`category` = '$old_cat'");
			$this->db->query($sql);
			
			$query = $this->db->query("SELECT * FROM `fnb_category_options` WHERE `name` = ?", array($old_cat));
			if ($query->num_rows()){
				$this->db->update('fnb_category_options', array(
					'name'			=> $new_cat,
					'options'		=> json_encode($this->input->post('option')),
					'price'			=> json_encode($this->input->post('price'))
				),"`name` = '{$old_cat}'");
				
			} else {
			
				$this->db->insert('fnb_category_options', array(
					'name'			=> $new_cat,
					'options'		=> json_encode($this->input->post('option')),
					'price'			=> json_encode($this->input->post('price'))
				));				
			}
			
			echo $sql;
			
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
			
		} else {
			
			$query = $this->db->query("SELECT `iphone`, `category_order` FROM `fnb_inventory` WHERE `subcategory` = ? AND `category` = ? LIMIT 1", array($subcat, $cat));
			$subcategory = $query->row();
						
			$query = $this->db->query("SELECT * FROM `fnb_category_options` WHERE `name` = ?", array($subcat));
			$this->d['options']			= $query->row();
			
			$this->d['iphone'] 			= $category->iphone;
			$this->d['order'] 			= $category->category_order;
			$this->d['old_subcat']		= $category->subcategory;
			$this->d['old_cat'] 		= $cat;
			
			$this->load->view('fnb/edit-subcategory',$this->d);

		}
	}

	
	function Save_arrangement(){
		$arrangement = $this->input->post('coa');

		$i = 0;
		foreach ($arrangement as $account){
			if ($account){
				$i++;
				$this->db->query("UPDATE `fnb_inventory` SET `order` = ? WHERE `id` = ?",array($i, $account));
			}
			
		}
		
		$this->d['items'] = $this->fb->get_items("ORDER BY `order` ASC");		
		$this->load->view('fnb/items-filtered', $this->d);
	
	}
	
	
	function Update_cell(){
		$field = str_replace('`', '', $this->input->post('field'));
		$val = $this->input->post('val');
		$id = $this->input->post('id');
		
		if ($field == 'qty'){
			$this->inv->update_quantity($id, $val);
			echo $val;
		} else {		
			$this->db->query("UPDATE `fnb_inventory` SET `$field` = ? WHERE `id` = ?", array($val, $id));
		
			$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `id` = ?", array($id));
			$row = $query->row();
		
			echo $row->$field;
		}
	}
	

}