<?php

class HR extends Controller {

	function HR(){
		parent::Controller();

		$this->d['user'] = $this->user->data();
		$this->d['system'] = $this->system->config();

		$this->load->model('hrm');
		$this->load->model('charts');
		$this->load->helper('autocomplete_helper');
		
	}
	
	function Config(){
		$query = $this->db->query("SELECT * FROM `salary_voucher_format` ORDER BY `type`");
		$this->d['sv_breakdown'] = $query->result();
		
		$this->load->view('hr/config', $this->d);
	}
	
	function Index(){
		$this->d['title'] = 'HR';
		
		
		$query = $this->db->query("SELECT * FROM `employees`");
		$this->d['total_employees'] = $query->num_rows();
		
		$query = $this->db->query("SELECT * FROM `leave` WHERE `from` >= '$this_month_from' AND `from` <= '$this_month_to'");
		$this->d['total_leave_this_month'] = $query->num_rows();
		
		$query = $this->db->query("SELECT * FROM `leave` WHERE `from` >= '$last_month_from' AND `from` <= '$last_month_to'");
		$this->d['total_leave_last_month'] = $query->num_rows();
		
		$query = $this->db->query("SELECT * FROM `vacancies` WHERE `status` = 'Active'");
		$this->d['total_active_recruitment'] = $query->num_rows();
		
		$query = $this->db->query("SELECT * FROM `vacancies` WHERE `status` = 'Closed'");
		$this->d['total_closed_recruitment'] = $query->num_rows();

		
		$this->load->view('header', $this->d);
		$this->load->view('hr/index',$this->d);
		$this->load->view('footer', $this->d);

	}
	
	function Overview(){
		$this->d['leave_list'] = $this->hrm->get_leave_list("`status` = 'Pending'");
		
		$this_month_from = date('Y-m-1');
		$this_month_to = date('Y-m-t');
		
		$last_month_from = date('Y-m-1',mktime(0 ,0 ,0,date('m')-1,1,date('Y')));
		$last_month_to = date('Y-m-t',mktime(0 ,0 ,0,date('m')-1,1,date('Y')));
		
		$query = $this->db->query("SELECT * FROM `employees`");
		$this->d['total_employees'] = $query->num_rows();
		
		$query = $this->db->query("SELECT * FROM `leave` WHERE `from` >= '$this_month_from' AND `from` <= '$this_month_to'");
		$this->d['total_leave_this_month'] = $query->num_rows();
		
		$query = $this->db->query("SELECT * FROM `leave` WHERE `from` >= '$last_month_from' AND `from` <= '$last_month_to'");
		$this->d['total_leave_last_month'] = $query->num_rows();
		
		$query = $this->db->query("SELECT * FROM `vacancies` WHERE `status` = 'Active'");
		$this->d['total_active_recruitment'] = $query->num_rows();
		
		$query = $this->db->query("SELECT * FROM `vacancies` WHERE `status` = 'Closed'");
		$this->d['total_closed_recruitment'] = $query->num_rows();
		
		$this->load->view('hr/overview',$this->d);
	}
	
	function Recruitment(){
		$this->d['recruitments'] = $this->hrm->get_recruitments();
		$this->load->view('hr/recruitment',$this->d);
	}
	
	function Edit_applicant($id, $do){
		if ($do){
			if (!$this->input->post('firstname')) return;
			if ($this->hrm->edit_applicant($id)){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			} else {
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			}
		} else{
			$this->d['applicant'] = $this->hrm->get_applicant($id);
			$this->load->view('hr/edit-applicant',$this->d);
		}
	}
	
	function Add_applicant($vacancy_id, $do){
		if ($do){
			if (!$this->input->post('firstname')) return;
			if ($this->hrm->add_applicant($vacancy_id)){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			} else {
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			}
		} else{
			$this->d['vacancy_id'] = $vacancy_id;
			$this->load->view('hr/new-applicant',$this->d);
		}
	}
	
	
	function Payroll(){
		$from = date('Y-m-1');
		$to = date('Y-m-t');

		$query = $this->db->query("SELECT * FROM `salary_voucher` WHERE `datetime` >= ? AND `datetime` <= ?", array($from, $to));
		$svs = $query->result();
		
		foreach ($svs as $sv){
			$svs_list[$sv->employee_id] = $sv;
		}
		
		$this->d['employees'] = $this->hrm->get_employees();
		$this->d['svs'] = $svs_list;
		
		$this->load->view('hr/payroll', $this->d);
	}
	
	function Payroll_filter(){
		$from = date('Y-m-1');
		$to = date('Y-m-t');

		$query = $this->db->query("SELECT * FROM `salary_voucher` WHERE `datetime` >= ? AND `datetime` <= ?", array($from, $to));
		$svs = $query->result();
		
		foreach ($svs as $sv){
			$svs_list[$sv->employee_id] = $sv;
		}
		
		$this->d['employees'] = $this->hrm->get_employees();
		$this->d['svs'] = $svs_list;
		
		$this->load->view('hr/payroll', $this->d);
	
	}
	
	function Add_payslip($do){
		if ($do == 'do'){
			$this->hrm->add_payslip();
			echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';

		} else {
			$employees = $this->hrm->get_employee_list("WHERE employment.status != 'Resigned'");
			$employee_list[] = 'Select';
			foreach ($employees as $employee){
				if ($employee->id != $id){
					$employee_list[$employee->id] = $employee->firstname . ' ' . $employee->lastname .' ('. $employee->job_title .')';
				}
			}
			$this->d['employee_list'] = $employee_list;
			
			$query = $this->db->query("SELECT * FROM `salary_voucher_format` WHERE `type` = 'Basic'");
			$this->d['basic_denomination'] = $query->result();
			
			$query = $this->db->query("SELECT * FROM `salary_voucher_format` WHERE `type` = 'Add'");
			$this->d['add_denomination'] = $query->result();
			
			$query = $this->db->query("SELECT * FROM `salary_voucher_format` WHERE `type` = 'Deduct'");
			$this->d['deduct_denomination'] = $query->result();
			
			$query = $this->db->query("SELECT * FROM `salary_voucher_format` WHERE `type` = 'BDeduct'");
			$this->d['basic_deduct_denomination'] = $query->result();


			$query = $this->db->query("SELECT * FROM `salary_voucher_format` WHERE `type` = 'Null'");
			$this->d['null_denomination'] = $query->result();

			$this->load->view('hr/new-payslip',$this->d);
		}
	}
	
	
	function Add_vacancy($do){
		if ($do){
			if (!$this->input->post('job_title')) return;
			if ($this->hrm->add_vacancy()){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			} else {
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			}
		} else {
			$managers_dropdown[''] = 'Select Manager';
			$query = $this->db->query("SELECT employees.*, employment.job_title AS `job_title` FROM `employees` LEFT JOIN `employment` ON employees.id = employment.employee_id ORDER BY `firstname` ASC");
			foreach ($query->result() as $emp){
				$managers_dropdown[$emp->id] = $emp->firstname . ' ' . $emp->lastname . ' &mdash; ' . $emp->job_title ;
			}
			
			$this->d['managers_dropdown'] = $managers_dropdown;
			
			$this->load->view('hr/new-vacancy', $this->d);
		}
	}
	
	function View_vacancy($id){
		$this->d['vacancy'] = $this->hrm->get_vacancy($id);
		$this->load->view('hr/view-vacancy',$this->d);
	}
	
	function Edit_vacancy($id, $do){
		if ($do){
			if (!$this->input->post('job_title')) return;
			if ($this->hrm->edit_vacancy($id)){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			} else {
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			}
		} else {
			$this->d['vacancy'] = $this->hrm->get_vacancy($id);
			$this->load->view('hr/edit-vacancy',$this->d);
		}
	}
	
	function Employee(){
		$this->d['employees'] = $this->hrm->get_employee_list();
		$this->load->view('hr/employee', $this->d);
	}
	
	function Add_employee($action){
		if ($action == 'do'){
			if ($id = $this->hrm->add_employee()){
				$user_id = $this->input->post('user');
				$this->db->update('users', array(
					'employee_id'	=> $id
				), "`id` = '{$user_id}'");
				
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			} else {
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			}

		} else {
			$query = $this->db->query("SELECT * FROM `users` WHERE `employee_id` = 0 OR `employee_id` IS NULL");
			$unlinked_users[] = 'Select User';
			foreach ($query->result() as $user){
				$unlinked_users[$user->id] = $user->firstname . ' ' . $user->lastname . ' (' . $user->username . ')';
			}
			
			$this->d['unlinked_users'] = $unlinked_users;
			$this->load->view('hr/new-employee', $this->d);
		}
	}
	
	function Edit_employee($id,$action){
		if ($action == 'do'){
			if ($this->hrm->edit_employee($id)){
				
				$this->db->update('users', array(
					'employee_id' => 0,
				),"`employee_id` = '{$id}'");
				
				$user_id = $this->input->post('user');
				
				$this->db->update('users', array(
					'employee_id' => $id,
				),"`id` = '{$user_id}'");
								
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			} else {
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			}

		} else {
			$this->d['employee'] = $this->hrm->get_employee("`id` = '$id'");
			$employees = $this->hrm->get_employee_list();
			$employee_list[] = 'Select';
			foreach ($employees as $employee){
				if ($employee->id != $id){
					$employee_list[$employee->id] = $employee->firstname . ' ' . $employee->lastname .' ('. $employee->job_title .')';
				}
			}
			$this->d['employee_list'] = $employee_list;
			
			$query = $this->db->query("SELECT * FROM `users` WHERE `employee_id` = ?", array($id));
			$user = $query->row();
			
			$this->d['user'] = $user->id;
			
			if ($user){
				$query = $this->db->query("SELECT * FROM `users` WHERE `employee_id` = 0 OR `employee_id` IS NULL OR `employee_id` = ? ", array($id));
			} else {
				$query = $this->db->query("SELECT * FROM `users` WHERE `employee_id` = 0 OR `employee_id` IS NULL");
			}
			$unlinked_users[] = 'Select User';
			foreach ($query->result() as $user){
				$unlinked_users[$user->id] = $user->firstname . ' ' . $user->lastname . ' (' . $user->username . ')';
			}
			
			
			$salary_categories[] = 'Select Category';
			$query = $this->db->query("SELECT `salary_category` FROM `employees` GROUP BY `salary_category` ORDER BY `salary_category`");
			foreach ($query->result() as $sc){
				if ($sc->salary_category){
					$salary_categories[$sc->salary_category] = $sc->salary_category;
				}
			}
			
			$this->d['salary_categories'] = $salary_categories;
			
			
			$this->d['unlinked_users'] = $unlinked_users;			
			
			$this->load->view('hr/edit-employee', $this->d);
		}
	}
	
	function View_employee($id){
		$this->d['employee'] = $this->hrm->get_employee("`id` = '$id'");
		$this->load->view('hr/view-employee', $this->d);
	}
	
	function Leave(){
		$this->d['leave_list'] = $this->hrm->get_leave_list();
		$this->load->view('hr/leave-list', $this->d);
	}
	
	function Assign_leave($do){
		if ($do == 'do'){
			if ($this->hrm->assign_leave()){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			} else {
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			}
		} else {
			$this->d['employees_dropdown'] = $this->hrm->get_employee_dropdown(); 
			$this->load->view('hr/assign-leave',$this->d);
		}
	}
	
	function Upload_document($employee_id){

		if (!is_dir('./assets/documents/employee_'.$employee_id)) mkdir('./documents/employee_'.$employee_id);

		$config['upload_path'] = './documents/employee_'.$employee_id;
		$config['allowed_types'] = 'rar|zip|doc|docx|xls|xlx|ppt|pptx|ppts|txt|rtf|gif|jpg|png';
		$config['max_size']	= '50000';
		
		$this->load->library('upload', $config);
	
		if (!$this->upload->do_upload()){
			$error = array('error' => $this->upload->display_errors());
			echo '<script language="javascript" type="text/javascript">window.top.window.stopUpload(0);</script>';
		} else 	{
			$file_data = $this->upload->data();
			
			$sql = $this->db->insert_string('employee_documents',array(
				'employee_id'		=> $employee_id,
				'filename'			=> $file_data['file_name'],
				'filetype'			=> $file_data['file_ext'],
				'size'				=> $file_data['file_size']				
			));
			
			$this->db->query($sql);
			
		}
	}
	
	function Edit_leave($id, $do){
		if ($do == 'do'){
			if ($this->hrm->edit_leave($id)){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			} else {
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			}		
		} else {
			$this->d['leave'] = $this->hrm->get_leave($id);
			$this->load->view('hr/edit-leave',$this->d);
		}

	}
	
	function Delete_sv($id, $do){
		if ($id){
			$this->db->query("DELETE FROM `salary_voucher` WHERE `id` = ?", array($id));
			$this->db->query("DELETE FROM `salary_voucher_items` WHERE `sv_id` = ?", array($id));
			echo 'ok';
		}
	}
	
	function Delete_supervisor($subordinate_id, $supervisor_id){
		$this->db->query("DELETE FROM `report_to` WHERE `supervisor_id` = '$supervisor_id' AND `subordinate_id` = '$subordinate_id'");
		echo 'ok';
	}
	
	function Delete_dependent($employee_id, $dependent_id){
		$this->db->query("DELETE FROM `employee_dependents` WHERE `id` = '$dependent_id'");
		echo 'ok';
	}
		
	function Delete_contact($employee_id, $contact_id){
		$this->db->query("DELETE FROM `employee_emergency_contacts` WHERE `id` = '$contact_id'");
		echo 'ok';
	}
	
	function Delete_work_experience($employee_id, $we_id){
		$this->db->query("DELETE FROM `employee_work_experience` WHERE `id` = '$we_id'");
		echo 'ok';
	}
	
	function Delete_education($employee_id, $education_id){
		$this->db->query("DELETE FROM `employee_education` WHERE `id` = '$education_id'");
		echo 'ok';
	}
	
	function Delete_skill($employee_id, $skill_id){
		$this->db->query("DELETE FROM `employee_skills` WHERE `id` = '$skill_id'");
		echo 'ok';
	}
	
	function Delete_language($employee_id, $language_id){
		$this->db->query("DELETE FROM `employee_languages` WHERE `id` = '$language_id'");
		echo 'ok';
	}
	
	function Delete_license($employee_id, $license_id){
		$this->db->query("DELETE FROM `employee_licenses` WHERE `id` = '$license_id'");
		echo 'ok';
	}
	
	
	function Ajax($type){
		switch ($type){
			case "calculate_payslip":
				
				$gross = $this->input->post('gross');
				$employee_id = $this->input->post('id');
				
				
				$employee = $this->hrm->get_employee_by_id($employee_id);
				
				$deduction_formats = $this->hrm->get_payslip_format('Deduct');

				foreach ($deduction_formats as $deduct_type){
					if ($deduct_type->percentage){
						$deduct[$deduct_type->field_name] = $gross * $deduct_type->percentage / 100;
					} else {
						$query = $this->db->query("SELECT * FROM `salary_deduction_table` WHERE `gross_to` >= ? AND `gross_from` <= ? AND `type` = ?", array($gross, $gross, $deduct_type->name));
						$res = $query->row();
						$deduct[$deduct_type->field_name] = $res->deduction_amount;
					}
				}
				
				$null_formats = $this->hrm->get_payslip_format('Null');

				foreach ($null_formats as $deduct_type){
					if ($deduct_type->percentage){
						$deduct[$deduct_type->field_name] = $gross * $deduct_type->percentage / 100;
					} else {
						$query = $this->db->query("SELECT * FROM `salary_deduction_table` WHERE `gross_to` >= ? AND `gross_from` <= ? AND `type` = ?", array($gross, $gross, $deduct_type->name));
						$res = $query->row();
						$deduct[$deduct_type->field_name] = $res->deduction_amount;
					}
				}
				
				echo json_encode($deduct);
				

			
			break;
			case "delete_deduction":
				$id = $this->input->post('id');
				$this->db->query("DELETE FROM `salary_deduction_table` WHERE `id` = ?", array($id));
				
			break;
			case "save_deduction":
				$id = $this->input->post('id');
				if ($id){
					$this->db->update('salary_deduction_table',array(
						'gross_from'		=> $this->input->post('gross_from'),
						'gross_to'			=> $this->input->post('gross_to'),
						'deduction_amount'	=> $this->input->post('deduction_amount'),
						'type'				=> $this->input->post('type'),
						'conditions'		=> $this->input->post('conditions')
					),array(
						'id'				=> $id
					));
					
				} else {
					$this->db->insert('salary_deduction_table',array(
						'gross_from'		=> $this->input->post('gross_from'),
						'gross_to'			=> $this->input->post('gross_to'),
						'deduction_amount'	=> $this->input->post('deduction_amount'),
						'type'				=> $this->input->post('type'),
						'conditions'		=> $this->input->post('conditions')
					));
				}
			
			break;
			case "deduction_table":
			
				$query = $this->db->query("SELECT `type` FROM `salary_deduction_table` GROUP BY `type`");
				$types[''] = 'All Types';
				foreach ($query->result() as $d){
					$types[$d->type] = $d->type;
				}
				$data['types'] = $types;
			
				$data['current_type'] = $type = $this->input->post('type');
				if (trim($type)){
					$filters[] = " `type` = " . $this->db->escape($type);
				}
				
				if (count($filters)){
					$filter = ' WHERE ' . implode(' AND ', $filters);
				}
			
				$query = $this->db->query("SELECT * FROM `salary_deduction_table` $filter ORDER BY `type` ASC,`gross_from` ASC");
				$deductions = $query->result();
				$data['deductions'] = $deductions;
				
				$this->load->view('hr/ajax/deduction-table', $data);
				
			break;
			case "upload_csv_timesheet":
				$config['upload_path'] = 'media';
				$config['allowed_types'] = 'text/plain|text/csv|csv';
				$config['max_size'] = '10000';
				$config['file_name'] = 'upload' . time();

				$this->load->library('upload', $config);

				if(!$this->upload->do_upload('file')){
					$error = 1;
					$msg = $this->upload->display_errors();
					
				} else {
					$file_info = $this->upload->data('file');
					$csvfilepath = "media/" . $file_info['file_name'];
					
					$res = fopen($csvfilepath, 'r');
					$data = fread($res, filesize($csvfilepath));
					fclose($res);
					
					$lines = explode("\n", $data);
					foreach ($lines as $line){
						$line = trim($line);
						list($datetime, $employee_id, $cico) = explode(',', $line);
						list($date, $time) = explode(' ', $datetime);
						list($year, $month, $day) = explode('-',$date);
						if (strlen($year) == 2) $year = '20'.$year;
						$date = $year . '-' . $month . '-' . $day;
						
						$this->db->insert('employee_cico', array(
							'employee_id'	=> $employee_id,
							'check_in'		=> $cico ? $date . ' ' . $time : null,
							'check_out'		=> !$cico ? $date . ' ' . $time : null
						));
						
					}
					
					$msg = 'Timesheet has been uploaded successfully!';

    			}
    			
				echo '<script language="javascript" type="text/javascript">window.top.window.uploadStatus("'.$msg.'");</script>';
			
				break;
			case "add_supervisor":
				$supervisor_id	= $this->input->post('supervisor_id');
				$supervisor 	= $this->hrm->get_employee("`id` = '$supervisor_id'");
				$employee_id 	= $this->input->post('employee_id');
				$employee 		= $this->hrm->get_employee("`id` = '$employee_id'");
				$method			= $this->input->post('method');
				
				if ($supervisor_id == $employee_id){
					echo 'invalid'; 
					return;
				}
				
				if ($this->hrm->add_report_to($supervisor, $employee, $method)) echo $supervisor->firstname . ' ' . $supervisor->lastname . '|' . $supervisor->id;
				else echo 'failed';
				return;

			break;
			case "add_subordinate":
				$subordinate_id	= $this->input->post('subordinate_id');
				$subordinate 	= $this->hrm->get_employee("`id` = '$subordinate_id'");
				$employee_id 	= $this->input->post('employee_id');
				$employee 		= $this->hrm->get_employee("`id` = '$employee_id'");
				$method			= $this->input->post('method');
				
				if ($subordinate_id == $employee_id){
					echo "invalid";
					return;
				}

				if ($this->hrm->add_report_to($employee, $subordinate, $method)) echo $subordinate->firstname . ' ' . $subordinate->lastname . '|' . $subordinate->id;
				else echo 'failed';
				return;
			break;
			case "add_contact":
				$name			= $this->input->post('name');
				$relationship	= $this->input->post('relationship');
				$home_phone		= $this->input->post('home_phone');
				$work_phone		= $this->input->post('work_phone');
				$mobile			= $this->input->post('mobile');
				$employee_id	= $this->input->post('employee_id');
				
				$sql = $this->db->insert_string('employee_emergency_contacts', array(
					'name'			=> $name,
					'relationship'	=> $relationship,
					'home_phone'	=> $home_phone,
					'work_phone'	=> $work_phone,
					'mobile'		=> $mobile,
					'employee_id'	=> $employee_id
				));
				
				if ($this->db->query($sql)) echo $this->db->insert_id();
				else echo 'failed';
				
			break;
			case "add_dependent":
				$name 			= $this->input->post('name');
				$relationship	= $this->input->post('relationship');
				$dob			= $this->input->post('dob');
				$employee_id	= $this->input->post('employee_id');
				
				list($day, $month, $year) = explode('/', $dob);
				$dob = $year . '-' . $month . '-' . $day;
				
				$sql = $this->db->insert_string('employee_dependents', array(
					'name'			=> $name,
					'relationship'	=> $relationship,
					'dob'			=> $dob,
					'employee_id'	=> $employee_id
				));
				
				if ($this->db->query($sql)) echo $this->db->insert_id();
				else echo 'failed';
			
			break;
			case "add_work_experience":
				$employer		= $this->input->post('employer');
				$from			= $this->input->post('from');
				$to				= $this->input->post('to');
				$job_title		= $this->input->post('job_title');
				$remarks		= $this->input->post('remarks');
				$employee_id	= $this->input->post('employee_id');
				
				list($day, $month, $year) = explode('/', $from);
				$from = $year . '-' . $month . '-' . $day;
				
				list($day, $month, $year) = explode('/', $to);
				$to = $year . '-' . $month . '-' . $day;
				
				$sql = $this->db->insert_string('employee_work_experience', array(
					'employer'		=> $employer,
					'start_date'	=> $from,
					'end_date'		=> $to,
					'job_title'		=> $job_title,
					'remarks'		=> $remarks,
					'employee_id'	=> $employee_id
				));
				
				if ($this->db->query($sql)) echo $this->db->insert_id();
				else echo 'failed';
			
			break;
			case "add_education":
				$education		= $this->input->post('education');
				$from			= $this->input->post('from');
				$to				= $this->input->post('to');
				$major			= $this->input->post('major');
				$year			= $this->input->post('year');
				$gpa_score		= $this->input->post('gpa_score');
				$employee_id	= $this->input->post('employee_id');
				
				list($day, $month, $year) = explode('/', $from);
				$from = $year . '-' . $month . '-' . $day;
				
				list($day, $month, $year) = explode('/', $to);
				$to = $year . '-' . $month . '-' . $day;
				
				$sql = $this->db->insert_string('employee_education', array(
					'education'		=> $education,
					'start_date'	=> $from,
					'end_date'		=> $to,
					'major'			=> $major,
					'gpa_score'		=> $gpa_score,
					'year'			=> $year,
					'employee_id'	=> $employee_id
				));
				
				if ($this->db->query($sql)) echo $this->db->insert_id();
				else echo 'failed';

			
			break;
			case "add_skill":
				$skill			= $this->input->post('skill');
				$yoe			= $this->input->post('yoe');
				$remarks		= $this->input->post('remarks');
				$employee_id	= $this->input->post('employee_id');
				
				
				$sql = $this->db->insert_string('employee_skills', array(
					'skill'					=> $education,
					'years_of_experience'	=> $from,
					'remarks'				=> $to,
					'employee_id'			=> $employee_id
				));
				
				if ($this->db->query($sql)) echo $this->db->insert_id();
				else echo 'failed';

			
			break;
			case "add_language":
				$language		= $this->input->post('language');
				$fluency		= $this->input->post('fluency');
				$competency		= $this->input->post('competency');
				$employee_id	= $this->input->post('employee_id');
				
				
				$sql = $this->db->insert_string('employee_languages', array(
					'language'		=> $language,
					'fluency'		=> $fluency,
					'competency'	=> $competency,
					'employee_id'	=> $employee_id
				));
				
				if ($this->db->query($sql)) echo $this->db->insert_id();
				else echo 'failed';

			
			break;
			case "add_license":
				$type			= $this->input->post('type');
				$from			= $this->input->post('from');
				$to				= $this->input->post('to');
				$employee_id	= $this->input->post('employee_id');
				
				list($day, $month, $year) = explode('/', $from);
				$from = $year . '-' . $month . '-' . $day;
				
				list($day, $month, $year) = explode('/', $to);
				$to = $year . '-' . $month . '-' . $day;
				
				$sql = $this->db->insert_string('employee_licenses', array(
					'type'			=> $type,
					'start_date'	=> $from,
					'end_date'		=> $to,
					'employee_id'	=> $employee_id
				));
				
				if ($this->db->query($sql)) echo $this->db->insert_id();
				else echo 'failed';
			break;
			case "employee_timesheet":
				$id = $this->input->post('id');
				
				$this->d['employee'] = $this->hrm->get_employee("`id` = '{$id}'");
				
				$query = $this->db->query("SELECT `id` FROM `salary_voucher` WHERE `employee_id` = ? ORDER BY `datetime` DESC LIMIT 3", array($id));
				$last_svs = $query->result();
				foreach ($last_svs as $sv_id){
					$svs[] = $this->hrm->get_payslip_by_id($sv_id->id);
				}
				$this->d['svs'] = $svs;
				
				$from = $svs[0]->datetime ? $svs[0]->datetime : date('Y-m-d',time() - (60 * 60 * 24 * 30));
				$to = date('Y-m-d');
			
				$query = $this->db->query("SELECT * FROM `employee_cico` WHERE `employee_id` = ? AND `check_in` >= ? AND `check_in` <= ?", array($id, $from, $to));
				$this->d['cico'] = $query->result();
				
				$query = $this->db->query("SELECT * FROM `leave` WHERE `employee_id` = ? AND `from` >= ? AND `from` <= ?", array($id, $from, $to));
				$this->d['leaves'] = $query->result();
				
				$this->d['from'] = $from;
				$this->d['to'] = $to;
				
				
				$this->load->view('hr/ajax/timesheet', $this->d);
				
			break;
			case "employee_timesheet_filter":
				$id 	= $this->input->post('id');
				$from 	= $this->input->post('from');
				$to		= $this->input->post('to');

				$this->d['employee'] = $this->hrm->get_employee("`id` = '{$id}'");
				
				if ($from && $to){
					list($day, $month, $year) = explode('/',$from);
					$from = $year . '-' . $month . '-' . $day;

					list($day, $month, $year) = explode('/',$to);
					$to = $year . '-' . $month . '-' . $day;
					
				} else {
					$from = date('Y-m-01');
					$to = date('Y-m-d');
				}
				
				$query = $this->db->query("SELECT * FROM `employee_cico` WHERE `employee_id` = ? AND `check_in` >= ? AND `check_in` <= ?", array($id, $from, $to));	
				$this->d['cico'] = $query->result();
				
				
				$query = $this->db->query("SELECT * FROM `leave` WHERE `employee_id` = ? AND `from` >= ? AND `from` <= ?", array($id, $from, $to));
				$this->d['leaves'] = $query->result();
				
				$this->d['from'] = $from;
				$this->d['to'] = $to;
				
				
				$this->load->view('hr/ajax/timesheet-filtered', $this->d);
				
				
			break;
			case "save_sv_field":
				if ($this->hrm->add_sv_field()){
					echo 'ok';
				} else {
					echo 'exists';
				}
			break;
			case "update_sv_field":
				$id = $this->input->post('id');
				if ($this->hrm->edit_sv_field($id)){
					echo 'ok';
				} else {
					echo 'exists';
				}
			
			break;
		}
	}
	
	function Delete_field($id){
		$this->db->query("DELETE FROM `salary_voucher_format` WHERE `id` = ?", array($id));
		echo 'ok';
	}
	
	function pie_chart($chart_id){
		$this->load->plugin('ofc2');	
		
		$data = $_SESSION[$chart_id];
		
		$title = new title($data['title']);
		$pie = new pie();
		$pie->set_alpha(0.7);
		$pie->set_start_angle( 35 );
        $pie->add_animation( new pie_fade() );
        $pie->set_tooltip( '#val# of #total#<br>#percent# of 100%' );

        $pie->set_colours($data['colors']);
        
        $values = $data['values'];
		foreach ($values as $key => $value){
			if (!is_numeric($key)) $new_value[] = new pie_value(intval($value), $key);
			else $new_value[] = $value;
		}
        $pie->set_values($new_value);

        $chart = new open_flash_chart();
        $chart->set_title( $title );
        $chart->add_element( $pie );
		$chart->set_bg_colour('#FFFFFF');


        $chart->x_axis = null;

        echo $chart->toPrettyString();

	}
	
	function Salary_vouchers(){
		$this->d['svs'] = $this->hrm->get_salary_vouchers("1=1 LIMIT 100");
		$this->load->view('hr/sv', $this->d);	
	}
	
	function SV_filter(){
		$from = sql_date_reformat($this->input->post('date_from'));		
		$to = sql_date_reformat($this->input->post('date_to'));	
		$sv_id = $this->input->post('sv_id');
		
		if (trim($sv_id)){
			$this->d['svs'] = $this->hrm->get_salary_vouchers("`id` = '{$sv_id}'");
		} else {
			$this->d['svs'] = $this->hrm->get_salary_vouchers("`datetime` >= '{$from}' AND `datetime` <= '{$to}' ORDER BY `id` DESC");
		}
		$this->load->view('hr/sv-filtered', $this->d);
	
	}

	function Delete($id, $do){
		if ($do == 'do'){
			$this->db->query("DELETE FROM `employees` WHERE `id` = ?", array($id));
	
			$this->db->update('users', array(
				'employee_id' 	=> ''
			), "`employee_id` = {$id}");
			
			echo 'ok';
		}
	}
	

}
