<?php

class Inventory extends Controller {

	function Inventory(){
		parent::Controller();

		$this->d['user'] = $this->user->data();
		$this->load->model('im');

		
		$this->load->model('inv');
		$this->load->model('calendar');
		$this->load->model('charts');
		$this->load->model('tax');

		if (!$this->system->uses('Contacts')){
			die('This module requires Contacts module to operate.');
		} 
		
		$this->load->model('contact');
		
		if (!$this->system->uses('Inventory') && !$this->system->uses('Services')){
			die('This module requires either Inventory or Services module to operate.');
		}

		$this->load->model('inv');
		$this->load->model('service');
				
		if ($this->system->uses('Accounts')){
			$this->load->model('account');
			$this->d['payment_accounts_list'] = $this->account->cash_postable_account_list();
			$this->d['default_bank_account'] = $this->account->get_default_bank_account();
		}

		if ($this->system->uses('Sales')) $this->load->model('sale');

		
		$this->d['system'] = $this->system->config();
	}
	
	function Config($do){
		if ($do == 'do'){
			
			$config['upload_path'] = './assets/img/';
			$config['allowed_types'] = 'gif|jpg|png';
			$config['max_size']	= '1024';
			$config['remove_spaces'] = true;
			
			$this->load->library('upload', $config);
			
			if ($this->upload->do_upload('company_logo')){
				$image_data = $this->upload->data('company_logo');
				$logo = $image_data['file_name']; 					
				// $this->system->set_config('company_logo',$logo);
			} 
			
			$this->system->set_config('po_tnc',$this->input->post('po_tnc'));
			$this->system->set_config('pr_tnc',$this->input->post('po_tnc'));
			$this->system->set_config('dn_tnc',$this->input->post('dn_tnc'));
			
			$this->system->set_config('po_footer',$this->input->post('po_footer'));
			$this->system->set_config('pr_footer',$this->input->post('po_footer'));
			$this->system->set_config('dn_footer',$this->input->post('dn_footer'));


			$this->system->set_config('cost_update_method', $this->input->post('cost_update_method'));

			$this->system->set_config('warehouse_shared_inventory', $this->input->post('warehouse_shared_inventory'));

			
 			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
 		} else {
 			$this->load->view('inventory/config');
 		}
	}
	
	function Stock_count(){
		$warehouse_id = $this->user->data('branch');
		$this->d['counts'] = $this->inv->get_stock_counts("WHERE `warehouse_id` = '{$warehouse_id}' ORDER BY `id` DESC");
		$this->load->view('inventory/stock-count',$this->d);

	}
	
	function New_stock_count(){
		$sql = $this->db->insert_string('stock_count',array(
			'date' 			=> date('Y-m-d H:i:s'),
			'remarks'		=> '',
			'event'			=> 'Stock Count - ' . date('d/m/Y'),
			'status'		=> 'Pending',
			'warehouse_id'	=> $this->user->data('branch')
		));
		

		$this->db->query($sql);
		$this->Stock_count_entry($this->db->insert_id());
	}
	
	function Stock_count_entry($id,$do){
		if ($do == 'do'){
			$this->inv->stock_count($id);
		
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['id'] = $id;
			$this->load->view('inventory/stock-count-entry',$this->d);
		}
	}
	
	function DN_receive($id){
		$dn = $this->inv->dn_items_received($id);
		$this->system->event_log('inventory','receive','dn', $dn->id, $dn);
		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
	}

	function DN_update_status($id){
		$status = $this->input->post('status');
		$sql = $this->db->update_string('debit_notes', array(
			'status'	=> $status
		), "`id` = '{$id}'");
		
		if ($status == 'Pending'){
			$this->inv->dn_items_unreceived($id);
		}
		
		$this->db->query($sql);
		
		$dn = $this->inv->get_dn_by_id($id);
		$this->system->event_log('inventory','status_update','dn', $dn->id, $dn);
	}
		
	
	function PO_update_status($id){
		$status = $this->input->post('status');
		$sql = $this->db->update_string('purchase_orders', array(
			'status'	=> $status
		), "`id` = '{$id}'");
		
		if ($status == 'Pending'){
			$this->inv->po_items_unreceived($id);
		}
		
		$this->db->query($sql);
		
		$po = $this->inv->get_po_by_id($id);
		$this->system->event_log('inventory','status_update','po',$po->id, $po);
		
	}
	
	
	function PO_receive($id){

		$po = $this->inv->po_items_received($id);
		$this->system->event_log('inventory','receive','po',$po->id,$po);
		
		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
	}
	

	
	function PO_unpaid($id){
		$cur_po = $this->inv->get_po_by_id($id);
		
		if ($this->system->uses('Accounts')){
			if ($cur_po->payment_contra){
				$rc = $this->account->void_receipt($cur_po->payment_contra);
				
				foreach ($rc->items as $item){

					if ($item->po_id) $this->inv->po_set_unpaid($item->po_id);
					if ($item->dn_id) $this->inv->dn_set_unpaid($item->dn_id);
					
					if ($this->system->uses('Sales')){
						if ($item->invoice_id) $this->sale->invoice_set_unpaid($item->invoice_id);
						if ($item->cn_id) $this->sale->cn_set_unpaid($item->cn_id);
					}
				}

				$this->system->event_log('accounts','void_rc','rc',$rc->id, $rc);
			} else {
				$pv = $this->account->void_pv($cur_po->payment_reference);
				
				foreach ($pv->items as $item){
					
					if ($item->po_id) $this->inv->po_set_unpaid($item->po_id);
					if ($item->dn_id) $this->inv->dn_set_unpaid($item->dn_id);
					
					if ($this->system->uses('Sales')){
						if ($item->invoice_id) $this->sale->invoice_set_unpaid($item->invoice_id);
						if ($item->cn_id) $this->sale->cn_set_unpaid($item->cn_id);
					}
		
				}
				
				$this->system->event_log('accounts','void_pv','pv',$pv->id, $pv);
			}
		}

		$po = $this->inv->po_set_unpaid($id);
		$this->system->event_log('inventory','unpaid','po',$po->id, $po);

		$this->po_view($id);
	
	}
	
	function PO_paid($id){
		$date = $this->input->post('payment_date');
		$reference = $this->input->post('payment_reference');
		$po = $this->inv->po_set_paid($id, $date, $reference, $contra_id);
		$this->system->event_log('inventory','paid','po',$po->id, $po);
		
		$this->po_view($id);
	}
	
	function DN_unpaid($id){
		$cur_dn = $this->inv->get_dn_by_id($id);
		
		if ($this->system->uses('Accounts')){
			if ($cur_dn->payment_contra){
				$pv = $this->account->void_pv($cur_dn->payment_contra);
				
				foreach ($pv->items as $item){
					
					if ($item->po_id) $this->inv->po_set_unpaid($item->po_id);
					if ($item->dn_id) $this->inv->dn_set_unpaid($item->dn_id);
					
					if ($this->system->uses('Sales')){
						if ($item->invoice_id) $this->sale->invoice_set_unpaid($item->invoice_id);
						if ($item->cn_id) $this->sale->cn_set_unpaid($item->cn_id);
					}
		
				}
				
				$this->system->event_log('accounts','void_pv','pv',$pv->id, $pv);
		
			} else {
				$rc = $this->account->void_receipt($cur_dn->payment_reference);
				
				foreach ($rc->items as $item){

					if ($item->po_id) $this->inv->po_set_unpaid($item->po_id);
					if ($item->dn_id) $this->inv->dn_set_unpaid($item->dn_id);
					
					if ($this->system->uses('Sales')){
						if ($item->invoice_id) $this->sale->invoice_set_unpaid($item->invoice_id);
						if ($item->cn_id) $this->sale->cn_set_unpaid($item->cn_id);
					}
				}
				
				$this->system->event_log('accounts','void_rc','rc',$rc->id, $rc);
			}
		}


		$dn = $this->inv->dn_set_unpaid($id);
		$this->system->event_log('inventory','unpaid','dn',$dn->id, $dn);

		$this->dn_view($id);
	
	}
	
	function DN_paid($id){
		$date = $this->input->post('receipt_date');
		$reference = $this->input->post('receipt_no');
		$dn = $this->inv->dn_set_paid($id, $date, $reference, $contra_id);
		$this->system->event_log('inventory','paid','dn',$dn->id, $dn);
		
		$this->dn_view($id);
	}
	
	function Index(){


		$this->d['items'] = $this->inv->alert_items();
		$this->d['total_items'] = $this->inv->total_items();
		$this->d['total_categories'] = $this->inv->total_categories();
		$this->d['total_subcategories'] = $this->inv->total_subcategories();
		$this->d['total_brands'] = $this->inv->total_brands();
		$this->d['title'] = 'Inventory';		

		$this->d['current_warehouse'] = $this->user->data('branch');
		$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown();			
		$this->d['fixed_inventory'] = true;
		
		$this->load->view('header', $this->d);
		$this->load->view('inventory/index', $this->d);
		$this->load->view('footer', $this->d);
	}
	
	function Select_warehouse($id, $redirect){
		$warehouse = $this->inv->get_warehouse_by_id($id);
		if ($warehouse->id || $id == '*'){
			if ($id == '*') $id = null;
			$this->session->set_userdata(array('inventory_warehouse'=>$id));
		}
		if ($redirect) redirect($redirect);
		redirect('inventory');
	}
	
	function Overview(){
		$this->d['items'] = $this->inv->alert_items();
		$this->d['total_items'] = $this->inv->total_items();
		$this->d['total_categories'] = $this->inv->total_categories();
		$this->d['total_subcategories'] = $this->inv->total_subcategories();
		$this->d['total_brands'] = $this->inv->total_brands();
		$this->load->view('inventory/overview', $this->d);
	}
	
	function Items(){
		$this->d['items'] = $this->inv->get_items("LIMIT 500");
		$this->d['categories_dropdown'] = $this->inv->get_categories(true);
		$this->d['subcategories_dropdown'] = $this->inv->get_subcategories(true);
		
		$this->load->view('inventory/items',$this->d);
	}
	
	function Items_filter(){
		if ($sku = $this->input->post('sku')) $filter[] = "`sku` = ".$this->db->escape($sku);
		if ($name = $this->input->post('name')) $filter[] = "`name` LIKE ".$this->db->escape('%'.$name.'%');
		if ($category = $this->input->post('category')) $filter[] = "`category` = ".$this->db->escape($category);
		if ($subcategory = $this->input->post('subcategory')) $filter[] = "`subcategory` = ".$this->db->escape($subcategory);
		if ($alert = $this->input->post('alert')) $this->d['alert_items'] = true;
		if ($limit = $this->input->post('limit')) $limit_string = ' LIMIT ' . $limit;

		
		$filter_string = implode(' AND ', $filter);
		

		if ($filter_string) $filter_string = 'WHERE ' . $filter_string;
		
		$this->d['items'] = $this->inv->get_items($filter_string  . $limit_string);
		
		$this->load->view('inventory/items-filtered',$this->d);

	}

	function Item_view($id){
		$this->d['item'] = $this->inv->get_item_by_id($id);
		$this->d['orders'] = $this->inv->get_purchase_order_by_item($id);
		$this->d['prices'] = $this->inv->get_price_history_by_item($id);
		$this->d['costs'] = $this->inv->get_cost_history_by_item($id);
		$this->d['consignment'] = $this->inv->get_quantity_consigned($id);
		
		$this->load->view('inventory/item-view',$this->d);
	}
	
	function Item_add($do, $option){
		if ($do == 'do'){
			$item = $this->inv->get_item_by_sku($this->input->post('sku'));
			$this->system->event_log('inventory','add','item',$item->id, $item);
			if ($item->id){
		 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(0);</script>';				
			} else {
				$this->inv->add_item();
				// $this->inv->propagate_quantities();
		 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		 	}
		} else {

			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['brands_dropdown'] = $this->inv->get_brands(true);
			$this->d['subcategories_dropdown'] = $this->inv->get_subcategories(true);
			
			if ($option == 'po') $this->load->view('inventory/item-add-po',$this->d);
			else $this->load->view('inventory/item-add',$this->d);
		}
		
	}
	
	function Item_edit($id, $do){

		$items =  $this->inv->get_items("WHERE `id` = $id");
		$item = $items[0];
		
		$variants = $this->inv->get_variants_by_sku($item->sku);
		foreach ($variants as $variant){
			$link_skus[] = $variant->sku;
		}
		
		$item->links = implode(',', $link_skus);
		
		if ($item->linked){
			$parent = $this->inv->get_item_by_sku($item->linked);
		}
		
		$item->parent = $parent;
		
		$this->d['item'] = $item;
		
		

		if ($do == 'do'){
			if ($item->sku == $this->input->post('sku')){
				$item = $this->inv->edit_item($id);
				
				$this->db->query("UPDATE `inventory_stock_quantities` SET `cost` = ? WHERE `item_id` = ? AND `warehouse_id` = ? ", array($this->input->post('cost'), $id, $this->user->data('branch')));
				
				$this->system->event_log('inventory','edit','item',$item->id,$item);
		 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		 	} else {
		 		$other_item = $this->inv->get_item_by_sku($this->input->post('sku'));
		 		if ($other_item->id){
		 			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(0);</script>';
		 		} else {
			 		$this->inv->edit_item($id);
			 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		 		}
		 	}
		} else {

			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['brands_dropdown'] = $this->inv->get_brands(true);
			$this->d['subcategories_dropdown'] = $this->inv->get_subcategories(true);

			$this->load->view('inventory/item-edit',$this->d);
		}
	}

	function Item_delete($id){
		$item = $this->inv->delete_item($id);
		$this->system->event_log('inventory','delete','item',$item->id, $item);
		echo 'ok';
	}
	
	function Purchase_Orders(){
		$warehouse_filter = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));

		$this->d['pos'] = $this->inv->get_po("$warehouse_filter ORDER BY `date` DESC, `id` DESC LIMIT 100");
		$this->d['categories_dropdown'] = $this->inv->get_categories(true);
		$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('inventory/po',$this->d);
	}
	
	function Po_filter(){

		if ($number = $this->input->post('number')) $filter[] = "`number` = ".$this->db->escape($number);
		if ($supplier = $this->input->post('supplier')) $filter[] = "`supplier_id` = ".$this->db->escape($supplier);
		if ($term = $this->input->post('term')) $filter[] = "`terms` = ".$this->db->escape($term);
		if ($status = $this->input->post('status')) $filter[] = "`status` = ".$this->db->escape($status);
		if ($payment_status = $this->input->post('payment_status')) $filter[] = "`payment_status` = ".$this->db->escape($payment_status);
		if ($date_from = $this->input->post('date_from')) $filter[] = "`date` >= ".$this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) $filter[] = "`date` <= ".$this->db->escape(sql_date_reformat($date_to));
		
		$filter[] = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		if ($limit = $this->input->post('limit')) $limit_string = ' LIMIT ' . $limit;
		$order_string = ' ORDER BY `date` DESC, `id` DESC ';
		
		$filter_string = implode(' AND ', $filter);
		$this->d['pos'] = $this->inv->get_po($filter_string . $order_string . $limit_string);

		$this->load->view('inventory/po-filtered',$this->d);
	}
	
	function Po_view($id){
		$this->d['po'] = $po = $this->inv->get_po_by_id($id);
		$this->d['supplier'] = $this->contact->get_contact_by_id($po->supplier_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$this->load->view('inventory/po-view',$this->d);
	}
	
	function Po_pdf($id){
		$this->d['po'] = $po = $this->inv->get_po_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($po->supplier_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$html = $this->load->view('inventory/po-pdf',$this->d, true);
		
		ini_set("memory_limit", "128M");
		pdf_create($html,"PO-".$id);
	}
		
	function Pr_from_so($id){
		if ($this->system->uses('Sales')){
			$so = $this->sale->get_so_by_id(null, $id);	
			
			if ($so->warehouse_id){
				$warehouse = $this->inv->get_warehouse_by_id($so->warehouse_id);
				$so->contact_id = $warehouse->type_reference;
			}
			
			$so->warehouse_id = $this->user->data('branch');
		}
		
		$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
		$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($warehouse);
		
		$so->so_number = $id;

		$this->d['pr'] = $so;
		$this->d['so'] = $id;
		
		$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
		$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('inventory/pr-from-so', $this->d);

	}
	
	function Po_from_invoice($id){
		if ($this->system->uses('Sales')){
			$invoice = $this->sale->get_invoice_by_id(null, $id);	
			
			if ($invoice->warehouse_id){
				$warehouse = $this->inv->get_warehouse_by_id($invoice->warehouse_id);
				$invoice->contact_id = $warehouse->type_reference;
			}
			
			$invoice->warehouse_id = $this->user->data('branch');
		}
		
		$this->d['current_warehouse'] = $warehouse = $this->user->data('branch');
		$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
		$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($warehouse);
		
		$invoice->invoice_number = $id;

		$this->d['po'] = $invoice;
		$this->d['so'] = $id;
		
		$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
		$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('inventory/po-from-invoice', $this->d);

	}
	
	function Po_add($do){
		if ($do == 'do'){					
			$po = $this->inv->add_po();
			$this->system->event_log('inventory','add','po',$po->id, $po);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	

		} else {
			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
			$this->load->view('inventory/po-add',$this->d);
		}
	}
	
	function Po_edit($id, $do){

		if ($do == 'do'){
			$po = $this->inv->edit_po($id);
			$this->system->event_log('inventory','edit','po',$po->id, $po);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
			$this->d['po'] = $this->inv->get_po_by_id($id);

			$this->load->view('inventory/po-edit',$this->d);		
		}
	}
	
	
	
	// Purchase Requests
	
	function Purchase_requests(){
		$warehouse_filter = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));

		$this->d['prs'] = $this->inv->get_pr("$warehouse_filter ORDER BY `date` DESC, `id` DESC LIMIT 100");
		$this->d['categories_dropdown'] = $this->inv->get_categories(true);
		$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('inventory/pr',$this->d);
	}
	
	function Pr_filter(){

		if ($number = $this->input->post('number')) $filter[] = "`number` = ".$this->db->escape($number);
		if ($supplier = $this->input->post('supplier')) $filter[] = "`supplier_id` = ".$this->db->escape($supplier);
		if ($term = $this->input->post('term')) $filter[] = "`terms` = ".$this->db->escape($term);
		if ($status = $this->input->post('status')) $filter[] = "`status` = ".$this->db->escape($status);
		if ($payment_status = $this->input->post('payment_status')) $filter[] = "`payment_status` = ".$this->db->escape($payment_status);
		if ($date_from = $this->input->post('date_from')) $filter[] = "`date` >= ".$this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) $filter[] = "`date` <= ".$this->db->escape(sql_date_reformat($date_to));
		
		$filter[] = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		if ($limit = $this->input->post('limit')) $limit_string = ' LIMIT ' . $limit;
		$order_string = ' ORDER BY `date` DESC, `id` DESC ';
		
		$filter_string = implode(' AND ', $filter);
		$this->d['prs'] = $this->inv->get_pr($filter_string . $order_string . $limit_string);

		$this->load->view('inventory/pr-filtered',$this->d);
	}
	
	function Pr_view($id){
		$this->d['pr'] = $pr = $this->inv->get_pr_by_id($id);
		$this->d['supplier'] = $this->contact->get_contact_by_id($pr->supplier_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		if ($pr->terms == 'Consignment'){
			$this->d['pos'] = $this->inv->get_po_by_pr_id($pr->id);
		}

		$this->load->view('inventory/pr-view',$this->d);
	}
	
	function Pr_pdf($id){
		$this->d['pr'] = $pr = $this->inv->get_pr_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($pr->supplier_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		if ($pr->terms == 'Consignment'){
			$this->d['pos'] = $this->inv->get_po_by_pr_id($pr->id);
		}

		$html = $this->load->view('inventory/pr-pdf',$this->d, true);

		ini_set("memory_limit", "128M");
		pdf_create($html,"PR-".$id);

	}
	
	
	
	function Pr_add($do){
		if ($do == 'do'){					
			$pr = $this->inv->add_pr();
			$this->system->event_log('inventory','add','pr',$pr->id, $pr);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	

		} else {
			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
			$this->load->view('inventory/pr-add',$this->d);
		}
	}
	
	function Pr_edit($id, $do){

		if ($do == 'do'){
			$pr = $this->inv->edit_pr($id);
			$this->system->event_log('inventory','edit','pr',$pr->id, $pr);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
			$this->d['pr'] = $this->inv->get_pr_by_id($id);

			$this->load->view('inventory/pr-edit',$this->d);		
		}
	}
	
	function PR_update_status($id){
		$status = $this->input->post('status');
		$sql = $this->db->update_string('purchase_requests', array(
			'status'	=> $status
		), "`id` = '{$id}'");
				
		$this->db->query($sql);
		
		$pr = $this->inv->get_pr_by_id($id);
		$this->system->event_log('inventory','status_update','pr',$pr->id, $pr);
		
	}

	function Convert_pr($id){
		$this->d['po'] 					= $pr = $this->inv->get_pr_by_id($id);
		$this->d['categories_dropdown'] = $this->inv->get_categories(true);
		$this->d['suppliers_dropdown'] 	= $this->contact->contacts_dropdown(true);
		$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
		 	
		$this->d['contact'] = $this->contact->get_contact_by_id($pr->contact_id);
		$this->d['pr_id']	= $id;
		

		if ($pr->terms == 'Consignment'){
			$prs = $this->inv->get_po_by_pr_id($pr->id);
			foreach ($prs as $pr){
				$actual_pr = $this->inv->get_po_by_id($pr->id);
				foreach ($actual_pr->orders as $item){
					if ($actual_pr->status == 'Received'){
						$pr_items[$item->item_id] += $item->delivered;					
					} else {
						$pr_items[$item->item_id] += $item->qty;						
					}

				}
			}
		}
		
		
		$this->d['pr_items'] = $pr_items;

		$this->load->view('inventory/pr-convert', $this->d);
		

	}
	
	function Pr_delete($id){
		$pr = $this->inv->delete_pr($id);
		$this->system->event_log('inventory','delete','pr',$pr->id, $pr);
		echo 'ok';
	}

	
	function Debit_notes(){
	
		$warehouse_filter = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		$this->d['dns'] = $this->inv->get_dn("{$warehouse_filter} ORDER BY `date` DESC, `id` DESC LIMIT 100");
		$this->d['categories_dropdown'] = $this->inv->get_categories(true);
		$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('inventory/dn',$this->d);
	}
	
	function Dn_filter(){
		
		if ($number = $this->input->post('number')) $filter[] = "`number` = ".$this->db->escape($number);
		if ($supplier = $this->input->post('supplier')) $filter[] = "`supplier_id` = ".$this->db->escape($supplier);
		if ($status = $this->input->post('status')) $filter[] = "`status` = ".$this->db->escape($status);
		if ($date_from = $this->input->post('date_from')) $filter[] = "`date` >= ".$this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) $filter[] = "`date` <= ".$this->db->escape(sql_date_reformat($date_to));

		$filter[] = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));		
		
		$order_string = " ORDER BY `date` DESC, `id` DESC ";
		if ($limit = $this->input->post('limit')) $limit_string = ' LIMIT ' . $limit;

		$filter_string = implode(' AND ', $filter);
		$this->d['dns'] = $this->inv->get_dn($filter_string . $order_string . $limit_string);

		$this->load->view('inventory/dn-filtered',$this->d);
	}
	
	function Dn_view($id){
		$this->d['dn'] = $dn = $this->inv->get_dn_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($dn->id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$this->load->view('inventory/dn-view',$this->d);
	}

	function Dn_pdf($id){
		$this->d['dn'] = $dn = $this->inv->get_dn_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($dn->id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$html = $this->load->view('inventory/dn-pdf',$this->d, true);
		
		ini_set("memory_limit", "128M");
		pdf_create($html,"DN-".$id);

	}
	
	function Dn_add($do){
		if ($do == 'do'){

			$dn = $this->inv->add_dn();
			$this->system->event_log('inventory','add','dn',$dn->id, $dn);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	

		} else {
			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->load->view('inventory/dn-add',$this->d);
		}
	}
	
	function Dn_edit($id, $do){

		if ($do == 'do'){
			
			$dn = $this->inv->edit_dn($id);
			$this->system->event_log('inventory','edit','dn',$dn->id, $dn);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['suppliers_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->d['dn'] = $this->inv->get_dn_by_id($id);

			$this->load->view('inventory/dn-edit',$this->d);
		}
	}

	
	function Po_delete($id){
		$po = $this->inv->delete_po($id);
		$this->system->event_log('inventory','delete','po',$po->id, $po);
		echo 'ok';
	}
	
	function Dn_delete($id){
		$dn = $this->inv->delete_dn($id);
		$this->system->event_log('inventory','delete','dn',$dn->id, $dn);
		echo 'ok';
	}
	
	function Search_product($q, $t = 'name'){
		$cell = 'name';
		if ($t == 'Product Name') $cell = 'name';
		elseif ($t == 'SKU') $cell = 'sku';
		
		if ($cell == 'sku'){
			if (!$this->system->config('warehouse_shared_inventory')){
				$query = $this->db->query("SELECT * FROM `inventory` WHERE (`sku` = ? OR `sku2` = ? OR `sku3` = ? OR `sku4` = ?) AND `warehouse_id` = ? ORDER BY `name` ASC", array($q, $q, $q, $q, $this->user->data('branch')));
			} else {
				$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ? OR `sku2` = ? OR `sku3` = ? OR `sku4` = ? ORDER BY `name` ASC", array($q, $q, $q, $q));
			} 
			
			$row = $query->row();
			if ($row->sku == $q){
				$sku_select = false;
				$uom = $row->uom1;
			} elseif ($row->sku2 == $q){
				$sku_select = 2;
				$uom = $row->uom2;
			} elseif ($row->sku3 == $q){
				$sku_select = 3;
				$uom = $row->uom3;
			} elseif ($row->sku4 == $q){
				$sku_select = 4;
				$uom = $row->uom4;
			}
			
			if ($sku_select){
				$qty_ratio = $row->{'loose_qty'.$sku_select};
				
			}
		} else {
			if (!$this->system->config('warehouse_shared_inventory')){
				$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' AND `warehouse_id` = ? ORDER BY `name` ASC", array($this->user->data('branch')));
			} else {
				$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' ORDER BY `name` ASC");				
			}

		}

		if ($query->num_rows() < 1){
			echo "<tr><td colspan=\"3\"><strong>No item found</strong>. <a href=\"inventory/item_add/x/po\" class=\"target_dialog\">Create new item record</a>?</td></tr>";
			return;
		}
		$x = 0;
		echo '<tbody>';
		if($this->user->has_permission('to_view_cost_in_inventory','Inventory')){
			$HideCost="";
		}else{
			$HideCost="hidden";
		}

		foreach ($query->result() as $product){
			$qty = $this->inv->get_item_quantity($product->id);
			$class = $x%2 == 0 ? 'class="alt"' : ''; 
			
			
			if ($sku_select){
				$sku = $product->{'sku'.$sku_select};
				$primary_sku = $product->sku;
				$cost = str_replace(',','.',number_format($product->{'loose_qty'.$sku_select} * $product->cost,4));
				$price = $product->price;
			} else {
				$sku = $primary_sku = $product->sku;
				$cost = $product->cost;
				$price = $product->price;
			}
			
			$contact = $this->user->branch_contact();
			$eff_price = $this->sale->effective_price($contact, $product->id);
		
			$cost = $eff_price ? str_replace(',','',number_format($eff_price,4)) : str_replace(',','',number_format($cost,4));

			if ($sku_select) $sku_select_packaging = $product->{'uom'.$sku_select};
			else $sku_select_packaging = $product->uom1;
			
			
			echo "<tr {$class} tax_code=\"{$product->purchase_tax_code}\" taxable=\"{$product->purchase_taxable}\" rel=\"{$product->id}\" primary_sku=\"{$primary_sku}\">
				<td class=\"checkbox\" rel=\"1\" title=\"{$product->name}\"><input type=\"checkbox\" class=\"product-items\" value=\"{$product->id}\" /> <span class=\"product-name\">{$product->name} ($sku_select_packaging)  [{$product->purchase_tax_code}]<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>{$sku}</strong></span></td>
				<td class=\"checkbox\" rel=\"2\" style=\"width: 100px; text-align: left\"><span class=\"quantity\"><input class=\"qty\" style=\"width: 95%\" value=\"1\" type=\"number\" /></span> {$uom}</td>
				<td rel=\"3\" style=\"width: 50px; text-align: center\"><span class=\"quantity-in-stock\">{$qty}</span></td>
				<td rel=\"4\" style=\"width: 80px; text-align: right\"><span class=\"product-price \"$HideCost>{$cost}</span><span class=\"selling-price\" style=\"display:none\">{$price}</span></td></tr>";
			$x++;
		}
		echo '</tbody>';
	}
	
	


	function Date_update(){
		$query = $this->db->query("SELECT * FROM `purchase_order_items`");
		foreach ($query->result() as $po_item){
			$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `id` = ?", array($po_item->purchase_order_id));
			$po = $query->row();
			
			$this->db->query("UPDATE `purchase_order_items` SET `date` = ? WHERE `id` = ?", array($po->date, $po_item->id));
		}
	}
	
	function Cost_update($sku){
		echo "<h1>INBOUND/OUTBOUND COST EVALUATION</h1>";
		$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?", array($sku));

		foreach ($query->result() as $item){
			$cur_quantity = 0;
			$value = 0;
			
			$query = $this->db->query("SELECT `date`, `qty`, 'in' AS `type`, `received_price` AS `amount` FROM `purchase_order_items` WHERE `item_id` = ? UNION
							SELECT `date`, `qty`, 'out' AS `type`, `cost` AS `amount` FROM `sale_items` WHERE `item_id` = ?
							ORDER BY `date` ASC", array($item->id, $item->id));
							
			echo 'ITEM ' . $item->name . '<br />';	

			
			foreach ($query->result() as $inout){
				if ($inout->type == 'in'){
					$cur_quantity += $inout->qty;
					$in_cost = $inout->amount;
					$value += $in_cost;
					echo '<strong>+IN</strong> - ' . $inout->date . ' - '  . $inout->qty  . ' UNITS - ' . number_format($inout->amount,2) . '<br />';	
				} else {
//					$cur_quantity -= $inout->qty;
//					$out_cost = $inout->amount;
//					$value -= $out_cost;
//					echo '<strong>-OUT</strong> - ' . $inout->date . ' - ' . $inout->qty . ' UNITS - ' . number_format($inout->amount,2) . '<br />';	
				}
			}
			echo 'VALUE - <strong>' . $value . '</strong><br />';
			echo 'QUANTITY - <strong>' . $cur_quantity . '</strong><br />';
			echo 'COST - <strong>' . ($value / $cur_quantity) . '</strong><br />';

			$cur_cost = $value/$cur_quantity;
			if ($cur_cost > 0){
				if ($cur_cost > $item->price){
					echo "ABOVE PRICE! NOT UPDATED!!! COST - <strong>{$item->cost}</strong> - PRICE <strong>{$item->price}</strong><br />";			
				} else {
					$this->db->query("UPDATE `inventory` SET `cost` = ? WHERE `id` = ?", array($cur_cost, $item->id ));
				}
			} else {
				$x++;
				echo "BELOW COST! NOT UPDATED!!! COST - <strong>{$item->cost}</strong><br />";			

			}
				echo '<hr />';

		}
		echo 'TOTAL 0 COST - ' . $x;
	}
	
	function Sales_cost_update(){
		$query = $this->db->query("SELECT * FROM `sale_items` WHERE `date` >= '2011-05-01' ORDER BY `id` ASC");
		foreach ($query->result() as $saleitem){
			$item = $this->inv->get_item_by_sku($saleitem->item_sku);
			$sql = $this->db->update_string('sale_items',array(
				'cost'		=> $tc = $saleitem->qty * $item->cost,
				'margin'	=> $saleitem->amount - $tc
			),"`id` = '{$saleitem->id}'");
			echo $item->name . ' - ' . $item->cost . ' - ';
			echo '#' . $saleitem->id . ' UPDATED COST: ' . ($tc / $saleitem->qty) . '<br />';
			$this->db->query($sql);
		}
	}
	
	function Sales_update(){
		$query = $this->db->query("SELECT * FROM `sales`");
		foreach ($query->result() as $sale){
			$query = $this->db->query("SELECT SUM(`cost`) AS `total_cost` FROM `sale_items` WHERE `sale_id` = ? GROUP BY `sale_id`", array($sale->id));
			$res = $query->row();

			$sql = $this->db->update_string('sales',array(
				'cost'	=> $res->total_cost
			), "`id` = '{$sale->id}'");

			$this->db->query($sql);
			echo 'SALE #' . $sale->id . ' - UPDATED COST RM' . $res->total_cost . ' - AMOUNT - RM' . $sale->amount . '<br />';
		}
	}

	function Item_by_sku(){
		$sku = $this->input->post('sku');
		echo json_encode($this->inv->get_item_by_sku($sku));
	}
	
	function Stock_take_item_delete($id){
		$this->db->query("DELETE FROM `stock_count_items` WHERE `id` = ?", array($id));
		echo 'ok';
	}
	
	function Stock_take_list($stock_take_id){
		$sku = $this->input->post('sku');
		$item = $this->inv->get_item_by_sku($sku);
		$take = $this->inv->get_stock_take_data($item->id, $stock_take_id);
		foreach ($take as $count){
			$output .= "<tr><td>{$count->username}</td><td>{$count->datetime}</td><td style=\"text-align:right\">{$count->qty}</td><td><a class=\"grid-action grid-action-delete\" href=\"inventory/stock_take_item_delete/{$count->id}\"></td></tr>";
			$total += $count->qty;
		}
		$output .= "<tr style=\"background: #EEE\"><td colspan=\"2\"><strong>TOTAL</strong></td><td style=\"text-align: right; font-weight: bold\" class=\"total_count\">{$total}</td><td></td></tr>";

		
		echo $output;
	}
	
	function Stock_take_report($stock_take_id){
		$query = $this->db->query("SELECT * FROM `stock_count` WHERE `id` = ?", array($stock_take_id));
		$this->d['stock_count'] = $stock_count = $query->row();
		
		$warehouse_id = $this->user->data('branch');
		
		$query = $this->db->query("SELECT `item_id`, `cost`, `qty` FROM `inventory_stock_quantities` WHERE `warehouse_id` = ?", array($warehouse_id));
		$stocks = $query->result();
					
		foreach ($stocks as $stock){
			$item_stock[$stock->item_id] = $stock->qty;
			$item_cost[$stock->item_id] = $stock->cost;
		}

		
		$query = $this->db->query("SELECT * FROM `inventory` ORDER BY `category`, `name` ASC");
		foreach ($query->result() as $item){
			if ($stock_count->status == 'Completed'){
				$query = $this->db->query("SELECT `processed_qty`, `discrepancy` FROM `stock_count_items` WHERE `item_id` = ? AND `count_id` = ? GROUP BY `item_id` LIMIT 1", array($item->id, $stock_take_id));
				if ($query->num_rows()){
					$count = $query->row();
					$item->counted = true;
					$item->count_qty = $count->processed_qty;
					
					if ($count->discrepancy != 0){
						$item->differ = true;
					}
					$item->discrepancy = 0 - $count->discrepancy;
				}
				
			} else {
				$query = $this->db->query("SELECT SUM(`qty`) AS `count_qty`, `discrepancy` FROM `stock_count_items` WHERE `item_id` = ? AND `count_id` = ? GROUP BY `item_id`", array($item->id, $stock_take_id));
				if ($query->num_rows()){
					$count = $query->row();
					$item->counted = true;
	
					$item->count_qty 	= $count->count_qty;
					$item->qty			= $item_stock[$item->id];
					
					if ($count->count_qty != $item->qty){
						$item->differ = true;
					}
				}
			
			}

			$items[] = $item;
		}
		$this->d['stid'] = $stock_take_id;
		$this->d['items'] = $items;
		$this->load->view('inventory/stock-count-report', $this->d);
	}
	
	function Stock_take_execute($stock_take_id, $do){

		ini_set('max_execution_time', 300);
	
	
		if ($do == 'do'){
			$query = $this->db->query("SELECT SUM(`qty`) AS `count_qty`, `item_id` FROM `stock_count_items` WHERE `count_id` = ? GROUP BY `item_id`", array($stock_take_id));
			foreach ($query->result() as $count){
				$item = $this->inv->get_item_quantity($count->item_id);
				$difference = $item->qty - $count->count_qty;
				
				if ($difference < 0){
					$negative_deviation += $difference;
					$total_positive_mismatch++;
				} elseif ($difference > 0) {
					$positive_deviation += $difference;
					$total_negative_mismatch++;
				}
				
				
				$sql = $this->db->update_string('stock_count_items',array(
					'processed_qty'			=> $count->count_qty,
					'processed_discrepancy'	=> $difference
				),"`count_id` = '{$stock_take_id}' AND `item_id` = '{$count->item_id}'");
				
				$this->db->query($sql);
				
				echo $count->item_id . "\t" . $count->county_qty . "\n";
				
				$this->inv->update_quantity($count->item_id, $count->count_qty, false);
				
				
			}
			
			$sql = $this->db->update_string('stock_count',array(
				'positive_deviation'		=> $positive_deviation,
				'negative_deviation'		=> $negative_deviation,
				'total_positive_mismatch'	=> $total_positive_mismatch,
				'total_negative_mismatch'	=> $total_negative_mismatch,
				'status'					=> 'Completed',
				'remarks'					=> $this->input->post('remarks')
			), "`id` = '{$stock_take_id}'");
			
			$this->db->query($sql);
		}
	}
	
	function Update_item_cost($item_sku){
		$item = $this->inv->get_item_by_sku($item_sku);
		$this->inv->Update_item_cost($item->id);
	}
	
	function Update_cell(){
		$field = str_replace('`', '', $this->input->post('field'));
		$val = $this->input->post('val');
		$id = $this->input->post('id');
		
		if ($field == 'qty'){
			$this->inv->update_quantity($id, $val);
			echo $val;
		} elseif ($field == 'cost'){
		
			$this->inv->update_item_cost($id);
						
			$this->db->query("UPDATE `inventory_stock_quantities` SET `$field` = ? WHERE `item_id` = ? AND `warehouse_id` = ? ", array($val, $id, $this->user->data('branch')));
			$query = $this->db->query("SELECT * FROM `inventory_stock_quantities` WHERE `item_id` = ? AND `warehouse_id` = ?", array($id, $this->user->data('branch')));
			$row = $query->row();
		
			echo $row->$field;

		} else {		
			$this->db->query("UPDATE `inventory` SET `$field` = ? WHERE `id` = ?", array($val, $id));
		
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($id));
			$row = $query->row();
		
			echo $row->$field;
		}
	}
		
	function Ajax($request){
		switch ($request){
			case "pv":

				$po_id = $this->input->post('id');
				$this->d['po'] = $po = $this->inv->get_po_by_id($po_id);
				$this->d['pv'] = $this->account->get_pv_by_id($po->payment_reference);

				$this->load->view('inventory/ajax/pv-view', $this->d);
				
			break;
			
			case "variant":
				$sku = $this->input->post('sku');
				$item = $this->inv->get_item_by_sku($sku);
				if ($item->name){
					$item->status = 'ok';
				} else {
					$item->status = 'false';
				}
				echo json_encode($item);
			break;
			
		}
	}

	function Stock_movements(){

		$this->d['wms'] = $this->inv->get_movements("1=1 ORDER BY `delivered_date` DESC LIMIT 100");
		$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
		$this->load->view('inventory/wm',$this->d);
	}
	
	function WM_update_status($id, $arg_status){
		$status = $arg_status ? $arg_status : $this->input->post('status');
		$sql = $this->db->update_string('warehouse_movements', array(
			'status'	=> $status
		), "`id` = '{$id}'");
		$this->db->query($sql);
		
		$sql = $this->db->update_string('warehouse_movement_items', array(
			'status'	=> $status
		), "`movement_id` = {$id}");
		
		$this->db->query($sql);
		
		$wm = $this->inv->get_movement_by_id($id);
		
		foreach ($wm->items as $item){
			$this->inv->update_item_qty($item->item_id, $item->from_warehouse);
			$this->inv->update_item_qty($item->item_id, $item->to_warehouse);
		}
		
		$this->system->event_log('inventory','status_update','wm', $wm->id, $wm);
	}
	
	function WM_delete($id, $do){
		if ($do == 'do'){			
			
			$this->db->query("DELETE FROM `warehouse_movements` WHERE `id` = ?", array($id));
			$this->db->query("DELETE FROM `warehouse_movement_items` WHERE `movement_id` = ?", array($id));
			
			echo 'ok';	
		}
	}
	
	function WM_add($do){
		if ($do == 'do'){
			$this->inv->add_movement();
 			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
			$this->load->view('inventory/wm-add', $this->d);
		}
	}
	
	function WM_edit($id, $do){
		if ($do == 'do'){
			$this->inv->edit_movement($id);
 			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {

			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
			$this->d['wm'] = $this->inv->get_movement_by_id($id);
			$this->load->view('inventory/wm-edit', $this->d);		
		}
	}
	
	function WM_view($id){
		$this->d['wm'] = $this->inv->get_movement_by_id($id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$this->load->view('inventory/wm-view', $this->d);
	}
	
	function WM_filter(){

		if ($number = $this->input->post('number')) $filter[] = "`number` = ".$this->db->escape($number);
		if ($supplier = $this->input->post('supplier')) $filter[] = "`supplier_id` = ".$this->db->escape($supplier);
		if ($term = $this->input->post('term')) $filter[] = "`terms` = ".$this->db->escape($term);
		if ($status = $this->input->post('status')) $filter[] = "`status` = ".$this->db->escape($status);
		if ($payment_status = $this->input->post('payment_status')) $filter[] = "`payment_status` = ".$this->db->escape($payment_status);
		if ($date_from = $this->input->post('date_from')) $filter[] = "`date` >= ".$this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) $filter[] = "`date` <= ".$this->db->escape(sql_date_reformat($date_to));
		
		if ($limit = $this->input->post('limit')) $limit_string = ' LIMIT ' . $limit;
		$order_string = ' ORDER BY `date` DESC ';
		
		$filter_string = implode(' AND ', $filter);
		$this->d['pos'] = $this->inv->get_po($filter_string . $order_string . $limit_string);

		$this->load->view('inventory/wm-filtered',$this->d);
	}
	
	function Warehouses(){
		$this->d['warehouses'] = $this->inv->get_warehouses("1=1 ORDER BY `name` ASC LIMIT 100"); 
		$this->load->view('inventory/warehouses', $this->d);
	}
	
	function Warehouse_add($do){
		if ($do == 'do'){
			$this->inv->add_warehouse();
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true,'Stakeholder,Franchisee');
			$this->load->view('inventory/warehouse-add', $this->d);
		}
	}
	
	function Warehouse_edit($id, $do){
		if ($do == 'do'){
			$this->inv->edit_warehouse($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($id);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true,'Stakeholder,Franchisee');
			$this->load->view('inventory/warehouse-edit', $this->d);
		}
	}
	
	function Warehouse_delete($id, $do){
		if ($do == 'do'){
			$this->inv->delete_warehouse($id);
			echo 'ok';
		}
	}
	
	function Get_warehouse_details($warehouse_id){	
		$warehouse = $this->inv->get_warehouse_by_id($warehouse_id);
		
		$address->name 		= $warehouse->name;
		$address->tel		= $warehouse->tel;
		$address->address1	= $warehouse->address1;
		$address->address2	= $warehouse->address2;
		$address->zipcode	= $warehouse->zipcode;
		$address->city		= $warehouse->city;
		$address->state		= $warehouse->state;
		$address->country	= $warehouse->country;
		
		echo json_encode($address);

	}
	
	function Consignments(){
		$this->d['items'] = $this->inv->get_consignment_items();
		$this->load->view('inventory/consignments', $this->d);
	}
	
	function Consignment_view($item_id){
		$this->load->view('inventory/consignment_detail', $this->d);
	}

}