<?php

class Ledger extends Controller {

	function Ledger(){
		parent::Controller();
		$this->d['user'] = $this->user->data();

		$this->load->model('sale');
		
		$this->load->model('inv');
		$this->load->model('charts');

		
		$this->d['system'] = $this->system->config();
	}

	function Index(){
		$this->d['title'] = "Ledger";
		
		$this->d['transactions'] = $this->sale->get_transactions(date('Y-m-d 00:00:00'), date('Y-m-d 23:59:59'));
		
		$this->load->view('header', $this->d);
		$this->load->view('ledger/index', $this->d);
		$this->load->view('footer');
	}
	
	function Transactions(){
		$this->d['transactions'] = $this->sale->get_transactions(date('Y-m-d 00:00:00'), date('Y-m-d 23:59:59'));
		$this->d['date_from'] = date('d/m/Y');
		$this->d['time_from'] = '12:00AM';
		$this->d['date_to'] = date('d/m/Y');
		$this->d['time_to'] = '11:59PM';
		$this->load->view('ledger/transactions', $this->d);
	}
	
	function Transactions_filter(){

		$from = $this->input->post('date_from');
		$from_time = $this->input->post('time_from');
		
		$to = $this->input->post('date_to');
		$to_time = $this->input->post('time_to');
		

		$this->d['transactions'] = $this->sale->get_transactions(sql_date_reformat($from . ' ' . $from_time),sql_date_reformat($to . ' ' . $to_time));
		$this->load->view('ledger/transactions-filtered', $this->d);
	}
	
	function Overview(){
		$this->d['transactions'] = $this->sale->get_transactions(date('Y-m-d 00:00:00'), date('Y-m-d 23:59:59'));
		$this->load->view('ledger/overview', $this->d);
	}
	
	function Payable(){

		$this->d['payables'] = $payables = $this->inv->get_po("`payment_status` = 'Unpaid' ORDER BY `due_date` ASC");
		$this->load->view('ledger/payable',$this->d);

		
	}
	
	function Receivable(){

		$this->d['receivables'] = $receivables = $this->sale->get_invoices("WHERE `payment_status` = 'Unpaid' ORDER BY `date` ASC");
		$this->load->view('ledger/receivables',$this->d);
	}
	

	function line_chart($chart_id, $option){

		$this->load->plugin('ofc2');			

		$data = $_SESSION[$chart_id];
		
		$title = new title($data['title']);
		$bar = new bar();
        $bar->set_tooltip( '#x_label#<br>#val#');
		$bar->set_on_show(new bar_on_show('grow-up', 0.5, 0));
		
				
		$hol = new dot();
		$hol->size(3)->tooltip('#x_label#<br>#val#');

		$line = new line();
		$line->set_default_dot_style($hol);
		$line->set_width(2);
		
		$line->set_colour('#3333CC');
		
        $values = $data['values'];
        $maxval = 10;
		foreach ($values as $key => $value){
			$new_value[] = $value;
			if ($value > $maxval) $maxval = $value;
			if ($option == 'time'){
				$labels[] = sprintf('%d:%s%s', date('h',$key), date('i',$key), date('A',$key));
			} else {
				$labels[] = sprintf('%d %s %d', date('d',$key), date('M',$key), date('Y',$key));
			}
		}
		$maxval = ceil($maxval);
		$line->set_values($new_value);
		
		$count = count($values);
		if ($count < 10){
			$steps = 1;
		} else if ($count < 20){
			$steps = 2;
		} else if ($count <= 30){
			$steps = 3;
		} else if ($count <= 50){
			$steps = 5;
		} else if ($count <= 100){
			$steps = 10;
		} else if ($count <= 150){
			$steps = 15;
		} else if ($count <= 200){
			$steps = 18;
		} else if ($count <= 400){
			$steps = 30;
		} else if ($count <= 600){
			$steps = 60;
		} else if ($count <= 1000){
			$steps = 100;
		} else if ($count <= 2000){
			$steps = 200;
		} else {
			$steps = 500;
		}
		
		$x_axis = new x_axis();
		$x_axis->set_steps($steps);
		$x_axis->set_colour('#cccccc');
		$x_axis->set_grid_colour('#dddddd');
		$x_axis->set_labels_from_array($labels);
		
		$y_axis = new y_axis();
		$y_axis->set_colour('#dddddd');
		$y_axis->set_grid_colour('#dddddd');
		$y_axis->set_range( 0, $maxval, $maxval/10 );

        $chart = new open_flash_chart();
        $chart->set_title($title);
        $chart->add_element($line);
        $chart->set_x_axis($x_axis);
        $chart->set_y_axis($y_axis);

		$chart->set_bg_colour('#FFFFFF');

        echo $chart->toPrettyString();
	
	}

}