<?php

class Reports extends Controller {
	
	function Reports(){
		parent::Controller();
		$this->d['user'] = $this->user->data();
		$this->load->model('im');
		$this->load->model('calendar');
		$this->load->model('sale');
		$this->load->model('charts');
		$this->load->model('inv');
		$this->load->model('report');
		
		$this->d['system'] = $this->system->config();
	}
	
	
	function Index(){
		$this->d['title'] = 'Reports';

		/* 
		$sales_data = $this->sale->chart_data(date('Y-m-1'),date('Y-m-t'));
		$saleschart_data['title'] = '';
		$saleschart_data['values'] = $sales_data;
		$_SESSION['saleschart'] = $saleschart_data;
		$this->d['sales_chart'] = $this->charts->output(base_url().'ledger/line_chart/saleschart/date', "100%", 250);
		
		$today = date('Y-m-d');
		$tomorrow = date('Y-m-d',strtotime(date('Y-m-d')) + (60 * 60 * 24));

		$this->d['sales'] = $this->sale->get_sales_by_date($today, $tomorrow);
		*/
		
		$this->d['reports'] = $this->report->get_reports("ORDER BY `name` ASC");
		
		$this->load->view('header', $this->d);
		$this->load->view('reports/index', $this->d);
		$this->load->view('footer', $this->d);

	}
	
	function Overview(){
		$this->d['reports'] = $this->report->get_reports("ORDER BY `name` ASC");
		
		$this->load->view('reports/overview', $this->d);
	}
	

	function Config(){
		$this->d['reports'] = $this->report->get_reports('ORDER BY `name` ASC');
		$this->load->view('reports/config', $this->d);
	}	
	
	function Add($do){
		if ($do == 'do'){
			$this->report->add();
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->load->view('reports/add');
		}
	}
	
	function Edit($id, $do){
		if ($do == 'do'){
			$this->report->edit($id);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['report'] = $this->report->get_report_by_id($id);
			$this->load->view('reports/edit', $this->d);
		}
	}
	
	function Delete($id, $do){
		if ($do == 'do'){
			$this->report->delete($id);
			echo 'ok';
		}
	}
	
	function Saved_reports(){
		
		$this->d['saved_reports'] = $this->report->get_saved_reports("1=1 ORDER BY `added_on` LIMIT 100");
		$this->d['reports_dropdown'] = $this->report->get_reports_dropdown(true);
		
		$this->load->view('reports/saved-reports', $this->d);
	}
	
	function Saved_reports_filter(){
		if ($type = $this->input->post('type')) $filter[] = "`type` = ".$this->db->escape($type);
		if ($date_from = $this->input->post('date_from')) $filter[] = "`added_on` >= ".$this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) $filter[] = "`added_on` <= ".$this->db->escape(sql_date_reformat($date_to));
		
		if ($limit = $this->input->post('limit')) $limit_string = ' LIMIT ' . $limit;
		$order_string = ' ORDER BY `added_on` DESC ';
		
		$filter_string = implode(' AND ', $filter);
		if (!$filter_string) $filter_string = '1=1 ';

		$this->d['saved_reports'] = $this->report->get_saved_reports($filter_string . $order_string . $limit_string);
		$this->load->view('reports/saved-reports-filtered', $this->d);
	}
	
	function Save_report(){
		$this->report->save_generated_report();
	}
	
	function View_saved_report($id){
		$this->d['saved_report'] = $this->report->get_saved_report_by_id($id);

		$this->load->view('reports/view-saved-report', $this->d);
		
	}
	
	function Delete_saved_report($id, $do){
		if ($do == 'do'){
			$this->report->delete_generated_report($id);
			echo 'ok';
		}
	}

	
	function Stock_adjustment(){
		$date_from = $this->input->post('date_from');
		$date_to = $this->input->post('date_to');
		
		
		$time_from = $this->input->post('time_from');
		$time_to = $this->input->post('time_to');
		
		if (!$date_from) $from = date('Y-m-d');
		else {
			list($day, $month, $year) = explode('/',$date_from);
			$from = $year . '-' . $month . '-' . $day;
		}
		
		if (!$date_to) $to = date('Y-m-d');
		else {
			list($day, $month, $year) = explode('/',$date_to);
			$to = $year . '-' . $month . '-' . $day;
		}
		
		$this->d['from'] = $from;
		$this->d['to'] = $to;
		
		$query = $this->db->query("SELECT * FROM `stock_adjustment` WHERE `datetime` >= ? AND `datetime` <= ? ", array($from . ' 00:00:00', $to . ' 23:59:59'));
		$this->d['sa'] = $query->result();
		
		$this->load->view('reports/stock_adjustment', $this->d);

	}
	
	
	
	function Items(){
		$date_from = $this->input->post('date_from');
		$date_to = $this->input->post('date_to');
		
		$time_from = $this->input->post('time_from');
		$time_to = $this->input->post('time_to');
		
		if (!$date_from) $from = date('Y-m-d');
		else {
			list($day, $month, $year) = explode('/',$date_from);
			$from = $year . '-' . $month . '-' . $day;
		}
		
		if (!$date_to) $to = date('Y-m-d');
		else {
			list($day, $month, $year) = explode('/',$date_to);
			$to = $year . '-' . $month . '-' . $day;
		}
		
		$this->d['from'] = $from;
		$this->d['to'] = $to;
		
		if ($from == $to) $this->d['duration'] = 1;
		else $this->d['duration'] = (strtotime($to) - strtotime($from)) / (60 * 60 * 24);
		
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_qty`, `item_name`, `item_sku` FROM `sale_items` WHERE `date` >= ? AND `date` <= ? GROUP BY `item_id` ORDER BY `total_qty` DESC", array($from, $to));
		$this->d['items'] = $query->result();
		
		$this->load->view('reports/items', $this->d);
	}
	
	function Sales(){

		if (!$this->input->post('date')){
			$date = date('d/m/Y');
		} else {
			$date = $this->input->post('date');
		}
		
		$this->d['current_date'] = $date;
		
		$warehouse_id = $this->input->post('warehouse');
		if ($warehouse_id) $wfilter = ' AND `warehouse_id` = ' . $this->db->escape($warehouse_id);

		$this->d['current_warehouse'] = $warehouse_id;
	
		list($day, $month, $year) = explode('/',$date);
		$date = $year . '-' . $month . '-' . $day;
		$sales_data			= $this->sale->daily_chart_data($date, $warehouse_id);
		

		$saleschart_data['title'] = '';
		$saleschart_data['values'] = $sales_data;

		$_SESSION['saleschart'] = $saleschart_data;
		$this->d['sales_chart'] = $this->charts->output(base_url().'ledger/line_chart/saleschart/time', "100%", 250);


		$this->d['date'] = $date;
		

		$query = $this->db->query("SELECT SUM(`cost`) AS `total_cost`, SUM(`amount`) AS `total_sales` FROM `sales` WHERE `datetime` >= ? AND `datetime` <= ? {$wfilter}", array($date . ' 00:00:00', $date . ' 23:59:59'));
		$this->d['sales'] = $query->row();		
		
		$query = $this->db->query("SELECT SUM(`cost`) AS `total_cost`, SUM(`total`) AS `total_sales` FROM `invoices` WHERE `date` >= ? AND `date` <= ? AND FIND_IN_SET('Online Sales',`tags`) {$wfilter}", array($date . ' 00:00:00', $date . ' 23:59:59'));
		$this->d['online_sales'] = $query->row();		

		$query = $this->db->query("SELECT SUM(`cost`) AS `total_cost`, SUM(`total`) AS `total_sales` FROM `invoices` WHERE `date` >= ? AND `date` <= ? AND NOT FIND_IN_SET('Online Sales',`tags`) {$wfilter}", array($date . ' 00:00:00', $date . ' 23:59:59'));
		$this->d['invoiced_sales'] = $query->row();		

		
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_qty` FROM `sale_items` WHERE `date` >= ? AND `date` <= ? AND `sold` = 1 AND `redeemed` <> 1 {$wfilter}", array($date . ' 00:00:00', $date . ' 23:59:59'));
		$this->d['item_qty'] = $query->row();
				
		$query = $this->db->query("SELECT * FROM `reverts` WHERE `datetime` >= ? AND `datetime` <= ? {$wfilter}", array($date . ' 00:00:00', $date . ' 23:59:59'));
		$this->d['reverts'] = $query->result();
		
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_qty`, `item_name`, `item_sku` FROM `sale_items` WHERE  `date` >= ? AND `date` <= ? {$wfilter} GROUP BY `item_id` ORDER BY `total_qty` DESC", array($date . ' 00:00:00', $date . ' 23:59:59'));
		$this->d['pos_items'] = $query->result();
		
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_qty`, `item_name`, `item_sku` FROM `invoice_items` WHERE  `date` >= ? AND `date` <= ? {$wfilter} GROUP BY `item_id` ORDER BY `total_qty` DESC", array($date . ' 00:00:00', $date . ' 23:59:59'));
		$this->d['invoiced_items'] = $query->result();
		

		if ($this->system->uses('Inventory') && $this->system->config('warehouse_enabled')){
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
		}
		
		$this->load->view('reports/sales', $this->d);
	}
	
	

	
	function Stock(){
		$inventory_items = $this->inv->get_items();
		$this->d['items'] = $inventory_items;
		$this->load->view('reports/stocks', $this->d);
	}
	
	function Turnover(){
		$from = $this->input->post('date_from');
		$to = $this->input->post('date_to');
		
		if (!$from) $from = date('Y-m-1');
		else {
			list($day, $month, $year) = explode('/',$from);
			$from = $year . '-' . $month . '-' . $day;
		}
		
		if (!$to) $to = date('Y-m-t');
		else {
			list($day, $month, $year) = explode('/',$to);
			$to = $year . '-' . $month . '-' . $day;
		}
		
		$datef = strtotime($from);
		
		$this->d['from'] = $from;
		$this->d['to'] = $to;
	
		$duration = (strtotime($to) - strtotime($from)) / (60 * 60 * 24);

		for($i = 0; $i < $duration+1; $i++){
			$sale = null;
			$cur_date = date("Y-m-d",$datef + ((60*60*24)*$i));
			$next_date = date("Y-m-d",$datef + ((60*60*24)*($i+1))); 
			list($day,$month,$year) = explode('-',$cur_date);
			if ($cur_month != $month){
				$showmonth = true;
			} else {
				$showmonth = false;
			}
			
			$query = $this->db->query("SELECT SUM(`amount`) AS `total_sales`, (SUM(`amount`) - SUM(`cost`)) AS `total_margin` FROM `sales` WHERE `datetime` >= '$cur_date' AND `datetime` < '$next_date' AND `payment_status` = 'Paid' GROUP BY `payment_status`");
			if ($query->num_rows()){
				$sale = $query->row();
			} else {
				$sale->total_sales = 0;
				$sale->total_margin = 0;
			}
			$sale->date = $cur_date;

			$sales[] = $sale;
			if ($sale->total_sales > $max_sale){
				$max_sale = $sale->total_sales;
			}
			
			if ($sale->total_margin > $max_margin){
				$max_margin = $sale->total_margin;
			}
			
		}

		$this->d['max_margin'] = $max_margin;
		$this->d['max_sale'] = $max_sale;
		$this->d['sales'] = $sales;
		$this->load->view('reports/turnover',$this->d);
	
	}
	
	function Cash_count(){
		$from = $this->input->post('date_from');
		$to = $this->input->post('date_to');
		
		if (!$from) $from = date('Y-m-1');
		else {
			list($day, $month, $year) = explode('/',$from);
			$from = $year . '-' . $month . '-' . $day;
		}
		
		if (!$to) $to = date('Y-m-t');
		else {
			list($day, $month, $year) = explode('/',$to);
			$to = $year . '-' . $month . '-' . $day;
		}
		
		$datef = strtotime($from);
		
		$this->d['from'] = $from;
		$this->d['to'] = $to;
	
		$query = $this->db->query("SELECT * FROM `cash_count` WHERE `from` >= '$from' AND `from` < '$to'");
		
		$this->d['counts'] = $query->result();
		$this->load->view('reports/cash_count',$this->d);
	
	}
	
	function Redemptions(){
		$from = $this->input->post('date_from');
		$to = $this->input->post('date_to');

		if (!$from) $from = date('Y-m-1');
		else {
			list($day, $month, $year) = explode('/',$from);
			$from = $year . '-' . $month . '-' . $day;
		}
		
		if (!$to) $to = date('Y-m-t');
		else {
			list($day, $month, $year) = explode('/',$to);
			$to = $year . '-' . $month . '-' . $day;
		}
		
		$datef = strtotime($from);
		
		$this->d['from'] = $from;
		$this->d['to'] = $to;

		$query = $this->db->query("SELECT * FROM `sale_items` WHERE `redeemed` = 1 AND `date` >= ? AND `date` <= ?", array($from, $to));

		foreach ($query->result() as $redemption){
			$redemptions[] = $redemption;
		}

		$this->d['redemptions'] = $redemptions;
		
		$query = $this->db->query("SELECT * FROM `members`");
		foreach ($query->result() as $member){
			$members[$member->id] = $member;
		}
		$this->d['members'] = $members;
		
		$this->load->view('reports/redemptions', $this->d);
	}
	
	
	function Test(){
		echo "<pre>";
		
		$code1 = '		
			a->b();
			c::d();
			e->f(g->h());
			i->j(k::l());
			e->f ( g->h ( ));
			i->j ( k::l ( ));
			mm->nn(oo->pp());
			qq->rr(ss::tt());
			uu()
			vv (ww());
			xx ( yy() );
			zz ( aaa ( ) );
			{$abc}({$def}());
			{$ghi}( {$jkl}( {$mno} ({$pqr}()) ) );
			{"stu"}( {"vwx"}({"xyz"}();); );
			{"$stu"}( {"vw$x"}({"$xyz"}();); );
			{\'stu\'}( {\'vwx\'}({\'xyz\'}();); );';
			
		$code = '
			$b = 1;
			$a = str_replace("e","o","the quick brown fox")
			if ($b == 1){
			
			}
			for ( $i = 0; $i < 10; $i++){
			
			}
			switch ($case){
				case "":
					break;
			}
			
			
			';
				

		$pattern = '((\w+|\{\$\w+\}|\{"\w+"\}|{"[A-Za-z0-9_\$]+"\}|\{\'\w+\'\})(\s+\(|\())';

		preg_match_all($pattern, $code, $matches);
		$matching_funcs = $matches[0];
		
		
	
	    $cs = array("print","echo","require","include","if","else","while","for","switch","exit","break","die");    
	    $whitelist = array("str_replace","substr","pow","tan"); 
	
	    $allowed_list = array_merge($cs, $whitelist);
	    
	    $status = 1;
	    foreach ($matching_funcs as $func){
		    if (!in_array(trim(str_replace('(','', $func)), $allowed_list)){
		    	$status = 0;
		    }
		}
		
		echo 'STATUS: ' . $status;

	    
	}
	
	function Generate($id){
		$report = $this->report->get_report_by_id($id);
		
		$inputs = $_REQUEST;
				
		eval($report->process_script);
		
		
		eval('?>' . $report->display_script);
	}

	function Generate_widget($id){
		$report = $this->report->get_report_by_id($id);
		
		$inputs = $_REQUEST;
				
		eval($report->process_script);
		
		
		eval('?>' . $report->display_script);
	}


}