<?php

class Sales extends Controller {

	function Sales(){
		parent::Controller();
		
		
		if ($this->system->uses('Accounts')){
			$this->load->model('account');
			$this->d['payment_accounts_list'] = $this->account->cash_postable_account_list();
			$this->d['default_bank_account'] = $this->account->get_default_bank_account();
		}

		$this->load->model('charts');
		$this->load->model('tax');
		
		if (!$this->system->uses('Contacts')){
			die('This module requires Contacts module to operate.');
		} 
		
		$this->load->model('contact');
		
		if (!$this->system->uses('Inventory') && !$this->system->uses('Services')){
			die('This module requires either Inventory or Services module to operate.');
		}		

		if ($this->system->uses('Inventory')) $this->load->model('inv');
		if ($this->system->uses('Services')) $this->load->model('service');
		

		$this->load->model('sale');
		$this->load->model('shipping');
		
		$this->d['user'] = $this->user->data();
		$this->d['system'] = $this->system->config();
		

	}
		
	function Payment_gateways(){
		
		$this->d['pgs'] = $this->sale->get_payment_gateways();
		
		$this->load->view('sales/payment-gateways', $this->d);
		
	}
	
	function PG_add($do){
		if ($do == 'do'){
			$this->sale->add_payment_gateway();
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';			
		} else {
			$this->load->view('sales/pg-add');
		}		
	}
	
	function PG_edit($id, $do){
		if ($do == 'do'){
			$this->sale->edit_payment_gateway($id);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['pg'] = $this->sale->get_payment_gateway_by_id($id);
			$this->load->view('sales/pg-edit', $this->d);
		}
		
	}
	
	function PG_view($id){
		$this->d['pg'] = $this->sale->get_payment_gateway_by_id($id);
		$this->load->view('sales/pg-view', $this->d);
	}
	
	function PG_delete($id, $do){
		if ($do == 'do'){
			$this->sale->delete_payment_gateway($id);
			echo 'ok';
		}
	}
	
	
	function Config($do){
		if ($do == 'do'){
			
			$config['upload_path'] = './assets/img/';
			$config['allowed_types'] = 'gif|jpg|png';
			$config['max_size']	= '1024';
			$config['remove_spaces'] = true;
			
			$this->load->library('upload', $config);
			
			if ($this->upload->do_upload('company_logo')){
				$image_data = $this->upload->data('company_logo');
				$logo = $image_data['file_name']; 					
				// $this->system->set_config('company_logo',$logo);
			} 
			
			$this->system->set_config('receipt_printing', $this->input->post('receipt_printing'));

			$this->system->set_config('quote_tnc',$this->input->post('quote_tnc'));
			$this->system->set_config('so_tnc',$this->input->post('so_tnc'));
			$this->system->set_config('invoice_tnc',$this->input->post('invoice_tnc'));
			$this->system->set_config('cn_tnc',$this->input->post('cn_tnc'));
			$this->system->set_config('do_tnc',$this->input->post('do_tnc'));
			
			$this->system->set_config('quote_footer',$this->input->post('quote_footer'));
			$this->system->set_config('so_footer',$this->input->post('so_footer'));
			$this->system->set_config('invoice_footer',$this->input->post('invoice_footer'));
			$this->system->set_config('cn_footer',$this->input->post('cn_footer'));
			$this->system->set_config('do_footer',$this->input->post('do_footer'));

			
			$this->system->set_config('po_store_signee', $this->input->post('po_store_signee'));
			$this->system->set_config('po_supplier_signee', $this->input->post('po_supplier_signee'));
			
			$this->system->set_config('member_tnc',$this->input->post('member_tnc'));
			$this->system->set_config('online_sales_tnc',$this->input->post('online_sales_tnc'));
			
			$this->system->set_config('price_rules', json_encode($this->input->post('price_rules')));			
			
			$this->system->set_config('till_deposit', $this->input->post('till_deposit'));
			
			$this->system->set_config('pos_allowed_roles', $this->input->post('pos_allowed_roles'));

			
			$this->system->set_config('cd_welcome_1', $this->input->post('cd_welcome_1'));
			$this->system->set_config('cd_welcome_2', $this->input->post('cd_welcome_2'));
			
			$this->system->set_config('cd_thankyou', $this->input->post('cd_thankyou'));
			
			$this->system->set_config('checkout_cc', $this->input->post('checkout_cc'));
			$this->system->set_config('checkout_credit', $this->input->post('checkout_credit'));
			$this->system->set_config('checkout_cheque', $this->input->post('checkout_cheque'));
			$this->system->set_config('checkout_bank_deposit', $this->input->post('checkout_bank_deposit'));
			$this->system->set_config('checkout_voucher', $this->input->post('checkout_voucher'));
			
			$this->system->set_config('checkout_ltc', $this->input->post('checkout_ltc'));
			$this->system->set_config('checkout_remarks', $this->input->post('checkout_remarks'));
			$this->system->set_config('checkout_delivery', $this->input->post('checkout_delivery'));
			
			$this->system->set_config('discount_allowed', $this->input->post('discount_allowed'));
			$this->system->set_config('discount_type_default', $this->input->post('discount_type_default'));
			
			$this->system->set_config('revert_allowed', $this->input->post('revert_allowed'));
			$this->system->set_config('revert_level', $this->input->post('revert_level'));
			$this->system->set_config('revert_keycard', $this->input->post('revert_keycard'));
			
			$this->system->set_config('hybrid_pos', $this->input->post('hybrid_pos'));
			
			$this->system->set_config('print_is', $this->input->post('print_is'));
			$this->system->set_config('print_ta', $this->input->post('print_ta'));


			$this->system->set_config('receipt_type', $this->input->post('receipt_type'));			
			$this->system->set_config('report_type', $this->input->post('report_type'));
			$this->system->set_config('report_cashout_hide', $this->input->post('report_cashout_hide'));
			$this->system->set_config('report_secondary_categories', $this->input->post('report_secondary_categories'));
			$this->system->set_config('report_running_numbers', $this->input->post('report_running_numbers'));
			
			$this->system->set_config('custom_price_allowed', $this->input->post('custom_price_allowed'));
			
			$this->system->set_config('sales_screen_cost', $this->input->post('sales_screen_cost'));
			$this->system->set_config('sales_screen_gp', $this->input->post('sales_screen_gp'));
			
			
			$this->system->set_config('member_points', $this->input->post('member_points'));
			$this->system->set_config('member_minimum_amount', $this->input->post('member_minimum_amount'));
			$this->system->set_config('member_minimum_point', $this->input->post('member_minimum_point'));
			$this->system->set_config('member_discount', $this->input->post('member_discount'));
			
			
			$this->system->set_config('rounding_adjust', $this->input->post('rounding_adjust'));
			$this->system->set_config('customer_phone', $this->input->post('customer_phone'));
			
			$this->system->set_config('pos_retail_item_layout', $this->input->post('pos_retail_item_layout'));
			
			
			if ($this->system->uses('FnB')){
				$this->system->set_config('fnb_print_items_individually', $this->input->post('fnb_print_items_individually'));
				$this->system->set_config('fnbpos_secondary_display', $this->input->post('fnbpos_secondary_display'));
				$this->system->set_config('fnbpos_discount_with_customer', $this->input->post('fnbpos_discount_with_customer'));
				$this->system->set_config('fnbpos_print_cli', $this->input->post('fnbpos_print_cli'));
				$this->system->set_config('fnbpos_service_charge', $this->input->post('fnbpos_service_charge'));
				$this->system->set_config('fnbpos_course_serving', $this->input->post('fnbpos_course_serving'));
				$this->system->set_config('fnbpos_no_sc_is', $this->input->post('fnbpos_no_sc_is'));
				$this->system->set_config('fnbpos_print_paper_size', $this->input->post('fnbpos_print_paper_size'));
				$this->system->set_config('fnbpos_idle_table_duration', $this->input->post('fnbpos_idle_table_duration'));				
				$this->system->set_config('fnbpos_reroute_wtc', $this->input->post('fnbpos_reroute_wtc'));
				$this->system->set_config('fnbpos_logout_timeout', $this->input->post('fnbpos_logout_timeout'));
				$this->system->set_config('fnbpos_cash_only', $this->input->post('fnbpos_cash_only'));
				$this->system->set_config('fnbpos_hide_pax', $this->input->post('fnbpos_hide_pax'));
				$this->system->set_config('fnbpos_hide_cardno', $this->input->post('fnbpos_hide_cardno'));
				$this->system->set_config('fnbpos_void_reason', $this->input->post('fnbpos_void_reason'));
				$this->system->set_config('fnbpos_mtd_mode', $this->input->post('fnbpos_mtd_mode'));
				
				$this->system->set_config('fnbpos_discount_no_amount', $this->input->post('fnbpos_discount_no_amount'));
				$this->system->set_config('fnbpos_discount_default', $this->input->post('fnbpos_discount_default'));
				
				
				$this->system->set_config('pos_sales_report_no_print', $this->input->post('pos_sales_report_no_print'));
				$this->system->set_config('pos_sales_hide_tax', $this->input->post('pos_sales_hide_tax'));
				$this->system->set_config('pos_sales_report_name', $this->input->post('pos_sales_report_name'));
				$this->system->set_config('pos_substantive_categories', $this->input->post('pos_substantive_categories'));
				

			}
			
			$this->system->set_config('online_sales', $this->input->post('online_sales'));
			if ($this->input->post('online_sales')){
				if (!$this->system->config('online_sales_api_key')) $this->system->set_config('online_sales_api_key', md5(time()));				
			}
			
			$this->system->set_config('online_sales_min_purchase', $this->input->post('online_sales_min_purchase'));
			$this->system->set_config('online_sales_responder_name', $this->input->post('online_sales_responder_name'));
			$this->system->set_config('online_sales_responder_name', $this->input->post('online_sales_responder_name'));
			$this->system->set_config('online_sales_responder_email', $this->input->post('online_sales_responder_email'));
			$this->system->set_config('online_sales_responder_password', $this->input->post('online_sales_responder_password'));
			$this->system->set_config('online_sales_responder_txn_email', $this->input->post('online_sales_responder_txn_email'));
			$this->system->set_config('online_sales_responder_hostname', $this->input->post('online_sales_responder_hostname'));
			$this->system->set_config('online_sales_responder_port', $this->input->post('online_sales_responder_port'));
			
			$this->system->set_config('online_sales_so_duration', $this->input->post('online_sales_so_duration'));
			
			$this->system->set_config('online_sales_email_new_registration', $this->input->post('online_sales_email_new_registration'));
			$this->system->set_config('online_sales_email_password_reset', $this->input->post('online_sales_email_password_reset'));
			$this->system->set_config('online_sales_email_new_order', $this->input->post('online_sales_email_new_order'));
			$this->system->set_config('online_sales_email_new_order_bo', $this->input->post('online_sales_email_new_order_bo'));
			
			$this->system->set_config('online_sales_email_new_registration_subject', $this->input->post('online_sales_email_new_registration_subject'));
			$this->system->set_config('online_sales_email_password_reset_subject', $this->input->post('online_sales_email_password_reset_subject'));
			$this->system->set_config('online_sales_email_new_order_subject', $this->input->post('online_sales_email_new_order_subject'));
			$this->system->set_config('online_sales_email_new_order_bo_subject', $this->input->post('online_sales_email_new_order_bo_subject'));
			
			$this->system->set_config('online_sales_email_order_status', $this->input->post('online_sales_email_order_status'));
			$this->system->set_config('online_sales_email_order_status_subject', $this->input->post('online_sales_email_order_status_subject'));

			
			$this->system->set_config('online_sales_fb_login', $this->input->post('online_sales_fb_login'));
			$this->system->set_config('online_sales_fb_app_id', $this->input->post('online_sales_fb_app_id'));
			$this->system->set_config('online_sales_fb_app_secret', $this->input->post('online_sales_fb_app_secret'));
			
			$this->system->set_config('online_sales_item_limit_per_page', $this->input->post('online_sales_item_limit_per_page'));
			
			$this->system->set_config('online_sales_email_css', $this->input->post('online_sales_email_css'));
			
 			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
 		} else {
 			$this->load->view('sales/config');
 		}
	}
	
	function Index(){

		$this->d['title'] = 'Sales';		
		$this->d['pending_invoices'] = $this->sale->get_invoices("WHERE `status` LIKE '%Pending%' {$warehouse_filter} ORDER BY `date` DESC");
		$this->d['pending_sos'] = $this->sale->get_sos("WHERE `status` LIKE '%Pending%' {$warehouse_filter} ORDER BY `date` DESC");

		$this->load->view('header', $this->d);
		$this->load->view('sales/index', $this->d);
		$this->load->view('footer', $this->d);
	}
	
	function Overview(){
			
		$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		$this->d['pending_invoices'] = $this->sale->get_invoices("WHERE `status` LIKE '%Pending%' {$warehouse_filter} ORDER BY `date` DESC");
		$this->d['pending_sos'] = $this->sale->get_sos("WHERE `status` LIKE '%Pending%' {$warehouse_filter} ORDER BY `date` DESC");


		$this->load->view('sales/overview', $this->d);
	}
	
	
	
	function Cash_Sales(){
		$this->d['transactions'] = $this->sale->get_sales_transactions(date('Y-m-d 00:00:00'), date('Y-m-d 23:59:59'));
		$this->d['date_from'] = date('d/m/Y');
		$this->d['time_from'] = '12:00AM';
		$this->d['date_to'] = date('d/m/Y');
		$this->d['time_to'] = '11:59PM';
		
		$query = $this->db->query("SELECT * FROM `contacts`");
		foreach ($query->result() as $contact){
			$contacts[$contact->id] = $contact;
		}
		$this->d['contacts'] = $contacts;
		
		$this->load->view('sales/sales', $this->d);
	}
	
	function Edit_sales($id, $do){
		if ($do == 'do'){
			$this->sale->edit_sale($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';			
		} else {
			$this->d['sale'] = $this->sale->get_sale_by_id($id);
			$this->load->view('sales/sales-edit', $this->d);
		}
	}
	
	function Sales_filter(){

		$from = $this->input->post('date_from');
		$from_time = $this->input->post('time_from');
		
		$to = $this->input->post('date_to');
		$to_time = $this->input->post('time_to');
		
		$receipt_no = $this->input->post('receipt_no');
		
		if (trim($receipt_no)){
			$query = $this->db->query("SELECT * FROM `sales` WHERE `txn_no` = ?", array($receipt_no));
			$this->d['transactions'] = $query->result();
		} else {
			$this->d['transactions'] = $this->sale->get_sales_transactions(sql_date_reformat($from . ' ' . $from_time),sql_date_reformat($to . ' ' . $to_time));
		}
		
		$query = $this->db->query("SELECT * FROM `contacts`");
		foreach ($query->result() as $contact){
			$contacts[$contact->id] = $contact;
		}
		$this->d['contacts'] = $contacts;
		
		$this->load->view('sales/sales-filtered', $this->d);
	}	
	
	function Invoice_update_status($id){
		$status = $this->input->post('status');
		
		if ($status == 'Pending'){
			$this->sale->invoice_items_undelivered($id);
		} 
		
		$sql = $this->db->update_string('invoices', array(
			'status'	=> $status = $this->input->post('status')
		), "`id` = '{$id}'");
		
		$this->db->query($sql);
		
		$invoice = $this->sale->get_invoice_by_id($id);
		$this->system->event_log('sales','status_update','invoice',$id,$invoice);
	}
	
	function Quote_update_status($id){
		$sql = $this->db->update_string('quotes', array(
			'status'	=> $status = $this->input->post('status')
		), "`id` = '{$id}'");
				
		$this->db->query($sql);
		
		$quote = $this->sale->get_quote_by_id($id);
		$this->system->event_log('sales','status_update','quote',$id,$quote);
	}
	
	function So_update_status($id){
		$sql = $this->db->update_string('sales_order', array(
			'status'	=> $status = $this->input->post('status')
		), "`id` = '{$id}'");
				
		$this->db->query($sql);
		
		$so = $this->sale->get_so_by_id($id);
		$this->system->event_log('sales','status_update','so',$id,$so);
	}

		
	function Invoice_deliver($id){
		
		ini_set('max_execution_time', 0);
		ini_set('memory_limit','128M');
		
		$this->sale->invoice_items_undelivered($id);
		
		$invoice = $this->sale->invoice_items_delivered($id);
		
		$this->system->event_log('sales','deliver','invoice',$id,$invoice);

		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
	}
	
	

	
	
	function Invoices(){
		$warehouse_filter = "WHERE `warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->d['invoices'] = $this->sale->get_invoices("{$warehouse_filter} ORDER BY `date` DESC LIMIT 100");
		$this->load->view('sales/invoices', $this->d);
	}
	
	function Invoice_filter(){

		if ($number = $this->input->post('number')) 				$filter[] = "`id` = ".$this->db->escape($number);
		if ($contact_id = $this->input->post('contact')) 			$filter[] = "`contact_id` = ".$this->db->escape($contact_id);
		if ($term = $this->input->post('term')) 					$filter[] = "`terms` = ".$this->db->escape($term);
		if ($status = $this->input->post('status'))		 			$filter[] = "`status` = ".$this->db->escape($status);
		if ($payment_status = $this->input->post('payment_status')) $filter[] = "`payment_status` = ".$this->db->escape($payment_status);
		if ($date_from = $this->input->post('date_from')) 			$filter[] = "`date` >= ".$this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) 				$filter[] = "`date` <= ".$this->db->escape(sql_date_reformat($date_to));
		

		$filter[] = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		if ($limit = $this->input->post('limit')) $limit_string = " LIMIT $limit ";
		
		$order_string = ' ORDER BY `date` DESC, `id` DESC ';
		
		$filter_string = implode(' AND ', $filter);
		
		if ($filter_string) $filter_string = ' WHERE ' . $filter_string;
						
		$this->d['invoices'] = $this->sale->get_invoices($filter_string . $order_string . $limit_string);
		$this->load->view('sales/invoice-filtered',$this->d);
	}

	
	function Invoice_add($do){
		if ($do == 'do'){
			$invoice = $this->sale->add_invoice();
			$this->system->event_log('sales','add','invoice',$invoice->id,$invoice);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1,'.$invoice->id.');</script>';	
		} else {

			$this->d['current_warehouse'] = $warehouse = $this->user->data('branch');
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
			$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($this->user->data('branch'));

			$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->load->view('sales/invoice-add', $this->d);
		}
	}
	
	function Invoice_add_consignment($do){
		if ($do == 'do'){
			$invoice = $this->sale->add_invoice();
			$this->system->event_log('sales','add','invoice',$invoice->id,$invoice);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1,'.$invoice->id.');</script>';	
		} else {

			$this->d['current_warehouse'] = $warehouse = $this->user->data('branch');
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
			$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($this->user->data('branch'));

			$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->load->view('sales/invoice-consignment', $this->d);
		}
	}
	
	function Invoice_edit($id, $do){
		if ($do == 'do'){
			$invoice = $this->sale->edit_invoice($id);
			$this->system->event_log('sales','edit','invoice',$invoice->id,$invoice);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
		
			$this->d['current_warehouse'] = $warehouse = $this->user->data('branch');
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
			$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($this->user->data('branch'));

			$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
			$this->d['invoice'] = $this->sale->get_invoice_by_id($id);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->load->view('sales/invoice-edit', $this->d);
		}
	}
	
	
	function Invoice_view($id){

		$this->d['invoice'] = $invoice = $this->sale->get_invoice_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($invoice->contact_id);
		$this->d['so']		= $this->sale->get_so_by_id($invoice->sales_order_id);
		
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}			
		$this->load->view('sales/invoice-view',$this->d);
	}
	
	function Invoice_pdf($id){

		$this->d['invoice'] = $invoice = $this->sale->get_invoice_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($invoice->contact_id);
		$this->d['so']		= $this->sale->get_so_by_id($invoice->sales_order_id);
		
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}		
		$html = $this->load->view('sales/invoice-pdf',$this->d, true);
		
		ini_set("memory_limit", "128M");

		pdf_create($html,"INV-".$id);
	}
	
	function Invoice_delete($id){
		$invoice = $this->sale->delete_invoice($id);
		$this->system->event_log('sales','delete','invoice',$id, $invoice);
		
		echo 'ok';
	}
	
	function Invoice_unpaid($id){
		$cur_invoice = $this->sale->get_invoice_by_id($id);
		
		
		if ($this->system->uses('Accounts')){
			if ($cur_invoice->payment_contra){
			
				$pv = $this->account->void_pv($cur_invoice->payment_contra);
				
				foreach ($pv->items as $item){
					
					if ($item->invoice_id) $this->sale->invoice_set_unpaid($item->invoice_id);
					if ($item->cn_id) $this->sale->cn_set_unpaid($item->cn_id);
					
					if ($this->system->uses('Inventory')){
						if ($item->po_id) $this->inv->po_set_unpaid($item->po_id);
						if ($item->dn_id) $this->inv->dn_set_unpaid($item->dn_id);
					}
		
				}
				
				$this->system->event_log('accounts','void_pv','pv',$pv->id, $pv);
			
			} else {
				$rc = $this->account->void_receipt($cur_invoice->payment_reference);
								
				foreach ($rc->items as $item){

					if ($item->invoice_id) $this->sale->invoice_set_unpaid($item->invoice_id);
					if ($item->cn_id) $this->sale->cn_set_unpaid($item->cn_id);
					
					if ($this->system->uses('Inventory')){
						if ($item->po_id) $this->inv->po_set_unpaid($item->po_id);
						if ($item->dn_id) $this->inv->dn_set_unpaid($item->dn_id);
					}
				}

				
				$this->system->event_log('accounts','void_rc','rc',$rc->id, $rc);
			}
		}
		
		$invoice = $this->sale->invoice_set_unpaid($id);
		$this->system->event_log('sales','unpaid','invoice',$invoice->id, $invoice);

		$this->invoice_view($id);
	}
	
	function Invoice_paid($id){
		$receipt_date = $this->input->post('receipt_date');
		$receipt_reference = $this->input->post('receipt_reference');
		$invoice = $this->sale->invoice_set_paid($id, $receipt_date, $receipt_reference, $contra_id);
		
		$this->system->event_log('sales','paid','invoice',$invoice->id, $invoice);
		
		$this->invoice_view($id);
	}
	
	function CN_unpaid($id){
		$cur_cn = $this->sale->get_cn_by_id($id);
		
		if ($this->system->uses('Accounts')){
			if ($cur_cn->payment_contra){
				$rc = $this->account->void_receipt($cur_cn->payment_contra);
				
				foreach ($rc->items as $item){

					if ($item->invoice_id) $this->sale->invoice_set_unpaid($item->invoice_id);
					if ($item->cn_id) $this->sale->cn_set_unpaid($item->cn_id);
					
					if ($this->system->uses('Inventory')){
						if ($item->po_id) $this->inv->po_set_unpaid($item->po_id);
						if ($item->dn_id) $this->inv->dn_set_unpaid($item->dn_id);
					}
				}

				$this->system->event_log('accounts','void_rc','rc',$rc->id, $rc);
			
			} else {
				$pv = $this->account->void_pv($cur_cn->payment_reference);
				
				foreach ($pv->items as $item){
					
					if ($item->invoice_id) $this->sale->invoice_set_unpaid($item->invoice_id);
					if ($item->cn_id) $this->sale->cn_set_unpaid($item->cn_id);
					
					if ($this->system->uses('Inventory')){
						if ($item->po_id) $this->inv->po_set_unpaid($item->po_id);
						if ($item->dn_id) $this->inv->dn_set_unpaid($item->dn_id);
					}
		
				}
				
				$this->system->event_log('accounts','void_pv','rc',$pv->id, $pv);
			}
		}
		
		$cn = $this->sale->cn_set_unpaid($id);
		$this->system->event_log('sales','unpaid','cn',$cn->id, $cn);

		$this->cn_view($id);
	}
	
	function CN_paid($id){
		$receipt_date = $this->input->post('receipt_date');
		$receipt_reference = $this->input->post('receipt_reference');
		$invoice = $this->sale->cn_set_paid($id, $receipt_date, $receipt_reference, $contra_id);
		
		$this->system->event_log('sales','paid','invoice',$invoice->id, $invoice);
		
		$this->cn_view($id);
	}
	

	function Quotes(){


		$warehouse_filter = "WHERE `warehouse_id` = " . $this->db->escape($this->user->data('branch'));

		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->d['quotes'] = $this->sale->get_quotes("{$warehouse_filter} ORDER BY `date` DESC, `id` DESC LIMIT 100");
		$this->load->view('sales/quotes', $this->d);
	}
	
	function Quotes_filter(){

		if ($number = $this->input->post('number')) 		$filter[] = "`id` = " . $this->db->escape($number);
		if ($contact_id = $this->input->post('contact')) 	$filter[] = "`contact_id` = " . $this->db->escape($contact_id);
		if ($term = $this->input->post('term')) 			$filter[] = "`terms` = " . $this->db->escape($term);
		if ($status = $this->input->post('status')) 		$filter[] = "`status` = " . $this->db->escape($status);
		if ($date_from = $this->input->post('date_from')) 	$filter[] = "`date` >= " . $this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) 		$filter[] = "`date` <= " . $this->db->escape(sql_date_reformat($date_to));
		
		$filter[] = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		if ($limit = $this->input->post('limit')) $limit_string = " LIMIT $limit ";
		
		$order_string = ' ORDER BY `date` DESC, `id` DESC ';

		$filter_string = implode(' AND ', $filter);
		
		if ($filter_string) $filter_string = ' WHERE ' . $filter_string;

		$this->d['quotes'] = $this->sale->get_quotes($filter_string . $order_string . $limit_string);

		$this->load->view('sales/quote-filtered',$this->d);
	}
	
	function Convert_quote($id){
		$this->d['so'] = $this->sale->get_quote_by_id($id);
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
		$this->load->view('sales/quote-convert', $this->d);
	}

	
	function Quote_add($do){
		if ($do == 'do'){
			$quote = $this->sale->add_quote();
			$this->system->event_log('sales','add','quote', $quote->id, $quote);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
			$this->load->view('sales/quote-add', $this->d);
		}
	}
	
	function Quote_edit($id, $do){
		if ($do == 'do'){
			$quote = $this->sale->edit_quote($id);
			$this->system->event_log('sales','edit','quote', $quote->id, $quote);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {

			$this->d['quote'] = $this->sale->get_quote_by_id($id);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
			$this->load->view('sales/quote-edit', $this->d);
		}
	}
	
	
	function Quote_view($id){
		$this->d['quote'] = $quote = $this->sale->get_quote_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($quote->contact_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$this->load->view('sales/quote-view',$this->d);
	}
	
	function Quote_pdf($id){
		$this->d['quote'] = $quote = $this->sale->get_quote_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($quote->contact_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$html = $this->load->view('sales/quote-pdf',$this->d, true);
		
		ini_set("memory_limit", "128M");
	
		pdf_create($html,"QUO-".$id);
	}

	
	function Quote_delete($id){
		$quote = $this->sale->delete_quote($id);		
		$this->system->event_log('sales','delete','quote',$id, $quote);
		echo 'ok';		
	}
	
	
	function So(){


		$warehouse_filter = "WHERE `warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->d['sos'] = $this->sale->get_sos("{$warehouse_filter} ORDER BY `date` DESC, `id` DESC LIMIT 100");
		$this->load->view('sales/so', $this->d);
	}
	
	function So_filter(){

		if ($number = $this->input->post('number')) 		$filter[] = "`id` = " . $this->db->escape($number);
		if ($contact_id = $this->input->post('contact')) 	$filter[] = "`contact_id` = " . $this->db->escape($contact_id);
		if ($term = $this->input->post('term')) 			$filter[] = "`terms` = " . $this->db->escape($term);
		if ($status = $this->input->post('status')) 		$filter[] = "`status` = " . $this->db->escape($status);
		if ($date_from = $this->input->post('date_from')) 	$filter[] = "`date` >= " . $this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) 		$filter[] = "`date` <= " . $this->db->escape(sql_date_reformat($date_to));
		
		$filter[] = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		if ($limit = $this->input->post('limit')) $limit_string = " LIMIT $limit ";
		
		$order_string = ' ORDER BY `date` DESC, `id` DESC ';

		$filter_string = implode(' AND ', $filter);
		
		if ($filter_string) $filter_string = ' WHERE ' . $filter_string;

		$this->d['sos'] = $this->sale->get_sos($filter_string . $order_string . $limit_string);

		$this->load->view('sales/so-filtered',$this->d);
	}
	
	function Convert_so($id){
		$this->d['invoice'] = $so = $this->sale->get_so_by_id($id);
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
		
		$this->d['contact'] = $this->contact->get_contact_by_id($so->contact_id);

		if ($so->terms == 'Consignment'){
			$invoices = $this->sale->get_invoice_by_so_id($so->id);
			foreach ($invoices as $invoice){
				$actual_invoice = $this->sale->get_invoice_by_id($invoice->id);
				foreach ($actual_invoice->orders as $item){
					if ($actual_invoice->status == 'Delivered'){
						$invoiced_items[$item->item_id] += $item->delivered;					
					} else {
						$invoiced_items[$item->item_id] += $item->qty;						
					}

				}
			}
		}
		
		
		$this->d['invoiced_items'] = $invoiced_items;

		$this->load->view('sales/so-convert', $this->d);
		

	}

	
	function So_add($do){
		if ($do == 'do'){
			$so = $this->sale->add_so();
			$this->system->event_log('sales','add','so', $so->id, $so);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1,'.$so->id.');</script>';	
		} else {

			$this->d['current_warehouse'] = $warehouse = $this->user->data('branch');
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
			$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($warehouse);

			$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->load->view('sales/so-add', $this->d);
		}
	}
	
	
	function So_edit($id, $do){
		if ($do == 'do'){
			$so = $this->sale->edit_so($id);
			$this->system->event_log('sales','edit','so', $so->id, $so);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
		
			$this->d['current_warehouse'] = $warehouse = $this->user->data('branch');
			$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
			$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($warehouse);

			$this->d['so'] = $this->sale->get_so_by_id($id);	
			$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->load->view('sales/so-edit', $this->d);
		}
	}
	
	function So_from_pr($id){

		if ($this->system->uses('Inventory')){
			$pr = $this->inv->get_pr_by_id(null, $id);	
			
			if ($pr->warehouse_id){
				$warehouse = $this->inv->get_warehouse_by_id($pr->warehouse_id);
				$pr->contact_id = $warehouse->type_reference;
			}
		}
		
		
		
		$this->d['current_warehouse'] = $warehouse = $this->user->data('branch');
		$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
		$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($warehouse);

		$this->d['so'] = $pr;
		$this->d['pr'] = $id;
		
		$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('sales/so-from-pr', $this->d);

	}
	
	function So_from_po($id){

		if ($this->system->uses('Inventory')){
			$po = $this->inv->get_po_by_id(null, $id);	
			
			if ($po->warehouse_id){
				$warehouse = $this->inv->get_warehouse_by_id($po->warehouse_id);
				$po->contact_id = $warehouse->type_reference;
			}
		}
		
		$this->d['current_warehouse'] = $warehouse = $this->user->data('branch');
		$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
				
		$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($warehouse);

		$this->d['so'] = $po;
		$this->d['po'] = $id;
		
		$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('sales/so-from-po', $this->d);

	}
	
	
	function So_view($id){
		$this->d['so'] = $so = $this->sale->get_so_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($so->contact_id);
		
		if ($so->invoice_id){
			$this->d['invoice'] = $this->sale->get_invoice_by_id($so->invoice_id);
		}
		
		if ($so->terms == 'Consignment'){
			$this->d['invoices'] = $this->sale->get_invoice_by_so_id($so->id);
		}
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$this->load->view('sales/so-view',$this->d);
	}
	
	function So_pdf($id){
		$this->d['so'] = $so = $this->sale->get_so_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($so->supplier_id);
		
		if ($so->terms == 'Consignment'){
			$this->d['invoices'] = $this->sale->get_invoice_by_so_id($so->id);
		}
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$html = $this->load->view('sales/so-pdf',$this->d,true);
		
		ini_set("memory_limit", "128M");
	
		pdf_create($html,"SO-".$id);

	}
	
	function So_delete($id){
		$so = $this->sale->delete_so($id);		
		$this->system->event_log('sales','delete','so',$id, $so);
		echo 'ok';		
	}
	
	function Credit_notes(){

		$warehouse_filter = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));

		$this->d['cns'] = $this->sale->get_cn("{$warehouse_filter} ORDER BY `date` DESC, `id` DESC LIMIT 100");
		$this->d['categories_dropdown'] = $this->inv->get_categories(true);
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->load->view('sales/cn',$this->d);
	}
	
	function Cn_filter(){
		
		if ($number = $this->input->post('number')) $filter[] = "`number` = ".$this->db->escape($number);
		if ($contact = $this->input->post('contact')) $filter[] = "`contact_id` = ".$this->db->escape($contact);
		if ($status = $this->input->post('status')) $filter[] = "`status` = ".$this->db->escape($status);
		if ($date_from = $this->input->post('date_from')) $filter[] = "`date` >= ".sql_date_reformat($this->db->escape($date_from));
		if ($date_to = $this->input->post('date_to')) $filter[] = "`date` <= ".sql_date_reformat($this->db->escape($date_to));

		$filter[] = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		
		$order_string = " ORDER BY `date` DESC, `id` DESC ";
		if ($limit = $this->input->post('limit')) $limit_string = ' LIMIT ' . $limit;

		$filter_string = implode(' AND ', $filter);
		$this->d['cns'] = $this->sale->get_cn($filter_string . $order_string . $limit_string);

		$this->load->view('sales/cn-filtered',$this->d);
	}
	
	function Cn_view($id){
		$this->d['cn'] = $cn = $this->sale->get_cn_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($cn->contact_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$this->load->view('sales/cn-view',$this->d);
	}
	
	function Cn_pdf($id){
		$this->d['cn'] = $cn = $this->sale->get_cn_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($cn->contact_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}
		$html = $this->load->view('sales/cn-pdf',$this->d, true);
		
		ini_set("memory_limit", "128M");
	
		pdf_create($html,"CN-".$id);

	}

	
	function Cn_add($do){
		if ($do == 'do'){

			$cn = $this->sale->add_cn();
			$this->system->event_log('sales','add','cn',$cn->id, $cn);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	

		} else {
			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->load->view('sales/cn-add',$this->d);
		}
	}
	
	function Cn_edit($id, $do){

		if ($do == 'do'){
			
			$cn = $this->sale->edit_cn($id);
			$this->system->event_log('sales','edit','cn',$cn->id, $cn);
	 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['categories_dropdown'] = $this->inv->get_categories(true);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
			$this->d['cn'] = $this->sale->get_cn_by_id($id);

			$this->load->view('sales/cn-edit',$this->d);
		}
	}
	
	function CN_receive($id){
		$this->sale->cn_items_unreceived($id);

		$cn = $this->sale->cn_items_received($id);
		$this->system->event_log('sales','receive','cn',$cn->id, $cn);
		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
	}

	function CN_update_status($id){
		$status = $this->input->post('status');
		$sql = $this->db->update_string('credit_notes', array(
			'status'	=> $status
		), "`id` = '{$id}'");
		
		if ($status == 'Pending'){
			$this->sale->cn_items_unreceived($id);
		}
		
		$this->db->query($sql);
		
		$cn = $this->sale->get_cn_by_id($id);
		$this->system->event_log('sales','status_update','cn',$cn->id,$cn);
	}
	
	
	function CN_delete($id){
		$cn = $this->sale->delete_cn($id);
		$this->event_log('sales','delete','credit_note',$id, $cn);
		echo 'ok';
	}
	
	function Discount_rules(){
		$this->d['drs'] = $this->sale->get_discount_rules("ORDER BY `date_from` DESC, `id` DESC LIMIT 100");
		$this->load->view('sales/discount-rules', $this->d);
	}
	
	function Discount_rules_filter(){
		$this->d['drs'] = $this->sale->get_discount_rules("ORDER BY `date_from` DESC, `id` DESC LIMIT 100");
		$this->load->view('sales/discount-rules-filtered', $this->d);
	}
	
	function DR_add($do){
		if ($do == 'do'){
			$this->sale->add_discount_rule();
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';					
		} else {
			$this->load->view('sales/dr-add', $this->d);
		}
	}
	
	function DR_edit($id, $do){

		if ($do == 'do'){	
			$this->sale->edit_discount_rule($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';			
		} else {
			$this->d['dr'] = $dr = $this->sale->get_discount_rule_by_id($id);
			$this->load->view('sales/dr-edit', $this->d);
		}
	}
	
	function DR_view($id){
		$this->d['dr'] = $this->sale->get_discount_rule_by_id($id);
		$this->load->view('sales/dr-view', $this->d);				
	}
	
	function DR_delete($id, $do){
		if ($do == 'do'){
			$this->sale->delete_discount_rule($id);
			echo 'ok';
		}
	}
	
	
	
	
	function Dos(){

		$warehouse_filter = "AND `warehouse_id` = " . $this->db->escape($this->user->data('branch'));

		$this->d['shipping_dropdown'] = $this->shipping->services_dropdown(true);		
		$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true);
		$this->d['invoices'] = $this->sale->get_invoices("WHERE `status` <> 'Pending' {$warehouse_filter} ORDER BY `date` DESC, `id` DESC LIMIT 100");
		$this->load->view('sales/do', $this->d);
	}
	
	function Do_filter(){

		if ($number = $this->input->post('number')) 				$filter[] = "`id` = ".$this->db->escape($number);
		if ($contact_id = $this->input->post('contact')) 			$filter[] = "`contact_id` = ".$this->db->escape($contact_id);
		if ($shipping_id = $this->input->post('shipping')) 			$filter[] = "`shipping_id` = ".$this->db->escape($shipping_id);
		if ($tracking_no = $this->input->post('tracking_number')) 	$filter[] = "`delivery-tracking_number` = ".$this->db->escape($delivery_tracking_no);
		if ($status = $this->input->post('status'))		 			$filter[] = "`delivery_status` = ".$this->db->escape($status);
		if ($date_from = $this->input->post('date_from')) 			$filter[] = "`delivery_date` >= ".$this->db->escape(sql_date_reformat($date_from));
		if ($date_to = $this->input->post('date_to')) 				$filter[] = "`delivery_date` <= ".$this->db->escape(sql_date_reformat($date_to));
		
		$filter[] = "`warehouse_id` = " . $this->db->escape($this->user->data('branch'));
		$filter[] = "`status` <> 'Pending'";
		
		if ($limit = $this->input->post('limit')) $limit_string = " LIMIT $limit ";
		
		$order_string = ' ORDER BY `date` DESC, `id` DESC ';
		
		$filter_string = implode(' AND ', $filter);
		
		if ($filter_string) $filter_string = ' WHERE ' . $filter_string;
						
		$this->d['invoices'] = $this->sale->get_invoices($filter_string . $order_string . $limit_string);
		$this->load->view('sales/do-filtered',$this->d);
	}

	function Do_view($id){

		$this->d['invoice'] = $invoice = $this->sale->get_invoice_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($invoice->contact_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}			
		$this->load->view('sales/do-view',$this->d);
	}
	
	function Do_pdf($id){

		$this->d['invoice'] = $invoice = $this->sale->get_invoice_by_id($id);
		$this->d['contact'] = $this->contact->get_contact_by_id($invoice->contact_id);
		if($this->user->data('branch')){
			$this->d['warehouse'] = $this->inv->get_warehouse_by_id($this->user->data('branch'));	
		}		
		$html = $this->load->view('sales/do-pdf',$this->d, true);
		
		ini_set("memory_limit", "128M");
	
		pdf_create($html,"DO-".$id);
	}
	
	function Do_update_status($id){
		$status = $this->input->post('status');

		$sql = $this->db->update_string('invoices', array(
			'delivery_status'	=> $status = $this->input->post('status')
		), "`id` = '{$id}'");
		
		$this->db->query($sql);
		
		$invoice = $this->sale->get_invoice_by_id($id);
		$this->system->event_log('sales','delivery_status_update','do',$id,$invoice);
	}
	
	function Do_update($id){
		$delivery_date = $this->input->post('delivery_date');
		$delivery_tracking_no = $this->input->post('delivery_tracking_no');
		$invoice = $this->sale->do_update($id, $receipt_date, $receipt_reference, $contra_id);
		
		$this->system->event_log('sales','delivery_info_update','do',$invoice->id, $invoice);
		
		$this->do_view($id);
	}
	
	function DO_pending($id){
		$invoice = $this->sale->do_pending($id);
		$this->system->event_log('sales','delivery_info_update','do',$invoice->id, $invoice);
		
		$this->do_view($id);
	}
	
	function Get_contact_address($contact_id){	
		$contact = $this->contact->get_contact_by_id($contact_id);
		
		$address->name 		= $contact->company_name ? $contact->company_name : $contact->contact_person;
		$address->mobile	= $contact->tel ? $contact->tel : $contact->contact_number;
		$address->address1	= $contact->address1;
		$address->address2	= $contact->address2;
		$address->zipcode	= $contact->zipcode;
		$address->city		= $contact->city;
		$address->state		= $contact->state;
		$address->country	= $contact->country;
		
		echo json_encode($address);

	}
		
	function Search_product($q, $t = 'name', $contact_id){
	
		if ($contact_id){
			$contact = $this->contact->get_contact_by_id($contact_id);
			$price_rules = json_decode($this->system->config('price_rules'));
		}
	
		$cell = 'name';
		if ($t == 'Product Name') $cell = 'name';
		elseif ($t == 'SKU') $cell = 'sku';
		
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' AND `warehouse_id` = ? ORDER BY `name` ASC", array($this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' ORDER BY `name` ASC");
		}

		if ($query->num_rows() < 1){
			echo "<tr><td colspan=\"3\"><strong>No item found</strong>. <a href=\"inventory/item_add/x/po\" class=\"target_dialog\">Create new item record</a>?</td></tr>";
			return;
		}
		$x = 0;
		echo '<tbody>';
		
		foreach ($query->result() as $product){
			$qty = $this->inv->get_item_quantity($product->id);
			
			if ($contact->rank){
				$contact_price = $product->{'price'.$price_rules->{str_replace(' ','_',$contact->rank)}};
			}
			
			if ($price_rules->{str_replace(' ','_',$contact->rank)} == 'cost'){
				$contact_price = $product->cost;
			}
			
			
			$prices = null;
		
			$prices[$product->price] = $product->price;
			if ($product->price_2 != 0) $prices[$product->price_2] = $product->price_2 . ' (Price2)';
			if ($product->price_3 != 0) $prices[$product->price_3] = $product->price_3 . ' (Price3)';
			if ($product->price_4 != 0) $prices[$product->price_4] = $product->price_4 . ' (Price4)';
			
			if($this->user->has_permission('to_view_cost_in_sales','Sales')){
				$prices[$product->cost] = $product->cost . ' (Cost)';
			}else{
			
			}
			
			
			$price_dropdown = form_dropdown('price',$prices,$contact_price,'class="item-price-select" style="width: 100%"');
		
			$class = $x%2 == 0 ? 'class="alt"' : ''; 
			echo "<tr {$class} tax_code=\"{$product->supply_tax_code}\" taxable=\"{$product->supply_taxable}\" rel=\"{$product->id}\" weight=\"{$product->weight}\" weight_unit=\"{$product->weight_unit}\" volume=\"{$product->volume}\" volume_unit=\"{$product->volume_unit}\">
				<td class=\"checkbox\" rel=\"1\" title=\"{$product->name}\"><input type=\"checkbox\" class=\"product-items\" value=\"{$product->id}\" /> <span class=\"product-name\">{$product->name} [{$product->supply_tax_code}]<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>{$product->sku}</strong></span></td>
				<td class=\"checkbox\" rel=\"2\" style=\"width: 100px; text-align: right\"><span class=\"quantity\"><input style=\"width: 80px\" value=\"1\" type=\"number\" class=\"qty\" /></span></td>
				<td rel=\"3\" style=\"width: 60px; text-align: right\"><span class=\"quantity-in-stock\">{$qty}</span></td>
				<td rel=\"4\" style=\"width: 100px; text-align: right\">{$price_dropdown}<span class=\"product-price\" style=\"display:none\">{$product->price}</span><span class=\"selling-price\" style=\"display:none\">{$product->price}</span></td></tr>";
			$x++;
		}
		echo '</tbody>';
	}
	
	function Search_product_consignment($q, $t = 'name', $contact_id){
	
		if ($contact_id){
			$contact = $this->contact->get_contact_by_id($contact_id);
			$price_rules = json_decode($this->system->config('price_rules'));
		}
	
		$cell = 'name';
		if ($t == 'Product Name') $cell = 'name';
		elseif ($t == 'SKU') $cell = 'sku';
		
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' AND `warehouse_id` = ? ORDER BY `name` ASC", array($this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' ORDER BY `name` ASC");
		}

		if ($query->num_rows() < 1){
			echo "<tr><td colspan=\"3\"><strong>No item found</strong>. <a href=\"inventory/item_add/x/po\" class=\"target_dialog\">Create new item record</a>?</td></tr>";
			return;
		}
		$x = 0;
		echo '<tbody>';
		foreach ($query->result() as $product){
			$qty = $this->inv->get_balance_consigned($product->id, $contact_id);
			
			if ($contact->rank){
				$contact_price = $product->{'price'.$price_rules->{str_replace(' ','_',$contact->rank)}};
			}
			
			if ($price_rules->{str_replace(' ','_',$contact->rank)} == 'cost'){
				$contact_price = $product->cost;
			}
			
			
			$prices = null;
		
			$prices[$product->price] = $product->price;
			if ($product->price_2 != 0) $prices[$product->price_2] = $product->price_2 . ' (Price2)';
			if ($product->price_3 != 0) $prices[$product->price_3] = $product->price_3 . ' (Price3)';
			if ($product->price_4 != 0) $prices[$product->price_4] = $product->price_4 . ' (Price4)';
			
			if($this->user->has_permission('to_view_cost_in_sales','Sales')){
				$prices[$product->cost] = $product->cost . ' (Cost)';
			}else{
				
			}
			
			$price_dropdown = form_dropdown('price',$prices,$contact_price,'class="item-price-select" style="width: 100%"');
		
			$class = $x%2 == 0 ? 'class="alt"' : ''; 
			echo "<tr {$class} taxable=\"{$product->supply_taxable}\" rel=\"{$product->id}\" weight=\"{$product->weight}\" weight_unit=\"{$product->weight_unit}\" volume=\"{$product->volume}\" volume_unit=\"{$product->volume_unit}\">
				<td class=\"checkbox\" rel=\"1\" title=\"{$product->name}\"><input type=\"checkbox\" class=\"product-items\" value=\"{$product->id}\" /> <span class=\"product-name\">{$product->name}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>{$product->sku}</strong></span></td>
				<td class=\"checkbox\" rel=\"2\" style=\"width: 100px; text-align: right\"><span class=\"quantity\"><input style=\"width: 80px\" value=\"1\" type=\"number\" class=\"qty\" /></span></td>
				<td rel=\"3\" style=\"width: 60px; text-align: right\"><span class=\"quantity-in-stock\">{$qty}</span></td>
				<td rel=\"4\" style=\"width: 100px; text-align: right\">{$price_dropdown}<span class=\"product-price\" style=\"display:none\">{$product->price}</span><span class=\"selling-price\" style=\"display:none\">{$product->price}</span></td></tr>";
			$x++;
		}
		echo '</tbody>';
	}
	
	
	function Search_discount_product($q, $t = 'name', $contact_id){
	
		if ($contact_id){
			$contact = $this->contact->get_contact_by_id($contact_id);
			$price_rules = json_decode($this->system->config('price_rules'));
		}
		

	
		$cell = 'name';
		if ($t == 'Product Name') $cell = 'name';
		elseif ($t == 'SKU') $cell = 'sku';
		
		if (!$this->system->config('warehouse_shared_inventory')){
			if (trim($q) == '*'){
				$query = $this->db->query("SELECT * FROM `inventory` WHERE `warehouse_id` = ? ORDER BY `name` ASC", array($this->user->data('branch')));
			} else {
				$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' AND `warehouse_id` = ? ORDER BY `name` ASC", array($this->user->data('branch')));
			}
		} else {
			if (trim($q) == '*'){
				$query = $this->db->query("SELECT * FROM `inventory` ORDER BY `name` ASC");				
			} else {
				$query = $this->db->query("SELECT * FROM `inventory` WHERE `$cell` LIKE '%$q%' ORDER BY `name` ASC");
			}
		}

		if ($query->num_rows() < 1){
			echo "<tr><td colspan=\"3\"><strong>No item found</strong>. <a href=\"inventory/item_add/x/po\" class=\"target_dialog\">Create new item record</a>?</td></tr>";
			return;
		}
		$x = 0;
		echo '<tbody>';
		foreach ($query->result() as $product){
			$qty = $this->inv->get_item_quantity($product->id);
			
			if ($contact->rank){
				$contact_price = $product->{'price'.$price_rules->{str_replace(' ','_',$contact->rank)}};
			}
			
			if ($price_rules->{str_replace(' ','_',$contact->rank)} == 'cost'){
				$contact_price = $product->cost;
			}
			
			
			$prices = null;
		
			$prices[$product->price] = $product->price;
			if ($product->price_2 != 0) $prices[$product->price_2] = $product->price_2 . ' (Price2)';
			if ($product->price_3 != 0) $prices[$product->price_3] = $product->price_3 . ' (Price3)';
			if ($product->price_4 != 0) $prices[$product->price_4] = $product->price_4 . ' (Price4)';
			if($this->user->has_permission('to_view_cost_in_sales','Sales')){
				$prices[$product->cost] = $product->cost . ' (Cost)';
			}else{
				$prices[$product->cost] = $product->cost . ' (CostHidden)';
			}
			
			$price_dropdown = form_dropdown('price',$prices,$contact_price,'class="item-price-select" style="width: 100%"');
		
			$class = $x%2 == 0 ? 'class="alt"' : ''; 
			echo "<tr {$class} rel=\"{$product->id}\" weight=\"{$product->weight}\" weight_unit=\"{$product->weight_unit}\" volume=\"{$product->volume}\" volume_unit=\"{$product->volume_unit}\">
				<td class=\"checkbox\" rel=\"1\" title=\"{$product->name}\"><input type=\"checkbox\" class=\"product-items\" value=\"{$product->id}\" /> <span class=\"product-name\">{$product->name}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>{$product->sku}</strong></span></td>
				<td rel=\"3\" style=\"width: 60px; text-align: center\"><span class=\"quantity-in-stock\">{$qty}</span></td>
				<td rel=\"4\" style=\"width: 100px; text-align: right\">{$price_dropdown}<span class=\"product-price\" style=\"display:none\">{$product->price}</span><span class=\"selling-price\" style=\"display:none\">{$product->price}</span></td></tr>";
			$x++;
		}
		echo '</tbody>';
	}
	

	function Search_service($q, $t = 'name'){
		$cell = 'name';
		if ($t == 'Product Name') $cell = 'name';
		elseif ($t == 'SKU') $cell = 'sku';
		
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT * FROM `services` WHERE `$cell` LIKE '%$q%' AND `warehouse_id` = ? ORDER BY `name` ASC", array($this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT * FROM `services` WHERE `$cell` LIKE '%$q%' ORDER BY `name` ASC");			
		}

		if ($query->num_rows() < 1){
			echo "<tr><td colspan=\"3\"><strong>No item found</strong>. <a href=\"services/add/x/po\" class=\"target_dialog\">Create new service record</a>?</td></tr>";
			return;
		}
		$x = 0;
		echo '<tbody>';
		foreach ($query->result() as $service){
			$class = $x%2 == 0 ? 'class="alt"' : ''; 
			echo "<tr {$class} rel=\"{$service->id}\">
				<td class=\"checkbox\" rel=\"1\" title=\"{$service->name}\"><input type=\"checkbox\" class=\"service-items\" value=\"{$service->id}\" /> <span class=\"service-name\">{$service->name}</span><span style=\"display:none\" class=\"service-description\">{$service->description}</span></td>
				<td rel=\"2\" style=\"width: 60px; text-align: right\"><span class=\"service-price\">{$service->price}</span><span class=\"selling-price\" style=\"display:none\">{$service->price}</span></td></tr>";
			$x++;
		}
		echo '</tbody>';
	}
	
	
	function Send_order_notification($id){
		
		$so = $this->sale->get_so_by_id($id);	
		$invoice = $this->sale->get_invoice_by_id($so->invoice_id);
		$contact = $this->contact->get_contact_by_id($so->contact_id);
		
		$payment_status = $invoice->payment_status;
		$status = $so->status;
		
		$total 				= number_format($so->total - $so->handling_charges,2);
		$handling_charges	= number_format($so->handling_charges,2);
		$grand_total 		= number_format($so->total,2);
		
		$styles = '<style>' . $this->system->config('online_sales_email_css') . '</style>';
		
		$order_table = "<table style=\"border-collapse: collapse;\"><thead><tr><th>No</th><th>Item</th><th>Unit Price</th><th>Qty</th><th>Subtotal</th></tr></thead>";
		$order_table .= "<tfoot>
							<tr>
								<td colspan=\"4\">Total</td>
								<td style=\"text-align: right\">{$total}</td>
							</tr>
							<tr>
								<td colspan=\"4\">Shipping: {$so->shipping}</td>
								<td style=\"text-align: right\">{$handling_charges}</td>
							</tr>
							<tr>
								<td colspan=\"4\"><strong>Grand Total</strong></td>
								<td style=\"text-align: right\">{$grand_total}</td>	
							</tr>
						</tfoot>";
		$order_table .= "<tbody>";
		
		foreach ($so->orders as $item){
			$z++;
			$order_table .= "<tr>
								<td style=\"text-align: center\">{$z}</td>
								<td>{$item->item_name}<br />{$item->item_sku}</td>
								<td style=\"text-align: center\">{$item->price_per_unit}</td>
								<td style=\"text-align: center\">{$item->qty}</td>
								<td style=\"text-align: right\">{$item->price}</td>
							</tr>";
		}
		$order_table .= "</tbody></table>";
		
		$address = json_decode($so->contact_address);
		$billing_address .= $address->address1 ? $address->address1 . "<br />"  : '';
		$billing_address .= $address->address2 ? $address->address2 . "<br />"  : '';
		$billing_address .= $address->zipcode ? $address->zipcode . ' ' : '';
		$billing_address .= $address->city ? $address->city . "<br />" : '';
		$billing_address .= $address->state ? $address->state . "<br />" : '';
		$billing_address .= $address->country ? $address->country : ''; 
		
		$address = json_decode($so->delivery_address);
    	$delivery_address = $address->name ? $address->name . "<br />" : '';
    	$delivery_address .= $address->mobile ? 'Contact No: ' . $address->mobile . "<br />"  : '';
    	$delivery_address .= $address->address1 ? $address->address1 . "<br />"  : '';
    	$delivery_address .= $address->address2 ? $address->address2 . "<br />"  : '';
    	$delivery_address .= $address->zipcode ? $address->zipcode . ' ' : '';
    	$delivery_address .= $address->city ? $address->city . "<br />"  : '';
    	$delivery_address .= $address->state ? $address->state . "<br />"  : '';
    	$delivery_address .= $address->country ? $address->country : '';
	
		if ($so->warehouse_id){
			$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($so->warehouse_id));
			$warehouse = $query->row();			
		}
		
		
		$message = populate_template_data(nl2br($this->system->config('online_sales_email_new_order')),array(
			'{name}'			=> $contact->contact_person,
			'{mobile}'			=> $contact->contact_number,
			'{email}'			=> $contact->email,
			'{order_no}'		=> $so->id,
			'{datetime}'		=> date('j:iA d/m/Y',strtotime($so->datetime)),
			'{bill_addr}'		=> $billing_address,
			'{delivery_addr}'	=> $delivery_address,
			'{gateway}'			=> $so->gateway,
			'{shipping}'		=> $so->shipping,
			'{order_table}'		=> $order_table,
			'{warehouse}'		=> $warehouse->name,
			'{status}'			=> $status,
			'{payment_status}'	=> $payment_status
		));
		
		$message = '<html><head>' . $styles . '</head><body>' . $message . '</body></html>';
		
		$subject = populate_template_data($this->system->config('online_sales_email_new_order_subject'),array(
			'{name}'			=> $contact->contact_person,
			'{mobile}'			=> $contact->contact_number,
			'{email}'			=> $contact->email,
			'{order_no}'		=> $so->id,
			'{datetime}'		=> date('j:iA d/m/Y',strtotime($so->datetime)),
			'{bill_addr}'		=> $billing_address,
			'{delivery_addr}'	=> $delivery_address,
			'{gateway}'			=> $so->gateway,
			'{shipping}'		=> $so->shipping,
			'{warehouse}'		=> $warehouse->name,
			'{status}'			=> $status,
			'{payment_status}'	=> $payment_status
		));
		
		$message_bo = populate_template_data(nl2br($this->system->config('online_sales_email_new_order_bo')),array(
			'{name}'			=> $contact->contact_person,
			'{mobile}'			=> $contact->contact_number,
			'{email}'			=> $contact->email,
			'{order_no}'		=> $so->id,
			'{datetime}'		=> date('j:iA d/m/Y',strtotime($so->datetime)),
			'{bill_addr}'		=> $billing_address,
			'{delivery_addr}'	=> $delivery_address,
			'{gateway}'			=> $so->gateway,
			'{shipping}'		=> $so->shipping,
			'{order_table}'		=> $order_table,
			'{warehouse}'		=> $warehouse->name,
			'{status}'			=> $status,
			'{payment_status}'	=> $payment_status
		));
		
		$message_bo = '<html><head>' . $styles . '</head><body>' . $message_bo . '</body></html>';
		
		$subject_bo = populate_template_data($this->system->config('online_sales_email_new_order_bo_subject'),array(
			'{name}'			=> $contact->contact_person,
			'{mobile}'			=> $contact->contact_number,
			'{email}'			=> $contact->email,
			'{order_no}'		=> $so->id,
			'{datetime}'		=> date('j:iA d/m/Y',strtotime($so->datetime)),
			'{bill_addr}'		=> $billing_address,
			'{delivery_addr}'	=> $delivery_address,
			'{gateway}'			=> $so->gateway,
			'{shipping}'		=> $so->shipping,
			'{warehouse}'		=> $warehouse->name,
			'{status}'			=> $status,
			'{payment_status}'	=> $payment_status
		));

    	
    	$config['protocol'] = 'smtp';
    	$config['mailpath'] = '/usr/sbin/sendmail';
    	$config['charset'] = 'iso-8859-1';
    	$config['wordwrap'] = TRUE;
    	$config['mailtype'] = 'html';
    
    	$config['smtp_host'] = $this->system->config('online_sales_responder_hostname');
    	$config['smtp_user'] = $this->system->config('online_sales_responder_email');
    	$config['smtp_pass'] = $this->system->config('online_sales_responder_password');
    	$config['smtp_port'] = '25';

    	$this->load->library('email');		
    	$this->email->initialize($config);

    	$this->email->from($this->system->config('online_sales_responder_email'), $this->system->config('online_sales_responder_name'));
    	$this->email->to($contact->email);
    	$this->email->bcc($this->system->config('online_sales_responder_txn_email'));
    	$this->email->subject($subject);
    	$this->email->message($message);
    	$this->email->send();
    	
    	
    	$this->email->from($this->system->config('online_sales_responder_email'), $this->system->config('online_sales_responder_name'));
    	if ($so->warehouse_id){
	    	$this->email->to($this->system->config('online_sales_responder_email') . ',' . $warehouse->email);
    	} else {
	    	$this->email->to($this->system->config('online_sales_responder_email'));
    	}
    	$this->email->bcc(array($this->system->config('online_sales_responder_txn_email')));
    	$this->email->subject($subject_bo);
    	$this->email->message($message_bo);
    	$this->email->send();
    	
    	if ($so->notifications){
	    	$notifications = json_decode($so->notifications);
	    }
    	
       	$notification->type 	= 'New Order';
    	$notification->datetime	= date('Y-m-d H:i:s');
    	$notification->by		= $this->user->data('username');
    	$notification->status 	= $payment_status;
    	
    	$notifications[] = $notification;
  
  		$this->db->update('sales_order', array(
  			'notification'	=> json_encode($notifications)
  		), "`id` = '{$so->id}'");

		
		$this->invoice_view($invoice->id);
	}
		
	function Send_status_notification($id){
		
		$invoice = $this->sale->get_invoice_by_id($id);
		$so = $this->sale->get_so_by_id($invoice->sales_order_id);
				
		$contact = $this->contact->get_contact_by_id($invoice->contact_id);

		$address = json_decode($invoice->delivery_address);
    	$delivery_address = $address->name ? $address->name . "<br />" : '';
    	$delivery_address .= $address->mobile ? 'Contact No: ' . $address->mobile . "<br />"  : '';
    	$delivery_address .= $address->address1 ? $address->address1 . "<br />"  : '';
    	$delivery_address .= $address->address2 ? $address->address2 . "<br />"  : '';
    	$delivery_address .= $address->zipcode ? $address->zipcode . ' ' : '';
    	$delivery_address .= $address->city ? $address->city . "<br />"  : '';
    	$delivery_address .= $address->state ? $address->state . "<br />"  : '';
    	$delivery_address .= $address->country ? $address->country : '';
    	
		if ($invoice->warehouse_id){
			$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($invoice->warehouse_id));
			$warehouse = $query->row();			
		}
		
		$message = populate_template_data(nl2br($this->system->config('online_sales_email_order_status')),array(
			'{name}'			=> $contact->contact_person,
			'{mobile}'			=> $contact->contact_number,
			'{email}'			=> $contact->email,
			'{order_no}'		=> $invoice->sales_order_id,
			'{invoice_no}'		=> $invoice->id,
			'{order_status}'	=> $so->status,
			'{delivery_status}'	=> $invoice->delivery_status ? $invoice->delivery_status : 'Pending',
			'{delivery_ref}'	=> $invoice->delivery_tracking_no,
			'{delivery_date}'	=> date('d/m/Y',strtotime($invoice->delivery_date)),
			'{delivery_addr}'	=> $delivery_address,
			'{datetime}'		=> date('j:iA d/m/Y',strtotime($so->datetime)),
			'{shipping}'		=> $invoice->shipping,
			'{warehouse}'		=> $warehouse->name
		));
		
		$message = '<html><head>' . $styles . '</head><body>' . $message . '</body></html>';
		
		$subject = populate_template_data($this->system->config('online_sales_email_order_status_subject'),array(
			'{name}'			=> $contact->contact_person,
			'{mobile}'			=> $contact->contact_number,
			'{email}'			=> $contact->email,
			'{order_no}'		=> $invoice->sales_order_id,
			'{invoice_no}'		=> $invoice->id,
			'{order_status}'	=> $so->status,
			'{delivery_status}'	=> $invoice->delivery_status ? $invoice->delivery_status : 'Pending',
			'{delivery_ref}'	=> $invoice->delivery_tracking_no,
			'{delivery_date}'	=> date('d/m/Y',strtotime($invoice->delivery_date)),
			'{delivery_addr}'	=> $delivery_address,
			'{datetime}'		=> date('j:iA d/m/Y',strtotime($so->datetime)),
			'{shipping}'		=> $invoice->shipping,
			'{warehouse}'		=> $warehouse->name
		));
		
		$config['protocol'] = 'smtp';
    	$config['mailpath'] = '/usr/sbin/sendmail';
    	$config['charset'] = 'iso-8859-1';
    	$config['wordwrap'] = TRUE;
    	$config['mailtype'] = 'html';
    
    	$config['smtp_host'] = $this->system->config('online_sales_responder_hostname');
    	$config['smtp_user'] = $this->system->config('online_sales_responder_email');
    	$config['smtp_pass'] = $this->system->config('online_sales_responder_password');
    	$config['smtp_port'] = '25';

    	$this->load->library('email');		
    	$this->email->initialize($config);

    	$this->email->from($this->system->config('online_sales_responder_email'), $this->system->config('online_sales_responder_name'));
    	$this->email->to($contact->email);
    	$this->email->bcc($this->system->config('online_sales_responder_txn_email'));
    	$this->email->subject($subject);
    	$this->email->message($message);
    	$this->email->send();
    	
    	if ($invoice->notifications){
	    	$notifications = json_decode($invoice->notifications);
	    }
    	
       	$notification->type 	= 'New Order';
    	$notification->datetime	= date('Y-m-d H:i:s');
    	$notification->by		= $this->user->data('username');
    	$notification->status	= $invoice->delivery_status;
    	$notification->ref		= $invoice->delivery_tracking_no;
    	
    	$notifications[] = $notification;
  
  		$this->db->update('invoices', array(
  			'notification'	=> json_encode($notifications)
  		), "`id` = '{$invoice->id}'");
  		
		$this->do_view($id);
		
	}
	
	function Send_so_status_notification($id){

		$so = $this->sale->get_so_by_id($id);		
		$invoice = $this->sale->get_invoice_by_id($so->invoice_id);

				
		$contact = $this->contact->get_contact_by_id($invoice->contact_id);

		$address = json_decode($invoice->delivery_address);
    	$delivery_address = $address->name ? $address->name . "<br />" : '';
    	$delivery_address .= $address->mobile ? 'Contact No: ' . $address->mobile . "<br />"  : '';
    	$delivery_address .= $address->address1 ? $address->address1 . "<br />"  : '';
    	$delivery_address .= $address->address2 ? $address->address2 . "<br />"  : '';
    	$delivery_address .= $address->zipcode ? $address->zipcode . ' ' : '';
    	$delivery_address .= $address->city ? $address->city . "<br />"  : '';
    	$delivery_address .= $address->state ? $address->state . "<br />"  : '';
    	$delivery_address .= $address->country ? $address->country : '';
    	
		if ($invoice->warehouse_id){
			$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($invoice->warehouse_id));
			$warehouse = $query->row();			
		}
		
		$message = populate_template_data(nl2br($this->system->config('online_sales_email_order_status')),array(
			'{name}'			=> $contact->contact_person,
			'{mobile}'			=> $contact->contact_number,
			'{email}'			=> $contact->email,
			'{order_no}'		=> $invoice->sales_order_id,
			'{invoice_no}'		=> $invoice->id,
			'{order_status}'	=> $so->status,
			'{delivery_status}'	=> $invoice->delivery_status ? $invoice->delivery_status : 'Pending',
			'{delivery_ref}'	=> $invoice->delivery_tracking_no,
			'{delivery_date}'	=> date('d/m/Y',strtotime($invoice->delivery_date)),
			'{delivery_addr}'	=> $delivery_address,
			'{datetime}'		=> date('j:iA d/m/Y',strtotime($so->datetime)),
			'{shipping}'		=> $invoice->shipping,
			'{warehouse}'		=> $warehouse->name
		));
		
		$message = '<html><head>' . $styles . '</head><body>' . $message . '</body></html>';
		
		$subject = populate_template_data($this->system->config('online_sales_email_order_status_subject'),array(
			'{name}'			=> $contact->contact_person,
			'{mobile}'			=> $contact->contact_number,
			'{email}'			=> $contact->email,
			'{order_no}'		=> $invoice->sales_order_id,
			'{invoice_no}'		=> $invoice->id,
			'{order_status}'	=> $so->status,
			'{delivery_status}'	=> $invoice->delivery_status ? $invoice->delivery_status : 'Pending',
			'{delivery_ref}'	=> $invoice->delivery_tracking_no,
			'{delivery_date}'	=> date('d/m/Y',strtotime($invoice->delivery_date)),
			'{delivery_addr}'	=> $delivery_address,
			'{datetime}'		=> date('j:iA d/m/Y',strtotime($so->datetime)),
			'{shipping}'		=> $invoice->shipping,
			'{warehouse}'		=> $warehouse->name
		));
		
		$config['protocol'] = 'smtp';
    	$config['mailpath'] = '/usr/sbin/sendmail';
    	$config['charset'] = 'iso-8859-1';
    	$config['wordwrap'] = TRUE;
    	$config['mailtype'] = 'html';
    
    	$config['smtp_host'] = $this->system->config('online_sales_responder_hostname');
    	$config['smtp_user'] = $this->system->config('online_sales_responder_email');
    	$config['smtp_pass'] = $this->system->config('online_sales_responder_password');
    	$config['smtp_port'] = '25';

    	$this->load->library('email');		
    	$this->email->initialize($config);

    	$this->email->from($this->system->config('online_sales_responder_email'), $this->system->config('online_sales_responder_name'));
    	$this->email->to($contact->email);
    	$this->email->bcc($this->system->config('online_sales_responder_txn_email'));
    	$this->email->subject($subject);
    	$this->email->message($message);
    	$this->email->send();
    	
    	if ($invoice->notifications){
	    	$notifications = json_decode($invoice->notifications);
	    }
    	
       	$notification->type 	= 'New Order';
    	$notification->datetime	= date('Y-m-d H:i:s');
    	$notification->by		= $this->user->data('username');
    	$notification->status	= $so->status;
    	
    	$notifications[] = $notification;
  
  		$this->db->update('sales_order', array(
  			'notification'	=> json_encode($notifications)
  		), "`id` = '{$so->id}'");
  		
		$this->so_view($so->id);
		
	}
	

}

