<?php

class Settings extends Controller {

	function Settings(){
		parent::Controller();
		$this->d['user'] = $this->user->data();
		$this->load->model('system');
		$this->load->model('cc');
		$this->load->model('tax');
		$this->load->model('shipping');
		$this->load->model('contact');
	}
	
	function Index(){
		$this->d['title'] = 'Settings';
		$this->d['system'] = $this->system->config();
		$this->d['users'] = $this->user->get_users();
		
		
		$this->load->view('header', $this->d);
		$this->load->view('settings/index', $this->d);
		$this->load->view('footer', $this->d);
	}
	
	function Shipping(){
		$this->d['services'] = $this->shipping->get_services();
		$this->load->view('settings/shipping', $this->d);		
	}
	
	function Shipping_add($do){
		if ($do == 'do'){
			$this->shipping->add_service();
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->load->view('settings/shipping-add',$this->d);
		}
	}
	
	function Shipping_edit($id, $do){
		if ($do == 'do'){
			$this->shipping->edit_service($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->d['shipping'] = $this->shipping->get_service_by_id($id);
			$this->load->view('settings/shipping-edit', $this->d);
		}
	}
	
	function Shipping_view($id){
		$this->d['shipping'] = $this->shipping->get_service_by_id($id);
		$this->d['rates'] = $this->shipping->get_rates_by_service_id($id);
		
		$this->d['local_zones'] = $this->shipping->get_local_zones(0,true);
		$this->d['international_zones'] = $this->shipping->get_international_zones(0,true);

		$this->load->view('settings/shipping-view', $this->d);
	}
	
	function Shipping_add_rate($shipping_id, $do){
		if ($do == 'do'){
			$this->shipping->add_rates($shipping_id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['shipping'] = $this->shipping->get_service_by_id($shipping_id);
			$this->d['local_zones'] = $this->shipping->get_local_zones($service_id,true);
			$this->d['international_zones'] = $this->shipping->get_international_zones($service_id,true);

			$this->load->view('settings/shipping-add-rate', $this->d);
		}
	}
	
	function Shipping_edit_rate($shipping_id, $rate_id, $do){

		if ($do == 'do'){
			$this->shipping->edit_rates($rate_id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['shipping'] = $this->shipping->get_service_by_id($shipping_id);
			$this->d['rate'] = $this->shipping->get_rate_by_id($rate_id);
			$this->d['local_zones'] = $this->shipping->get_local_zones($service_id,true);
			$this->d['international_zones'] = $this->shipping->get_international_zones($service_id,true);


			$this->load->view('settings/shipping-edit-rate', $this->d);
		}
	}
	
	function Shipping_delete_rate($id){
		$this->shipping->delete_rate($id);
		echo 'ok';
	}
	
	function Zones(){
		$this->d['zones'] = $this->shipping->get_zones();
		$this->load->view('settings/zones', $this->d);
	}
	
	function Zone_add($do){
		if ($do == 'do'){
			if ($this->input->post('type') == 'International'){
				$this->shipping->add_international_zone();
			} else {
				$this->shipping->add_local_zone();
			}
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			$this->load->view('settings/zone-add', $this->d);
		}
	}
	
	function Zone_edit($type, $id, $do){
		if ($do == 'do'){
			if ($type == 'International'){
				$this->shipping->edit_international_zone($id);
			} else {
				$this->shipping->edit_local_zone($id);
			}
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';	
		} else {
			if ($type == 'International') $this->d['zone'] = $this->shipping->get_international_zone_by_id($id);
			else $this->d['zone'] = $this->shipping->get_local_zone_by_id($id);
			
			$this->d['type'] = $type;
			$this->load->view('settings/zone-edit', $this->d);
		}
	
	}
	
	function Zone_delete($type, $id){
		if ($type == 'International') $this->shipping->delete_international_zone($id);
		else if ($type == 'Local') $this->shipping->delete_local_zone($id);
		
		echo 'ok';
	}

	
	function Tax(){
		$this->d['taxes'] = $this->tax->get_taxes();
		$this->load->view('settings/tax', $this->d);
	}
	
	function Credit_cards(){
		$this->d['cces'] = $this->cc->get_cces();
		$this->load->view('settings/credit_cards', $this->d);
	}
	
	function Add_cc($do){
		if ($do == 'do'){
			$cc = $this->cc->add();
			$this->system->event_log('cc','add','cc',$cc->id, $cc);
			
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd("success",'.$cc->id.');</script>';	

		}
	}
	
	function Edit_cc($do){
		if ($do == 'do'){
			$id = $this->input->post('id');
			$cc = $this->cc->edit($id);
			$this->system->event_log('cc','edit','cc', $cc->id, $cc);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyEdit("success",'.$cc->id.');</script>';

		}
	}
	
	function Delete_cc($id){
		$cc = $this->cc->delete($id);
		$this->system->event_log('cc','delete','cc',$cc->id, $cc);
		echo 'ok';
	}
		
	function Add_tax($do){
		if ($do){
			
			$tax = $this->tax->add();
			$this->system->event_log('tax','add','tax', $tax->id, $tax);

			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd("success",'.$tax->id.');</script>';	

		}
	}
	
	function Edit_tax($do){
		if ($do == 'do'){
			$id = $this->input->post('id');
			$tax = $this->tax->edit($id);
			$this->system->event_log('tax','edit','tax',$tax->id,$tax);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyEdit("success",'.$tax->id.');</script>';
		}
	}
	
	function Delete_tax($id){
		$tax = $this->tax->delete($id);
		$this->system->event_log('tax','delete','tax',$tax->id, $tax);
		echo 'ok';
	}
	
	function Users(){
		$this->d['users'] = $this->user->user_list();
		$this->load->view('settings/user-list', $this->d);
	}
	
	function New_user(){
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `super` <> 1");
		$permissions = $query->result();
		
		foreach ($permissions as $user_type){
			$user_types[$user_type->user_type] = $user_type->user_type;
		}
		$this->d['user_types'] 			= $user_types;
		$this->d['branches_dropdown']	= $this->system->get_branches_dropdown();
		
		$this->load->view('settings/user-new',$this->d);
	}
	
	function add_user($action){
		$username 	= trim($this->input->post('username'));
		$password 	= $this->input->post('password');
		$cpassword 	= $this->input->post('confirm_password');
		$type 		= $this->input->post('type');
		$status 	= $this->input->post('status');
		$email 		= trim($this->input->post('email'));
		$firstname 	= trim($this->input->post('firstname'));
		$lastname 	= trim($this->input->post('lastname'));
		$gender 	= $this->input->post('gender');
		$dob 		= sql_date_reformat($this->input->post('dob'));
		$phone 		= $this->input->post('phone');
		$mobile 	= $this->input->post('mobile');
		$alternative= $this->input->post('alternative_contact');
		$website 	= $this->input->post('website');
		$address1 	= $this->input->post('address1');
		$address2 	= $this->input->post('address2');
		$city 		= $this->input->post('city');
		$postcode 	= $this->input->post('postcode');
		$state 		= $this->input->post('state');
		$country 	= $this->input->post('country');
		$data		= $this->input->post('data');
		$division	= $this->input->post('division');
		$branch		= $this->input->post('branch');
		$keycard 	= $_REQUEST['keycard'];

		

		
		if (!$username){
			echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",0);</script>';
			return;
		}
		
		$query=$this->db->query("SELECT * FROM `users` WHERE `username` = '$username'");
		if ($query->num_rows()){
			echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",4);</script>';
			return;
		}
		
		if (strlen($password) < 6){
			echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",3);</script>';
			return;
		} 

		
		if ($cpassword !== $password){
			echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",2);</script>';
			return;
		}
		
		$sql = $this->db->insert_string('users', array(
			'username'	=> $username,
			'password'	=> md5($password),
			'email' 	=> $email,
			'type'		=> $type,
			'status'	=> $status,
			'firstname' => $firstname,
			'lastname'	=> $lastname,
			'gender'	=> $gender,
			'dob'		=> $dob,
			'phone'		=> $phone,
			'mobile'	=> $mobile,
			'role'		=> $role,
			'branch'	=> $branch,
			'division'	=> $division,
			'keycard'	=> $keycard,
			'data'		=> $data ? json_encode($data) : ''
		));
		
		$this->db->query($sql);
		
		echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
	}
	
	function view_user($id){

		$query = $this->db->query("SELECT * FROM `users` WHERE `id` = '$id'");
		$this->d['user'] = $query->row();
		$this->load->view('settings/user-view',$this->d);
	}

	function Edit_user($id, $action){
	
		$query = $this->db->query("SELECT * FROM `users` WHERE `id` = '$id'");
		$this->d['user'] = $user = $query->row();


		if ($action == 'do'){
			$password 	= $this->input->post('password');
			$type 		= $this->input->post('type');
			$status 	= $this->input->post('status');
			$email 		= trim($this->input->post('email'));
			$cpassword 	= $this->input->post('confirm_password');
			$firstname	= trim($this->input->post('firstname'));
			$lastname 	= trim($this->input->post('lastname'));
			$gender 	= $this->input->post('gender');
			$dob 		= sql_date_reformat($this->input->post('dob'));
			$phone 		= $this->input->post('phone');
			$mobile 	= $this->input->post('mobile');
			$alternative= $this->input->post('alternative_contact');
			$website 	= $this->input->post('website');
			$address1 	= $this->input->post('address1');
			$address2 	= $this->input->post('address2');
			$city 		= $this->input->post('city');
			$postcode 	= $this->input->post('postcode');
			$state 		= $this->input->post('state');
			$country 	= $this->input->post('country');
			$division 	= $this->input->post('division');
			$role 		= $this->input->post('role');
			$data 		= $this->input->post('data');
			$branch 	= $this->input->post('branch');
			$keycard 	= $_REQUEST['keycard'];
			
			
			if ($password){
				if (strlen($password) < 6){
					echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",3);</script>';
					return;
				} 
				if ($cpassword !== $password){
					echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",2);</script>';
					return;
				}
			}
			
			if ($this->user->check_superadmin($id)){
				$query = $this->db->query("SELECT * FROM `users` WHERE `id` = ?",array($id));
				$cur_user = $query->row();

				$status = $cur_user->status;
				$type = $cur_user->type;
			}
			
			
			if (trim($password)){
				$sql = $this->db->update_string('users', array(
					'password' 		=> md5($password),
					'email' 		=> $email,
					'type' 			=> $type,
					'status' 		=> $status,
					'firstname' 	=> $firstname,
					'lastname' 		=> $lastname,
					'gender' 		=> $gender,
					'dob' 			=> $dob,
					'phone' 		=> $phone,
					'mobile' 		=> $mobile,
					'role' 			=> $role,
					'branch'		=> $branch,
					'division'		=> $division,
					'keycard'		=> $keycard,
					'data'			=> is_array($data) ? json_encode($data) : $user->data
				),"`id` = '$id'");
			} else {
				$sql = $this->db->update_string('users', array(
					'email' 		=> $email,
					'type' 			=> $type,
					'status' 		=> $status,
					'firstname' 	=> $firstname,
					'lastname' 		=> $lastname,
					'gender' 		=> $gender,
					'dob' 			=> $dob,
					'phone' 		=> $phone,
					'mobile' 		=> $mobile,
					'role' 			=> $role,
					'branch'		=> $branch,
					'division'		=> $division,
					'keycard'		=> $keycard,
					'data'			=> json_encode($data)
				),"`id` = '$id'");

			}
			$this->db->query($sql);
			
			echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("'.$action.'",1);</script>';
			return;
		}

		$query = $this->db->query("SELECT * FROM `permissions` WHERE `super` <> 1");
		$permissions = $query->result();
		
		foreach ($permissions as $user_type){
			$user_types[$user_type->user_type] = $user_type->user_type;
		}
		
		$this->d['user_types'] 			= $user_types;
		$this->d['branches_dropdown']	= $this->system->get_branches_dropdown();
		$this->d['divisions_dropdown']	= $this->system->get_divisions_dropdown();
		
		$this->load->view('settings/user-edit', $this->d);
	}
	
	
	function Delete_user($id){
		$this->db->query("DELETE FROM `users` WHERE `id` = '$id'");
		echo 'ok';
	}
	
	
	function Permissions(){
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `super` <> 1");
		$this->d['permissions'] = $query->result();
		$this->load->view('settings/permissions',$this->d);
	}
	
	function New_user_type($do){
		if ($do == 'do'){
			$type = trim($this->input->post('type'));
			if (!$type) return;
			
			$modules = $this->input->post('modules');

			$query = $this->db->query("SELECT * FROM `modules` WHERE `common` = '1'");
			$common_modules = $query->result();
			
			foreach ($common_modules as $common_module){
				$modules[] = $common_module->name;
			}
		
			$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = '$type'");
			if ($query->num_rows()){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("new",2);</script>';
			}
			
			$sql = $this->db->insert_string('permissions',array(
				'user_type'	=> $type,
				'module'	=> implode(',', $modules),
				'action'	=> json_encode($this->input->post('action'))
			));
			
			$this->db->query($sql);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("new",1);</script>';
			
		} else {
			$query = $this->db->query("SELECT * FROM `modules` ORDER BY `common` DESC");
			$this->d['modules'] = $query->result();
			$this->load->view('settings/permission_new_type',$this->d);
		}
	}
	
	function Edit_user_type($id, $do){
		if ($do){
			$type = trim($this->input->post('type'));
			if (!$type) return;
			
			$modules = $this->input->post('modules');

			$query = $this->db->query("SELECT * FROM `modules` WHERE `common` = '1'");
			$common_modules = $query->result();
			
			foreach ($common_modules as $common_module){
				$modules[] = $common_module->name;
			}
			
			$query = $this->db->query("SELECT * FROM `permissions` WHERE `id` = '$id'");
			$permission = $query->row();
			
			if ($permission->super){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("new",2);</script>';
			}
		
			$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = '$type'");
			$type_perm = $query->row();
			if ($query->num_rows() && $type_perm->id != $id){
				echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("new",2);</script>';
			}
			
			$sql = $this->db->update_string('permissions',array(
				'user_type'	=> $type,
				'module'	=> implode(',', $modules),
				'action'	=> json_encode($this->input->post('action'))
			),"`id` = '$id'");
			$this->db->query($sql);
			
			$this->db->query($this->db->update_string('users',array('type'=>$type),"`type`='{$permission->user_type}'"));
			echo '<script language="javascript" type="text/javascript">window.top.window.readyPost("new",1);</script>';

		} else {
			$query = $this->db->query("SELECT * FROM `permissions` WHERE `id` = '$id'");
			$this->d['permission'] = $permission = $query->row();
			
			$query = $this->db->query("SELECT * FROM `modules` ORDER BY `common` DESC");
			$this->d['modules'] = $query->result();
			
			$this->load->view('settings/permission_edit_type',$this->d);
		}
	}
	
	function Delete_user_type($id, $do){
		if ($this->user->has_permission('to_delete','Settings')){
			$this->db->query("DELETE FROM `permissions` WHERE `id` = ?", array($id));
			echo 'ok';
		}
	}
	
	function POS_terminals(){

		$query = $this->db->query("SELECT * FROM `terminals` ORDER BY `name` ASC");
		$this->d['terminals'] = $query->result();		
		
		$this->load->view('settings/pos-terminals',$this->d);
	}
	
	function POS_add($do){

		if ($do == 'do'){
			if (!$this->input->post('name')) return false;
			
			if ($this->input->post('type') == 'Dynamic'){
				$identifier = md5(time());
				$key = md5(time().$this->input->post('type').$this->input->post('name'));
			}
			
			$sql = $this->db->insert_string('terminals',array(
				'type'				=> $this->input->post('type'),
				'ip'				=> $this->input->post('ip'),
				'name'				=> $this->input->post('name'),
				'printer_name'		=> $this->input->post('printer_name'),
				'printer_type'		=> $this->input->post('printer_type'),
				'printer_width'		=> $this->input->post('printer_width'),
				'printer_footer'	=> $this->input->post('printer_footer'),
				'drawer_name'		=> $this->input->post('drawer_name'),
				'display_name'		=> $this->input->post('display_name'),
				'trigger_chars'		=> $this->input->post('trigger_chars'),
				'till_deposit'		=> $this->input->post('till_deposit'),
				'warehouse_id'		=> $this->input->post('warehouse'),
				'pd_welcome1'		=> $this->input->post('pd_welcome1'),
				'pd_welcome2'		=> $this->input->post('pd_welcome2'),
				'pd_thankyou'		=> $this->input->post('pd_thankyou'),
				'identifier'		=> $identifier,
				'key'				=> $key
			));
		
			$this->db->query($sql);
			
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
			
		} else {	
		
			if ($this->system->uses('Inventory') && $this->system->config('warehouse_enabled')){
				$this->load->model('inv');
				$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
			}
			$this->load->view('settings/pos-add', $this->d);

		}
	}
	
	function POS_edit($id, $do){
		if ($do == 'do'){
		
			$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($id));
			$terminal = $query->row();
			
			if ($terminal->type == 'Static' && $this->input->post('type') == 'Dynamic'){
				$identifier = md5(time());
				$key = md5(time().$this->input->post('type').$this->input->post('name'));
			} else {
				$identifier = $terminal->identifier;
				$key = $terminal->key;
			}
		
			$sql = $this->db->update_string('terminals', array(
				'type'				=> $this->input->post('type'),
				'ip'				=> $this->input->post('ip'),
				'name'				=> $this->input->post('name'),
				'printer_name'		=> $this->input->post('printer_name'),
				'printer_type'		=> $this->input->post('printer_type'),
				'printer_width'		=> $this->input->post('printer_width'),
				'printer_footer'	=> $this->input->post('printer_footer'),
				'drawer_name'		=> $this->input->post('drawer_name'),
				'display_name'		=> $this->input->post('display_name'),
				'trigger_chars'		=> $this->input->post('trigger_chars'),
				'till_deposit'		=> $this->input->post('till_deposit'),
				'warehouse_id'		=> $this->input->post('warehouse'),
				'pd_welcome1'		=> $this->input->post('pd_welcome1'),
				'pd_welcome2'		=> $this->input->post('pd_welcome2'),
				'pd_thankyou'		=> $this->input->post('pd_thankyou'),
				'identifier'		=> $identifier,
				'key'				=> $key
			),"`id` = '{$id}'");
			
			$this->db->query($sql);
			
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';

		} else {
		
			if ($this->system->uses('Inventory') && $this->system->config('warehouse_enabled')){
				$this->load->model('inv');
				$this->d['warehouses_dropdown'] = $this->inv->get_warehouses_dropdown(true);
			}

			$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($id));
			$this->d['terminal'] = $query->row();
			$this->load->view('settings/pos-edit', $this->d);

		}
	}
	
	function POS_view($id){
		
		$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($id));
		$this->d['terminal'] = $query->row();
		$this->load->view('settings/pos-view', $this->d);		
	}
	
	function POS_delete($id, $do){
		if ($do == 'do'){
			$this->db->query("DELETE FROM `terminals` WHERE `id` = ?", array($id));
			echo 'ok';
		}
	}
	
	
	function Update(){
		if (!$this->input->post('company_name')) return false;
		
		$config['upload_path'] = '../assets/img/';
		$config['allowed_types'] = 'gif|jpg|png';
		$config['max_size']	= '1024';
		$config['remove_spaces'] = true;
	
		$this->load->library('upload', $config);
		
		if ($this->upload->do_upload('company_logo')){
			$image_data = $this->upload->data('company_logo');
			$logo = $image_data['file_name']; 					
			$this->system->set_config('company_logo',$logo);
		} 

		
		$this->system->set_config('company_name',$this->input->post('company_name'));
		$this->system->set_config('company_reg_no',$this->input->post('company_reg_no'));
		$this->system->set_config('company_tax_no',$this->input->post('company_tax_no'));
		
		$this->system->set_config('company_tel',$this->input->post('company_tel'));
		$this->system->set_config('company_address1',$this->input->post('company_address1'));
		$this->system->set_config('company_address2',$this->input->post('company_address2'));
		$this->system->set_config('company_city', $this->input->post('company_city'));
		$this->system->set_config('company_zipcode', $this->input->post('company_zipcode'));
		$this->system->set_config('company_state', $this->input->post('company_state'));
		$this->system->set_config('company_country', $this->input->post('company_country'));
		
		$this->system->set_config('company_address',$this->input->post('company_address'));
		$this->system->set_config('company_contact', $this->input->post('company_contact'));
		$this->system->set_config('company_divisions', $this->input->post('company_divisions'));
		
		$this->system->set_config('currency', $this->input->post('currency'));
		
		$this->system->set_config('plexcloud_id', $this->input->post('plexcloud_id'));
		$this->system->set_config('plexcloud_key', $this->input->post('plexcloud_key'));

		$this->system->set_config('plexcenter_branch_code', $this->input->post('plexcenter_branch_code'));
		$this->system->set_config('plexcenter_branch_key', $this->input->post('plexcenter_branch_key'));
		$this->system->set_config('plexcenter_branch_url', $this->input->post('plexcenter_branch_url'));
		$this->system->set_config('plexcenter_date', $this->input->post('plexcenter_date'));
		
 		echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
	}
	
	function System_settings(){
		$this->load->view('settings/system',$this->d);
	}
	
	function Backup(){
		$this->load->view('settings/backup');
	}
	
	function Restore_backup(){
		$config['upload_path'] = '../assets/backup/';
		$config['allowed_types'] = array('sql','est');
		$config['max_size']	= '100000';
		
		$this->load->library('upload', $config);
		$this->load->helper('file');
	
		if (!$this->upload->do_upload('file')){
			$error = array('error' => $this->upload->display_errors());
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(0);</script>';
			echo print_r($error);
		} else {
			$data = $this->upload->data('file');
			$sql = read_file($data['full_path']);

			$query_array = explode(";", $sql);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
//			echo "<pre>";
			foreach($query_array as $qr){
				$qr = str_replace("\n",'',$qr);
				if (trim($qr[0]) == '#'){
					list($useless, $drop_statement) = explode('DROP',$qr);
//					echo 'DROP' . $drop_statement . "\n";
					$this->db->query('DROP' . $drop_statement);
				} else {
//					echo $qr . "\n";
					$this->db->query($qr); 
				}
			}


		}
		
		

	}
	
	

	
	function Ajax($request){
		switch ($request){
			
			case "shipping_rate":
				$service = $this->input->post('service');
				$country = $this->input->post('country');
				$zipcode = $this->input->post('zipcode');
				
				$service_rate = $this->shipping->get_shipping_rate_by_scz($service, $country, $zipcode);
				echo json_encode($service_rate);
			
			break;
			
		}
	}
	
	function Backup_current(){
		// Load the DB utility class
		$this->load->dbutil();
		
		$prefs = array(
                'format'      => 'gzip',             // gzip, zip, txt
                'filename'    => date('Ymd_His_').'BACKUP.gzip',    // File name - NEEDED ONLY WITH ZIP FILES
                'add_drop'    => TRUE,              // Whether to add DROP TABLE statements to backup file
                'add_insert'  => TRUE,              // Whether to add INSERT data to backup file
                'newline'     => "\n"               // Newline character used in backup file
              );
		
		// Backup your entire database and assign it to a variable
		$backup =& $this->dbutil->backup($prefs); 
		
		// Load the file helper and write the file to your server
		$this->load->helper('file');
		write_file('../assets/backup/'.date('Ymd_His_').'BACKUP.gzip', $backup); 
		
		// Load the download helper and send the file to your desktop
		$this->load->helper('download');
		force_download(date('Ymd_His_').'BACKUP.gzip', $backup);
	}
	
	function Software_update(){
		$this->load->view('settings/software-update');
	}
	
	function Check_software_update(){
		$contents = file_get_contents('http://plexsol.plexcloud.com/versions/info');
		$versions = explode("\n", $contents);
		$latest_version = $versions[count($versions)-1];
		
		$data = explode('|',$latest_version);
		if ($this->system->config('version') != str_replace('V','',$data[1])){
		
			$json->status 	= 'Available';
			$json->version	= $data[1];
			$json->name		= $data[2];
			$json->hash		= $data[3];
			$json->date		= date('d/m/Y',strtotime($data[0]));
			
			
		} else {
			
			$json->status 	= 'Up-to-date';
			
		}
		
		echo json_encode($json);
	}
	
	function Software_update_changelog(){
		$ver = $this->input->post('version');
		$contents = file_get_contents('http://plexsol.plexcloud.com/versions/changelog/'.$ver);
		echo $contents;
	}
	
	function Branch(){
		$this->d['branches'] = $this->system->get_branches("1=1 ORDER BY `name` ASC LIMIT 100"); 
		$this->load->view('settings/branch', $this->d);
	}
	
	function Branch_add($do){
		if ($do == 'do'){
			$this->system->add_branch();
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {

			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true,'Stakeholder,Franchise');
			$this->load->view('settings/branch-add', $this->d);
		}
	}
	
	function Branch_edit($id, $do){
		if ($do == 'do'){
			$this->system->edit_branch($id);
			echo '<script language="javascript" type="text/javascript">window.top.window.readyAdd(1);</script>';
		} else {
			$this->d['branch'] = $this->system->get_branch_by_id($id);
			$this->d['contacts_dropdown'] = $this->contact->contacts_dropdown(true,'Stakeholder,Franchise');
			$this->load->view('settings/branch-edit', $this->d);
		}
	}
	
	function Branch_delete($id, $do){
		if ($do == 'do'){
			$this->system->delete_branch($id);
			echo 'ok';
		}
	}
	
}