<?php

class Sys extends Controller {

	function Sys(){
		parent::Controller();
	}
	
	function Index(){
		$this->d['license'] = $license = json_decode($this->system->config('license'));
		
		if ($license->type == 'Lease'){
			$this->d['subscriptions'] = $this->system->get_lease_subscriptions();
		}

		$this->load->view('info',$this->d);
	}
	
	
	
	
	function Update_item_cost($item_id){
		$this->load->model('inv');
		
		$query = $this->db->query("SELECT `date`, `received` AS `qty`, 'in' AS `type`, `received_price` AS `amount` FROM `purchase_order_items` WHERE `item_id` = ? AND `received` > 0 UNION
							SELECT `date`, `qty`, 'out' AS `type`,`cost` AS `amount` FROM `sale_items` WHERE `item_id` = ? AND `sold` = '1' UNION
							SELECT `date`, `delivered` AS `qty`, 'out' AS `type`, `cost` AS `amount` FROM `invoice_items` WHERE `item_id` = ? AND `delivered` > 0 UNION
							SELECT `date`, `received` AS `qty`, 'out' AS `type`, `received_price` AS `amount` FROM `debit_note_items` WHERE `item_id` = ? AND `received` > 0
							ORDER BY `date` ASC", array($item_id, $item_id, $item_id, $item_id));
			
		$x = 0;

		foreach ($query->result() as $inout){
			$x++;
	    	if ($inout->type == 'in'){
	    		echo 'IN: ' . $inout->qty . ' VALUE: ' . $inout->amount . ' COST: ' . number_format($inout->amount / $inout->qty, 4) . '<br />';
	    		$cur_quantity += $inout->qty;
	    		$in_cost = $inout->amount;
	    		$value += $in_cost;
	    	} else {
	    		echo 'OUT: ' . $inout->qty . ' VALUE: ' . $inout->amount . ' COST: ' . number_format($inout->amount / $inout->qty, 4) . '<br />';
	    		$cur_quantity -= $inout->qty;
	    		$out_cost = $inout->amount;
	    		$value -= $out_cost;
	    	}
	    }

	    
	    // Average cost update
	    $this->db->query("UPDATE `inventory` SET `average_cost` = ? WHERE `id` = ?", array($value/$cur_quantity, $item_id));
	
	    $method = $this->system->config('cost_update_method');
	    
	    
	    if ($method == 'average'){
			$this->db->query("UPDATE `inventory` SET `cost` = ? WHERE `id` = ?", array($value/$cur_quantity, $item_id));
    	} elseif ($method == 'fifo'){
    		$this->inv->check_fifo_cost($item_id);
    	} elseif ($method == 'lifo'){
    		// get from last purchase order
    		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? ORDER BY `date` DESC", array($item_id));
    		$po_item = $query->row();
    		
    		$this->db->query("UPDATE `inventory` SET `cost` = ? WHERE `id` = ?", array($po_item->price_per_unit, $item_id));    		
    	}
	}

	
	function Transfer_cost_to_offset(){
		$query = $this->db->query("SELECT * FROM `inventoryxxx`");
		foreach ($query->result() as $item){
			$this->db->query("UPDATE `purchase_order_items` SET `received_price` = `received` * {$item->cost} WHERE `item_id` = ? AND `purchase_order_id` = 0", array($item->id));
		}	
		echo 'OK!';
	}
	
	function Transfer_cost(){
		$query = $this->db->query("SELECT * FROM `inventoryxxx`");
		foreach ($query->result() as $item){
			echo $item->name . ' ' . $item->cost . '<br />';
			$this->db->update('inventory', array(
				'cost'			=> $item->cost,
				'average_cost'	=> $item->cost
			), "`id` = '{$item->id}'");
			
		}
		echo 'OK!';
		
	}
	
	
	function Terminal(){
		$thid->d['title'] = 'Terminal';
		$this->load->view('plexterm', $this->d);
	}
	
	function Term(){
		$this->load->model('inv');
		$this->load->model('plexterm');
		
		$cmd = $this->input->post('cmd');
		$cmd_tokens = explode(' ', $cmd);
		foreach ($cmd_tokens as $token){
			if ($token) $tokens[] = $token;
		}

		echo '<div class="output"><pre>';
		
		if (method_exists($this->plexterm, $tokens[0])){
			$this->plexterm->{$tokens[0]}($tokens,$cmd);
		} else {
			echo '<b>Command not found.</b>';
		}
				
		echo '</pre></div>';
	}
	
	function License_error(){
		if ($this->system->validate_license()) redirect('sys');

		$this->d['title'] = "License Error";
		$this->d['error'] 	= "License Error";
		$this->d['message'] = "License could not be validated. Please contact your vendor for support.";
		$this->load->view('error', $this->d);
	}
	
	function License_setup(){
		if ($this->system->license_setup()) redirect('sys');
		
		$this->d['title'] = "License Error";
		$this->d['error'] 	= "License Error";
		$this->d['message'] = "No licensing was configured for this server system. Please contact your vendor for support.";
		$this->load->view('error', $this->d);
	}
	
	function License_renewal_notice(){
		$this->d['license'] = json_decode($this->system->config('license'));
		
		$last_active_sub = $this->system->last_active_lease();
		
		if ($sub = $this->system->current_lease()){
			$new_sub = $this->system->get_lease_by_id($sub->id + 1);
			$this->d['subscription'] = $new_sub;
		} else {
			$this->d['dateerror'] = true;
		}
		
		$to_date = date('d/m/Y',strtotime($last_active_sub->to_date));
	
		$this->d['title'] = "License Error";
		$this->d['error'] 	= "License Expiring";
		
		
		
		$this->d['message'] = "Your license will expire on <strong>{$to_date}</strong>. Please obtain your subscription key from your vendor to avoid disruption. <a href=\"".base_url()."\">Renew Later</a>";
			
		$this->load->view('license', $this->d);
	}
	
	function License_renewal($do){
		$this->d['license'] = json_decode($this->system->config('license'));
		

		
		if ($sub = $this->system->current_lease()){
			$this->d['subscription'] = $sub;
		} else {
			$this->d['dateerror'] = true;
		}
		
		if ($sub->status == 'Active'){
			redirect();
		}
				
		if ($do == 'do'){
		
			$license_key = $this->input->post('license_key');
			$hash = pcrypt_encode($sub->from_date, $license_key);
			$hash_compare = $hash[0] . $hash[1] . $hash[2] . $hash[3] . $hash[4] . $hash[5] . $hash[6] . $hash[7] . $hash[9] . $hash[11] . $hash[12] . $hash[15];
			
			if ($sub->hash == strtoupper($hash_compare)){
			
				$this->system->activate_lease($sub->id, $license_key);
				
				$from = date('d/m/Y',strtotime($sub->from_date));
				$to = date('d/m/Y',strtotime($sub->to_date));
			
				$this->d['title'] = "License Error";
				$this->d['error'] 	= "License Renewed";
				$this->d['message'] = "Subscription from <strong>{$from}</strong> to <strong>{$to}</strong> has been activated. Go to <a style=\"font-weight: bold\" href=\"".base_url()."\">Plexcloud Backend</a>";
				$this->load->view('error', $this->d);
				
			} else {

				$this->d['title'] = "License Error";
				$this->d['error'] 	= "License Error";
				$this->d['message'] = "Your license has expired. Please obtain your subscription key from your vendor.";
				$this->d['invalid'] = true;

				$this->load->view('license', $this->d);
				
			}
		
		} else {
		
			$this->d['title'] = "License Error";
			$this->d['error'] 	= "License Error";
			$this->d['message'] = "Your license has expired. Please obtain your subscription key from your vendor.";
			
			$this->load->view('license', $this->d);
		
		}
	}
	
	function Get_city_list(){
		$country = $this->input->post('country');
		$query = $this->db->query("SELECT * FROM `states` WHERE `country` = ? ORDER BY `state` ASC",array($country));
		
		foreach ($query->result() as $city){
			$html .= "<option value=\"{$city->state}\">{$city->state}</option>";
		}
		echo $html;
	}
	
	function Check_sql_tables(){
	
		
		$db = $this->db->database;
		$query = $this->db->query("SHOW TABLES IN {$db}");
		$current_tables = $query->result();		
		
		echo "<pre>";
		
		
		foreach ($current_tables as $table_result){
			$current_table = $table_result->{'Tables_in_'.$db};
			$query = $this->db->query("SHOW COLUMNS IN {$db}.{$current_table}");
			$columns = $query->result();
			foreach ($columns as $column){
				$table_columns[$current_table][$column->Field] = $column;
				$existing_tables[$current_table] = 1;
			}
		}
		
		
		$this->load->helper('file');
		$sql = read_file('./sql/tables.sql');
						
		$context = str_replace("CREATE", "\nCREATE", str_replace("\n","",$sql));
		$statements = explode("\n", $context);
		
		$clean = true;
		foreach ($statements as $statement){
			if (trim($statement)){
				preg_match_all('/.*CREATE\s+TABLE\s+`(\S+)`\s*\((.*)\).*/', $statement, $matches);
				$table = trim($matches[1][0]);
				if ($table){
									
					
					if (!$existing_tables[$table]){
					
						echo $table . ' NOT FOUND' . "\n";
						echo '   SQL: ' . $matches[0][0] . "\n";
						$this->db->query($matches[0][0]);
						echo '   QUERY EXECUTED' . "\n\n";
				
						$clean = false;		
						
					} else {
				
						$cols_line = preg_split('/,(?![^\(\)]*\))/', $matches[2][0]);
						foreach ($cols_line as $col_line){
							if (preg_match("/PRIMARY\s+KEY.*/", $col_line)){
								// primary key
								
								
							} else {
								// column
								preg_match('/`(\w+)`\s+(.*)/', $col_line, $coldata_matches);
								$field = $coldata_matches[1];
								$attr = $coldata_matches[2];
								
								
								if (!is_object($table_columns[$table][$field])){
									echo $table . '.' . $field . ' NOT FOUND' . "\n";
									echo '   ATTR: ' . $attr . "\n";
									
									echo '   SQL: ' . "ALTER TABLE `{$table}` ADD `{$field}` {$attr} AFTER `{$last_field}` \n";
									$this->db->query("ALTER TABLE `{$table}` ADD `{$field}` {$attr} AFTER `{$last_field}`");
									echo '   QUERY EXECUTED' . "\n\n";
									$clean = false;
								}
								
								$last_field = $field;
								
							}
						}
					}
					
				}

			}
		}
		
		if ($clean){
			echo 'DATABASE TABLES OK!';
		}
		
	}
	
	function Test_grid(){
		$this->load->view('header');
		$this->load->view('sys/test_grid');
		$this->load->view('footer');
	}

}