<?php 

class Account extends Model {

	function Account(){
		parent::Model();
	}

	function Get_default_bank_account(){
		$account = $this->get_account("`default` = '1' ORDER BY `id` ASC");
		return $account;
	}

	function Cash_postable_account_list(){
		$accounts = $this->get_accounts("`cash_postable` = 1 ORDER BY `id` ASC");		

		foreach ($accounts as $account){
			$accounts_array[$account->id] = $account->name;		
		}
		return $accounts_array;
	}
	
	function Delete_account($id){
		$this->db->query("DELETE FROM `account` WHERE `id` = ?", array($id));
	}

	function Get_accounts($filter = null){
		if ($filter) $filter_string = " WHERE " . $filter;
		$query = $this->db->query("SELECT * FROM `account` {$filter_string}");
		return $query->result();
	}

	function Get_account($filter = null){
		if ($filter) $filter_string = " WHERE " . $filter;
		$query = $this->db->query("SELECT * FROM `account` {$filter_string}");
		return $query->row();
	}
	
	function Get_account_by_id($id){
		$query = $this->db->query("SELECT * FROM `account` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Get_account_type($id){
	
	}
	
	function Get_journal($date_from, $date_to){
		$query = $this->db->query("SELECT * FROM `account_transactions` WHERE `date` >= ? AND `date` <= ?", array($date_from, $date_to));
		return $query->result();
	}
	
	

	function Get_account_debit_balance($date,$account_id){
		$query = $this->db->query("SELECT SUM(`amount`) AS `total_debit` FROM `account_transactions` WHERE `date` <= ? AND `account_id` = ? AND `type` = 'DR' GROUP BY `id`",array($date,$account_id));
		$txn_dr = $query->row();

		return $txn_dr->total_debit;
	}
	
	function Get_account_credit_balance($date,$account_id){
		$query = $this->db->query("SELECT SUM(`amount`) AS `total_credit` FROM `account_transactions` WHERE `date` <= ? AND `account_id` = ? AND `type` = 'CR' GROUP BY `id`",array($date,$account_id));
		$txn_cr = $query->row();

		return $txn_cr->total_credit;
	}

	 
	
	function Get_account_total($from,$to,$account_id){

		$query = $this->db->query("SELECT SUM(`amount`) AS `total_debit` FROM `account_transactions` WHERE `date` >= ? AND `date` <= ? AND `id` = ? AND `type` = 'DR' GROUP BY `id`",array($from,$to,$account_id));
		$txn_dr = $query->row();

		$query = $this->db->query("SELECT SUM(`amount`) AS `total_credit` FROM `account_transactions` WHERE `date` >= ? AND `date` <= ? AND `id` = ? AND `type` = 'CR' GROUP BY `id`",array($from,$to,$account_id));
		$txn_cr = $query->row();
		
		return $txn_dr->total_debit - $txn_cr->total_credit;
	
	}
	
	function Get_header_accounts($type,$division){
		$query = $this->db->query("SELECT * FROM `account` WHERE `is_header` = 1 AND `type` = ? ",array($type));
		return $query->result();
	}
	
	function Get_accounts_by_header($header, $type, $division){
		$query = $this->db->query("SELECT * FROM `account` WHERE `header` = ? AND `type` = ?",array($header, $type));
		return $query->result();
	}
	
	function Get_other_accounts($type,$division){
		$query = $this->db->query("SELECT * FROM `account` WHERE `header` = '' AND `type` = ?",array($type));
		return $query->result();
	}
	
	function Get_beginning_inventory($date_from, $date_to){
			
	}

	function Get_ending_inventory($date_from, $date_to){

	}

	function Get_purchases($date_from, $date_to){
		$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `date` >= ? AND `date` <= ? AND `payment_status` = ?", array($from, $to, 'Paid'));
		return $query->result();
		
	}
	
	function Get_expenses($date_from, $date_to){
		$query = $this->db->query("SELECT * FROM `account_transactions` WHERE `date` >= ? AND `date` <= ? AND `type` = 'Expense'");
		return $query->result();
	}
	
	function Get_receivables($to_date){
		$query = $this->db->query("SELECT * FROM `invoices` WHERE `date` <= ? AND `payment_status` = ?", array($to_date, 'Unpaid'));
		return $query->result();
	}
	
	function Get_payables($to_date){
		$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `date` <= ? AND `payment_status` = ?", array($to_date, 'Unpaid'));
		return $query->result();
	}
	
	function Get_receivable_amount($to_date){
		$query = $this->db->query("SELECT SUM(`amount`) AS `total` FROM `purchasse_orders` WHERE `date` <= ? AND `payment_status` = ?", array($to_date, 'Unpaid'));
		$row = $query->row();
		
		return $row->total;
	}
	
	function Get_payable_amount($to_date){
		$query = $this->db->query("SELECT SUM(`amount`) AS `total` FROM `invoices` WHERE `date` <= ? AND `payment_status` = ?", array($to_date, 'Unpaid'));
		$row = $query->row();
		
		return $row->total;
	}
	
	function Get_payment_vouchers($where){
		if ($where){
			$query = $this->db->query("SELECT * FROM `payment_vouchers` WHERE {$where}");
		} else {
			$query = $this->db->query("SELECT * FROM `payment_vouchers` ORDER BY `id` DESC");
		}
		
		return $query->result();
	}
	

	function Get_pv_by_id($id){

		$query = $this->db->query("SELECT * FROM `payment_vouchers` WHERE `id` = ?", array($id));
		$pv = $query->row();
		
		$query = $this->db->query("SELECT * FROM `payment_voucher_items` WHERE `pv_id` = ?", array($pv->id));
		$pv->items = $query->result();
		
		$query = $this->db->query("SELECT * FROM `payment_voucher_breakdown` WHERE `pv_id` = ?", array($pv->id));
		$pv->breakdown = $query->result();
		
		return $pv;
	
	}
	

	
	function New_payment_voucher(){
		$type = $this->input->post('type');
		
		if ($type == 'Expense'){
			$account_id = $this->input->post('account');
			$account = $this->get_account_by_id($account_id);
		} else if ($type == 'Purchase of Stock'){
			$contact_id = $this->input->post('contact');
			$contact = $this->contact->get_contact_by_id($contact_id);
		} else if ($type == 'Purchase of Asset'){
			$account_id = $this->input->post('asset_account');
			$account = $this->get_account_by_id($account_id);
		}
		
		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;
		
		if ($type == 'Expense'){
			$tax_code 	= $this->input->post('tax_code');
			$tax		= $this->input->post('tax');
		}
		
		if ($type == 'Purchase of Asset'){
			$tax_code 	= $this->input->post('tax_code');
			$tax		= $this->input->post('tax');			
		}

		$pv_id = $this->input->post('pv_id');
		
		
		$contact = $contact->company_name ? $contact->company_name : $contact->contact_person;
		if (!$contact) $payee = $this->input->post('payee');
		
		$txn_no = $this->input->post('txn_no');
		
		$data = array(
			'txn_no'		=> $txn_no,
			'payee'			=> $payee,
			'datetime'		=> $date,
			'account'		=> $account->name,
			'account_id'	=> $account->id,
			'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
			'contact_id'	=> $contact->id,
			'type'			=> $type,
			'status'		=> 'Issued',
			'tax_code'		=> $tax_code,
			'tax'			=> $tax,
			'added_on'		=> date('Y-m-d H:i:s'),
			'added_by'		=> $this->user->data('username')
		);
	
		if ($pv_id){
			$data['id'] = $pv_id;
			$this->db->query("DELETE FROM `payment_vouchers` WHERE `id` = ?", array($pv_id));
			$this->db->query("DELETE FROM `payment_voucher_items` WHERE `pv_id` = ?", array($pv_id));
			$this->db->query("DELETE FROM `payment_voucher_breakdown` WHERE `pv_id` = ?", array($pv_id));
		}
		
		$query = $this->db->insert('payment_vouchers',$data);			
			
		$pv_id = $query->insert_id;
		
		
		if ($type == 'Expense'){
			
			$reference_no 	= $this->input->post('reference_no');
			$amount			= $this->input->post('expense_amount');
			$amount_payable	= $this->input->post('expense_amount_payable');	
					
			for ($i = 0; $i < count($reference_no); $i++){
				$sql = $this->db->insert('payment_voucher_items',array(
					'txn_no'		=> $txn_no,
					'pv_id'			=> $pv_id,
					'account_id'	=> $account->id,
					'account'		=> $account->name,
					'reference'		=> $reference_no[$i],
					'datetime'		=> $date,
					'amount'		=> $amount[$i],
					'amount_payable'=> $amount_payable[$i],
					'tax_code'		=> $this->input->post('tax_code'),
					'status'		=> 'Issued'
				));
				
				
				$total_amount += $amount[$i];
			}

		} elseif ($type == 'Purchase of Asset'){
			
			$assets = $this->asset->add_multiple($pv_id, $account_id);
			
			foreach ($assets as $asset){
				$sql = $this->db->insert_string('payment_voucher_items',array(
					'txn_no'		=> $txn_no,
					'pv_id'			=> $pv_id,
					'account_id'	=> $account->id,
					'account'		=> $account->name,
					'reference'		=> $reference_no,
					'asset_id'		=> $asset->id,
					'amount'		=> $asset->cost,
					'datetime'		=> $asset->acquisition_date,
					'tax_code'		=> $this->input->post('tax_code'),
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount += $asset->cost;
			}
			
			$total_amount += $tax;
			
			
		} else {
		
			$po_ids	= $this->input->post('po_id');
			$cn_ids = $this->input->post('cn_id');
			$dn_ids = $this->input->post('dn_id');
			$invoice_ids = $this->input->post('invoice_id');
			
			$po_amount = $this->input->post('po_amount');
			$cn_amount = $this->input->post('cn_amount');
			$dn_amount = $this->input->post('dn_amount');
			$invoice_amount = $this->input->post('invoice_amount');


			$x = 0;
			
			
			foreach ($po_ids as $po_id){
				$amount = $po_amount[$x];
				$x++;
				
				$po = $this->inv->get_po_by_id($po_id);

				$sql = $this->db->insert_string('payment_voucher_items',array(
					'txn_no'		=> $txn_no,
					'pv_id'			=> $pv_id,
					'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
					'contact_id'	=> $contact->id,
					'po_id'			=> $po_id,
					'datetime'		=> date('Y-m-d H:i:s'),
					'amount'		=> $xamount = $amount,
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount += $xamount;
				
				
				if ($po->total_received == $this->Get_paid_amount('po',$po->id)){
					$this->inv->po_set_paid($po->id, date('Y-m-d H:i:s'), $pv_id);
				}
			}
			
			
			$x = 0;
			foreach ($cn_ids as $cn_id){
				$amount = $cn_amount[$x];
				$x++;

				$cn = $this->sale->get_cn_by_id($cn_id);

				$sql = $this->db->insert_string('payment_voucher_items',array(
					'txn_no'		=> $txn_no,
					'pv_id'			=> $pv_id,
					'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
					'contact_id'	=> $contact->id,
					'cn_id'			=> $cn_id,
					'datetime'		=> date('Y-m-d H:i:s'),
					'amount'		=> $xamount = $amount,
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount += $xamount;
				
				if ($cn->total_received == $this->Get_paid_amount('cn',$cn->id)){
					$this->sale->cn_set_paid($cn->id, date('Y-m-d H:i:s'), $pv_id);
				}
			}
			
			
			$x = 0;
			foreach ($invoice_ids as $invoice_id){
				$amount = $invoice_amount[$x];
				$x++;
				
				$invoice = $this->sale->get_invoice_by_id($invoice_id);

				$sql = $this->db->insert_string('payment_voucher_items',array(
					'txn_no'		=> $txn_no,
					'pv_id'			=> $pv_id,
					'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
					'contact_id'	=> $contact->id,
					'invoice_id'	=> $invoice_id,
					'datetime'		=> date('Y-m-d H:i:s'),
					'amount'		=> $xamount = $amount,
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount -= $xamount;
				
				if ($invoice->total_delivered == $this->Get_paid_amount('invoice',$invoice->id)){
					$this->sale->invoice_set_paid($invoice->id, date('Y-m-d H:i:s'), NULL, $pv_id);
				}
			}
			
			$x = 0;
			foreach ($dn_ids as $dn_id){
				$amount = $dn_amount[$x];
				$x++;

				$dn = $this->inv->get_dn_by_id($dn_id);

				$sql = $this->db->insert_string('payment_voucher_items',array(
					'txn_no'		=> $txn_no,
					'pv_id'			=> $pv_id,
					'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
					'contact_id'	=> $contact->id,
					'dn_id'			=> $dn_id,
					'datetime'		=> date('Y-m-d H:i:s'),
					'amount'		=> $xamount = $amount,
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount -= $xamount;
				
				if ($dn->total_received == $this->Get_paid_amount('dn',$dn->id)){
					$this->inv->dn_set_paid($dn->id, date('Y-m-d H:i:s'), NULL, $pv_id);
				}
			}
			
			
		}
		

		$account_from 		= $this->input->post('account_from');
		$breakdown_amount 	= $this->input->post('breakdown_amount');
		$breakdown_ref		= $this->input->post('breakdown_reference');
		$payment_method		= $this->input->post('payment_method');
	
		for ($i = 0; $i < count($account_from); $i++){
			$account_id = $account_from[$i];
			$account = $this->get_account_by_id($account_id);
			$amount = $breakdown_amount[$i];
		
			$sql = $this->db->insert_string('payment_voucher_breakdown', array(
				'txn_no'		=> $txn_no,
				'pv_id'			=> $pv_id,
				'datetime'		=> date('Y-m-d H:i:s'),
				'account'		=> $account->name,
				'account_id'	=> $account->id,
				'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
				'contact_id'	=> $contact->id,
				'payment_method'=> $payment_method[$i],
				'payment_reference'	=> $breakdown_ref[$i],
				'amount'		=> $amount,
				'status'		=> 'Issued'
			));
			
			$paid_amount += $amount;
		
			$this->db->query($sql);
		}
		
		if ($paid_amount > $total_amount){
			// generate debit note
			
			$address->address1	= $contact->address1;
			$address->address2	= $contact->address2;
			$address->zipcode	= $contact->zipcode;
			$address->city		= $contact->city;
			$address->state		= $contact->state;
			$address->country	= $contact->country;
			
			$total = $paid_amount - $total_amount;

			
			$this->db->insert('debit_notes',array(
				'txn_no'			=> $this->inv->serial_no('debit_notes'),
				'date'				=> $date,
				'terms'				=> 'Credit',
				'cn_number'			=> '',
				'supplier'			=> $contact->company_name ? $contact->company_name : $contact->contact_person,
				'supplier_id'		=> $contact->id,
				'supplier_address'	=> json_encode($address),
				'contact_person'	=> '',
				'status'			=> 'Pending',
				'remarks'			=> 'Overpaid for PV-'.$pv_id,
				'adjustment'		=> '',
				'adjustment_type'	=> '',
				'handling_charges'	=> '',
				'total'				=> $total,
				'tags'				=> '',
				'added_on'			=> date('Y-m-d H:i:s'),
				'added_by'			=> $this->user->data('username'),
				'payment_status'	=> 'Unpaid',
				'warehouse_id'		=> $this->user->data('branch')
			));
			
			$g_dn_id = $this->db->insert_id();
			
			$this->db->insert('debit_note_items', array(
				'debit_note_id'		=> $g_dn_id,
				'date'				=> $date,
				'item_id'			=> 0,
				'item_name'			=> 'Overpaid for PV-'.$pv_id,
				'item_description'	=> '',				
				'qty'				=> 1,
				'price'				=> $total,
				'price_per_unit'	=> $total,
				'discount_type'		=> '',
				'discount'			=> '',
				'warehouse_id'		=> $this->user->data('branch')
			));
			
			
			$sql = $this->db->insert_string('payment_voucher_items',array(			
				'txn_no'		=> $txn_no,
				'pv_id'			=> $pv_id,
				'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
				'contact_id'	=> $contact->id,
				'dn_id'			=> $g_dn_id,
				'datetime'		=> date('Y-m-d H:i:s'),
				'amount'		=> $total,
				'status'		=> 'Generated'
			));
		}

		$this->db->update('payment_vouchers', array(
			'amount'	=> $total_amount
		),"`id` = '{$pv_id}'");
		
		return $this->get_pv_by_id($pv_id);

	}
	
	function Get_pv_by_contact($id, $date_from, $date_to){
		$query = $this->db->query("SELECT SUM(`amount`) AS `balance` FROM `payment_vouchers` WHERE `status` = 'Issued' AND `contact_id` = ?  AND `datetime` < ? GROUP BY `contact_id`", array($id, $date_from));
		$opening = $query->row();

		$query = $this->db->query("SELECT * FROM `payment_vouchers` WHERE `contact_id` = ? AND `status` = 'Issued' AND `datetime` >= ? AND `datetime` <= ?", array($id, $date_from, $date_to));
		$pvs = $query->result();
		
		$txn->opening_balance = $opening->balance;
		$txn->pvs = $pvs;
		
		return $txn;

	}

	function Get_receipts_by_contact($id, $date_from, $date_to){
		$query = $this->db->query("SELECT SUM(`amount`) AS `balance` FROM `receipts` WHERE `status` = 'Issued' AND `contact_id` = ?  AND `datetime` < ? GROUP BY `contact_id`", array($id, $date_from));
		$opening = $query->row();

		$query = $this->db->query("SELECT * FROM `receipts` WHERE `contact_id` = ? AND `status` = 'Issued' AND `datetime` >= ? AND `datetime` <= ?", array($id, $date_from, $date_to));
		$receipts = $query->result();
		
		$txn->opening_balance = $opening->balance;
		$txn->receipts = $receipts;
		
		return $txn;

	}

	
	function Get_receipts($where){
		if ($where){
			$query = $this->db->query("SELECT * FROM `receipts` WHERE {$where}");
		} else {
			$query = $this->db->query("SELECT * FROM `receipts` ORDER BY `id` DESC");
		}
		return $query->result();
	}
	
	function New_receipt(){
		$type = $this->input->post('type');
		
		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;
		
		
		$po_amount = $this->input->post('po_amount');
		$cn_amount = $this->input->post('cn_amount');
		$dn_amount = $this->input->post('dn_amount');
		$invoice_amount = $this->input->post('invoice_amount');
		
		$receipt_id = $this->input->post('receipt_id');

		if ($type == 'Income (Non-Sales)'){
			$account_id = $this->input->post('account');
			$account = $this->get_account_by_id($account_id);
			
			$tax_code		= $this->input->post('tax_code');
			$tax			= $this->input->post('tax');


		} else if ($type == 'Income (Sales)'){
			$contact_id = $this->input->post('contact');
			$contact = $this->contact->get_contact_by_id($contact_id);
		}
		
		
		$txn_no = $this->input->post('txn_no');
		

		$data = array(
			'txn_no'		=> $txn_no,
			'datetime'		=> $date,
			'account'		=> $account->name,
			'account_id'	=> $account->id,
			'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
			'contact_id'	=> $contact->id,
			'type'			=> $type,
			'tax_code'		=> $tax_code,
			'tax'			=> $tax,
			'status'		=> 'Issued',
			'added_on'		=> date('Y-m-d H:i:s'),
			'added_by'		=> $this->user->data('username')
		);

		
		if ($receipt_id){
			$data['id'] = $receipt_id;
			$this->db->query("DELETE FROM `receipts` WHERE `id` = ?", array($receipt_id));
			$this->db->query("DELETE FROM `receipt_items` WHERE `receipt_id` = ?", array($receipt_id));
			$this->db->query("DELETE FROM `receipt_breakdown` WHERE `receipt_id` = ?", array($receipt_id));
		}
		
		$sql = $this->db->insert_string('receipts',$data);
		
		$query = $this->db->query($sql);
		
		$receipt_id = $query->insert_id;
		
		$type = $this->input->post('type');
		
		
		if ($type == 'Income (Non-Sales)'){
			
			$reference_no 	= $this->input->post('reference_no');
			$amount			= $this->input->post('income_amount');
			
			for ($i = 0; $i < count($reference_no); $i++){
				$sql = $this->db->insert_string('receipt_items',array(
					'txn_no'		=> $txn_no,
					'receipt_id'	=> $receipt_id,
					'account_id'	=> $account->id,
					'account'		=> $account->name,
					'reference'		=> $reference_no[$i],
					'datetime'		=> $date,
					'amount'		=> $amount[$i],
					'status'		=> 'Issued'
				));
				$this->db->query($sql);
				
				$total_amount += $amount[$i];
			}

		} elseif ($type == 'Disposal of Asset'){
			
			$assets = $this->asset->dispose_multiple($receipt_id);
			
			foreach ($assets as $asset){
				$sql = $this->db->insert_string('receipt_items',array(
					'txn_no'		=> $txn_no,
					'receipt_id'	=> $receipt_id,
					'asset_id'		=> $asset->id,
					'amount'		=> $asset->cost,
					'datetime'		=> date('Y-m-d H:i:s')
				));
				
				$this->db->query($sql);
				
				$total_amount += $aset->cost;
			}
			
			
			
		} else {
		
			$po_ids	= $this->input->post('po_id');
			$cn_ids = $this->input->post('cn_id');
			$dn_ids = $this->input->post('dn_id');
			$invoice_ids = $this->input->post('invoice_id');
			
			$x = 0;
			foreach ($invoice_ids as $invoice_id){
				$invoice = $this->sale->get_invoice_by_id($invoice_id);
				
				$amount = $invoice_amount[$x];
				$x++;
				
				$sql = $this->db->insert_string('receipt_items',array(
					'txn_no'		=> $txn_no,
					'receipt_id'	=> $receipt_id,
					'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
					'contact_id'	=> $contact->id,
					'invoice_id'	=> $invoice_id,
					'datetime'		=> $date,
					'amount'		=> $xamount = $amount,
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount += $xamount;
				
				if ($invoice->total_delivered == $this->Get_paid_amount('invoice',$invoice->id)){
					$this->sale->invoice_set_paid($invoice->id, date('Y-m-d H:i:s'), $receipt_id);
				}
			}
			
			$x = 0;
			foreach ($dn_ids as $dn_id){

				$dn = $this->inv->get_dn_by_id($dn_id);
				
				$amount = $dn_amount[$x];
				$x++;

				$sql = $this->db->insert_string('receipt_items',array(
					'txn_no'		=> $txn_no,
					'receipt_id'	=> $receipt_id,
					'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
					'contact_id'	=> $contact->id,
					'dn_id'			=> $dn_id,
					'datetime'		=> date('Y-m-d H:i:s'),
					'amount'		=> $xamount = $amount,
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount += $xamount;
				
				if ($dn->total_received == $this->Get_paid_amount('dn', $dn->id)){
					$this->inv->dn_set_paid($dn->id, date('Y-m-d H:i:s'), $receipt_id);
				}
			}
			
			$x = 0;
			

			
			foreach ($po_ids as $po_id){

				$po = $this->inv->get_po_by_id($po_id);

				$amount = $po_amount[$x];
				$x++;
				
				$sql = $this->db->insert_string('receipt_items',array(
					'txn_no'		=> $txn_no,
					'receipt_id'	=> $receipt_id,
					'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
					'contact_id'	=> $contact->id,
					'po_id'			=> $po_id,
					'datetime'		=> date('Y-m-d H:i:s'),
					'amount'		=> $xamount = $amount,
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount -= $xamount;
				
				if ($po->total_received == $this->Get_paid_amount('po', $po->id)){
					$this->inv->po_set_paid($po->id, date('Y-m-d H:i:s'), NULL, $receipt_id);
				}
			}
			
			$x = 0;
			foreach ($cn_ids as $cn_id){

				$cn = $this->sale->get_cn_by_id($cn_id);
				
				$amount = $cn_amount[$x];
				$x++;

				$sql = $this->db->insert_string('receipt_items',array(
					'txn_no'		=> $txn_no,
					'receipt_id'	=> $receipt_id,
					'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
					'contact_id'	=> $contact->id,
					'cn_id'			=> $cn_id,
					'datetime'		=> date('Y-m-d H:i:s'),
					'amount'		=> $xamount = $amount,
					'status'		=> 'Issued'
				));
				
				$this->db->query($sql);
				
				$total_amount -= $xamount;
				
				if ($cn->total_received == $this->Get_paid_amount('cn', $cn->id)){
					$this->sale->cn_set_paid($cn->id, date('Y-m-d H:i:s'), NULL, $receipt_id);						
				}
				

			}
			
		}
		

		$account_from = $this->input->post('account_from');
		$breakdown_amount = $this->input->post('breakdown_amount');
		$breakdown_ref		= $this->input->post('breakdown_reference');
		$payment_method		= $this->input->post('payment_method');
		$cc					= $this->input->post('cc');

	
		for ($i = 0; $i < count($account_from); $i++){
			$account_id = $account_from[$i];
			$account = $this->get_account_by_id($account_id);
			$amount = $breakdown_amount[$i];
			
			if ($payment_method[$i] == 'Credit Card'){
				$amount_effective = ((100 - $cc[$i]) / 100) * $amount;
				$amount_fees = $amount - $amount_effective;
			} else {
				$amount_effective = $amount;
				$amount_fees = 0;
			}
			
			$total_fees += $amount_fees;
			$total_effective += $amount_effective;
		
			$sql = $this->db->insert_string('receipt_breakdown', array(
				'receipt_id'	=> $receipt_id,
				'datetime'		=> date('Y-m-d H:i:s'),
				'account'		=> $account->name,
				'account_id'	=> $account->id,
				'contact'		=> $contact->company_name ? $contact->company_name : $contact->contact_person,
				'contact_id'	=> $contact->id,
				'amount'		=> $amount,
				'amount_fees'	=> $amount_fees,
				'amount_effective'	=> $amount_effective,
				'payment_method'=> $payment_method[$i],
				'payment_reference'=> $breakdown_ref[$i],
				'status'		=> 'Issued'
			));
		
			$this->db->query($sql);
		}
		
		
		$this->db->query($this->db->update_string('receipts', array('amount'=>$total_amount, 'amount_fees'=>$total_fees, 'amount_effective'=>$total_effective),"`id` = '{$receipt_id}'"));
		
		return $this->get_receipt_by_id($receipt_id);

	}
	
	
	
	function Get_receipt_by_id($id){

		$query = $this->db->query("SELECT * FROM `receipts` WHERE `id` = ?", array($id));
		$receipt = $query->row();
		
		$query = $this->db->query("SELECT * FROM `receipt_items` WHERE `receipt_id` = ?", array($receipt->id));
		$receipt->items = $query->result();
		
		$query = $this->db->query("SELECT * FROM `receipt_breakdown` WHERE `receipt_id` = ?", array($receipt->id));
		$receipt->breakdown = $query->result();
		
		return $receipt;
	
	}
	
	function New_salary_voucher(){
		$sv_id = $this->input->post('sv_id');
		
		$this->db->query("UPDATE `salary_voucher` SET `status` = 'Issued' WHERE `id` = ?", array($sv_id));
		$this->db->query("UPDATE `salary_voucher_items` SET `status` = 'Issued' WHERE `sv_id` = ?", array($sv_id));
		
		$account_from = $this->input->post('account_from');
		$breakdown_amount = $this->input->post('breakdown_amount');
		$breakdown_ref		= $this->input->post('breakdown_reference');
		$payment_method		= $this->input->post('payment_method');

	
		for ($i = 0; $i < count($account_from); $i++){
			$account_id = $account_from[$i];
			$account = $this->get_account_by_id($account_id);
			$amount = $breakdown_amount[$i];
		
			$sql = $this->db->insert_string('salary_voucher_breakdown', array(
				'sv_id'			=> $sv_id,
				'datetime'		=> date('Y-m-d H:i:s'),
				'account'		=> $account->name,
				'account_id'	=> $account->id,
				'amount'		=> $amount,
				'payment_method'=> $payment_method[$i],
				'payment_reference'=> $breakdown_ref[$i],
				'status'		=> 'Issued'
			));
		
			$this->db->query($sql);
		}


	}
	
	function Get_salary_vouchers($where){
		if ($where){
			$query = $this->db->query("SELECT * FROM `salary_voucher` WHERE {$where}");
		} else {
			$query = $this->db->query("SELECT * FROM `salary_voucher` ORDER BY `id` DESC");
		}
		
		return $query->result();
	}
	

	function Get_sv_by_id($id){

		$query = $this->db->query("SELECT * FROM `salary_voucher` WHERE `id` = ?", array($id));
		$sv = $query->row();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ?", array($sv->id));
		$sv->items = $query->result();

		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND (`type` = 'Add' OR `type` = 'Basic')", array($sv->id));
		$sv->earnings = $query->result();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND (`type` = 'Deduct' OR `type` = 'BDeduct')", array($sv->id));
		$sv->deductions = $query->result();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND `type` = 'Null'", array($sv->id));
		$sv->other = $query->result();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_breakdown` WHERE `sv_id` = ?", array($sv->id));
		$sv->breakdown = $query->result();
		
		return $sv;
	
	}

	
	

	function Cash_journal_entries($from, $to){
		$query = $this->db->query("
			(SELECT `id`, `type`, `datetime`, `account_id`, `account`, `contact_id`, `contact`, `amount`, `status` FROM `payment_vouchers` WHERE `datetime` >= ? AND `datetime` <= ?)
			UNION (SELECT `id`, `type`, `datetime`, `account_id`, `account`, `contact_id`, `contact`, `amount`, `status` FROM `receipts` WHERE `datetime` >= ? AND `datetime` <= ?)
			ORDER BY `datetime` ASC
		", array($from, $to, $from, $to));
		
		foreach ($query->result() as $entry){
			if ($entry->type == 'Expense' || $entry->type == 'Purchase of Stock' || $entry->type == 'Purchase of Asset'){
				$query = $this->db->query("SELECT * FROM `payment_voucher_breakdown` WHERE `pv_id` = ?", array($entry->id));
				$entry->breakdown = $query->result();
			} elseif ($entry->type == 'Income (Sales)' || $entry->type == 'Income (Non-Sales)' || $entry->type == 'Disposal of Asset'){
				$query = $this->db->query("SELECT * FROM `receipt_breakdown` WHERE `receipt_id` = ?", array($entry->id));
				$entry->breakdown = $query->result();
			}
			
			$entries[] = $entry;
		}
		
		return $entries;
	}
	
	function Payables_to_date($date){
		$query = $this->db->query("SELECT SUM(`total`) AS `amount` FROM `purchase_orders` WHERE `payment_status` = 'Unpaid' AND `date` < ?", array($date));
		$payables = $query->row();
		
		return $payables->amount;
	}
	
	function Payables($from, $to){
		$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `payment_status` = 'Unpaid` AND `date` >= ? AND `date` <= ?", array($from, $to));
		return $query->result();
	}
	
	function Receivables_to_date($date){
		$query = $this->db->query("SELECT SUM(`total`) AS `amount` FROM `invoices` WHERE `payment_status` = 'Unpaid' AND `date` < ?", array($date));
		$receivables = $query->row();
		
		return $receivables->amount;
	}
	
	function Receivables($from, $to){
		$query = $this->db->query("SELECT * FROM `invoices` WHERE `payment_status` = 'Unpaid' AND `date` >= ? AND `date` <= ?", array($from, $to));
		return $query->result();
	}
	
	function Void_receipt($id){
		$this->db->query("UPDATE `receipts` SET `status` = 'Voided' WHERE `id` = ?", array($id));
		$this->db->query("UPDATE `receipt_items` SET `status` = 'Voided' WHERE `receipt_id` = ?", array($id));
		$this->db->query("UPDATE `receipt_breakdown` SET `status` = 'Voided' WHERE `receipt_id` = ?", array($id));
		
		return $this->get_receipt_by_id($id);
	}
	
	function Void_pv($id){
		$this->db->query("UPDATE `payment_vouchers` SET `status` = 'Voided' WHERE `id` = ?", array($id));
		$this->db->query("UPDATE `payment_voucher_items` SET `status` = 'Voided' WHERE `pv_id` = ?", array($id));
		$this->db->query("UPDATE `payment_voucher_breakdown` SET `status` = 'Voided' WHERE `pv_id` = ?", array($id));
		
		return $this->get_pv_by_id($id);
	
	}
	
	function Void_sv($id){
		$this->db->query("UPDATE `salary_voucher` SET `status` = 'Voided' WHERE `id` = ?", array($id));
		$this->db->query("UPDATE `salary_voucher_items` SET `status` = 'Voided' WHERE `id` = ?", array($id));
		$this->db->query("UPDATE `salary_voucher_breakdown` SET `status` = 'Voided' WHERE `id` = ?", array($id));
	}
	
	
	
	function Get_gl_transactions($id, $from, $to, $flag){
		
		if (!$from) $from = date('Y-m-1');
		if (!$to) $to = date('Y-m-t');
		
		if ($flag == 1){

		}
		
		$account = $this->get_account_by_id($id);
		
		$from = $this->db->escape($from . ' 00:00:00');
		$to = $this->db->escape($to . ' 23:59:59');	
		
		switch ($flag){
			case "2":
				$flag_filter = ' AND `recon_date` != NULL ';
			break;
			case "3":
				$flag_filter = ' AND `recon_date` == NULL ';			
			break;
		}
		
		
		if ($account->cash_postable){
			
			$id = $this->db->escape($id);
			
			$query = $this->db->query("SELECT 
					`id`, `date`, `reference`, `description`, `type`, `amount`, `recon_date`
				FROM 
					`account_transactions`
				WHERE
					`account_id` = $id AND `date` >= $from AND `date` <= $to
					$flag_filter
			UNION
				SELECT
					CONCAT('P',`id`,' - ',`payment_method`) AS `id`, `datetime` AS `date`, `payment_reference` AS `reference`, `description`, 'CR' AS `type`, `amount`, `recon_date`
				FROM
					`payment_voucher_breakdown`
				WHERE
					`account_id` = $id AND `datetime` >= $from AND `datetime` <= $to AND `status` = 'Issued'
					$flag_filter
			UNION
				SELECT
					CONCAT('R',`id`,' - ',`payment_method`) AS `id`, `datetime` AS `date`, `payment_reference` AS `reference`, `description`, 'DR' AS `type`, `amount`, `recon_date`
				FROM
					`receipt_breakdown`
				WHERE
					`account_id` = $id AND `datetime` >= $from AND `datetime` <= $to AND `status` = 'Issued'
					$flag_filter
			");
					

		} else {
			
			$id = $this->db->escape($id);
		
		
			$query = $this->db->query("SELECT 
					`id`, `date`, `reference`, `description`, `type`, `amount`, `recon_date`
				FROM 
					`account_transactions`
				WHERE
					`account_id` = $id AND `date` >= $from AND `date` <= $to
					$flag_filter
			UNION
				SELECT
					CONCAT('P',`id`) AS `id`, `datetime` AS `date`, `reference`, `description`, 'DR' AS `type`, `amount`, `recon_date`
				FROM
					`payment_voucher_items`
				WHERE
					`account_id` = $id AND `datetime` >= $from AND `datetime` <= $to AND `status` = 'Issued'
					$flag_filter
			UNION
				SELECT
					CONCAT('R',`id`) AS `id`,`datetime` AS `date`, `reference`, `description`, 'CR' AS `type`, `amount`, `recon_date`
				FROM
					`receipt_items`
				WHERE
					`account_id` = $id AND `datetime` >= $from AND `datetime` <= $to AND `status` = 'Issued'
					$flag_filter
			");
				
		}
		
		$res = $query->result();
	
		
		switch ($account->integration_type){
			case "_CCSR":
				// credit card service charge
				
				// to pull from - credit card
				// Retail
				// FnB
				// Receipts
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('Credit Card Service Charge  ', `cc_name`) AS `description`, 
					'DR' AS `type`, 
					`cc_fee` AS `amount`,
					`recon_date`
				FROM 
					`fnb_buffer_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_fee` != 0 AND `cc_fee` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res2 = $query->result();
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('Credit Card Service Charge  ', `cc_name`) AS `description`, 
					'DR' AS `type`, 
					`cc_fee` AS `amount`,
					`recon_date`
				FROM 
					`fnb_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_fee` != 0 AND `cc_fee` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res3 = $query->result();
				
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('Credit Card Service Charge  ', `cc_name`) AS `description`, 
					'DR' AS `type`, 
					`cc_fees` AS `amount`,
					`recon_date`
				FROM 
					`sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_fees` != 0 AND `cc_fees` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res4 = $query->result();
				
				
			break;
			case "_CCSS":
				
				// credit card sales
				
				// to pull from - credit card
				// Retail 
				// FnB
				// Receipts
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales ', `cc_name`) AS `description`, 
					'CR' AS `type`, 
					`amount_cc` AS `amount`,
					`recon_date`
				FROM 
					`fnb_buffer_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_fee` != 0 AND `cc_fee` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res2 = $query->result();
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales ', `cc_name`) AS `description`, 
					'CR' AS `type`, 
					`amount_cc` AS `amount`,
					`recon_date`
				FROM 
					`fnb_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_fee` != 0 AND `cc_fee` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res3 = $query->result();
				
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales ', `cc_name`) AS `description`, 
					'CR' AS `type`, 
					`amount_cc` AS `amount`,
					`recon_date`
				FROM 
					`sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_fees` != 0 AND `cc_fees` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res4 = $query->result();
				

			
			break;
			case "_CASH";
			
				// cash sales
				
				// to pull from - cash
				// retail
				// FnB
				// receipts
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'CR' AS `type`, 
					`amount_cash` AS `amount`,
					`recon_date`
				FROM 
					`fnb_buffer_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cash` != 0 AND `amount_cash` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res2 = $query->result();
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'CR' AS `type`, 
					`amount_cash` AS `amount`,
					`recon_date`
				FROM 
					`fnb_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cash` != 0 AND `amount_cash` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res3 = $query->result();
				
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'CR' AS `type`, 
					`amount_cash` AS `amount`,
					`recon_date` 
				FROM 
					`sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cash` != 0 AND `amount_cash` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res4 = $query->result();
				
			break;
			case "_CURR";
			
				// current cash in hand
				
				// to pull from - cash
				// retail
				// fnb
				// receipts
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'DR' AS `type`, 
					`amount_cash` AS `amount`,
					`recon_date`
				FROM 
					`fnb_buffer_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cash` != 0 AND `amount_cash` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res2 = $query->result();
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'DR' AS `type`, 
					`amount_cash` AS `amount`,
					`recon_date`
				FROM 
					`fnb_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cash` != 0 AND `amount_cash` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res3 = $query->result();
				
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'DR' AS `type`, 
					`amount_cash` AS `amount`,
					`recon_date`
				FROM 
					`sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cash` != 0 AND `amount_cash` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res4 = $query->result();
				
				
				// DR BALANCE therefore figure in +ve 
							
				
			break;
			case "_BANK";
			
				// current bank
				
				// to pull from - cheque
				// retail
				// fnb
				// receipts
				
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'DR' AS `type`, 
					`amount_cheque` AS `amount`,
					`recon_date`
				FROM 
					`fnb_buffer_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cheque` != 0 AND `amount_cheque` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res2 = $query->result();
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'DR' AS `type`, 
					`amount_cheque` AS `amount`,
					`recon_date` 
				FROM 
					`fnb_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cheque` != 0 AND `amount_cheque` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res3 = $query->result();
				
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'DR' AS `type`, 
					`amount_cheque` AS `amount`,
					`recon_date` 
				FROM 
					`sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_cheque` != 0 AND `amount_cheque` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res4 = $query->result();


				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales') AS `description`, 
					'DR' AS `type`, 
					`amount_bank_deposit` AS `amount`,
					`recon_date`
				FROM 
					`sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`amount_bank_deposit` != 0 AND `amount_bank_deposit` IS NOT NULL) AND `type` = 'history'
					$flag_filter
				");
				$res5 = $query->result();

				
			break;
			case "_OTAX":
			
				// output tax
				
				// to pull from
				// invoices
				// retail tax invoices
				// fnb tax invoices
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales Tax') AS `description`, 
					'CR' AS `type`, 
					`tax_amount` AS `amount`,
					`datetime` AS `recon_date`
				FROM 
					`fnb_buffer_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`tax_amount` != 0 AND `tax_amount` IS NOT NULL) AND `type` = 'history'");
				$res2 = $query->result();
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales Tax') AS `description`, 
					'CR' AS `type`, 
					`tax_amount` AS `amount`,
					`datetime` AS `recon_date`
				FROM 
					`fnb_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`tax_amount` != 0 AND `tax_amount` IS NOT NULL) AND `type` = 'history'");
				$res3 = $query->result();
				
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('POS Sales Tax') AS `description`, 
					'CR' AS `type`, 
					`tax_amount` AS `amount`,
					`datetime` AS `recon_date`
				FROM 
					`sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`tax_amount` != 0 AND `tax_amount` IS NOT NULL) AND `type` = 'history'");
				$res4 = $query->result();
				
				
				$query = $this->db->query("SELECT
					`id`,
					`date`,
					`txn_no` AS `reference`,
					CONCAT('Invoice ', `txn_no`) AS `description`,
					'CR' AS `type`,
					'total_tax' AS `amount,
					`datetime` AS `recon_date`
				FROM
					`invoices` WHERE `date` >= $from AND `date` <= $to AND `status` != 'Pending'");
				$res5 = $query->result();
							
			break;
			case "_LTAX":
			
				// local tax
				
				// to pull from
				// invoices
				// retail tax invoices
				// fnb tax invoices

				$integrated_balance = 0 - $res->total_amount;
							
			break;
			case "_ITAX":
				// input tax
				
				// to pull from
				// purchase orders
				// payment vouchers
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('Credit Card Charge Tax') AS `description`, 
					'CR' AS `type`, 
					`cc_tax` AS `amount` ,
					`datetime` AS `recon_date`
				FROM 
					`fnb_buffer_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_tax` != 0 AND `cc_tax` IS NOT NULL) AND `type` = 'history'");
				$res2 = $query->result();
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('Credit Card Charge Tax') AS `description`, 
					'CR' AS `type`, 
					`cc_tax` AS `amount`,
					`datetime` AS `recon_date`
				FROM 
					`fnb_sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_tax` != 0 AND `cc_tax` IS NOT NULL) AND `type` = 'history'");
				$res3 = $query->result();
				
				
				
				$query = $this->db->query("SELECT 
					`id`, 
					`datetime` AS `date`, 
					CONCAT('RC',`id`) AS `reference`, 
					CONCAT('Credit Card Charge Tax') AS `description`, 
					'CR' AS `type`, 
					`cc_tax` AS `amount`,
					`datetime` AS `recon_date`
				FROM 
					`sales` WHERE `datetime` >= $from AND `datetime` <= $to AND (`cc_tax` != 0 AND `cc_tax` IS NOT NULL) AND `type` = 'history'");
				$res4 = $query->result();
				
				
				$query = $this->db->query("SELECT
					`id`,
					`date`,
					`txn_no` AS `reference`,
					CONCAT('Invoice ', `txn_no`) AS `description`,
					'CR' AS `type`,
					'total_tax' AS `amount`,
					`date` AS `recon_date`
				FROM
					`purchase_orders` WHERE `date` >= $from AND `date` <= $to AND `status` != 'Pending'");
				$res5 = $query->result();
				
			break;
		
		}
		
		
		

		if (count($res2)) foreach ($res2 as $r) $res[] = $r;			
		if (count($res3)) foreach ($res3 as $r) $res[] = $r;	
		if (count($res4)) foreach ($res4 as $r) $res[] = $r;
		if (count($res5)) foreach ($res4 as $r) $res[] = $r;
		if (count($res6)) foreach ($res4 as $r) $res[] = $r;
		if (count($res7)) foreach ($res4 as $r) $res[] = $r;

		sortdata($res, 'date');
		
		
		if ($debug){
			echo "<pre>";
			print_r($res);
			echo "</pre>";
			die();
		}
			
		return $res;
		
	}
	
	
	function Get_account_balance($date,$id, $from_date, $flag){
		
		if (!$date) $date = date('Y-m-d', time() + (60*60*24)) . ' 00:00:00';
		else $date . ' 00:00:00';
		
		$date = $this->db->escape($date);
		
		$account = $this->get_account_by_id($id);
		
		
		if ($from_date){
			$filter1 = 'AND `check_in` >= ' . $this->db->escape($from_date . ' 00:00:00');
			$filter2 = 'AND `date` >= ' . $this->db->escape($from_date . ' 00:00:00');	
		}
		
		
		
		switch ($account->integration_type){
			case "_CCSR":
				// credit card service charge
				
				// to pull from - credit card
				// Retail
				// FnB
				// Receipts
				
				$query = $this->db->query("SELECT SUM(`cc_fee`) AS `total` FROM `fnb_buffer_sales` WHERE `datetime` < $date");
				$res1 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`cc_fee`) AS `total` FROM `fnb_sales` WHERE `datetime` < $date");
				$res2 = $query->row();

				$query = $this->db->query("SELECT SUM(`cc_fees`) AS `total` FROM `sales` WHERE `datetime` < $date");
				$res3 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`cc_fees`) AS `total` FROM `receipt_breakdown` WHERE `datetime` < $date AND `payment_method` = 'Credit Card' AND `status` = 'Issued'");
				$res4 = $query->row();
				
				
				// DR BALANCE therefore figure in +ve 
				
				
				$integrated_balance = $res1->total + $res2->total + $res3->total + $res4->total;
				
				
			break;
			case "_CCSS":
				
				// credit card sales
				
				// to pull from - credit card
				// Retail 
				// FnB
				// Receipts
				
				$query = $this->db->query("SELECT SUM(`amount_cc`) AS `total` FROM `fnb_buffer_sales` WHERE `datetime` < $date");
				$res1 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount_cc`) AS `total` FROM `fnb_sales` WHERE `datetime` < $date");
				$res2 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount_cc`) AS `total` FROM `sales` WHERE `datetime` < $date");
				$res3 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount`) AS `total` FROM `receipt_breakdown` WHERE `datetime` < $date AND `payment_method` = 'Credit Card' AND `status` = 'Issued'");
				$res4 = $query->row();
				
				
				// CR Balance therefore figure in -ve
			
				$integrated_balance = 0 - ($res1->total + $res2->total + $res3->total + $res4->total);
			
			break;
			case "_CASH";
			
				// cash sales
				
				// to pull from - cash
				// retail
				// FnB
				// receipts
				
				
				$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total` FROM `fnb_buffer_sales` WHERE `datetime` < $date");
				$res1 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total` FROM `fnb_sales` WHERE `datetime` < $date");
				$res2 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total` FROM `sales` WHERE `datetime` < $date");
				$res3 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount`) AS `total` FROM `receipt_breakdown` WHERE `datetime` < $date AND `payment_method` = 'Cash' AND `status` = 'Issued'");
				$res4 = $query->row();
				
				
				// CR Balance therefore figure in -ve
				
				$integrated_balance = 0 - ($res1->total + $res2->total + $res3->total);
				
			break;
			case "_CURR";
			
				// current cash in hand
				
				// to pull from - cash
				// retail
				// fnb
				// receipts
				
				$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total` FROM `fnb_buffer_sales` WHERE `datetime` < $date");
				$res1 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total` FROM `fnb_sales` WHERE `datetime` < $date");
				$res2 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total` FROM `sales` WHERE `datetime` < $date");
				$res3 = $query->row();
				
				
				// DR BALANCE therefore figure in +ve 
							
				$integrated_balance = $res1->total + $res2->total + $res3->total;
				
			break;
			case "_BANK";
			
				// current bank
				
				// to pull from - cheque
				// retail
				// fnb
				// receipts
				
				
				
				$query = $this->db->query("SELECT SUM(`amount_cheque`) AS `total` FROM `fnb_buffer_sales` WHERE `datetime` < $date");
				$res1 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount_cheque`) AS `total` FROM `fnb_sales` WHERE `datetime` < $date");
				$res2 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount_cheque`) AS `total` FROM `sales` WHERE `datetime` < $date");
				$res3 = $query->row();

				$query = $this->db->query("SELECT SUM(`amount_bank_deposit`) AS `total` FROM `sales` WHERE `datetime` < $date");
				$res4 = $query->row();

			
				// DR BALANCE therefore figure in +ve 
							
				$integrated_balance = $res1->total + $res2->total + $res3->total + $res4->total;


				
			break;
			case "_OTAX":
			
				// output tax
				
				// to pull from
				// invoices
				// retail tax invoices
				// fnb tax invoices
				
				
				// CR Balance therefore figure in -ve
				$query = $this->db->query("SELECT SUM(`tax_amount`) AS `total` FROM `fnb_buffer_sales` WHERE `datetime` < $date");
				$res1 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`tax_amount`) AS `total` FROM `fnb_sales` WHERE `datetime` < $date");
				$res2 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`tax_amount`) AS `total` FROM `sales` WHERE `datetime` < $date");
				$res3 = $query->row();

				$query = $this->db->query("SELECT SUM(`total_tax`) AS `total` FROM `invoices` WHERE `date` < $date AND `status` != 'Pending'");
				$res4 = $query->row();

			
				$integrated_balance = 0 - ($res1->total + $res2->total + $res3->total + $res4->total);
							
			break;
			case "_LTAX":
			
				// local tax
				
				// to pull from
				// invoices
				// retail tax invoices
				// fnb tax invoices

				$integrated_balance = 0 - $res->total_amount;
							
			break;
			case "_ITAX":
				// input tax
				
				// to pull from
				// purchase orders
				// payment vouchers
				
				$query = $this->db->query("SELECT SUM(`cc_tax`) AS `total` FROM `fnb_buffer_sales` WHERE `datetime` < $date");
				$res1 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`cc_tax`) AS `total` FROM `fnb_sales` WHERE `datetime` < $date");
				$res2 = $query->row();
				
				$query = $this->db->query("SELECT SUM(`cc_tax`) AS `total` FROM `sales` WHERE `datetime` < $date");
				$res3 = $query->row();

				$query = $this->db->query("SELECT SUM(`total_tax`) AS `total` FROM `purchase_orders` WHERE `date` < $date AND `status` != 'Pending'");
				$res4 = $query->row();
			
				$integrated_balance = $res1->total + $res2->total + $res3->total + $res4->total;
			break;
		}
		
	
		if ($account->type == 'Expense'){
			$query = $this->db->query("SELECT SUM(`amount`-`tax`) AS `total_amount` FROM `payment_vouchers` WHERE `datetime` < $date AND `account_id` = ?", array($id));
			$exp_dr = $query->row();
		}
		
		if ($account->cash_postable){
			$query = $this->db->query("SELECT SUM(`amount`) AS `total_credit` FROM `payment_voucher_breakdown` WHERE `datetime` < $date AND `account_id` = ? AND `status` = 'Issued'", array($id));
			$payments = $query->row();

			$query = $this->db->query("SELECT SUM(`amount`) AS `total_debit` FROM `receipt_breakdown` WHERE `datetime` < $date AND `account_id` = ? AND `status` = 'Issued'", array($id));
			$receipts = $query->row();
			
		}
		
		$query = $this->db->query("SELECT SUM(`amount`) AS `total_debit` FROM `account_transactions` WHERE `date` < $date $filter2 AND `account_id` = ? AND `type` = 'DR'",array($id));
		$txn_dr = $query->row();

		$query = $this->db->query("SELECT SUM(`amount`) AS `total_credit` FROM `account_transactions` WHERE `date` < $date $filter2 AND `account_id` = ? AND `type` = 'CR'",array($id));
		$txn_cr = $query->row();
		
		return $account->opening_balance + $txn_dr->total_debit - $txn_cr->total_credit - $payments->total_credit + $receipts->total_debit + $integrated_balance + $exp_dr->total_amount - $exp_cr->total_amount;
	}
		
	
	function Cancel_transaction($id){
		if ($id[0] == 'R'){
			
		} elseif ($id[0] == 'L'){
			
		} else {
			$query = $this->db->query("SELECT * FROM `account_transactions` WHERE `id` = ?", array($id));
			$txn = $query->row();
			$this->db->query("DELETE FROM `account_transactions` WHERE `group` = ?", array($txn->group));
			
			
		}
	}
	
	function Close_accounts(){
		$year_end_date = sql_date_reformat($this->input->post('year_end_date'));
		$this->db->insert('account_closure',array(
			'year_end_date'	=> $year_end_date,
		));
		
		$closure_id = $this->db->insert_id();
		
		$expense_accounts = $this->get_accounts("`type` = 'Expense'");
		$income_accounts = $this->get_accounts("`type` = 'Income'");
		
		$group = time();
		
		
		foreach ($expense_accounts as $account){
			$bal = $this->account->Get_account_balance($year_end_date,$account->id);
			$close_balance = abs($bal);
			if ($bal < 0) $type = 'DR';
			else $type = 'CR';
			
			$this->db->insert('account_transactions', array(
				'journal'		=> 'Closure',
				'account_id'	=> $account->id,
				'account_name'	=> $account->name,
				'amount'		=> $close_balance,
				'type'			=> $type,
				'reference'		=> 'AC-' . $closure_id,
				'description'	=> 'Accounts Closed - Year End ' . $year_end_date,
				'group'			=> $group,
				'closure_id'	=> $closure_id
			));
			
			$total += $bal;
		}
		
		foreach ($income_accounts as $account){
			$bal = $this->account->Get_account_balance($year_end_date,$account->id);
			$close_balance = abs($bal);
			if ($bal < 0) $type = 'DR';
			else $type = 'CR';
			
			$this->db->insert('account_transactions', array(
				'journal'		=> 'Closure',
				'account_id'	=> $account->id,
				'account_name'	=> $account->name,
				'amount'		=> $close_balance,
				'type'			=> $type,
				'reference'		=> 'AC-' . $closure_id,
				'description'	=> 'Accounts Closed - Year End ' . $year_end_date,
				'group'			=> $group,
				'closure_id'	=> $closure_id
			));
			
			$total += $bal;
		}
		
		$this->db->update('account_closure', array(
			'retained_earnings'	=> $total,
			
		),array(
			'id'	=> $closure_id
		));
	}	
	
	function Get_paid_amount($type, $id){
		switch ($type){
			case "po":
				$query = $this->db->query("SELECT SUM(`amount`) AS `paid` FROM `payment_voucher_items` WHERE `po_id` = ? AND `status` = 'Issued'", array($id));
				$res = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount`) AS `paid` FROM `receipt_items` WHERE `po_id` = ? AND `status` = 'Issued'", array($id));
				$res2 = $query->row();
								
				return $res->paid + $res2->paid;
			break;
			case "cn":
				$query = $this->db->query("SELECT SUM(`amount`) AS `paid` FROM `payment_voucher_items` WHERE `cn_id` = ? AND `status` = 'Issued'", array($id));
				$res = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount`) AS `paid` FROM `receipt_items` WHERE `cn_id` = ? AND `status` = 'Issued'", array($id));
				$res2 = $query->row();
				
				
				return $res->paid + $res2->paid;
			
			break;
			case "invoice":
				$query = $this->db->query("SELECT SUM(`amount`) AS `paid` FROM `payment_voucher_items` WHERE `invoice_id` = ? AND `status` = 'Issued'", array($id));
				$res = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount`) AS `paid` FROM `receipt_items` WHERE `invoice_id` = ? AND `status` = 'Issued'", array($id));
				$res2 = $query->row();
				
				return $res->paid + $res2->paid;
			
			break;
			case "dn":
				$query = $this->db->query("SELECT SUM(`amount`) AS `paid` FROM `payment_voucher_items` WHERE `dn_id` = ? AND `status` = 'Issued'", array($id));
				$res = $query->row();
				
				$query = $this->db->query("SELECT SUM(`amount`) AS `paid` FROM `receipt_items` WHERE `dn_id` = ? AND `status` = 'Issued'", array($id));
				$res2 = $query->row();
				
				
				return $res->paid + $res2->paid;
			
			break;
		}
		
		
	}
}

