<?php

class Calendar extends Model{

	function get_event($id){
		$user = $this->user->data('username');
		$query = $this->db->query("SELECT * FROM `calendar` WHERE `id` = '$id'");
		$event = $query->row();
		
		if ($event->user == $user || $event->assigned_by == $user) return $event;
		else return false;
	}

	function task_list($limit = null, $filters = null){
		$user = $this->user->data('username');
		if ($limit) $limit_string = " LIMIT $limit";
		if (is_array($filters)){
			if ($filters['orderby']){
				if ($filters['order']) $order = $filters['order'];
				else $order = 'ASC';
				$orderby = " ORDER BY `{$filters['orderby']}` $order ";
			}
			$query = $this->db->query("SELECT * FROM `calendar` WHERE `user` = '$user' AND `type` = 'task' $orderby $limit_string");
			return $query->result();
		} else {
			$query = $this->db->query("SELECT * FROM `calendar` WHERE `user` = '$user' AND `type` = 'task' $limit_string");
			return $query->result();
		}
						
	}
	
	function assigned_list($limit = null, $filters = null){
		$user = $this->user->data('username');
		if ($limit) $limit_string = " LIMIT $limit";
		if (is_array($filters)){
			if ($filters['orderby']){
				if ($filters['order']) $order = $filters['order'];
				else $order = 'ASC';
				$orderby = " ORDER BY `{$filters['orderby']}` $order ";
			}
			$query = $this->db->query("SELECT * FROM `calendar` WHERE `assigned_by` = '$user' AND `type` = 'task' $orderby $limit_string");
			return $query->result();
		} else {
			$query = $this->db->query("SELECT * FROM `calendar` WHERE `assigned_by` = '$user' AND `type` = 'task' $limit_string");
			return $query->result();
		}
						
	}
	
	function schedule_list($limit = null, $filters = null){
		$user = $this->user->data('username');
		if (is_array($filters)){
			if ($filters['orderby']){
				if ($filters['order']) $order = $filters['order'];
				else $order = 'ASC';
				$orderby = " ORDER BY `{$filters['orderby']}` $order ";
			}
			if ($filters['type']){
				$filter = "`type` = " . $this->db->escape($filters['type']);
			}
			
			$filter = $filter . " AND";
			$query = $this->db->query("SELECT * FROM `calendar` WHERE {$filter} `user` = '$user' AND `type` <> 'task' $orderby $limit_string");
			return $query->result();
		} else {
			$query = $this->db->query("SELECT * FROM `calendar` WHERE {$filter} `user` = '$user' AND `type` <> 'task' $limit_string");
			return $query->result();
		}
	
	}

	function Json_data($mode){
	
		$user = $this->user->data('username');
			
		if ($mode == 1){
			
		} else {
			$query = $this->db->query("SELECT * FROM `calendar` WHERE (`user` = ? OR `broadcast` = 1)", array($user));
			$result = $query->result();
			
		}
		

		foreach ($result as $event){
			$object = null;
			$object->id = $event->id;
			$object->title = $event->title;
			$object->type = $event->type;
			$object->className = 'calendar-'.$event->type;
			$object->allDay = $event->allday;
			$object->start = $event->start;
			$object->group = $event->group;
			$object->end = $event->end;
			$object->notes = $event->notes;
			$object->location = $event->location;
			$object->priority = $event->priority;
			$object->status = $event->status;
			if ($event->user != $user){
				$object->editable = false;
			} else {
				$object->editable = true;
			}
			$events[] = $object;
		}
	
		return json_encode($events);
	}
	
	function Add_task($data, $module, $module_type, $module_id){
		
		if (is_array($data)){

			$user 		= $this->user->data('username');
			$events		= $data['event'];
			$location	= $data['location'];
			$assigned_to= $data['assigned_to'];
			$assign_type= $data['assign_type'];
			$type		= $data['type'];
			$allday		= $data['allday'];
			$repeat		= $data['repeat'];
			$from_date	= $data['from_date'];
			$from_time 	= $data['from_time'];
			$to_date	= $data['to_date'];
			$to_time	= $data['to_time'];
			$notes		= $data['notes'];
			$status		= $data['status'];
			$division	= $data['division'];
			$priority	= $data['priority'];
			
		
		} else {
			
			$user 		= $this->user->data('username');
			$event 		= $this->input->post('task');
			$location 	= $this->input->post('location');
			$assigned_to= $this->input->post('user');
			$assign_type= $this->input->post('assign_type');
			$type		= $this->input->post('type');
			$allday 	= $this->input->post('allday');
			$repeat 	= $this->input->post('repeat');
			$from_date 	= $this->input->post('from_date');
			$from_time	= $this->input->post('from_time');
			$to_date 	= $this->input->post('to_date');
			$to_time 	= $this->input->post('to_time');
			$notes 		= $this->input->post('notes');
			$status		= $this->input->post('status');
			$group	= $this->input->post('group');
			$priority	= $this->input->post('priority');			
			
		}
		
		if (!$allday) $allday = '';
		
		if ($allday){
			list($from_day, $from_month, $from_year) = explode('/',$from_date);
			$from_datetime = date('Y-m-d H:i:s', strtotime($from_year.'-'.$from_month.'-'.$from_day));

			list($to_day, $to_month, $to_year) = explode('/',$to_date);
			$to_datetime = date('Y-m-d H:i:s', strtotime($to_year.'-'.$to_month.'-'.$to_day));

		} else {
			list($from_day, $from_month, $from_year) = explode('/',$from_date);
			$from_date = date('Y-m-d', strtotime($from_year.'-'.$from_month.'-'.$from_day));
			$from_time = date('H:i:s', strtotime($from_time));
			$from_datetime = $from_date . ' ' . $from_time;

			list($to_day, $to_month, $to_year) = explode('/',$to_date);
			$to_date = date('Y-m-d', strtotime($to_year.'-'.$to_month.'-'.$to_day));
			$to_time = date('H:i:s', strtotime($to_time));
			$to_datetime = $to_date . ' ' . $to_time;
		}
		
		$sql = $this->db->insert_string('calendar',array(
			'title' 	=> $event,
			'type'		=> 'task',
			'location'	=> $location,
			'allday'	=> $allday,
			'start'		=> $from_datetime,
			'end'		=> $to_datetime,
			'repeat'	=> $repeat,
			'status'	=> $status,
			'division'	=> $group,
			'priority'	=> $priority,
			'notes'		=> $notes,
			'user'		=> $assigned_to,
			'assigned_by'=> $user
		));
		
		if (!$event) return false;
		$this->db->query($sql);
		return true;
	}
	
	function Add_event(){
		$event 		= $this->input->post('event');
		$location 	= $this->input->post('location');
		$type		= $this->input->post('type');
		$allday 	= $this->input->post('allday');
		$repeat 	= $this->input->post('repeat');
		$from_date 	= $this->input->post('from_date');
		$from_time	= $this->input->post('from_time');
		$to_date 	= $this->input->post('to_date');
		$to_time 	= $this->input->post('to_time');
		$notes 		= $this->input->post('notes');
		$status		= $this->input->post('status');
		$group		= $this->input->post('group');
		$priority	= $this->input->post('priority');
		
		if (!$allday) $allday = '';
		
		if ($allday){
			list($from_day, $from_month, $from_year) = explode('/',$from_date);
			$from_datetime = date('Y-m-d H:i:s', strtotime($from_year.'-'.$from_month.'-'.$from_day));

			list($to_day, $to_month, $to_year) = explode('/',$to_date);
			$to_datetime = date('Y-m-d H:i:s', strtotime($to_year.'-'.$to_month.'-'.$to_day));

		} else {
			list($from_day, $from_month, $from_year) = explode('/',$from_date);
			$from_date = date('Y-m-d', strtotime($from_year.'-'.$from_month.'-'.$from_day));
			$from_time = date('H:i:s', strtotime($from_time));
			$from_datetime = $from_date . ' ' . $from_time;

			list($to_day, $to_month, $to_year) = explode('/',$to_date);
			$to_date = date('Y-m-d', strtotime($to_year.'-'.$to_month.'-'.$to_day));
			$to_time = date('H:i:s', strtotime($to_time));
			$to_datetime = $to_date . ' ' . $to_time;
		}
		
		$sql = $this->db->insert_string('calendar',array(
			'title' 	=> $event,
			'type'		=> $type,
			'location'	=> $location,
			'allday'	=> $allday,
			'start'		=> $from_datetime,
			'end'		=> $to_datetime,
			'repeat'	=> $repeat,
			'status'	=> $status,
			'division'	=> $group,
			'priority'	=> $priority,
			'notes'		=> $notes,
			'user'		=> $this->user->data('username')
		));
		
		if (!$event) return false;
		$this->db->query($sql);
		return true;
	}	
	
	function Shift_event(){
		$day_delta = $this->input->post('day');
		$minute_delta = $this->input->post('minute');
		$allday = $this->input->post('allday');
		
		if ($allday == 'false' || !$allday) $allday = null;
		else $allday = true;
		
		$id = $this->input->post('id');
		
		$query = $this->db->query("SELECT * FROM `calendar` WHERE `id` = '$id'");
		$event = $query->row();
		
		$new_start_date = date('Y-m-d H:i:s',strtotime($event->start) + ($day_delta * 60 * 60 * 24) + ($minute_delta * 60));
		$new_end_date = date('Y-m-d H:i:s',strtotime($event->end) + ($day_delta * 60 * 60 * 24) + ($minute_delta * 60));
		
		$this->db->query("UPDATE `calendar` SET `start` = '$new_start_date', `end` = '$new_end_date', `allday` = '$allday' WHERE `id` = '$id'");
	}
	
	function Resize_event(){
		$day_delta = $this->input->post('day');
		$minute_delta = $this->input->post('minute');
		$id = $this->input->post('id');
		
		$query = $this->db->query("SELECT * FROM `calendar` WHERE `id` = '$id'");
		$event = $query->row();
		$new_end_date = date('Y-m-d H:i:s',strtotime($event->end) + ($day_delta * 60 * 60 * 24) +  ($minute_delta * 60));	
		
		$this->db->query("UPDATE `calendar` SET `end` = '$new_end_date' WHERE `id` = '$id'");
	}
	
	function Delete_event($id){
		$event = $this->get_event($id);
		
		if ($event->user == $this->user->data('username') && $event->assigned_by == null){
			$this->db->query("DELETE FROM `calendar` WHERE `id` = '$id'");
			return true;
		} else {
			return false;
		}
	}
	
	function Edit_event(){
		$event 		= $this->input->post('event');
		$location 	= $this->input->post('location');
		$type		= $this->input->post('type');

		$allday 	= $this->input->post('allday');
		$repeat 	= $this->input->post('repeat');
		$from_date 	= $this->input->post('from_date');
		$from_time	= $this->input->post('from_time');
		$to_date 	= $this->input->post('to_date');
		$to_time 	= $this->input->post('to_time');
		$notes 		= $this->input->post('notes');
		$status		= $this->input->post('status');
		$priority	= $this->input->post('priority');
		$id			= $this->input->post('id');
		$group	= $this->input->post('group');
		
		if (!$allday) $allday = '';
		
		if ($allday){
			list($from_day, $from_month, $from_year) = explode('/',$from_date);
			$from_datetime = date('Y-m-d H:i:s', strtotime($from_year.'-'.$from_month.'-'.$from_day));

			list($to_day, $to_month, $to_year) = explode('/',$to_date);
			$to_datetime = date('Y-m-d H:i:s', strtotime($to_year.'-'.$to_month.'-'.$to_day));

		} else {
			list($from_day, $from_month, $from_year) = explode('/',$from_date);
			$from_date = date('Y-m-d', strtotime($from_year.'-'.$from_month.'-'.$from_day));
			$from_time = date('H:i:s', strtotime($from_time));
			$from_datetime = $from_date . ' ' . $from_time;

			list($to_day, $to_month, $to_year) = explode('/',$to_date);
			$to_date = date('Y-m-d', strtotime($to_year.'-'.$to_month.'-'.$to_day));
			$to_time = date('H:i:s', strtotime($to_time));
			$to_datetime = $to_date . ' ' . $to_time;
		}
		
		$sql = $this->db->update_string('calendar',array(
			'title' 	=> $event,
			'type'		=> $type,
			'location'	=> $location,
			'allday'	=> $allday,
			'start'		=> $from_datetime,
			'end'		=> $to_datetime,
			'division'	=> $group,
			'repeat'	=> $repeat,
			'status'	=> $status,
			'priority'	=> $priority,
			'notes'		=> $notes,
			'user'		=> $this->user->data('username')
		),"`id` = '$id'");
		
		if (!$event) return false;
		$this->db->query($sql);
		return true;

	}
	
}