<?php 

class Contact extends Model {


	function Get_ranks($dropdown = false){
		$query = $this->db->query("SELECT `rank` FROM `contacts` GROUP BY `rank` ORDER BY `rank` ASC");
		if ($dropdown) $ranks[] = "Select Rank";
		foreach ($query->result() as $rank){
			if (trim($rank->rank)) $ranks[$rank->rank] = $rank->rank;
		}
		return $ranks;
	}

	function Add_log($id, $contact_id){
	
		$config['upload_path'] = '../assets/docs/';
		$config['allowed_types'] = 'doc|docx|dotx|pdf|xls|xlsx|ppt|pptx|pot|ppts|jpg|png';
	    $config['max_size']	= '10240';
	    $config['remove_spaces'] = true;
	    
	    $this->load->library('upload', $config);
	    
	    if ($this->upload->do_upload('file')){
	    	$file_data = $this->upload->data('file');
	    	$file = $file_data['file_name'];
	    }
	    
		$sql = $this->db->insert_string('contact_logs', array(
			'contact_id'		=> $contact_id,
			'case_id'			=> $id,
			'subject'			=> $this->input->post('subject'),
			'description'		=> $this->input->post('description'),
			'status'			=> $this->input->post('status'),
			'file'				=> $file,
			'added_on'			=> date('Y-m-d H:i:s'),
			'added_by'			=> $this->user->data('username')
		));
		
		$query = $this->db->query($sql);
		
		$id = $query->insert_id;
		
		$sql = $this->db->update_string('contact_cases', array(
			'description'		=> $this->input->post('description'),
			'log_date'			=> date('Y-m-d H:i:s'),
			'log_status'		=> $this->input->post('status'),
			'log_user'			=> $this->user->data('username')
		), "`id` = '{$id}'");
		
		$this->db->query($sql);
		
		return $this->get_log_by_id($id);
	}
	
	function Edit_log($id){
		$sql = $this->db->update_string('contact_logs', array(
			'description'		=> $this->input->post('description'),
			'priority'			=> $this->input->post('priority'),
			'modified_on'		=> date('Y-m-d H:i:s'),
			'modified_by'		=> $this->user->data('username')
		), "`id` = '{$id}'");
		
		$this->db->query($sql);
	}
	
	function Delete_log($id){
		$this->db->query("DELETE FROM `contact_logs` WHERE `id` = ?", array($id));
		
	}
	
	function Add_case($id){
	
		$sql = $this->db->insert_string('contact_cases', array(
			'contact_id'		=> $id,
			'subject'			=> $this->input->post('subject'),
			'description'		=> $this->input->post('description'),
			'file_location'		=> $this->input->post('file_location'),
			'reference_no'		=> $this->input->post('reference_no'),
			'status'			=> $this->input->post('status'),
			'added_on'			=> date('Y-m-d H:i:s'),
			'added_by'			=> $this->user->data('username'),
			'log_date'			=> date('Y-m-d H:i:s'),
			'log_status'		=> $this->input->post('status'),
			'log_user'			=> $this->user->data('username')
		));
	
		$query = $this->db->query($sql);
		
		$case_id = $query->insert_id;
		
		$sql = $this->db->insert_string('contact_logs', array(
			'contact_id'		=> $id,
			'case_id'			=> $case_id,
			'subject'			=> $this->input->post('subject'),
			'description'		=> $this->input->post('description'),
			'status'			=> $this->input->post('status'),
			'added_on'			=> date('Y-m-d H:i:s'),
			'added_by'			=> $this->user->data('username')
		));
		
		$this->db->query($sql);
	}
	
	function Edit_case($id){
		$sql = $this->db->update_string('contact_cases', array(
			'file_location'		=> $this->input->post('file_location'),
			'reference_no'		=> $this->input->post('reference_no'),
			'description'		=> $this->input->post('description'),
			'status'			=> $this->input->post('status'),
			'modified_on'		=> date('Y-m-d H:i:s'),
			'modified_by'		=> $this->user->data('username'),
			'log_date'			=> date('Y-m-d H:i:s')
		), "`id` = '{$id}'");
		
		$this->db->query($sql);
	}
	
	function Get_cases($filter){
		if ($filter) $filter = 'WHERE ' . $filter;
		$query = $this->db->query("SELECT * FROM `contact_cases` {$filter}");
		return $query->result();
	}
	
	function Get_cases_by_contact($id){
		$query = $this->db->query("SELECT * FROM `contact_cases` WHERE `contact_id` = ? ORDER BY `added_on` DESC", array($id));
		return $query->result();
	}
	
	function Get_case_by_id($id){
		$query = $this->db->query("SELECT * FROM `contact_cases` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Get_case_by_ref($ref){
		$query = $this->db->query("SELECT * FROM `contact_cases` WHERE `reference_no` = ?", array($ref));
		return $query->row();		
	}
	
	function Get_logs_by_case($id){
		$query = $this->db->query("SELECT * FROM `contact_logs` WHERE `case_id` = ? ORDER BY `added_on` DESC", array($id));
		return $query->result();		
	}
	
	function Get_log_by_id($id){
		$query = $this->db->query("SELECT * FROM `contact_logs` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Get_points_by_contact($id){
		$query = $this->db->query("SELECT SUM(FLOOR(`amount`)) AS `total_amount` FROM `sales` WHERE `customer_id` = ? AND `payment_status` = 'Paid' AND `type` = 'history'", array($id));
	    $point_sales = $query->row();
	    
	    $query = $this->db->query("SELECT SUM(FLOOR(`total_delivered`)) AS `total_amount` FROM `invoices` WHERE `contact_id` = ? AND `payment_status` = 'Paid'", array($id));
	    $point_invoices = $query->row();
	    
	    $total = $point_sales->total_amount + $point_invoices->total_amount;
	    
	    $amount = $this->system->config('member_minimum_amount');
	    $ppa = $this->system->config('member_minimum_point');
	    
	    $query = $this->db->query("SELECT SUM(`points`) AS `total_points` FROM `sale_items` WHERE `is_redemption` = 1 AND `member_id` = ?", array($id));
	    $points_redeemed = $query->row();

	    return (floor($total / $amount) * $ppa) - $points_redeem->total_points;
	}

	function Add(){
	
		
		
		$sql = $this->db->insert_string('contacts',array(
			'tax_no'				=> $this->input->post('tax_no'),
			'is_customer'			=> $this->input->post('is_customer'),
			'is_agent'				=> $this->input->post('is_agent'),
			'is_prospect'			=> $this->input->post('is_prospect'),
			'is_creditor'			=> $this->input->post('is_creditor'),
			'is_member'				=> $this->input->post('is_member'),
			'is_stakeholder'		=> $this->input->post('is_stakeholder'),
			'is_franchise'			=> $this->input->post('is_franchise'),
			'company_name'			=> $this->input->post('company_name'),
			'company_registration'	=> $this->input->post('company_registration'),
			'contact_person'		=> $this->input->post('contact_person'),
			'ic'					=> $this->input->post('ic'),
			'contact_number'		=> $this->input->post('contact_number'),
			'credit_limit'			=> $this->input->post('credit_limit'),
			'credit_term'			=> $this->input->post('credit_term'),
			'discount_limit'		=> $this->input->post('discount_limit'),
			'rank'					=> $this->input->post('rank_other') ? $this->input->post('rank_other') : $this->input->post('rank'),
			'address1'				=> $this->input->post('address1'),
			'address2'				=> $this->input->post('address2'),
			'city'					=> $this->input->post('city'),
			'zipcode'				=> $this->input->post('zipcode'),
			'state'					=> $this->input->post('state'),
			'country'				=> $this->input->post('country'),
			'tel'					=> $this->input->post('tel'),
			'fax'					=> $this->input->post('fax'),
			'general_email'			=> $this->input->post('general_email'),
			'terms'					=> $this->input->post('terms'),
			'remarks'				=> $this->input->post('remarks'),
			'description'			=> $this->input->post('description'),
			'tags'					=> $this->input->post('tags'),
			'email'					=> $this->input->post('email'),
			'password'				=> $this->input->post('password') ? md5($this->input->post('password')) : '',
			'added_on'				=> date('Y-m-d H:i:s'),
			'added_by'				=> $this->user->data('username'),
			'status'				=> $this->input->post('status')
		));
		
		$query = $this->db->query($sql);
		$id = $query->insert_id;
		
		$this->system->tag($this->input->post('tags'));
		
		return $this->get_contact_by_id($id);
		
	}
	
	function Edit($id){
		$contact = $this->get_contact_by_id($id);
	
		$sql = $this->db->update_string('contacts',array(
			'tax_no'				=> $this->input->post('tax_no'),
			'is_customer'			=> $this->input->post('is_customer'),
			'is_supplier'			=> $this->input->post('is_supplier'),
			'is_agent'				=> $this->input->post('is_agent'),
			'is_prospect'			=> $this->input->post('is_prospect'),
			'is_member'				=> $this->input->post('is_member'),
			'is_stakeholder'		=> $this->input->post('is_stakeholder'),
			'is_franchise'			=> $this->input->post('is_franchise'),
			'company_name'			=> $this->input->post('company_name'),
			'company_registration'	=> $this->input->post('company_registration'),
			'contact_person'		=> $this->input->post('contact_person'),
			'ic'					=> $this->input->post('ic'),
			'contact_number'		=> $this->input->post('contact_number'),
			'credit_limit'			=> $this->input->post('credit_limit'),
			'credit_term'			=> $this->input->post('credit_term'),
			'discount_limit'		=> $this->input->post('discount_limit'),
			'rank'					=> $this->input->post('rank_other') ? $this->input->post('rank_other') : $this->input->post('rank'),
			'address1'				=> $this->input->post('address1'),
			'address2'				=> $this->input->post('address2'),
			'city'					=> $this->input->post('city'),
			'zipcode'				=> $this->input->post('zipcode'),
			'state'					=> $this->input->post('state'),
			'country'				=> $this->input->post('country'),
			'tel'					=> $this->input->post('tel'),
			'fax'					=> $this->input->post('fax'),
			'general_email'			=> $this->input->post('general_email'),
			'terms'					=> $this->input->post('terms'),
			'remarks'				=> $this->input->post('remarks'),
			'tags'					=> $this->input->post('tags'),
			'email'					=> $this->input->post('email'),
			'password'				=> $this->input->post('password') ? md5($this->input->post('password')) : $contact->password,
			'description'			=> $this->input->post('description'),
			'modified_on'			=> date('Y-m-d H:i:s'),
			'modified_by'			=> $this->user->data('username'),
			'status'				=> $this->input->post('status')
		), "`id` = '{$id}'");
		
		$this->db->query($sql);
		
		return $this->get_contact_by_id($id);
	}
	
	function Delete($id){
		$contact = $this->get_contact_by_id($id);
		
		$this->db->query("DELETE FROM `contacts` WHERE `id` = ?", array($id));
		
		return $contact;
	}
	
	function Get_contacts($where){
		if ($where){
			$query = $this->db->query("SELECT * FROM `contacts` WHERE {$where}");
		} else {
			$query = $this->db->query("SELECT * FROM `contacts` ORDER BY `id` ASC");
		}
		
		return $query->result();
	}
	
	function Get_contact_by_id($id){
	
		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($id));
		return $query->row();
	
	}
	
	function Get_contact_by_ic($ic){
	
		$query = $this->db->query("SELECT * FROM `contacts` WHERE `ic` = ?", array($ic));
		return $query->row();
	
	}
	
	function Contacts_dropdown($dropdown = false, $type){

		if ($dropdown) $contacts_array[''] = "Select Contact";
		
		if ($type){
			if (strpos($type,',')){
				$types = explode(',', $type);
			} else {
				$types[] = $type;
			}
			
			foreach ($types as $type){
				$sql_type = strtolower($type);
				$query = $this->db->query("SELECT * FROM `contacts` WHERE `is_{$sql_type}` = 1");
				foreach ($query->result() as $contact){
					$contacts_array[$type][$contact->id] = $contact->company_name ? $contact->company_name : $contact->contact_person;
				}
			}
			
		} else {
		
			$query = $this->db->query("SELECT * FROM `contacts` WHERE `company_name` <> ''");
			foreach ($query->result() as $contact){
				$contacts_array['Company'][$contact->id] = $contact->company_name;
			}
			
			$query = $this->db->query("SELECT * FROM `contacts` WHERE `company_name` = '' OR `company_name` IS NULL ");
			foreach ($query->result() as $contact){
				$contacts_array['Contact'][$contact->id] = $contact->contact_person;
			}

		}
		return $contacts_array;
	}
	

}
