<?php

class FB extends Model {

	function get_items($filter){
		$query = $this->db->query("SELECT * FROM `fnb_inventory` $filter");
		return $query->result();
	}
		
	function get_item_by_id($id){
		$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `id` = ?", array($id));
		$item = $query->row();
		return $item;
	}
	
	function get_item_by_sku($sku){
		$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `sku` = ?", array($sku));
		return $query->row();
	}
	
	function add_item(){
		$cat = $this->input->post('category');
		$cat_other = $this->input->post('category_other');
		if ($cat_other) $cat = $cat_other;
		
		$subcat = $this->input->post('subcategory');
		$subcat_other = $this->input->post('subcategory_other');
		if ($subcat_other) $subcat = $subcat_other;
		
		$query = $this->db->query("SELECT `iphone`, `order` FROM `fnb_inventory` WHERE `category` = ? LIMIT 1", array($cat));
		$category = $query->row();

		if (!($price_x = json_encode($this->input->post('price')))){
			$price_x = '';			
		}
		
		if (!($option_x = json_encode($this->input->post('option')))){
			$option_x = '';
		}
		
		$price_x = $price_x == 'false' ? '' : $price_x;
		$option_x = $option_x == 'false' ? '' : $option_x;
		
		
		
		if (!($customer_price_x = json_encode($this->input->post('customer_price')))){
			$customer_price_x = '';			
		}
		
		if (!($customer_option_x = json_encode($this->input->post('customer_option')))){
			$customer_option_x = '';
		}
		
		$customer_price_x = $customer_price_x == 'false' ? '' : $customer_price_x;
		$customer_option_x = $customer_option_x == 'false' ? '' : $customer_option_x;

		
		
		$sql = $this->db->insert_string('fnb_inventory',array(
			'name'			=> $this->input->post('name'),
			'category'		=> $cat,
			'subcategory'	=> $subcat,
			'location'		=> $this->input->post('location'),
			'sku'			=> $this->input->post('sku'),
			'si_item_id'	=> $this->input->post('si_item_id'),
			'item_price'	=> $this->input->post('item_price'),
			'quick'			=> $this->input->post('quick'),
			'cost'			=> $this->input->post('cost'),
			'max_quantity'	=> $this->input->post('max_quantity'),
			'alert_quantity'=> $this->input->post('alert_quantity'),
			'price'			=> $price_x,
			'has_options'	=> $this->input->post('has_options'),
			'options'		=> $option_x,
			'customer_price'		=> $customer_price_x,
			'has_customer_options'	=> $this->input->post('has_customer_options'),
			'customer_options'		=> $customer_option_x,
			'remarks'		=> $this->input->post('remarks'),
			'description'	=> $this->input->post('description'),
			'alert_quantity'=> $this->input->post('alert_quantity'),
			'enter_price'	=> $this->input->post('enter_price'),
	    	'purchase_tax_code'	=> $this->input->post('purchase_tax_code'),
	    	'purchase_taxable'	=> $this->input->post('purchase_taxable'),
	    	'supply_tax_code'	=> $this->input->post('supply_tax_code'),
	    	'supply_taxable'	=> $this->input->post('supply_taxable'),
			'added_on'		=> date('Y-m-d H:i:s'),
			'added_by'		=> $this->user->data('username'),
			'iphone'		=> $category->iphone,
			'order'			=> $category->order,
			'printer'		=> $this->input->post('printer')
		));
		
		$this->db->query($sql);
	}
	
	function edit_item($id){
		$cat = $this->input->post('category');
		$cat_other = $this->input->post('category_other');
		if ($cat_other) $cat = $cat_other;
		
		$subcat = $this->input->post('subcategory');
		$subcat_other = $this->input->post('subcategory_other');
		if ($subcat_other) $subcat = $subcat_other;
		
		
		if (!($price_x = json_encode($this->input->post('price')))){
			$price_x = '';			
		}
		
		if (!($option_x = json_encode($this->input->post('option')))){
			$option_x = '';
		}
		
		$price_x = $price_x == 'false' ? '' : $price_x;
		$option_x = $option_x == 'false' ? '' : $option_x;
		
		
		if (!($customer_price_x = json_encode($this->input->post('customer_price')))){
			$customer_price_x = '';			
		}
		
		if (!($customer_option_x = json_encode($this->input->post('customer_option')))){
			$customer_option_x = '';
		}
		
		$customer_price_x = $customer_price_x == 'false' ? '' : $customer_price_x;
		$customer_option_x = $customer_option_x == 'false' ? '' : $customer_option_x;



		$sql = $this->db->update_string('fnb_inventory',array(
			'name'			=> $this->input->post('name'),
			'category'		=> $cat,
			'subcategory'	=> $subcat,
			'location'		=> $this->input->post('location'),
			'alert_quantity'=> $this->input->post('alert_quantity'),
			'item_price'	=> $this->input->post('item_price'),
			'sku'			=> $this->input->post('sku'),
			'si_item_id'	=> $this->input->post('si_item_id'),
			'quick'			=> $this->input->post('quick'),
			'cost'			=> $this->input->post('cost'),
			'max_quantity'	=> $this->input->post('max_quantity'),
			'price'			=> $price_x,
			'has_options'	=> $this->input->post('has_options'),
			'options'		=> $option_x,
			'customer_price'		=> $customer_price_x,
			'has_customer_options'	=> $this->input->post('has_customer_options'),
			'customer_options'		=> $customer_option_x,
			'remarks'		=> $this->input->post('remarks'),
			'description'	=> $this->input->post('description'),
			'alert_quantity'=> $this->input->post('alert_quantity'),
			'enter_price'	=> $this->input->post('enter_price'),
	    	'purchase_tax_code'	=> $this->input->post('purchase_tax_code'),
	    	'purchase_taxable'	=> $this->input->post('purchase_taxable'),
	    	'supply_tax_code'	=> $this->input->post('supply_tax_code'),
	    	'supply_taxable'	=> $this->input->post('supply_taxable'),
			'added_on'		=> date('Y-m-d H:i:s'),
			'added_by'		=> $this->user->data('username'),
			'printer'		=> $this->input->post('printer')

		),"`id` = '$id'");
		
		$this->db->query($sql);
	}
	
	function delete_item($id){
		$this->db->query("DELETE FROM `fnb_inventory` WHERE `id` = ?",array($id));
	}
	
	function get_items_by_category($category){
		$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `category` = ?",array($category));
		return $query->result();
	}	

	function get_categories($dropdown = false){
		$query = $this->db->query("SELECT `category` FROM `fnb_inventory` GROUP BY `category` ORDER BY `category` ASC");
		if ($dropdown) $categories[] = "Select Category";
		foreach ($query->result() as $cat){
			$categories[$cat->category] = $cat->category;
		}
		return $categories;
	}
	
	function get_subcategories($dropdown = false){
		$query = $this->db->query("SELECT `subcategory` FROM `fnb_inventory` GROUP BY `subcategory` ORDER BY `category` ASC");
		if ($dropdown) $categories[] = "Select Subcategory";
		foreach ($query->result() as $cat){
			$categories[$cat->subcategory] = $cat->subcategory;
		}
		return $categories;
	}
	
	function get_printers(){
		$query = $this->db->query("SELECT * FROM `fnb_printer_map`");
		return $query->result();
	}
	
	function get_printer_by_id($id){
		$query = $this->db->query("SELECT * FROM `fnb_printer_map` WHERE `id` = ?", array($id));
		return $query->row();	
	}
	
	function add_printer(){
		$categories = implode(',',$this->input->post('categories'));
		$sql = $this->db->insert_string('fnb_printer_map',array(
			'categories' 	=> $categories,
			'waiter_copy'	=> $this->input->post('waiter_copy'),
			'printer_ip'	=> $this->input->post('printer_ip')
		));
		$this->db->query($sql);
	}
	
	function edit_printer($id){
		$categories = implode(',',$this->input->post('categories'));
		$sql = $this->db->update_string('fnb_printer_map',array(
			'categories' 	=> $categories,
			'waiter_copy'	=> $this->input->post('waiter_copy'),
			'printer_ip'	=> $this->input->post('printer_ip')
		),"`id` = '$id'");
		$this->db->query($sql);	
	}
	
	function delete_printer($id){
		$this->db->query("DELETE FROM `fnb_printer_map` WHERE `id` =?", array($id));
	}
	
	function get_sst(){
		$query = $this->db->query("SELECT * FROM `fnb_self_service_map`");
		return $query->result();
	}
	
	function get_sst_by_id($id){
		$query = $this->db->query("SELECT * FROM `fnb_self_service_map` WHERE `id` = ?", array($id));
		return $query->row();	
	}
	
	function add_sst(){
		$categories = implode(',',$this->input->post('categories'));
		$sql = $this->db->insert_string('fnb_self_service_map',array(
			'categories' 	=> $categories,
			'printer'		=> $this->input->post('printer'),
			'terminal_id'	=> $this->input->post('terminal_id')
		));
		$this->db->query($sql);
	}
	
	function edit_sst($id){
		$categories = implode(',',$this->input->post('categories'));
		$sql = $this->db->update_string('fnb_self_service_map',array(
			'categories' 	=> $categories,
			'printer'		=> $this->input->post('printer'),
			'terminal_id'	=> $this->input->post('terminal_id')
		),"`id` = '$id'");
		$this->db->query($sql);	
	}
	
	function delete_sst($id){
		$this->db->query("DELETE FROM `fnb_self_service_map` WHERE `id` =?", array($id));
	}

}