<?php

class HRM extends Model {

	function Get_vacancy($id){
		$query = $this->db->query("SELECT * FROM `vacancies` WHERE `id` = '$id'");
		$vacancy = $query->row();

		$manager = $this->get_employee("`id` = '{$vacancy->manager}'");
		$applicants = $this->get_applicants("`vacancy_id` = '{$vacancy->id}'");
		
		$vacancy->applicants = $applicants;
		$vacancy->manager_name = $manager->firstname . ' ' . $manager->lastname;
		return $vacancy;
	}

	function Get_recruitments($where){
		if ($where){
			$sql_filter = " WHERE " . $where;
		}
		$query = $this->db->query("SELECT * FROM `vacancies` $sql_filter");
		foreach ($query->result() as $vacancy){
			$applicants = $this->get_applicants("`vacancy_id` = '{$vacancy->id}'");
			$manager = $this->get_employee("`id` = '{$vacancy->manager}'");
			$vacancy->manager_name = $manager->firstname . ' ' . $manager->lastname;
			$vacancy->total_applicants = count($applicants);
			$recruitments[] = $vacancy;
		}
		return $recruitments;
	}
	
	function Get_cico_by_time($id, $from, $to){
		$query = $this->db->query("SELECT * FROM `employee_cico` WHERE `employee_id` = ? AND `check_in` >= ? AND `check_in` <= ?", array($id, $from, $to));
		$this->d['cico'] = $query->result();
	}
	
	function Get_applicants($where){
		if ($where){
			$sql_filter = " WHERE " . $where;
		}
		$query = $this->db->query("SELECT * FROM `applicants` $sql_filter");
		return $query->result();
	}
	
	function Get_applicant($id){
		$query = $this->db->query("SELECT * FROM `applicants` WHERE `id` = '$id'");
		return $query->row();
	}

	function Get_leave_list(){
		$query = $this->db->query("SELECT leave.id, leave.type, leave.from, leave.to, leave.remarks, leave.status, 
									employees.firstname, employees.lastname 
									FROM `leave` LEFT JOIN employees ON leave.employee_id = employees.id ORDER BY leave.from DESC");
		return $query->result();
	}
	
	function Get_leave($id){
		$query = $this->db->query("SELECT * FROM `leave` WHERE `id` = '$id'");
		$leave = $query->row();
		
		$query = $this->db->query("SELECT * FROM `employees` WHERE `id` = '{$leave->employee_id}'");
		$leave->employee = $query->row();
		
		return $leave;
	}
	
	function Approve_leave($id){
		$sql = $this->db->update_string('leave',array(
			'status' => 'Approved'
		),"`id` = '$id'");
		$this->db->query($sql);
	}
	
	function Get_employees($where){
		if ($where){
			$query = $this->db->query("SELECT * FROM `employees` WHERE {$where}");
		} else {
			$query = $this->db->query("SELECT * FROM `employees`");
		}
		
		return $query->result();
	}
	
	function Get_employee_dropdown(){
		$query = $this->db->query("SELECT * FROM `employees` ORDER BY `firstname` ASC");
		foreach ($query->result() as $employee){
			$employees[$employee->id] = $employee->firstname . ' ' . $employee->lastname;
		}
		
		return $employees;
		
	}
	
	function Get_manager_dropdown(){
		$query = $this->db->query("SELECT * FROM `employees` WHERE `is_manager` = 1 ORDER BY `firstname` ASC");
		foreach ($query->result() as $manager){
			$managers[$manager->id] = $manager->firstname . ' ' . $manager->lastname;
		}
		
		return $managers;
	}
	
	function Get_employee_list($filter){
		$query = $this->db->query("SELECT employees.id, employees.firstname, employees.lastname, employment.job_title, 
									employment.status, employment.division
									FROM employees LEFT JOIN employment ON employment.employee_id = employees.id $filter");
		return $query->result();
	}
	
	function Get_employee_by_id($id){
		$query = $this->db->query("SELECT * FROM `employees` WHERE `id` = ?", array($id));
		$employee = $query->row();		
		return $employee;
	}
	
	function Get_employee_cico($id, $from, $to){
		if (!$from && !$to){
			$from = date('Y-m-1');
			$to = date('Y-m-t');
		}
		$query = $this->db->query("SELECT * FROM `employee_cico` WHERE `employee_id` = ? AND `check_in` <= ? AND `check_in` >= ?", array($id, $from, $to));
		return $query->result();
	}
	
	function Get_employee($where){
		if ($where){
			$query = $this->db->query("SELECT * FROM `employees` WHERE $where");
		} else {
			$query = $this->db->query("SELECT * FROM `employees`");
		}
		$employee = $query->row();
		
		$query = $this->db->query("SELECT * FROM `employee_dependents` WHERE `employee_id` = '{$employee->id}'");
		$employee->dependents = $query->result();
		
		$query = $this->db->query("SELECT * FROM `employee_education` WHERE `employee_id` = '{$employee->id}'");
		$employee->education = $query->result();
		
		$query = $this->db->query("SELECT * FROM `employee_documents` WHERE `employee_id` = '{$employee->id}'");
		$employee->documents = $query->result();
		
		$query = $this->db->query("SELECT * FROM `employee_emergency_contacts` WHERE `employee_id` = '{$employee->id}'");
		$employee->emergency_contacts = $query->result();
		
		$query = $this->db->query("SELECT * FROM `employee_languages` WHERE `employee_id` = '{$employee->id}'");
		$employee->languages = $query->result();
		
		$query = $this->db->query("SELECT * FROM `employee_licenses` WHERE `employee_id` = '{$employee->id}'");
		$employee->licenses = $query->result();
		
		$query = $this->db->query("SELECT * FROM `employee_skills` WHERE `employee_id` = '{$employee->id}'");
		$employee->skills = $query->result();

		$query = $this->db->query("SELECT * FROM `employee_work_experience` WHERE `employee_id` = '{$employee->id}'");
		$employee->work_experience = $query->result();
		
		$query = $this->db->query("SELECT * FROM `employment` WHERE `employee_id` = '{$employee->id}'");
		$employee->employment = $query->row();
		
		$query = $this->db->query("SELECT * FROM `report_to` WHERE `supervisor_id` = '{$employee->id}'");
		$employee->subordinates = $query->result();
		
		$query = $this->db->query("SELECT * FROM `report_to` WHERE `subordinate_id` = '{$employee->id}'");
		$employee->supervisors = $query->result();

		return $employee;		
	}
	
	function Edit_applicant($id){
		list($day,$month,$year) = explode('/', $this->input->post('dob'));
		$dob = $year . '-' . $month . '-' . $day;
		
		$sql = $this->db->update_string('applicants',array(
			'firstname'		=> $this->input->post('firstname'),
			'lastname'		=> $this->input->post('lastname'),
			'location'		=> $this->input->post('location'),
			'gender'		=> $this->input->post('gender'),
			'dob'			=> $dob,
			'phone'			=> $this->input->post('phone'),
			'mobile'		=> $this->input->post('mobile'),
			'remarks'		=> $this->input->post('remarks'),
			'status'		=> $this->input->post('status')
		),"`id` = '$id'");
		
		if ($this->db->query($sql)) return true;
		return false;
	}

	
	function Add_applicant($vacancy_id){
		list($day,$month,$year) = explode('/', $this->input->post('dob'));
		$dob = $year . '-' . $month . '-' . $day;
		
		$sql = $this->db->insert_string('applicants',array(
			'vacancy_id'	=> $vacancy_id,
			'firstname'		=> $this->input->post('firstname'),
			'lastname'		=> $this->input->post('lastname'),
			'location'		=> $this->input->post('location'),
			'gender'		=> $this->input->post('gender'),
			'dob'			=> $dob,
			'phone'			=> $this->input->post('phone'),
			'mobile'		=> $this->input->post('mobile'),
			'remarks'		=> $this->input->post('remarks'),
			'status'		=> $this->input->post('status')
		));
		
		if ($this->db->query($sql)) return true;
		return false;
	}
	
	function Edit_vacancy($id){

		list($day,$month,$year) = explode('/', $this->input->post('closing_date'));
		$date = $year . '-' . $month . '-' . $day;

		$sql = $this->db->update_string('vacancies',array(
			'job_title'		=> $this->input->post('job_title'),
			'manager'		=> $this->input->post('manager'),
			'closing_date'	=> $date,
			'status'		=> $this->input->post('status'),
			'description'	=> $this->input->post('description')			
		),"`id` = '$id'");
		
		if ($this->db->query($sql)) return true;
		return false;
	}
	
	function Add_vacancy(){

		list($day,$month,$year) = explode('/', $this->input->post('closing_date'));
		$date = $year . '-' . $month . '-' . $day;

		$sql = $this->db->insert_string('vacancies',array(
			'job_title'		=> $this->input->post('job_title'),
			'manager'		=> $this->input->post('manager'),
			'closing_date'	=> $date,
			'status'		=> $this->input->post('status'),
			'description'	=> $this->input->post('description')			
		));
		
		if ($this->db->query($sql)) return true;
		return false;
	}
	
	function Assign_leave(){
	
		list($day,$month,$year) = explode('/', $this->input->post('from'));
		$from = $year . '-' . $month . '-' . $day;

		list($day,$month,$year) = explode('/', $this->input->post('to'));
		$to = $year . '-' . $month . '-' . $day;

		$sql = $this->db->insert_string('leave',array(
			'employee_id'		=> $this->input->post('employee_id'),
			'from'				=> $from,
			'to'				=> $to,
			'type'				=> $this->input->post('type'),
			'remarks'			=> $this->input->post('remarks'),
			'status'			=> $this->input->post('status')
		));
		
		if ($this->db->query($sql)) return true;
		return false;
	}
	
	function Edit_leave($id){
	
		list($day,$month,$year) = explode('/', $this->input->post('from'));
		$from = $year . '-' . $month . '-' . $day;

		list($day,$month,$year) = explode('/', $this->input->post('to'));
		$to = $year . '-' . $month . '-' . $day;

		$sql = $this->db->update_string('leave',array(
			'from'				=> $from,
			'to'				=> $to,
			'type'				=> $this->input->post('type'),
			'remarks'			=> $this->input->post('remarks'),
			'status'			=> $this->input->post('status')
		),"`id` = '$id'");
		
		if ($this->db->query($sql)) return true;
		return false;
	}
	

	
	function Add_employee(){
		list($day,$month,$year) = explode('/', $this->input->post('dob'));
		$dob = $year . '-' . $month . '-' . $day;
		$sql = $this->db->insert_string('employees',array(
			'firstname' 		=> $this->input->post('firstname'),
			'lastname'			=> $this->input->post('lastname'),
			'gender'			=> $this->input->post('gender'),
			'nationality'		=> $this->input->post('nationality'),
			'ic_no'				=> $this->input->post('ic_no'),
			'dob'				=> $dob,
			'marital_status'	=> $this->input->post('marital_status'),
			'race'				=> $this->input->post('race'),
			'photo'				=> $photo,
			'address1'			=> $this->input->post('address_1'),
			'address2'			=> $this->input->post('address_2'),
			'city'				=> $this->input->post('city'),
			'zipcode'			=> $this->input->post('postcode'),
			'stateprov'			=> $this->input->post('stateprov'),
			'country'			=> $this->input->post('country'),
			'home_phone'		=> $this->input->post('home_phone'),
			'mobile'			=> $this->input->post('mobile'),
			'work_phone'		=> $this->input->post('work_phone'),
			'work_email'		=> $this->input->post('work_email'),
			'other_email'		=> $this->input->post('other_email'),
			'tags'				=> $this->input->post('tags'),
			'is_manager'		=> $this->input->post('is_manager'),
			'is_cashier'		=> $this->input->post('is_cashier')
		));
		
		$query = $this->db->query($sql);
		$employee_id = $query->insert_id;
		
		return $employee_id;
	}
	
	function Edit_employee($id){
		list($day, $month, $year) = explode('/',$this->input->post('dob'));
		$dob = $year . '-' . $month . '-' . $day;
	
		$sql = $this->db->update_string('employees',array(
			'firstname' 		=> $this->input->post('firstname'),
			'lastname'			=> $this->input->post('lastname'),
			'gender'			=> $this->input->post('gender'),
			'ic_no'				=> $this->input->post('ic_no'),
			'nationality'		=> $this->input->post('nationality'),
			'dob'				=> $dob,
			'marital_status'	=> $this->input->post('marital_status'),
			'race'				=> $this->input->post('race'),
			'address1'			=> $this->input->post('address_1'),
			'address2'			=> $this->input->post('address_2'),
			'city'				=> $this->input->post('city'),
			'zipcode'			=> $this->input->post('postcode'),
			'stateprov'			=> $this->input->post('stateprov'),
			'country'			=> $this->input->post('country'),
			'home_phone'		=> $this->input->post('home_phone'),
			'mobile'			=> $this->input->post('mobile'),
			'work_phone'		=> $this->input->post('work_phone'),
			'work_email'		=> $this->input->post('work_email'),
			'other_email'		=> $this->input->post('other_email'),
			'tags'				=> $this->input->post('tags'),
			'is_manager'		=> $this->input->post('is_manager'),
			'is_cashier'		=> $this->input->post('is_cashier'),
			'socso_id'			=> $this->input->post('socso_id'),
			'epf_id'			=> $this->input->post('epf_id'),
			'tax_id'			=> $this->input->post('tax_id'),			
			'salary_category'	=> $this->input->post('salary_category')

		), "`id` = '{$id}'");
		
		$this->db->query($sql);


		list($day, $month, $year) = explode('/',$this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;
		
		
		$query = $this->db->query("SELECT * FROM `employment` WHERE `employee_id` = ?",array($id));
		if ($query->num_rows()){
				
			$sql = $this->db->update_string('employment',array(
				'job_title'			=> $this->input->post('job_title'),
				'status'			=> $this->input->post('status'),
				'date'				=> $date,
				'type'				=> $this->input->post('type'),
				'pay_grade'			=> $this->input->post('pay_grade'),
				'pay_frequency'		=> $this->input->post('pay_frequency'),
				'minimum_salary'	=> $this->input->post('minimum_salary'),
				'maximum_salary'	=> $this->input->post('maximum_salary'),
				'basic_salary'		=> $this->input->post('basic_salary')
			),"`employee_id` = '{$id}'");
			$this->db->query($sql);

		} else {
		
			$sql = $this->db->insert_string('employment',array(
				'employee_id'		=> $id,
				'job_title'			=> $this->input->post('job_title'),
				'status'			=> $this->input->post('status'),
				'date'				=> $date,
				'type'				=> $this->input->post('type'),
				'pay_grade'			=> $this->input->post('pay_grade'),
				'pay_frequency'		=> $this->input->post('pay_frequency'),
				'minimum_salary'	=> $this->input->post('minimum_salary'),
				'maximum_salary'	=> $this->input->post('maximum_salary'),
				'basic_salary'		=> $this->input->post('basic_salary')
			));
			$this->db->query($sql);
		
		}
		
		
		return true;
		
		
	}
	

	
	function Add_report_to($supervisor, $subordinate, $method){
		$sql = $this->db->insert_string('report_to',array(
			'supervisor_id'		=> $supervisor->id,
			'supervisor'		=> trim($supervisor->firstname . ' ' . $supervisor->lastname),
			'subordinate_id'	=> $subordinate->id,
			'subordinate'		=> trim($subordinate->firstname . ' ' . $subordiante->lastname),
			'reporting_method'	=> $method
		));
		
		if ($this->db->query($sql)) return true;
		return false;
	}
	
	function Job_category_data(){
		
	}
	
	function Job_by_division_data(){
		$query = $this->db->query("SELECT COUNT(`division`) as `total`, `division` FROM `employment` GROUP BY `division`");
		foreach ($query->result() as $employment){
			$result[$employment->division . ' ('.$employment->total.')'] = $employment->total;
		}
		return $result;
	}

	function Job_by_gender_data(){
		$query = $this->db->query("SELECT COUNT(`gender`) as `total`, `gender` FROM `employees` GROUP BY `gender`");
		foreach ($query->result() as $employment){
			$result[$employment->gender . ' ('.$employment->total.')'] = $employment->total;
		}
		return $result;
	}
	
	function Add_payslip(){
		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;
		
		$id = $this->input->post('employee');
		$employee = $this->hrm->get_employee("`id` = '{$id}'");
		
		$sql = $this->db->insert_string('salary_voucher', array(
			'datetime'		=> $date,
			'employee_id'	=> $employee->id,
			'employee'		=> $employee->firstname . ' ' . $employee->lastname,
			'status'		=> 'Created'
		));
		
		$query = $this->db->query($sql);
		$sv_id = $query->insert_id;
		
		$items = $this->input->post('fields');
		
		foreach ($items as $field => $value){
			$query = $this->db->query("SELECT * FROM `salary_voucher_format` WHERE `field_name` = ?", array($field));
			$field = $query->row();
			
			$sql = $this->db->insert_string('salary_voucher_items',array(
				'sv_id'			=> $sv_id,
				'field'			=> $field->field_name,
				'field_id'		=> $field->id,
				'type'			=> $field->type,
				'description'	=> $field->name,
				'amount'		=> $value,
				'datetime'		=> $date
			));
			
			if ($field->type == 'Basic' || $field->type == 'Add') $total += $value;
			if ($field->type == 'Deduct') $total -= $value;
			
			if ($field->type == 'Null') $null_total += $value;
			
			$this->db->query($sql);
		}
		
		
		$sql = $this->db->update_string('salary_voucher', array(
			'amount'			=> $total,
			'amount_employer'	=> $null_total
		),"`id` = '{$sv_id}'");
		
		$this->db->query($sql);
	}
	
	function Get_payslip_by_id($id){

		$query = $this->db->query("SELECT * FROM `salary_voucher` WHERE `id` = ?", array($id));
		$sv = $query->row();
				
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND (`type` = 'Add' OR `type` = 'Basic')", array($id));
		$sv->earnings = $query->result();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND `type` = 'Deduct'", array($id));
		$sv->deductions = $query->result();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND `type` = 'Null'", array($id));
		$sv->other = $query->result();
		
		return $sv;
		
	}
	
	function Get_payslip_format($type){
		
		$filter = where_filter(array(
			'type'	=> $type
		));
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_format` $filter");
		
		return $query->result();
	}
	
	function Add_sv_field(){
		$field_name = $this->input->post('field_name');
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_format` WHERE `field_name` = ?", array($field_name));
		if ($query->num_rows()) return false;
		
		$sql = $this->db->insert_string('salary_voucher_format', array(
			'name'		=> $this->input->post('name'),
			'field_name'=> $this->input->post('field_name'),
			'type'		=> $this->input->post('type'),
			'percentage'=> $this->input->post('percent')
		));
		
		$query = $this->db->query($sql);
		
		return $query->insert_id;
		
	}
	
	function Edit_sv_field($id){
		$field_name = $this->input->post('field_name');
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_format` WHERE `field_name` = ?", array($field_name));
		$check_row = $query->row();
		
		if ($check_row->id != $id) return false;
			
		$sql = $this->db->update_string('salary_voucher_format', array(
			'name'		=> $this->input->post('name'),
			'field_name'=> $this->input->post('field_name'),
			'type'		=> $this->input->post('type'),
			'percentage'=> $this->input->post('percent')
		),"`id` = '{$id}'");

		$query = $this->db->query($sql);
		
		return true;		
	}
	
	function Get_salary_vouchers($where){
		if ($where){
			$query = $this->db->query("SELECT * FROM `salary_voucher` WHERE {$where}");
		} else {
			$query = $this->db->query("SELECT * FROM `salary_voucher` ORDER BY `id` DESC");
		}
		
		return $query->result();
	}
	

	function Get_sv_by_id($id){

		$query = $this->db->query("SELECT * FROM `salary_voucher` WHERE `id` = ?", array($id));
		$sv = $query->row();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ?", array($sv->id));
		$sv->items = $query->result();

		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND (`type` = 'Add' OR `type` = 'Basic')", array($sv->id));
		$sv->earnings = $query->result();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND `type` = 'Deduct'", array($sv->id));
		$sv->deductions = $query->result();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_items` WHERE `sv_id` = ? AND `type` = 'Null'", array($sv->id));
		$sv->other = $query->result();
		
		$query = $this->db->query("SELECT * FROM `salary_voucher_breakdown` WHERE `sv_id` = ?", array($sv->id));
		$sv->breakdown = $query->result();
		
		return $sv;
	
	}

	
}
