<?php

class Inv extends Model {

	function Inv(){
		parent::Model();
		
		$this->load->model('contact');
		$this->load->model('tax');
	}
	
	function Get_quantity_consigned($item_id){
		
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_consigned` FROM `sales_order_items` WHERE `consignment` = 1 AND `item_id` = ? AND `warehouse_id` = ?", array($item_id, $this->user->data('branch')));
		$consigned = $query->row();

		$query = $this->db->query("SELECT SUM(`delivered`) AS `total_delivered` FROM `invoice_items` WHERE `consignment` = 1 AND `item_id` = ? AND `warehouse_id` = ?", array($item_id, $this->user->data('branch')));
		$delivered = $query->row();
		
		$total->consigned 	= $consigned->total_consigned;
		$total->delivered 	= $delivered->total_delivered;
		$total->balance 	= $consigned->total_consigned - $delivered->total_delivered;
		
		return $total;
	}

	function Total_items(){
	
		$warehouse_id = $this->user->data('branch');

		if ($this->system->config('warehouse_shared_inventory'))
			$query = $this->db->query("SELECT COUNT(`id`) AS `total` FROM `inventory`");
		else {
			$query = $this->db->query("SELECT COUNT(`id`) AS `total` FROM `inventory` WHERE `warehouse_id` = ?", array($warehouse_id)); 
		}

		$items = $query->row();
		return $items->total;
	}
	
	function Total_categories(){
		$warehouse_id = $this->user->data('branch');

		if ($this->system->config('warehouse_shared_inventory'))
    		$query = $this->db->query("SELECT COUNT(`category`) AS `total` FROM `inventory` GROUP BY `category`");
    	else {
    		$query = $this->db->query("SELECT COUNT(`category`) AS `total` FROM `inventory` WHERE `warehouse_id` = ? GROUP BY `category` ", array($warehouse_id));
    	}

		$categories = $query->row();
		return $categories->total;
	}
	
	function Total_subcategories(){
		$warehouse_id = $this->user->data('branch');
		
		if ($this->system->config('warehouse_shared_inventory'))
    		$query = $this->db->query("SELECT COUNT(`subcategory`) AS `total` FROM `inventory` GROUP BY `subcategory`");
    	else {
    		$query = $this->db->query("SELECT COUNT(`subcategory`) AS `total` FROM `inventory` WHERE `warehouse_id` = ? GROUP BY `subcategory`", array($warehouse_id));
    	}

		$subcategories = $query->row();
		return $subcategories->total;
	}
	
	function Total_brands(){
		$warehouse_id = $this->user->data('branch');
		
		if ($this->system->config('warehouse_shared_inventory'))
			$query = $this->db->query("SELECT COUNT(`brand`) AS `total` FROM `inventory` GROUP BY `brand`");
		else {
			$query = $this->db->query("SELECT COUNT(`brand`) AS `total` FROM `inventory` WHERE `warehouse_id` = ? GROUP BY `brand`", array($warehouse_id));
		}
		
		$brands = $query->row();
		return $brands->total;
	}

	function Alert_items(){

		$warehouse_id = $this->user->data('branch');
		$query = $this->db->query("SELECT * FROM `inventory_stock_quantities` WHERE `qty` < `alert_quantity` AND `warehouse_id` = ?", array($warehouse_id));

		return $query->result();
	}

	function Get_items($filter){

		$warehouse_id = $this->user->data('branch');
		
		$query = $this->db->query("SELECT `item_id`, `cost`, `qty` FROM `inventory_stock_quantities` WHERE `warehouse_id` = ?", array($warehouse_id));
		$stocks = $query->result();
					
		foreach ($stocks as $stock){
			$item_stock[$stock->item_id] = $stock->qty;
			$item_cost[$stock->item_id] = $stock->cost;
		}
			
		if (!$this->system->config('warehouse_shared_inventory')){
			if (preg_match('/where/i',$filter)){
				$filter = preg_replace('/where/i', " WHERE `warehouse_id` = '{$warehouse_id}' AND ", $filter);
			} else {
				$filter = " WHERE `warehouse_id` = '{$warehouse_id}' " . $filter;
			}
		}
		
		$branch = $this->user->data('branch');
			
		$query = $this->db->query("SELECT * FROM `inventory` $filter");
		foreach ($query->result() as $item){
			$item->qty = $item_stock[$item->id] ? $item_stock[$item->id] : 0;
			$item->cost = $item_cost[$item->id] ? $item_cost[$item->id] : ($branch->id == 1 ? $item->cost : '0.00');
			$items[] = $item;
		}


		return $items;
	}

	function Get_purchase_order_by_item($item_id){
		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? ORDER BY `date` DESC", array($item_id));
		foreach ($query->result() as $order){
			$po = $this->get_po_by_id($order->purchase_order_id);
			$order->po = $po;
			$orders[] = $order;
		}
		return $orders;
	}
	
	function Get_price_history_by_item($item_id){
		$query = $this->db->query("SELECT MIN(`date`) AS `earliest_date`, MAX(`date`) AS `latest_date`, `price_per_unit`, SUM(`qty`) AS `total_qty` FROM `sale_items` WHERE `item_id` = ? GROUP BY `price_per_unit` ORDER BY `date` ASC", array($item_id));	
		return $query->result();
	}

	function Get_cost_history_by_item($item_id){
		$query = $this->db->query("SELECT MIN(`date`) AS `earliest_date`, MAX(`date`) AS `latest_date`, (`cost` / `qty`) AS `cost_per_unit`, SUM(`qty`) AS `total_qty` FROM `sale_items` WHERE `item_id` = ?  GROUP BY (`cost` / `qty`) ORDER BY `date` ASC", array($item_id));	
		return $query->result();
	}	

	function Get_sale_count_by_date($item_id, $date){
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_qty` FROM `sale_items` WHERE `item_id` = ? AND `date` <= ? GROUP BY `item_id", array($item_id, $date));
		$row = $query->row();
		return $row->total_qty;
	}
		
	function Get_categories($dropdown = false){
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT `category` FROM `inventory` WHERE `warehouse_id` = ? GROUP BY `category` ORDER BY `category` ASC", array($this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT `category` FROM `inventory` GROUP BY `category` ORDER BY `category` ASC");
		}
		if ($dropdown) $categories[] = "Select Category";
		foreach ($query->result() as $cat){
			$categories[$cat->category] = $cat->category;
		}
		$categories[0] = 'All';
		return $categories;
	}
	
	function Get_subcategories($dropdown = false){
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT `subcategory` FROM `inventory` WHERE `warehouse_id` = ? GROUP BY `subcategory` ORDER BY `subcategory` ASC", array($this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT `subcategory` FROM `inventory` GROUP BY `subcategory` ORDER BY `subcategory` ASC");
		}
		if ($dropdown) $categories[] = "Select Subcategory";
		foreach ($query->result() as $cat){
			$categories[$cat->subcategory] = $cat->subcategory;
		}
		$categories[0] = 'All';
		return $categories;
	}
	
	function Get_brands($dropdown = false){
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT `brand` FROM `inventory` WHERE `warehouse_id` = ? GROUP BY `brand` ORDER BY `brand` ASC", array($this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT `brand` FROM `inventory` GROUP BY `brand` ORDER BY `brand` ASC");
		}
		if ($dropdown) $categories[] = "Select Brand";
		foreach ($query->result() as $cat){
			$categories[$cat->brand] = $cat->brand;
		}
		$categories[0] = 'All';
		return $categories;
	}

	
	function Get_item_by_id($id){
		$warehouse_id = $this->user->data('branch');

		$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($id));
		$item = $query->row();
		
		$query = $this->db->query("SELECT `item_id`, `cost`, `qty` FROM `inventory_stock_quantities` WHERE `warehouse_id` = ? AND `item_id` = ?", array($warehouse_id, $item->id));
		$stocks = $query->row();

		$item->qty = $stocks->qty;
		$item->cost = str_replace(',','',number_format($stocks->cost,2));

		return $item;
	
	}
	
	function Get_item_by_sku($sku){
		$warehouse_id = $this->user->data('branch');
	
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ? AND `warehouse_id` = ?", array($sku, $this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?", array($sku));			
		}
		
		$item = $query->row();
		
		$query = $this->db->query("SELECT `item_id`, `cost`, `qty` FROM `inventory_stock_quantities` WHERE `warehouse_id` = ? AND `item_id` = ?", array($warehouse_id, $item->id));
		$stocks = $query->row();
					
		$item->qty = $stocks->qty;
		$item->cost = $stocks->cost;
				
		return $item;

	}
	
	function Add_item(){
		$cat = $this->input->post('category');
		$cat_other = $this->input->post('category_other');
		if ($cat_other) $cat = $cat_other;
				
		$subcat = $this->input->post('subcategory');
		$subcat_other = $this->input->post('subcategory_other');
		if ($subcat_other) $subcat = $subcat_other;
		
		$brand = $this->input->post('brand');
		$brand_other = $this->input->post('brand_other');
		if ($brand_other) $brand = $brand_other;
		
		$config['upload_path'] = '../assets/items/';
		$config['allowed_types'] = 'gif|jpg|png';
		$config['max_size']	= '1024';

		$this->load->library('upload', $config);
		$this->load->library('image_lib');

			
		$data = array('upload_data' => $this->upload->data());
		
		for ($i = 0; $i < 4; $i++){
			if ($this->upload->do_upload('item_photo_'.$i)){
				$image_data = $this->upload->data('item_photo_'.$i);
				$image_filename[] = $image_data['file_name'];
				if ($i == $this->input->post('primary_photo')){
					$primary_image = $image_data['file_name']; 					
				}
				
				// thumbnail config
				
				$img_config['image_library']	= 'gd2';
				$img_config['source_image']		= '../assets/items/'.$image_data['file_name'];
				$img_config['create_thumb']		= TRUE;
				$img_config['maintain_ratio']	= TRUE;
				$img_config['thumb_marker']		= '_plex_thumb50';
				$img_config['width']			= 50;
				$img_config['height']			= 50;

				$this->image_lib->initialize($img_config); 
				$this->image_lib->resize();
				$this->image_lib->clear();
				
				// standard size config
				
				$img_config['image_library']	= 'gd2';
				$img_config['source_image']		= '../assets/items/'.$image_data['file_name'];
				$img_config['create_thumb']		= TRUE;
				$img_config['maintain_ratio']	= TRUE;
				$img_config['thumb_marker']		= '_plex_standard300';
				$img_config['width']			= 300;
				$img_config['height']			= 300;

				$this->image_lib->initialize($img_config); 
				$this->image_lib->resize();
				$this->image_lib->clear();

			} 
		}
		
		$new_links = $this->input->post('links');
		if (strpos($new_links,',')){
			$new_variants = explode(',', $new_links);
		} else {
			if ($new_links) $new_variants[] = $new_links;
		}
		
		$sku = $this->input->post('sku');
		
		foreach ($new_variants as $variant){
			$this->db->update('inventory', array('linked'=>$sku), "`sku` = '{$variant}'");
		}

		
		$sql = $this->db->insert_string('inventory',array(
			'name'			=> $this->input->post('name'),
			'category'		=> $cat,
			'subcategory'	=> $subcat,
			'brand'			=> $brand,
	    	'image'			=> implode(',',$image_filename),
	    	'primary_image'	=> $primary_image,
	    	'links'			=> $this->input->post('links'),
			'location'		=> $this->input->post('location'),
			'sku'			=> $this->input->post('sku'),
			'sku2'			=> $this->input->post('sku2'),
			'sku3'			=> $this->input->post('sku3'),
			'sku4'			=> $this->input->post('sku4'),
			'quick'			=> $this->input->post('quick'),
			'cost'			=> $this->input->post('cost'),
			'max_quantity'	=> $this->input->post('max_quantity'),
			'warranty'		=> $this->input->post('warranty'),
			'alert_quantity'=> $this->input->post('alert_quantity'),
	    	'price'			=> $this->input->post('price'),
	    	'price_2'		=> $this->input->post('price_2'),
	    	'price_3'		=> $this->input->post('price_3'),
	    	'price_4'		=> $this->input->post('price_4'),
	    	'price2'		=> $this->input->post('price2'),
	    	'price2_2'		=> $this->input->post('price2_2'),
	    	'price2_3'		=> $this->input->post('price2_3'),
	    	'price2_4'		=> $this->input->post('price2_4'),
	    	'price3'		=> $this->input->post('price3'),
	    	'price3_2'		=> $this->input->post('price3_2'),
	    	'price3_3'		=> $this->input->post('price3_3'),
	    	'price3_4'		=> $this->input->post('price3_4'),
	    	'price4'		=> $this->input->post('price4'),
	    	'price4_2'		=> $this->input->post('price4_2'),
	    	'price4_3'		=> $this->input->post('price4_3'),
	    	'price4_4'		=> $this->input->post('price4_4'),
	    	'purchase_tax_code'	=> $this->input->post('purchase_tax_code'),
	    	'purchase_taxable'	=> $this->input->post('purchase_taxable'),
	    	'supply_tax_code'	=> $this->input->post('supply_tax_code'),
	    	'supply_taxable'	=> $this->input->post('supply_taxable'),
			'uom1'			=> $this->input->post('uom1'),
			'uom2'			=> $this->input->post('uom2'),
			'uom3'			=> $this->input->post('uom3'),
			'uom4'			=> $this->input->post('uom4'),
			'loose_qty2'	=> $this->input->post('loose_qty2'),
			'loose_qty3'	=> $this->input->post('loose_qty3'),
			'loose_qty4'	=> $this->input->post('loose_qty4'),
			'remarks'		=> $this->input->post('remarks'),
			'description'	=> $this->input->post('description'),
			'alert_quantity'=> $this->input->post('alert_quantity'),
			'enter_price'	=> $this->input->post('enter_price'),
			'enter_serial'	=> $this->input->post('enter_serial'),
			'model_no'		=> $this->input->post('model_no'),
			'adjust_cost'	=> $this->input->post('adjust_cost'),
			'is_consigned'	=> $this->input->post('is_consigned'),
			'redeemable'	=> $this->input->post('redeemable'),
			'redeem_points'	=> $this->input->post('redeem_points'),
			'isbn'			=> $this->input->post('isbn'),
			'author'		=> $this->input->post('author'),
			'publisher'		=> $this->input->post('publisher'),
			'tags'			=> $this->input->post('tags'),
			'weight'		=> $this->input->post('weight'),
			'weight_unit'	=> $this->input->post('weight_unit'),
	    	'weight2'		=> $this->input->post('weight2'),
	    	'weight3'		=> $this->input->post('weight3'),
	    	'weight4'		=> $this->input->post('weight4'),	    	
			'volume'		=> $this->input->post('volume'),
			'volume_unit'	=> $this->input->post('volume_unit'),
			'volume2'		=> $this->input->post('volume2'),
			'volume3'		=> $this->input->post('volume3'),
			'volume4'		=> $this->input->post('volume4'),
	    	'min_cart_qty'	=> $this->input->post('min_cart_qty'),
	    	'max_cart_qty'	=> $this->input->post('max_cart_qty'),
	    	'ready_for_sale'=> $this->input->post('ready_for_sale'),
			'added_on'		=> date('Y-m-d H:i:s'),
			'added_by'		=> $this->user->data('username'),
			'warehouse_id'	=> $this->user->data('branch')
		));
		
		$query = $this->db->query($sql);
		
		$id = $query->insert_id;	
		$this->inv->update_quantity($id, $this->input->post('initial_stock'));
		
		$this->db->query("UPDATE `inventory_stock_quantities` SET `cost` = ? WHERE `item_id` = ? AND `warehouse_id` = ? ", array($this->input->post('cost'), $id, $this->user->data('branch')));
		$query = $this->db->query("SELECT * FROM `inventory_stock_quantities` WHERE `item_id` = ? AND `warehouse_id` = ?", array($id, $this->user->data('branch')));
		$row = $query->row();

		
		return $this->get_item_by_id($id);

	}
	
	function Edit_item($id){
		$cat = $this->input->post('category');
		$cat_other = $this->input->post('category_other');
		if ($cat_other) $cat = $cat_other;
		
		$subcat = $this->input->post('subcategory');
		$subcat_other = $this->input->post('subcategory_other');
		if ($subcat_other) $subcat = $subcat_other;
		
		$brand = $this->input->post('brand');
		$brand_other = $this->input->post('brand_other');
		if ($brand_other) $brand = $brand_other;
		
		$config['upload_path'] = '../assets/items/';
		$config['allowed_types'] = 'gif|jpg|png';
		$config['max_size']	= '1024';

		$this->load->library('upload', $config);
		$this->load->library('image_lib');
		
		$item = $this->get_item_by_id($id);

		$current_photos = (strpos($item->image,',')) ? explode(',',$item->image) : array($item->image);

		for ($i = 1; $i <= 4; $i++){
			if ($this->upload->do_upload('item_photo_'.$i)){
				$image_data = $this->upload->data('item_photo_'.$i);
				$image_filename[] = $image_data['file_name'];
				if ($i == $this->input->post('primary_photo')){
					$primary_image = $image_data['file_name']; 					
				}
				
				$img_config['image_library']	= 'gd2';
				$img_config['source_image']		= '../assets/items/'.$image_data['file_name'];
				$img_config['create_thumb']		= TRUE;
				$img_config['maintain_ratio']	= TRUE;
				$img_config['width']			= 50;
				$img_config['height']			= 50;

				$this->image_lib->initialize($img_config); 
				$this->image_lib->resize();
				$this->image_lib->clear();
				
				// standard size config
				
				$img_config['image_library']	= 'gd2';
				$img_config['source_image']		= '../assets/items/'.$image_data['file_name'];
				$img_config['create_thumb']		= TRUE;
				$img_config['maintain_ratio']	= TRUE;
				$img_config['thumb_marker']		= '_standard';
				$img_config['width']			= 300;
				$img_config['height']			= 300;

				$this->image_lib->initialize($img_config); 
				$this->image_lib->resize();
				$this->image_lib->clear();

			} else {
				if (!$this->input->post('remove_photo_'.$i)){
					if ($current_photos[$i-1]) $image_filename[] = $current_photos[$i-1];
					if ($i == $this->input->post('primary_photo')){
						$primary_image = $current_photos[$i-1];
					}
				}
			}
		}
		
		if (strpos($item->links,',')){
			$variants = explode(',', $item->links);
		} else {
			if ($item->links) $variants[] = $item->links;
		}


		$new_links = $this->input->post('links');
		if (strpos($new_links,',')){
			$new_variants = explode(',', $new_links);
		} else {
			if ($new_links) $new_variants[] = $new_links;
		}
		
		$sku = $this->input->post('sku');
		
		foreach ($new_variants as $variant){
			$this->db->update('inventory', array('linked'=>$sku), "`sku` = '{$variant}'");
		}
		
		foreach ($variants as $variant){
			if (!in_array($variant, $new_variants)){
				$this->db->update('inventory', array('linked'=>NULL), "`sku` = '{$variant}'");
			}
		}



	    $sql = $this->db->update_string('inventory',array(
	    	'name'			=> $this->input->post('name'),
	    	'category'		=> $cat,
	    	'subcategory'	=> $subcat,
	    	'brand'			=> $brand,
	    	'image'			=> implode(',',$image_filename),
	    	'primary_image'	=> $primary_image,
	    	'links'			=> $this->input->post('links'),
	    	'location'		=> $this->input->post('location'),
	    	'alert_quantity'=> $this->input->post('alert_quantity'),
	    	'sku'			=> $this->input->post('sku'),
	    	'sku2'			=> $this->input->post('sku2'),
	    	'sku3'			=> $this->input->post('sku3'),
	    	'sku4'			=> $this->input->post('sku4'),
	    	'quick'			=> $this->input->post('quick'),
	    	'max_quantity'	=> $this->input->post('max_quantity'),
	    	'warranty'		=> $this->input->post('warranty'),
	    	'cost'			=> $this->input->post('cost'),
	    	'price'			=> $this->input->post('price'),
	    	'price_2'		=> $this->input->post('price_2'),
	    	'price_3'		=> $this->input->post('price_3'),
	    	'price_4'		=> $this->input->post('price_4'),
	    	'price2'		=> $this->input->post('price2'),
	    	'price2_2'		=> $this->input->post('price2_2'),
	    	'price2_3'		=> $this->input->post('price2_3'),
	    	'price2_4'		=> $this->input->post('price2_4'),
	    	'price3'		=> $this->input->post('price3'),
	    	'price3_2'		=> $this->input->post('price3_2'),
	    	'price3_3'		=> $this->input->post('price3_3'),
	    	'price3_4'		=> $this->input->post('price3_4'),
	    	'price4'		=> $this->input->post('price4'),
	    	'price4_2'		=> $this->input->post('price4_2'),
	    	'price4_3'		=> $this->input->post('price4_3'),
	    	'price4_4'		=> $this->input->post('price4_4'),
	    	'purchase_tax_code'	=> $this->input->post('purchase_tax_code'),
	    	'purchase_taxable'	=> $this->input->post('purchase_taxable'),
	    	'supply_tax_code'	=> $this->input->post('supply_tax_code'),
	    	'supply_taxable'	=> $this->input->post('supply_taxable'),
	    	'uom1'			=> $this->input->post('uom1'),
	    	'uom2'			=> $this->input->post('uom2'),
	    	'uom3'			=> $this->input->post('uom3'),
	    	'uom4'			=> $this->input->post('uom4'),
	    	'loose_qty2'	=> $this->input->post('loose_qty2'),
	    	'loose_qty3'	=> $this->input->post('loose_qty3'),
	    	'loose_qty4'	=> $this->input->post('loose_qty4'),
	    	'remarks'		=> $this->input->post('remarks'),
	    	'description'	=> $this->input->post('description'),
	    	'alert_quantity'=> $this->input->post('alert_quantity'),
	    	'enter_price'	=> $this->input->post('enter_price'),
	    	'enter_serial'	=> $this->input->post('enter_serial'),
	    	'model_no'		=> $this->input->post('model_no'),
	    	'adjust_cost'	=> $this->input->post('adjust_cost'),
	    	'is_consigned'	=> $this->input->post('is_consigned'),
	    	'redeemable'	=> $this->input->post('redeemable'),
	    	'redeem_points'	=> $this->input->post('redeem_points'),
	    	'isbn'			=> $this->input->post('isbn'),
	    	'author'		=> $this->input->post('author'),
	    	'publisher'		=> $this->input->post('publisher'),
	    	'tags'			=> $this->input->post('tags'),
	    	'weight'		=> $this->input->post('weight'),
	    	'weight_unit'	=> $this->input->post('weight_unit'),
	    	'weight2'		=> $this->input->post('weight2'),
	    	'weight3'		=> $this->input->post('weight3'),
	    	'weight4'		=> $this->input->post('weight4'),	    	
	    	'volume'		=> $this->input->post('volume'),
	    	'volume_unit'	=> $this->input->post('volume_unit'),
			'volume2'		=> $this->input->post('volume2'),
			'volume3'		=> $this->input->post('volume3'),
			'volume4'		=> $this->input->post('volume4'),
	    	'min_cart_qty'	=> $this->input->post('min_cart_qty'),
	    	'max_cart_qty'	=> $this->input->post('max_cart_qty'),
	    	'ready_for_sale'=> $this->input->post('ready_for_sale'),
	    	'modified_on'	=> date('Y-m-d H:i:s'),
	    	'modified_by'	=> $this->user->data('username')
		),"`id` = '$id'");
	
		
		$this->db->query($sql);
		
		$this->db->query("UPDATE `inventory_stock_quantities` SET `cost` = ? WHERE `item_id` = ? AND `warehouse_id` = ? ", array($this->input->post('cost'), $id, $this->user->data('branch')));
		$query = $this->db->query("SELECT * FROM `inventory_stock_quantities` WHERE `item_id` = ? AND `warehouse_id` = ?", array($id, $this->user->data('branch')));
		$row = $query->row();

		
		return $this->get_item_by_id($id);
	}
	
	function Delete_item($id){
		$item = $this->get_item_by_id($id);
		
		$this->db->query("DELETE FROM `inventory` WHERE `id` = ?",array($id));
		$this->db->query("DELETE FROM `inventory_stock_quantities` WHERE `item_id` = ?",array($id));		
		
		return $item;
	}
	
	function Get_items_by_category($category){
		$query = $this->db->query("SELECT * FROM `inventory` WHERE `category` = ?",array($category));
		return $query->result();
	}
	
	function Get_variants_by_sku($sku){
		$query = $this->db->query("SELECT * FROM `inventory` WHERE `linked` = ?", array($sku));
		return $query->result();
	}
	
	
	
	// PURCHASE ORDERS
	
	function Get_po($where){
		if ($where){
			$sql = "SELECT * FROM `purchase_orders` WHERE $where";

		} else {
			$sql = "SELECT * FROM `purchase_orders` ORDER BY `date` DESC";
		}
		$query = $this->db->query($sql);
		return $query->result();
	}
	
	function Get_po_by_id($id, $txn_no){
	
		if ($txn_no){
			$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `txn_no` = ?", array($txn_no));
		} else {
			$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `id` = ?", array($id));
		}
		$po = $query->row();
		
		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `purchase_order_id` = ? ORDER BY `done` ASC", array($po->id));
		$orders = $query->result();
		

		
		foreach ($orders as $order_item){
			$products[$order_item->item_id] = $product = $this->get_item_by_id($order_item->item_id);
			$sorted[] = $product->name;
			$unsorted_orders[] = $order_item;
		}

		asort($sorted);

		foreach ($sorted as $order_item_id => $product_name){
			$sorted_orders[] = $unsorted_orders[$order_item_id];
		}		
		
		$po->orders = $sorted_orders;
		$po->products = $products;

		return $po;
	}
	
	
		
	function Add_po(){
		
		

	
		$price	= $this->input->post('price');
		$items	= $this->input->post('item_id');
		$cost	= $this->input->post('item_new_cost');
		$i = 0;
		
		foreach ($price as $new_price){
			$item_id = $items[$i];
			$sql = $this->db->update('inventory',array(
				'price' => $new_price,
				'cost'	=> $cost[$item_id],
			), "`id` = '{$item_id}'");
			
			$i++;
		}
		
	
		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;

		$contact = $this->contact->get_contact_by_id($this->input->post('supplier'));
		
		if ($duration = $this->input->post('duration')){
			$due_date = date('Y-m-d',strtotime($date)+((60*60*24)*$duration));
		} else {
			$due_date = null;
		}
		
		
		$address->address1	= $contact->address1;
		$address->address2	= $contact->address2;
		$address->zipcode	= $contact->zipcode;
		$address->city		= $contact->city;
		$address->state		= $contact->state;
		$address->country	= $contact->country;
		
		$delivery_address 	= $this->input->post('delivery');
	
		$tax = $this->input->post('tax');

		foreach ($tax as $id => $amount){
			$total_tax += $amount;
			$t = $this->tax->get_tax_by_id($id);
			$ntax = null;
			
			$ntax->percentage 	= $t->percentage;
			$ntax->id			= $id;
			$ntax->name			= $t->name;
			$ntax->inclusive	= $t->inclusive;
			$ntax->amount		= $amount;
			$taxes[] = $ntax;
		}


		$sql = $this->db->insert_string('purchase_orders',array(
			'txn_no'			=> $this->input->post('txn_no') ? $this->input->post('txn_no') : $this->serial_no('purchase_orders'),
			'date'				=> $date,
			'due_date'			=> $due_date,
			'invoice_number'	=> $this->input->post('invoice_number'),
			'pr_id'				=> $pr_id = $this->input->post('pr_id'),
			'supplier'			=> $contact->company_name ? $contact->company_name : $contact->contact_person,
			'supplier_id'		=> $this->input->post('supplier'),
			'supplier_address'	=> json_encode($address),
			'delivery_address'	=> json_encode($delivery_address),
			'contact_person'	=> $this->input->post('contact_person'),
			'terms'				=> $this->input->post('terms'),
			'duration'			=> $this->input->post('duration'),
			'payment_status'	=> 'Unpaid',
			'status'			=> 'Pending',
			'adjustment'		=> $this->input->post('adjustment'),
			'adjustment_type'	=> $this->input->post('adjustment_type'),
			'handling_charges'	=> $this->input->post('sh_charges'),
			'remarks'			=> $this->input->post('remarks'),
			'tax'				=> json_encode($taxes),
			'tax_inclusive'		=> $this->input->post('inclusive'),
			'total_tax'			=> $total_tax,
			'total'				=> $this->input->post('grand_total'),
			'tags'				=> $this->input->post('tags'),
			'added_on'			=> date('Y-m-d H:i:s'),
			'added_by'			=> $this->user->data('username'),
			'warehouse_id'		=> $this->user->data('branch')
		));

		$query = $this->db->query($sql);

		$po_id = $query->insert_id;
		
		if ($pr_id){
			$sql = $this->db->update_string('purchase_requests', array(
				'po_id'	=> $po_id
			), "`id` = '{$pr_id}'");
			$this->db->query($sql);
		}	
		
		$items 				= $this->input->post('item_id');
		$item_type 			= $this->input->post('item_type');
		$item_ppu			= $this->input->post('item_net_price');
		$item_price 		= $this->input->post('item_totalnet_price');
		$item_name			= $this->input->post('item_name');
		$item_qty			= $this->input->post('item_qty');
		$item_description	= $this->input->post('item_description');
		$item_discount_type	= $this->input->post('item_discount_type');
		$item_discount		= $this->input->post('item_discount');
		$taxable			= $this->input->post('taxable');
		$tax_code			= $this->input->post('tax_code');

		

		for ($i = 0; $i < count($items); $i++){
			$name = explode('<',$item_name[$i]);
			$item_name_actual = $name[0];

			$sql = $this->db->insert_string('purchase_order_items',array(
				'purchase_order_id'	=> $po_id,
				'date'				=> $date,
				'item_id'			=> $items[$i],
				'item_name'			=> $item_name_actual,
				'item_description'	=> $item_description[$i],
				'qty'				=> $item_qty[$i],
				'price'				=> $item_price[$i],
				'price_per_unit'	=> $item_price[$i] / $item_qty[$i],
				'discount_type'		=> $item_discount_type[$i],
				'discount'			=> $item_discount[$i],
				'taxable'			=> $taxable[$i],
				'tax_code'			=> $tax_code[$i],
				'warehouse_id'		=> $this->user->data('branch')
			));
			
			$this->db->query($sql);
			
		}
		
		$this->system->set_config('diagnose','a1');
		
		return $this->get_po_by_id($po_id);
	}
	
	function Edit_po($id){
		$po_id = $id;
		$price = $this->input->post('price');
		$cost = $this->input->post('item_new_cost');
		
		foreach ($price as $item_id => $new_price){
			$this->db->update('inventory',array(
				'price' => $new_price,
				'cost'	=> $cost[$item_id]
			), "`id` = '{$item_id}'");
		
			$wid = $this->user->data('branch');
			
			$this->db->update('inventory_stock_quantities', array(
				'cost'	=> $cost[$item_id],
			),"`item_id` = '{$item_id} AND `warehouse_id` = {$wid}'");
		}
	

		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;
		
		$contact = $this->contact->get_contact_by_id($this->input->post('supplier'));
		
		if ($duration = $this->input->post('duration')){
			$due_date = date('Y-m-d',strtotime($date)+((60*60*24)*$duration));
		} else {
			$due_date = null;
		}
		
		$address->address1	= $contact->address1;
		$address->address2	= $contact->address2;
		$address->zipcode	= $contact->zipcode;
		$address->city		= $contact->city;
		$address->state		= $contact->state;
		$address->country	= $contact->country;
		
		$delivery_address 	= $this->input->post('delivery');

		$tax = $this->input->post('tax');

		foreach ($tax as $tax_id => $amount){
			$total_tax += $amount;
			
			$t = $this->tax->get_tax_by_id($tax_id);
			
			$ntax = null;
			
			$ntax->percentage 	= $t->percentage;
			$ntax->id			= $id;
			$ntax->name			= $t->name;
			$ntax->inclusive	= $t->inclusive;
			$ntax->amount		= $amount;
			$taxes[] = $ntax;
		}
		
		$data = array(
			'date'				=> $date,
			'due_date'			=> $due_date,
			'invoice_number'	=> $this->input->post('invoice_number'),
			'supplier'			=> $contact->company_name ? $contact->company_name : $contact->contact_person,
			'supplier_id'		=> $this->input->post('supplier'),
			'supplier_address'	=> json_encode($address),
			'delivery_address'	=> json_encode($delivery_address),
			'terms'				=> $this->input->post('terms'),
			'contact_person'	=> $this->input->post('contact_person'),
			'duration'			=> $this->input->post('duration'),
			'remarks'			=> $this->input->post('remarks'),
			'adjustment'		=> $this->input->post('adjustment'),
			'adjustment_type'	=> $this->input->post('adjustment_type'),
			'handling_charges'	=> $this->input->post('sh_charges'),
			'tax'				=> json_encode($taxes),
			'tax_inclusive'		=> $this->input->post('inclusive'),
			'total_tax'			=> $total_tax,
			'total'				=> $this->input->post('grand_total'),
			'tags'				=> $this->input->post('tags'),
			'modified_on'		=> date('Y-m-d H:i:s'),
			'modified_by'		=> $this->user->data('username'),
			'warehouse_id'		=> $this->user->data('branch')

		);
		
		
		if ($this->input->post('txn_no')){
			$data['txn_no'] = $this->input->post('txn_no');
		}


		$sql = $this->db->update_string('purchase_orders',$data,"`id` = '$po_id'");

		$query = $this->db->query($sql);

		
		$items 				= $this->input->post('item_id');
		$item_type 			= $this->input->post('item_type');
		$item_ppu			= $this->input->post('item_net_price');
		$item_price 		= $this->input->post('item_totalnet_price');
		$item_name			= $this->input->post('item_name');
		$item_qty			= $this->input->post('item_qty');
		$item_description	= $this->input->post('item_description');
		$item_discount_type	= $this->input->post('item_discount_type');
		$item_discount		= $this->input->post('item_discount');
		$taxable			= $this->input->post('taxable');
		$tax_code			= $this->input->post('tax_code');

		
		$this->db->query("DELETE FROM `purchase_order_items` WHERE `purchase_order_id` = ?", array($id));
		
				
		for ($i = 0; $i < count($items); $i++){
			$name = explode('<',$item_name[$i]);
			$item_name_actual = $name[0];
			
			$sql = $this->db->insert_string('purchase_order_items',array(
				'purchase_order_id'	=> $po_id,
				'date'				=> $date,
				'item_id'			=> $items[$i],
				'item_name'			=> $item_name_actual,
				'item_description'	=> $item_description[$i],
				'qty'				=> $item_qty[$i],
				'price'				=> $item_price[$i],
				'price_per_unit'	=> $item_ppu[$i],
				'discount_type'		=> $item_discount_type[$i],
				'discount'			=> $item_discount[$i],
				'taxable'			=> $taxable[$i],
				'tax_code'			=> $tax_code[$i],
				'warehouse_id'		=> $this->user->data('branch')
			));
			
			$this->db->query($sql);
			
		}
		
		return $this->get_po_by_id($id);
		
	}
	
	function Delete_po($id){
		$po = $this->get_po_by_id($id);
		$this->db->query("DELETE FROM `purchase_order_items` WHERE `purchase_order_id` = ?", array($id));
		$this->db->query("DELETE FROM `purchase_orders` WHERE `id`= ?", array($id));
		return $po;
	}
	
	function PO_items_received($po_id){
		
		ini_set('max_execution_time', '300');

		$received 	= $this->input->post('received_qty');
		$done		= $this->input->post('done');
		$grand_total = 0;
		
		$cost_update_method = $this->system->config('cost_update_method');
		
		foreach ($received as $order_id => $qty){

			$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `id` = ?", array($order_id));
			$order = $query->row();
			
			$item = $this->get_item_by_id($order->item_id);
			
			if ($order->discount_type == 'p'){
				$ppu = $order->price_per_unit * ((100 - $order->discount) / 100);
				$price = str_replace(',', '', number_format($qty * $ppu,2));
			} elseif ($order->discount_type == 'd'){
				$price = ($order->price_per_unit * $qty) - $order->discount;
				$ppu = $price / $qty;
			} else {
				$ppu = $order->price_per_unit;
				$price = $ppu * $qty;
			}
			
			
			$ppu = str_replace(',', '', number_format($price, 2));
			
			
			$sql = $this->db->update_string('purchase_order_items', array(
				'received' 			=> $qty,
				'received_price'	=> $price,
				'done'				=> $done[$order->id]
			), "`id` = '{$order_id}'");
			

			
			$this->db->query($sql);
			
			$this->update_item_qty($order->item_id);
			
			if ($cost_update_method == 'average'){
				$this->update_item_average_cost($item->id, $qty, $ppu);
			} else {
				$this->update_item_cost($order->item_id);
			}
			
			
	

			$grand_total += $price;
		}
		
		

		$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `id` = ?", array($po_id));
		$po = $query->row();
		
		$grand_total = $grand_total + $po->handling_charges;
		
		if ($po->adjustment_type == 'Add'){
			$grand_total += $po->adjustment;
		} else {
			$grand_total -= $po->adjustment;
		}
		
		echo $grand_total;
		echo $po->total_tax;
		
		if (!$po->tax_inclusive){
			$grand_total += $po->total_tax;
		}
		

		
		$sql = $this->db->update_string('purchase_orders', array(
			'total_received'	=> $grand_total 
		),"`id` = '{$po_id}'");
		
		$this->db->query($sql);
		
		return $this->get_po_by_id($po_id);
		
	}
	
	function PO_items_unreceived($po_id){
		
		ini_set('max_execution_time', '300');
		
		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `purchase_order_id` = ?", array($po_id));
		
		$cost_update_method = $this->system->config('cost_update_method');
		
		$sql = $this->db->update_string('purchase_order_items', array(
			'received' 			=> 0,
			'received_price'	=> 0,
			'done'	   			=> 0
		), "`purchase_order_id` = '{$po_id}'");
		
		$this->db->query($sql);
		
		foreach ($query->result() as $order){
			if ($cost_update_method == 'average'){
			} else {
				$this->update_item_cost($order->item_id);
			}
			$this->update_item_qty($order->item_id);
		}
		
		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `purchase_order_id` = ?", array($po_id));
		
		$sql = $this->db->update_string('purchase_orders', array(
			'status' 			=> 'Pending',
			'total_received'	=> 0
		),"`id` = '{$po_id}'");
		
		$this->db->query($sql);
		
		return $this->get_po_by_id($po_id);
	}
	
	

	function PO_set_paid($id, $date, $pv_id, $contra_id){

		if (!$date){
			list($day, $month, $year) = explode('/', $this->input->post('payment_date'));
			$date = $year . '-' . $month . '-' . $day;
		} else {
			if (strpos($date,'/')){
				list($day, $month, $year) = explode('/', $date);
				$date = $year . '-' . $month . '-' . $day;
			}
		}

		
		$sql = $this->db->update_string('purchase_orders',array(
			'payment_status'	=> 'Paid',
			'payment_reference'	=> $pv_id,
			'payment_date'		=> $date,
			'payment_contra'	=> $contra_id
		),"`id` = '$id'");
		
		$this->db->query($sql);
		
		return $this->get_po_by_id($id);
	}

	function PO_set_unpaid($id){
		
		$sql = $this->db->update_string('purchase_orders',array(
			'payment_status'	=> 'Unpaid',
			'payment_reference'	=> '',
			'payment_contra'	=> '',
			'payment_date'		=> ''
		),"`id` = '$id'");
		
		$this->db->query($sql);
		
		return $this->get_po_by_id($id);
	}	
	
	
	
	// PURCHASE REQUESTS
	
	function Get_pr($where){
		if ($where){
			$sql = "SELECT * FROM `purchase_requests` WHERE $where";

		} else {
			$sql = "SELECT * FROM `purchase_requests` ORDER BY `date` DESC";
		}
		$query = $this->db->query($sql);
		return $query->result();
	}
	
	function Get_pr_by_id($id, $txn_no){
	
		if ($txn_no){
			$query = $this->db->query("SELECT * FROM `purchase_requests` WHERE `txn_no` = ?", array($txn_no));
		} else {
			$query = $this->db->query("SELECT * FROM `purchase_requests` WHERE `id` = ?", array($id));
		}
		$pr = $query->row();
		
		$query = $this->db->query("SELECT * FROM `purchase_request_items` WHERE `purchase_request_id` = ? ORDER BY `done` ASC", array($pr->id));
		$orders = $query->result();
		

		
		foreach ($orders as $order_item){
			$products[$order_item->item_id] = $product = $this->get_item_by_id($order_item->item_id);
			$sorted[$order_item->item_id] = $product->name;
			$unsorted_orders[$order_item->item_id] = $order_item;
		}

		asort($sorted);

		foreach ($sorted as $order_item_id => $product_name){
			$sorted_orders[] = $unsorted_orders[$order_item_id];
		}		
		
		$pr->orders = $sorted_orders;
		$pr->products = $products;

		return $pr;
	}
	
	function Get_po_by_pr_id($id){
		$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `pr_id` = ? ORDER BY `txn_no` ASC", array($id));
		return $query->result();
	}
		
	function Add_pr(){
	

		$cost = $this->input->post('item_new_cost');
		
	
		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;

		$contact = $this->contact->get_contact_by_id($this->input->post('supplier'));
		
		if ($duration = $this->input->post('duration')){
			$due_date = date('Y-m-d',strtotime($date)+((60*60*24)*$duration));
		} else {
			$due_date = null;
		}
		
		
		$address->address1	= $contact->address1;
		$address->address2	= $contact->address2;
		$address->zipcode	= $contact->zipcode;
		$address->city		= $contact->city;
		$address->state		= $contact->state;
		$address->country	= $contact->country;
		
		$delivery_address 	= $this->input->post('delivery');
	

		$sql = $this->db->insert_string('purchase_requests',array(
			'txn_no'			=> $this->serial_no('purchase_requests'),
			'date'				=> $date,
			'due_date'			=> $due_date,
			'supplier'			=> $contact->company_name ? $contact->company_name : $contact->contact_person,
			'supplier_id'		=> $this->input->post('supplier'),
			'supplier_address'	=> json_encode($address),
			'delivery_address'	=> json_encode($delivery_address),
			'contact_person'	=> $this->input->post('contact_person'),
			'terms'				=> $this->input->post('terms'),
			'duration'			=> $this->input->post('duration'),
			'payment_status'	=> 'Unpaid',
			'status'			=> 'Pending',
			'adjustment'		=> $this->input->post('adjustment'),
			'adjustment_type'	=> $this->input->post('adjustment_type'),
			'handling_charges'	=> $this->input->post('sh_charges'),
			'remarks'			=> $this->input->post('remarks'),
			'total'				=> $this->input->post('grand_total'),
			'tags'				=> $this->input->post('tags'),
			'added_on'			=> date('Y-m-d H:i:s'),
			'added_by'			=> $this->user->data('username'),
			'warehouse_id'		=> $this->user->data('branch')
		));

		$query = $this->db->query($sql);

		$pr_id = $query->insert_id;
		
	
		
		$items 			= $this->input->post('item_id');
		$item_type 		= $this->input->post('item_type');
		$item_ppu		= $this->input->post('item_net_price');
		$item_price 	= $this->input->post('item_totalnet_price');
		$item_name		= $this->input->post('item_name');
		$item_qty		= $this->input->post('item_qty');
		$item_description	= $this->input->post('item_description');
		$item_discount_type	= $this->input->post('item_discount_type');
		$item_discount		= $this->input->post('item_discount');
		

		for ($i = 0; $i < count($items); $i++){
			$name = explode('<',$item_name[$i]);
			$item_name_actual = $name[0];

			$sql = $this->db->insert_string('purchase_request_items',array(
				'purchase_request_id'	=> $pr_id,
				'date'				=> $date,
				'item_id'			=> $items[$i],
				'item_name'			=> $item_name_actual,
				'item_description'	=> $item_description[$i],
				'qty'				=> $item_qty[$i],
				'price'				=> $item_price[$i],
				'price_per_unit'	=> $item_price[$i] / $item_qty[$i],
				'discount_type'		=> $item_discount_type[$i],
				'discount'			=> $item_discount[$i],
				'warehouse_id'		=> $this->user->data('branch')
			));
			
			$this->db->query($sql);
			
		}
		
		
		return $this->get_pr_by_id($po_id);
	}
	
	function Edit_pr($id){

		$cost = $this->input->post('item_new_cost');	

		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;
		
		$contact = $this->contact->get_contact_by_id($this->input->post('supplier'));
		
		if ($duration = $this->input->post('duration')){
			$due_date = date('Y-m-d',strtotime($date)+((60*60*24)*$duration));
		} else {
			$due_date = null;
		}
		
		$address->address1	= $contact->address1;
		$address->address2	= $contact->address2;
		$address->zipcode	= $contact->zipcode;
		$address->city		= $contact->city;
		$address->state		= $contact->state;
		$address->country	= $contact->country;
		
		$delivery_address 	= $this->input->post('delivery');


		$sql = $this->db->update_string('purchase_requests',array(
			'date'				=> $date,
			'due_date'			=> $due_date,
			'supplier'			=> $contact->company_name ? $contact->company_name : $contact->contact_person,
			'supplier_id'		=> $this->input->post('supplier'),
			'supplier_address'	=> json_encode($address),
			'delivery_address'	=> json_encode($delivery_address),
			'terms'				=> $this->input->post('terms'),
			'contact_person'	=> $this->input->post('contact_person'),
			'duration'			=> $this->input->post('duration'),
			'remarks'			=> $this->input->post('remarks'),
			'adjustment'		=> $this->input->post('adjustment'),
			'adjustment_type'	=> $this->input->post('adjustment_type'),
			'handling_charges'	=> $this->input->post('sh_charges'),
			'total'				=> $this->input->post('grand_total'),
			'tags'				=> $this->input->post('tags'),
			'modified_on'		=> date('Y-m-d H:i:s'),
			'modified_by'		=> $this->user->data('username'),
			'warehouse_id'		=> $this->user->data('branch')

		),"`id` = '$id'");

		$query = $this->db->query($sql);

		
		$items 				= $this->input->post('item_id');
		$item_type 			= $this->input->post('item_type');
		$item_ppu			= $this->input->post('item_net_price');
		$item_price 		= $this->input->post('item_totalnet_price');
		$item_name			= $this->input->post('item_name');
		$item_qty			= $this->input->post('item_qty');
		$item_description	= $this->input->post('item_description');
		$item_discount_type	= $this->input->post('item_discount_type');
		$item_discount		= $this->input->post('item_discount');
		
		$this->db->query("DELETE FROM `purchase_request_items` WHERE `purchase_request_id` = ?", array($id));
		
				
		for ($i = 0; $i < count($items); $i++){
			$name = explode('<',$item_name[$i]);
			$item_name_actual = $name[0];
			
			$sql = $this->db->insert_string('purchase_request_items',array(
				'purchase_request_id'	=> $id,
				'date'				=> $date,
				'item_id'			=> $items[$i],
				'item_name'			=> $item_name_actual,
				'item_description'	=> $item_description[$i],
				'qty'				=> $item_qty[$i],
				'price'				=> $item_price[$i],
				'price_per_unit'	=> $item_ppu[$i],
				'discount_type'		=> $item_discount_type[$i],
				'discount'			=> $item_discount[$i],
				'warehouse_id'		=> $this->user->data('branch')
			));
			
			$this->db->query($sql);
			
		}
		
		return $this->get_pr_by_id($id);
		
	}
	
	function Delete_pr($id){
		$pr = $this->get_pr_by_id($id);
		$this->db->query("DELETE FROM `purchase_request_items` WHERE `purchase_request_id` = ?", array($id));
		$this->db->query("DELETE FROM `purchase_requests` WHERE `id`= ?", array($id));
		return $pr;
	}

	
	function DN_set_paid($id, $date, $pv_id, $contra_id){
		if (!$date){
			list($day, $month, $year) = explode('/', $this->input->post('payment_date'));
			$date = $year . '-' . $month . '-' . $day;
		} else {
			if (strpos($date,'/')){
				list($day, $month, $year) = explode('/', $date);
				$date = $year . '-' . $month . '-' . $day;
			}
		}
		
		$sql = $this->db->update_string('debit_notes',array(
			'payment_status'	=> 'Paid',
			'payment_reference'	=> $pv_id,
			'payment_date'		=> $date,
			'payment_contra'	=> $contra_id
		),"`id` = '$id'");
		
		$this->db->query($sql);
		
		return $this->get_dn_by_id($id);
	}

	function DN_set_unpaid($id){
		$sql = $this->db->update_string('debit_notes',array(
			'payment_status'	=> 'Unpaid',
			'payment_reference'	=> '',
			'payment_contra'	=> '',
			'payment_date'		=> ''
		),"`id` = '$id'");
		
		$this->db->query($sql);
		
		return $this->get_dn_by_id($id);
	}	

	
	
	
	// DEBIT NOTES

	function Get_dn($where){
		if ($where){
			$sql = "SELECT * FROM `debit_notes` WHERE $where";

		} else {
			$sql = "SELECT * FROM `debit_notes` ORDER BY `date` DESC";
		}
		$query = $this->db->query($sql);
		return $query->result();
	}
	
	function Get_dn_by_id($id){
		$query = $this->db->query("SELECT * FROM `debit_notes` WHERE `id` = ?", array($id));
		$dn = $query->row();
		
		$query = $this->db->query("SELECT * FROM `debit_note_items` WHERE `debit_note_id` = '{$dn->id}' ORDER BY `done` ASC");
		$orders = $query->result();
		

		
		foreach ($orders as $order_item){
			$products[$order_item->item_id] = $product = $this->get_item_by_id($order_item->item_id);
			$sorted[$order_item->item_id] = $product->name;
			$unsorted_orders[$order_item->item_id] = $order_item;
		}

		asort($sorted);

		foreach ($sorted as $order_item_id => $product_name){
			$sorted_orders[] = $unsorted_orders[$order_item_id];
		}		
		
		$dn->orders = $sorted_orders;
		$dn->products = $products;

		return $dn;
	}

	
	function Add_dn(){
		$price = $this->input->post('price');
		foreach ($price as $item_id => $new_price){
			$sql = $this->db->update_string('inventory',array(
				'price' => $new_price
			), "`id` = '{$item_id}'");
			
			$this->db->query($sql);
		}
	
		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;
		
		$contact = $this->contact->get_contact_by_id($this->input->post('supplier'));
		
		if ($duration = $this->input->post('duration')){
			$due_date = date('Y-m-d',strtotime($date)+((60*60*24)*$duration));
		} else {
			$due_date = null;
		}
		
		$address->address1	= $contact->address1;
		$address->address2	= $contact->address2;
		$address->zipcode	= $contact->zipcode;
		$address->city		= $contact->city;
		$address->state		= $contact->state;
		$address->country	= $contact->country;

		$tax = $this->input->post('tax');

		foreach ($tax as $id => $amount){
			$total_tax += $amount;
			$t = $this->tax->get_tax_by_id($id);
			$ntax = null;
			
			$ntax->percentage 	= $t->percentage;
			$ntax->id			= $id;
			$ntax->name			= $t->name;
			$ntax->inclusive	= $t->inclusive;
			$ntax->amount		= $amount;
			$taxes[] = $ntax;
		}

		$sql = $this->db->insert_string('debit_notes',array(
			'txn_no'			=> $this->input->post('txn_no') ? $this->input->post('txn_no') : $this->serial_no('debit_notes'),
			'date'				=> $date,
			'terms'				=> $this->input->post('terms'),
			'cn_number'			=> $this->input->post('cn_number'),
			'supplier'			=> $contact->company_name ? $contact->company_name : $contact->contact_person,
			'supplier_id'		=> $this->input->post('supplier'),
			'supplier_address'	=> json_encode($address),
			'contact_person'	=> $this->input->post('contact_person'),
			'status'			=> 'Pending',
			'remarks'			=> $this->input->post('remarks'),
			'adjustment'		=> $this->input->post('adjustment'),
			'adjustment_type'	=> $this->input->post('adjustment_type'),
			'handling_charges'	=> $this->input->post('sh_charges'),
			'total'				=> $this->input->post('grand_total'),
			'tax'				=> json_encode($taxes),
			'total_tax'			=> $total_tax,
			'tags'				=> $this->input->post('tags'),
			'added_on'			=> date('Y-m-d H:i:s'),
			'added_by'			=> $this->user->data('username'),
			'payment_status'	=> 'Unpaid',
			'warehouse_id'		=> $this->user->data('branch')
		));

		$query = $this->db->query($sql);

		$dn_id = $query->insert_id;
		
		$items 			= $this->input->post('item_id');
		$item_type 		= $this->input->post('item_type');
		$item_ppu		= $this->input->post('item_net_price');
		$item_price 	= $this->input->post('item_totalnet_price');
		$item_name		= $this->input->post('item_name');
		$item_qty		= $this->input->post('item_qty');
		$item_description	= $this->input->post('item_description');
		$item_discount_type	= $this->input->post('item_discount_type');
		$item_discount		= $this->input->post('item_discount');
		$taxable			= $this->input->post('taxable');
		$tax_code			= $this->input->post('tax_code');

				
		for ($i = 0; $i < count($items); $i++){
			$name = explode('<',$item_name[$i]);
			$item_name_actual = $name[0];

			$sql = $this->db->insert_string('debit_note_items',array(
				'debit_note_id'		=> $dn_id,
				'date'				=> $date,
				'item_id'			=> $items[$i],
				'item_name'			=> $item_name_actual,
				'item_description'	=> $item_description[$i],				
				'qty'				=> $item_qty[$i],
				'price'				=> $item_price[$i],
				'price_per_unit'	=> $item_price[$i] / $item_qty[$i],
				'discount_type'		=> $item_discount_type[$i],
				'discount'			=> $item_discount[$i],
				'taxable'			=> $taxable[$i],
				'tax_code'			=> $tax_code[$i],
				'warehouse_id'		=> $this->user->data('branch')
			));
			
			$this->db->query($sql);
			
		}
		
		return $this->get_dn_by_id($dn_id);
		
	}
	
	function Edit_dn($id){
		$price = $this->input->post('price');
		foreach ($price as $item_id => $new_price){
			$sql = $this->db->update_string('inventory',array(
				'price' => $new_price
			), "`id` = '{$item_id}'");
			
			$this->db->query($sql);
		}
	

		list($day, $month, $year) = explode('/', $this->input->post('date'));
		$date = $year . '-' . $month . '-' . $day;
		
		$contact = $this->contact->get_contact_by_id($this->input->post('supplier'));
		
		if ($duration = $this->input->post('duration')){
			$due_date = date('Y-m-d',strtotime($date)+((60*60*24)*$duration));
		} else {
			$due_date = null;
		}
		
		$address->address1	= $contact->address1;
		$address->address2	= $contact->address2;
		$address->zipcode	= $contact->zipcode;
		$address->city		= $contact->city;
		$address->state		= $contact->state;
		$address->country	= $contact->country;
		
		
		$tax = $this->input->post('tax');

		foreach ($tax as $id => $amount){
			$total_tax += $amount;
			$t = $this->tax->get_tax_by_id($id);
			$ntax = null;
			
			$ntax->percentage 	= $t->percentage;
			$ntax->id			= $id;
			$ntax->name			= $t->name;
			$ntax->inclusive	= $t->inclusive;
			$ntax->amount		= $amount;
			$taxes[] = $ntax;
		}


		$data = array(
			'terms'				=> $this->input->post('terms'),
			'date'				=> $date,
			'cn_number'			=> $this->input->post('cn_number'),
			'supplier'			=> $contact->company_name ? $contact->company_name : $contact->contact_person,
			'supplier_id'		=> $this->input->post('supplier'),
			'supplier_address'	=> json_encode($address),
			'contact_person'	=> $this->input->post('contact_person'),
			'remarks'			=> $this->input->post('remarks'),
			'adjustment'		=> $this->input->post('adjustment'),
			'adjustment_type'	=> $this->input->post('adjustment_type'),
			'handling_charges'	=> $this->input->post('sh_charges'),
			'total'				=> $this->input->post('grand_total'),
			'tags'				=> $this->input->post('tags'),
			'modified_on'		=> date('Y-m-d H:i:s'),
			'modified_by'		=> $this->user->data('username'),
			'warehouse_id'		=> $this->user->data('branch')
		);

		if ($this->input->post('txn_no')){
			$data['txn_no'] = $this->input->post('txn_no');
		}

		$sql = $this->db->update_string('debit_notes',$data,"`id` = '$id'");

		$query = $this->db->query($sql);
		
		$items 			= $this->input->post('item_id');
		$item_type 		= $this->input->post('item_type');
		$item_ppu		= $this->input->post('item_net_price');
		$item_price 	= $this->input->post('item_totalnet_price');
		$item_name		= $this->input->post('item_name');
		$item_qty		= $this->input->post('item_qty');
		$item_description	= $this->input->post('item_description');
		$item_discount_type	= $this->input->post('item_discount_type');
		$item_discount		= $this->input->post('item_discount');
		$taxable			= $this->input->post('taxable');
		$tax_code			= $this->input->post('tax_code');

		
		$this->db->query("DELETE FROM `debit_note_items` WHERE `debit_note_id` = ?", array($id));
		
				
		for ($i = 0; $i < count($items); $i++){
			$name = explode('<',$item_name[$i]);
			$item_name_actual = $name[0];

			$sql = $this->db->insert_string('debit_note_items',array(
				'debit_note_id'		=> $id,
				'item_id'			=> $items[$i],
				'item_name'			=> $item_name_actual,
				'item_description'	=> $item_description[$i],
				'qty'				=> $item_qty[$i],
				'price'				=> $item_price[$i],
				'price_per_unit'	=> $item_ppu[$i],
				'taxable'			=> $taxable[$i],
				'tax_code'			=> $tax_code[$i],
				'discount_type'		=> $item_discount_type[$i],
				'discount'			=> $item_discount[$i],
				'warehouse_id'		=> $this->user->data('branch')
			));
			
			$this->db->query($sql);
			
		}
		
		return $this->get_dn_by_id($id);
		
	}


	function Delete_dn($id){
		$dn = $this->get_dn_by_id($id);
		$this->db->query("DELETE FROM `debit_note_items` WHERE `debit_note_id` = ?", array($id));
		$this->db->query("DELETE FROM `debit_notes` WHERE `id`= ?", array($id));
		
		return $dn;
		
	}
	
	function DN_items_received($dn_id){

		$received 	= $this->input->post('received_qty');
		$done		= $this->input->post('done');
		$grand_total = 0;
		
		$cost_update_method = $this->system->config('cost_update_method');
		
		foreach ($received as $order_id => $qty){

			$query = $this->db->query("SELECT * FROM `debit_note_items` WHERE `id` = ?", array($order_id));
			$order = $query->row();
			
			$item = $this->get_item_by_id($order->item_id);
			
			$sql = $this->db->update_string('debit_note_items', array(
				'received' 			=> $qty,
				'received_price'	=> $qty * $order->price_per_unit,
				'done'				=> $done[$order->id]
			), "`id` = '{$order_id}'");
		
			$this->db->query($sql);

			$this->update_item_cost($order->item_id);
			$this->update_item_qty($order->item_id);
			
			$grand_total += $qty * $order->price_per_unit;
		}
		
		

		$query = $this->db->query("SELECT * FROM `debit_notes` WHERE `id` = ?", array($dn_id));
		$dn = $query->row();
		
		$grand_total = $grand_total + $dn->handling_charges;
		
		if ($dn->adjustment_type == 'Add'){
			$grand_total += $dn->adjustment;
		} else {
			$grand_total -= $dn->adjustment;
		}
		
		$sql = $this->db->update_string('debit_notes', array(
			'total_received'	=> $grand_total 
		),"`id` = '{$dn_id}'");
		
		$this->db->query($sql);
		
		return $this->get_dn_by_id($dn_id);
		
	}
	
	function DN_items_unreceived($dn_id){
		
		
		$query = $this->db->query("SELECT * FROM `debit_note_items` WHERE `debit_note_id` = ?", array($dn_id));
		
		$cost_update_method = $this->system->config('cost_update_method');
		
		$sql = $this->db->update_string('debit_note_items', array(
			'received' 			=> 0,
			'received_price'	=> 0,
			'done'	   			=> 0
		), "`debit_note_id` = '{$dn_id}'");
		
		$this->db->query($sql);
		
		$query = $this->db->query("SELECT * FROM `debit_note_items` WHERE `debit_note_id` = ?", array($dn_id));
		

		foreach ($query->result() as $order){
			$this->update_item_cost($order->item_id);
			$this->update_item_qty($order->item_id);
		}
		
		$sql = $this->db->update_string('debit_notes', array(
			'status' 			=> 'Pending',
			'total_received'	=> 0
		),"`id` = '{$dn_id}'");
		
		$this->db->query($sql);
		
		return $this->get_dn_by_id($dn_id);
	}

	
	
	
	function Items_by_category(){
		$query = $this->db->query("SELECT COUNT(`category`) as `frequency`, `category` FROM `inventory` GROUP BY `category`");
		foreach($query->result() as $product){
			$data[$product->category] = $product->frequency;
		}
		return $data;
	}
	
		
	function Get_item_quantity($item_id, $warehouse){
	
		if (!$warehouse) $warehouse = $this->user->data('branch');
		
		if ($warehouse == '*' || $warehouse == ''){
		
			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));
			$inbound = $query->row();
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));
			$returned = $query->row();
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));
			$c_returned = $query->row();
			
			$query = $this->db->query("SELECT SUM(`delivered`) AS `total_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `no_do` IS NULL GROUP BY `item_id`", array($item_id));
			$invoiced = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `sold` = 1  GROUP BY `item_id`", array($item_id));
			$outbound = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `fnb_sale_items` WHERE `si_item_id` = ? AND `sold` = 1  GROUP BY `si_item_id`", array($item_id));
			$fnb_outbound = $query->row();

			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `fnb_buffer_sale_items` WHERE `si_item_id` = ? AND `sold` = 1  GROUP BY `si_item_id`", array($item_id));
			$fnb_buffer_outbound = $query->row();


		} else {
		
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_inbound` FROM `warehouse_movement_items` WHERE `item_id` = ? AND `to_warehouse` = ? AND `status` = 'Moved' GROUP BY `item_id`", array($item_id, $warehouse));
			$inbound_movement = $query->row();
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));
			$inbound_po = $query->row();			
			
			$inbound->total_inbound = $inbound_movement->total_inbound + $inbound_po->total_inbound;
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));
			$returned = $query->row();
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));
			$c_returned = $query->row();
			
			$query = $this->db->query("SELECT SUM(`delivered`) AS `total_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `warehouse_id` = ? AND `no_do` IS NULL GROUP BY `item_id`", array($item_id, $warehouse));
			$invoiced = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `warehouse_id` = ? AND `sold` = 1  GROUP BY `item_id`", array($item_id, $warehouse));
			$outbound = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `fnb_sale_items` WHERE `si_item_id` = ? AND `warehouse_id` = ? AND `sold` = 1  GROUP BY `si_item_id`", array($item_id, $warehouse));
			$fnb_outbound = $query->row();

			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `fnb_buffer_sale_items` WHERE `si_item_id` = ? AND `warehouse_id` = ? AND `sold` = 1  GROUP BY `si_item_id`", array($item_id, $warehouse));
			$fnb_buffer_outbound = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `warehouse_movement_items` WHERE `item_id` = ? AND `from_warehouse` = ? AND `status` = 'Moved' GROUP BY `item_id`", array($item_id, $warehouse));
			$movement = $query->row();


		}
		

		$qty = $inbound->total_inbound - $outbound->total_outbound - $invoiced->total_outbound - $returned->total_outbound + $c_returned->total_inbound - $fnb_buffer_outbound->total_outbound - $fnb_outbound->total_outbound - $movemnet->total_outbound;
		
		
		return $qty;
	}
	
	function Get_outbound_quantity($item_id){
		$query = $this->db->query("SELECT `id`, SUM(`delivered`) AS `total_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `no_do` != 1", array($item_id));
		$invoiced = $query->row();
		
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `sold` = 1", array($item_id));
		$outbound = $query->row();
		
		$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ?", array($item_id));
		$returned = $query->row();

		return $outbound->total_outbound + $invoiced->total_outbound + $returned->total_outbound;	
	}
	
	function Get_inbound_quantity($item_id){
		$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ? AND `purchase_order_id` <> 0", array($item_id));
		$inbound = $query->row();

		$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? AND `credit_note_id` <> 0", array($item_id));
		$returned = $query->row();

		return $inbound->total_inbound + $returned->total_inbound;	
	}
	

	function Get_stock_counts($where){
		$query = $this->db->query("SELECT * FROM `stock_count` {$where}");
		return $query->result();
	}
	
	function Stock_count($id){
		$count = $this->input->post('count');
		$cost = $this->input->post('cost');
		$sku = $this->input->post('sku');
		$price = $this->input->post('price');
		$name = $this->input->post('name');
		$category = $this->input->post('category');
		$subcategory = $this->input->post('subcategory');
		$brand = $this->input->post('brand');
		
		$item = $this->get_item_by_sku($sku); 

		$item_count = $count;		
		$count = $count - $item->qty;
		
		$sql = $this->db->update_string('inventory', array(
			'name'			=> $name,
			'price'			=> $price,
			'category'		=> $category,
			'subcategory'	=> $subcategory,
			'brand'			=> $brand
		), "`id` = '{$item->id}'");
		
		$this->db->query($sql);
		
		$sql = $this->db->insert_string('stock_count_items',array(
			'count_id'		=> $id,
			'item_id'		=> $item->id,
			'qty'			=> $item_count,
			'discrepancy'	=> $item_count - $item->qty,
			'datetime'		=> date('Y-m-d H:i:s'),
			'username'		=> $this->user->data('username'),
			'warehouse_id'	=> $this->user->data('branch')
		));
		
		$this->db->query($sql);
		
	}
	
	function Get_stock_take_data($item_id, $count_id){
		$query = $this->db->query("SELECT * FROM `stock_count_items` WHERE `item_id` = ? AND `count_id`", array($item_id, $count_id));
		return $query->result();
	}
	
	function Bulk_update_cost($item_id, $cost){
		$item = $this->get_item_by_id($item_id);

		$warehouse = $this->user->data('branch');

		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? AND `purchase_order_id` = ? AND `warehouse_id` = ?", array($item_id, 0, $warehouse));
		
		if ($query->num_rows()){
			$initial_offset = $query->row();
			$offset_qty = $initial_offset->received;
			
			// $this->db->query("UPDATE `purchase_order_items` SET `received` = ? WHER", array($offset_qty, $item_id, 0, $warehouse));
			
			$this->db->update('purchase_order_items', array(
				'received'			=> $offset_qty,
				'received_price'	=> $offset_qty * $cost
			), "`item_id` = '{$item->id}' AND `purchase_order_id` = 0 AND `warehouse_id` = '{$warehouse}'");

		} else {
			$this->system->set_config('diagnose',5);
			$offset_qty = $initial_offset->received;
			
			$sql = $this->db->insert_string('purchase_order_items', array(
				'item_id'			=> $item->id,
				'received'			=> $offset_qty,
				'received_price'	=> $offset_qty * $cost,
				'purchase_order_id'	=> '0',
				'warehouse_id'		=> $warehouse
			));
			$this->db->query($sql);

		}
	}
	
	function Bulk_update_selling($item_id, $selling){
		$this->db->query("UPDATE `sale_items` SET `amount` = ($selling * `qty`) AND `margin` = (($selling * qty) - `cost`) WHERE `item_id` = ?", array($item_id));
	}
	
	function Update_quantity($item_id, $new_qty, $report = true){
		$item = $this->get_item_by_id($item_id);
		$item->qty = $this->get_item_quantity($item_id);

		$warehouse = $this->user->data('branch');

		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? AND `purchase_order_id` = ? AND `warehouse_id` = ?", array($item_id, 0, $warehouse));


		// if ($new_qty == $item->qty) return;
		
		if ($query->num_rows()){
			$initial_offset = $query->row();
			$offset_qty = $initial_offset->received + $new_qty - $item->qty;
			
			// $this->db->query("UPDATE `purchase_order_items` SET `received` = ? WHER", array($offset_qty, $item_id, 0, $warehouse));
			
			$this->db->update('purchase_order_items', array(
				'received'			=> $offset_qty,
				'received_price'	=> $offset_qty * $item->cost
			), "`item_id` = '{$item->id}' AND `purchase_order_id` = 0 AND `warehouse_id` = '{$warehouse}'");
			
			if ($report){
				$sql = $this->db->insert_string('stock_adjustment',array(
					'datetime'		=> date('Y-m-d H:i:s'),
					'item_id'		=> $item->id,
					'item_sku'		=> $item->sku,
					'item_name'		=> $item->name,
					'previous_qty'	=> $item->qty,
					'new_qty'		=> $new_qty,
					'warehouse_id'	=> $warehouse,
					'performed_by'	=> $this->user->data('username')
				));
				$this->db->query($sql);
			}
		} else {

			$offset_qty = $initial_offset->received + $new_qty - $item->qty;
			
			$sql = $this->db->insert_string('purchase_order_items', array(
				'item_id'			=> $item->id,
				'received'			=> $offset_qty,
				'received_price'	=> $offset_qty * $item->cost,
				'purchase_order_id'	=> '0',
				'warehouse_id'		=> $warehouse
			));
			$this->db->query($sql);
			
			if ($report){
				$sql = $this->db->insert_string('stock_adjustment', array(
					'datetime'		=> date('Y-m-d H:i:s'),
					'item_id'		=> $item->id,
					'item_sku'		=> $item->sku,
					'item_name'		=> $item->name,
					'previous_qty'	=> $item->qty,
					'new_qty'		=> $new_qty,
					'warehouse_id'	=> $warehouse,
					'performed_by'	=> $this->user->data('username')
				));
				$this->db->query($sql);
			}
		}
		
		$this->update_item_qty($item_id, $warehouse);
		
	}
	


	function Fifo_entry($item, $cost, $qty, $po_item_id, $po_id){
		$query = $this->db->query("SELECT * FROM `fifo` WHERE `item_id` = ? AND `po_id` = ?", array($item->id, $po_id));
		
		if ($query->num_rows()){
			$sql = $this->db->update_string('fifo',array(
				'cost'		=> $cost,
				'qty'		=> $qty
			), "`item_id` = '{$item->id}' AND `po_id` = '{$po_id}'");
			
			$this->db->query($sql);
			
		} else {
			$sql = $this->db->insert_string('fifo',array(
				'cost'		=> $cost,
				'qty'		=> $qty,
				'item_id'	=> $item->id,
				'po_item_id'=> $po_item_id,
				'po_id'		=> $po_id,
				'datetime'	=> date('Y-m-d H:i:s')
			));
			
			$this->db->query($sql);
		}
	}
	
	function Get_fifo_cost($item_id, $qty, $warehouse_id){

		if (!$warehouse_id) $warehouse_id = $this->user->data('branch');

		if ($warehouse_id){
			$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? AND `warehouse_id` = ? ORDER BY `date` ASC", array($item_id, $warehouse_id));
		} else {
			$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? ORDER BY `date` ASC", array($item_id));				
		}

		
		$item = $this->get_item_by_id($item_id);

    	$fifo_cost = $item->cost; // defaulting
    	$fifo_qty = 0;
    	
    	$outbound = $this->get_outbound_quantity($item_id);
    	
    	$cont = true;
    	
    	$iqty = $qty;
    	
    	if (!$query->num_rows()) return $item->cost * $qty;

    	foreach ($query->result() as $fifo){
    		$fifo_qty += $fifo->received;
    		if ($fifo_qty >= $outbound && $cont){	
				if ($fifo_qty >= $outbound + $iqty){
					$cost += $qty * $fifo->price_per_unit;
	    			$cont = false;
				} else {

					$bal = $outbound + $iqty - $fifo_qty;
					$cost += ($qty - $bal) * $fifo->price_per_unit;
					$qty = $bal;
				}

    		}
    	}
    	

    	
    	return $cost;
	}
	
	function Check_fifo_cost($item_id, $warehouse_id){
	
		if (!$warehouse_id) $warehouse_id = $this->user->data('branch');

		$item = $this->get_item_by_id($item_id);

    	$cost = $item->cost; // defaulting
    	$fifo_qty = 0;
    	
    	$outbound = $this->get_outbound_quantity($item_id);
    	
    	$cont = true;
		
		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? AND `warehouse_id` = ? ORDER BY `date` ASC", array($item_id, $warehouse_id));	
    	
    	foreach ($query->result() as $fifo){
    		$fifo_qty += $fifo->received;
    		if ($fifo_qty < $outbound){
				// do nothing
				// echo 'less';
    		} else {
    			if ($cont){
					$cost = $fifo->price_per_unit;
					$cont = false;
					
					echo '<br />'.'outbound:' . $outbound;
					echo '<br />'.'cost:' . $cost;
				}
			}
    	}
    	
    		
    	// echo '<br />Current cost: ' . $cost;
    	// echo '<br />Item ID: ' . $item_id;
    	// echo '<br />Warehouse ID: ' . $warehouse_id  . '<br />'; 
    	
		
		if (!$cost) $cost = $item->cost * 1;
		
		$this->db->query("UPDATE `inventory_stock_quantities` SET `cost` = ? WHERE `item_id` = ? AND `warehouse_id` = ?", array($cost, $item_id, $warehouse_id));

		
    	return $cost;
	}
	
	function Update_item_qty($item_id, $warehouse_id){

		if (!$warehouse_id) $warehouse_id = $this->user->data('branch');
		
		$query = $this->db->query("SELECT `id` FROM `inventory_stock_quantities` WHERE `item_id` = ? AND `warehouse_id` = ?", array($item_id, $warehouse_id));
		if ($query->num_rows()){
		    $isq = $query->row();
		    
		    $qty = $this->get_item_quantity($item_id, $warehouse_id);
		    
		    $this->db->update('inventory_stock_quantities', array(
		    	'qty' 			=> $qty,
		    	'last_sold'		=> date('Y-m-d H:i:s')
		    ), "`id` = '{$isq->id}'");
		} else {
			$item = $this->get_item_by_id($item_id);
			
		    $qty = $this->get_item_quantity($item_id, $warehouse_id);
		    
		    $this->db->insert('inventory_stock_quantities', array(
		    	'item_id'		=> $item->id,
		    	'item_name'		=> $item->name,
		    	'item_sku'		=> $item->sku,
		    	'warehouse_id'	=> $warehouse_id,
		    	'alert_quantity'=> $item->alert_quantity,
		    	'qty'			=> $qty
		    ));
		}
			

	}
	
	function Update_item_average_cost($item_id, $qty, $cost){
		$item = $this->get_item_by_id($item_id);
		$cost = (($qty * $cost) + ($item->qty * $item->cost)) / ($item->qty + $qty);
		$this->db->update('inventory', array(
			'cost'			=> $cost,
			'average_cost'	=> $cost
		),"`id` = '{$item->id}'");
		
	}


	function Update_item_cost($item_id){
	    $method = $this->system->config('cost_update_method');
	    
	    if ($method == 'average') return;
	    
		$query = $this->db->query("SELECT `date`, `received` AS `qty`, 'in' AS `type`, `received_price` AS `amount` FROM `purchase_order_items` WHERE `item_id` = ? AND `received` > 0 AND `warehouse_id` = ? UNION
							SELECT `date`, `qty`, 'out' AS `type`,`cost` AS `amount` FROM `sale_items` WHERE `item_id` = ? AND `sold` = '1' AND `warehouse_id` = ? UNION
							SELECT `date`, `qty`, 'out' AS `type`,`cost` AS `amount` FROM `fnb_sale_items` WHERE `si_item_id` = ? AND `sold` = '1' AND `warehouse_id` = ? UNION
							SELECT `date`, `qty`, 'out' AS `type`,`cost` AS `amount` FROM `fnb_buffer_sale_items` WHERE `si_item_id` = ? AND `sold` = '1' AND `warehouse_id` = ? UNION
							SELECT `date`, `delivered` AS `qty`, 'out' AS `type`, `cost` AS `amount` FROM `invoice_items` WHERE `item_id` = ? AND `delivered` > 0 AND `warehouse_id` = ? UNION
							SELECT `date`, `received` AS `qty`, 'out' AS `type`, `received_price` AS `amount` FROM `debit_note_items` WHERE `item_id` = ? AND `received` > 0 AND `warehouse_id` = ?
							ORDER BY `date` ASC", array($item_id, $warehouse_id, $item_id, $warehouse_id, $item_id, $warehouse_id, $item_id, $warehouse_id, $item_id, $warehouse_id, $item_id, $warehouse_id));
			
		foreach ($query->result() as $inout){
	    	if ($inout->type == 'in'){
	    		$cur_quantity += $inout->qty;
	    		$in_cost = $inout->amount;
	    		$value += $in_cost;
	    	} else {
	    		$cur_quantity -= $inout->qty;
	    		$out_cost = $inout->amount;
	    		$value -= $out_cost;
	    	}
	    }
	    
	    if ($method == 'fifo'){
    		$this->check_fifo_cost($item_id, $this->user->data('branch'));
    	} elseif ($method == 'lifo'){
    		// get from last purchase order
    		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? ORDER BY `date` DESC LIMIT 1", array($item_id));
    		$po_item = $query->row();
    		
    		$this->db->query("UPDATE `inventory` SET `cost` = ? WHERE `id` = ?", array($po_item->price_per_unit, $item_id));    		
    		$this->db->query("UPDATE `inventory_stock_quantities` SET `cost` = ? WHERE `item_id` = ?", array($po_item->price_per_unit, $item_id));    		
    	}
	}
	
	function Get_pending_po(){
		$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `payment_status` = 'Unpaid' ORDER BY `supplier` ASC, `date` ASC");
		return $query->result();
	}
	
	function Get_pending_po_by_contact($id){
		$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `supplier_id` = ? AND `payment_status` = 'Unpaid' ORDER BY `date` ASC", array($id));
		return $query->result();
		
	}
	

	
	function Get_purchase_orders_by_contact($id, $date_from, $date_to, $where){
		if ($date_from == NULL && $date_to == NULL){
			if ($where) $where = ' AND ' . $where;
			$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `supplier_id` = ? {$where} ORDER BY `date` DESC", array($id));
			return $query->result();
		} else {
			$query = $this->db->query("SELECT SUM(`total`) AS `balance` FROM `purchase_orders` WHERE `supplier_id` = ?  AND `date` < ? GROUP BY `supplier_id`", array($id, $date_from));
			$opening = $query->row();
		
			$query = $this->db->query("SELECT * FROM `purchase_orders` WHERE `supplier_id` = ? AND `date` >= ? AND `date` <= ? ORDER BY `date` ASC", array($id, $date_from, $date_to));
			$pos = $query->result();
		
			$txn->opening_balance = $opening->balance;
			$txn->purchase_orders = $pos;
		
			return $txn;
		}
	}
	

	
	function Get_debit_notes_by_contact($id, $date_from, $date_to, $where){
		if ($date_from == NULL && $date_to == NULL){
			if ($where) $where = ' AND ' . $where;
			$query = $this->db->query("SELECT * FROM `debit_notes` WHERE `supplier_id` = ? {$where} ORDER BY `date` DESC", array($id));
			return $query->result();
		} else {
		
			$query = $this->db->query("SELECT SUM(`total`) AS `balance` FROM `debit_notes` WHERE `supplier_id` = ?  AND `date` < ? GROUP BY `supplier_id`", array($id, $date_from));
			$opening = $query->row();
		
			$query = $this->db->query("SELECT * FROM `debit_notes` WHERE `supplier_id` = ? AND `date` >= ? AND `date` <= ? ORDER BY `date` ASC", array($id, $date_from, $date_to));
			$debit_notes = $query->result();
		
			$txn->opening_balance = $opening->balance;
			$txn->debit_notes = $debit_notes;
		
			return $txn;
		}
	}
	

	function Get_movement_by_id($id){
		$query = $this->db->query("SELECT * FROM `warehouse_movements` WHERE `id` = ?", array($id));
		$movement = $query->row();
		
		$query = $this->db->query("SELECT * FROM `warehouse_movement_items` WHERE `movement_id` = ?", array($movement->id));
		$movement->items = $query->result();
		
		return $movement;
		
	}
	
	function Get_movements($filter){
		if ($filter) $filter = 'WHERE ' . $filter;
		$query = $this->db->query("SELECT * FROM `warehouse_movements` {$filter}");
		return $query->result();
	}
	

	function Add_movement(){
		$query = $this->db->query("SELECT * FROM `warehouses`");
		foreach ($query->result() as $warehouse){
			$address = $address_line = null;
			$warehouses[$warehouse->id] = $warehouse->name;
			$address[] = $warehouse->address1;
			$address[] = $warehouse->address2;
			$address[] = $warehouse->zipcode . ' ' . $warehouse->city;;
			$address[] = $warehouse->state ? ($warehouse->country ? $warehouse->state . ', ' . $warehouse->country : $warehouse->state) : '';
			foreach ($address as $line){
				if ($line) $address_line .= $line . "\n";
			}
			
			$warehouse_address[$warehouse->id] = $address_line;
		}
		
		$warehouses['0'] = 'Consolidated';
		
		list($day,$month,$year) = explode('/', $this->input->post('delivered_date'));
		$delivered_date = $year . '-' . $month . '-' . $day;
		
		list($day,$month,$year) = explode('/', $this->input->post('received_date'));
		$received_date = $year . '-' . $month . '-' . $day;
		
		foreach ($this->input->post('item_qty') as $qty){
			$total_qty += $qty;
		}
		
		$sql = $this->db->insert_string('warehouse_movements',array(
			'from_warehouse'		=> $this->input->post('from_warehouse'),
			'from_warehouse_name'	=> $warehouses[$this->input->post('from_warehouse')],
			'from_warehouse_address'=> $warehouse_address[$this->input->post('from_warehouse')],
			'to_warehouse'			=> $this->input->post('to_warehouse'),
			'to_warehouse_name'		=> $warehouses[$this->input->post('to_warehouse')],
			'to_warehouse_address'	=> $warehouse_address[$this->input->post('to_warehouse')],			
			'total_items'			=> $total_qty,
			'delivered_date'		=> $delivered_date,
			'received_date'			=> $received_date,
			'status'				=> 'Pending',
			'tags'					=> $this->input->post('tags'),
			'added_by'				=> $this->user->data('username'),
			'added_on'				=> date('Y-m-d H:i:s'),
			'remarks'				=> $this->input->post('remarks')
		));
		
		$query = $this->db->query($sql);
		
		$movement_id = $query->insert_id;
		
		$items = $this->input->post('item_id');				
		$item_qtys = $this->input->post('item_qty');
		
		for ($i = 0; $i < count($items); $i++){
			
			$id = $items[$i];
			$qty = $item_qtys[$i];
			
			$item = $this->get_item_by_id($id);
			
			$sql = $this->db->insert_string('warehouse_movement_items', array(
				'movement_id'			=> $movement_id,
				'item_id'				=> $item->id,
				'item_name'				=> $item->name,
				'item_sku'				=> $item->sku,				
				'from_warehouse'		=> $this->input->post('from_warehouse'),
				'from_warehouse_name'	=> $warehouses[$this->input->post('from_warehouse')],
				'to_warehouse'			=> $this->input->post('to_warehouse'),
				'to_warehouse_name'		=> $warehouses[$this->input->post('to_warehouse')],
				'qty'					=> $qty,
				'delivered_date'		=> $delivered_date,
				'received_date'			=> $received_date,
				'status'				=> $this->input->post('status'),
			));
			
			$this->db->query($sql);
		}
		
		return $this->get_movement_by_id($movement_id);
	}
	

	
	function Edit_movement($id){
	
		$query = $this->db->query("SELECT * FROM `warehouses`");
		foreach ($query->result() as $warehouse){
			$address = $address_line = null;
			$warehouses[$warehouse->id] = $warehouse->name;
			$address[] = $warehouse->address1;
			$address[] = $warehouse->address2;
			$address[] = $warehouse->zipcode . ' ' . $warehouse->city;;
			$address[] = $warehouse->state ? ($warehouse->country ? $warehouse->state . ', ' . $warehouse->country : $warehouse->state) : '';
			foreach ($address as $line){
				if ($line) $address_line .= $line . "\n";
			}
			
			$warehouse_address[$warehouse->id] = $address_line;
		}
		
		$warehouses['0'] = 'Consolidated';
		
		list($day,$month,$year) = explode('/', $this->input->post('delivered_date'));
		$delivered_date = $year . '-' . $month . '-' . $day;
		
		list($day,$month,$year) = explode('/', $this->input->post('received_date'));
		$received_date = $year . '-' . $month . '-' . $day;
		
		foreach ($this->input->post('item_qty') as $qty){
			$total_qty += $qty;
		}
		
		$sql = $this->db->update_string('warehouse_movements',array(
			'from_warehouse'		=> $this->input->post('from_warehouse'),
			'from_warehouse_name'	=> $warehouses[$this->input->post('from_warehouse')],
			'from_warehouse_address'=> $warehouse_address[$this->input->post('from_warehouse')],
			'to_warehouse'			=> $this->input->post('to_warehouse'),
			'to_warehouse_name'		=> $warehouses[$this->input->post('to_warehouse')],
			'to_warehouse_address'	=> $warehouse_address[$this->input->post('to_warehouse')],			
			'total_items'			=> $total_qty,
			'delivered_date'		=> $delivered_date,
			'received_date'			=> $received_date,
			'tags'					=> $this->input->post('tags'),
			'modified_by'			=> $this->user->data('username'),
			'modified_on'			=> date('Y-m-d H:i:s'),
			'remarks'				=> $this->input->post('remarks')
		),"`id` = '{$id}'");
		
		$query = $this->db->query($sql);
		
		$this->db->query("DELETE FROM `warehouse_movement_items` WHERE `movement_id` = ?", array($id));
		
		$items = $this->input->post('item_id');				
		$item_qtys = $this->input->post('item_qty');
		
		for ($i = 0; $i < count($items); $i++){
			
			$item_id = $items[$i];
			$qty = $item_qtys[$i];
			
			$item = $this->get_item_by_id($item_id);
			
			$sql = $this->db->insert_string('warehouse_movement_items', array(
				'movement_id'			=> $id,
				'item_id'				=> $item->id,
				'item_name'				=> $item->name,
				'item_sku'				=> $item->sku,
				'from_warehouse'		=> $this->input->post('from_warehouse'),
				'from_warehouse_name'	=> $warehouses[$this->input->post('from_warehouse')],
				'to_warehouse'			=> $this->input->post('to_warehouse'),
				'to_warehouse_name'		=> $warehouses[$this->input->post('to_warehouse')],
				'qty'					=> $qty,
				'delivered_date'		=> $delivered_date,
				'received_date'			=> $received_date,
				'status'				=> $this->input->post('status')
			));
			
			$this->db->query($sql);
		}
		
		return $this->get_movement_by_id($movement_id);
	
	}
	

	
	function Delete_movement($id){
	
		$movement = $this->get_movement_by_id($id);
		
		$this->db->query("DELETE FROM `warehouse_movements` WHERE `id` = ?", array($id));
		$this->db->query("DELETE FROM `warehouse_movement_items` WHERE `movement_id` = ?", array($id));
		
		return $movement;

	}
	

	
	function Get_warehouses_dropdown($dropdown){
		$query = $this->db->query("SELECT * FROM `warehouses` ORDER BY `name` ASC");
		if ($dropdown) $warehouses[] = "Select Warehouse";
		else $warehouses['*'] = 'Consolidated';
		
		foreach ($query->result() as $warehouse){
			$warehouses[$warehouse->id] = $warehouse->name;
		}
		return $warehouses;
	
	}
	
	function Get_warehouses($filter){
		if ($filter) $filter = 'WHERE ' . $filter;
		$query = $this->db->query("SELECT * FROM `warehouses` $filter");
		return $query->result();
	}
	
	
	function Get_warehouse_by_id($id){
		$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($id));
		return $query->row();
	}
		

	function Add_warehouse(){
		$sql = $this->db->insert_string('warehouses', array(
			'name'			=> $this->input->post('name'),
			'type'			=> $this->input->post('type'),
			'type_reference'=> $this->input->post('type_reference'),
			'address1'		=> $this->input->post('address1'),
			'address2'		=> $this->input->post('address2'),
			'city'			=> $this->input->post('city'),
			'state'			=> $this->input->post('state'),
			'zipcode'		=> $this->input->post('zipcode'),
			'country'		=> $this->input->post('country'),
			'tel'			=> $this->input->post('tel'),
			'fax'			=> $this->input->post('fax'),
			'email'			=> $this->input->post('email'),
			'remarks'		=> $this->input->post('remarks'),
			'tags'			=> $this->input->post('tags'),
			'online_store'	=> $this->input->post('online_store'),
			'added_on'		=> date('Y-m-d H:i:s'),
			'added_by'		=> $this->user->data('username')
		));
		
		$query = $this->db->query($sql);
		
		$id = $query->insert_id;
		
		return $this->get_warehouse_by_id($id);
	}
	
	function Edit_warehouse($id){
		$sql = $this->db->update_string('warehouses', array(
			'name'			=> $this->input->post('name'),
			'type'			=> $this->input->post('type'),
			'type_reference'=> $this->input->post('type_reference'),
			'address1'		=> $this->input->post('address1'),
			'address2'		=> $this->input->post('address2'),
			'city'			=> $this->input->post('city'),
			'state'			=> $this->input->post('state'),
			'zipcode'		=> $this->input->post('zipcode'),
			'country'		=> $this->input->post('country'),
			'tel'			=> $this->input->post('tel'),
			'fax'			=> $this->input->post('fax'),
			'email'			=> $this->input->post('email'),
			'remarks'		=> $this->input->post('remarks'),
			'tags'			=> $this->input->post('tags'),
			'online_store'	=> $this->input->post('online_store'),
			'modified_on'	=> date('Y-m-d H:i:s'),
			'modified_by'	=> $this->user->data('username')
		), "`id` = '{$id}'");
		
		$this->db->query($sql);
	}
	
	function Delete_warehouse($id){
		if ($id == 1) return;
		$query = $this->db->query("DELETE FROM `warehouses` WHERE `id` = ?", array($id));
	}
	
	
	function Propagate_quantities($tokens){
		
		$query = $this->db->query("SELECT `id` FROM `warehouses`");
	    $warehouses = $query->result();
	    
	    if (!$this->system->config('warehouse_shared_inventory')) $independent = true;
	    else {
	    	$query = $this->db->query("SELECT `id`, `name`, `sku`, `alert_quantity` FROM `inventory`");
	    	$items = $query->result();
	    }
	    
	    foreach ($warehouses as $warehouse){
	    	$qty = $this->inv->get_item_quantity($item->id, $warehouse->id);
	    	
	    	if ($independent){
	    		$query = $this->db->query("SELECT `id`, `name`, `sku`, `alert_quantity` FROM `inventory` WHERE `warehouse_id` = ?", array($warehouse->id));
	    		$items = $query->result();
	    	}
	    	
	    	foreach ($items as $item){
	    		$query = $this->db->query("SELECT `id` FROM `inventory_stock_quantities` WHERE `item_id` = ? AND `warehouse_id` = ?", array($item->id, $warehouse->id));
	    		if ($query->num_rows()){
	    			$isq = $query->row();
	    			
	    			$this->db->update('inventory_stock_quantities', array(
	    				'qty' => $qty
	    			), "`id` = '{$isq->id}'");
	    		} else {
	    			
	    			$this->db->insert('inventory_stock_quantities', array(
	    				'item_id'		=> $item->id,
	    				'item_name'		=> $item->name,
	    				'item_sku'		=> $item->sku,
	    				'warehouse_id'	=> $warehouse->id,
	    				'alert_quantity'=> $item->alert_quantity,
	    				'qty'			=> $qty
	    			));
	    		}
	    	}
	    }
		
	}
	
	function Serial_no($type){
		$warehouse = $this->user->data('branch');
		$query = $this->db->query("SELECT `txn_no` FROM `$type` WHERE `warehouse_id` = ? ORDER BY `txn_no` DESC LIMIT 1", array($warehouse));
		$row = $query->row();
		
		list($w, $txn_no) = explode('-', $row->txn_no);
		
		if (!$txn_no){
			$next_id = $warehouse . '-' . 10001;
		} else {
			$next_id = $warehouse . '-' . ($txn_no + 1);
		}

		return $next_id;
	}
	
	function Get_consignment_items(){
		$query = $this->db->query("SELECT *, SUM(`qty`) AS `qty_consigned` FROM `sales_order_items` WHERE `consignment` = 1 GROUP BY `item_id`");
		return $query->result();
	}
	
	function Get_balance_consigned($item_id, $contact_id){
		if ($contact_id){
			$query = $this->db->query("SELECT sales_order_items.*, SUM(sales_order_items.qty) AS `qty_consigned`, sales_order.contact_id FROM sales_order_items LEFT JOIN sales_order ON sales_order.id = sales_order_items.sales_order_id WHERE sales_order.consignment = 1 AND sales_order.contact_id = ? AND sales_order_items.item_id = ?", array($contact_id, $item_id));
			$consigned = $query->row();
			
			$query = $this->db->query("SELECT invoice_items.*, SUM(invoice_items.qty) AS `qty_consigned`, invoices.contact_id FROM invoice_items LEFT JOIN invoices ON invoices.id = invoice_items.invoice_id WHERE invoices.consignment = 1 AND invoices.contact_id = ? AND invoice_items.item_id = ?", array($contact_id, $item_id));
			$invoiced = $query->row();
			
			return $consigned->qty_consigned - $invoiced->qty_consigned;
		} else {
			
			
		}

	}

}