<?php

class Klinik extends Model {

	function Klinik(){
		parent::Model();
		$this->load->model('contact');
	}
	
	
	function Add_patient(){
		$contact = $this->contact->get_contact_by_ic($this->input->post('ic'));
		
		if (!$contact){
			$query = $this->db->insert('contacts',array(
				'contact_person'		=> $this->input->post('name'),
				'ic'					=> $this->input->post('ic'),
				'is_customer'			=> 1,
				'contact_number'		=> $this->input->post('contact_number'),
				'address1'				=> $this->input->post('address1'),
				'address2'				=> $this->input->post('address2'),
				'city'					=> $this->input->post('city'),
				'zipcode'				=> $this->input->post('zipcode'),
				'state'					=> $this->input->post('state'),
				'country'				=> $this->input->post('country'),
				'tel'					=> $this->input->post('contact_number'),
				'general_email'			=> $this->input->post('email'),
				'added_on'				=> date('Y-m-d H:i:s'),
				'added_by'				=> $this->user->data('username'),
				'status'				=> 'Active'
			));
			
			$contact_id = $query->insert_id;
			
		} else {
		
			$contact_id = $contact->id;
			
		}

		
		$sql = $this->db->insert('patients',array(
			'contact_id'				=> $contact_id,
			'marital_status'			=> $this->input->post('marital_status'),
			'gender'					=> $this->input->post('gender'),
			'ic'						=> $this->input->post('ic'),
			'blood_type'				=> $this->input->post('blood_type'),			
			'weight'					=> $this->input->post('weight'),
			'emergency_contact'			=> $this->input->post('emergency_contact'),
			'height'					=> $this->input->post('height'),
			'allergy'					=> $this->input->post('allergy'),
			'spouse_ic'					=> $this->input->post('spouse_ic'),
			'added_on'					=> date('Y-m-d H:i:s'),
			'added_by'					=> $this->user->data('username')
		));
	}
	
	function Edit_patient($id){

		$this->db->update('patients',array(
			'marital_status'			=> $this->input->post('marital_status'),
			'gender'					=> $this->input->post('gender'),
			'blood_type'				=> $this->input->post('blood_type'),			
			'weight'					=> $this->input->post('weight'),
			'height'					=> $this->input->post('height'),
			'allergy'					=> $this->input->post('allergy'),
			'spouse_ic'					=> $this->input->post('spouse_ic'),
			'modified_on'				=> date('Y-m-d H:i:s'),
			'modified_by'				=> $this->user->data('username')
		),"`id` = '{$id}'");
		
		$patient = $this->get_patient_by_id($id);
		
		$this->db->update('contacts',array(
			'contact_person'		=> $this->input->post('name'),
			'ic'					=> $this->input->post('ic'),
			'contact_number'		=> $this->input->post('contact_number'),
			'address1'				=> $this->input->post('address1'),
			'address2'				=> $this->input->post('address2'),
			'city'					=> $this->input->post('city'),
			'zipcode'				=> $this->input->post('zipcode'),
			'state'					=> $this->input->post('state'),
			'country'				=> $this->input->post('country'),
			'tel'					=> $this->input->post('contact_number'),
			'general_email'			=> $this->input->post('email'),
			'modified_on'			=> date('Y-m-d H:i:s'),
			'modified_by'			=> $this->user->data('username'),
		),"`id` = '{$patient->contact_id}'");
		
	}
	
	function Delete_patient($id){
		$patient = $this->get_patient_by_id($id);
		
		$this->db->query("DELETE FROM `patients` WHERE `id` = ?", array($patient->id));
		$this->db->query("DELETE FROM `contacts` WHERE `id` = ?", array($patient->contact_id));
		
	}
	
	function Get_patients($filter){
		if (!$filter) $filter = "patients.contact_id = contacts.id";
		else $filter = "patients.contact_id = contacts.id AND " . $filter;
		
		$query = $this->db->query("SELECT patients.id as `id`, patients.ic as `ic`, contacts.contact_person as `contact_person`, contacts.contact_number as `contact_number`  FROM `patients`, `contacts` WHERE {$filter}");
		return $query->result();
	}
	
	function Get_patient_by_id($id){
		$query = $this->db->query("SELECT * FROM `patients` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Get_patient_by_ic($ic){
		$query = $this->db->query("SELECT * FROM `patients` WHERE `ic` = ?", array($ic));
		return $query->row();
	}
	
	
	
	function Get_appointments($filter){
		if (!$filter) $filter = "WHERE `module` = 'Clinic' AND `module_type` = 'Patient Appointments'";
		else $filter = "WHERE `module` = 'Clinic' AND `module_type` = 'Patient Appointments' AND " . $filter;
		$query = $this->db->query("SELECT * FROM `calendar` $filter");
		return $query->result();
	}
	
	function Get_appointment_by_id($id){
		$query = $this->db->query("SELECT * FROM `calendar` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Add_appointment(){
		$query = $this->db->query("SELECT * FROM `patients` WHERE `id` = ?", array($this->input->post('patient')));
		$patient = $query->row();
		
		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($patient->contact_id));
		$contact = $query->row();
		
		list($day, $month, $year) = explode('/', $this->input->post('start_date'));
		$start_date = $year . '-' . $month . '-' . $day;
		$start = $start_date . ' ' . date('H:i:s',strtotime($this->input->post('start_time')));
		
		list($day, $month, $year) = explode('/', $this->input->post('end_date'));
		$end_date = $year . '-' . $month . '-' . $day;
		$end = $end_date . ' ' . date('H:i:s',strtotime($this->input->post('end_time')));
		
		
	
		$this->db->insert('calendar', array(
			'title'			=> 'Appointment: ' . $contact->contact_person,
			'type'			=> 'appointment',
			'module'		=> 'Clinic',
			'module_id'		=> $this->input->post('patient'),
			'module_type'	=> 'Patient Appointments',
			'location'		=> '',
			'priority'		=> 'Normal',
			'status'		=> 'Pending',
			'start'			=> $start,
			'end'			=> $end,
			'allday'		=> '',
			'user'			=> $this->user->data('username'),
			'broadcast'		=> 1,
			'notes'			=> $this->input->post('notes'),
			'division'		=> $this->input->post('division'),
			'branch'		=> $this->user->data('branch')
		));
	}
	
	function Edit_appointment($id){
		$query = $this->db->query("SELECT * FROM `patients` WHERE `id` = ?", array($this->input->post('patient')));
		$patient = $query->row();
		
		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($patient->contact_id));
		$contact = $query->row();
		
		list($day, $month, $year) = explode('/', $this->input->post('start_date'));
		$start_date = $year . '-' . $month . '-' . $day;
		$start = $start_date . ' ' . date('H:i:s',strtotime($this->input->post('start_time')));
		
		list($day, $month, $year) = explode('/', $this->input->post('end_date'));
		$end_date = $year . '-' . $month . '-' . $day;
		$end = $end_date . ' ' . date('H:i:s',strtotime($this->input->post('end_time')));
			
		$this->db->update('calendar', array(
			'title'			=> 'Appointment: ' . $contact->contact_person,
			'location'		=> '',
			'priority'		=> 'Normal',
			'status'		=> 'Pending',
			'start'			=> $start,
			'end'			=> $end,
			'notes'			=> $this->input->post('notes'),
			'division'		=> $this->input->post('division')			
		), "`id` = '{$id}'");
	}
	
	function Delete_appointment($id){
		$this->db->query("DELETE FROM `calendar` WHERE `id` = ? AND `branch` = ? AND `module_type` = 'Patient Appointments'", array($id, $this->user->data('branch')));
	}
	
	
	function Patients_dropdown($dropdown = false){

		if ($dropdown) $patients[''] = "Select Patient";

		$query = $this->db->query("SELECT patients.id AS id, contacts.contact_person AS name FROM `patients`, `contacts` WHERE patients.contact_id = contacts.id ORDER BY contacts.contact_person ASC");
		foreach ($query->result() as $patient){
			$patients[$patient->id] = $patient->name;
		}

		return $patients;

	}
	
	function Get_patient_history($patient_id){
		$query = $this->db->query("SELECT * FROM `patient_history` WHERE `patient_id` = ? ORDER BY `added_on` DESC	", array($patient_id));
		return $query->result();
	}
	
	function Get_meds_history($contact_id){
		$query = $this->db->query("SELECT * FROM `sale_items` WHERE `customer_id` = ?", array($contact_id));
		return $query->result();
	}
	
	
}