<?php

class Sales extends Model {

	function Get_transactions($from, $to){
		
		$sql = "SELECT 'Cash Sale' AS `details`, 'sale' AS `type`, `id` AS `reference_no`, `amount`, `amount` AS `amount_received`, `amount_cheque`, `amount_cc`, `amount_credit`, `amount_cash`, `datetime` FROM `sales` WHERE `datetime` >= ? AND `datetime` <= ? AND `type` = 'history' UNION
				SELECT `supplier` AS `details`,'purchase' AS `type`, `id` AS `reference_no`, `total` AS `amount`,`total_received` AS `amount_received`,  0 AS `amount_cheque`, 0 AS `amount_cc`, 0 AS `amount_credit`, 0 AS `amount_cash`,`date` AS `datetime` FROM `purchase_orders` WHERE `date` >= ? AND `date` <= ? AND `payment_status` = 'Paid'
				ORDER BY `datetime` ASC";
		$query = $this->db->query($sql, array($from, $to, $from, $to));
		return $query->result();
	}
	
	function Balance_to_date($date){
		$query = $this->db->query("SELECT SUM(`amount`) AS `total_sales` FROM `sales` WHERE `datetime` < ? AND `type` = 'history' GROUP BY `type`", array($date));
		$sales = $query->row();
		
		$query = $this->db->query("SELECT SUM(`total`) AS `total_purchases` FROM `purchase_orders` WHERE `date` < ? AND `status` = 'Paid' GROUP BY `status`", array($date));
		$purchase = $query->row();
		
		return $sales->total_sales - $purchase->total_purchases;
		
	}

	function Daily_chart_data(){
		$datef = strtotime(date('Y-m-d'));

		for($i = 0; $i < 48; $i++){
			$cur_date = date("Y-m-d H:i:s",$datef + ((60*60*0.5)*$i));
			$next_date = date("Y-m-d H:i:s",$datef + ((60*60*0.5)*($i+1))); 
			list($day,$month,$year) = explode('-',$cur_date);

			$query = $this->db->query("SELECT * FROM `sales` WHERE `datetime` >= '$cur_date' AND `datetime` < '$next_date' AND `payment_status` = 'Paid'");
			$gtotal = 0;
			if ($query->num_rows()){
				foreach ($query->result() as $sales){

					$gtotal += $sales->amount;
				}
			}

					
			$data[$datef + ((60*60*0.5)*$i)] = $gtotal;
		}
		return $data;
	}

	function Chart_data($datefrom, $dateto){
	

		
		$duration = (strtotime($dateto) - strtotime($datefrom)) / (60 * 60 * 24);
		$datef = strtotime($datefrom);
		if ($duration > 50){
			$days_per_label = 2;
		} else if ($duration > 100){
			$days_per_label = 5;
		} else if ($duration > 200) {
			$days_per_label = 10;
		} else if ($duration > 300){
			$days_per_label = 30;
		} else {
			$days_per_label = 1;
		}
		
		for($i = 0; $i < $duration+1; $i++){
			$cur_date = date("Y-m-d",$datef + ((60*60*24)*$i));
			$next_date = date("Y-m-d",$datef + ((60*60*24)*($i+1))); 
			list($day,$month,$year) = explode('-',$cur_date);
			if ($cur_month != $month){
				$showmonth = true;
			} else {
				$showmonth = false;
			}

			$query = $this->db->query("SELECT * FROM `sales` WHERE `datetime` >= '$cur_date' AND `datetime` < '$next_date' AND `payment_status` = 'Paid'");
			$gtotal = 0;
			if ($query->num_rows()){
				foreach ($query->result() as $sales){

					$gtotal += $sales->amount;
				}
			}

					
			$data[$datef + ((60*60*24)*$i)] = $gtotal;
		}
		return $data;
	}
	
	function Get_sales_by_date($from, $to){
		$query = $this->db->query("SELECT * FROM `sales` WHERE `datetime` >= ? AND `datetime` < ? AND `payment_status` = 'Paid'", array($from, $to));
		return $query->result();
	}
	
	function Get_sales_by_daysweek($from, $to){
		$days = array();
	}

}