<?php

class Shipping extends Model {
	
	function Get_services(){
		$query = $this->db->query("SELECT * FROM `shipping`");
		return $query->result();
	}
	
	function Services_dropdown($dropdown){
		$query = $this->db->query("SELECT * FROM `shipping` ORDER BY `name` ASC");
		if ($dropdown) $services[] = 'Select';
		foreach ($query->result() as $service){
			$services[$service->id] = $service->name;
		}
		
		return $services;
	}

	function Get_service_by_id($id){
		$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?",array($id));
		return $query->row();
	}
	
	function Get_rates_by_service_id($service_id){
		$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ?",array($service_id));
		foreach ($query->result() as $rate){
			if ($rate->zone_type == 'Local'){
				$rate->zone = $this->get_local_zone_by_id($rate->zone_id);
			} else {
				$rate->zone = $this->get_international_zone_by_id($rate->zone_id);
			}
			$rates[] = $rate;
		}
		return $rates;
	}
	
	function Get_zones(){
		$query = $this->db->query("SELECT * FROM `shipping_local_zones`");
		foreach ($query->result() as $zone){
			$zone->type = 'Local';
			$zones[] = $zone;
		}
		
		$query = $this->db->query("SELECT * FROM `shipping_international_zones`");
		foreach ($query->result() as $zone){
			$zone->type = 'International';
			$zones[] = $zone;
		}
		
		return $zones;
	}
	
	function Get_rate_by_zone_id($type, $zone_id,$service_id){
		$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `zone_type` = ? AND `zone_id` = ? AND `service_id` = ?",array($type,$zone_id,$service_id));
		return $query->row();
	}
	
	function Get_zone_by_zipcode($zipcode){
		$query = $this->db->query("SELECT * FROM `shipping_local_zones` WHERE `zipcode_from` <= ? AND `zipcode_to` >= ?",array($zipcode,$zipcode));
		if ($query->num_rows()){
			return $query->row();
		} else {
			return false;
		}
	}
	
	function Get_service_name_by_id($id){
		$service = $this->get_service_by_id($id);
		return $service->name;
	}
	
	function Get_zone_by_country($country){
		$query = $this->db->query("SELECT * FROM `shipping_international_zones` WHERE FIND_IN_SET(`countries`,?)",array($country));
		if ($query->num_rows()){
			return $query->row();
		} else {
			return false;
		}
	}
	
	
	function Get_rate_by_id($id){
		$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `id` = ?",array($id));
		$rate = $query->row();
		if ($rate->zone_type == 'Local'){
			$rate->zone = $this->get_local_zone_by_id($rate->zone_id);
		} else {
			$rate->zone = $this->get_international_zone_by_id($rate->zone_id);
		}
		return $rate;
	}
	
	function Get_local_zone_by_id($id){
		$query = $this->db->query("SELECT * FROM `shipping_local_zones` WHERE `id` = ?",array($id));
		return $query->row();
	}
	
	function Get_international_zone_by_id($id){
		$query = $this->db->query("SELECT * FROM `shipping_international_zones` WHERE `id` = ?",array($id));
		return $query->row();
	}
	
	function Get_local_zones($exclude_service_id = null,$list = false){
		if ($exclude_service_id){
			$query = $this->db->query("SELECT `zone_id` FROM `shipping_rates` WHERE `service_id` = ? AND `zone_type` = 'Local'",array($exclude_service_id));
			
			$exclude_id[] = 0;
			foreach ($query->result() as $zone){
				$exclude_id[] = $zone->zone_id;
			}
			$exclude_zone_id = implode(',',$exclude_id);
			$query = $this->db->query("SELECT * FROM `shipping_local_zones` WHERE NOT FIND_IN_SET(`id`,?)",array($exclude_zone_id));

		} else {
			$query = $this->db->query("SELECT * FROM `shipping_local_zones`");			
		}
		if ($list){
			foreach ($query->result() as $zone){
				$zones[$zone->id] = $zone->name;
			}
			return $zones;
		} else {
			return $query->result();
		}
	}
	
	function Get_international_zones($exclude_service_id = null,$list = false){
		if ($exclude_service_id){
			$query = $this->db->query("SELECT `zone_id` FROM `shipping_rates` WHERE `service_id` = ? AND `zone_type` = 'International'",array($exclude_service_id));
			
			$exclude_id[] = 0;
			foreach ($query->result() as $zone){
				$exclude_id[] = $zone->zone_id;
			}
			$exclude_zone_id = implode(',',$exclude_id);
			$query = $this->db->query("SELECT * FROM `shipping_international_zones` WHERE NOT FIND_IN_SET(`id`,?)",array($exclude_zone_id));
		} else {
			$query = $this->db->query("SELECT * FROM `shipping_international_zones`");			
		}
		if ($list){
			foreach ($query->result() as $zone){
				$zones[$zone->id] = $zone->name;
			}
			return $zones;
		} else {
			return $query->result();
		}
	}


	function Add_service(){
		$sql = $this->db->insert_string('shipping',array(
			'name'					=> $this->input->post('name'),
			'description'			=> $this->input->post('description'),
			'type'					=> $this->input->post('type'),
			'measurements_type'		=> $this->input->post('measurements_type'),
			'calculation_technique'	=> $this->input->post('calculation_technique'),
			'shipping_factor'		=> $this->input->post('shipping_factor')
		));

		$this->db->query($sql);
		return $this->db->insert_id();
	}

	function Edit_service($id){
		$sql = $this->db->update_string('shipping',array(
			'name'					=> $this->input->post('name'),
			'description'			=> $this->input->post('description'),
			'type'					=> $this->input->post('type'),
			'measurements_type'		=> $this->input->post('measurements_type'),
			'calculation_technique'	=> $this->input->post('calculation_technique'),
			'shipping_factor'		=> $this->input->post('shipping_factor')
		),"`id` = '$id'");

		$this->db->query($sql);
	}

	function Add_rates($service_id){
		if ($this->input->post('zone_type') == 'Local'){
			$zone_id = $this->input->post('local_zone');
		} else {
			$zone_id = $this->input->post('international_zone');		
		}
		
		$sql = $this->db->insert_string('shipping_rates',array(
			'service_id'			=> $service_id,
			'zone_type'				=> $this->input->post('zone_type'),
			'zone_id'				=> $zone_id,
			'first_weight_rate'		=> $this->input->post('first_weight_rate'),
			'subsequent_weight_rate'=> $this->input->post('subsequent_weight_rate'),
			'flat_rate'				=> $this->input->post('flat_rate'),
			'max_weight_rate'		=> $this->input->post('max_weight_rate'),
			'first_weight'			=> $this->input->post('first_weight'),
			'subsequent_weight'		=> $this->input->post('subsequent_weight'),
			'max_weight'			=> $this->input->post('max_weight')

		));

		$this->db->query($sql);

		return $this->db->insert_id();
	}

	function Edit_rates($id){
		$sql = $this->db->update_string('shipping_rates',array(
			'first_weight_rate'		=> $this->input->post('first_weight_rate'),
			'subsequent_weight_rate'=> $this->input->post('subsequent_weight_rate'),
			'flat_rate'				=> $this->input->post('flat_rate'),
			'max_weight_rate'		=> $this->input->post('max_weight_rate'),
			'first_weight'			=> $this->input->post('first_weight'),
			'subsequent_weight'		=> $this->input->post('subsequent_weight'),
			'max_weight'			=> $this->input->post('max_weight')
		),"`id` = '$id'");

		$this->db->query($sql);
	}	

	function Add_local_zone(){
		$sql = $this->db->insert_string('shipping_local_zones',array(
			'name'			=> $this->input->post('name'),
			'description'	=> $this->input->post('description'),
			'zipcode_from'	=> $this->input->post('zipcode_from'),
			'zipcode_to'	=> $this->input->post('zipcode_to')
		));
		
		$this->db->query($sql);
	
	}

	function Add_international_zone(){
		$sql = $this->db->insert_string('shipping_international_zones',array(
			'name'			=> $this->input->post('name'),
			'description'	=> $this->input->post('description'),
			'countries'		=> implode(',',$this->input->post('countries'))
		));
		
		$this->db->query($sql);
	
	}
	
	function Edit_local_zone($id){
		$sql = $this->db->update_string('shipping_local_zones',array(
			'name'			=> $this->input->post('name'),
			'description'	=> $this->input->post('description'),
			'zipcode_from'	=> $this->input->post('zipcode_from'),
			'zipcode_to'	=> $this->input->post('zipcode_to')
		),"`id` = '$id'");
		
		$this->db->query($sql);
	
	}

	function Edit_international_zone($id){
		$sql = $this->db->update_string('shipping_international_zones',array(
			'name'			=> $this->input->post('name'),
			'description'	=> $this->input->post('description'),
			'countries'		=> implode(',',$this->input->post('countries'))
		),"`id` = '$id'");
		
		$this->db->query($sql);
	
	}
	
	
	
	function Calculate_shipping_charges($item,$service,$rate){
		if ($service->calculation_technique == 'By Weight'){
			if ($service->measurements_type == 'Metric'){
			
			} else if ($service->measurements_type == 'Imperial'){
			
			}
		}
	}
	
	function Get_shipping_rate_by_scz($service, $country, $zipcode){
		$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($service));
		$service = $query->row();
		
		
		if ($country == $this->system->config('country')){
			// local zone
			$query = $this->db->query("SELECT * FROM `shipping_local_zones` WHERE `zipcode_from` <= ? AND `zipcode_to` >= ?", array($zipcode, $zipcode));
			$service->zone = $query->row();
			
			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = 'Local'", array($service->id, $service->zone->id));
			$service->rate = $query->row();
						
		} else {

			$query = $this->db->query("SELECT * FROM `shipping_international_zones` WHERE FIND_IN_SET(?, `countries`)", array($country));
			$service->zone = $query->row();
			
			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = 'International'", array($service->id, $service->zone->id));
			$service->rate = $query->row();

		}
		
		
		return $service;
	
	}
	
	function Delete_international_zone($id){
		$this->db->query("DELETE FROM `shipping_international_zones` WHERE `id` = ?", array($id));
	}

	function Delete_local_zone($id){
		$this->db->query("DELETE FROM `shipping_local_zones` WHERE `id` = ?", array($id));
	}
	
	function Delete_rate($id){
		$this->db->query("DELETE FROM `shipping_rates` WHERE `id` = ?", array($id));
	}
	
	
	
	function Get_delivery_charges($service, $country, $zipcode, $items){
		
		$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($service));
		$service = $query->row();
		
		
		if ($country == $this->system->config('country')){
			// local zone
			$query = $this->db->query("SELECT * FROM `shipping_local_zones` WHERE `zipcode_from` <= ? AND `zipcode_to` >= ?", array($zipcode, $zipcode));
			$zone = $query->row();
			
			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = 'Local'", array($service->id, $zone->id));
			$rate = $query->row();
						
		} else {

			$query = $this->db->query("SELECT * FROM `shipping_international_zones` WHERE FIND_IN_SET(?, `countries`)", array($country));
			$zone = $query->row();
			
			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = 'International'", array($service->id, $zone->id));
			$rate = $query->row();

		}

		foreach ($items as $item){

			$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($item->id));
			$xitem = $query->row();
			

			if ($service->measurements_type == 'Metric'){
				
				$item_weight = $this->__convertWeight($xitem->weight, $xitem->weight_unit, 'kg');
				$item_volume = $this->__convertVolume($xitem->volume, $xitem->volume_unit, 'cm3');
				$item_volumetric_weight = $item_volume / $service->shipping_factor;
				

				$weight = $item_weight >= $item_volumetric_weight ? $item_weight : $item_volumetric_weight;
				$weight *= $item->qty;
				
			} else {
				
				$item_weight = $this->__convertWeight($xitem->weight, $xitem->weight_unit, 'lb');
				$item_volume = $this->__convertVolume($xitem->volume, $xitem->volume_unit, 'in3');
				$item_volumetric_weight = $item_volume / $service->shipping_factor;
				
				$weight = $item_weight >= $item_volumetric_weight ? $item_weight : $item_volumetric_weight;
				$weight *= $item->qty;
				
			}
			
			$total_items += $item->qty;
			$total_weight += $weight;		
			

			
			if ($weight <= $rate->first_weight){
			    $shipping_rate = $rate->flat_rate + $rate->first_weight_rate;
			} elseif ($weight >= $rate->max_weight_rate){
			    $shipping_rate = $rate->flat_rate + $rate->max_weight_rate;
			} else {
				$subsequent_rate = ceil(($weight - $rate->first_weight) / $rate->subsequent_weight) * $rate->subsequent_weight_rate;
			    $shipping_rate = $rate->flat_rate + $rate->first_weight_rate + $subsequent_rate;
			}
			

			$total_rates += $shipping_rate;

		}

		$data->total_rate = $total_rates ? $total_rates : 0;
		$data->total_weight = $total_weight ? $total_weight : 0;
		$data->total_items = $total_items ? $total_items : 0;
		$data->weight_unit = $service->measurements_type == 'Metric' ? 'kg' : 'lb';
		
		return $data;
		
	}
	
	function __convertWeight($value, $from, $to){
		$unit_ratios = array(
			'g'		=> 1,
			'kg'	=> 0.001,
			'oz'	=> 0.035273962,
			'lb'	=> 0.0022046226
		);
		
		return ($value / $unit_ratios[$from]) * $unit_ratios[$to];
	}
	
	function __convertVolume($value, $from, $to){
		$unit_ratios = array(
			'cm3'	=> 1,
			'l'		=> 0.001,
			'in3'	=> 0.0610237441
		);
		return ($value / $unit_ratios[$from]) * $unit_ratios[$to];
	}


	
}