<?php


class System extends Model {
	
	
	function Is_local_ip(){
		$ip = $_SERVER['REMOTE_ADDR'];
		if ($ip == '::1') return true;
		if ($ip == '127.0.0.1') return true;
		if (strpos($ip, '192.168') !== false) return true;
	}

	function System(){
		parent::Model();

		if ($this->uri->segment(1) == 'login') return;
		
		$query = $this->db->query("SELECT * FROM `modules`");
		$this->modules = $query->result();
		
		$this->check_version();
	}
	
	function Tag($tags){
		if (!strpos($tags,',')) $tags[] = $tags;
		foreach (explode(',', $tags) as $tag){
			if (trim($tag)){
				$query = $this->db->query("SELECT * FROM `tags` WHERE `name` = ?", array(trim($tag)));
				if (!$query->num_rows()){
					$this->db->insert('tags',array('name'=>$tag,'added_on'=>date('Y-m-d H:i:s'),'user'=>$this->user->data('username')));
				}
			}
		}
	}
	
	function Dropdown_list($val, $display){
		list($table, $val) = explode('.', $val);
		list($table2, $display) = explode('.',$display);
		
		$query = $this->db->query("SELECT * FROM `$table`");
		foreach ($query->result() as $row){
			$dropdown[$row->$val] = $row->$display;
		}
		
		return $dropdown;
		
	}

	function Config($field = null){
	
		if ($field){

		
			$query = $this->db->query("SELECT * FROM `config` WHERE `config` = ?", array($field));
			
			if ($query->num_rows() > 0){

				$config = $query->row();
				if ($config->allow_branch_config && $this->user->data('branch') != 1){
					$query = $this->db->query("SELECT * FROM `config_branch` WHERE `config` = ? AND `branch_id` = ?", array($field, $this->user->data('branch')));
					if ($query->num_rows() > 0){
						$branch_config = $query->row();
						if ($branch_config->value)	return $branch_config->value;
					} 
				}
				return $config->value;
			}
			
			return false;
			
		} else {
		
			$query = $this->db->query("SELECT * FROM `config`");
			$result = $query->result();
			
			foreach ($result as $config){
				$system->{$config->config} = $config->value;
			}
			
			return $system;
			
		}
		
	}
	
	function Set_config($config, $value){
	
		$query = $this->db->query("SELECT * FROM `config` WHERE `config` = ?", array($config));
		
		if ($query->num_rows()){
			$row = $query->row();
			
			if ($row->allow_branch_config && $this->user->data('branch') != 1){
				$query = $this->db->query("SELECT * FROM `config_branch` WHERE `config` = ? AND `branch_id` = ?", array($config, $this->user->data('branch')));
				
				if ($query->num_rows()){
					$query = $this->db->query("UPDATE `config_branch` SET `value` = ? WHERE `config` = ? AND `branch_id` = ?", array($value, $config, $this->user->data('branch')));
				} else {
					$sql = $this->db->insert_string('config_branch',array(
						'config'	=> $config,
						'value'		=> $value,
						'branch_id'	=> $this->user->data('branch')
					));
					$this->db->query($sql);
				}
				
			} else {
				$query = $this->db->query("UPDATE `config` SET `value` = ? WHERE `config` = ?", array($value, $config));
			}

			
		} else {
		
			if ($this->user->data('branch') == 1){

				$sql = $this->db->insert_string('config',array(
					'config'	=> $config,
					'value'		=> $value
				));
				$this->db->query($sql);
				
			} else {
			
				$sql = $this->db->insert_string('config',array(
					'config'	=> $config
				));
				$this->db->query($sql);

		
				$sql = $this->db->insert_string('config_branch',array(
					'config'	=> $config,
					'value'		=> $value,
					'branch_id'	=> $this->user->data('branch')
				));
				$this->db->query($sql);
			
			}
			
		}
	}
	
	function Get_company_details(){
		$company->name 		= $this->config('company_name');
		$company->address1 	= $this->config('company_address1');
		$company->address2 	= $this->config('company_address2');
		$company->city		= $this->config('company_city');
		$company->zipcode	= $this->config('company_zipcode');
		$company->state		= $this->config('company_state');
		$company->country	= $this->config('company_country');
		$company->tel		= $this->config('company_tel');
		
		return $company;
	}
	
	
	
	function Event_log($module, $action, $type, $record_id, $record_data){
	
		$sql = $this->db->insert_string('system_transactions',array(
			'module'		=> $module,
			'action'		=> $action,
			'type'			=> $type,
			'record_id'		=> $record_id,
			'record_data'	=> json_encode($record_data),
			'datetime'		=> date('Y-m-d H:i:s'),
			'performed_by'	=> $this->user->data('username')
		));
		
		$this->db->query($sql);
		
	}
	
	function Retrieve_logs($module, $action, $type, $record_id){
		$query = $this->db->query("SELECT * FROM `system_transactions` WHERE `module` = ? AND `action` = ? AND `type` = ? AND `record_id` = ?", array($module, $action, $type, $record_id));
		return $query->result();
	}
	
	function View_logs(){
	
		$module = $this->input->post('module');
		$action = $this->input->post('action');
		$from 	= $this->input->post('from');
		$to		= $this->input->post('to');
		
		if ($from){
			list($day, $month, $year) = explode('/', $from);
			$from = $year . '-' . $month . '-' . $day . ' 00:00:00';	
		} else {
			$from = date('Y-m-d H:i:s');
		}
		
		if ($to){
			list($day, $month, $year) = explode('/', $to);
			$to = $year . '-' . $month . '-' . $day . ' 23:59:59';
		} else {
			$to = date('Y-m-d') . ' 23:59:59';
		}
			
		if ($module) $filter[] = '`module` = ' . $this->db->escape($module);
		if ($action) $filter[] = '`action` = ' . $this->db->escape($action);
		
		$filter_string = implode(' AND ', $filter);
		if ($filter_string) $filter_string = 'AND ' . $filter_string;
		
		$query = $this->db->query("SELECT * FROM `logs` WHERE `datetime` >= ? AND `datetime` <= ? {$filter_string} ORDER BY BY `datetime` ASC");
		
		$this->d['logs'] = $query->result();
		
		$this->load->view('settings/logs', $this->d);
		
		
	}
	
	function Country_list($select = true){
		$query = $this->db->query("SELECT * FROM `countries`");
		if ($select) $countries[] = "Select Country";
		foreach ($query->result() as $country){
			$countries[$country->name] = $country->name;
		}
		
		return $countries;
	}

	
	function State_list($country){
		if ($country){
			$query = $this->db->query("SELECT * FROM `states` WHERE `country` = ? ORDER BY `state` ASC",array($country));
			foreach ($query->result() as $state){
				$states[$state->state] = $state->state;
			}
			return $states;
		}
		return false;		
	}
	
	function Uses($module_name){
		
		foreach ($this->modules as $module){
			if ($module->name == $module_name && $module->enabled) return true;
		}

		return false;
	}
	
	function Uses_assignment(){
		return $this->config('system_uses_assignment');
	}
	
	function Uses_division(){
		return $this->config('system_uses_division');
	}
	
	function Get_modules(){
		$query = $this->db->query("SELECT * FROM `modules` ORDER BY `name` ASC");
		return $query->result();
	}

	function Check_version(){
		
		// check database version
		$dbt = filemtime('./sql/tables.sql');
		
		if ($dbt > $this->config('database_version')){
			
			$db = $this->db->database;
			$query = $this->db->query("SHOW TABLES IN {$db}");
			$current_tables = $query->result();		
			
			foreach ($current_tables as $table_result){
				$current_table = $table_result->{'Tables_in_'.$db};
				$query = $this->db->query("SHOW COLUMNS IN {$db}.{$current_table}");
				$columns = $query->result();
				foreach ($columns as $column){
					$table_columns[$current_table][$column->Field] = $column;
					$existing_tables[$current_table] = 1;
				}
			}
			
			
			$this->load->helper('file');
			$sql = read_file('./sql/tables.sql');
							
			$context = str_replace("CREATE", "\nCREATE", str_replace("\n","",$sql));
			$statements = explode("\n", $context);
			
			$clean = true;
			foreach ($statements as $statement){
				if (trim($statement)){
					preg_match_all('/.*CREATE\s+TABLE\s+`(\S+)`\s*\((.*)\).*/', $statement, $matches);
					$table = trim($matches[1][0]);
					if ($table){
										
						
						if (!$existing_tables[$table]){
							$this->db->query($matches[0][0]);
					
							$clean = false;		
							
						} else {
					
							$cols_line = preg_split('/,(?![^\(\)]*\))/', $matches[2][0]);
							foreach ($cols_line as $col_line){
								if (preg_match("/PRIMARY\s+KEY.*/", $col_line)){
									// primary key
									
									
								} else {
									// column
									preg_match('/`(\w+)`\s+(.*)/', $col_line, $coldata_matches);
									$field = $coldata_matches[1];
									$attr = $coldata_matches[2];
									
									
									if (!is_object($table_columns[$table][$field])){
										$this->db->query("ALTER TABLE `{$table}` ADD `{$field}` {$attr} AFTER `{$last_field}`");
										$clean = false;
									}
									
									$last_field = $field;
									
								}
							}
						}
					}	
				}
			}
			
			$this->set_config('database_version', $dbt);
		}
		
	}
	
	function Get_divisions_dropdown($label){
		$divisions_data = $this->config('company_divisions');
		if ($label){
			$divisions[''] = $label;
		}
		foreach (explode(',',$divisions_data) as $division){
			$divisions[$division] = $division;
		}
		return $divisions;
	
	}
	
	function Get_branches_dropdown($label){
		$query = $this->db->query("SELECT * FROM `warehouses` ORDER BY `name` ASC");
		if ($label){
			$warehouses[''] = $label;
		}
		foreach ($query->result() as $warehouse){
			$warehouses[$warehouse->id] = $warehouse->name;
		}
		return $warehouses;
	
	}
	
	function Get_branches($filter){
		if ($filter) $filter = 'WHERE ' . $filter;
		$query = $this->db->query("SELECT * FROM `warehouses` $filter");
		return $query->result();
	}
	
	
	function Get_branch_by_id($id){
		$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($id));
		return $query->row();
	}
		

	function Add_branch(){
		$sql = $this->db->insert_string('warehouses', array(
			'name'			=> $this->input->post('name'),
			'type'			=> $this->input->post('type'),
			'type_reference'=> $this->input->post('type_reference'),
			'remarks'		=> $this->input->post('remarks'),
			'tags'			=> $this->input->post('tags'),
			'address1'		=> $this->input->post('address1'),
			'address2'		=> $this->input->post('address2'),
			'city'			=> $this->input->post('city'),
			'state'			=> $this->input->post('state'),
			'zipcode'		=> $this->input->post('zipcode'),
			'country'		=> $this->input->post('country'),
			'tel'			=> $this->input->post('tel'),
			'fax'			=> $this->input->post('fax'),
			'email'			=> $this->input->post('email'),
			'added_on'		=> date('Y-m-d H:i:s'),
			'added_by'		=> $this->user->data('username')
		));
		
		$query = $this->db->query($sql);
		
		$id = $query->insert_id;
		
		return $this->get_branch_by_id($id);
	}
	
	function Edit_branch($id){
		$sql = $this->db->update_string('warehouses', array(
			'name'			=> $this->input->post('name'),
			'type'			=> $this->input->post('type'),
			'type_reference'=> $this->input->post('type_reference'),
			'remarks'		=> $this->input->post('remarks'),
			'tags'			=> $this->input->post('tags'),
			'address1'		=> $this->input->post('address1'),
			'address2'		=> $this->input->post('address2'),
			'city'			=> $this->input->post('city'),
			'state'			=> $this->input->post('state'),
			'zipcode'		=> $this->input->post('zipcode'),
			'country'		=> $this->input->post('country'),
			'tel'			=> $this->input->post('tel'),
			'fax'			=> $this->input->post('fax'),
			'email'			=> $this->input->post('email'),
			'modified_on'	=> date('Y-m-d H:i:s'),
			'modified_by'	=> $this->user->data('username')
		), "`id` = '{$id}'");
		
		$this->db->query($sql);
	}
	
	function Delete_branch($id){
		if ($id == 1) return;
		$query = $this->db->query("DELETE FROM `warehouses` WHERE `id` = ?", array($id));
	}
	
	function Branch_config_list(){
		$config = array(
			'till_deposit'			=> 1,
			'receipt_header'		=> 1,
			'receipt_footer'		=> 1,
			'company_name'			=> 1,
			'company_address'		=> 1,
			'company_contact'		=> 1,
			'po_store_signee'		=> 1,
			'po_supplier_signee'	=> 1,
			'checkout_cc'			=> 1,
			'checkout_credit'		=> 1,
			'checkout_cheque'		=> 1,
			'discount_allowed'		=> 1,
			'discount_type_default'	=> 1,
			'revert_allowed'		=> 1,
			'revert_level'			=> 1,
			'report_type'			=> 1,
			'receipt_printing'		=> 1,
			'cd_welcome_1'			=> 1,
			'cd_welcome_2'			=> 1,
			'cd_thankyou'			=> 1,
			'receipt_type'			=> 1,
			'custom_price_allowed'	=> 1,
			'cost_update_method'	=> 1,
			'sales_screen_cost'		=> 1,
			'sales_screen_gp'		=> 1,
			'company_logo'			=> 1,
			'checkout_ltc'			=> 1,
			'rounding_adjust'		=> 1,
			'customer_phone'		=> 1,
			'po_tnc'				=> 1,
			'dn_tnc'				=> 1,
			'quote_tnc'				=> 1,
			'invoice_tnc'			=> 1,
			'cn_tnc'				=> 1,
			'company_address1'		=> 1,
			'company_address2'		=> 1,
			'company_city'			=> 1,
			'company_zipcode'		=> 1,
			'company_state'			=> 1,
			'company_country'		=> 1,
			'company_divisions'		=> 1,
			'so_tnc'				=> 1,
			'do_tnc'				=> 1,
			'company_tel'			=> 1,
			'print_is'				=> 1,
			'print_ta'				=> 1,
			'checkout_remarks'		=> 1,
			'checkout_delivery'		=> 1,
			'checkout_bank_deposit'	=> 1,
			'report_secondary_categories'	=> 1
		);
	}
}

