<?php

class Texteditor extends Model {


	function ftp_connect(){
		$this->ftp_stream = ftp_connect($profile->hostname, $profile->port ? $profile->port : 21);
		if ($this->ftp_stream){
			if (ftp_login($this->stream, $profile->username, $profile->password)){
				return true;
			} else {
				return false;							
			}
		} else {
			return false;
		}
	}
	
	
	function ftp_list(){
		$rawlist = ftp_rawlist($this->stream, $profile->root);
		foreach ($rawlist as $item){
			preg_match("([-d])[rwxst-]{9}.* ([0-9]*) [a-zA-Z]+ [0-9: ]*[0-9] (.+)",$item, $matches);
		}
		
	}

	function Get_profile_by_id($id){		
		$query = $this->db->query("SELECT * FROM `editor_profiles` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Get_profiles($filter){
		$query = $this->db->query("SELECT * FROM `editor_profiles` {$filter}");
		return $query->result();
	}
	
	function Add_profile($api_key, $linker_file){
		
		$this->db->insert('editor_profiles', array(
			'name'				=> $this->input->post('name'),
			'hostname'			=> $this->input->post('hostname'),
			'root_url'			=> $this->input->post('root'),
			'root_path'			=> $this->input->post('root_path'),
			'linker_file'		=> $linker_file,
			'api_key'			=> $api_key,
			'ftp_protocol'		=> $this->input->post('ftp_protocol'),
			'ftp_port'			=> $this->input->post('ftp_port'),
			'ftp_server'		=> $this->input->post('ftp_server'),
			'ftp_username'		=> $this->input->post('ftp_username'),
			'ftp_password'		=> $this->input->post('ftp_password'),
			'added_on'			=> date('Y-m-d H:i:s'),
			'added_by'			=> $this->user->data('username')
		));
		
	}
	
	function Edit_profile($id, $api_key, $linker_file){
		
		$this->db->update('editor_profiles', array(
			'name'				=> $this->input->post('name'),
			'hostname'			=> $this->input->post('hostname'),
			'root_url'			=> $this->input->post('root'),
			'root_path'			=> $this->input->post('root_path'),
			'linker_file'		=> $linker_file,
			'api_key'			=> $api_key,
			'ftp_protocol'		=> $this->input->post('ftp_protocol'),
			'ftp_port'			=> $this->input->post('ftp_port'),
			'ftp_server'		=> $this->input->post('ftp_server'),
			'ftp_username'		=> $this->input->post('ftp_username'),
			'ftp_password'		=> $this->input->post('ftp_password'),
			'modified_on'		=> date('Y-m-d H:i:s'),
			'modified_by'		=> $this->user->data('username')
		), "`id` = '{$id}'");
		
	}
	
	function Delete_profile(){
		
	}
	
	function Test(){
		$profile = $this->get_profile_by_id(8);
		$data->path = '/';
		return $this->plexsvn_request($profile, 'test', $data, true);
	}
	

	
	function PlexSVN_Request($profile, $request, $postdata, $debug){
		
		$postdata->api_key	= $profile->api_key;
		$postdata->action	= $request;
	
		$opts = array('http' =>
	  	    array(
	  	        'method'  => 'POST',
	  	        'header'  => 'Content-type: text/plain',
	  	        'content' => $content = $this->encrypt(json_encode($postdata), $profile->api_key)
	  	    )
	  	);

	  	$context  = stream_context_create($opts);					
	  	$res = file_get_contents($profile->root_url.$profile->linker_file,'',$context);
	  	
	  	$decrypted = $this->decrypt($res, $profile->api_key);
	  	$data = json_decode($decrypted);

	  	if (!$data){
		  	$data->status 				= 'failed';
		  	if ($debug){
			  	$data->res 					= $res;
			  	$data->encrypted_content 	= $content;
			  	$data->content				= $postdata;
		  	}
		  	return $data;
	  	} else {
		  	return $data;
	  	}
	}
	
	function encrypt($str, $pass){
		$pass = str_split(str_pad("", strlen($str), $pass, STR_PAD_RIGHT));
		$stra = str_split($str);
		
		foreach($stra as $k=>$v){
			$tmp = ord($v)+ord($pass[$k]);
			$stra[$k] = chr( $tmp > 255 ?($tmp-256):$tmp);
		}   
		
		return join("", $stra);
	}
	
	function decrypt($str, $pass){
		$pass = str_split(str_pad("", strlen($str), $pass, STR_PAD_RIGHT));
		$stra = str_split($str);
		
		foreach($stra as $k=>$v){
			$tmp = ord($v)-ord($pass[$k]);
			$stra[$k] = chr( $tmp < 0 ?($tmp+256):$tmp);
		}
		
		return join("", $stra);
	}

	
	
}