<?php

class User extends Model {
	var $session_id;
	var $username;
	var $data;
	var $hash;
	
	var $allowed_uri = array('login', 'mobile');
	
	function User_list($filter = null){
		
		$query = $this->db->query("SELECT * FROM `users`");
		return $query->result();
	}
	
	function User(){
		parent::Model();
		
		
		session_start();
		$this->session_id = session_id();
		$this->ip_address = $_SERVER['REMOTE_ADDR'];
		$this->timeout 	  = time() + (3600 * 24);
		$this->username	  = $_SESSION['admin_user'];
				
		if (!$this->is_alive() && !in_array($this->uri->segment(1), $this->allowed_uri)) redirect('login');
	}
	
	function Get_acname_by_username($username){
		$query = $this->db->query("SELECT * FROM `users` WHERE `username` = ?", array($username));
		$user = $query->row();
		
		$ac->plain	= $user->firstname . ' ' . $user->lastname . ' (' . $user->division . ')';
		$ac->id		= $user->username;
		$ac->html	= $user->firstname . ' ' . $user->lastname . ' (' . $user->division . ')';
		
		return $ac;
		
	}
	
	function Get_fullname($username){
		$query = $this->db->query("SELECT * FROM `users` WHERE `username` = '$username'");
		$user = $query->row();
		
		if ($user->lastname){
			return $user->firstname . ' ' . $user->lastname;
		}
		return $user->firstname;
	}

	
	function Login($username, $password){

		if ($query = $this->db->query("SELECT * FROM `users` WHERE `username` = '$username'")){
			$user_data = $query->row();
			if (md5($password) == $user_data->password && $user_data->flag != '2'){
				$_SESSION['admin_user'] = $this->username = $username;
				$_SESSION['hash'] = $this->hash = md5(mt_rand(100000,999999));
				$_SESSION['name'] = $this->data('firstname');
				$this->db->query("UPDATE `users` SET `session` = '{$this->session_id}', `ip` = '{$this->ip_address}', `flag` = '1', `timeout` = '{$this->timeout}', `hash` = '{$this->hash}' WHERE `username` = '$username'");
				$mpk_long = md5(base64_encode($password));
				$_SESSION['mpk'] = $mpk[0] . $mpk[2] . $mpk[5] . $mpk[1] . $mpk[0] . $mpk[3] . $mpk[4];
				
				$session_module_data = json_decode($user_data->data);
				foreach ($session_module_data as $module => $data){
					foreach ($data as $key => $value){
						$this->session->set_userdata(array(strtolower($module.'_'.$key) => $value));
					}
				}
				
				return true;
			} else {
				return false;
			}			
		} else {
			return false;
		}
	}
	
	function is_alive(){
		$query = $this->db->query("SELECT * FROM `users` WHERE `username` = '{$this->username}'");
		$result = $query->result();
		$user_data = $result[0];
		if ($user_data->timeout > time()){
			if (time() > ($user_data->timeout - 1800)) $this->update_hash();
			$this->db->query("UPDATE `users` SET `timeout` = '{$this->timeout}' WHERE `username` = '{$this->username}'", FALSE, TRUE, FALSE);
			return true;
		} else {
			$this->logout();
			return false;
		}
	}
	
	function update_hash(){
		$_SESSION['hash'] = $this->hash = md5(mt_rand(100000,999999));
		$this->db->query("UPDATE `users` SET `hash` = '{$this->hash}' WHERE `username` = '{$this->username}'", FALSE, TRUE, FALSE);
	}
	
	function data($var = null){
		$query = $this->db->query("SELECT * FROM `users` WHERE `username` = '{$this->username}'");
		$this->data = $query->row();
		if ($var) return $this->data->$var;
		else return $this->data;
	}
	
	function update_user_data($user_data){
		$sql = $this->db->update_string('users', $user_data, "`username` = '{$this->username}'");
		$this->db->query($sql);
	}
	
	function logout(){
		$_SESSION['hash'] = '';
		$_SESSION['admin_user'] = '';
		$_SESSION['name'] = '';
	}
	
	function group_list(){
		$query = $this->db->query("SELECT * FROM `groups` ORDER BY `name` ASC");
		$groups = $query->result();
		foreach($groups as $group){
			$group_list[$group->name] = $group->name;
		}

		return $group_list;
	}
	
	function roles(){
		$query = $this->db->query("SELECT * FROM `roles` WHERE `parent_role` = ''");
		$roles = $query->result();
		
		foreach ($roles as $role){
			$children = $this->roles_children($role->rolename,0);
			if (is_array($children)){
				$role_array['children'] = $children;
			    $role_array['state'] = 'open';
			}
			$role_array['data'] = $role->rolename;
			$role_array['attributes'] = array('id' => 'role_'. $role->id);
			$roles_array[] = $role_array;
		}
		return $roles_array;
	}
	
	function get_children($parent){
		$query = $this->db->query("SELECT * FROM `roles` WHERE `parent_role` = '$parent'");
		$roles = $query->result();
		return $roles;
	}
	
	function roles_children($parent, $level) { 
		$children = $this->get_children($parent);
  		foreach($children as $child) { 
		    // indent and display the title of this child 
		    $more_child = $this->roles_children($child->rolename, $level+1);
		    if (is_array($more_child)){
		    	$child_array['children'] = $more_child;
			    $child_array['state'] = 'open';
		    }
		    $child_array['data'] = $child->rolename;
		    $child_array['attribute'] = array('id' => 'role_'. $child->id);
		    $children_array[] = $child_array;
		
		    // call this function again to display this 
		    // child's children 

		}
		return $children_array;
	} 
	
	function Auth_pass($pass = null){
		if (!$pass) $pass = $this->input->post('pass');
		$query = $this->db->query("SELECT * FROM `users` WHERE `role` = 'Superadmin'");
		$superadmin = $query->row();
		
		if ($superadmin->password == md5($pass)) return true;
		
		return false;
	}
	
	function Get_users($sql_filter){
		$query = $this->db->query("SELECT * FROM `users` {$sql_filter}");
		return $query->result();
	}
	
	function has_permission($action_type, $module, $user){
	
		if ($user){
			$query = $this->db->query("SELECT * FROM `users` WHERE `username` = ?", array($user));
			$user_data = $query->row();
			
			if ($this->check_superadmin($user_data->id)) return true;
		} else {
			if ($this->is_super_admin()) return true;			
			$user_data = $this->data();
		}
		
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = '{$user_data->type}'");
		$permission = $query->row();


		if ($permission->super) return true;
		
		if ($permission->module == '*') return true;
		
		$modules = explode(',', $permission->module);
		
		if (!in_array($module,$modules)) return false;

		$actions = json_decode($permission->action);
		$p_action = $actions->{$module};
		
		
		if ($p_action->{$action_type}) return true;
		return false;		
	}
	
	function is_super_admin(){
		$user_data = $this->data();
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = '{$user_data->type}'");
		$permission = $query->row();
		
		if ($permission->super) return true;
		else return false;
	}
	
	function has_access($controller){
		if ($this->is_super_admin()) return true;
		
		$query = $this->db->query("SELECT * FROM `modules` WHERE `name` = '$controller'");
		$module = $query->row();
		
		if ($module->common) return true;
		
		$user_data = $this->data();
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = '{$user_data->type}'");
		$permission = $query->row();
		
		if ($permission->super) return true;
		
		if ($permission->module == '*') return true;
		$modules = explode(',', $permission->module);
		
		if (in_array($module->name,$modules)) return true;
		return false;
	}
	
	function check_superadmin($id){
		$query = $this->db->query("SELECT * FROM `users` WHERE `id` = ?", array($id));
		$user = $query->row();
		
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));
		$permission = $query->row();
		
		if ($permission->super) return true;
		else return false;
	}
	
	function can_assign_task(){
		if ($this->is_super_admin()) return true;

		if ($this->has_permission('to_assign_task','Dashboard')) return true;
		else return false;			
	}
	
	function can_assign_division_schedule(){
		if ($this->is_super_admin()) return true;
		
		if ($this->has_permission('to_assign_division_schedule','Dashboard')) return true;
		else return false;	
	}
	
	function has_all_division_access(){
		if ($this->is_super_admin()) return true;
	
		$user_data = $this->data();
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = '{$user_data->type}'");
		$permission = $query->row();
		
		if ($permission->divisions == '*') return true;
		else return false;
	}	
	
	function Branch_contact($branch){
		if ($branch){
		
			$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($branch));
			$branch = $query->row();

			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($branch->type_reference));
			return $query->row();
			
		} else {
			$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($this->user->data('branch')));
			$branch = $query->row();
			
			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($branch->type_reference));
			return $query->row();
		}
	}
	

	
}

