<?php

foreach ($pv->items as $item){
	if ($item->invoice_id) $rc_invoice[$item->invoice_id] = $item;
	if ($item->po_id) $rc_po[$item->po_id] = $item;
	if ($item->dn_id) $rc_dn[$item->dn_id] = $item;
	if ($item->cn_id) $rc_cn[$item->cn_id] = $item;
}
	
?>
<script type="text/javascript">

$(document).ready(function(){

	$('input.paid').click(function(){
		calculateTotal();	
	});
	
	$('td.amount input').change(function(){
		var val = parseFloat($(this).val());
		var max = parseFloat($(this).attr('max'));
		
		
		if (!val) val = '0.00';
		else {
			if (val > max){
				val = max;
			}
			val = val.toFixed(2);
		}
		
		$(this).val(val);
		calculateTotal();
	})
	
	calculateTotal();
	
});



</script>

	<table class="grid">
		<thead>
			<tr>
				<th style="width: 100px">Date</th>
				<th>Transaction</th>
				<th style="width: 150px">Payable (<?php echo $this->system->config('currency'); ?>)</th>
				<th style="width: 150px">Paid (<?php echo $this->system->config('currency'); ?>)</th>
				<th style="width: 150px">Amount (<?php echo $this->system->config('currency'); ?>)</th>
				<th style="width: 30px"></th>
			</tr>
		</thead>
		<tfoot>
			<tr class="foot">
				<td class="dark" colspan="4" style="text-align:right"><strong>Total</strong></td>
				<td class="darker grandTotal" style="font-weight: bold; text-align: right">0.00</td>
				<td class="dark"></td>
			</tr>
		</tfoot>
		<tbody>
		<?php $x = 0; foreach ($pos as $po):  $x++;  ?>
			<?php $paid = $this->account->get_paid_amount('po',$po->id) - $rc_po[$po->id]->amount; ?>
			<?php $payable = $po->total_received + $rc_po[$po->id]->amount; ?>
			
			
			<?php if ($payable - $paid > 0): ?>
			<tr<?php if ($x%2) echo ' class="alt"'; ?>>
				<td><?php echo date('d/m/Y',strtotime($po->date)); ?></td>
				<td><?php echo 'Purchase Order PO-' . $po->id; ?></td>
				<td style="text-align: right"><?php echo number_format($payable = $po->total_received == 0 ? $po->total : $po->total_received,2); ?></td>
				<td style="text-align: right"><?php echo number_format($paid,2); ?></td>
				<td class="amount" style="text-align: right">
					<?php 
						if ($rc_po[$po->id]->amount){
							$val = str_replace(',','',number_format($rc_po[$po->id]->amount,2));
							$checked = 'checked="checked"';
						} else {
							$val = str_replace(',','',number_format($po->total_received == 0 ? $po->total - $paid : $po->total_received - $paid,2));
							$checked = '';
						}
					?>
					<input style="width: 100%" max="<?php echo $payable-$paid; ?>" name="po_amount[]" type="text" class="v-text v-number-decimal" value="<?php echo $val; ?>" />
				</td>
				<td><input  <?php echo $checked; ?> type="checkbox" amount="<?php echo $po->total_received == 0 ? $po->total : $po->total_received; ?>" class="paid" name="po_id[]" value="<?php echo $po->id; ?>" /></td>
			</tr>
			<?php endif; ?>
			
		<?php endforeach; ?>
		
		<?php foreach ($cns as $cn):  $x++;  ?>
			<?php $payable = $cn->total_received + $rc_cn[$cn->id]->amount; ?>
			<?php $paid = $this->account->get_paid_amount('cn',$cn->id) - $rc_cn[$cn->id]->amount; ; ?>
			<?php if ($payable - $paid > 0): ?>
			<tr<?php if ($x%2) echo ' class="alt"'; ?>>
				<td><?php echo date('d/m/Y',strtotime($cn->date)); ?></td>
				<td><?php echo 'Credit Note CN-' . $cn->id; ?></td>
				<td style="text-align: right"><?php echo number_format($payable = $cn->total_received == 0 ? $cn->total : $cn->total_received,2); ?></td>
				<td style="text-align: right"><?php echo number_format($paid,2); ?></td>
				<td class="amount" style="text-align: right">
					<?php 
						if ($rc_cn[$cn->id]->amount){
							$val = str_replace(',','',number_format($rc_cn[$cn->id]->amount,2));
							$checked = 'checked="checked"';
						} else {
							$val = str_replace(',','',number_format($cn->total_received == 0 ? $cn->total - $paid : $cn->total_received - $paid,2));
							$checked = '';
						}
					?>
				</td>
				<td><input  <?php echo $checked; ?> type="checkbox" amount="<?php echo $val; ?>" class="paid" name="cn_id[]" value="<?php echo $cn->id; ?>" /></td>
			</tr>
			<?php endif; ?>
			<?php endforeach; ?>

		</tbody>
		<tbody>
			
			<?php if (count($dns) || count($invoices)): ?>
			<tr class="foot">
				<td colspan="6"><strong>Invoice and Debit Note Knock-off</strong></td>
			</tr>		
			<?php endif; ?>
			
			<?php $x = 0; foreach ($dns as $dn): $x++; ?>
			<?php $paid = $this->account->get_paid_amount('dn',$dn->id) - $rc_dn[$dn->id]->amount; ?>
			<?php $payable = $dn->total_received + $rc_dn[$dn->id]->amount; ?>
			
			<?php if ($payable - $paid > 0): ?>			
			<tr<?php if ($x%2) echo ' class="alt"'; ?>>
				<td><?php echo date('d/m/Y',strtotime($po->date)); ?></td>
				<td><?php echo 'Debit Note DN-' . $dn->id; ?></td>
				<td style="text-align: right"><?php echo number_format($payable = $dn->total_received == 0 ? $dn->total : $dn->total_received,2); ?></td>
				<td style="text-align: right"><?php echo number_format($paid,2); ?></td>
				<td class="dark amount contra" style="text-align: right">
					<?php
						if ($rc_dn[$dn->id]->amount){
							$val = str_replace(',','',number_format($rc_dn[$dn->id]->amount,2));
							$checked = 'checked="checked"';
						} else {
							$val = str_replace(',','',number_format($dn->total_received == 0 ? $dn->total - $paid : $dn->total_received - $paid,2));
							$checked = '';
						}
					?>
					<input style="width: 100%" max="<?php echo $payable-$paid; ?>" name="dn_amount[]" type="text" class="v-text v-number-decimal" value="<?php echo $val; ?>" />

				</td>
				<td><input  <?php echo $checked; ?> type="checkbox" amount="<?php echo $dn->total_received == 0 ? (0 - $dn->total) : (0 - $dn->total_received); ?>" class="paid" name="dn_id[]" value="<?php echo $dn->id; ?>" /></td>
			</tr>
			<?php endif; ?>
			<?php endforeach; ?>
		
			<?php foreach ($invoices as $invoice): $x++; ?>
			<?php $paid = $this->account->get_paid_amount('invoice',$invoice->id) - $rc_invoice[$invoice->id]->amount; ?>
			<?php $payable = $invoice->total_delivered + $rc_invoice[$invoice->id]->amount; ?>
			
			<?php if ($payable - $paid > 0): ?>
			<tr<?php if ($x%2) echo ' class="alt"'; ?>>
				<td><?php echo date('d/m/Y',strtotime($invoice->date)); ?></td>
				<td><?php echo 'Invoice INV-' . $invoice->id; ?></td>
				<td style="text-align: right"><?php echo number_format($payable = $invoice->total_received == 0 ? $invoice->total : $invoice->total_received,2); ?></td>
				<td style="text-align: right"><?php echo number_format($paid,2); ?></td>
				<td class="dark amount contra" style="text-align: right">
					<?php 
						if ($rc_invoice[$invoice->id]->amount){
							$val = str_replace(',','',number_format($rc_invoice[$invoice->id]->amount,2));							
							$checked = 'checked="checked"';
						} else {
							$val = str_replace(',','',number_format($invoice->total_received == 0 ? $invoice->total - $paid : $invoice->total_received - $paid,2));
							$checked = '';
						}

					?>
					<input style="width: 100%" max="<?php echo $payable-$paid; ?>" name="invoice_amount[]" type="text" class="v-text v-number-decimal" value="<?php echo $val; ?>" />
				</td>
				<td><input  <?php echo $checked; ?> type="checkbox" amount="<?php echo $invoice->total_received == 0 ? (0 - $invoice->total) : (0 - $invoice->total_received); ?>" class="paid" name="invoice_id[]" value="<?php echo $invoice->id; ?>" /></td>
			</tr>
			<?php endif; ?>
			<?php endforeach; ?>
			
		</tbody>
	</table>