<?php
	

$tax_codes = array (
	''		=> 'Select',
	'TX'	=> 'TX - Purchases with GST incurred at 6% and directly attributable to taxable supplies',
	'IM'	=> 'IM - Import of goods with GST incurred',
	'IS'	=> 'IS - Imports under special scheme with no GST incurred (e.g. Approved Trader Scheme, ATMS Scheme)',
	'BL'	=> 'BL - Purchases with GST incurred but not claimable (Disallowance of Input Tax) (e.g. medical expenses for staff)',
	'NR'	=> 'NR - Purchase from non GST-registered supplier with no GST incurred',
	'ZP'	=> 'ZP - Purchase from GST-registered supplier with no GST incurred. (e.g. supplier provides transportation of goods that qualify as international services)',
	'EP'	=> 'EP - Purchases exempted from GST. E.g. purchase of residential property or financial services',
	'OP'	=> 'OP - Purchase transactions which is out of the scope of GST legislation (e.g. purchase of goods overseas)',
	'TX-E43'=> 'TX-E43 - Purchase with GST incurred directly attributable to incidental exempt supplies',
	'TX-N43'=> 'TX-N43 - Purchase with GST incurred directly attributable to non-incidental exempt supplies',
	'TX-RE'	=> 'TX-RE - Purchase with GST incurred that is not directly attributable to taxable or exempt supplies',
	'GP'	=> 'GP - Purchase transactions which disregarded under GST legislation (e.g. purchase within GST group registration)',
	'SR'	=> 'SR - Standard-rated supplies with GST Charged',
	'ZRL'	=> 'ZRL - Local supply of goods or services which are subject to zero rated supplies',
	'ZRE'	=> 'ZRE - Exportation of goods or services which are subject to zero rated supplies',
	'ES43'	=> 'ES43 - Incidental Exempt supplies',
	'GS'	=> 'GS - Disregarded supplies'
);
	
?>
<script type="text/javascript">
var pv_id = '<?php echo $pv->id; ?>';
var breakdown_item = $('tr.breakdown-entry').clone();
var expense_item = $('tr.expense-entry').clone();
var asset_item = $('table.asset').clone();

var totalB = 0.00;
var totalO = 0.00;

function readyAdd(status, id){

	if (status == 'pv'){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		var href = $('a.view-pv').attr('href');
		$('a.view-pv').attr('href',href+''+id);
		showDialog('ok','Payment','Payment has been recorded.',function(){
			$('a.view-pv').click();
		});
		form_warning = false;
	} else if (status == 'sv'){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		var href = $('a.view-sv').attr('href');
		$('a.view-sv').attr('href',href+''+id);
		showDialog('ok','Payment','Payment has been recorded.',function(){
			$('a.view-sv').click();
		});
		form_warning = false;
	
	
	} else if (status == '0') {
		showDialog('ok','Error','Payment cannot be recorded now. Please login again.');
		$('div.main_full').show();
		$('div.status').hide();
	} 
}

$(document).ready(function(){
	$('a.create').click(function(event){
		calculateTotal();
		if (totalO == 0){
			showDialog('ok','Error','Amount cannot be 0.00');
			return;
		}
		
		
		if (totalB > totalO){
			showDialog('yesno','Imbalance Entry','Your payment is more than total payable. Generate debit note?', function(){
				$('form.insert').submit();
			}, function(){
				// do nothing			
			})

			return;
			
		} else if (totalB < totalO){
			showDialog('ok','Insufficient Amount','Your payment is less than total payable.');
			return;
		}
		
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('select.payment-type').change(function(){
		var type = $(this).val();
		
		if (type == 'Purchase of Stock'){
			$('.type-purchase-orders').show();
			$('.type-purchase-asset').hide();
			$('.type-expense').hide();
			$('.type-wages').hide();
			$('.type-payee').hide();
			
			$('div.type-purchase-asset :input').attr('disabled',true);
			$('div.type-expense :input').attr('disabled',true);
			$('div.type-wages :input').attr('disabled',true);
			$('div.type-purchase-orders :input').removeAttr('disabled');
			
			$('div.type-purchase-asset input.mandatory').removeClass('mandatory');
			$('div.type-expense input.mandatory').removeClass('mandatory');
			$('div.type-purchase-orders input[mandatory=1]').addClass('mandatory');
			$('tr.tax').hide();

		} else if (type == 'Purchase of Asset'){
			$('.type-purchase-orders').hide();
			$('.type-purchase-asset').show();
			$('.type-expense').hide();		
			$('.type-wages').hide();
			$('.type-payee').show();
			
			$('div.type-purchase-orders :input').attr('disabled',true);
			$('div.type-expense :input').attr('disabled',true);
			$('div.type-wages :input').attr('disabled',true);
			$('div.type-purchase-asset :input').removeAttr('disabled');
			
			$('div.type-purchase-asset input[mandatory=1]').addClass('mandatory');
			$('div.type-expense input.mandatory').removeClass('mandatory');
			$('div.type-purchase-orders input.mandatory').removeClass('mandatory');
			
		} else if (type == 'Wages'){
			
			$('.type-purchase-orders').hide();
			$('.type-purchase-asset').hide();
			$('.type-expense').hide();		
			$('.type-wages').show();
			$('.type-payee').hide();
			
			$('div.type-purchase-orders :input').attr('disabled',true);
			$('div.type-expense :input').attr('disabled',true);
			$('div.type-purchase-asset :input').attr('disabled',true);
			$('div.type-wages :input').removeAttr('disabled');


			$('div.type-purchase-asset input[mandatory=1]').removeClass('mandatory');
			$('div.type-expense input.mandatory').removeClass('mandatory');
			$('div.type-purchase-orders input.mandatory').removeClass('mandatory');
			
			$.ajax({
				url: base_url + 'accounts/ajax/pending_payslips',
				type: 'post',
				success: function (res){
					$('div.grid-container-payslip').html(res);
				}
			})

			
			
		} else {
			$('.type-expense').show();
			$('.type-purchase-orders').hide();
			$('.type-purchase-asset').hide();
			$('.type-wages').hide();
			$('.type-payee').show();
			
			$('div.type-wages :input').attr('disabled',true);
			$('div.type-purchase-orders :input').attr('disabled',true);
			$('div.type-purchase-asset :input').attr('disabled',true);
			$('div.type-expense :input').removeAttr('disabled');

			
			$('div.type-purchase-asset input.mandatory').removeClass('mandatory');
			$('div.type-expense input[mandatory=1]').addClass('mandatory');
			$('div.type-purchase-orders input.mandatory').removeClass('mandatory');
			$('tr.tax').show();

		}
		
		calculateTotal();
	});
	
	$('tr.expense-entry a.expense-remove').remove();
	$('table.asset a.asset-remove').remove();
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Form Error','Please make sure you have filled the form correctly.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});

	$('a.add-breakdown').click(function(){
		$('table.breakdown tbody').append($(breakdown_item).clone());
		populateEvents();
	});
	
	$('a.breakdown-remove').live('click',function(){
		$(this).parents('tr').remove();
		calculateTotal();
	});
	
	$('a.add-asset').click(function(){
		$('div.type-purchase-asset').append($(asset_item).clone());
		populateEvents();
	});
	
	$('a.add-expense').click(function(){
		$('table.expense tbody').append($(expense_item).clone());
		populateEvents();
	});
	
	$('a.expense-remove').live('click',function(){
		$(this).parents('tr').remove();
		calculateTotal();
	});
	
	$('a.asset-remove').live('click',function(){
		$(this).parents('table').remove();
		calculateTotal();
	});
	
	$('select.contact').change(function(){
		var id = $(this).val();
		$('div.type-purchase-orders h3').show();
		$('div.grid-container').html('<img src="'+base_url+'images/loading.gif" /> Loading purchase orders.');
		$.ajax({
			url: base_url + 'accounts/ajax/po_by_supplier',
			data: 'id=' + id + '&pv_id=' + pv_id,
			type: 'post',
			success: function (res){
				$('div.grid-container').html(res);
			}
		})
	});
	
	$('input[name=tax]').live('change',function(){
		calculateTotal();
	})
	
	$('input.asset_cost').live('change',function(){
		calculateTotal();
	});
	
	$('input.expense_amount').live('change',function(){
		calculateTotal();
	});
	
	$('input.breakdown').live('change',function(){
		calculateTotal();
	});
	
	
	
	$('select.payment-type').change();
	$('select.contact').change();

});

function calculateTotal(){
	var grandTotal = 0.00;
	var type = $('select.payment-type').val();
	

	
	if (type == 'Purchase of Stock'){
		$('input.paid:checked').each(function(){
			var amount = $(this).parents('tr').find('td.amount input').val();
			amount.replace(',','');
			if (!amount) amount = 0.00;
			if ($(this).parents('tr').find('td.amount').hasClass('contra')){
				grandTotal -= parseFloat(amount);				
			} else {
				grandTotal += parseFloat(amount);
			}
		});
		$('td.grandTotal').text(number_format(grandTotal,2));
	} else if (type == 'Purchase of Asset'){
		$('input.asset_cost').each(function(){
			var amount = $(this).val();
			if (!amount) amount = 0.00;
			grandTotal += parseFloat(amount);
		});
		
		var tax  = parseFloat($('.type-purchase-asset .tax input[name=tax]').val());
		if (!tax) tax = 0.00;
		
		grandTotal += tax;

	} else if (type == 'Wages'){
		var amount = $('input.sv:checked').attr('amount');
		if (!amount) amount = 0.00;
		grandTotal += parseFloat(amount);
		$('td.grandTotalSalary').text(number_format(grandTotal,2));
		
	} else if (type == 'Expense'){
		$('input.expense_amount').each(function(){
			var amount = $(this).val();
			if (!amount) amount = 0.00;
			grandTotal += parseFloat(amount);
			
		});
		
		var tax  = parseFloat($('.type-expense .tax input[name=tax]').val());
		if (!tax) tax = 0.00;
		
		grandTotal += tax;

		

	}
	
	var breakdownTotal = 0.00;
	
	$('input.breakdown').each(function(){
		var amount = $(this).val();
		if (!amount) amount = 0.00;
		breakdownTotal += parseFloat(amount);	
	})
	
	totalB = breakdownTotal;
	totalO = grandTotal;
	
	$('td.outstanding-paid').text(number_format(breakdownTotal,2));
	$('td.outstanding').text(number_format(grandTotal,2));
}

</script>
	<div class="status">
	
	</div>
	<div class="toolbar">
		<h3 class="grid-title">Payment</h3>
		<div class="global-tabs" style="padding: 5px;">
			<a href="#" class="v-btn create">Save Payment</a>
		</div>
	</div>
	<div class="main_full">
		<div class="main-container">
			<a style="display:none" class="target_main view-pv" href="accounts/pv_view/">View PV</a>
			<a style="display:none" class="target_main view-sv" href="accounts/sv_view/">View SV</a>
			<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>
			
			<form method="post" class="insert" action="<?php echo base_url(); ?>accounts/payment_purchase/do" target="postframe">
				<input type="hidden" name="pv_id" value="<?php echo $pv->id; ?>" />
			
				<h3>Payment Information</h3>
				<table class="general-form">
					<tbody>
						<tr class="four">
							<td class="label">PV Number</td>
							<td class="input">
								<input value="<?php echo $pv->txn_no ? $pv->txn_no : $pv->id; ?>" type="text" class="v-text" name="txn_no" value="" placeholder="Auto" />
								
							</td>
							<td class="label">Date <span class="red">*</span></td>
							<td class="input"><input value="<?php echo $pv->datetime ? date('d/m/Y', strtotime($pv->datetime)) : ''; ?>" type="text" name="date" class="v-text date mandatory" /></td>
						</tr>
						<tr class="four">
							<td class="label">Type</td>
							<td class="input"><?php echo form_dropdown('type',array(
								'Expense'				=> 'Expense',
								'Purchase of Stock'		=> 'Purchase of Stock',
								'Purchase of Asset'		=> 'Purchase of Asset',
								'Wages'					=> 'Employee\'s Wages'
								),$pv->type,'class="v-dropdown payment-type" style="width:100%"');?></td>
							<td class="label">
								<span class="type-purchase-orders">Contact <span class="red">*</span></span>
								<span class="type-expense" style="display:none">Account <span class="red">*</span></span>
								<span class="type-purchase-asset" style="display:none">Account <span class="red">*</span></span>
							</td>
							<td class="input">
								<?php echo form_dropdown('contact',$contacts_dropdown,$pv->contact_id,'class="v-dropdown contact type-purchase-orders" style="width:100%"'); ?>
								<?php echo form_dropdown('account',$expense_accounts_list,$pv->account_id,'class="v-dropdown account type-expense" style="width:100%; display:none"'); ?>
								<?php echo form_dropdown('asset_account',$asset_accounts_list,$pv->account_id,'class="v-dropdown account type-purchase-asset" style="width:100%; display:none"'); ?>
							</td>
						</tr>
						<tr class="four type-payee ">
							<td class="label">Payee Name</td>
							<td class="input" colspan="3"><input type="text" class="v-text" name="payee" /></td>
						</tr>
						
					</tbody>
				
				</table>
				
				<div class="type-purchase-orders" style="display:none">
					<h3 style="display:none">Unpaid Purchase Orders and Credit Notes</h3>
					<div class="grid-container">
					
					</div>
				</div>
				
				<div class="type-wages" style="display:none">
					<h3>Pending Pay Slip</h3>
					<div class="grid-container-payslip">
					
					</div>
				</div>
				
				<div class="type-purchase-asset" style="display:none">
					<h3>Asset</h3>
					<a class="v-btn add-asset">Add Asset</a>
					<table class="general-form asset" style="margin-top: 10px">
						<tbody>
							<tr class="four">
								<td class="label"><a class="v-btn asset-remove">Remove</a> Asset Name <span class="red">*</span></td>
								<td class="input"><input type="text" name="name[]" class="v-text mandatory" mandatory="1" /></td>
								<td class="label">Product Name</td>
								<td class="input"><input type="text" name="product_names[]" class="v-text" /></td>
							</tr>
							<tr class="four">
								<td class="label">Category <span class="red">*</span></td>
								<td class="input"><?php echo form_dropdown('category[]',$categories_dropdown,'', 'class="v-dropdown" style="width: 100%"'); ?></td>
								<td class="label">Other Category</td>
								<td class="input"><input type="text" name="category_other[]" class="v-text" /></td>
							</tr>
							<tr class="four">
								<td class="label">Subcategory <span class="red">*</span></td>
								<td class="input"><?php echo form_dropdown('subcategory[]',$subcategories_dropdown,'', 'class="v-dropdown" style="width: 100%"'); ?></td>
								<td class="label">Other Subcategory</td>
								<td class="input"><input type="text" name="subcategory_other[]" class="v-text" /></td>
							</tr>
							<tr class="four">
								<td class="label">Acquisition Date <span class="red">*</span></td>
								<td class="input"><input type="text" class="v-text date mandatory" mandatory="1" name="acquisition_date[]" /></td>
								<td class="label">Amortization Date <span class="red">*</span></td>
								<td class="input"><input type="text" class="v-text date mandatory" mandatory="1" name="amortization_date[]" /></td>

							</tr>
							<tr class="four">
								<td class="label">Cost <span class="red">*</span></td>
								<td class="input"><input type="text" name="costs[]" class="v-number-decimal mandatory asset_cost" mandatory="1" /></td>
								<td class="label">Residual <span class="red">*</span></td>
								<td class="input"><input type="text" name="residual_costs[]" class="v-number-decimal mandatory" /></td>

							</tr>
							<tr class="four">
								<td class="label">Evaluation Interval <span class="red">*</span></td>
								<td class="input"><?php echo form_dropdown('evaluation_interval[]', array('1'=>'Every Month','3'=>'Every 3 Months','6'=>'Every 6 Months','12'=>'Every 12 Months'),'','class="v-select pmethod" style="width: 100%"'); ?></td>
								<td class="label">Barcode</td>
								<td class="input"><input type="text" name="barcodes[]" class="v-text" /></td>
							</tr>
							<tr class="four">
								<td class="label">Remarks</td>
								<td class="input" colspan="3"><input type="text" name="remarks[]" class="v-text" /></td>
							</tr>
						</tbody>
					</table>
					
					<h3>Tax</h3>
					<table class="general-form tax">
						<tbody>
							<tr class="four">
								<td class="label">Tax Code</td>
								<td class="input"><?php echo form_dropdown('tax_code', $tax_codes,$pv->tax_code,'class="v-dropdown" style="width:100%"'); ?></td>
								<td class="label">Tax Amount</td>
								<td class="input"><input style="text-align: right" value="<?php echo $pv->tax; ?>" type="text" name="tax" class="v-text" /></td>
							</tr>
							<tr class="foot">
								<td colspan="3" style="text-align: right; padding: 5px"><strong>Total Outstanding</strong></td>
								<td class="dark outstanding" style="text-align: right; padding: 5px; font-weight: bold">0.00</td>
							</tr>	

						</tbody>
					</table>
				</div>
				
				<div class="type-expense" style="display:none">
					<h3>Expense Items</h3>
					<a class="v-btn add-expense">Add Expense</a>
					<table class="general-form expense" style="margin-top: 10px">
						

						<tbody>
							<?php if ($pv->type == 'Expense'): ?>
								<?php foreach ($pv->items as $item): ?>
									<tr class="four expense-entry">
										<td class="label"><a class="v-btn expense-remove">Remove</a> Reference No</td>
										<td class="input"><input value="<?php echo $item->reference; ?>" type="text" name="reference_no[]" mandatory="1" class="v-text mandatory" /></td>
										<td class="label">Amount</td>
										<td class="input"><input value="<?php echo $item->amount; ?>" type="text" name="expense_amount[]" style="text-align: right" mandatory="1" class="v-text v-number-decimal pv-amount expense_amount mandatory" /></td>
									</tr>
								<?php endforeach; ?>
							<?php else: ?>
							<tr class="four expense-entry">
								<td class="label"><a class="v-btn expense-remove">Remove</a> Reference No</td>
								<td class="input"><input type="text" name="reference_no[]" mandatory="1" class="v-text mandatory" /></td>
								<td class="label">Amount</td>
								<td class="input"><input type="text" name="expense_amount[]" style="text-align: right" mandatory="1" class="v-text v-number-decimal pv-amount expense_amount mandatory" /></td>
							</tr>
							<?php endif; ?>
						</tbody>
						<tfoot>
							<tr class="four">
								<td class="label">Tax Code</td>
								<td class="input"><?php echo form_dropdown('tax_code', $tax_codes,$pv->tax_code,'class="v-dropdown" style="width:100%"'); ?></td>
								<td class="label">Tax Amount</td>
								<td class="input"><input style="text-align: right" value="<?php echo $pv->tax; ?>" type="text" name="tax" class="v-text" /></td>
							</tr>
							<tr class="foot">
								<td colspan="3" style="text-align: right; padding: 5px"><strong>Total Outstanding</strong></td>
								<td class="dark outstanding" style="text-align: right; padding: 5px; font-weight: bold">0.00</td>
							</tr>	
						</tfoot>

					</table>
					
				</div>
			
				<h3 style="margin-top: 10px">Payment Breakdown</h3>
				<a class="v-btn add-breakdown">Add Breakdown</a>
				<table class="general-form breakdown" style="margin-top: 10px">
					<thead>
						<tr>
							<th style="width: 30px"></th>
							<th>Account</th>
							<th>Reference No</th>
							<th>Method</th>
							<th>Amount (<?php echo $this->system->config('currency'); ?>)</th>
						</tr>
					</thead>
					<tfoot>
						<tr class="foot">
							<td colspan="4" style="text-align: right; padding: 5px"><strong>Total</strong></td>
							<td class="dark outstanding-paid" style="text-align: right; padding: 5px; font-weight: bold">0.00</td>
						</tr>
					</tfoot>
					<tbody>
						<?php if ($pv->id): ?>
							<?php foreach ($pv->breakdown as $breakdown): ?>
								<tr class="four breakdown-entry">
									<td style="width: 30px"><a class="remove grid-action grid-action-delete-tx breakdown-remove" ><span>Remove Item</span></a></td>
									<td><?php echo form_dropdown('account_from[]', $cash_postable_list, $breakdown->account_id,'class="v-dropdown" style="width:100%; float: right"'); ?></td>
									<td class="input" style="width: auto"><input type="text" value="<?php echo $breakdown->payment_reference; ?>" name="breakdown_reference[]" class="v-text" /></td>
									<td><?php echo form_dropdown('payment_method[]', array('Cash'=>'Cash','Cheque'=>'Cheque','Credit Card'=>'Credit Card','Bank Transfer'=>'Bank Transfer','Bank Draft'=>'Bank Draft'),$pv->payment_method, 'class="v-dropdown" style="width: 100%"'); ?></td>
									<td class="input" style="width: auto"><input type="text" value="<?php echo $breakdown->amount; ?>" name="breakdown_amount[]" style="text-align: right" class="v-text v-number-decimal breakdown" /></td>
								</tr>
							<?php endforeach; ?>
						<?php else: ?>
							<tr class="four breakdown-entry">
								<td style="width: 30px"><a class="remove grid-action grid-action-delete-tx breakdown-remove" ><span>Remove Item</span></a></td>
								<td><?php echo form_dropdown('account_from[]', $cash_postable_list, '','class="v-dropdown" style="width:100%; float: right"'); ?></td>
								<td class="input" style="width: auto"><input type="text" name="breakdown_reference[]" class="v-text" /></td>
								<td><?php echo form_dropdown('payment_method[]', array('Cash'=>'Cash','Cheque'=>'Cheque','Credit Card'=>'Credit Card','Bank Transfer'=>'Bank Transfer','Bank Draft'=>'Bank Draft'),'', 'class="v-dropdown" style="width: 100%"'); ?></td>
								<td class="input" style="width: auto"><input type="text" name="breakdown_amount[]" style="text-align: right" class="v-text v-number-decimal breakdown" /></td>
							</tr>
						<?php endif; ?>
					</tbody>
				</table>
				
			</form>

		
			
		</div>
	
	</div>