<?php
	

$tax_codes = array (
	''		=> 'Select',
	'TX'	=> 'TX - Purchases with GST incurred at 6% and directly attributable to taxable supplies',
	'IM'	=> 'IM - Import of goods with GST incurred',
	'IS'	=> 'IS - Imports under special scheme with no GST incurred (e.g. Approved Trader Scheme, ATMS Scheme)',
	'BL'	=> 'BL - Purchases with GST incurred but not claimable (Disallowance of Input Tax) (e.g. medical expenses for staff)',
	'NR'	=> 'NR - Purchase from non GST-registered supplier with no GST incurred',
	'ZP'	=> 'ZP - Purchase from GST-registered supplier with no GST incurred. (e.g. supplier provides transportation of goods that qualify as international services)',
	'EP'	=> 'EP - Purchases exempted from GST. E.g. purchase of residential property or financial services',
	'OP'	=> 'OP - Purchase transactions which is out of the scope of GST legislation (e.g. purchase of goods overseas)',
	'TX-E43'=> 'TX-E43 - Purchase with GST incurred directly attributable to incidental exempt supplies',
	'TX-N43'=> 'TX-N43 - Purchase with GST incurred directly attributable to non-incidental exempt supplies',
	'TX-RE'	=> 'TX-RE - Purchase with GST incurred that is not directly attributable to taxable or exempt supplies',
	'GP'	=> 'GP - Purchase transactions which disregarded under GST legislation (e.g. purchase within GST group registration)',
	'SR'	=> 'SR - Standard-rated supplies with GST Charged',
	'ZRL'	=> 'ZRL - Local supply of goods or services which are subject to zero rated supplies',
	'ZRE'	=> 'ZRE - Exportation of goods or services which are subject to zero rated supplies',
	'ES43'	=> 'ES43 - Incidental Exempt supplies',
	'GS'	=> 'GS - Disregarded supplies'
);
	
?>



<script type="text/javascript">

var breakdown_item = $('tr.breakdown-entry').clone();
var income_item = $('tr.income-entry').clone();
var asset_item = $('table.asset').clone();
var receipt_id = '<?php echo $receipt->id; ?>';

var totalB = 0.00;
var totalO = 0.00;


function readyAdd(status, id){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		var href = $('a.view-pv').attr('href');
		$('a.view-pv').attr('href',href+''+id);
		showDialog('ok','Receipt','Receipt has been recorded.',function(){
			$('a.view-pv').click();
		});
		form_warning = false;
	} else if (status == 0) {
		showDialog('ok','Error','Receipt cannot be recorded now. Please login again.');
		$('div.main_full').show();
		$('div.status').hide();
	} 
}

$(document).ready(function(){

	$('select.pmethod').unbind('change');
	$('select.cces').unbind('change');

	$('select.pmethod').change(function(){
		if ($(this).val() == 'Credit Card'){
			$(this).parents('tr').find('select.cces').show().change();
			$(this).css('width','50%');
		} else {
			$(this).parents('tr').find('select.cces').hide();
			var oldcc = $(this).parents('tr').find('input.reference').attr('cc');
			var string = $(this).parents('tr').find('input.reference').val();
			var string = string.replace(' [*'+oldcc+']','');
			$(this).parents('tr').find('input.reference').val(string);
			$(this).css('width','100%');

		}
	});
	
	$('select.cces').change(function(){
		var oldcc = $(this).parents('tr').find('input.reference').attr('cc');
		
		var string = $(this).parents('tr').find('input.reference').val();
		var string = string.replace(' [*'+oldcc+']','');

		var newcc = $(this).find('option:selected').text();
		
		$(this).parents('tr').find('input.reference').attr('cc',newcc);
		$(this).parents('tr').find('input.reference').val(string + ' [*' + newcc + ']');
	});

	$('a.create').click(function(event){
		calculateTotal();
		if (totalO == 0){
			showDialog('ok','Error','Amount cannot be 0.00');
			return;
		}
		
			
		if (totalB > totalO){
			showDialog('yesno','Imbalance Entry','Your payment is more than total payable. Generate credit note?', function(){
				$('form.insert').submit();
			}, function(){
				// do nothing			
			})

			return;
			
		} else if (totalB < totalO){
			showDialog('ok','Insufficient Amount','Your payment is less than total payable.');
			return;
		}
		
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('select.receipt-type').change(function(){
		var type = $(this).val();
		
		if (type == 'Income (Sales)'){
			$('.type-income-sales').show();
			$('.type-income-non-sales').hide();
			$('.type-asset-disposal').hide();
			
			$('div.type-asset-disposal input.mandatory').removeClass('mandatory');
			$('div.type-income-non-sales input.mandatory').removeClass('mandatory');
			$('div.type-income-sales input[mandatory=1]').addClass('mandatory');

		} else if (type == 'Income (Non-Sales)'){
			$('.type-income-sales').hide();
			$('.type-income-non-sales').show();
			$('.type-asset-disposal').hide();
			
			$('div.type-asset-disposal input.mandatory').removeClass('mandatory');
			$('div.type-income-non-sales input.mandatory').addClass('mandatory');
			$('div.type-income-sales input[mandatory=1]').removeClass('mandatory');
			
		} else {
			$('.type-income-sales').hide();
			$('.type-income-non-sales').hide();
			$('.type-asset-disposal').show();
			
			$('div.type-asset-disposal input.mandatory').addClass('mandatory');
			$('div.type-income-non-sales input.mandatory').removeClass('mandatory');
			$('div.type-income-sales input[mandatory=1]').removeClass('mandatory');

		}
		
		calculateTotal();
	});
	
	$('tr.breakdown-entry a.breakdown-remove').remove();
	$('tr.income-entry a.income-remove').remove();
	$('table.asset a.asset-remove').remove();
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Form Error','Please make sure you have filled the form correctly.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});

	$('a.add-breakdown').click(function(){
		$('table.breakdown tbody').append($(breakdown_item).clone());
		
		$('select.pmethod').unbind('change');
		$('select.cces').unbind('change');
		
		$('select.pmethod').change(function(){
			if ($(this).val() == 'Credit Card'){
				$(this).parents('tr').find('select.cces').show().change();
				$(this).css('width','50%');
			} else {
				$(this).parents('tr').find('select.cces').hide();
				var oldcc = $(this).parents('tr').find('input.reference').attr('cc');
				var string = $(this).parents('tr').find('input.reference').val();
				var string = string.replace(' [*'+oldcc+']','');
				$(this).parents('tr').find('input.reference').val(string);
				$(this).css('width','100%');
	
			}
		});
		
		$('select.cces').change(function(){
			var oldcc = $(this).parents('tr').find('input.reference').attr('cc');
			
			var string = $(this).parents('tr').find('input.reference').val();
			var string = string.replace(' [*'+oldcc+']','');
	
			var newcc = $(this).find('option:selected').text();
			
			$(this).parents('tr').find('input.reference').attr('cc',newcc);
			$(this).parents('tr').find('input.reference').val(string + ' [*' + newcc + ']');
		});		
		populateEvents();
	});
	
	$('a.breakdown-remove').live('click',function(){
		$(this).parents('tr').remove();
		calculateTotal();
	});
	
	$('a.add-asset').click(function(){
		$('div.type-purchase-asset').append($(asset_item).clone());
		populateEvents();
	});
	
	$('a.add-receipt').click(function(){
		$('table.income tbody').append($(income_item).clone());
		populateEvents();
	});
	
	$('a.income-remove').live('click',function(){
		$(this).parents('tr').remove();
		calculateTotal();
	});
	
	$('a.asset-remove').live('click',function(){
		$(this).parents('table').remove();
		calculateTotal();
	});
	
	$('select.contact').change(function(){
		var id = $(this).val();
		$('div.type-income-sales h3').show();
		$('div.grid-container').html('<img src="'+base_url+'images/loading.gif" /> Loading invoices.');
		$.ajax({
			url: base_url + 'accounts/ajax/invoice_by_contact',
			data: 'id=' + id+'&receipt_id='+receipt_id,
			type: 'post',
			success: function (res){
				$('div.grid-container').html(res);
			}
		})
	});
	
	$('input.asset_cost').live('change',function(){
		calculateTotal();
	});
	
	$('input.income_amount').live('change',function(){
		calculateTotal();
	});
	
	$('input.breakdown').live('change',function(){
		calculateTotal();
	});
	
	$('input.inclusive-amount').click(function(){
		calculateTotal();
	});
	
	$('input.tax-amount').change(function(){
		calculateTotal();
	})
	
	$('select.receipt-type').change();

	$('select.contact').change();
	

});

function calculateTotal(){
	var grandTotal = 0.00;
	var type = $('select.receipt-type').val();
	

	
	if (type == 'Income (Sales)'){
		$('input.paid:checked').each(function(){
			var amount = $(this).parents('tr').find('td.amount input').val();
			amount = amount.replace(/,/g,"");
			
			if (!amount) amount = 0.00;
			if ($(this).parents('tr').find('td.amount').hasClass('contra')){
				grandTotal -= parseFloat(amount);				
			} else {
				grandTotal += parseFloat(amount);
			}
		});
		$('td.grandTotal').text(number_format(grandTotal,2));
	} else if (type == 'Disposal of Asset'){
		$('input.asset_cost').each(function(){
			var amount = $(this).val();
			if (!amount) amount = 0.00;
			grandTotal += parseFloat(amount);
		});

	
	} else if (type == 'Income (Non-Sales)'){
		$('input.income_amount').each(function(){
			var amount = $(this).val();
			if (!amount) amount = 0.00;
			grandTotal += parseFloat(amount);
		});
		
		if (!$('input.inclusive-amount').attr('checked')){
			var tax = parseFloat($('input.tax-amount').val());
			if (!tax) tax = 0.00;
			grandTotal += tax;
		}
	}
	
	var breakdownTotal = 0.00;
	
	$('input.breakdown').each(function(){
		var amount = $(this).val();
		if (!amount) amount = 0.00;
		breakdownTotal += parseFloat(amount);	
	})
	
	totalB = breakdownTotal;
	totalO = grandTotal;
	
	$('td.outstanding-paid').text(number_format(breakdownTotal,2));
	$('td.outstanding').text(number_format(grandTotal,2));
}

</script>
	<div class="status">
	
	</div>
	<div class="toolbar">
		<h3 class="grid-title">Receipt</h3>
		<div class="global-tabs" style="padding: 5px;">
			<a href="#" class="v-btn create">Save Receipt</a>
		</div>
	</div>
	<div class="main_full">
		<div class="main-container">
			<a style="display:none" class="target_main view-pv" href="accounts/receipt_view/">View Receipt</a>
			<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>
			
			<form method="post" class="insert" action="<?php echo base_url(); ?>accounts/receipt_deposit/do" target="postframe">
				<input type="hidden" name="receipt_id" value="<?php echo $receipt->id; ?>" />
				<h3>Receipt Information</h3>
				<table class="general-form">
					<tbody>
						<tr class="four">
							<td class="label">Receipt Number</td>
							<td class="input">
								<input value="<?php echo $receipt->txn_no ? $receipt->txn_no : $receipt->id; ?>" type="text" class="v-text" name="txn_no" value="" placeholder="Auto" />
							</td>
							<td class="label">Date <span class="red">*</span></td>
							<td class="input"><input value="<?php echo $receipt->datetime ? date('d/m/Y',strtotime($receipt->datetime)) : ''; ?>" type="text" name="date" class="v-text date mandatory" /></td>
						</tr>
						<tr class="four">
							<td class="label">Type</td>
							<td class="input">
								
									<?php echo form_dropdown('type',array(
									'Income (Sales)'		=> 'Income (Sales)',
									'Income (Non-Sales)'	=> 'Income (Non-Sales)',
									'Disposal of Asset'		=> 'Disposal of Asset',
									'Capital'				=> 'Capital'
									),$receipt->type,'class="v-dropdown receipt-type" style="width:100%"');?>

							</td>
									
							<td class="label">
								<span class="type-income-sales">Contact</span>
								<span class="type-income-non-sales" style="display:none">Account</span>
							</td>	
							<td class="input">
								<?php echo form_dropdown('contact',$contacts_dropdown,$receipt->contact_id,'class="v-dropdown contact type-income-sales" style="width:100%"'); ?>
								<?php echo form_dropdown('account',$income_accounts_list,$receipt->account_id,'class="v-dropdown account type-income-non-sales" style="width:100%; display:none"'); ?>
							</td>
						</tr>
						
					</tbody>
				
				</table>
				
				<div class="type-income-sales" style="display:none">
					<h3 style="display:none">Unpaid Invoices and Debit Notes</h3>
					<div class="grid-container">
					
					</div>
				</div>
				
				<div class="type-asset-disposal" style="display:none">
					<h3>Asset To Dispose</h3>
					<a class="v-btn add-asset">Add Asset</a>
					<table class="general-form asset" style="margin-top: 10px">
						<tbody>
							<tr class="four">
								<td class="label"><a class="v-btn asset-remove">Remove</a> Asset Name <span class="red">*</span></td>
								<td class="input"><input type="text" name="name[]" class="v-text mandatory" mandatory="1" /></td>
								<td class="label">Product Name</td>
								<td class="input"><input type="text" name="product_name[]" class="v-text" /></td>
							</tr>

						</tbody>
					</table>
				</div>
				
				<div class="type-income-non-sales" style="display:none">
					<h3>Receipt Items</h3>
					<a class="v-btn add-receipt">Add</a>
					<table class="general-form income" style="margin-top: 10px">
						<tfoot>
							<tr class="foot">
								<td colspan="3" style="text-align: right; padding: 5px"><strong>Total Outstanding</strong></td>
								<td class="dark outstanding" style="text-align: right; padding: 5px; font-weight: bold">0.00</td>
							</tr>	
						</tfoot>
						<tbody>
							<?php if ($receipt->type == 'Income (Non-Sales)'): ?>
								
								<?php foreach ($receipt->items as $item): ?>
									<tr class="four income-entry">
										<td class="label"><a class="v-btn expense-remove">Remove</a> Reference No</td>
										<td class="input"><input value="<?php echo $item->payment_reference; ?>" type="text" name="reference_no[]" mandatory="1" class="v-text mandatory" /></td>
										<td class="label">Amount (<?php echo $this->system->config('currency'); ?>)</td>
										<td class="input"><input value="<?php echo $item->amount; ?>" type="text" name="income_amount[]" mandatory="1" class="v-text v-number-decimal pv-amount income_amount mandatory" /></td>
									</tr>
								<?php endforeach; ?>
							
							
							<?php else: ?>
							<tr class="four income-entry">
								<td class="label"><a class="v-btn expense-remove">Remove</a> Reference No</td>
								<td class="input"><input type="text" name="reference_no[]" mandatory="1" class="v-text mandatory" /></td>
								<td class="label">Amount (<?php echo $this->system->config('currency'); ?>)</td>
								<td class="input"><input type="text" name="income_amount[]" mandatory="1" class="v-text v-number-decimal pv-amount income_amount mandatory" /></td>
							</tr>
							<?php endif; ?>
						</tbody>
						
					</table>
					
					
					<h3>Tax</h3>
					<table class="general-form tax">
						<tbody>
							<tr class="four">
								<td class="label">Tax Code</td>
								<td class="input"><?php echo form_dropdown('tax_code', $tax_codes,$receipt->tax_code,'class="v-dropdown" style="width:100%"'); ?></td>
								<td class="label">Tax Amount</td>
								<td class="input"><input value="<?php echo $receipt->tax_amount; ?>" type="text" name="tax" class="v-text" /></td>
							</tr>
						</tbody>
					</table>
				</div>
			
				<h3 style="margin-top: 10px">Receipt Breakdown</h3>
				<a class="v-btn add-breakdown">Add Breakdown</a>
				

				<table class="general-form breakdown" style="margin-top: 10px">
					<thead>
						<tr>
							<th style="width: 30px"></th>
							<th>Account</th>
							<th>Reference No</th>
							<th>Method</th>
							<th>Amount (<?php echo $this->system->config('currency'); ?>)</th>
						</tr>
					</thead>
					<tfoot>
						<tr class="foot">
							<td colspan="4" style="text-align: right; padding: 5px"><strong>Total</strong></td>
							<td class="dark outstanding-paid" style="text-align: right; padding: 5px; font-weight: bold">0.00</td>
						</tr>
					</tfoot>
					<tbody>
						<?php if ($receipt->id): ?>
							<?php foreach ($receipt->breakdown as $breakdown): ?>
							<tr class="four breakdown-entry">
								<td style="width: 30px"><a class="remove grid-action grid-action-delete-tx breakdown-remove" ><span>Remove Item</span></a></td>
								<td><?php echo form_dropdown('account_from[]', $cash_postable_list, $breakdown->account_from,'class="v-dropdown" style="width:100%; float: right"'); ?></td>
								<td class="input" style="width: auto"><input type="text" name="breakdown_reference[]" value="<?php echo $breakdown->payment_reference; ?>" class="v-text reference" /></td>
								<td>
									<?php echo form_dropdown('cc[]', $cces, $breakdown->cc_type, 'class="v-dropdown cces" style="width: 48%; float: right; display:none"'); ?>
									<?php echo form_dropdown('payment_method[]', array('Cash'=>'Cash','Cheque'=>'Cheque','Credit Card'=>'Credit Card','Bank Transfer'=>'Bank Transfer','Bank Draft'=>'Bank Draft'),$breakdown->payment_method, 'class="v-dropdown pmethod" style="width: 100%"'); ?>
								</td>
								<td class="input" style="width: auto"><input value="<?php echo $breakdown->amount; ?>" type="text" name="breakdown_amount[]" style="text-align: right" class="v-text v-number-decimal breakdown" /></td>
							</tr>
							<?php endforeach; ?>
						<?php else: ?>
						<tr class="four breakdown-entry">
							<td style="width: 30px"><a class="remove grid-action grid-action-delete-tx breakdown-remove" ><span>Remove Item</span></a></td>
							<td><?php echo form_dropdown('account_from[]', $cash_postable_list, '','class="v-dropdown" style="width:100%; float: right"'); ?></td>
							<td class="input" style="width: auto"><input type="text" name="breakdown_reference[]" class="v-text reference" /></td>
							<td>
								<?php echo form_dropdown('cc[]', $cces, '', 'class="v-dropdown cces" style="width: 48%; float: right; display:none"'); ?>
								<?php echo form_dropdown('payment_method[]', array('Cash'=>'Cash','Cheque'=>'Cheque','Credit Card'=>'Credit Card','Bank Transfer'=>'Bank Transfer','Bank Draft'=>'Bank Draft'),'', 'class="v-dropdown pmethod" style="width: 100%"'); ?>
							</td>
							<td class="input" style="width: auto"><input type="text" name="breakdown_amount[]" style="text-align: right" class="v-text v-number-decimal breakdown" /></td>
						</tr>
						<?php endif; ?>
					</tbody>
				</table>
				
			</form>

		
			
		</div>
	
	</div>