<?php if (!$this->user->has_permission('to_add','Clinic')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">


function readyAdd(status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		showDialog('ok','Patient','New patient has been added.');
		$('input.ic').focus();
		form_warning = false;
	} else if (status == 0) {
		showDialog('ok','Error','Patient cannot be saved now. Please login again.');
		$('div.main_full').show();
		$('div.status').hide();
	} 
}

function validate() {
	var ic = $('input.ic').val();
    $('div.notice').html('');
    
    $.ajax({
    	url: base_url + 'clinic/check_ic/'+ic,
    	dataType: 'json',
    	success: function (item){
    		if (item.status == 'registered'){
    			$('form').clearForm();
    			$('div.notice').html('<p class="v-warning">Patient has already registered.</p>');
    			showDialog('ok','Error','Patient with IC number '+ic+' is already registered');
    			$('div.tabs').hide();
    		}
    	}
    })
    
}

$(document).ready(function(){
	windowResize();
	var timer = null;
	
	$('input.ic').blur(function() {
		validate();
	});
	

	$('a.create').click(function(event){
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
	
});

</script>
	<div class="status">
	
	</div>
	<div class="toolbar">
		<h3 class="grid-title"><a href="clinic/patients" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn back_btn">Back</a>New Patient </h3>
		<div class="global-tabs" style="padding: 3px 5px">
			<a class="v-btn create">Save Patient</a>
		</div>
	</div>

	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing/empty/<?php echo mt_rand(10000,99999); ?>" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">


		<form class="insert" enctype="multipart/form-data" method="post" action="<?=base_url()?>clinic/patient_add/do" target="postframe">
			<div class="notice" style="margin-bottom: 15px">
			
			</div>
			
			<div id="item" class="tabs">
			<p><span style="color:red">*</span> Mandatory fields</p>
			<h3>Identification Card Number (IC)</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Identification Number <span class="red">*</span></td>
						<td class="input"><input type="text" name="ic" class="v-text ic mandatory" /></td>
					</tr>
					
				</tbody>
			</table>		
			<h3>Contact Details</h3>
			<table class="general-form">
				<tbody>	
					<tr>
						<td class="label">Nationality <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('nationality',$this->system->country_list(), $this->system->config('country'),'class="v-dropdown mandatory"'); ?></td>
					</tr>		
					<tr>
						<td class="label">Name <span class="red">*</span></td>
						<td class="input"><input type="text" name="name" class="v-text mandatory" /></td>
					</tr>
					<tr>
						<td class="label">Gender <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('gender',array('Male'=>'Male','Female'=>'Female'),'', 'class="v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Address 1 <span class="red">*</span></td>
						<td class="input"><input type="text" name="address1" class="v-text mandatory" /></td>
					</tr>
					<tr>
						<td class="label">Address 2</td>
						<td class="input"><input type="text" name="address2" class="v-text" /></td>
					</tr>
					<tr>
						<td class="label">City <span class="red">*</span></td>
						<td class="input"><input type="text" name="city" class="v-text mandatory" /></td>
					</tr>
					<tr>
						<td class="label">Zipcode <span class="red">*</span></td>
						<td class="input"><input type="text" name="zipcode" class="v-text mandatory" /></td>
					</tr>
					<tr>
						<td class="label">State/Province <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('state',$this->system->state_list($this->system->config('country')), 'Kedah', 'class="v-city v-dropdown mandatory"'); ?></td>
					</tr>
					<tr>
						<td class="label">Country <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('country',$this->system->country_list(), $this->system->config('country'),'class="v-country v-dropdown mandatory"'); ?></td>
					</tr>
					<tr>
						<td class="label">Email</td>
						<td class="input"><input type="text" name="email" class="v-text" /></td>
					</tr>
					<tr>
						<td class="label">Contact Number <span class="red">*</span></td>
						<td class="input"><input type="text" name="contact_number" class="v-number-decimal mandatory" /></td>
					</tr>

					<tr>
						<td class="label">Marital Status <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('marital_status',array('Married'=>'Married','Single'=>'Single'),'', 'class="v-dropdown"'); ?></td>
					</tr>
					
					<tr>
						<td class="label">Spouse's IC </td>
						<td class="input"><input type="text" name="spouse_ic" class="v-text" /></td>
					</tr>
				</tbody>
			</table>
			
			<h3>Health Details</h3>
			<table class="general-form">
					<tr>
						<td class="label">Blood Type </td>
						<td class="input"><input type="text" name="blood_type" class="v-text" /></td>
					</tr>
					<tr>
						<td class="label">Weight </td>
						<td class="input"><input type="text" name="weight" class="v-text" /></td>
					</tr>
 					<tr>
						<td class="label">Height </td>
						<td class="input"><input type="text" name="height" class="v-text" /></td>
					</tr>	
					<tr>
						<td class="label">Allergy</td>
						<td class="input"><textarea name="allergy" class="v-textarea"></textarea></td>
					</tr>									
			</table>
			<br/>
		</form>
		</div>
	</div>
