<?php if (!$this->user->has_permission('to_view_case','Contacts')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">


$(document).ready(function(){
	$('a.create').click(function(event){
		$(this).parents('form').submit();
		event.preventDefault();
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Form Error','Please make sure you have filled the form correctly.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
	
	$('div.global-tabs li a').click(function(){
		$('.tab-related').hide();
		var current = $(this).attr('href');
		$('table.'+current).show();
	});

});

function filterItems(){
	var date_from	= $('input.filter-date-from').val();
	var date_to		= $('input.filter-date-to').val();
	var status		= $('select.filter-status').val();
	var contact		= $('select.filter-contact').val();
	
	$('div.main_full').html('<p style="text-align: center; padding-top: 20px;"><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	
	
	$.ajax({
		url: base_url + 'contacts/case_list_filter',
		type: 'POST',
		data: 'date_from='+date_from+'&date_to='+date_to+'&status='+status+'&contact='+contact,
		success: function (result){
			reload_data = 'date_from='+date_from+'&date_to='+date_to+'&status='+status+'&contact='+contact;
			$('div.main_full').html(result);
			populateEvents();
			filtered = true;
			
			$('div.global-tabs ul a.current').click();
		}
	})
}


</script>
	<div class="status">
	
	</div>
	<div class="toolbar">
		<h3 class="grid-title">
			<?php if ($this->user->has_permission('to_create_case','Contacts')): ?>
			<a class="v-btn target_main float_right" style="padding: 0 10px; font-weight: normal" href="contacts/new_case">New Case</a>
			<?php endif; ?>
			Cases
		</h3>
		
		<div class="global-tabs" style="padding: 5px; font-size: 10pt">
			<a class="v-btn show-filter-controls icon-search">Search</a>
		</div>

		<div class="modal-filter-form filter" style="font-size: 10pt;">
			<div class="triangle"></div>
			<table>
				<tr>
					<td>Contact</td>
					<td><?php echo form_dropdown('contact', $contacts_dropdown,'','class="filter-contact v-dropdown" style="font-size:10pt; margin-right: 10px; width: 110px"'); ?></td>
				</tr>
				<tr>				
					<td>Status</td>
					<td><?php echo form_dropdown('status', array(''=>'Select','Pending'=>'Pending','Low'=>'Low','Medium'=>'Medium','High'=>'High','Closed Solved'=>'Closed Solved','Closed Unsolved'=>'Closed Unsolved'),'','class="filter-status v-dropdown" style="font-size:10pt; margin-right: 10px; width: 80px"'); ?></td>
				</tr>
				<tr>
					<td>From</td>
					<td><input type="text" name="date_from" class="date v-text filter-date-from" value="<?php echo date('1/m/Y'); ?>" style="width: 80px" /> </td>
				</tr>
			    <tr>
			    	<td>To</td>
			    	<td><input type="text" name="date_from" class="date v-text filter-date-to" value="<?php echo date('d/m/Y'); ?>" style="width: 80px" /> </td>
			    </tr>
			</table>
			<hr />
	    	<a class="v-btn filter-btn">Filter</a>
			
		</div>
		

		<table class="grid">
    		<thead>
    			<tr>
    				<th style="width: 80px">Log Date</th>
    				<th style="width: 80px">Report Date</th>
    				<th>Case</th>
    				<th style="width: 100px">Reported by</th>
    				<th style="width: 100px">Logged by</th>
    				<th style="width: 100px">Case Status</th>
    				<th style="width: 100px">Log Status</th>


					<th class="grid-action" style="text-align: center; width: 75px; padding: 0"><img src="<?=base_url()?>images/email-action.gif" alt="Action"></th>
    				<th style="width: 15px; padding: 0"></th>
    			</tr>
    		</thead>
    	</table>
	</div>
	
	<div class="main_full">
	    <table class="grid grid_data">
	    	<tbody>
	    		<?php $x = 1; foreach ($cases as $case): $x++; ?>
	    		<tr rel="<?php echo $case->id; ?>" <?php if ($x%2==0) echo ' class="alt"'; ?>>
	    			<td style="width: 80px"><?php echo $case->log_date ? date('d/m/Y',strtotime($case->log_date)) : ''; ?></td>
	    			<td style="width: 80px;"><?php echo date('d/m/Y',strtotime($case->added_on)); ?></td>
	    			<td><?php echo $case->subject; ?></td>
	    			<td style="width: 100px;"><?php echo $case->added_by; ?></td>
	    			<td style="width: 100px"><?php echo $case->log_user; ?></td>
	    			<td style="width: 100px; text-align: center"><span class="case-<?php echo str_replace(' ','-',strtolower($case->status)); ?>"><?php echo $case->status; ?></span></td>
	    			<td style="width: 100px; text-align: center"><span class="case-<?php echo str_replace(' ','-',strtolower($case->log_status)); ?>"><?php echo $case->log_status; ?></span></td>
					<td style="width: 75px; padding: 0">
						<?php if ($this->user->has_permission('to_view_case','Contacts')): ?><a class="grid-action grid-action-view target_main" href="contacts/case_logs/<?php echo $case->id?>"><span>View</span></a><?php endif; ?>
						<?php if ($this->user->has_permission('to_edit_case','Contacts')): ?><a class="grid-action grid-action-edit target_main" href="contacts/edit_case/<?php echo $case->id?>"><span>Edit</span></a><?php endif; ?>
						<?php if ($this->user->has_permission('to_delete_case', 'Contacts')): ?><a class="grid-action grid-action-delete" href="contacts/delete_case/<?php echo $case->id?>/do"><span>Delete</span></a><?php endif; ?>
					</td>
	    		</tr>
	    		<?php endforeach; ?>
	    	</tbody>
		</table>
			
			


	</div>
