<?php if (!$this->user->has_permission('to_view_case','Contacts')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var logpsuedo;
$(document).ready(function(){

	$('a.delete-file').click(function(e){
		e.preventDefault();
		
		var href = $(this).attr('href');
		var that = this;
		
		showDialog('yesno','Confirm Delete Log','Are you sure you want to delete this file?', function(){	
			$.ajax({
				url: href,
				success: function (res){
					if (res == 'ok'){
						$(that).parents('tr').fadeOut(function(){
							$(this).remove();
						});
					}
				}
			})
		})
	});
	
	$('a.set-as-current-file').click(function(e){
		e.preventDefault();
		var href = $(this).attr('href');
		var that = this;
		
		$.ajax({
			url: href,
			success: function (res){
				if (res == 'ok'){
					$('table.file-list tr').removeClass('current-file');
					$(that).parents('tr').addClass('current-file');
					var href = $(that).parents('tr').find('a.case-file-link').attr('href');
					var name = $(that).parents('tr').find('a.case-file-link').attr('name');
					$('td.case-file').html('<a target="_blank" href="'+href+'">'+name+'</a>');
				}
			}
		})
	})

	$('a.create').click(function(event){
		$(this).parents('form').submit();
		event.preventDefault();
	});
	
	$('a.browse-files').click(function(event){
		event.preventDefault();
		showModalForm('file-search');
	});
	
	$('a.file-search-done').click(function(){
		event.preventDefault();
		hideModalForm('file-search');		
	});
	
	
	<?php if ($this->user->has_permission('to_delete_log','Contacts')): ?>
	$('button.delete-log').click(function(){
		var id = $(this).attr('id');
		var parent = $(this).parents('div.log');
	
		showDialog('yesno','Confirm Delete Log','Are you sure you want to delete the log?', function(){			
			$.ajax({
				url: base_url + 'contacts/ajax/delete_log/',
				type: 'post',
				data: 'id='+id,
				success: function (res){
					if (res){
						parent.fadeOut(function(){
							$(this).remove();
						})
					} else {
						showDialog('ok','Error','Failed to delete log.');
					}
				}
			})
		});
	})
	<?php endif; ?>
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Form Error','Please make sure you have filled the form correctly.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
	
	$('div.global-tabs li a').click(function(){
		$('.tab-related').hide();
		var current = $(this).attr('href');
		$('table.'+current).show();
	});
	
	$('a.add-entry').click(function(){
		addEntry();
	});
	
	$('#global-sidebar-list li').removeClass('current');
	$('#global-sidebar-list a.contacts').parent('li').addClass('current');

});


function reloadFileList(){
	$.ajax({
		url: 'contacts/case_files/<?php echo $case->id; ?>',
		success: function(res){
			$('div.modal-search-result').html(res);
		}
	})
}

function addEntry(){
	var subject = $('input.entry-subject').val();
	var desc = $('textarea.entry-description').val();
	var status = $('select.status').val();
	
	if (!subject && !desc){
		showDialog('ok','Error','Subject and description cannot be empty.');
		return;
	}
	
	$('form.log').submit();
	$('div.main_full').show();
	
	logpsuedo = $('div.log-psuedo').clone();
	$(logpsuedo).removeClass('log-psuedo').prepend('<p class="loading" style="text-align: center"><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	$('div.log-container').prepend(logpsuedo);
	$(logpsuedo).slideDown();



}

function readyLog(logdata){

	reloadFileList();
	
	$('input.entry-subject').val('');
	$('textarea.entry-description').val('');
	$('select.status').val('');
	
	
	$(logpsuedo).find('p.loading').remove();
	$(logpsuedo).find('div.log-status').addClass('log-status-'+logdata.status).text(logdata.status);
	$(logpsuedo).find('div.log-subject').text(logdata.subject);
	$(logpsuedo).find('div.log-description').text(logdata.description);
	$(logpsuedo).find('div.log-file').html('<a target="_blank" href="../assets/docs/'+logdata.file+'">'+logdata.file+'</a>');
	<?php if ($this->user->has_permission('to_delete_log','Contacts')): ?>
	    $(logpsuedo).find('div.log-meta').html('Posted on ' + logdata.added_on + ' by ' + logdata.added_by + ' <button class="v-btn delete-log" id="'+logdata.id+'">Delete</button>');
	    $(logpsuedo).find('button.delete-log').click(function(){
	    	var id = $(this).attr('id');
	    	var parent = $(this).parents('div.log');
	    
	    	showDialog('yesno','Confirm Delete Log','Are you sure you want to delete the log?', function(){			
	    		$.ajax({
	    			url: base_url + 'contacts/ajax/delete_log/',
	    			type: 'post',
	    			data: 'id='+id,
	    			success: function (res){
	    				if (res){
	    					parent.fadeOut(function(){
	    						$(this).remove();
	    					})
	    				} else {
	    					showDialog('ok','Error','Failed to delete log.');
	    				}
	    			}
	    		})
	    	});
	    });
	<?php else: ?>
	    $(logpsuedo).find('div.log-meta').html('Posted on ' + logdata.added_on + ' by ' + logdata.added_by);			
	<?php endif; ?>
	$(logpsuedo).find('div').show();
}

</script>

	<div id="file-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Files</h3>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">File Name</th>
						<th class="sortable" style="width: 270px">Action</th>
						<th style="width: 14px; padding: 0;"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll; height: 290px">
				<table class="grid grid_data file_list">
					<?php $x = 0; foreach ($logs as $log): if ($log->file): $x++; ?>
					<tr class="<?php if ($x%2 == 0) echo 'alt'; ?>">
						<td><?php echo $log->file; ?></td>
						<td style="width: 270px">
							<a target="_blank" name="<?php echo $log->file; ?>" class="v-btn case-file-link" href="../assets/docs/<?php echo $log->file; ?>">Open File</a>
							<a class="v-btn set-as-current-file" href="contacts/set_case_file/<?php echo $log->id; ?>">Set as Case File</a>
							<a class="v-btn delete-file" href="contacts/delete_case_file/<?php echo $log->id; ?>">Delete File</a>
						</td>
					</tr>
					<?php if ($log->current_file) $current_file = $log->file; ?>
					<?php endif; endforeach; ?>
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;">
				<a class="v-dbtn file-search-done">Close</a>
			</p>
		</div>
	</div>


	<div class="status">
	
	</div>
	<div class="toolbar">
		<h3 class="grid-title"><a href="contacts/view/<?php echo $contact->id; ?>" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn target_main">Back</a>Case Log &raquo; <?php echo $contact->company_name ? $contact->company_name : $contact->contact_person; ?></h3>
		
		<div>
			<table class="general-form" style="padding-bottom: 0; margin-bottom: 0">
				<tr class="four">
					<td class="label">Reported Date</td>
					<td class="input"><?php echo date('h:iA d/m/Y', strtotime($case->added_on)); ?></td>
					<td class="label">Status</td>
					<td class="input"><?php echo $case->status; ?></td>
				</tr>
				<tr class="four">
					<td class="label">Case</td>
					<td class="input"><?php echo $case->subject; ?></td>
					<td class="label">Description</td>
					<td class="input"><?php echo $case->description; ?></td>
				</tr>
				<tr class="four">
					<td class="label">File Location</td>
					<td class="input"><?php echo $case->file_location; ?></td>
					<td class="label">Reference No</td>
					<td class="input"><?php echo $case->reference_no; ?> <a href="contacts/case_barcode/<?php echo $case->id; ?>" target="_blank" class="v-btn">Barcode</a></td>
				</tr>
				<tr class="four">
					<td class="label">Case File</td>
					<td class="input case-file">
						<?php if ($current_file): ?>
						<a target="_blank" href="../assets/docs/<?php echo $current_file; ?>"><?php echo $current_file; ?></a>
						<?php endif; ?>
					</td>
					<td class="label">Others</td>
					<td class="input"><a class="v-btn browse-files">Browse Files</a>
				</tr>
			</table>
		</div>
		<?php if ($this->user->has_permission('to_create_log','Contacts')): ?>

		<div class="log-entry" style="padding: 10px; background: #EEE; border-bottom: 1px solid #DDD;">
			<iframe id="postframe_log" name="postframe_log" style="display:none"></iframe>
			<form target="postframe_log" class="log" method="post" action="contacts/ajax/add_log" enctype="multipart/form-data">
				<input type="hidden" name="id" value="<?php echo $case->id; ?>" />
				<table style="font-size: 10pt; width: 100%">
					<tr>
						<td style="width: 25%; text-align: right; padding-right: 20px; font-weight: bold">Entry Subject</td>
						<td><input name="subject" type="text" style="width: 100%" class="entry-subject v-text" /></td>
					</tr>
					<tr>
						<td style="width: 25%; text-align: right; padding-right: 20px; font-weight: bold">Entry Description</td>
						<td><textarea name="description" style="width: 100%; height: 40px;" class="entry-description v-textarea"></textarea></td>
					</tr>
					<tr>
						<td style="width: 25%; text-align: right; padding-right: 20px; font-weight: bold">Upload File</td>
						<td><input type="file" class="file" name="file" /></td>
					</tr>
					<tr>
						<td style="width: 25%; text-align: right; padding-right: 20px; font-weight: bold">Log Status</td>
						<td><?php echo form_dropdown('status',array('Low'=>'Low','Medium'=>'Medium','High'=>'High'),'','class="v-dropdown status" style="width: auto;"'); ?> <a class="v-btn add-entry">Add Log Entry</a></td>
					</tr>
				</table>
			</form>
		</div>

		<?php endif; ?>
	</div>
	
	<div class="main_full">
		
		
			<div class="log log-psuedo" style="display:none">
				<div style="display:none" class="log-status"></div>
				<div style="display:none" class="log-subject"></div>
				<div style="display:none" class="log-description"></div>
				<div style="display:none" class="log-meta"></div>
				<div class="log-file"></div>
			</div>

		<div class="log-container">
			
			<?php 
				$count = count($logs) + 1;
				foreach ($logs as $log): $count--;
			?>
			<div class="log">
				<div class="log-status log-status-<?php echo $log->status; ?>"><?php echo $log->status; ?></div>
				<div class="log-subject"><?php echo '#' . $count . ' - ' . $log->subject; ?></div>
				<div class="log-description"><?php echo $log->description; ?></div>
				<div class="log-meta">
					Posted on <?php echo date('h:iA d/m/Y', strtotime($log->added_on)); ?> by <?php echo $log->added_by; ?> 
					<?php if ($this->user->has_permission('to_delete_log','Contacts')): ?>
					<button class="v-btn delete-log" id="<?php echo $log->id; ?>">Delete</button>
					<?php endif; ?>

				</div>
				<div class="log-file">
				<?php if ($log->file): ?>
					<a target="_blank" href="../assets/docs/<?php echo $log->file; ?>"><?php echo $log->file; ?></a>
				<?php endif; ?>
				</div>
			</div>
			<?php endforeach; ?>
		</div>
	</div>
