<?php if (!$this->user->has_permission('to_view_contact','Contacts')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">


$(document).ready(function(){
	$('a.create').click(function(event){
		$(this).parents('form').submit();
		event.preventDefault();
	});
	
	$('a.delete-file').click(function(e){
		e.preventDefault();
		var href = $(this).attr('href');
		var that = this;
		$.ajax({
			url: href,
			success: function (res){
				if (res == 'ok'){
					$(this).parents('tr').fadeOut(function(){
						$(this).remove();
					});
				}
			}
		})
	})
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Form Error','Please make sure you have filled the form correctly.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
	
	$('div.global-tabs li a').click(function(){
		$('.tab-related').hide();
		var current = $(this).attr('href');
		$('.'+current).show();
	});

});

function filterItems(){
	var date_from = $('input.filter-date-from').val();
	var date_to = $('input.filter-date-to').val();
	
	$('div.main_full').html('<p style="text-align: center; padding-top: 20px;"><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	
	
	$.ajax({
		url: base_url + 'contacts/view_filter/<?php echo $contact->id; ?>',
		type: 'POST',
		data: 'date_from='+date_from+'&date_to='+date_to,
		success: function (result){
			reload_data = 'date_from='+date_from+'&date_to='+date_to;
			$('div.main_full').html(result);
			populateEvents();
			filtered = true;
			
			$('div.global-tabs ul a.current').click();
		}
	})
}


</script>
	<div class="status">
	
	</div>
	<div class="toolbar">
		<h3 class="grid-title"><a href="contacts/elist" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn target_main">Back</a>Contact &raquo; <?php echo $contact->company_name ? $contact->company_name : $contact->contact_person; ?></h3>
		<div>
			<table class="general-form" style="padding-bottom: 0; margin-bottom: 0px;">
				<tbody>
					<tr class="four">
						<td class="label">Company Name</td>
						<td class="input"><?php echo $contact->company_name; ?></td>
						<td class="label">Registration Number</td>
						<td class="input"><?php echo $contact->reg_number; ?></td>
					</tr>
					<tr class="four">
						<td class="label">Address</td>
						<td class="input" colspan="3"><?php echo $contact->address; ?></td>
					</tr>
					<tr class="four">
						<td class="label">Contact Person</td>
						<td class="input"><?php echo $contact->contact_person; ?></td>
						<td class="label">Contact Number</td>
						<td class="input"><?php echo $contact->contact_number; ?></td>
					</tr>
					<tr class="four">
						<td class="label">Status</td>
						<td class="input"><?php echo $contact->status; ?></td>
						<td class="label">Credit Limit</td>
						<td class="input"><?php echo $contact->credit_limit; ?></td>
					</tr>
					<tr class="four">
						<td class="label">Total Outstanding</td>
						<td class="input"><?php echo $outstanding >= 0 ? number_format($outstanding,2) : '(' . number_format(0-$outstanding,2) . ')';?></td>
						<td class="label">Available Credit</td>
						<td class="input"><?php echo number_format($available,2);?></td>
					</tr>
					<tr class="four">
						<td class="label">Points</td>
						<td class="input" colspan="3"><?php echo number_format($points); ?></td>
					</tr>

				</tbody>
			</table>


		</div>
		
		<?php if ($this->system->uses('Sales') || $this->system->uses('Inventory') || $this->system->uses('Accounts')): ?>
		<div class="global-tabs filter" style="height: 35px">
			
	    	<div style="float: right; font-size: 10pt; padding: 10px;">
	    		<?php if ($this->user->has_permission('to_create_case','Contacts')): ?>
	    		<a class="v-btn target_main float_right" style="padding: 0 10px; margin-left: 20px;" href="contacts/add_case/<?php echo $contact->id; ?>">New Case</a>
	    		<?php endif; ?>
	    		
	    		<?php if ($this->system->uses('Sales') || $this->system->uses('Inventory')): ?>
		    	<span style="padding-right: 20px">&#10004; Paid</span>
		    	<span style="padding-right: 15px">&#10008; Unpaid</span>
		    	<?php endif; ?>
		    	<?php if ($this->system->uses('Accounts')): ?>
		    	<span>&#10038; Contra</span>
		    	<?php endif; ?>
			</div>

		    <p class="filter" style="margin:0; padding: 10px 5px 0 15px; font-size: 10pt">
				From <input type="text" name="date_from" class="date v-text filter-date-from" value="<?php echo date('1/m/Y'); ?>" style="width: 80px" /> 
		    	To <input type="text" name="date_from" class="date v-text filter-date-to" value="<?php echo date('d/m/Y'); ?>" style="width: 80px" /> 
		    	<a class="v-btn filter-btn">Filter</a>
		    </p>
		</div>
		

				
		<div class="global-tabs" style="padding: 5px 5px 0 5px">
			<ul>
				<li><a href="notes" class="current" style="width: 50px">Notes</a></li>
				<?php if ($this->user->has_permission('to_view_case','Contacts')): ?>
				<li><a href="cases" style="width: 50px">Cases</a></li>
				<?php endif; ?>
				<?php if ($this->system->uses('Sales')): ?>
				<li><a href="invoices" style="width: 60px">Invoices</a></li>
				<li><a href="cns" style="width: 80px">Credit Notes</a></li>
				<?php endif; ?>
				<?php if ($this->system->uses('Inventory')): ?>
				<li><a href="purchases" style="width: 110px">Purchase Orders</a></li>
				<li><a href="dns" style="width: 80px">Debit Notes</a></li>
				<?php endif; ?>
				<?php if ($this->system->uses('Accounts')): ?>
				<li><a href="soa" style="width: 130px">Statement of Account</a></li>
				<li><a href="aging-payables" style="width: 100px">Payables Aging</a></li>
				<li><a href="aging-receivables" style="width: 120px">Receivables Aging</a></li>
				<?php endif; ?>
			</ul>
		</div>
		
		<?php endif; ?>
		

		<?php if ($this->system->uses('Sales')): ?>
		<table class="grid tab-related invoices" style="display:none">
    		<thead>
    			<tr>
    				<th style="width: 100px">Date</th>
    				<th>Transaction</th>
    				<th style="width: 100px">Payment Date</th>
    				<th style="width: 100px">Reference No</th>
    				<th style="width: 100px">Amount</th>
    				<th style="width: 35px">Paid</th>
    				<th style="width: 15px; padding: 0"></th>
    			</tr>
    		</thead>
    	</table>
    	

		<table class="grid tab-related cns" style="display:none">
    		<thead>
    			<tr>
    				<th style="width: 100px">Date</th>
    				<th>Transaction</th>
    				<th style="width: 100px">Payment Date</th>
    				<th style="width: 100px">Reference No</th>
    				<th style="width: 100px">Amount</th>
    				<th style="width: 35px">Paid</th>
    				<th style="width: 15px; padding: 0"></th>
    			</tr>
    		</thead>
    	</table>
    	<?php endif; ?>

		<?php if ($this->system->uses('Inventory')): ?>
		<table class="grid tab-related purchases" style="display:none">
    		<thead>
    			<tr>
    				<th style="width: 100px">Date</th>
    				<th>Transaction</th>
    				<th style="width: 100px">Payment Date</th>
    				<th style="width: 100px">Reference No</th>
    				<th style="width: 100px">Amount</th>
    				<th style="width: 35px">Paid</th>
    				<th style="width: 15px; padding: 0"></th>
    			</tr>
    		</thead>
    	</table>

		<table class="grid tab-related dns" style="display:none">
    		<thead>
    			<tr>
    				<th style="width: 100px">Date</th>
    				<th>Transaction</th>
    				<th style="width: 100px">Payment Date</th>
    				<th style="width: 100px">Reference No</th>
    				<th style="width: 100px">Amount</th>
    				<th style="width: 35px">Paid</th>
    				<th style="width: 15px; padding: 0"></th>
    			</tr>
    		</thead>
    	</table>
    	<?php endif; ?>

    	<?php if ($this->system->uses('Accounts')): ?>
    	<table class="grid tab-related soa" style="display:none">
    		<thead>
    			<tr>
    				<th style="width: 100px">Date</th>
    				<th>Description</th>
    				<th style="width: 120px">Type</th>
    				<th style="width: 120px">Reference No</th>
    				<th style="width: 120px">Debit</th>
    				<th style="width: 120px">Credit</th>
    				<th style="width: 15px; padding: 0"></th>

    			</tr>
    		</thead>
    	</table>
    	
    	<table class="grid tab-related aging-payables" style="display:none">
    		<thead>
    			<tr>
    				<th style="width: 100px">Date</th>
    				<th>PO No</th>
    				<th style="width: 100px">Due Date</th>
    				<th style="width: 110px">Current</th>
    				<th style="width: 110px">1-30</th>
    				<th style="width: 110px">31-60</th>
    				<th style="width: 110px">61-90</th>
    				<th style="width: 110px">Over 90</th>
    				<th style="width: 15px; padding: 0"></th>
    			</tr>
    		</thead>
    	</table>
    	
    	<table class="grid tab-related aging-receivables" style="display:none">
    		<thead>
    			<tr>
    				<th style="width: 100px">Date</th>
    				<th>Invoice No</th>
    				<th style="width: 100px">Due Date</th>
    				<th style="width: 110px">Current</th>
    				<th style="width: 110px">1-30</th>
    				<th style="width: 110px">31-60</th>
    				<th style="width: 110px">61-90</th>
    				<th style="width: 110px">Over 90</th>
    				<th style="width: 15px; padding: 0"></th>

    			</tr>
    		</thead>
    	</table>
    	<?php endif; ?>
    	
    	<?php if ($this->user->has_permission('to_view_case','Contacts')): ?>
    	<table class="grid tab-related cases" style="display:none">
    		<thead>
    			<tr>
    				<th style="width: 80px">Log Date</th>
    				<th style="width: 80px">Report Date</th>
    				<th>Case</th>
    				<th style="width: 100px">Reported by</th>
    				<th style="width: 100px">Logged by</th>
    				<th style="width: 100px">Case Status</th>
    				<th style="width: 100px">Log Status</th>


					<th class="grid-action" style="text-align: center; width: 75px; padding: 0"><img src="<?=base_url()?>images/email-action.gif" alt="Action"></th>
    				<th style="width: 15px; padding: 0"></th>
    			</tr>
    		</thead>
    	</table>
    	<?php endif; ?>
	</div>
	
	<div class="main_full">
		
		<div class="tab-related notes" style="padding: 10px">
			<h3>Notes</h3>
			<?php echo nl2br($contact->notes); ?>
			
		</div>


		<?php if ($this->system->uses('Sales')): ?>
	    <table type="invoices" class="grid tab-related grid_data invoices" style="display:none">
	    	<tbody>
	    		<?php $x = 1; foreach ($invoices as $transaction): $x++; ?>
	    		<?php
	    			$balance = $transaction->debit + $transaction->credit;
	    			$total_debit = $transaction->debit;
	    			$total_credit = $transaction->credit;
	    		?>
	    		<tr rel="<?php echo $transaction->id; ?>" <?php if ($x%2==0) echo ' class="alt"'; ?> <?php if ($transaction->payment_status == 'Paid') echo 'paid="1"'; else echo 'paid="0"'; ?>>
	    			<td style="width: 100px;"><?php echo date('d/m/Y',strtotime($transaction->date)); ?></td>
	    			<td>INV-<?php echo $transaction->id; ?></td>
	    			<td style="width: 100px"><?php echo $transaction->payment_status == 'Paid' ? date('d/m/Y',strtotime($transaction->payment_date)) : ''; ?></td>
	    			<td style="width: 100px"><?php echo $transaction->payment_contra ? 'PV-' . $transaction->payment_contra : 'RC-' . $transaction->payment_reference; ?></td>
	    			<td style="width: 100px; text-align: right">
	    				<?php if ($transaction->no_do): ?>
	    					<?php echo number_format($transaction->amount_credit,2); ?>
	    				<?php else: ?>
	    					<?php echo number_format($transaction->total,2); ?>							
	    				<?php endif; ?>
	    			</td>
	    			<td style="width: 35px; text-align: center"><?php if ($transaction->payment_status == 'Paid') echo $transaction->payment_contra ? '&#10038;' :'&#10004;'; else echo '&#10008;'; ?></td>
	    		</tr>
	    		<?php endforeach; ?>
	    	</tbody>
		</table>
	
		<table type="cns" class="grid tab-related grid_data cns" style="display:none">
			<tbody>
		    	<?php $x = 1; foreach ($cns as $transaction): $x++; ?>
		    	<?php
		    		$balance = $transaction->debit + $transaction->credit;
		    		$total_debit = $transaction->debit;
		    		$total_credit = $transaction->credit;
		    	?>
		    	<tr rel="<?php echo $transaction->id; ?>" <?php if ($x%2==0) echo ' class="alt"'; ?> <?php if ($transaction->payment_status == 'Paid') echo 'paid="1"'; else echo 'paid="0"'; ?>>
		    		<td style="width: 100px;"><?php echo date('d/m/Y',strtotime($transaction->date)); ?></td>
		    		<td>CN-<?php echo $transaction->id; ?></td>
	    			<td style="width: 100px"><?php echo $transaction->payment_status == 'Paid' ? date('d/m/Y',strtotime($transaction->payment_date)) : ''; ?></td>
	    			<td style="width: 100px"><?php echo $transaction->payment_contra ? 'RC-' . $transaction->payment_contra : 'PV-' . $transaction->payment_reference; ?></td>
		    		<td style="width: 100px; text-align: right"><?php echo number_format($transaction->total,2); ?></td>
	    			<td style="width: 35px; text-align: center"><?php if ($transaction->payment_status == 'Paid') echo $transaction->payment_contra ? '&#10038;' :'&#10004;'; else echo '&#10008;'; ?></td>
		    	</tr>
		    	<?php endforeach; ?>
		    </tbody>
		</table>
		
		<?php endif; ?>
		
		
		<?php if ($this->system->uses('Inventory')): ?>
		
		<table type="purchases" class="grid tab-related grid_data purchases" style="display:none">
			<tbody>
		    	<?php $x = 1; foreach ($purchases as $transaction): $x++; ?>
		    	<?php
		    		$balance = $transaction->debit + $transaction->credit;
		    		$total_debit = $transaction->debit;
		    		$total_credit = $transaction->credit;
		    	?>
		    	<tr rel="<?php echo $transaction->id; ?>" <?php if ($x%2==0) echo ' class="alt"'; ?> <?php if ($transaction->payment_status == 'Paid') echo 'paid="1"'; else echo 'paid="0"'; ?>>
		    		<td style="width: 100px;"><?php echo date('d/m/Y',strtotime($transaction->date)); ?></td>
		    		<td>PO-<?php echo $transaction->id; ?></td>
	    			<td style="width: 100px"><?php echo $transaction->payment_status == 'Paid' ? date('d/m/Y',strtotime($transaction->payment_date)) : ''; ?></td>
	    			<td style="width: 100px"><?php echo $transaction->payment_contra ? 'RC-' . $transaction->payment_contra : 'PV-' . $transaction->payment_reference; ?></td>
		    		<td style="width: 100px; text-align: right"><?php echo number_format($transaction->total,2); ?></td>
	    			<td style="width: 35px; text-align: center"><?php if ($transaction->payment_status == 'Paid') echo $transaction->payment_contra ? '&#10038;' :'&#10004;'; else echo '&#10008;'; ?></td>
		    	</tr>
		    	<?php endforeach; ?>
		    </tbody>
		</table>	
		
		
		<table type="dns" class="grid tab-related grid_data dns" style="display:none">
			<tbody>
		    	<?php $x = 1; foreach ($dns as $transaction): $x++; ?>
		    	<?php
		    		$balance = $transaction->debit + $transaction->credit;
		    		$total_debit = $transaction->debit;
		    		$total_credit = $transaction->credit;
		    	?>
		    	<tr rel="<?php echo $transaction->id; ?>" <?php if ($x%2==0) echo ' class="alt"'; ?> <?php if ($transaction->payment_status == 'Paid') echo 'paid="1"'; else echo 'paid="0"'; ?>>
		    		<td style="width: 100px;"><?php echo date('d/m/Y',strtotime($transaction->date)); ?></td>
		    		<td>DN-<?php echo $transaction->id; ?></td>
	    			<td style="width: 100px"><?php echo $transaction->payment_status == 'Paid' ? date('d/m/Y',strtotime($transaction->payment_date)) : ''; ?></td>
	    			<td style="width: 100px"><?php echo $transaction->payment_contra ? 'PV-' . $transaction->payment_contra : 'RC-' . $transaction->payment_reference; ?></td>
		    		<td style="width: 100px; text-align: right"><?php echo number_format($transaction->total,2); ?></td>
	    			<td style="width: 35px; text-align: center"><?php if ($transaction->payment_status == 'Paid') echo $transaction->payment_contra ? '&#10038;' :'&#10004;'; else echo '&#10008;'; ?></td>
		    	</tr>
		    	<?php endforeach; ?>
		    </tbody>
		</table>	

		<?php endif; ?>
		
		
		<?php if ($this->system->uses('Accounts')): ?>
		<table class="grid tab-related grid-data soa" style="display:none">
			<tbody>
			    <?php $x=0; foreach ($transactions as $date => $txns): ?>	    
		    	<?php foreach ($txns as $txn): ?>
			    <?php
			    	$balance += $txn->balance + $txn->debit - $txn->credit;
			    	
			    	if ($txn->balance){
			    		if ($txn->balance < 0){
				    		$txn->credit = str_replace(',', '',number_format(0 - $txn->balance,2));
				    	} else {
				    		$txn->debit = str_replace(',', '',number_format($txn->balance,2));
				    	}
			    	}
			    ?>
			    <tr <?php echo $x%2 == 0 ? 'class="alt"' : ''; ?>>
		    		<td style="width: 100px"><?php if ($x != 0) echo date('d/m/Y',$date); ?></td>
		    		<td><?php echo $txn->type; ?></td>
					<td style="width: 120px"><?php echo $txn->ref; ?></td>
					<td class="dark" style="width: 120px; text-align: right"><?php echo $txn->debit ? number_format($txn->debit,2) : ''; ?></td>
					<td class="darker" style="width: 120px; text-align: right"><?php echo $txn->credit ? number_format($txn->credit,2) : ''; ?></td>
				</tr>
				<?php $x++; endforeach; endforeach; ?>
				<tr class="foot">
					<td colspan="3" style="text-align: right; font-weight: bold">Total Outstanding</td>
					<td class="dark" style="width: 120px; text-align: right; font-weight: bold"><?php if ($balance >= 0) echo number_format($balance,2) ?></td>
					<td class="darker" style="width: 120px; text-align: right; font-weight: bold"><?php if ($balance < 0) echo number_format(0 - $balance,2) ?></td>
				</tr>
			</tbody>
		</table>
		
		<table class="grid tab-related grid-data aging-payables" style="display:none">
			<tbody>
				<?php
					$tt0 = $tt30 = $tt60 = $tt90 = $tto90 = 0;
				?>

				<?php $x = 0; $day = 60 * 60 * 24; foreach ($payables as $doc): ?>
				
				<?php
					if (!$doc->due_date) $doc->due_date = $doc->date;
					
					$due_time = strtotime($doc->due_date);
					$t0 = $t30 = $t60 = $t90 = $to90 = 0;
					
					if ($due_time >= time()){
						$t0 = $doc->total_delivered ? $doc->total_delivered : $doc->total;
						$tt0 += $t0;
					} elseif ($due_time >= time() - ($day * 30)){
						$t30 = $doc->total_delivered ? $doc->total_delivered : $doc->total;
						$tt30 += $t30;
					} elseif ($due_time >= time() - ($day * 60)){
						$t60 = $doc->total_delivered ? $doc->total_delivered : $doc->total;
						$tt60 += $t60;
					} elseif ($due_time >= time() - ($day * 90)){
						$t90 = $doc->total_delivered ? $doc->total_delivered : $doc->total;
						$tt90 += $t90;
					} else {
						$to90 = $doc->total_delivered ? $doc->total_delivered : $doc->total;
						$tto90 += $tto90;
					}					
				?>
				<tr class="<?php echo $x%2 == 0 ? 'alt' : ''; ?>">
					<td style="width: 100px"><?php echo date('d/m/Y',strtotime($doc->date)); ?></td>
					<td>PO-<?php echo $doc->id; ?></td>
					<td style="width: 100px"><?php echo date('d/m/Y',strtotime($doc->due_date)); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($t0,2); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($t30,2); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($t60,2); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($t90,2); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($to90,2); ?></td>
				</tr>
				<?php $x++; endforeach; ?>
				<tr class="foot">
					<td colspan="3" style="text-align: right"><strong>TOTALS</strong></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tt0,2); ?></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tt30, 2); ?></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tt60, 2); ?></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tt90, 2); ?></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tto90, 2); ?></td>
					
				</tr>
			</tbody>		
		</table>
		
		<table class="grid tab-related grid-data aging-receivables" style="display:none">
			<tbody>
				<?php
					$tt0 = $tt30 = $tt60 = $tt90 = $tto90 = 0;
				?>
				<?php $x = 0; $day = 60 * 60 * 24; foreach ($receivables as $doc): ?>
				
				<?php
					if (!$doc->due_date) $doc->due_date = $doc->date;
					
					$due_time = strtotime($doc->due_date);
					$t0 = $t30 = $t60 = $t90 = $to90 = 0;
					
					if ($due_time >= time()){
						$t0 = $doc->total_received ? $doc->total_received : $doc->total;
						$tt0 += $t0;
					} elseif ($due_time >= time() - ($day * 30)){
						$t30 = $doc->total_received ? $doc->total_received : $doc->total;
						$tt30 += $t30;
					} elseif ($due_time >= time() - ($day * 60)){
						$t60 = $doc->total_received ? $doc->total_received : $doc->total;
						$tt60 += $t60;
					} elseif ($due_time >= time() - ($day * 90)){
						$t90 = $doc->total_received ? $doc->total_received : $doc->total;
						$tt90 += $t90;
					} else {
						$to90 = $doc->total_received ? $doc->total_received : $doc->total;
						$tto90 += $to90;
					}					
				?>
				<tr class="<?php echo $x%2 == 0 ? 'alt' : ''; ?>">
					<td style="width: 100px"><?php echo date('d/m/Y',strtotime($doc->date)); ?></td>
					<td>INV-<?php echo $doc->id; ?></td>
					<td style="width: 100px"><?php echo date('d/m/Y',strtotime($doc->due_date)); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($t0,2); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($t30,2); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($t60,2); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($t90,2); ?></td>
					<td style="width: 110px; text-align: right"><?php echo number_format($to90,2); ?></td>
				</tr>
				<?php $x++; endforeach; ?>
				<tr class="foot">
					<td colspan="3" style="text-align: right"><strong>TOTALS</strong></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tt0,2); ?></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tt30, 2); ?></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tt60, 2); ?></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tt90, 2); ?></td>
					<td style="width: 110px; text-align: right; font-weight: bold;"><?php echo number_format($tto90, 2); ?></td>
					
				</tr>
			</tbody>			
		</table>
		
		<?php endif; ?>
		
		
		<?php if ($this->user->has_permission('to_view_case','Contacts')) :?>
		<table class="grid grid_data tab-related cases">
	    	<tbody>
	    		<?php $x = 1; foreach ($cases as $case): $x++; ?>
	    		<tr rel="<?php echo $case->id; ?>" <?php if ($x%2==0) echo ' class="alt"'; ?>>
	    			<td style="width: 80px"><?php echo $case->log_date ? date('d/m/Y',strtotime($case->log_date)) : ''; ?></td>
	    			<td style="width: 80px;"><?php echo date('d/m/Y',strtotime($case->added_on)); ?></td>
	    			<td><?php echo $case->subject; ?></td>
	    			<td style="width: 100px;"><?php echo $case->added_by; ?></td>
	    			<td style="width: 100px"><?php echo $case->log_user; ?></td>
	    			<td style="width: 100px; text-align: center"><span class="case-<?php echo str_replace(' ','-',strtolower($case->status)); ?>"><?php echo $case->status; ?></span></td>
	    			<td style="width: 100px; text-align: center"><span class="case-<?php echo str_replace(' ','-',strtolower($case->log_status)); ?>"><?php echo $case->log_status; ?></span></td>
					<td style="width: 75px; padding: 0">
						<?php if ($this->user->has_permission('to_view_case','Contacts')): ?><a class="grid-action grid-action-view target_main" href="contacts/case_logs/<?php echo $case->id?>"><span>View</span></a><?php endif; ?>
						<?php if ($this->user->has_permission('to_edit_case','Contacts')): ?><a class="grid-action grid-action-edit target_main" href="contacts/edit_case/<?php echo $case->id?>"><span>Edit</span></a><?php endif; ?>
						<?php if ($this->user->has_permission('to_delete_case', 'Contacts')): ?><a class="grid-action grid-action-delete" href="contacts/delete_case/<?php echo $case->id?>/do"><span>Delete</span></a><?php endif; ?>
					</td>
	    		</tr>
	    		<?php endforeach; ?>
	    	</tbody>
		</table>
		<?php endif; ?>


	</div>
