<?php if (!$this->user->has_access('FnB')) die('You do not have the permissions to access this area.'); ?>

<script type="text/javascript">

cell_update_url = 'fnb/update_cell';

$(document).ready(function(){

	$('div.filter input').keypress(function(e){
		
		if (e.which == 13) filterItems();
	});
	
	$('div.filter select').keypress(function(e){
		if (e.which == 13) filterItems();
	});
	
	$('a.filter-btn').click(function(){
		filterItems();
	});


	var order = '';
	
	$('a.setup').click(function(){
		if ($(this).hasClass('started')){
			showDialog('loading','Saving Arrangement','Arrangement is being updated. Please wait...');
			$(this).removeClass('started').text('Setup Arrangement');

			$.ajax({
				url: base_url + 'fnb/save_arrangement',
				type: 'POST',
				data: order,
				success: function (html){
					$('table.grid_data').html(html);
					populateEvents();
					setTimeout("hideDialog('loading')",1000);
				}
			});
		} else {
			showDialog('ok','Setup Chart','Drag and drop account to arrange accounts and account headers.');
			$(this).addClass('started').text('Save Arrangement');
			$("table.grid_data").tableDnD({
				onDragClass: "selected",
				onDrop: function (table,row){
					order = $.tableDnD.serialize();
				}
			});
			
		}
	});
	
	$('input.frontend-show').click(function(){
		$(this).attr('disabled',true);
		if ($(this).attr('checked')) var val = 1;
		else var val = 0;
		
		var id = $(this).attr('id');
		
		var that = this;
		
		$.ajax({
			url: 'fnb/update_cell',
			type: 'post',
			data: 'field=frontend_show&val='+val+'&id='+id,
			success: function(){
				$(that).removeAttr('disabled');
			}
		})
	})
	
	
});

function filterItems(){
	var sku = $('input.filter-sku').val();
	var name = $('input.filter-name').val();
	var category = $('select.filter-category').val();
	var subcategory = $('select.filter-subcategory').val();
	
	$('table.grid_data tbody').html('<td colspan="7" style="text-align: center; padding: 20px"><img src="'+base_url+'images/loading.gif" /> Loading</td>');
	
	
	$.ajax({
		url: base_url + 'fnb/items_filter',
		type: 'POST',
		data: 'sku='+sku+'&name='+name+'&category='+category+'&subcategory='+subcategory,
		success: function (result){
			$('div.main_full').html(result);
			populateEvents();
			
			$('input.frontend-show').click(function(){
				$(this).attr('disabled',true);
				if ($(this).attr('checked')) var val = 1;
				else var val = 0;
				
				var id = $(this).attr('id');
				
				var that = this;
				
				$.ajax({
					url: 'fnb/update_cell',
					type: 'post',
					data: 'field=frontend_show&val='+val+'&id='+id,
					success: function(){
						$(that).removeAttr('disabled');
					}
				})
			})
		}
	});
	
}



</script>

<div id="dashboard-container">

	<div id="global-sidebar">
		<ul id="global-sidebar-list">
			<li class="current"><a href="fnb/items" class="fnb">Menu Items</a></li>
			<?php if ($this->user->has_permission('to_view_category','FnB')): ?>
				<li><a href="fnb/categories" class="categories">Categories</a></li>
				<li><a href="fnb/subcategories" class="subcategories">Subcategories</a></li>
			<?php endif; ?>
			<?php if ($this->user->has_permission('to_view_printer_mapping','FnB')): ?>
				<li><a href="fnb/printers" class="printers">Printer Mapping</a></li>
				<li><a href="fnb/ss_terminal" class="printers">Self-Service Terminal</a></li>
			<?php endif; ?>
		</ul>
	</div>
	<div id="global-content">
		<div class="toolbar">
			<h3 class="grid-title">
				<a href="fnb/item_add" class="v-btn target_main float_right" style="padding:0 10px; font-weight: normal">New Item</a>
				<a class="v-btn setup" style="float:right; padding:0 10px; font-weight: normal; margin-right: 5px">Setup Arrangement</a>				
				Items
			</h3>

			<div class="global-tabs" style="padding: 5px; font-size: 10pt">
				<a class="v-btn show-filter-controls icon-search">Search</a>
			</div>
	
			<div class="modal-filter-form filter" style="font-size: 10pt;">
				<div class="triangle"></div>
				<table>
					<tr>
						<td>SKU</td>
						<td><input type="text" name="sku" class="v-text filter-sku" style="width: 130px; margin-right: 10px" /></td>
					</tr>
					<tr>
						<td>Item Name</td>
						<td><input type="text" name="name" class="v-text filter-name" style="width: 130px; margin-right: 10px" /></td>
					</tr>
					<tr>
						<td>Category</td>
						<td><?php echo form_dropdown('category', $categories_dropdown, '', 'class="v-dropdown filter-category" style="margin-right: 10px; font-size: 10pt; width: 130px"'); ?></td>
					</tr>
					<tr>
						<td>Subcategory</td>
						<td><?php echo form_dropdown('subcategory', $subcategories_dropdown, '', 'class="v-dropdown filter-subcategory" style="margin-right: 10px; font-size: 10pt; width: 130px"'); ?></td>
					</tr>
				</table>
				<hr />
				<a class="v-btn filter-btn">Filter</a>
			</div>
			<table class="grid">
				<thead>
					<tr>
						<th rel="8" style="width: 30px">Show</th>
						<th rel="1" class="sortable" style="width: 100px">Item SKU</th>
						<th rel="2" class="sortable" style="width: 150px">Item Name</th>
						<th rel="6" class="sortable">Front-end Name</th>
						<th rel="3" class="sortable" style="width: 120px">Category</th>
						<th rel="4" class="sortable" style="width: 120px">Subcategory</th>
						<th rel="7" class="sortable" style="width: 120px">Front-end Subcategory</th>
						<th rel="5" class="sortable" style="width: 100px">Price (<?php echo $this->system->config('currency'); ?>)</th>
						<th class="grid-action" style="text-align: center; width: 75px"><img src="<?=base_url()?>images/email-action.gif" alt="Action"></th>
						<th style="width: 15px; padding: 0;"></th>
					</tr>
				</thead>
			</table>
		</div>

		<div class="main_full">
			<table class="grid grid_data">
    			<?php
    				if ($this->user->has_permission('to_edit_menu_item','FnB')) $editable = 'editable';
    			?>    			

    			<tbody>
    				<?php $x=0; foreach ($items as $item): ?>
    				<tr rel="<?php echo $item->id; ?>" <?php echo $x%2 == 0 ? 'class="alt list-item"' : 'class="list-item"'; ?> id="<?php echo $item->id; ?>" rel="<?php echo $item->id; ?>">
    					<td rel="8" style="width: 30px; text-align: center"><input type="checkbox" id="<?php echo $item->id; ?>" value="1" class="frontend-show" <?php if ($item->frontend_show == 1) echo 'checked="checked"'; ?> /></td>
    					<td rel="1" field="sku" class="<?php echo $editable; ?>" style="width: 100px"><?php echo $item->sku; ?></td>
    					<td rel="2" field="name" class="<?php echo $editable; ?>" style="width: 150px"><?php echo $item->name; ?></td>
    					<td rel="6" field="frontend_name" class="<?php echo $editable; ?>"><?php echo $item->frontend_name; ?></td>
    					<td rel="3" field="category" class="<?php echo $editable; ?>" style="width: 120px"><?php echo $item->category; ?></td>
    					<td rel="4" field="subcategory" class="<?php echo $editable; ?>" style="width: 120px"><?php echo $item->subcategory; ?></td>
    					<td rel="7" field="frontend_subcategory" class="<?php echo $editable; ?>" style="width: 120px"><?php echo $item->frontend_subcategory; ?></td>
    					<td rel="5" field="price" type="v-number-decimal" class="<?php echo $editable; ?>" style="text-align: right; width: 100px"><?php echo $item->item_price; ?></td>

    					<td style="width: 75px">
    						<?php if ($this->user->has_permission('to_view_menu_item','FnB')): ?><a class="grid-action grid-action-view target_main" href="fnb/item_view/<?=$item->id?>"><span>View</span></a><?php endif; ?>
    						<?php if ($this->user->has_permission('to_edit_menu_item','FnB')): ?><a class="grid-action grid-action-edit target_main" href="fnb/item_edit/<?=$item->id?>"><span>Edit</span></a><?php endif; ?>
    						<?php if ($this->user->has_permission('to_delete_menu_item','FnB')): ?><a class="grid-action grid-action-delete" href="fnb/item_delete/<?=$item->id?>"><span>Delete</span></a><?php endif; ?>
    					</td>
    				</tr>
    				<?php $x++; endforeach; ?>
    			</tbody>
    		</table>
		</div>
	</div>
</div>