<?php
	
$purchase_tax_codes = array (
	''		=> 'Select',
	'TX'	=> 'TX - Purchases with GST incurred at 6% and directly attributable to taxable supplies',
	'IM'	=> 'IM - Import of goods with GST incurred',
	'IS'	=> 'IS - Imports under special scheme with no GST incurred (e.g. Approved Trader Scheme, ATMS Scheme)',
	'BL'	=> 'BL - Purchases with GST incurred but not claimable (Disallowance of Input Tax) (e.g. medical expenses for staff)',
	'NR'	=> 'NR - Purchase from non GST-registered supplier with no GST incurred',
	'ZP'	=> 'ZP - Purchase from GST-registered supplier with no GST incurred. (e.g. supplier provides transportation of goods that qualify as international services)',
	'EP'	=> 'EP - Purchases exempted from GST. E.g. purchase of residential property or financial services',
	'OP'	=> 'OP - Purchase transactions which is out of the scope of GST legislation (e.g. purchase of goods overseas)',
	'TX-E43'=> 'TX-E43 - Purchase with GST incurred directly attributable to incidental exempt supplies',
	'TX-N43'=> 'TX-N43 - Purchase with GST incurred directly attributable to non-incidental exempt supplies',
	'TX-RE'	=> 'TX-RE - Purchase with GST incurred that is not directly attributable to taxable or exempt supplies',
	'GP'	=> 'GP - Purchase transactions which disregarded under GST legislation (e.g. purchase within GST group registration)'	
);

$supply_tax_codes = array (
	''		=> 'Select',
	'SR'	=> 'SR - Standard-rated supplies with GST Charged',
	'ZRL'	=> 'ZRL - Local supply of goods or services which are subject to zero rated supplies',
	'ZRE'	=> 'ZRE - Exportation of goods or services which are subject to zero rated supplies',
	'ES43'	=> 'ES43 - Incidental Exempt supplies',
	'GS'	=> 'GS - Disregarded supplies'
);
	
	
?>

<script type="text/javascript">


function readyAdd(status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('div.notice').html('<p class="v-success">Item has been updated.</p>');
		form_warning = false;
	} else if (status == 0) {
		$('div.notice').html('<p class="v-warning">Item SKU already exists.</p>');
		$('div.main_full').show();
		$('div.status').hide();
	} 
}

$(document).ready(function(){

	var optionCell = $('<tr class="four option"><td class="label option">Option <span class="red">*</span></td><td class="input"><input type="text" name="option[]" class="option v-text" /></td><td class="label">Price <span class="red">*</span></td><td class="input"><input type="text" name="price[]" class="v-text" /></td></tr>');
	$(optionCell).find('td.option').prepend('<a class="v-btn cancel">Remove</a> ');
	$(optionCell).find('input.option').val('');
	
	var customerOptionCell = $('<tr class="four option"><td class="label option">Option <span class="red">*</span></td><td class="input"><input type="text" name="customer_option[]" class="option v-text" /></td><td class="label">Price <span class="red">*</span></td><td class="input"><input type="text" name="customer_price[]" class="v-text" /></td></tr>');
	$(customerOptionCell).find('td.option').prepend('<a class="v-btn cancel">Remove</a> ');
	$(customerOptionCell).find('input.option').val('');


	$('a.create').click(function(event){
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('a.cancel').live('click',function(){
		$(this).parents('tr').remove();
	});

	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});

	
	$('a.add-option').click(function(){
		$('tbody.options').append($(optionCell).clone());
	});

	$('a.customer-add-option').click(function(){
		$('tbody.customer-options').append($(optionCell).clone());
	});
	

	$('input[name=product_search]').keypress(function(e){
		var code = (e.keyCode ? e.keyCode : e.which);
		if (code == 13){
			var t = $('#product-search select[name=st]').val();
			var q = $(this).val();
			var cid = $('select[name=contact]').val();
			

			$('#product-search div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
			$.ajax({
				type: "POST",
				url: base_url + 'fnb/search_product/' + q + '/' + t + '/' + cid,
				success: function (html){
					$('#product-search div.modal-search-result table.grid_data').html(html);
					$('select.item-price-select').change();
				}			
			}); 
		}
	});
	
	$('a.product_search').click(function(){
		var t = $('#product-search select[name=st]').val();
		var q = $('input[name=product_search]').val();
		var cid = $('select[name=contact]').val();
			

		$('#product-search div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
		$.ajax({
			type: "POST",
			url: base_url + 'fnb/search_product/' + q + '/' + t + '/' + cid,
			success: function (html){
				$('#product-search div.modal-search-result table.grid_data').html(html);
				$('select.item-price-select').change();
			}			
		}); 
	});
	
	$('select.product-search-type').keypress(function(e){
		if (code == 13){
			$('a.product_search').click();
		}		
	});
	
	$('a.add-product').click(function(event){
		event.preventDefault();
		showModalForm('product-search');
	});
		
	$('a.search-product-done').click(function(event){
		event.preventDefault();
		hideModalForm('product-search');
		
		var tr = $('input.product-item:checked').parents('tr');
		console.log(tr);
		
		$('input.linked_with').val($(tr).attr('name'));
		$('input.linked_id').val($(tr).attr('rel'));
		$('input[name=name]').val($(tr).attr('name'));
		$('input[name=sku]').val($(tr).attr('sku'));
		
		$('select[name=category]').val($(tr).find('td.category').text())
		$('select[name=subcategory]').val($(tr).find('td.subcategory').text())
		$('input[name=subcategory_other]').val($(tr).find('td.subcategory').text());
		$('input[name=category_other]').val($(tr).find('td.category').text());
		$('input[name=item_price]').val($(tr).find('span.selling-price').text());
	});
	
	$('a.clear-link').click(function(){
		$('input.linked_with').val('');
		$('input.linked_id').val('');
	});

	$('input.menu_sku').keypress(function(e){
		var sku = $(this).val();
		if (e.which == 13){
			$('div.order-options').html('<p><img src="images/loading.gif" /> Loading...</p>');
			$.ajax({
				url: 'fnb/get_item_options',
				type: 'post',
				data: 'sku='+sku,
				success: function (html){
					$('div.order-options').html(html);
				}
			})
		}
	});
	
	$('input.customer_menu_sku').keypress(function(e){
		var sku = $(this).val();
		if (e.which == 13){
			$('div.order-options').html('<p><img src="images/loading.gif" /> Loading...</p>');
			$.ajax({
				url: 'fnb/get_customer_item_options',
				type: 'post',
				data: 'sku='+sku,
				success: function (html){
					$('div.customer-order-options').html(html);
				}
			})
		}
	});
	
	$('input.options').click(function(){
		if ($(this).attr('checked')){
			$('div.order-options').show();
			$('span.order-options').show();
		} else {
			$('div.order-options').hide();
			$('span.order-options').hide();			
		}
	});
	
	if ($('input.options').attr('checked')){
    	$('div.order-options').show();
    	$('span.order-options').show();
    } else {
    	$('div.order-options').hide();
    	$('span.order-options').hide();			
    }
    
    $('input.customer-options').click(function(){
		if ($(this).attr('checked')){
			$('div.customer-order-options').show();
			$('span.customer-order-options').show();
		} else {
			$('div.customer-order-options').hide();
			$('span.customer-order-options').hide();			
		}
	});
	
	if ($('input.customer-options').attr('checked')){
    	$('div.customer-order-options').show();
    	$('span.customer-order-options').show();
    } else {
    	$('div.customer-order-options').hide();
    	$('span.customer-order-options').hide();			
    }



})

</script>
	<div class="status">
	
	</div>
	
	<div id="product-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Item Search</h3>
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label" style="width: 50px; padding: 0;">Search</label>
					<td><input type="text" name="product_search" class="text" /> in <?=form_dropdown('st',array('SKU'=>'SKU','Product Name'=>'Product Name'))?> <a class="v-btn product_search">Search</a></td>
				</tr>
			</table>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">Product Name</th>
						<th class="sortable" rel="2" style="width: 100px">Category</th>
						<th class="sortable" rel="3" style="width: 100px">Subcategory</th>
						<th class="sortable" rel="4" style="width: 60px">In Stock</th>
						<th class="sortable" rel="5" style="width: 100px">Price (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 14px; padding:0"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll">
				<table class="grid grid_data">
					
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;"><a class="v-dbtn search-product-done">Done</a></p>
		</div>
	</div>
	
	<div class="toolbar">
		<h3 class="grid-title"><a href="fnb/items" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn target_main">Back</a>Edit Item &raquo; <?php echo $item->name; ?></h3>
		<div class="global-tabs" style="padding: 5px">
			<a class="v-btn create">Save</a>
		</div>

	</div>		
		
	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">

		<form class="insert" method="post" action="<?=base_url()?>fnb/item_edit/<?php echo $item->id; ?>/do" target="postframe">
			<div class="notice" style="margin-bottom: 15px">
			
			</div>
			<h3>Item Information <a class="add-product v-btn" style="margin-left: 5px; margin-top: -3px">Link with Inventory Item</a></h3>
			<p><span class="red">*</span> Mandatory fields</p>

			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Menu Item Name <span class="red">*</span></td>
						<td class="input"><input value="<?php echo $item->name; ?>" type="text" name="name" class="v-text mandatory" /></td>
					</tr>
					<tr>
						<td class="label"><a class="clear-link v-btn">Clear</a> Linked with</td>
						<td class="input"><input type="text" name="linked_with" class="v-text linked_with" readonly /></td>
					</tr>
					<tr>
						<td class="label">Linked ID</td>
						<td class="input"><input type="text" name="si_item_id" class="v-text linked_id" readonly /></td>
					</tr>
					<tr>
						<td class="label">Category <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('category',$categories_dropdown, $item->category, 'class="v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Other Category</td>
						<td class="input"><input type="text" name="category_other" class="v-text" /></td>
					</tr>
					<tr>
						<td class="label">Subcategory <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('subcategory',$subcategories_dropdown,$item->subcategory, 'class="v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Other Subcategory</td>
						<td class="input"><input type="text" name="subcategory_other" class="v-text" /></td>
					</tr>
					<tr>
						<td class="label">Item Code <span class="red">*</span></td>
						<td class="input"><input value="<?php echo $item->sku; ?>" type="text" name="sku" class="v-text mandatory" /></td>
					</tr>
					<tr>
						<td class="label">Item Cost <span class="red">*</span></td>
						<td class="input"><input value="<?php echo $item->cost; ?>" type="text" name="cost" class="v-text mandatory" /></td>
					</tr>

					<tr>
						<td class="label">Item Price <span class="red">*</span></td>
						<td class="input"><input value="<?php echo $item->item_price; ?>" type="text" name="item_price" class="v-text mandatory" /></td>
					</tr>
					<tr>
						<td class="label">Enter Price</td>
						<td class="input"><input type="checkbox" name="enter_price" value="1" <?php if ($item->enter_price) echo 'checked="checked"'; ?> /></td>
					</tr>
					<tr>
						<td class="label">Printer Override</td>
						<td class="input"><input type="text" class="v-text" name="printer" value="<?php echo $item->printer; ?>" /></td>
					</tr>

				</tbody>
			</table>
			
			
			<br />
			
			<h3>Tax</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Purchase Tax Code</td>
						<td class="input"><?php echo form_dropdown('purchase_tax_code', $purchase_tax_codes,$item->purchase_tax_code,'class="v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Purchase Taxable</td>
						<td class="input"><input <?php if ($item->purchase_taxable) echo 'checked="checked"'; ?> type="checkbox" name="purchase_taxable" value="1" /> Yes</td>
					</tr>
					<tr>
						<td class="label">Supply Tax Code</td>
						<td class="input"><?php echo form_dropdown('supply_tax_code', $supply_tax_codes,$item->supply_tax_code,'class="v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Supply Taxable</td>
						<td class="input"><input <?php if ($item->supply_taxable) echo 'checked="checked"'; ?> type="checkbox" name="supply_taxable" value="1" /> Yes</td>
					</tr>

				</tbody>
			</table>
			
			<br /><br />
			
			<?php 			
				$prices = json_decode($item->price);
				$options = json_decode($item->options);
			?>			
			
			<h3><input type="checkbox" value="1" name="has_customer_options" class="options" <?php if ($item->has_options) echo 'checked="checked"'; ?> /> Order Option and Price <span class="order-options" style="display:none"><a class="v-btn add-option" style="margin-left: 5px; margin-top: -3px">Add Option</a> <small style="font-weight: normal">or get from other item. Menu SKU</small> <input type="text" name="menu_sku" class="menu_sku v-text" style="width: 100px" /></span></h3>
			<div class="order-options">
				<table class="general-form">
					<tbody class="options">
						<?php for ($i = 0; $i < count($prices); $i++): ?>
						<tr class="four option">
							<td class="label option"><a class="v-btn cancel">Remove</a> Option</td>
							<td class="input"><input type="text" name="option[]" value="<?php echo $options[$i]; ?>" class="option v-text" /></td>
							<td class="label">Price <span class="red">*</span></td>
							<td class="input"><input type="text" name="price[]" value="<?php echo $prices[$i]; ?>" class="v-text" /></td>
						</tr>
						<?php endfor; ?>
					</tbody>
				</table>
			</div>
			
			<br /><br />
			
			<?php 			
				$prices = json_decode($item->customer_price);
				$options = json_decode($item->customer_options);
			?>			

			
			<h3><input type="checkbox" value="1" name="has_options" class="customer-options"  <?php if ($item->has_customer_options) echo 'checked="checked"'; ?> /> Customer Order Option and Price 	<span style="display:none" class="customer-order-options"><a class="v-btn customer-add-option" style="margin-left: 5px; margin-top: -3px">Add Option</a> <small style="font-weight: normal">or get from other item. Menu SKU</small> <input type="text" name="customer_menu_sku" class="customer_menu_sku v-text" style="width: 100px" /></span></h3>
			<div class="customer-order-options" style="display:none">
				<table class="general-form">
					<tbody class="customer-options">
						<?php for ($i = 0; $i < count($prices); $i++): ?>
						<tr class="four option">
							<td class="label option"><a class="v-btn cancel">Remove</a> Option</td>
							<td class="input"><input type="text" name="customer_option[]" value="<?php echo $options[$i]; ?>" class="option v-text" /></td>
							<td class="label">Price <span class="red">*</span></td>
							<td class="input"><input type="text" name="customer_price[]" value="<?php echo $prices[$i]; ?>" class="v-text" /></td>
						</tr>
						<?php endfor; ?>
					</tbody>
				</table>
			</div>
			
			<br /><br />
			
			<h3>Description &amp; Remarks</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Description</td>
						<td class="input"><?php echo $item->description; ?></td>
					</tr>
					<tr>
						<td class="label">Remarks</td>
						<td class="input"><textarea name="remarks" class="v-textarea"><?php echo $item->remarks; ?></textarea></td>
					</tr>
				</tbody>
			</table>
			
		
		</form>
		</div>
	</div>
