	<table class="grid grid_data">
		<thead>
			<tr>
				<th>Gross Salary From</th>
				<th>Gross Salary To</th>
				<th>Deduction Amount</th>
				<th>Type</th>
				<th>Other Condition</th>
				<th style="width: 110px"></th>
			</tr>
		</thead>
		<tbody>
			<tr class="deduction">
				<td><input style="background: none; width: 100%" placeholder="Enter gross salary from range" name="gross_from" value="<?php echo $d->gross_from; ?>" class="v-text" /></td>
				<td><input style="background: none; width: 100%" placeholder="Enter gross salary to range" name="gross_to" value="<?php echo $d->gross_to; ?>" class="v-text" /></td>
				<td><input style="background: none; width: 100%" placeholder="Enter deduction amount" name="deduction_amount" value="<?php echo $d->deduction_amount; ?>" class="v-text save" /></td>
				<td><input style="background: none; width: 100%" placeholder="Enter type of deduction as per payslip field name" name="type" value="<?php echo $current_type; ?>" class="v-text save" /></td>
				<td><input style="background: none; width: 100%" placeholder="Enter other applicable conditions" name="conditions" value="<?php echo $d->conditions; ?>" class="v-text save" /></td>
				<td style="text-align: center"><a class="v-btn save">Save</a></td>
			</tr>
			<?php foreach ($deductions as $d): $i++; ?>
			<tr class="deduction <?php echo $i%2 != 0 ? 'alt' : ''; ?>" rel="<?php echo $d->id; ?>">
				<td><input style="background: none; width: 100%" readonly name="gross_from" value="<?php echo $d->gross_from; ?>" class="v-text" /></td>
				<td><input style="background: none; width: 100%" readonly name="gross_to" value="<?php echo $d->gross_to; ?>" class="v-text" /></td>
				<td><input style="background: none; width: 100%" readonly name="deduction_amount" value="<?php echo $d->deduction_amount; ?>" class="v-text save" /></td>
				<td><input style="background: none; width: 100%" readonly name="type" value="<?php echo $d->type; ?>" class="v-text save" /></td>
				<td><input style="background: none; width: 100%" readonly name="conditions" value="<?php echo $d->conditions; ?>" class="v-text save" /></td>
				<td style="text-align: center">
					<a class="v-btn delete">Delete</a>
					<a class="v-btn edit">Edit</a>
				</td>
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	
<?php echo form_dropdown('filter_type', $types, $current_type, 'class="filter-type"'); ?>
	
<script type="text/javascript">

$(document).ready(function(){
	$('.deduction-filter').html('Filter by Type ');
	$('.deduction-filter').append($('select.filter-type'));
	
	$('select.filter-type').change(function(){
		loadDeductionTable();
	})
	
	$('input.save').keypress(function(e){
		if (e.keyCode == 13){
			$(this).parents('tr').find('a.save').click();
			$(this).parents('tr').find('a.edit').click();
		}
	})
	
	$('a.save').click(function(){
		var tr = $(this).parents('tr');
		data = 'gross_from='+encodeURIComponent($(tr).find('input[name=gross_from]').val());
		data += '&gross_to='+encodeURIComponent($(tr).find('input[name=gross_to]').val());
		data += '&deduction_amount='+encodeURIComponent($(tr).find('input[name=deduction_amount]').val());
		data += '&type='+encodeURIComponent($(tr).find('input[name=type]').val());
		data += '&conditions='+encodeURIComponent($(tr).find('input[name=conditions]').val());
		$(this).text('Saving');
		$.ajax({
			url: 'hr/ajax/save_deduction',
			type: 'post',
			data: data,
			success: function(){
				loadDeductionTable();
			}
		})
	})
	
	$('a.delete').click(function(){
		var id = $(this).parents('tr').attr('rel');
		showDialog('yesno','Delete','Are you sure you want to delete this deduction record?',function(){
			$.ajax({
				url: 'hr/ajax/delete_deduction',
				type: 'post',
				data: 'id='+id,
				success: function(){
					loadDeductionTable();
				}
			})
		})
	})
	
	$('input').dblclick(function(){
		if ($(this).parents('tr').find('.edit').text() == 'Edit'){
			$(this).parents('tr').find('.edit').click();
		}
	})
	
	$('a.edit').click(function(){
		if ($(this).text() == 'Save'){
			var tr = $(this).parents('tr');
			var id = $(tr).attr('rel');
			data = 'gross_from='+encodeURIComponent($(tr).find('input[name=gross_from]').val());
			data += '&gross_to='+encodeURIComponent($(tr).find('input[name=gross_to]').val());
			data += '&deduction_amount='+encodeURIComponent($(tr).find('input[name=deduction_amount]').val());
			data += '&type='+encodeURIComponent($(tr).find('input[name=type]').val());
			data += '&conditions='+encodeURIComponent($(tr).find('input[name=conditions]').val());
			data += '&id='+encodeURIComponent(id);
			$(this).text('Saving');
			$.ajax({
				url: 'hr/ajax/save_deduction',
				type: 'post',
				data: data,
				success: function(){
					loadDeductionTable();
				}
			})
		} else {
			$(this).text('Save');
			$(this).parents('tr').find('input').removeAttr('readonly');
		}
	})
})


	
</script>