
		<div class="pay-grade">
			<h3>Employee Information</h3>
			<table class="general-form">
				<tr class="four">
					<td class="label">Position</td>
					<td class="input"><?php echo $employee->employment->job_title; ?></td>
					<td class="label">Employment Date</td>
					<td class="input"><?php echo date('d/m/Y', strtotime($employee->employment->date)); ?></td>
					
					
				</tr>
				<tr class="four">
					<td class="label">Pay Frequency</td>
					<td class="input"><?php echo $employee->employment->pay_frequency; ?></td>
					<td class="label">Basic Salary</td>
					<td class="input basic_salary"><?php echo $employee->employment->basic_salary; ?></td>
				</tr>
				<tr class="four">
					<td class="label">Minimum Salary</td>
					<td class="input"><?php echo $employee->employment->minimum_salary; ?></td>
					<td class="label">Maximum Salary</td>
					<td class="input"><?php echo $employee->employment->maximum_salary; ?></td>
				</tr>
				<tr class="four">
					<td class="label">Employment Type</td>
					<td class="input"><?php echo $employee->employment->type; ?></td>
					<td class="label">Employment Status</td>
					<td class="input"><?php echo $employee->employment->status; ?></td>
				</tr>
				
				
			</table>
		</div>
		
		<div class="last-svs">
			<h3>Previous Pay Slip</h3>
			<table class="grid">
				<thead>
					<tr>
						<th style="width: 100px">Date</th>
						<th>Earnings</th>
						<th>Deductions</th>
						<th style="width: 100px">Net Salary</th>
						<th>Other</th>
					</tr>
				</thead>
				<tbody>
				<?php foreach ($svs as $sv): $total_earnings = 0; $total_deductions = 0;?>
					<tr>
						<td style="vertical-align: top"><?php echo date('d/m/Y',strtotime($sv->datetime)); ?></td>
						<td style="vertical-align: top">
							<table class="grid">
								<?php foreach ($sv->earnings as $earning): ?>
								<tr>
									<td><?php echo $earning->description; ?></td>
									<td style="text-align: right"><?php echo number_format($earning->amount,2); ?></td>
								</tr>
								<?php $total_earnings += $earning->amount; endforeach; ?>
								<tr style="border-top: 1px solid #555">
									<td><strong>Total Earnings</strong></td>
									<td style="text-align: right"><strong><?php echo number_format($total_earnings,2); ?></strong></td>
								</tr>
							</table>
						</td>
						<td style="vertical-align: top">
							<table class="grid">
								<?php foreach ($sv->deductions as $deduction): ?>
								<tr>
									<td><?php echo $deduction->description; ?></td>
									<td style="text-align: right"><?php echo $deduction->amount; ?></td>
								</tr>
								<?php $total_deductions += $deduction->amount; endforeach; ?>
								<tr style="border-top: 1px solid #555">
									<td><strong>Total Deductions</strong></td>
									<td style="text-align: right"><strong><?php echo number_format($total_deductions,2); ?></strong></td>
								</tr>
							</table>
						</td>
						<td style="text-align: center; vertical-align: top">
							<strong><?php echo number_format($total_earnings - $total_deductions,2); ?></strong>
						</td>
						<td style="vertical-align: top">
							<table class="grid">
								<?php foreach ($sv->other as $other): ?>
								<tr>
									<td><?php echo $other->description; ?></td>
									<td style="text-align: right"><?php echo $other->amount; ?></td>
								</tr>
								<?php endforeach; ?>
							</table>
						</td>
					</tr>
				<?php endforeach; ?>
				<?php if (!count($svs)): ?>
					<tr>
						<td colspan="5"><i>No previous pay slip found.</i></td>
					</tr>
				<?php endif; ?>
				</tbody>
			</table>
		</div>
		
	
		<div style="margin-top: 20px" class="timesheet">
			<h3>Timesheet</h3>
			<table class="grid">
				<thead>
					<tr>
						<th style="width: 300px">Clock In</th>
						<th style="width: 300px">Clock Out</th>
						<th>Duration</th>
						<th style="width: 15px; padding: 0;"></th>
					</tr>
				</thead>
			</table>
			<div style="height: 100px; overflow-y: scroll;">
			<table class="grid grid_data">
				<tbody>
					<?php $x = 0; foreach ($cico as $ci):
				
					if ($ci->check_out){
						$time_duration = strtotime($ci->check_out) - strtotime($ci->check_in);
						$total_duration += $time_duration;
						$hours = floor($time_duration / (60 * 60));
						$minutes = floor(($time_duration / 60) - ($hours * 60));
						if ($hours){
							$duration = $hours . ' hour(s) ' . $minutes . ' minute(s)';
						} else {
							$duration = $minutes . ' minute(s)';
						}
					}
					?>
					<tr <?php echo $x%2 == 0 ? 'class="alt"' : ''; ?>>
						<td style="width: 300px"><?php echo date('l, d M h:iA ', strtotime($ci->check_in)); ?></td>
						<td style="width: 300px"><?php echo $ci->check_out ? date('l, d M h:iA', strtotime($ci->check_out)) : ''; ?></td>
						<td><?php echo $duration; ?></td>
					</tr>
					<?php $x++; endforeach; ?>
					<?php
						$hours = floor($total_duration / (60 * 60));
						$minutes = floor(($total_duration / 60) - ($hours * 60));
						if ($hours){
							$duration = $hours . ' hour(s) ' . $minutes . ' minute(s)';
						} else {
							$duration = $minutes . ' minute(s)';
						}
					?>
					<?php if (!count($cico)): ?>
					<tr>
						<td colspan="3"><i>No timesheet records found.</i></td>
					</tr>
				<?php endif; ?>
				</tbody>
			</table>
			</div>
			<table class="grid">
				<tfoot>
					<tr class="foot">
						<td colspan="2" style="width: 600px; text-align: right; font-weight: bold">Total Work Hours</td>
						<td><strong><?php echo $duration; ?></strong></td>
					</tr>
				</tfoot>
			</table>
			
			<h3 style="margin-top: 20px">Leave</h3>
			
			<table class="grid">
				<thead>
					<tr>
						<th>Leave</th>
						<th>From</th>
						<th>To</th>
						<th>Status</th>
					</tr>
				</thead>
				<tbody>
					<?php $x = 0; foreach ($leaves as $leave): ?>
					<tr <?php echo $x%2 == 0 ? 'class="alt"' : ''; ?>>
						<td><?php echo $leave->type; ?></td>
						<td><?php echo date('l, d M Y', strtotime($leave->from)); ?></td>
						<td><?php echo date('l, d M Y', strtotime($leave->to)); ?></td>
						<td><?php echo $leave->status; ?></td>
					</tr>
					<?php $x++; endforeach; ?>
					<?php if (!count($leaves)): ?>
					<tr>
						<td colspan="4"><i>No leave taken</i></td>
					</tr>
					<?php endif; ?>
				</tbody>
			</table>
		</div>