<script type="text/javascript">

var fieldID = '';

function readyPost(action,status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		$('table.alloc tbody tr').remove();
		showDialog('ok','New Vacancy','Job vacancy has been added successfully.');
	} else {
		showDialog('ok','Error','There has been an error adding the job vacancy.');
		$('div.main_full').show();
		$('div.status').hide();
	}
}


$(document).ready(function(){
	$('a.submit_btn').click(function(event){
		$('form.config').submit();
		event.preventDefault();
	});
	
	$('div.global-tabs li a').click(function(){
		$('.tab-related').hide();
		var current = $(this).attr('href');
		$('.'+current).show();
	});
	
	
	$('a.add-field').click(function(){
		showModalForm('add-field');
	});
		
	$('a.discard-field').click(function(){
		hideModalForm('add-field');
	});

	$('a.discard-update-field').click(function(){
		hideModalForm('update-field');
	});
	
	$('a.edit-field').live('click',function(){

		fieldID = $(this).attr('rel');
		
		var name 		= $(this).parents('tr').find('td.name').text();
		var field_name 	= $(this).parents('tr').find('td.field-name').text();
		var type		= $(this).parents('tr').find('td.type').attr('value');
		var percent		= $(this).parents('tr').find('td.percent').text();
		
		
		$('#update-field input.name').val(name);
		$('#update-field input.field-name').val(field_name);
		$('#update-field select.type').val(type);
		$('#update-field input.percent').val(percent == 'N/A' ? '' : percent);
		

		
		showModalForm('update-field');
		
	});
	
	$('a.update-field').click(function(){

		var name 		= $('#update-field input.name').val();
		var field_name 	= $('#update-field input.field-name').val();
		var type		= $('#update-field select.type').val();
		var percent		= $('#update-field input.percent').val();
		
		$.ajax({
			url: base_url + 'hr/ajax/update_sv_field',
			type: 'post',
			data: 'name='+name+'&field_name='+field_name+'&type='+type+'&percent='+percent+'&id='+fieldID,
			success: function (res){
				if (res == 'exists'){
					showDialog('ok','Form Error','Field name already exists');
				} else {
					hideModalForm('update-field');
					
					if (type == 'Add') var typeName = 'Earning';
					if (type == 'Deduct') var typeName = 'Deduction';
					if (type == 'BDeduct') var typeName = 'Basic Deduction';
					if (type == 'Null') var typeName = 'Other';
					
					if (!percent) percent = 'N/A';
					
					var html = '<tr>	\
						<td class="name">'+name+'</td>	\
						<td class="field-name">'+field_name+'</td>	\
						<td class="type">'+typeName+'</td>	\
						<td class="percent" style="text-align:right">'+percent+'</td>	\
						<td style="width: 50px; padding: 0">	\
							<a class="grid-action grid-action-edit prevent-default edit-field" rel="'+res+'"><span>Edit</span></a>	\
							<a class="grid-action grid-action-delete" href="hr/delete/'+res+'>"><span>Delete</span></a>	\
						</td></tr>';
												
					$('a.edit-field[rel='+fieldID+']').parents('tr').replaceWith($(html));
					
					$('table.fields tbody tr').removeClass('alt');
					$('table.fields tbody tr:even').addClass('alt');
				}
			}
			
		})

	
	})
	
	
	$('a.save-field').click(function(){
	
		var name 		= $('#add-field input.name').val();
		var field_name 	= $('#add-field input.field-name').val();
		var type		= $('#add-field select.type').val();
		var percent		= $('#add-field input.percent').val();
		

		$.ajax({
			url: base_url + 'hr/ajax/save_sv_field',
			type: 'post',
			data: 'name='+name+'&field_name='+field_name+'&type='+type+'&percent='+percent,
			success: function (res){
				if (res == 'exists'){
					showDialog('ok','Form Error','Field name already exists');
				} else {
					hideModalForm('add-field');
					
					if (type == 'Add') var typeName = 'Earning';
					if (type == 'Deduct') var typeName = 'Deduction';
					if (type == 'BDeduct') var typeName = 'Basic Deduction';
					if (type == 'Null') var typeName = 'Other';
					
					if (!percent) percent = 'N/A';
					
					var html = '<tr>	\
						<td class="name">'+name+'</td>	\
						<td class="field-name">'+field_name+'</td>	\
						<td class="type">'+typeName+'</td>	\
						<td class="percent" style="text-align:right">'+percent+'</td>	\
						<td style="width: 50px; padding: 0">	\
							<a class="grid-action grid-action-edit prevent-default edit-field" rel="'+res+'"><span>Edit</span></a>	\
							<a class="grid-action grid-action-delete" href="hr/delete/'+res+'>"><span>Delete</span></a>	\
						</td></tr>';
						
					$('table.fields tbody').append(html);
					
					$('table.fields tbody tr').removeClass('alt');
					$('table.fields tbody tr:even').addClass('alt');
				}
			}
			
		})
	});


	
	$('form').submit(function(){
		var passed = true;
		$('input.mandatory').each(function(){
			if (!$(this).val().trim()){
				passed = false;
			}
		});
	
		if (!passed){
			showDialog('ok','Error','Please ensure you have filled in all required fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
	
	
});


</script>


<div id="add-field" class="global-modal-form" style="height: 210px">
	<div class="global-modal-form-body">
	<h3>Add Field</h3>
	<table class="grid-form grid-form-transparent">
		<tr>
			<td class="label">Name</label>
			<td><input type="text" class="v-text name" style="width: 80%" name="name" /></td>
		</tr>
		<tr>
			<td class="label">Field Name</label>
			<td><input type="text" class="v-text field-name" name="relationship" /></td>
		</tr>
		<tr>
			<td class="label">Type</label>
			<td><?php echo form_dropdown('type',array('Add'=>'Earning','Deduct'=>'Deduction','BDeduct'=>'Basic Deduction','Null'=>'Other'),'','class="v-dropdown type" style="width: 150px"'); ?></td>
		</tr>
		<tr>
			<td class="label">Auto Deduct Percentage</label>
			<td style="font-size: 10pt;"><input type="text" style="text-align: right" class="v-number-decimal v-text percent" name="percent" /> %</td>
		</tr>
		</tr>
	</table>
	<hr />
	<p class="align-right"><a class="v-dbtn save-field">Save</a> <a class="v-dbtn discard-field">Discard</a></p>
	</div>
</div>

<div id="update-field" class="global-modal-form" style="height: 210px">
	<div class="global-modal-form-body">
	<h3>Add Field</h3>
	<table class="grid-form grid-form-transparent">
		<tr>
			<td class="label">Name</label>
			<td><input type="text" class="v-text name" style="width: 80%" name="name" /></td>
		</tr>
		<tr>
			<td class="label">Field Name</label>
			<td><input type="text" class="v-text field-name" name="relationship" /></td>
		</tr>
		<tr>
			<td class="label">Type</label>
			<td><?php echo form_dropdown('type',array('Add'=>'Earning','Deduct'=>'Deduction','BDeduct'=>'Basic Deduction','Null'=>'Other'),'','class="v-dropdown type" style="width: 150px"'); ?></td>
		</tr>
		<tr>
			<td class="label">Auto Deduct Percentage</label>
			<td style="font-size: 10pt"><input type="text" style="text-align: right" class="v-number-decimal v-text percent" name="percent" /> %</td>
		</tr>
		</tr>
	</table>
	<hr />
	<p class="align-right"><a class="v-dbtn update-field">Save</a> <a class="v-dbtn discard-update-field">Discard</a></p>
	</div>
</div>



	<div class="toolbar">
		<h3 class="grid-title">Configuration</h3>
		<div class="global-tabs" style="padding: 3px 5px;">
			<a class="v-btn submit_btn">Save Config</a>
		</div>
		<div class="global-tabs" style="padding: 3px 5px 0 3px">
			<ul>
				<li><a href="general" class="current">General</a></li>
				<li><a href="payslip">Pay Slip</a></li>
				<li><a href="deductions">Deductions</a></li>
			</ul>
		</div>
	</div>
	<div class="status">
	
	</div>
	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>
	
		<div class="main-container">
		
	
			<form method="post" class="config" action="<?=base_url()?>hr/config/do" target="postframe">
				
				<div class="grid tab-related general">
					<h3 class="general-form-header">Configuration</h3>
					<table class="general-form">
						<?php 
							for ($i = 1; $i <= 28; $i++){
								if (strlen($i) == 2){
									if ($i[1] == 1) $suffix = 'st';
									elseif ($i[1] == 2) $suffix = 'nd';
									elseif ($i[1] == 3) $suffix = 'rd';
									else $suffix = 'th';
								} else {
									if ($i == 1) $suffix = 'st';
									elseif ($i == 2) $suffix = 'nd';
									elseif ($i == 3) $suffix = 'rd';
									else $suffix = 'th';
										
								}							
								$days[$i] = $i . $suffix . ' of the month';
							}
							
						?>
						<tr class="two">
							<td class="label">Payroll Cutoff Date</td>
							<td class="input">Every <?php echo form_dropdown('payroll_cutoff',$days,'','class="v-dropdown"'); ?> 
						</tr>
						<tr class="two">
							<td class="label">Operating Duration (hours)</td>
							<td class="input"><input type="text" class="v-number" name="payroll_operating_duration" /></td>
						</tr>
						<tr class="two">
						
						</tr>
					</table>
					
				</div>
				
				
				<div class="grid tab-related payslip" style="display:none">
					<a style="padding: 0px 10px" class="v-btn add-field float_right">Add Field</a>
					<h3 class="general-form-header"> Pay Slip Fields</h3>
					<div  style="border-bottom: 1px solid #EEE;">
					<table class="grid grid_data fields">
						<thead>
							<tr>
								<th>Field</th>
								<th>Field Name</th>
								<th>Type</th>
								<th>Auto Deduct (%)</th>
								<th class="grid-action" style="width: 50px; text-align: center"><img src="<?=base_url()?>images/email-action.gif" alt="Action" /></th>
		
							</tr>
						</thead>
						<tbody>
							<?php $x = 0; foreach ($sv_breakdown as $breakdown): ?>
							<tr <?php echo $x%2 == 0 ? 'class="alt"' : ''; ?>>
								<td class="name"><?php echo $breakdown->name; ?></td>
								<td class="field-name"><?php echo $breakdown->field_name; ?></td>
								<td class="type" value="<?php echo $breakdown->type; ?>">
									<?php if ($breakdown->type == 'Add') echo 'Earning'; ?>
									<?php if ($breakdown->type == 'BDeduct') echo 'Basic Deduction'; ?>
									<?php if ($breakdown->type == 'Deduct') echo 'Deduction'; ?>
									<?php if ($breakdown->type == 'Null') echo 'Other'; ?>
									<?php if ($breakdown->type == 'Basic') echo 'Basic'; ?>
		
								</td>
								<td class="percent" style="text-align: right"><?php echo $breakdown->percentage ? number_format($breakdown->percentage,3) : 'N/A'; ?></td>
								<td style="width: 50px; padding: 0">
									<a class="grid-action grid-action-edit prevent-default edit-field" rel="<?php echo $breakdown->id?>"><span>Edit</span></a>
									<a class="grid-action grid-action-delete" href="hr/delete_field/<?php echo $breakdown->id?>"><span>Delete</span></a>
								</td>
							</tr>
							<?php $x++; endforeach; ?>
						</tbody>
					</table>
					</div>
				</div>
				
				
				<div class="grid tab-related deductions" style="display:none">
					<div class="deduction-filter" style="float:right">
						
					</div>
					<h3 class="general-form-header">Deduction Table</h3>
					<div class="deduction-table">
						
					</div>
					<script type="text/javascript">
						$(document).ready(function(){
							loadDeductionTable();
							
							
							
						})	
						
										
						function loadDeductionTable(){
							var type = $('select.filter-type').val();
							if (!type) type = '';
							$.ajax({
								url: 'hr/ajax/deduction_table',
								type: 'post',
								data: 'type='+encodeURIComponent(type),
								success: function(res){
									$('div.deduction-table').html(res);
								}
							})
						}			
					</script>
				</div>
				
			</form>
		</div>
	</div>
	

