<script type="text/javascript">

var content;
var accId;
var accName;
var allocAmount;
var allocType;
var allocTotal = 0.00;
var curAcc;
var allocNo = 0;

function readyPost(action,status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		$('table.alloc tbody tr').remove();
		showDialog('ok','Journal Entry','Journey entry has been recorded successfully.');
	} else {
		showDialog('ok','Error','There has been an error recording the journal entry.');
		$('div.main_full').show();
		$('div.status').hide();
	}
}

function evaluateBalance(){
	
	allocTotal = 0.00;

	$('table.alloc tbody tr').each(function(){
		var curAllocAmount = $(this).children('td.alloc-amount').html();
		var curAllocType = $(this).children('td.alloc-type').html();
		if (curAllocType == 'CR'){
			allocTotal += parseFloat(curAllocAmount);
		} else {
			allocTotal -= parseFloat(curAllocAmount);
		}
	});
	
	if (allocTotal == 0){
		$('p.status').html("").removeClass('v-notice');
	} else {
		allocTotal = parseFloat(allocTotal).toFixed(2);
		$('p.status').html("Amount not yet applied to an account (out of balance): " + allocTotal).addClass('v-notice');	
	}
}

$(document).ready(function(){
	$('a.submit_btn').click(function(event){
		$(this).parents('form').submit();
		event.preventDefault();
	});
	
	$('a.alloc-add').click(function(event){
		event.preventDefault();
		showModalForm('new-alloc');
	});
	
	$('a.alloc-cancel').click(function(event){
		event.preventDefault();
		hideModalForm('new-alloc');
	});
	
	$('input[name=credit_amount]').change(function(){
		var val = parseFloat($(this).val()).toFixed(2);
		$(this).val(val);
		evaluateBalance();
	});
	
	$('a.alloc-delete').click(function(event){
		$('table.alloc tbody tr[rel='+curAcc+']').remove();
		evaluateBalance();
	});

	
	$('#new-alloc table.select tbody tr').click(function(){
		$('#new-alloc table tr').removeClass('selected');
		$(this).addClass('selected');
		$('input[name=account_name]').val($(this).children('td.account-name').html());
		$('input[name=account_id]').val($(this).children('td.account-id').html());
		var type = $(this).children('td.account-type').html();

		if (type == 'Asset' || type == 'Expenses'){
			$('select[name=alloc_type]').val('DR');
		} else{
			$('select[name=alloc_type]').val('CR');
		}

	});
	
	$('#new-alloc a.alloc-apply').click(function(){
		accId = $('input[name=account_id]').val();
		accName = $('input[name=account_name]').val();
		allocAmount = $('input[name=alloc_amount]').val();
		allocAmount = parseFloat(allocAmount).toFixed(2)
		allocType = $('select[name=alloc_type]').val();
		
		if (!accId){
			showDialog('ok','Error','Account is not selected');
			return;
		}
		if (!$('input[name=alloc_amount]').val()){
			showDialog('ok','Error','Allocation amount not specified');
			return;
		}
		$('input[name=alloc_amount]').val('');
		$('#new-alloc table.select tbody tr').removeClass('selected');
		addAllocation();
		accId = null;
		hideModalForm('new-alloc');
		
	});
	
	$('form').submit(function(){
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
});

function addAllocation(){
	$('table.alloc tbody').append('<tr rel="'+accId+'"><td>'+accId+'</td><td><input type="hidden" name="alloc_id['+allocNo+']" value="'+accId+'" /><input type="hidden" name="alloc_amount['+allocNo+']" value="'+allocAmount+'|'+allocType+'" />'+accName+'</td><td class="alloc-amount">'+allocAmount+'</td><td class="alloc-type">'+allocType+'</td></tr>');
	
	$('table.alloc tbody tr').click(function(){
		$('table.alloc tbody tr').removeClass('selected');
		$(this).addClass('selected');
		curAcc = $(this).attr('rel');
	});
	allocNo++;
	evaluateBalance();
}

function editAllocation(){

}

</script>
	<div id="new-alloc" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Select Account</h3>
			<div class="scrollable-grid" style="height:200px; width: 100%">
			<table class="grid select">
				<thead>
					<tr>
						<th>Account No</th>
						<th>Type</th>
						<th>Name</th>
					</tr>
				</thead>
				<tbody>
					<?php foreach($accounts as $account):?>
					<tr rel="<?=$account->id?>">
						<td class="account-id"><?=$account->id?></td>
						<td class="account-type"><?=$account->type?></td>
						<td class="account-name"><?=$account->name?></td>
					</tr>
					<?php endforeach; ?>
				</tbody>
			</table>
			</div>
			<input type="hidden" name="account_id" />
			<input type="hidden" name="account_name" />
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label"><label>Amount</label></td>
					<td><input type="text" name="alloc_amount" class="text" /></td>
				</tr>
				<tr>
					<td class="label">Entry Type</td>
					<td><?=form_dropdown('alloc_type',array('DR'=>'DR','CR'=>'CR'))?></td>
				</tr>
			</table>
			<hr />
			<p style="margin-bottom: 10px" class="align-right action-button-all"><a class="v-dbtn alloc-apply">Apply</a> <a class="v-dbtn alloc-cancel">Cancel</a></p>
		</div>
	</div>
	
	<div class="status">
	
	</div>
	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>
		<h3 class="grid-title">New Journal Entry</h3>
		<div class="main-container">

		<form method="post" action="<?=base_url()?>accounts/entry/manual" target="postframe">
			<h3 class="general-form-header">Transaction Details</h3>
			<table class="general-form">
				<tr>
					<td class="label">Transaction Date</td>
					<td class="input"><input type="text" name="date" class="date" /></td>
				</tr>
				<tr>
					<td class="label">Journal</td>
					<td class="input"><?=form_dropdown('journal',array("General"=>"General","Payments"=>"Payments","Receipts"=>"Receipts","Sales"=>"Sales","Purchases"=>"Purchases"))?></td>
				</tr>
				<tr>
					<td class="label">Transaction Reference</td>
					<td class="input"><input type="text" name="refno" class="text" /></td>
				</tr>
				<tr>
					<td class="label">Journal Memo</td>
					<td class="input"><input type="text" name="memo" class="text" /></td>
				</tr>
			</table>
			<h3 class="general-form-header">Account Allocation</h3>
			<table class="grid alloc">
				<thead>
					<tr>
						<th style="10%">Number</th>
						<th style="70%">Name</th>
						<th style="20%">Amount</th>
						<th style="10%"></th>
					</tr>
				</thead>
				<tbody>
				
				</tbody>
			</table>
			<p><a class="v-btn alloc-add">Add</a> <a class="v-btn alloc-delete">Delete</a></p>
			<p class="status"></p>
			<hr />
			<a class="v-btn submit_btn">Record</a>
			<br />
		</form>
		</div>
	</div>
