<html>
	<head>
		<title>Plexcloud&trade; - System Info</title>
		<style>	
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 10pt;
				margin: 0;
				padding: 0;
			}
			input:active {
				outline: none;
				border: none;
			}
			#term {
				padding: 10px;
			}
			
			div.user {
				background: #333;
				color: #FFF;
				padding: 10px;
				border-top: 2px solid red;
			}
			
			div.user p {
				padding: 0;
				margin: 0;
			}
			
			div.user a {
				color: #999;
			}
			
			table {
				width: 100%;
			}
			
			table td, table th {
				background: #EEE;
				padding: 10px;
				font-size: 10pt;
			}
			
			table td.lighter, table th.lighter {
				background: #F3F3F3;
			}
			
			div.content {
				padding: 20px;
			}
		</style>
	</head>
	<body>
		<div id="container">
			<div class="user">
				<span style="float:left">plexcloud&trade; - System Info</span>
				<p style="text-align: right">Logged in as <strong><?php echo $this->user->data('username')?></strong>. <?php echo anchor('logout','Logout','class="v-btn"'); ?></p>
			</div>				
			<div class="content">
				<h3>License Information</h3>
				<table>
					<tr>
			    		<td style="width: 200px; font-weight: bold">Licensed To</td>
			    		<td class="lighter"><?php echo $license->licensee; ?></td>
			    	</tr>
			    	<tr>
			    		<td style="width: 200px; font-weight: bold">License Date</td>
			    		<td class="lighter"><?php echo date('d/m/Y',strtotime($license->date)); ?></td>
			    	</tr>
			    	<tr>
			    		<td style="width: 200px; font-weight: bold">License Type</td>
			    		<td class="lighter"><?php echo $license->type; ?></td>
			    	</tr>
			    	<?php if ($license->type == 'Lease'): ?>
			    	<tr>
			    		<td style="width: 200px; font-weight: bold">Tenure Period</td>
			    		<td class="lighter"><?php echo $license->tenure; ?> years</td>
			    	</tr>
			    	<?php endif; ?>
					<tr>
			    		<td style="width: 200px; font-weight: bold">Registered Hostname</td>
			    		<td class="lighter"><?php echo $license->hostname; ?></td>
			    	</tr>
					<tr>
			    		<td style="width: 200px; font-weight: bold">Registered Host IP Address</td>
			    		<td class="lighter"><?php echo $license->ip; ?></td>
			    	</tr>

			    </table>
			    <?php if ($license->type == 'Lease'): ?>
			    <h3>Lease Subscriptions</h3>
			    <table>
			    	<tr>
			    		<th style="width: 89px; font-weight: bold">From</th>
			    		<th style="width: 89px; font-weight: bold">To</th>
			    		<th>Key</th>
			    		<th style="width: 80px; font-weight: bold">Status</th>
			    	</tr>
					<?php foreach ($subscriptions as $subscription): ?>
					<tr>
						<td class="lighter" style="text-align: center"><?php echo date('d/m/Y',strtotime($subscription->from_date)); ?></td>
						<td class="lighter" style="text-align: center"><?php echo date('d/m/Y',strtotime($subscription->to_date)); ?></td>
						<td class="lighter"><?php echo $subscription->key; ?></td>
						<td class="lighter" style="text-align: center"><?php echo $subscription->status == 'Active' ? '<span style="font-weight: bold; color: green">Activated</span>' : 'Inactive' ; ?></td>
					</tr>
					<?php endforeach; ?>
			    </table>
			    <?php endif; ?>
		    </div>	
		</div>		   
	</body>
</html>