<?php if (!$this->user->has_permission('to_add','Branches')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">


function readyAdd(status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		showDialog('ok','Warehouse','Warehouse record has been updated.');
		form_warning = false;
	} else if (status == 0) {
		showDialog('ok','Error','Warehouse record cannot be saved now. Please login again.');
		$('div.main_full').show();
		$('div.status').hide();
	} 
}

$(document).ready(function(){
	$('a.create').click(function(event){
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Form Error','Please make sure you have filled the form correctly.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>').show();
	});
	
	$('select.warehouse-type').change(function(){
		if ($(this).val() == 'Stakeholder'){
			$('span.stakeholder').show();
			$('span.franchise').hide();
		} else {
			$('span.stakeholder').hide();
			$('span.franchise').show();			
		}
	});
	
	$('select.warehouse-type').change();
	
	$('select.v-contact').change(function(){
		var id = $(this).val();
		$('input.name').val('Loading...').attr('disabled',true);
		$('input.mobile').val('');
		$('input.address1').val('');
		$('input.address2').val('');
		$('input.zipcode').val('');
		$('input.city').val('');

		$.ajax({
			url: base_url + 'contacts/get_contact_details/' + id,
			dataType: 'json',
			success: function(data){
				$('input.name').val(data.name).attr('disabled',false);
				$('input.mobile').val(data.mobile);
				$('input.address1').val(data.address1);
				$('input.address2').val(data.address2);
				$('input.zipcode').val(data.zipcode);
				$('input.city').val(data.city);
				$('input.tel').val(data.tel);
				$('input.fax').val(data.fax);
				$('input.email').val(data.email);
				$('select.v-country').attr('state',data.state).val(data.country).change();
			}
		})
	});	
	

})

</script>
	<div class="toolbar">
		<h3 class="grid-title"><a href="inventory/warehouses" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn back_btn">Back</a>Edit Warehouse &raquo; <?php echo $warehouse->name; ?></h3>
		<div class="global-tabs" style="padding: 5px">
			<a class="v-btn create">Save Warehouse</a>
		</div>
	</div>
	<div class="status">
	
	</div>

	<div class="main_full">
		<div class="main-container">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<form class="insert" method="post" action="<?=base_url()?>inventory/warehouse_edit/<?php echo $warehouse->id; ?>/do" target="postframe">
			<h3>Warehouse Information</h3>
			<p><span class="red">*</span> Mandatory fields</p>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Type</td>
						<td class="input"><?php echo form_dropdown('type', array('Stakeholder'=>'Stakeholder\'s Warehouse', 'Franchise'=>'Franchise\'s Warehouse'), $warehouse->type, 'class="v-dropdown warehouse-type"'); ?></td>
					</tr>
					<tr>
						<td class="label"><span class="stakeholder">Stakeholder</span><span style="display:none" class="franchise">Franchise</span></td>
						<td class="input"><?php echo form_dropdown('type_reference', $contacts_dropdown, $warehouse->type_reference, 'class="v-dropdown v-contact"'); ?></td>
					</tr>
					<tr>
						<td class="label">Name <span class="red">*</span></td>
						<td class="input"><input value="<?php echo $warehouse->name; ?>" type="text" name="name" class="v-text mandatory name" /></td>
					</tr>
					<tr>
						<td class="label">Address 1</td>
						<td class="input"><input value="<?php echo $warehouse->address1; ?>" type="text" name="address1" class="v-text address1" /></td>
					</tr>
					<tr>
						<td class="label">Address 2</td>
						<td class="input"><input value="<?php echo $warehouse->address2; ?>" type="text" name="address2" class="v-text address2" /></td>
					</tr>
					<tr>
						<td class="label">City</td>
						<td class="input"><input value="<?php echo $warehouse->city; ?>" type="text" name="city" class="v-text city" /></td>
					</tr>
					<tr>
						<td class="label">Zipcode</td>
						<td class="input"><input value="<?php echo $warehouse->zipcode; ?>" type="text" name="zipcode" class="v-text zipcode" /></td>
					</tr>
					<tr>
						<td class="label">State/Province</td>
						<td class="input"><?php echo form_dropdown('state',$this->system->state_list($warehouse->country), $warehouse->state, 'class="v-city v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Country</td>
						<td class="input"><?php echo form_dropdown('country',$this->system->country_list(), $warehouse->country,'class="v-country v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Telephone</td>
						<td class="input"><input value="<?php echo $warehouse->tel; ?>" type="text" name="tel" class="v-text tel" /></td>
					</tr>
					<tr>
						<td class="label">Fax</td>
						<td class="input"><input value="<?php echo $warehouse->fax; ?>" type="text" name="fax" class="v-text fax" /></td>
					</tr>
					<tr>
						<td class="label">Email</td>
						<td class="input"><input value="<?php echo $warehouse->email; ?>" type="text" name="email" class="v-text email" /></td>
					</tr>
				</tbody>
			</table>
			
			
			<?php if ($this->system->config('online_sales')): ?>
			<h3>Online Store</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Enabled</td>
						<td class="input"><input type="checkbox" value="1" <?php if ($warehouse->online_store) echo 'checked="checked"'; ?> name="online_store" /> Yes</td>
					</tr>
				</tbody>
			</table>
			<?php endif; ?>
			
			
			
			<h3>Tags</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Tags</td>
						<td class="input"><input value="<?php echo tagcomplete($warehouse->tags); ?>" type="text" class="v-text autocomplete-tag" name="tags" /></td>
					</tr>
				</tbody>
			</table>
			
			

			
			<h3>Remarks</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Remarks</td>
						<td class="input"><textarea name="remarks" class="v-textarea"><?php echo $warehouse->remarks; ?></textarea></td>
					</tr>
				</tbody>
			</table>
			
		

		</form>
		</div>
	</div>
