<?php if (!$this->user->has_permission('to_create_item','Inventory')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">


function readyAdd(status){
	if (status == 1){
		$('div.mc-add').show();
		$('div.status-add').hide();
		$('form').clearForm();
		$('div.notice').html('<p class="v-success">Item has been added.</p>');
		$('input.first').focus();
		form_warning = false;
	} else if (status == 0) {
		$('div.notice').html('<p class="v-warning">Item SKU already exists.</p>');
		$('div.mc-add').show();
		$('div.status-add').hide();
	} 
}

$(document).ready(function(){
	windowResize();
	
	
	$('select[name=weight_unit]').change(function(){
		$('span.weight-unit').text($(this).val());
	})
	
	$('select[name=volume_unit]').change(function(){
		if ($(this).val() == 'in3') var vol_unit = 'in<sup>3</sup>';
		else var vol_unit = 'cm<sup>3</sup>';
		$('span.volume-unit').html(vol_unit);
	})
	
	$('select[name=weight_unit]').change();
	$('select[name=volume_unit]').change();
	

	$('a.save-item').click(function(event){
		$('#add-item-form').submit();
		event.preventDefault();
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$(this).find('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.mc-add').hide();
		$('div.status-add').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});

		
	$('input.margin').change(function(){
		var margin = parseFloat($(this).val());
		var cost = parseFloat($('input.cost').val());
		var selling = (100 * cost) / (100 - margin);
				
		$('input.selling').val(selling.toFixed(2));
		
	});
	
	$('input.selling').change(function(){
		var cost = parseFloat($('input.cost').val());
		var selling = parseFloat($(this).val());
		var gp = selling - cost;
		var margin = gp / selling * 100;
		
		$('input.margin').val(margin.toFixed(2));
		
	});
	
	$('ul.category-tabs a').click(function(e){
		e.preventDefault();
		$('div.tabs').hide();
		$($(this).attr('href')).show();
	});

	$('ul.category-tabs a.current').click();
	
});

</script>
	<div class="status status-add">
	
	</div>

	<p style="float: right" class="general-form-action"><a class="v-btn save-item">Save</a> <a class="v-btn done-new-item">Done</a></p>


	<h3>New Item</h3>
	<div class="global-tabs" style="background: none; padding-bottom: 1px;">
		<ul class="category-tabs">
			<li><a style="border: 1px solid #CCC; border-bottom: none" class="item current" href="#item">Item Information</a></li>
			<li><a style="border: 1px solid #CCC; border-bottom: none" class="packaging" href="#packaging">Packaging</a></li>
			<li><a style="border: 1px solid #CCC; border-bottom: none" class="other" href="#other">Other Options</a></li>
			<li><a style="border: 1px solid #CCC; border-bottom: none" class="remarks" href="#remarks">Remarks</a></li>
		</ul>
	</div>
	
		<div style="height: 340px; overflow-y: scroll; border: 1px solid #DDD; background:#FFF">
		<iframe id="postframe-po" name="postframe-po" src="<?=base_url()?>nothing/empty/<?php echo mt_rand(10000,99999); ?>" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container mc-add">


		<form method="post" id="add-item-form" action="<?=base_url()?>inventory/item_add/do" target="postframe-po">
			<div class="notice" style="margin-bottom: 15px">
			
			</div>
			<div id="item" class="tabs">
			<h3>Item Information</h3>
			<p><span style="color:red">*</span> Mandatory fields</p>

			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Item Name <span class="red">*</span></td>
						<td class="input"><input type="text" name="name" class="v-text mandatory first" /></td>
					</tr>
					<tr>
						<td class="label">Primary SKU <span class="red">*</span></td>
						<td class="input"><input type="text" name="sku" class="v-text mandatory" /></td>
					</tr>
					<?php
						$categories_dropdown[0] = 'Uncategorized';
						$subcategories_dropdown[0] = 'Uncategorized';
						$brands_dropdown[0] = 'Uncategorized';
					?>
					<tr>
						<td class="label">Category <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('category',$categories_dropdown,'', 'class="v-dropdown"'); ?> Other: <input type="text" name="category_other" class="v-txt" /></td>
					</tr>
					<tr>
						<td class="label">Subcategory <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('subcategory',$subcategories_dropdown,'', 'class="v-dropdown"'); ?> Other: <input type="text" name="subcategory_other" class="v-txt" /></td>
					</tr>
					<tr>
						<td class="label">Brand</td>
						<td class="input"><?php echo form_dropdown('brand',$brands_dropdown, $item->brand, 'class="v-dropdown"'); ?> Other: <input type="text" name="brand_other" class="v-txt" /></td>
					</tr>
					<tr>
						<td class="label">Unit of Measurement</td>
						<td class="input"><input type="text" name="uom1" class="v-text" /></td>
					</tr>
					<tr>
						<td class="label">Initial Stock</td>
						<td class="input"><input type="text" name="initial_stock" class="v-number" /></td>					
					</tr>


					<tr>
						<td class="label">Item Photo</td>
						<td class="input"><input type="file" name="attachment" /></td>
					</tr>
					<tr>
						<td class="label">Location</td>
						<td class="input"><input type="text" name="location" class="v-text" /></td>
					</tr>
					<tr>
						<td class="label">Quick Item</td>
						<td class="input"><input type="checkbox" <?php if ($item->quick) echo 'checked="checked"'; ?> name="quick" value="1" />  Yes &nbsp;&nbsp;<small>Item will appear in quick item list in sales screen.</small></td>
					</tr>
					<tr>
						<td class="label">Weight Unit</td>
						<td class="input"><?php echo form_dropdown('weight_unit',array('g'=>'Gram (g)','kg'=>'Kilogram (kg)','oz'=>'Ounce (oz)','lb'=>'Pound (lb)'), $item->weight_unit); ?>
					</tr>					
					<tr>
						<td class="label">Weight (<span class="weight-unit"></span>)</td>
						<td class="input"><input type="text" class="v-text" name="weight" value="<?php echo $item->weight; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Volume Unit</td>
						<td class="input"><?php echo form_dropdown('volume_unit',array('cm3'=>'Cubic Centimetre','in3'=>'Cubic Inch'), $item->volume_unit); ?>
					</tr>					
					<tr>
						<td class="label">Volume (<span class="volume-unit"></span>)</td>
						<td class="input"><input type="text" class="v-text" name="volume" value="<?php echo $item->volume; ?>" /></td>
					</tr>


				</tbody>
			</table>
			<h3>Item Cost &amp; Price</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Cost <span class="red">*</span></td>
						<td class="input"><input type="text" name="cost" class="v-text v-number-decimal cost mandatory" /></td>
					</tr>
					<tr>
						<td class="label">Selling Price <span class="red">*</span></td>
						<td class="input"><input type="text" name="price" class="v-text v-number-decimal selling mandatory" /></td>
					</tr>
					<tr>
						<td class="label">Margin (%)</td>
						<td class="input"><input value="" type="text" name="margin" class="v-text v-number-decimal margin" /></td>
					</tr>
					<tr>
						<td class="label">Selling Price 2</td>
						<td class="input"><input type="text" name="price_2" class="v-text v-number-decimal" /></td>
					</tr>
					<tr>
						<td class="label">Selling Price 3</td>
						<td class="input"><input type="text" name="price_3" class="v-text v-number-decimal" /></td>
					</tr>
					<tr>
						<td class="label">Selling Price 4</td>
						<td class="input"><input type="text" name="price_4" class="v-text v-number-decimal" /></td>
					</tr>
					<tr>
						<td class="label">Allow Custom Price</td>
						<td class="input"><input type="checkbox" name="enter_price" value="1" /> Yes &nbsp;&nbsp;<small>Allow sales screen to change price.</small></td>
					</tr>
					<tr>
						<td class="label">Adjust Cost Accordingly</td>
						<td class="input"><input type="checkbox" name="adjust_cost" value="1" /> Yes &nbsp;&nbsp;<small>Adjust cost based on custom price and margin</small></td>
					</tr>
				</tbody>
			</table>
			
			<?php if ($this->system->config('online_sales')): ?>
			<h3>Online Sales</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Minimum Cart Quantity</td>
						<td class="input"><input type="text" name="min_cart_qty" class="v-text v-number" /></td>
					</tr>
					<tr>
						<td class="label">Maximum Cart Quantity</td>
						<td class="input"><input type="text" name="max_cart_qty" class="v-text v-number" /></td>
					</tr>
				</tbody>
			</table>
			<?php endif; ?>
			
			<h3>Stock Keeping</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Alert Quantity <span class="red">*</span></td>
						<td class="input"><input type="text" name="alert_quantity" class="v-text v-number" /></td>					
					</tr>
					<tr>
						<td class="label">Maximum Quantity</td>
						<td class="input"><input type="text" name="max_quantity" class="v-text v-number" /></td>					
					</tr>
				</tbody>
			</table>
			
			
			<h3>Tags</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Tags</td>
						<td class="input"><input value="<?php echo tagcomplete($item->tags); ?>" type="text" class="v-text autocomplete-tag" name="tags" /></td>
					</tr>
				</tbody>
			</table>

			</div>
			
			<div id="packaging" class="tabs">
			<h3>Packaging</h3>
			<table style="width: 100%">
				<tr>
					<td style="width: 33%;">
						<table class="general-form form-tc">
							<tbody>
								<tr>
									<td class="label">SKU 2</td>
									<td class="input"><input type="text" name="sku2" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Unit of Measurement</td>
									<td class="input"><input type="text" name="uom2" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Price</td>
									<td class="input"><input type="text" name="price2" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 2</td>
									<td class="input"><input type="text" name="price2_2" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 3</td>
									<td class="input"><input type="text" name="price2_3" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 4</td>
									<td class="input"><input type="text" name="price2_4" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Qty Ratio</td>
									<td class="input"><input type="text" name="loose_qty2" class="v-text v-ratio" /></td>
								</tr>
								<tr>
									<td class="label">Weight (<span class="weight-unit"></span>)</td>
									<td class="input"><input type="text" name="weight2" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Volume (<span class="volume-unit"></span>) </td>
									<td class="input"><input type="text" name="volume2" class="v-number-decimal" /></td>
								</tr>
							</tbody>
						</table>
					</td>
					<td style="width: 33%;">
						<table class="general-form form-tc">
							<tbody>
								<tr>
									<td class="label">SKU 3</td>
									<td class="input"><input type="text" name="sku3" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Unit of Measurement</td>
									<td class="input"><input type="text" name="uom3" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Price</td>
									<td class="input"><input type="text" name="price3" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 2</td>
									<td class="input"><input type="text" name="price3_2" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 3</td>
									<td class="input"><input type="text" name="price3_3" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 4</td>
									<td class="input"><input type="text" name="price3_4" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Qty Ratio</td>
									<td class="input"><input type="text" name="loose_qty3" class="v-text v-ratio" /></td>
								</tr>
								<tr>
									<td class="label">Weight (<span class="weight-unit"></span>)</td>
									<td class="input"><input type="text" name="weight3" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Volume (<span class="volume-unit"></span>) </td>
									<td class="input"><input type="text" name="volume3" class="v-number-decimal" /></td>
								</tr>
							</tbody>
						</table>
					</td>
					<td style="width: 33%;">
						<table class="general-form form-tc">
							<tbody>
								<tr>
									<td class="label">SKU 4</td>
									<td class="input"><input type="text" name="sku4" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Unit of Measurement</td>
									<td class="input"><input type="text" name="uom4" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Price</td>
									<td class="input"><input type="text" name="price4" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 2</td>
									<td class="input"><input type="text" name="price4_2" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 3</td>
									<td class="input"><input type="text" name="price4_3" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 4</td>
									<td class="input"><input type="text" name="price4_4" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Qty Ratio</td>
									<td class="input"><input type="text" name="loose_qty4" value="<?php echo $item->loose_qty4; ?>" class="v-text v-ratio" /></td>
								</tr>
								<tr>
									<td class="label">Weight (<span class="weight-unit"></span>)</td>
									<td class="input"><input type="text" name="weight4" value="<?php echo $item->weight4; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Volume (<span class="volume-unit"></span>) </td>
									<td class="input"><input type="text" name="volume4" value="<?php echo $item->volume4; ?>" class="v-number-decimal" /></td>
								</tr>
							</tbody>
						</table>
					</td>					
				</tr>
			</table>
			</div>
			
			<div class="tabs" id="other">
			<h3>Other Options</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">ISBN</td>
						<td class="input"><input type="text" class="v-text" name="isbn" value="<?php echo $item->isbn; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Author(s)</td>
						<td class="input"><input type="text" class="v-text" name="author" value="<?php echo $item->author; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Publisher</td>
						<td class="input"><input type="text" class="v-text" name="publisher" value="<?php echo $item->publisher; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Model No</td>
						<td class="input"><input type="text" class="v-text" name="model_no" /></td>
					</tr>
					<tr>
						<td class="label">Warranty Duration</td>
						<td class="input"><input type="text" class="v-text" name="warranty" /></td>
					</tr>
					<tr>
						<td class="label">Require Serial Number</td>
						<td class="input"><input type="checkbox" name="enter_serial" <?php if ($item->enter_serial) echo 'checked="checked"'; ?> value="1" /> Yes &nbsp;&nbsp; <small>Sales transaction prompts for item serial number for record</small></td>
					</tr>
					<tr>
						<td class="label">Redeemable</td>
						<td class="input"><input type="checkbox" name="redeemable" value="1" /> Yes &nbsp;&nbsp; <small>Allow item to be redeemed by members.</small></td>
					</tr>
					<tr>
						<td class="label">Redeem Points</td>
						<td class="input"><input type="text" class="v-number" name="redeem_points" /></td>
					</tr>
				</tbody>
			</table>
			</div>
			

			<div id="remarks" class="tabs">
			<h3>Product Description &amp; Remarks</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Description</td>
						<td class="input"><textarea name="description" class="v-textarea"></textarea></td>
					</tr>
					<tr>
						<td class="label">Remarks</td>
						<td class="input"><textarea name="remarks" class="v-textarea"></textarea></td>
					</tr>
				</tbody>
			</table>
			</div>
			
		</form>
		</div>

	</div>
