<?php
	
$purchase_tax_codes = array (
	''		=> 'Select',
	'TX'	=> 'TX - Purchases with GST incurred at 6% and directly attributable to taxable supplies',
	'IM'	=> 'IM - Import of goods with GST incurred',
	'IS'	=> 'IS - Imports under special scheme with no GST incurred (e.g. Approved Trader Scheme, ATMS Scheme)',
	'BL'	=> 'BL - Purchases with GST incurred but not claimable (Disallowance of Input Tax) (e.g. medical expenses for staff)',
	'NR'	=> 'NR - Purchase from non GST-registered supplier with no GST incurred',
	'ZP'	=> 'ZP - Purchase from GST-registered supplier with no GST incurred. (e.g. supplier provides transportation of goods that qualify as international services)',
	'EP'	=> 'EP - Purchases exempted from GST. E.g. purchase of residential property or financial services',
	'OP'	=> 'OP - Purchase transactions which is out of the scope of GST legislation (e.g. purchase of goods overseas)',
	'TX-E43'=> 'TX-E43 - Purchase with GST incurred directly attributable to incidental exempt supplies',
	'TX-N43'=> 'TX-N43 - Purchase with GST incurred directly attributable to non-incidental exempt supplies',
	'TX-RE'	=> 'TX-RE - Purchase with GST incurred that is not directly attributable to taxable or exempt supplies',
	'GP'	=> 'GP - Purchase transactions which disregarded under GST legislation (e.g. purchase within GST group registration)'	
);

$supply_tax_codes = array (
	''		=> 'Select',
	'SR'	=> 'SR - Standard-rated supplies with GST Charged',
	'ZRL'	=> 'ZRL - Local supply of goods or services which are subject to zero rated supplies',
	'ZRE'	=> 'ZRE - Exportation of goods or services which are subject to zero rated supplies',
	'ES43'	=> 'ES43 - Incidental Exempt supplies',
	'GS'	=> 'GS - Disregarded supplies'
);
	
	
?>
<?php if (!$this->user->has_permission('to_edit_item','Inventory')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">


function readyAdd(status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('div.notice').html('<p class="v-success">Item has been updated.</p>');
		form_warning = false;
	} else if (status == 0) {
		$('div.notice').html('<p class="v-warning">Item SKU already exists.</p>');
		$('div.main_full').show();
		$('div.status').hide();
	} 
}

function renamePhoto(){
	var i = 1;
	$('div.photo').each(function(){
		$(this).find('input[name=primary_photo]').val(i);
		$(this).find('input.v-photo').attr('name','item_photo_'+i);
		$(this).find('input.remove_photo').attr('name','remove_photo_'+i);
		i++;
	});
}

function renameLinks(){
	$('input[name=links]').val('');
	var i = 0;
	$('span.variant-sku').each(function(){
		if (i == 0) $('input[name=links]').val($(this).text());
		else $('input[name=links]').val($('input[name=links]').val() + ',' + $(this).text());
		i++;
	})
}


$(document).ready(function(){

	
	$('select[name=weight_unit]').change(function(){
		$('span.weight-unit').text($(this).val());
	})
	
	$('select[name=volume_unit]').change(function(){
		if ($(this).val() == 'in3') var vol_unit = 'in<sup>3</sup>';
		else var vol_unit = 'cm<sup>3</sup>';
		$('span.volume-unit').html(vol_unit);
	})
	
	$('select[name=weight_unit]').change();
	$('select[name=volume_unit]').change();
	


	var variant = $('div.variant-new').first().clone();
	$('div.variant-new').remove();
	
	var photo = $('div.photo-new').clone().removeClass('photo-new');	
	$('div.photo-new').remove();
	var curNo = 0;	
	
	$('div.photo').each(function(){
		curNo++;
	});
	
	$('a.remove-variant').click(function(){
		$(this).parents('div.variant').fadeOut(300, function(){
			$(this).remove();	
			renameLinks();
		})
	});
	
	
	$('button.item-sku').click(function(e){
		e.preventDefault();
		
		var sku = $('input.variant_sku').val();
		
		if (sku == $('input.sku').val()){
			showDialog('ok','Item Variant','Variant cannot be the same as the current item');
			return;
		}
		
		$.ajax({
			url: base_url + 'inventory/ajax/variant',
			type: 'post',
			data: 'sku='+sku,
			dataType: 'json',
			success: function (item){
				
				if (item.status == 'false' || item.length == 0){
					showDialog('ok','Item Variant', 'Item not found');
					return;
				}
				
				var exists = false;
				$('span.variant-sku').each(function(){
					if ($(this).text() == item.sku){
						showDialog('ok','Item Variant', 'Item is already in the list of variants.');
						exists = true;
					}					
				});
				if (exists) return;
				
				if (!item.links && !item.linked){
					var newVariant = $(variant).clone();
					
					$(newVariant).find('span.variant-name').text(item.name);
					$(newVariant).find('span.variant-sku').text(item.sku);
					$(newVariant).find('span.variant-price').text(item.price);
					$(newVariant).find('a.remove-variant').click(function(){
						$(this).parents('div.variant').fadeOut(300, function(){
					   	 	$(this).remove();	
					   	 	renameLinks();
					   	 	})
					});
					

					
					if (item.primary_image){
						$(newVariant).find('div.variant-photo').html('<img src="'+base_url+'assets/items/'+item.primary_image+'" style="height: 88px;"/>');
					}
					
					$('input.variant_sku').val('').focus();
					$('div.variant-container').append($(newVariant).fadeIn(300));
					
					renameLinks();
					

					
				} else {
					showDialog('ok','Item Variant', 'Item is already linked with other items');
				}
			}
		})
	});
	
	$('a.add-photo').click(function(){
		if (curNo == 4) return;
		curNo++;
		var newPhoto = $(photo).clone();
		$(newPhoto).find('input[name=primary_photo]').val(curNo).attr('checked',false);
		$(newPhoto).append(' <a class="v-btn cancel-photo">Cancel</a>');
		$('div.photo-container').append($(newPhoto).clone().fadeIn(300));
		renamePhoto();
	});
	
	$('a.cancel-photo').live('click',function(){
		curNo--;
		$(this).parents('div.photo').fadeOut(300,function(){ $(this).remove(); renamePhoto(); });
	});



	$('a.create').click(function(event){
		$('form.update').submit();

		event.preventDefault();
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});

	$('input.margin').change(function(){
		var margin = parseFloat($(this).val());
		var cost = parseFloat($('input.cost').val());
		var selling = (100 * cost) / (100 - margin);
				
		$('input.selling').val(selling.toFixed(2));
		
	});
	
	$('input.selling').change(function(){
		var cost = parseFloat($('input.cost').val());
		var selling = parseFloat($(this).val());
		var gp = selling - cost;
		var margin = gp / selling * 100;
		
		$('input.margin').val(margin.toFixed(2));
		
	});
	
	$('input.selling').change();
	
	
	$('ul.category-tabs a').click(function(e){
		e.preventDefault();
		$('div.tabs').hide();
		$($(this).attr('href')).show();
	});

	$('ul.category-tabs a.current').click();

})

</script>
<style>
.hidden{display:none};
</style>
<?php if($this->user->has_permission('to_view_cost','Inventory')){
	$HideCost="";
}else{
	$HideCost="hidden";
}
?>
	<div class="status">
	
	</div>
	<div class="toolbar">
		<h3 class="grid-title"><a style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn back_btn">Back</a>Edit Item &raquo; <?php echo $item->name; ?></h3>
		<div class="global-tabs" style="padding: 3px 5px">
			<a class="v-btn create">Save Item</a>
		</div>
		<div class="global-tabs">
			<ul class="category-tabs">
				<li><a class="item current" href="#item">Item Information</a></li>
				<li><a class="packaging" href="#packaging">Packaging</a></li>
				<li><a class="images" href="#images">Images</a></li>
				<li><a class="variants" href="#variants">Variants</a></li>
				<li><a class="other" href="#other">Other Options</a></li>
				<li><a class="remarks" href="#remarks">Remarks</a></li>
			</ul>
		</div>
	</div>		
		
	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing/empty/<?php echo mt_rand(10000,99999); ?>" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">

		<form class="update" enctype="multipart/form-data" method="post" action="<?=base_url()?>inventory/item_edit/<?php echo $item->id; ?>/do" target="postframe">
			<div class="notice" style="margin-bottom: 15px">
			
			</div>
			
			<div id="item" class="tabs">
			<h3>Item Information</h3>
			<p><span class="red">*</span> Mandatory fields</p>

			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Item Name <span class="red">*</span></td>
						<td class="input"><input value="<?php echo $item->name; ?>" type="text" name="name" class="v-text mandatory" /></td>
					</tr>
					<tr>
						<td class="label">Primary SKU <span class="red">*</span></td>
						<td class="input"><input value="<?php echo $item->sku; ?>" type="text" name="sku" class="v-text mandatory sku" /></td>
					</tr>
					<tr>
						<td class="label">Unit</td>
						<td class="input"><input type="text" name="uom1" class="v-text" value="<?php echo $item->uom1; ?>" /></td>
					</tr>

					<?php
						$categories_dropdown[0] = 'Uncategorized';
						$subcategories_dropdown[0] = 'Uncategorized';
						$brands_dropdown[0] = 'Uncategorized';
					?>
					<tr>
						<td class="label">Category <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('category',$categories_dropdown,$item->category, 'class="v-dropdown"'); ?> Other: <input type="text" name="category_other" class="v-txt" /></td>
					</tr>
					<tr>
						<td class="label">Subcategory <span class="red">*</span></td>
						<td class="input"><?php echo form_dropdown('subcategory',$subcategories_dropdown,$item->subcategory, 'class="v-dropdown"'); ?> Other: <input type="text" name="subcategory_other" class="v-txt" /></td>
					</tr>
					<tr>
						<td class="label">Brand</td>
						<td class="input"><?php echo form_dropdown('brand',$brands_dropdown, $item->brand, 'class="v-dropdown"'); ?> Other: <input type="text" name="brand_other" class="v-txt" /></td>
					</tr>

					<tr>
						<td class="label">Location</td>
						<td class="input"><input type="text" name="location" value="<?php echo $item->location; ?>" class="v-text" /></td>
					</tr>
					<tr>
						<td class="label">Quick Item</td>
						<td class="input"><input type="checkbox" <?php if ($item->quick) echo 'checked="checked"'; ?> name="quick" value="1" />   Yes &nbsp;&nbsp;<small>Item will appear in quick item list in sales screen.</small></td>
					</tr>
					<tr>
						<td class="label">Weight Unit</td>
						<td class="input"><?php echo form_dropdown('weight_unit',array('g'=>'Gram (g)','kg'=>'Kilogram (kg)','oz'=>'Ounce (oz)','lb'=>'Pound (lb)'), $item->weight_unit); ?>
					</tr>					
					<tr>
						<td class="label">Weight (<span class="weight-unit"></span>)</td>
						<td class="input"><input type="text" class="v-text" name="weight" value="<?php echo $item->weight; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Volume Unit</td>
						<td class="input"><?php echo form_dropdown('volume_unit',array('cm3'=>'Cubic Centimetre','in3'=>'Cubic Inch'), $item->volume_unit); ?>
					</tr>					
					<tr>
						<td class="label">Volume (<span class="volume-unit"></span>)</td>
						<td class="input"><input type="text" class="v-text" name="volume" value="<?php echo $item->volume; ?>" /></td>
					</tr>


				</tbody>
			</table>
			<h3>Item Cost &amp; Price</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="<?php echo $HideCost;?> label">Cost <span class="red">*</span></td>
						<td class="<?php echo $HideCost;?> input"><input type="text" name="cost" value="<?php echo $item->cost; ?>" class="v-number-decimal mandatory cost" /></td>
					</tr>
					<tr>
						<td class="label">Selling Price <span class="red">*</span></td>
						<td class="input"><input value="<?php echo $item->price; ?>" type="text" name="price" class="v-text mandatory v-number-decimal selling" /></td>
					</tr>
					<tr>
						<td class="label">Margin (%)</td>
						<td class="input"><input value="" type="text" name="margin" class="v-text v-number-decimal margin" /></td>
					</tr>
					<tr>
						<td class="label">Selling Price 2</td>
						<td class="input"><input value="<?php echo $item->price_2; ?>" type="text" name="price_2" class="v-text v-number-decimal" /></td>
					</tr>
					<tr>
						<td class="label">Selling Price 3</td>
						<td class="input"><input value="<?php echo $item->price_3; ?>" type="text" name="price_3" class="v-text v-number-decimal" /></td>
					</tr>
					<tr>
						<td class="label">Selling Price 4</td>
						<td class="input"><input value="<?php echo $item->price_4; ?>" type="text" name="price_4" class="v-text v-number-decimal" /></td>
					</tr>
					<tr>
						<td class="label">Allow Custom Price</td>
						<td class="input"><input type="checkbox" name="enter_price" <?php if ($item->enter_price) echo 'checked="checked"'; ?> value="1" /> Yes &nbsp;&nbsp;<small>Allow sales screen to change price.</small></td>
					</tr>
					<tr>
						<td class="label">Adjust Cost Accordingly</td>
						<td class="input"><input type="checkbox" name="adjust_cost" <?php if ($item->adjust_cost) echo 'checked="checked"'; ?> value="1" /> Yes &nbsp;&nbsp;<small>Adjust cost based on custom price and margin</small></td>
					</tr>
				</tbody>
			</table>
			
			<h3>Tax</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Purchase Tax Code</td>
						<td class="input"><?php echo form_dropdown('purchase_tax_code', $purchase_tax_codes,$item->purchase_tax_code,'class="v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Purchase Taxable</td>
						<td class="input"><input <?php if ($item->purchase_taxable) echo 'checked="checked"'; ?> type="checkbox" name="purchase_taxable" value="1" /> Yes</td>
					</tr>
					<tr>
						<td class="label">Supply Tax Code</td>
						<td class="input"><?php echo form_dropdown('supply_tax_code', $supply_tax_codes,$item->supply_tax_code,'class="v-dropdown"'); ?></td>
					</tr>
					<tr>
						<td class="label">Supply Taxable</td>
						<td class="input"><input <?php if ($item->supply_taxable) echo 'checked="checked"'; ?> type="checkbox" name="supply_taxable" value="1" /> Yes</td>
					</tr>

				</tbody>
			</table>
			
			<?php if ($this->system->config('online_sales')): ?>
			<h3>Online Sales</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Minimum Cart Quantity</td>
						<td class="input"><input value="<?php echo $item->min_cart_quantity; ?>" type="text" name="min_cart_qty" class="v-text v-number" /></td>
					</tr>
					<tr>
						<td class="label">Maximum Cart Quantity</td>
						<td class="input"><input value="<?php echo $item->max_cart_quantity; ?>" type="text" name="max_cart_qty" class="v-text v-number" /></td>
					</tr>
					<tr>
						<td class="label">Ready for Sale</td>
						<td class="input"><input value="1" type="checkbox" name="ready_for_sale" <?php if ($item->ready_for_sale) echo 'checked="checked"'; ?> /> Yes</td>
					</tr>

				</tbody>
			</table>
			<?php endif; ?>
			
			<h3>Stock Keeping</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Alert Quantity <span class="red">*</span></td>
						<td class="input"><input type="text" name="alert_quantity" class="v-text v-number" value="<?php echo $item->alert_quantity; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Maximum Quantity</td>
						<td class="input"><input type="text" name="max_quantity" class="v-text v-number" value="<?php echo $item->max_quantity; ?>" /></td>					
					</tr>
				
				</tbody>
			</table>
			
			<h3>Tags</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Tags</td>
						<td class="input"><input value="<?php echo tagcomplete($item->tags); ?>" type="text" class="v-text autocomplete-tag" name="tags" /></td>
					</tr>
				</tbody>
			</table>

			
			
			</div>
			
			<div id="other" class="tabs">
			<h3>Other Options</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">ISBN</td>
						<td class="input"><input type="text" class="v-text" name="isbn" value="<?php echo $item->isbn; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Author(s)</td>
						<td class="input"><input type="text" class="v-text" name="author" value="<?php echo $item->author; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Publisher</td>
						<td class="input"><input type="text" class="v-text" name="publisher" value="<?php echo $item->publisher; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Model No</td>
						<td class="input"><input type="text" class="v-text" name="model_no" value="<?php echo $item->model_no; ?>" /></td>
					</tr>
					<tr>
						<td class="label">Warranty Duration</td>
						<td class="input"><input type="text" class="v-text" name="warranty" value="<?php echo $item->warranty; ?>" ></td>
					</tr>
					<tr>
						<td class="label">Require Serial Number</td>
						<td class="input"><input type="checkbox" name="enter_serial" <?php if ($item->enter_serial) echo 'checked="checked"'; ?> value="1" /></td>
					</tr>
					<tr>
						<td class="label">Redeemable</td>
						<td class="input"><input <?php if ($item->redeemable) echo 'checked="checked"' ?> type="checkbox" name="redeemable" value="1" /></td>
					</tr>
					<tr>
						<td class="label">Redeem Points</td>
						<td class="input"><input value="<?php echo $item->redeem_points; ?>" type="text" class="v-number" name="redeem_points" /></td>
					</tr>

				</tbody>
			</table>
			</div>
			
			
			
			<div id="packaging" class="tabs">
			<h3>Packaging</h3>
			<table style="width: 100%">
				<tr>
					<td style="width: 33%;">
						<table class="general-form form-tc">
							<tbody>
								<tr>
									<td class="label">SKU 2</td>
									<td class="input"><input type="text" name="sku2" value="<?php echo $item->sku2; ?>" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Unit</td>
									<td class="input"><input type="text" name="uom2" value="<?php echo $item->uom2; ?>" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Price</td>
									<td class="input"><input type="text" name="price2" value="<?php echo $item->price2; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 2</td>
									<td class="input"><input type="text" name="price2_2" value="<?php echo $item->price2_2; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 3</td>
									<td class="input"><input type="text" name="price2_3" value="<?php echo $item->price2_3; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 4</td>
									<td class="input"><input type="text" name="price2_4" value="<?php echo $item->price2_4; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Qty Ratio</td>
									<td class="input"><input type="text" name="loose_qty2" value="<?php echo $item->loose_qty2; ?>" class="v-text v-ratio" /></td>
								</tr>
								<tr>
									<td class="label">Weight (<span class="weight-unit"></span>)</td>
									<td class="input"><input type="text" name="weight2" value="<?php echo $item->weight2; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Volume (<span class="volume-unit"></span>) </td>
									<td class="input"><input type="text" name="volume2" value="<?php echo $item->volume2; ?>" class="v-number-decimal" /></td>
								</tr>

							</tbody>
						</table>
					</td>
					<td style="width: 33%;">
						<table class="general-form form-tc">
							<tbody>
								<tr>
									<td class="label">SKU 3</td>
									<td class="input"><input type="text" name="sku3" value="<?php echo $item->sku3; ?>" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Unit</td>
									<td class="input"><input type="text" name="uom3" value="<?php echo $item->uom3; ?>" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Price</td>
									<td class="input"><input type="text" name="price3" value="<?php echo $item->price3; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 2</td>
									<td class="input"><input type="text" name="price3_2" value="<?php echo $item->price3_2; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 3</td>
									<td class="input"><input type="text" name="price3_3" value="<?php echo $item->price3_3; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 4</td>
									<td class="input"><input type="text" name="price3_4" value="<?php echo $item->price3_4; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Qty Ratio</td>
									<td class="input"><input type="text" name="loose_qty3" value="<?php echo $item->loose_qty3; ?>" class="v-text v-ratio" /></td>
								</tr>
								<tr>
									<td class="label">Weight (<span class="weight-unit"></span>)</td>
									<td class="input"><input type="text" name="weight3" value="<?php echo $item->weight3; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Volume (<span class="volume-unit"></span>) </td>
									<td class="input"><input type="text" name="volume3" value="<?php echo $item->volume3; ?>" class="v-number-decimal" /></td>
								</tr>

							</tbody>
						</table>
					</td>
					<td style="width: 33%;">
						<table class="general-form form-tc">
							<tbody>
								<tr>
									<td class="label">SKU 4</td>
									<td class="input"><input type="text" name="sku4" value="<?php echo $item->sku4; ?>" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Unit</td>
									<td class="input"><input type="text" name="uom4" value="<?php echo $item->uom4; ?>" class="v-text" /></td>
								</tr>
								<tr>
									<td class="label">Price</td>
									<td class="input"><input type="text" name="price4" value="<?php echo $item->price4; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 2</td>
									<td class="input"><input type="text" name="price4_2" value="<?php echo $item->price4_2; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 3</td>
									<td class="input"><input type="text" name="price4_3" value="<?php echo $item->price4_3; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Price 4</td>
									<td class="input"><input type="text" name="price4_4" value="<?php echo $item->price4_4; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Qty Ratio</td>
									<td class="input"><input type="text" name="loose_qty4" value="<?php echo $item->loose_qty4; ?>" class="v-text v-ratio" /></td>
								</tr>
								<tr>
									<td class="label">Weight (<span class="weight-unit"></span>)</td>
									<td class="input"><input type="text" name="weight4" value="<?php echo $item->weight4; ?>" class="v-number-decimal" /></td>
								</tr>
								<tr>
									<td class="label">Volume (<span class="volume-unit"></span>) </td>
									<td class="input"><input type="text" name="volume4" value="<?php echo $item->volume4; ?>" class="v-number-decimal" /></td>
								</tr>

							</tbody>
						</table>
					</td>					
				</tr>
			</table>

			</div>
			
			
			<div id="images" class="tabs">
				
				<h3>Images</h3>
				<table class="general-form">
					<tbody>
					<tr>
						<td class="label">Images <a class="v-btn add-photo">Add</a><br /><br /><small>Maximum 4 photos</small></td>
						<td class="input photo">
						
								<div class="photo photo-new" style="margin-top: 5px; padding: 10px 10px 10px 120px;">

									<strong>Upload Photo</strong><input type="file" name="item_photo_<?php echo $x; ?>" class="v-text v-photo" />
									<input type="radio" name="primary_photo" value="<?php echo $x; ?>" /> Primary photo									

									<br /><input type="checkbox" name="remove_photo_<?php echo $x; ?>" value="1" /> Remove Photo
								</div>
						
						
							<div class="photo-container" style="margin: 5px 0;">
								<?php
									if (strpos($item->image,',')){
										$images = explode(',', $item->image);
									} else {
										if ($item->image) $images[] = $item->image;
									}

								?>
								<?php $x = 1; foreach ($images as $image): ?>
								<div class="v-photo-placeholder" style="width: 100px; float: left; overflow: hidden; margin-right: 15px; text-align: center">
									<img height="100px" src="<?php echo base_url() . '../assets/items/' . $image; ?>" />
								</div>
								<div class="photo photo-edit" style="margin-top: 5px; padding: 10px 10px 10px 120px;">

									<strong>Change Photo</strong><input type="file" name="item_photo_<?php echo $x; ?>" class="v-text v-photo" />
									<?php if ($image == $item->primary_image): ?>
									<input type="radio" name="primary_photo" value="<?php echo $x; ?>" checked="checked" /> Primary photo
									<?php else :?>
									<input type="radio" name="primary_photo" value="<?php echo $x; ?>" /> Primary photo									
									<?php endif; ?>									
									<br /><input type="checkbox" class="remove_photo" name="remove_photo_<?php echo $x; ?>" value="1" /> Remove Photo


								</div>
								<br style="clear:left" />
								<?php $x++; endforeach; ?>
							</div>
							
						</td>
					</tr>
					</tbody>
				</table>
				
				
			</div>
			
			<div id="variants" class="tabs">
			
				<?php if ($item->linked): $variant = $item->parent; ?>
				<h3>This item is a variant of</h3>
				<div class="variant" style="border: 1px solid #EEE; padding: 10px; border-radius: 10px; margin-bottom: 5px">
					<div class="variant-photo" style="width: 88px; height: 88px; border: 1px solid #EEE; float: left; overflow: hidden; margin-right: 15px; text-align: center">
				    	<?php if ($variant->primary_image): ?>
				    	<img src="<?php echo base_url(); ?>assets/items/<?php echo $variant->primary_image; ?>" style="height: 88px" />
				    	<?php endif; ?>
				    </div>
				    <p><strong><span class="variant-name"><?php echo $variant->name; ?></span></strong>
				    	<br /><span class="variant-sku"><?php echo $variant->sku; ?></span>
				    	<br /><span class="variant-price"><?php echo $variant->price; ?></span>
				    	<br /><a href="inventory/item_edit/<?php echo $variant->id; ?>" class="target_main v-btn">Go to Parent Item</a>
				    </p>
				</div>
				
				<?php else: ?>
				
				<h3>Add Variants</h3>
				
				<div class="variant variant-new" style="border: 1px solid #EEE; padding: 10px; border-radius: 10px; margin-bottom: 5px">
						<div class="variant-photo" style="width: 88px; height: 88px; border: 1px solid #EEE; float: left; overflow: hidden; margin-right: 15px; text-align: center">
						</div>
						<p><strong><span class="variant-name"></span></strong>
							<br /><span class="variant-sku"></span>
							<br /><span class="variant-price"></span>
							<br /><a class="remove-variant v-btn">Unlink</a>
						</p>
					</div>
			
				<table class="general-form">
					<tbody>
						<tr>
							<td class="label">Item SKU</td>
							<td class="input">
								
								<input type="text" style="width: 200px" class="v-text variant_sku" />
								<button class="v-btn item-sku">Add</button>
							</td>
						</tr>
					</tbody>
				</table>
				
				<input type="hidden" name="links" class="v-text" value="<?php echo $item->links; ?>" />
				
				<h3>Variants</h3>
				
				<div class="variant-container">
					<div class="variant variant-new" style="border: 1px solid #EEE; padding: 10px; border-radius: 10px; margin-bottom: 5px">
						<div class="variant-photo" style="width: 88px; height: 88px; border: 1px solid #EEE; float: left; overflow: hidden; margin-right: 15px; text-align: center">
						</div>
						<p><strong><span class="variant-name"></span></strong>
							<br /><span class="variant-sku"></span>
							<br /><span class="variant-price"></span>
							<br /><a class="remove-variant v-btn">Unlink</a>
						</p>
					</div>

					<?php
						if (strpos($item->links,',')){
							$variants = explode(',', $item->links);
						} else {
							if ($item->links) $variants[] = $item->links;
						}
					?>
					<?php foreach ($variants as $variant_sku): $variant = $this->inv->get_item_by_sku($variant_sku); ?>
					<div class="variant" style="border: 1px solid #EEE; padding: 10px; border-radius: 10px; margin-bottom: 5px">
						<div class="variant-photo" style="width: 88px; height: 88px; border: 1px solid #EEE; float: left; overflow: hidden; margin-right: 15px; text-align: center">
							<?php if ($variant->primary_image): ?>
							<img src="<?php echo base_url(); ?>assets/items/<?php echo $variant->primary_image; ?>" style="height: 88px" />
							<?php endif; ?>
						</div>
						<p><strong><span class="variant-name"><?php echo $variant->name; ?></span></strong>
							<br /><span class="variant-sku"><?php echo $variant->sku; ?></span>
							<br /><span class="variant-price"><?php echo $variant->price; ?></span>
							<br /><a class="remove-variant v-btn">Unlink</a> <a href="inventory/item_edit/<?php echo $variant->id; ?>" class="target_main v-btn">Go to Variant Item</a>
						</p>
					</div>
					<?php endforeach; ?>
				</div>
				
				<?php endif; ?>
				
			</div>
			

			<div id="remarks" class="tabs">
			<h3>Remarks</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Remarks</td>
						<td class="input"><textarea name="remarks" class="v-textarea"><?php echo $item->remarks; ?></textarea></td>
					</tr>
					<tr>
						<td class="label">Description</td>
						<td class="input"><textarea name="description" class="v-textarea"><?php echo $item->description; ?></textarea></td>
					</tr>

				</tbody>
			</table>
			</div>
		
		</form>
		</div>
	</div>
