<?php if (!$this->user->has_permission('to_create_purchase_request','Inventory')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var content;
var itemCount = 0;
var listItem = $('tr.order-item').clone();

function readyAdd(status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		showDialog('ok','New Purchase Request','New purchase request has been created.');
		$('input.extraCharges').val('0.00');
		$('input.adjustment').val('0.00');
		
		$('table.order-form tbody').html('');
		calculateTotal();
		form_warning = false;
	} else {
		showDialog('ok','Error','There has been an error adding the purchase request.');
		$('div.main_full').show();
		$('div.status').hide();
	}
}

$(document).ready(function(){

	$('tr.order-item').remove();
	
	$('select.v-warehouse').change(function(){
		var id = $(this).val();
		$('input.name').val('Loading...').attr('disabled',true);
		$('input.mobile').val('');
		$('input.address1').val('');
		$('input.address2').val('');
		$('input.zipcode').val('');
		$('input.city').val('');

		$.ajax({
			url: base_url + 'inventory/get_warehouse_details/' + id,
			dataType: 'json',
			success: function(data){
				$('input.name').val(data.name).attr('disabled',false);
				$('input.tel').val(data.tel);
				$('input.address1').val(data.address1);
				$('input.address2').val(data.address2);
				$('input.zipcode').val(data.zipcode);
				$('input.city').val(data.city);
				$('select.v-country').attr('state',data.state).val(data.country).change();
			}
		})
	});
	
	
	$('select.term').change(function(){
		if ($(this).val() == 'Cash'){
			$('input.duration').attr('disabled',true).val('N/A');
		} else {
			$('input.duration').attr('disabled',false).val('');
		}
	})
	
	$('select.term').change();
	
	$('a.submit_btn').click(function(event){
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('a.target_dialog').live('click',function(e){
		e.preventDefault();
		
		var href = $(this).attr('href');
		$.ajax({
			url: base_url + href,
			success: function (res){
				$('#new-item div.global-modal-form-body').html(res);
				hideModalForm('product-search');
				showModalForm('new-item');
			}
		})
	})
	
	$('a.done-new-item').live('click',function(e){
		e.preventDefault();
		hideModalForm('new-item');
		showModalForm('product-search');
		$('a.search').click();
	})
	
	$('input.margin').live('change',function(){
		var margin = parseFloat($(this).val());
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = (100 * cost) / (100 - margin);
		
		$(this).parents('td').find('input.item_selling_price').val(selling.toFixed(2));
		
	});
	
	$('input.item_selling_price').live('change',function(){
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = parseFloat($(this).val());
		var gp = selling - cost;
		var margin = gp / selling * 100;
		var id = $(this).parents('td').find('input.item_id').val();
		$(this).attr('name','price['+id+']');
		$(this).parents('td').find('input.margin').val(margin.toFixed(2));	
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});


	
	$('input[name=product_search]').keypress(function(e){
		var code = (e.keyCode ? e.keyCode : e.which);
		if (code == 13){
			var t = $('select[name=st]').val();
			var q = $(this).val();
			$('div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
			$.ajax({
				type: "POST",
				url: base_url + 'inventory/search_product/' + q + '/' + t + '/' + cid,
				success: function (html){
	
					$('div.modal-search-result table.grid_data').html(html);
				}			
			}); 
		}
	});
	
	$('a.search').click(function(){
		var t = $('select[name=st]').val();
		var q = $('input[name=product_search]').val();
		$('div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
		$.ajax({
			type: "POST",
			url: base_url + 'inventory/search_product/' + q + '/' + t,
			success: function (html){
				$('div.modal-search-result table.grid_data').html(html);
			}			
		}); 
	});
	
		
	$('a.add-product').click(function(event){
		event.preventDefault();
		showModalForm('product-search');
	});
	
	$('a.add-product-item').click(function(event){
		event.preventDefault();
		$('input.product-items').each(function(){
			if ($(this).attr('checked')){
				addItem($(this).val(),'product');
			}
		});
		itemEvents();
		calculateTotal();
	});
	
	$('a.search-product-done').click(function(event){
		event.preventDefault();
		hideModalForm('product-search');
	});
	
	$('input.extraCharges').change(function(){
		calculateTotal();
	});

	$('input.adjustment').change(function(){
		calculateTotal();
	});
	
	
	
	$('select[name=adjustment_type]').change(function(){
		calculateTotal();
	});
	
	
	$('input[name=copy]').click(function(){
		if ($(this).val() == 'shipping'){
			$('input[name=billing_address1]').val($('input[name=shipping_address1]').val());
			$('input[name=billing_address2]').val($('input[name=shipping_address2]').val());
			$('input[name=billing_city]').val($('input[name=shipping_city]').val());
			$('input[name=billing_postcode]').val($('input[name=shipping_postcode]').val());
			$('input[name=billing_state]').val($('input[name=shipping_state]').val());
			$('input[name=billing_country]').val($('input[name=shipping_country]').val());

		} else {
			$('input[name=shipping_address1]').val($('input[name=billing_address1]').val());
			$('input[name=shipping_address2]').val($('input[name=billing_address2]').val());
			$('input[name=shipping_city]').val($('input[name=billing_city]').val());
			$('input[name=shipping_postcode]').val($('input[name=billing_postcode]').val());
			$('input[name=shipping_state]').val($('input[name=billing_state]').val());
			$('input[name=shipping_country]').val($('input[name=billing_country]').val());
		
		}
	});

	
	itemEvents();
});

function calculateTotal(){
	var netTotal = parseFloat(0);
	var grandTotal = parseFloat(0);
	
	$('td.item_net_price').each(function(){
		netTotal = netTotal + parseFloat($(this).html());
	});
	
	netTotal = netTotal.toFixed(2);

	var charges = $('input.extraCharges').val();
	if (!charges) charges = 0;
	
	var adjustment = $('input.adjustment').val();
	if (!adjustment) adjustment = 0;

	var adjustmentType = $('select[name=adjustment_type]').val();	
	if (adjustmentType == "Add"){
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(charges) + parseFloat(adjustment);
	} else {
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(charges) - parseFloat(adjustment);
	}
	
	grandTotal = parseFloat(grandTotal).toFixed(2);

	$('td.final_net_total').html(netTotal);
	$('td.final_grand_total').html(grandTotal);
	$('input[name=grand_total]').val(grandTotal);

}

function addItem(itemId,type){
	form_warning = true;
	switch (type){
		case 'product':
			var itemNetPrice = $('tr[rel='+itemId+'] span.product-price').html();
			if (!itemNetPrice) itemNetPrice = '0.00';
			
			var itemSellingPrice = $('tr[rel='+itemId+'] span.selling-price').html();
			if (!itemSellingPrice) itemSellingPrice = '0.00';
			
			var itemName = $('tr[rel='+itemId+'] span.product-name').html();
			var desc = '';
			
			var qtyInStock = $('tr[rel='+itemId+'] span.quantity-in-stock').html();
			var qty = $('tr[rel='+itemId+'] input.qty').val();
			
			var itemTotalPrice = qty * itemNetPrice;
			itemTotalPrice = itemTotalPrice.toFixed(2);
			
			if ($('tr[itemid='+itemId+']').hasClass('order-item')) return;
			
			newListItem = $(listItem).clone();
			
			$(newListItem).attr('itemid',itemId);
			$(newListItem).attr('rel',itemCount);
			$(newListItem).find('input.item_id').val(itemId);
			$(newListItem).find('input.item_type').val('product');
			$(newListItem).find('input.item_name').val(itemName);
			$(newListItem).find('input.item_qty').val(qty);
			$(newListItem).find('input.item_net_price').val(itemNetPrice);
			$(newListItem).find('input.item_list_price').val(itemNetPrice);
			$(newListItem).find('input.item_selling_price').val(itemSellingPrice).change();
			$(newListItem).find('input.item_totalnet_price').val(itemTotalPrice);
			$(newListItem).find('td.item_name').html(itemName);
			$(newListItem).find('td.item_qty_in_stock').html(qtyInStock);
			$(newListItem).find('p.item_total_price').val(itemNetPrice);
			
						
			$('table.order-form tbody').append(newListItem);

			itemEvents();
					
			$('tr[rel='+itemCount+']').find('input.item_qty').change();
			itemCount++;
		break;
		case 'service':

		break;
	}
	
	renameDiscountFields();
}


function renameDiscountFields(){
	var x = 0;
	$('input.discount_type').each(function(){
		var n = Math.floor(x / 2);
		$(this).attr('name','item_discount_type['+n+']');
		
		x++;
	});
}

function itemEvents(){

	$('input.item_list_price').unbind('change');
	$('input.item_list_price').change(function(){
		$('input.item_qty').change();
	});
	
	$('input.item_qty').unbind('change');
	$('input.item_qty').change(function(){
		
		var itemNo 			= $(this).parents('tr').attr('rel');
		var itemQty 		= parseInt($(this).val());
		var itemPrice 		= $('tr[rel='+itemNo+']').find('input.item_list_price').val();
		
		var total 			= parseFloat(itemQty * itemPrice) + 0.00;
		var netTotal 		= 0;
		
		var discounted 		= 0;
		var discountType 	= $('tr[rel='+itemNo+']').find('input.discount_type:checked').val();
		var discountVal 	= $('tr[rel='+itemNo+']').find('input.item_discount').val();
		
		if (discountType == 'p'){
			var discounted = parseFloat(((discountVal) / 100) * total).toFixed(2);
			var netTotal = total - discounted;
		} else if (discountType == 'd'){
			var discounted = parseFloat(discountVal).toFixed(2);
			var netTotal = total - discounted;
		} else {
			var netTotal = total;
			var discounted = '0.00';
		}
		
		
		total = total.toFixed(2);
		netTotal = parseFloat(netTotal).toFixed(2);

		$('tr[rel='+itemNo+']').find('input.item_totalnet_price').val(total);
		$('tr[rel='+itemNo+']').find('p.item_total_price').html(total);
		$('tr[rel='+itemNo+']').find('p.item_price_discount').html('-'+discounted);
		$('tr[rel='+itemNo+']').find('td.item_net_price').html(netTotal);
		$('tr[rel='+itemNo+']').find('input.item_net_price').val(itemPrice);
		
		calculateTotal();
	});
	
	$('input.discount_type').unbind('change');
	$('input.discount_type').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('input.item_discount').unbind('change');
	$('input.item_discount').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('a.remove').unbind('click');
	$('a.remove').click(function(){
		$(this).parents('tr').remove();
		var x = 0;
		$('input.rdp').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});
		
		x = 0;
		$('input.rdd').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});

		itemCount = x;
		
		renameDiscountFields();
	});
	
}



</script>
<style>
.hidden{display:none};
</style>
<?php if($this->user->has_permission('to_view_cost_in_inventory','Inventory')){
	$HideCost="";
}else{
	$HideCost="hidden";
}
?>
	<div class="status">
	
	</div>
	<div id="new-item" class="global-modal-form">
		<div class="global-modal-form-body">
		
		</div>		
	</div>
	<div id="product-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Item Search</h3>
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label" style="width: 50px; padding: 0;">Search</label>
					<td><input type="text" class="v-text" name="product_search" class="text" /> in <?=form_dropdown('st',array('SKU'=>'SKU','Product Name'=>'Product Name'),'','class="v-dropdown"')?> <a class="v-btn search">Search</a></td>
				</tr>
			</table>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">Product Name</th>
						<th class="sortable" rel="2" style="width: 100px">Qty</th>
						<th class="sortable" rel="3" style="width: 50px">In Stock</th>
						<th class="<?php echo $HideCost;?> sortable" rel="4" style="width: 80px">Cost (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 14px; padding: 0;"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll">
				<table class="grid grid_data">
					
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;"><a class="v-dbtn add-product-item">Add</a> <a class="v-dbtn search-product-done">Done</a></p>
		</div>
	</div>
	
			
	<div class="toolbar">
		<h3 class="grid-title"><a class="v-dbtn back_btn" style="float:right; padding:0 25px; margin-top: -1px" href="inventory/purchase_requests">Back</a>New Purchase Request</h3>
		<div class="global-tabs" style="padding: 5px">
			<a class="v-btn submit_btn">Save Purchase Request</a>
		</div>
	</div>

	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">

		<form class="insert" method="post" action="<?=base_url()?>inventory/pr_add/do" target="postframe">
			<h3 class="general-form-header">Purchase Request Information</h3>
			
			<table class="general-form">
				<tr class="four">
					<td class="label">Purchase Request Number</td>
					<td class="input">Auto</td>
					<td class="label">Supplier <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('supplier',$suppliers_dropdown,'','class="v-dropdown" style="width: 100%"'); ?></td>
				</tr>
				<tr class="four">
					<td class="label">Date <span class="red">*</span></td>
					<td class="input"><input type="text" name="date" class="v-text date mandatory" /></td>
					<td class="label">Terms <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('terms',array('Credit'=>'Credit','Cash'=>'Cash','Consignment'=>'Consignment'),'','class="v-dropdown term" style="width: 100%"'); ?></td>
				</tr>
				<!--
				<tr class="four">
					<td class="label">Credit Duration (days)</td>
					<td class="input"><input type="text" name="duration" class="v-text duration" /></td>
				</tr>
				-->
				<?php if ($wid = $this->session->userdata('inventory_warehouse')): ?>
				<tr class="four">
					<td class="label">Warehouse</td>
					<td class="input"><?php foreach ($warehouses_dropdown as $id => $warehouse){ if ($wid == $id) echo $warehouse; }; ?></td>
					<td class="label">Contact Person</td>
					<td class="input"><input type="text" name="contact_person" class="v-text" value="<?php echo $this->user->data('firstname') . ' ' . $this->user->data('lastname'); ?>" /></td>
				</tr>
				<?php else: ?>
				<tr class="four">
					<?php
						unset($warehouses_dropdown['*']);
					?>
					<td class="label">Warehouse</td>
					<td class="input"><?=$this->system->config('warehouse_enabled') ? form_dropdown('warehouse',$warehouses_dropdown,'','class="v-warehouse v-dropdown" style="width: 100%"') : 'N/A'; ?></td>
					<td class="label">Contact Person</td>
					<td class="input"><input type="text" name="contact_person" class="v-text" value="<?php echo $this->user->data('firstname') . ' ' . $this->user->data('lastname'); ?>" /></td>
				</tr>				
				<?php endif; ?>
			</table>
			
			<h3>Deliver to</h3>
			
			<?php if ($this->system->config('warehouse_enabled')): ?>
				<?php if ($wid = $this->session->userdata('inventory_warehouse')): ?>
				<?php $warehouse = $this->inv->get_warehouse_by_id($wid); ?>
				
				<table class="general-form">
					<tr class="four">
						<td class="label">Recipient</td>
						<td class="input"><input value="<?php echo $warehouse->name; ?>" type="text" name="delivery[name]" class="name v-text" readonly="readonly" />
						<td class="label">Contact No</td>
						<td class="input"><input value="<?php echo $warehouse->tel; ?>" type="text" name="delivery[mobile]" class="tel v-text" readonly="readonly" />
					</tr>
					<tr class="four">
						<td class="label">Address 1</td>
						<td class="input"><input value="<?php echo $warehouse->address1; ?>" type="text" name="delivery[address1]" class="address1 v-text" readonly="readonly" />
						<td class="label">Address 2</td>
						<td class="input"><input value="<?php echo $warehouse->address2; ?>" type="text" name="delivery[address2]" class="address2 v-text" readonly="readonly" />
					</tr>
					<tr class="four">
						<td class="label">Zipcode</td>
						<td class="input"><input value="<?php echo $warehouse->zipcode; ?>" type="text" name="delivery[zipcode]" class="zipcode v-text" readonly="readonly" />
						<td class="label">City</td>
						<td class="input"><input value="<?php echo $warehouse->city; ?>" type="text" name="delivery[city]" class="city v-text" readonly="readonly" />
					</tr>
					<tr class="four">
						<td class="label">State</td>
						<td class="input"><input value="<?php echo $warehouse->state; ?>" type="text" name="delivery[state]" class="v-text" readonly="readonly" /></td>
						<td class="label">Country</td>
						<td class="input"><input value="<?php echo $warehouse->country; ?>" type="text" name="delivery[country]" class="v-text" readonly="readonly" /></td>
					</tr>
				</table>
				
				<?php else: ?>
				
				<table class="general-form">
					<tr class="four">
						<td class="label">Recipient</td>
						<td class="input"><input value="" type="text" name="delivery[name]" class="name v-text" />
						<td class="label">Contact No</td>
						<td class="input"><input type="text" name="delivery[mobile]" class="mobile v-text" />
					</tr>
					<tr class="four">
						<td class="label">Address 1</td>
						<td class="input"><input type="text" name="delivery[address1]" class="address1 v-text" />
						<td class="label">Address 2</td>
						<td class="input"><input type="text" name="delivery[address2]" class="address2 v-text" />
					</tr>
					<tr class="four">
						<td class="label">Zipcode</td>
						<td class="input"><input type="text" name="delivery[zipcode]" class="zipcode v-text" />
						<td class="label">City</td>
						<td class="input"><input type="text" name="delivery[city]" class="city v-text" />
					</tr>
					<tr class="four">
						<td class="label">State</td>
						<td class="input"><?php echo form_dropdown('delivery[state]',$this->system->state_list($this->system->config('country')), '', 'class="state v-city v-dropdown" style="width: 100%"'); ?></td>
						<td class="label">Country</td>
						<td class="input"><?php echo form_dropdown('delivery[country]',$this->system->country_list(), $this->system->config('country'),'class="country v-country v-dropdown" style="width: 100%"'); ?></td>				
					</tr>
				</table>
				
				<?php endif; ?>
			<?php else: ?>
			
				<?php $company = $this->system->get_company_details(); ?>
				
				<table class="general-form">
					<tr class="four">
						<td class="label">Recipient</td>
						<td class="input"><input value="<?php echo $company->name; ?>" type="text" name="delivery[name]" class="name v-text" />
						<td class="label">Contact No</td>
						<td class="input"><input value="<?php echo $company->tel; ?>" type="text" name="delivery[mobile]" class="tel v-text" />
					</tr>
					<tr class="four">
						<td class="label">Address 1</td>
						<td class="input"><input value="<?php echo $company->address1; ?>" type="text" name="delivery[address1]" class="address1 v-text" />
						<td class="label">Address 2</td>
						<td class="input"><input value="<?php echo $company->address2; ?>" type="text" name="delivery[address2]" class="address2 v-text" />
					</tr>
					<tr class="four">
						<td class="label">Zipcode</td>
						<td class="input"><input value="<?php echo $company->zipcode; ?>" type="text" name="delivery[zipcode]" class="zipcode v-text" />
						<td class="label">City</td>
						<td class="input"><input value="<?php echo $company->city; ?>" type="text" name="delivery[city]" class="city v-text" />
					</tr>
					<tr class="four">
						<td class="label">State</td>
						<td class="input"><?php echo form_dropdown('delivery[state]',$this->system->state_list($company->country), $company->state, 'class="state v-city v-dropdown" style="width: 100%"'); ?></td>
						<td class="label">Country</td>
						<td class="input"><?php echo form_dropdown('delivery[country]',$this->system->country_list(), $company->country,'class="country v-country v-dropdown" style="width: 100%"'); ?></td>				
					</tr>
				</table>
			
			<?php endif; ?>
			
			<h3>Items</h3>
			<table class="order-form">
				<thead>
					<tr class="main-header">
						<th colspan="7">Item Details</th>
					</tr>
					<tr class="sub-header">
						<th style="width: 20px"><img src="<?=base_url()?>images/email-action.gif" alt="Action" /></th>
						<th>Item</th>
						<th style="width: 80px;">Qty in Stock</th>
						<th style="width: 80px">Quantity</th>
						<th class="<?php echo $HideCost;?>" style="width: 290px">List Price</th>
						<th class="<?php echo $HideCost;?>" style="width: 100px">Total</th>
						<th class="<?php echo $HideCost;?>" style="width: 100px">Price</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="<?php if ($HideCost) echo '4'; else echo '7'; ?>" style="padding: 10px 5px"><a class="add-product v-btn" href="#search-product">Add Item</a></td>
					</tr>
					<tr>
						<td class="<?php echo $HideCost;?> final" colspan="6">Net Total</td>
						<td class="<?php echo $HideCost;?> final final_net_total" style="width: 100px">0.00</td>
					</tr>
					<tr>
						<td class="<?php echo $HideCost;?> final" colspan="6">(+) Shipping &amp; Handling Charges</td>
						<td class="<?php echo $HideCost;?> final" style="width: 100px"><input type="text" style="text-align: right" name="sh_charges" class="extraCharges v-number-decimal" value="0.00" /></td>
					</tr>
					<tr>
						<td class="<?php echo $HideCost;?> final" colspan="6">Adjustment <?=form_dropdown('adjustment_type',array('Add'=>'Add','Deduct'=>'Deduct'))?></td>
						<td class="<?php echo $HideCost;?> final" style="width: 100px"><input type="text" style="text-align: right" name="adjustment" class="adjustment v-number-decimal" value="0.00" /></td>
					</tr>
					<tr>
						<td class="<?php echo $HideCost;?> final" colspan="6"><strong>GRAND TOTAL</strong></td>
						<td class="<?php echo $HideCost;?> final final_grand_total" style="width: 100px">0.00</td>
					</tr>

				</tfoot>
				<tbody>
			
			
			
	<tr class="order-item">	
		<td class="item_tool">	
			<input type="hidden" class="item_id" name="item_id[]" />	
			<input type="hidden" class="item_type" name="item_type[]" value="product" />	
			<input type="hidden" class="item_name" name="item_name[]" />	
			<input type="hidden" class="item_qty_in_stock" name="item_qty_in_stock[]" />	
			<input type="hidden" class="item_net_price" name="item_net_price[]" />	
			<input type="hidden" class="item_totalnet_price" name="item_totalnet_price[]" />	
			<a class="remove grid-action grid-action-delete-tx" ><span>Remove Item</span></a>
		</td>	
		<td class="item_name"></td>	
		<td class="item_qty_in_stock"></td>	
		<td class="item_qty">
			<input style="width: 75px; text-align: center;" type="text" class="item_qty v-number" name="item_qty[]" />
		</td>	
		<td class="<?php echo $HideCost;?>" item_prices">	
			<div style="height: 25px;">
				<div style="float: left;"> Cost <input style="width: 60px; text-align: right" type="text" class="item_list_price v-number-decimal" value="0.00" /></div>
				<div style="text-align: right">
					Selling <input style="width: 50px; text-align: right; margin-right: 3px;" type="text" class="item_selling_price v-number-decimal" value="0.00" />
					Margin <input style="width: 30px; text-align: right" type="text" class="margin v-number-decimal" />%
				</div>
				<br style="clear:left" />
			</div>
			<div>
				<input style="width: 80px; float:right; text-align: right" type="text" class="item_discount v-number-decimal" name="item_discount[]" value="0" />	
				Discount
				<label style="display:inline; margin-left: 5px"><input type="radio" class="discount_type rdp" name="item_discount_type[]" value="p" style="display:inline; width: auto" />%</label>
				<label style="display:inline; margin-left: 5px"><input type="radio" class="discount_type rdd" name="item_discount_type[]" value="d" style="display:inline; width: auto" />-</label>
			
			</div>

		</td>	
		<td class="<?php echo $HideCost;?> item_totals">	
			<p class="<?php echo $HideCost;?> item_total_price" style="text-align: right">0.00</p>	
			<p class="<?php echo $HideCost;?>  item_price_discount" style="text-align: right">0.00</p>		
		</td>	
		<td class="<?php echo $HideCost;?> item_net_price" style="text-align: right">0.00</td>
	</tr>			



				</tbody>
			</table>
			<input type="hidden" name="grand_total" />
			
			<h3>Tags</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Tags</td>
						<td class="input"><input value="<?php echo tagcomplete($pr->tags); ?>" type="text" class="v-text autocomplete-tag" name="tags" /></td>
					</tr>
				</tbody>
			</table>
			
			<h3 class="general-form-title">Remarks</h3>
			<table class="general-form">
				<tr>
					<td class="label">Remarks</td>
					<td class="input"><textarea name="remarks"></textarea></td>
				</tr>
			</table>
			
			<br />
		</form>
		</div>
	</div>
