<?php if (!$this->user->has_permission('to_create_stock_count','Inventory')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var itemName;

function readyAdd(status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		var sku = $('input.sku').val();
		$('input.sku').each(function(){
			this.select();
		});
		$('div.notice').html('<p class="v-success">Stock has been updated.</p>');
		$('input.first').focus();
		form_warning = false;
		
		$.ajax({
			url: base_url + 'inventory/stock_take_list/<?php echo $id; ?>',
			data: 'sku='+sku,
			type: 'post',
			success: function (res){
				$('tbody.list').html(res);
			}
		});
		
		$('input.sku').change();
	} else if (status == 0) {
		$('div.notice').html('<p class="v-warning">Item SKU already exists.</p>');
		$('div.main_full').show();
		$('div.status').hide();
	} 
}

$(document).ready(function(){
	windowResize();
	
	
	$('a.create').click(function(event){
		$(this).parents('form').submit();
		event.preventDefault();
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});

	
	
	$('input.margin').change(function(){
		var margin = parseFloat($(this).val());
		var cost = parseFloat($('input.cost').val());
		var selling = (100 * cost) / (100 - margin);
				
		$('input.selling').val(selling.toFixed(2));
		
	});
	
	$('input.selling').change(function(){
		var cost = parseFloat($('input.cost').val());
		var selling = parseFloat($(this).val());
		var gp = selling - cost;
		var margin = gp / selling * 100;
		
		$('input.margin').val(margin.toFixed(2));
		
	});
	
	$('input.count').keypress(function(e){
		if (e.which == 13){
			$(this).parents('form').submit();
			$('input.count').each(function(){ this.select() });
		}
	})
	
	$('input.sku').keypress(function(e){
		if (e.which == 13){
			$('input.sku').change();
		}
	})
	
	itemName = new $.TextboxList('input.autocomplete-item-single',{unique: true, max: 1, plugins: {autocomplete: {
		minLength: 1,
		queryRemote: true,
		onlyFromValues: true,
		remote: {url: base_url + 'autocomplete/search/item'}
	}}});
	
	itemName.addEvent('bitBoxAdd', function(bit) {
		$('input.count').focus();
		$('ul.textboxlist-autocomplete-results').hide();		
		$('input.count').focus();
		var sku = bit.autoValue[0];
		$('input.sku').val(sku).change();

		setTimeout(function(){

			$('input.count').focus();
		}, 50);
	});
	
	$('input.sku').change(function(){
		var sku = $(this).val();
		$('div.notice').html('');
		$.ajax({
			url: base_url + 'inventory/item_by_sku',
			data: 'sku='+sku,
			dataType: 'json',
			type: 'post',
			success: function (json){
				$('input.cost').val(json.cost);
				$('input.name').val(json.name);
				
				console.log(json);

				$('input.price').val(json.price);
				$('input.qty').val(json.qty);
				$('input.count').focus();
				
				$('input.model').val(json.model);
				$('input.oldstock').val(json.oldstock);
				
				$('select.brand').val(json.brand);
				$('select.category').val(json.category);
				$('select.subcategory').val(json.subcategory);

				itemName.setValues([json.name,json.id,json.name]);
			}
		});
		
		$.ajax({
			url: base_url + 'inventory/stock_take_list/<?php echo $id; ?>',
			data: 'sku='+sku,
			type: 'post',
			success: function (res){
				$('tbody.list').html(res);
				$('input.total_count').val($('td.total_count').text());
			}
		});

	});
	
});

</script>
	<div class="toolbar">
		<h3 class="grid-title"><a href="inventory/stock_count" style="float:right; padding: 0px 20px; margin-top: -1px;" class="v-dbtn target_main">Back</a>Stock Count</h3>
	</div>
	<div class="status">
	
	</div>
	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">


		<form method="post" action="<?=base_url()?>inventory/stock_count_entry/<?php echo $id; ?>/do" target="postframe">
			<div class="notice" style="margin-bottom: 15px">
			
			</div>
			<h3>Item Information</h3>
			<table class="general-form">
				<tbody>
					<tr class="four">
						<td class="label">Item SKU</td>
						<td class="input"><input type="text" name="sku" class="v-text mandatory sku" /></td>
						<td class="label">Category</td>
						<td class="input"><?php echo form_dropdown('category',$this->inv->get_categories(true),'', 'class="v-dropdown category" style="width: 100%"'); ?></td>

					</tr>
					<tr class="four">
						<td class="label">Item Name</td>
						<td class="input"><input type="text" name="name" class="v-text name autocomplete-item-single" /></td>
						<td class="label">Subcategory</td>
						<td class="input"><?php echo form_dropdown('subcategory',$this->inv->get_subcategories(true),'', 'class="v-dropdown subcategory" style="width: 100%"'); ?></td>

					</tr>
					<tr class="four">
						<td class="label">Model No</td>
						<td class="input"><input type="text" name="model" class="v-text model" /></td>
						<td class="label">Brand</td>
						<td class="input"><?php echo form_dropdown('brand',$this->inv->get_brands(true), $item->brand, 'class="v-dropdown brand" style="width: 100%"'); ?></td>
					</tr>
					<tr class="four">
						<td class="label">Cost (<?php echo $this->system->config('currency'); ?>)</td>
						<td class="input"><input type="text" name="cost" class="v-text v-number-decimal cost" /></td>
						<td class="label">Selling Price (<?php echo $this->system->config('currency'); ?>)</td>
						<td class="input"><input type="text" name="price" class="v-text v-number-decimal price" /></td>
					</tr>
					<tr class="four">
						<td class="label">Qty in Stock</td>
						<td class="input"><input type="text" name="qty" class="v-text qty" /></td>
						<td class="label">Total Count</td>
						<td class="input"><input type="text" name="total_count" class="v-text total_count" /></td>
					</tr>
					
				</tbody>
			</table>
			<h3>Stock Count</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Count Quantity</td>
						<td class="input" style="padding-top: 5px"><input style="width: 100px" type="text" name="count" class="v-number-decimal count" /> <a class="v-btn create">Update</a></td>
					</tr>

				</tbody>
			</table>
			</table>
			<hr />
			<div class="stock-take-table">
				<table class="grid">
					<thead>
						<tr>
							<th>User</th>
							<th>Datetime</th>
							<th>Qty</th>
							<th style="width: 25px;"></th>
						</tr>
					</thead>
					<tbody class="list">
					
					</tbody>
				</table>
			</div>
		</form>
		</div>
	</div>
