<script type="text/javascript">

$(document).ready(function(){

	$('div.filter input').keypress(function(e){
		
		if (e.which == 13) filterItems();
	});
	
	$('div.filter select').keypress(function(e){
		if (e.which == 13) filterItems();
	});
	
	$('a.filter-btn').click(function(){
		filterItems();
	});
	
	$('select[name=filter]').change(function(){
		var option = $(this).val();

		if (option == 1){
			$('table.grid_data tr').show();
			$('table.grid_data tr').removeClass('alt');
			$('table.grid_data tr:even').addClass('alt');

		} else if (option == 2){
			$('table.grid_data tr').hide();
			$('table.grid_data tr.counted').show();
			$('table.grid_data tr.counted').removeClass('alt');
			$('table.grid_data tr.counted:even').addClass('alt');

		} else if (option == 3){
			$('table.grid_data tr').hide();
			$('table.grid_data tr.differ').show();		
			$('table.grid_data tr.differ').removeClass('alt');
			$('table.grid_data tr.differ:even').addClass('alt');
		} else if (option == 4){
			$('table.grid_data tr').hide();
			$('table.grid_data tr.uncounted').show();		
			$('table.grid_data tr.uncounted').removeClass('alt');
			$('table.grid_data tr.uncounted:even').addClass('alt');
		} else if (option == 5){
			$('table.grid_data tr').hide();
			$('table.grid_data tr.matched').show();		
			$('table.grid_data tr.matched').removeClass('alt');
			$('table.grid_data tr.matched:even').addClass('alt');
		}
		
		
	});
	
	$('a.confirm-stock-count').click(function(){
		var stid = $(this).attr('rel');
		var remarks = $('input.remarks').val();
		$('div.execute').html('Processing...');

		$.ajax({
			url: base_url + 'inventory/stock_take_execute/' + stid + '/do',
			type: 'post',
			data: 'remarks=' + remarks,
			success: function (res){
				$('div.execute').html('Stock count confirmed! Remarks: ' + remarks);
			}
		})	
	});

});

function filterItems(){
	var number = $('input.filter-number').val();
	var date_from = $('input.filter-date-from').val();
	var date_to = $('input.filter-date-to').val();
	var payment_status = $('select.filter-payment-status').val();
	var status = $('select.filter-status').val();
	var term = $('select.filter-term').val();

	
	$('table.grid tbody').html('<td colspan="7" style="text-align: center; padding: 20px"><img src="'+base_url+'images/loading.gif" /> Loading</td>');
	
	
	$.ajax({
		url: base_url + 'inventory/sc_filter',
		type: 'POST',
		data: 'date_from='+date_from+'&date_to='+date_to,
		success: function (result){
			$('table.grid tbody').html(result);
			populateEvents();
		}
	})
}


</script>
		<div class="toolbar">
			<h3 class="grid-title"><a href="inventory/stock_count" class="v-btn target_main float_right" style="padding:0 10px; font-weight: normal">Back</a>Stock Count Report</h3>
			<div class="global-tabs" style="padding: 5px 5px; font-size: 10pt;">
				Filter <?php echo form_dropdown('filter',array('1'=>'All','2'=>'Counted','3'=>'Mismatched','4'=>'Uncounted','5'=>'Matched'),'','style="font-size: 10pt; margin-right: 50px"'); ?> 
				<?php if ($stock_count->status == 'Pending'): ?>
					<?php if ($this->user->has_permission('to_process_stock_count','Inventory')): ?>
					<div style="display: inline;" class="execute"><span class="execute">Remarks <input class="v-text remarks" type="text" name="remarks" /> <a rel="<?php echo $stid; ?>" class="v-btn confirm-stock-count">Confirm Stock Count</a></span></div>
					<?php endif; ?>
				<?php else: ?>
					Remarks: <?php echo $stock_count->remarks; ?>
				<?php endif; ?>

			</div>
			
			<table class="grid">
				<thead>
					<tr>
						<th>Item</th>
						<th style="width: 150px">SKU</th>
						<th style="width: 150px">Category</th>
						<th style="width: 100px">Qty Recorded</th>
						<th style="width: 100px">Qty Counted</th>
						<th style="width: 40px; text-align: center">+</th>
						<th style="width: 40px; text-align: center">-</th>
						<th style="width: 15px; padding: 0"></th>
					</tr>
				</thead>

			</table>
    	</div>
		
		<div class="main_full">
			<table class="grid grid_data">
				<?php if ($stock_count->status == 'Completed'): ?>
					<tbody>
						<?php $x=0; foreach ($items as $item): ?>
							<?php
								if ($item->counted) $counted_class = 'counted';
								else $counted_class = 'uncounted';
								
								if ($item->differ) $differ_class = 'differ';
								else $differ_class = $item->counted ? 'matched' : '';
							?>
						<tr <?php echo $x%2 == 0 ? 'class="alt '.$counted_class.' '.$differ_class.'"' : 'class="'.$counted_class.' '.$differ_class.'"'; ?>>
							<td><?php echo $item->name; ?></td>
							<td style="width: 150px"><?php echo $item->sku; ?></td>
							<td style="width: 150px"><?php echo $item->category; ?></td>
							<td style="width: 100px; text-align: right"><?php echo $old = $item->count_qty ? $item->count_qty + $item->discrepancy : 'N/A'; ?></td>
							<td style="width: 100px; text-align: right"><?php echo $new = $item->count_qty ? $item->count_qty : 'N/A'; ?></td>
							<td style="width: 40px; text-align: right"><?php if (($pdev = $new - $old) > 0) echo $new - $old; else echo 0; ?></td>
							<td style="width: 40px; text-align: right"><?php if (($ndev = $old - $new) > 0) echo $ndev; else echo 0; ?></td>
						</tr>
						<?php
							$oldinc += $old;
							$newinc += $new;
							if ($pdev > 0) $pdev_total += $pdev;
							if ($ndev > 0) $ndev_total += $ndev;
						?>
						<?php $x++; endforeach; ?>
						<tr style="background: #DDD; font-weight:bold">
							<td colspan="3"></td>
							<td style="text-align: right"><?php echo $oldinc; ?></td>
							<td style="text-align: right"><?php echo $newinc; ?></td>
							<td style="text-align: right"><?php echo $pdev_total; ?></td>
							<td style="text-align: right"><?php echo $ndev_total; ?></td>
	
						</tr>
					</tbody>

				
				<?php else: ?>
					<tbody>
						<?php $x=0; foreach ($items as $item): ?>
							<?php
								if ($item->counted) $counted_class = 'counted';
								else $counted_class = 'uncounted';
								
								if ($item->differ) $differ_class = 'differ';
								else $differ_class = $item->counted ? 'matched' : '';
							?>
						<tr <?php echo $x%2 == 0 ? 'class="alt '.$counted_class.' '.$differ_class.'"' : 'class="'.$counted_class.' '.$differ_class.'"'; ?>>
							<td><?php echo $item->name; ?></td>
							<td style="width: 150px"><?php echo $item->sku; ?></td>
							<td style="width: 150px"><?php echo $item->category; ?></td>
							<td style="width: 100px; text-align: right"><?php echo $old = $item->qty; ?></td>
							<td style="width: 100px; text-align: right"><?php echo $new = $item->count_qty; ?></td>
							<td style="width: 40px; text-align: right"><?php if (($pdev = $new - $old) > 0) echo $new - $old; else echo 0; ?></td>
							<td style="width: 40px; text-align: right"><?php if (($ndev = $old - $new) > 0) echo $ndev; else echo 0; ?></td>
						</tr>
						<?php
							$oldinc += $old;
							$newinc += $new;
							if ($pdev > 0) $pdev_total += $pdev;
							if ($ndev > 0) $ndev_total += $ndev;
						?>
						<?php $x++; endforeach; ?>
						<tr style="background: #DDD; font-weight:bold">
							<td colspan="3"></td>
							<td style="text-align: right"><?php echo $oldinc; ?></td>
							<td style="text-align: right"><?php echo $newinc; ?></td>
							<td style="text-align: right"><?php echo $pdev_total; ?></td>
							<td style="text-align: right"><?php echo $ndev_total; ?></td>
	
						</tr>
					</tbody>
				<?php endif; ?>
			</table>
		</div>