<?php if (!$this->user->has_permission('to_edit_stock_movement','Inventory')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var content;
var itemCount = 0;
var listItem = $('tr.order-item:first-child').clone();

function readyAdd(status){
	if (status == 1){	
		$('div.main_full').show();
		$('div.status').hide();
		showDialog('ok','Purchase Order','Purchase order has been updated.');
		calculateTotal();
		form_warning = false;
	} else {
		showDialog('ok','Error','There has been an error saving the purchase order.');
		$('div.main_full').show();
		$('div.status').hide();
	}
}

$(document).ready(function(){
	
	$('a.submit_btn').click(function(event){
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('a.target_dialog').live('click',function(e){
		e.preventDefault();
		
		var href = $(this).attr('href');
		$.ajax({
			url: base_url + href,
			success: function (res){
				$('#new-item div.global-modal-form-body').html(res);
				hideModalForm('product-search');
				showModalForm('new-item');
			}
		})
	})
	
	$('a.done-new-item').live('click',function(e){
		e.preventDefault();
		hideModalForm('new-item');
		showModalForm('product-search');
		$('a.search').click();
	})
	
	$('input.margin').live('change',function(){
		var margin = parseFloat($(this).val());
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = (100 * cost) / (100 - margin);
		
		$(this).parents('td').find('input.item_selling_price').val(selling.toFixed(2));
		
	});
	
	$('input.item_selling_price').live('change',function(){
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = parseFloat($(this).val());
		var gp = selling - cost;
		var margin = gp / selling * 100;
		
		var id = $(this).parents('td').find('input.item_id').val();
		$(this).attr('name','price['+id+']');

		$(this).parents('td').find('input.margin').val(margin.toFixed(2));	
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
	$('input[name=product_search]').keypress(function(e){
		var code = (e.keyCode ? e.keyCode : e.which);
		if (code == 13){
			var t = $('select[name=st]').val();
			var q = $(this).val();
			$('div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
			$.ajax({
				type: "POST",
				url: base_url + 'inventory/search_product/' + q + '/' + t,
				success: function (html){
	
					$('div.modal-search-result table.grid_data').html(html);
				}			
			}); 
		}
	});
	
	$('a.search').click(function(){
		var t = $('select[name=st]').val();
		var q = $('input[name=product_search]').val();
		$('div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
		$.ajax({
			type: "POST",
			url: base_url + 'inventory/search_product/' + q + '/' + t,
			success: function (html){
				$('div.modal-search-result table.grid_data').html(html);
			}			
		}); 
	});
		
	$('a.add-product').click(function(event){
		event.preventDefault();
		showModalForm('product-search');
	});
	
	$('a.add-product-item').click(function(event){
		event.preventDefault();
		$('input.product-items').each(function(){
			if ($(this).attr('checked')){
				addItem($(this).val(),'product');
			}
		});
		itemEvents();
		calculateTotal();
	});
	
	$('a.search-product-done').click(function(event){
		event.preventDefault();
		hideModalForm('product-search');
	});
	
	$('input.extraCharges').change(function(){
		calculateTotal();
	});

	$('input.adjustment').change(function(){
		calculateTotal();
	});
	
	
	
	$('select[name=adjustment_type]').change(function(){
		calculateTotal();
	});
	
	
	$('input[name=copy]').click(function(){
		if ($(this).val() == 'shipping'){
			$('input[name=billing_address1]').val($('input[name=shipping_address1]').val());
			$('input[name=billing_address2]').val($('input[name=shipping_address2]').val());
			$('input[name=billing_city]').val($('input[name=shipping_city]').val());
			$('input[name=billing_postcode]').val($('input[name=shipping_postcode]').val());
			$('input[name=billing_state]').val($('input[name=shipping_state]').val());
			$('input[name=billing_country]').val($('input[name=shipping_country]').val());

		} else {
			$('input[name=shipping_address1]').val($('input[name=billing_address1]').val());
			$('input[name=shipping_address2]').val($('input[name=billing_address2]').val());
			$('input[name=shipping_city]').val($('input[name=billing_city]').val());
			$('input[name=shipping_postcode]').val($('input[name=billing_postcode]').val());
			$('input[name=shipping_state]').val($('input[name=billing_state]').val());
			$('input[name=shipping_country]').val($('input[name=billing_country]').val());
		
		}
	});

	
	itemEvents();
	
	$('input.item_qty').change();
	
	renameDiscountFields();
	
});

function calculateTotal(){
	var netTotal = parseFloat(0);
	var grandTotal = parseFloat(0);
	
	$('td.item_net_price').each(function(){
		netTotal = netTotal + parseFloat($(this).html());
	});
	
	netTotal = netTotal.toFixed(2);

	var charges = $('input.extraCharges').val();
	if (!charges) charges = 0;
	
	var adjustment = $('input.adjustment').val();
	if (!adjustment) adjustment = 0;

	var adjustmentType = $('select[name=adjustment_type]').val();	
	if (adjustmentType == "Add"){
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(charges) + parseFloat(adjustment);
	} else {
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(charges) - parseFloat(adjustment);
	}
	
	grandTotal = parseFloat(grandTotal).toFixed(2);

	$('td.final_net_total').html(netTotal);
	$('td.final_grand_total').html(grandTotal);
	$('input[name=grand_total]').val(grandTotal);

}

function addItem(itemId,type){
	form_warning = true;
	switch (type){
		case 'product':
			var itemNetPrice = $('tr[rel='+itemId+'] span.product-price').html();
			if (!itemNetPrice) itemNetPrice = '0.00';
			
			var itemSellingPrice = $('tr[rel='+itemId+'] span.selling-price').html();
			if (!itemSellingPrice) itemSellingPrice = '0.00';
			
			var itemName = $('tr[rel='+itemId+'] span.product-name').html();
			var desc = '';
			
			var qtyInStock = $('tr[rel='+itemId+'] span.quantity-in-stock').html();
			var qty = $('tr[rel='+itemId+'] input.qty').val();
			
			var itemTotalPrice = qty * itemNetPrice;
			itemTotalPrice = itemTotalPrice.toFixed(2);
			
			if ($('tr[itemid='+itemId+']').hasClass('order-item')) return;
			
			newListItem = $(listItem).clone();
			
			$(newListItem).attr('itemid',itemId);
			$(newListItem).attr('rel',itemCount);
			$(newListItem).find('input.item_id').val(itemId);
			$(newListItem).find('input.item_type').val('product');
			$(newListItem).find('input.item_name').val(itemName);
			$(newListItem).find('input.item_qty').val(qty);
			$(newListItem).find('input.item_net_price').val(itemNetPrice);
			$(newListItem).find('input.item_list_price').val(itemNetPrice);
			$(newListItem).find('input.item_selling_price').val(itemSellingPrice).change();
			$(newListItem).find('input.item_totalnet_price').val(itemTotalPrice);
			$(newListItem).find('td.item_name').html(itemName);
			$(newListItem).find('td.item_qty_in_stock').html(qtyInStock);
			$(newListItem).find('p.item_total_price').val(itemNetPrice);
			
						
			$('table.order-form tbody').append(newListItem);

			itemEvents();
					
			$('tr[rel='+itemCount+']').find('input.item_qty').change();
			itemCount++;
		break;
		case 'service':

		break;
	}
	
	renameDiscountFields();
}


function renameDiscountFields(){
	var x = 0;
	$('input.discount_type').each(function(){
		var n = Math.floor(x / 2);
		$(this).attr('name','item_discount_type['+n+']');
		
		x++;
	});
}

function itemEvents(){

	$('input.item_list_price').unbind('change');
	$('input.item_list_price').change(function(){
		$('input.item_qty').change();
	});
	
	$('input.item_qty').unbind('change');
	$('input.item_qty').change(function(){
		
		var itemNo 			= $(this).parents('tr').attr('rel');
		var itemQty 		= parseInt($(this).val());
		var itemPrice 		= $('tr[rel='+itemNo+']').find('input.item_list_price').val();
		
		var total 			= parseFloat(itemQty * itemPrice) + 0.00;
		var netTotal 		= 0;
		
		var discounted 		= 0;
		var discountType 	= $('tr[rel='+itemNo+']').find('input.discount_type:checked').val();
		var discountVal 	= $('tr[rel='+itemNo+']').find('input.item_discount').val();
		
		if (discountType == 'p'){
			var discounted = parseFloat(((discountVal) / 100) * total).toFixed(2);
			var netTotal = total - discounted;
		} else if (discountType == 'd'){
			var discounted = parseFloat(discountVal).toFixed(2);
			var netTotal = total - discounted;
		} else {
			var netTotal = total;
			var discounted = '0.00';
		}
		
		
		total = total.toFixed(2);
		netTotal = parseFloat(netTotal).toFixed(2);

		$('tr[rel='+itemNo+']').find('input.item_totalnet_price').val(total);
		$('tr[rel='+itemNo+']').find('p.item_total_price').html(total);
		$('tr[rel='+itemNo+']').find('p.item_price_discount').html('-'+discounted);
		$('tr[rel='+itemNo+']').find('td.item_net_price').html(netTotal);
		$('tr[rel='+itemNo+']').find('input.item_net_price').val(itemPrice);
		
		calculateTotal();
	});
	
	$('input.discount_type').unbind('change');
	$('input.discount_type').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('input.item_discount').unbind('change');
	$('input.item_discount').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	
	$('a.remove').unbind('change');
	$('a.remove').click(function(){
		$(this).parents('tr').remove();
		var x = 0;
		$('input.rdp').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});
		
		x = 0;
		$('input.rdd').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});

		itemCount = x;
		
		renameDiscountFields();
	});
	
}



</script>
	<div class="status">
	
	</div>
	<div id="product-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Item Search</h3>
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label" style="width: 50px; padding: 0;">Search</label>
					<td><input type="text" class="v-text" name="product_search" class="text" /> in <?=form_dropdown('st',array('SKU'=>'SKU','Product Name'=>'Product Name'),'','class="v-dropdown"')?> <a class="v-btn search">Search</a></td>
				</tr>
			</table>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">Product Name</th>
						<th class="sortable" rel="2" style="width: 100px">Qty</th>
						<th class="sortable" rel="3" style="width: 50px">In Stock</th>
						<th class="sortable" rel="4" style="width: 80px">Cost (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 14px; padding: 0;"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll">
				<table class="grid grid_data">
					
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;"><a class="v-dbtn add-product-item">Add</a> <a class="v-dbtn search-product-done">Done</a></p>
		</div>
	</div>
		
	<div class="toolbar">
		<h3 class="grid-title"><a class="v-dbtn back_btn" style="float:right; padding:0 25px; margin-top: -1px" href="inventory/stock_movements">Back</a>Edit Stock Movement</h3>
		<div class="global-tabs" style="padding: 5px">
			<a class="v-btn submit_btn">Save Stock Movement</a>
		</div>
	</div>
	
	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing/load/<?php echo mt_rand(10000,99999)?>" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">

		<form class="insert" method="post" action="<?=base_url()?>inventory/wm_edit/<?php echo $wm->id;?>/do" target="postframe">
			<h3 class="general-form-header">Stock Movement Information</h3>
			<table class="general-form">
				<tr class="four">
					<td class="label">Movement Note Number</td>
					<td class="input">SM-<?php echo $wm->id; ?></td>
					<td class="label">Date <span class="red">*</span></td>
					<td class="input"><input type="text" name="delivered_date" value="<?php echo date('d/m/Y',strtotime($wm->delivered_date)); ?>" class="v-text date mandatory" /></td>
				</tr>
				<tr class="four">
					<td class="label">From Warehouse <span class="red">*</span></td>
					<td class="input"><?php echo form_dropdown('from_warehouse', $warehouses_dropdown, $wm->from_warehouse, 'class="v-dropdown" style="font-size: 10pt; width: 100%;"'); ?></td>
					<td class="label">To Warehouse <span class="red">*</span></td>
					<td class="input"><?php echo form_dropdown('to_warehouse', $warehouses_dropdown, $wm->to_warehouse, 'class="v-dropdown" style="font-size: 10pt; width: 100%;"'); ?></td>
				</tr>


			</table>
			
			
			
			
			<h3 class="general-form-title">Items</h3>
			<table class="order-form">
				<thead>
					<tr class="main-header">
						<th colspan="7">Item Details</th>
					</tr>
					<tr class="sub-header">
						<th style="width: 20px"><img src="<?=base_url()?>images/email-action.gif" alt="Action" /></th>
						<th>Item</th>
						<th style="width: 100px">Quantity</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="7" style="padding: 10px 5px"><a class="add-product v-btn" href="#search-product">Add Product</a></td>
					</tr>


				</tfoot>
				<tbody>
					<?php 
						foreach ($wm->items as $order): $i++; 	
					?>
					
					
					
	<tr class="order-item" rel="<?php echo $order->item_id; ?>" itemid="<?php echo $order->item_id; ?>">
		<td class="item_tool">	
			<input type="hidden" class="item_id" name="item_id[]" value="<?php echo $order->item_id; ?>" />	
			<input type="hidden" class="item_type" name="item_type[]" value="product" />	
			<input type="hidden" class="item_name" name="item_name[]" value="<?php echo $order->item_name; ?>" />	
			<input type="hidden" class="item_qty_in_stock" name="item_qty_in_stock[]" />	
			<input type="hidden" class="item_net_price" name="item_net_price[]" value="<?php echo $order->price_per_unit; ?>" />
			<input type="hidden" class="item_totalnet_price" name="item_totalnet_price[]" value="<?php echo $order->price; ?>" />
			<a class="remove grid-action grid-action-delete-tx" ><span>Remove Item</span></a>
		</td>	
		<td class="item_name"><?php echo $order->item_name; ?><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong><?php echo $order->item_sku; ?></strong></td>	
		<td class="item_qty" style="width: 150px">
			<input style="width: 143px; text-align: center; " type="text" class="item_qty v-number" name="item_qty[]" value="<?php echo $order->qty; ?>" />
		</td>	
	</tr>			
					
					

					<?php endforeach; ?>			
				</tbody>
			</table>
			</table>
			<input type="hidden" name="grand_total" />
			
			
			<h3>Tags</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Tags</td>
						<td class="input"><input value="<?php echo tagcomplete($wm->tags); ?>" type="text" class="v-text autocomplete-tag" name="tags" /></td>
					</tr>
				</tbody>
			</table>
			
			<h3 class="general-form-title">Remarks</h3>
			<table class="general-form">
				<tr>
					<td class="label">Remarks</td>
					<td class="input"><textarea name="remarks"><?php echo $wm->remarks; ?></textarea></td>
				</tr>
			</table>
			
			
			<br />
		</form>
		</div>
	</div>
