<?php if (!$this->user->has_access('ledger')) die('You do not have the permissions to access this area.'); ?>

<div id="dashboard-container">

	<div id="global-sidebar">
		<ul id="global-sidebar-list">
			<li class="current"><a href="ledger/overview" class="overview">Overview</a></li>
			<li><a href="ledger/transactions">Transactions</a></li>
			<li><a href="ledger/payable" class="payable">Payable</a></li>
			<li><a href="ledger/receivable" class="receivable">Receivable</a></li>
		</ul>
	</div>
	<div id="global-content">
		<div class="toolbar">
			<h3 class="grid-title">Today&#39;s Transactions</h3>
		</div>
		<div class="main_full">
			<table class="grid">
				<thead>
					<tr>
						<th style="width: 100px">Date</th>
						<th style="width: 150px">Reference No.</th>
						<th>Transaction Details</th>
						<th style="width: 100px">Debit (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 100px">Credit (<?php echo $this->system->config('currency'); ?>)</th>
					</tr>
				</thead>
				<tbody>
					<?php $x = 0; foreach ($transactions as $tx): ?>
					<tr <?php echo $x%2 == 0 ? 'class="alt"': ''; ; ?>>
						<td><?php echo date('d/m/Y',strtotime($tx->datetime)); ?></td>
						<td><?php echo $tx->type == 'sale' ? 'SC-'.$tx->reference_no : 'PO-'.$tx->reference_no; ?></td>
						<td><?php echo $tx->details; ?></td>
						<td style="text-align: right"><?php echo $tx->type == 'sale' ? number_format($tx->amount,2) : ''; ?></td>
						<td style="text-align: right"><?php echo $tx->type == 'purchase' ? number_format($tx->amount_received == 0 ? $tx->amount : $tx->amount_received,2): ''; ?></td>			
						<?php 
							$total_debit += $tx->type == 'sale' ? $tx->amount : 0;
							$total_credit += $tx->type == 'purchase' ? ($tx->amount_received == 0 ? $tx->amount : $tx->amount_received) : 0;
						?>
					</tr>
					<?php $x++; endforeach; ?>
					<tr class="total">
						<td style="text-align: right" colspan="3">Total</td>
						<td class="dark" style="text-align: center"><?php echo number_format($total_debit, 2); ?></td>
						<td class="dark" style="text-align: center"><?php echo number_format($total_credit, 2); ?></td>
					</tr>
					<tr class="balance">
						<td style="text-align: right" colspan="3">Balance</td>
						<td class="dark" colspan="2" style="text-align: center"><?php echo number_format($total_debit - $total_credit, 2); ?></td>
					</tr>
				</tbody>
			</table>
		</div>
	</div>
</div>