<?php if (!$this->user->has_access('ledger')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

$(document).ready(function(){

	$('div.filter input').keypress(function(e){
		
		if (e.which == 13) filterItems();
	});
	
	$('div.filter select').keypress(function(e){
		if (e.which == 13) filterItems();
	});
	
	$('a.filter-btn').click(function(){
		filterItems();
	});
});

function filterItems(){
	var date_from = $('input.filter-date-from').val();
	var date_to = $('input.filter-date-to').val();
	var time_from = $('input.filter-time-from').val();
	var time_to = $('input.filter-time-to').val();
	
	$('table.grid tbody').html('<td colspan="5" style="text-align: center; padding: 20px"><img src="'+base_url+'images/loading.gif" /> Loading</td>');
	
	
	$.ajax({
		url: base_url + 'ledger/transactions_filter',
		type: 'POST',
		data: 'date_from='+date_from+'&date_to='+date_to+'&time_from='+time_from+'&time_to='+time_to,
		success: function (result){
			$('div.main_full').html(result);
		}
	})
}

</script>

	<div class="toolbar">
		<h3 class="grid-title">Transactions</h3>
		<div class="global-tabs filter" style="padding: 5px 5px; font-size: 10pt;">
			Date from <input value="<?php echo $date_from; ?>" type="text" name="date_from" class="v-text date filter-date-from" style="width: 75px; margin-left: 10px" />
			<input value="<?php echo $time_from; ?>" type="text" name="time_from" class="v-text time filter-time-from" style="width: 75px;" />
			<span style="margin-left: 10px; margin-right: 10px">to</span> <input value="<?php echo $date_to; ?>" type="text" name="date_to" class="v-text date filter-date-to" style="width: 75px;" />
			<input value="<?php echo $time_to; ?>" type="text" name="time_to" class="v-text time filter-time-to" style="width: 75px;" />
			<a class="v-btn filter-btn search">Filter</a>
		</div>
		<table class="grid">
			<thead>
				<tr>
					<th style="width: 150px">Date</th>
					<th style="width: 150px">Reference No.</th>
					<th>Transaction Details</th>
					<th style="width: 100px">Debit (<?php echo $this->system->config('currency'); ?>)</th>
					<th style="width: 100px">Credit (<?php echo $this->system->config('currency'); ?>)</th>
					<th style="width: 15px; padding: 0"></th>
				</tr>
			</thead>
		</table>
	</div>
	<div class="main_full">
		<table class="grid grid_data">
			<tbody>
				<?php $x = 0; foreach ($transactions as $tx): ?>
				
				<?php if ($tx->amount_cc == 0 && $tx->amount_cheque == 0 && $tx->amount_credit == 0): ?>
				<tr <?php echo $x%2 == 0 ? 'class="alt"': ''; ; ?>>
					<td style="width: 150px"><?php echo date('d/m/Y h:iA',strtotime($tx->datetime)); ?></td>
					<td style="width: 150px"><?php echo $tx->type == 'sale' ? 'SA-'.$tx->reference_no : 'PO-'.$tx->reference_no; ?></td>
					<td><?php echo $tx->details; ?></td>
					<td style="width: 100px; text-align: right"><?php echo $tx->type == 'sale' ? number_format($tx->amount,2) : ''; ?></td>
					<td style="width: 100px; text-align: right"><?php echo $tx->type == 'purchase' ? number_format($tx->amount_received == 0 ? $tx->amount : $tx->amount_received,2): ''; ?></td>			
					<?php 
						$total_debit += $tx->type == 'sale' ? $tx->amount : 0;
						$total_credit += $tx->type == 'purchase' ? ($tx->amount_received == 0 ? $tx->amount : $tx->amount_received) : 0;
					?>
				</tr>
				
				<?php elseif ($tx->type == 'purchase'): ?>
				
				<tr <?php echo $x%2 == 0 ? 'class="alt"': ''; ; ?>>
					<td style="width: 150px"><?php echo date('d/m/Y h:iA',strtotime($tx->datetime)); ?></td>
					<td style="width: 150px"><?php echo $tx->type == 'sale' ? 'SA-'.$tx->reference_no : 'PO-'.$tx->reference_no; ?></td>
					<td><?php echo $tx->details == 'Cash Sale' ? 'Purchase Order' : $tx->details; ?></td>
					<td style="width: 100px; text-align: right"><?php echo $tx->type == 'sale' ? number_format($tx->amount,2) : ''; ?></td>
					<td style="width: 100px; text-align: right"><?php echo $tx->type == 'purchase' ? number_format($tx->amount_received == 0 ? $tx->amount : $tx->amount_received,2): ''; ?></td>			
					<?php 
						$total_debit += $tx->type == 'sale' ? $tx->amount : 0;
						$total_credit += $tx->type == 'purchase' ? ($tx->amount_received == 0 ? $tx->amount : $tx->amount_received) : 0;
					?>
				</tr>

				
				<?php else: ?>
				
				<?php
					$date = date('d/m/Y h:iA',strtotime($tx->datetime));
					$ref = 'SA-'.$tx->reference_no;
				?>
				
				<?php if ($tx->amount_cash != 0): ?>

				<tr <?php echo $x%2 == 0 ? 'class="alt"' : ''; ; ?>>
					<td style="width: 150px"><?php echo $date; ?></td>
					<td style="width: 150px"><?php echo $ref; ?></td>
					<td><?php echo 'Cash' ?></td>
					<td style="width: 100px; text-align: right"><?php echo $tx->type == 'sale' ? number_format($tx->amount_cash,2) : ''; ?></td>
					<td style="width: 100px; text-align: right"></td>			
					<?php 
						$total_debit += $tx->type == 'sale' ? $tx->amount_cash : 0;
						$date = $ref = null;
					?>
				</tr>
				<?php endif; ?>
				
				<?php if ($tx->amount_credit != 0): ?>
				<tr <?php echo $x%2 == 0 ? 'class="alt"' : ''; ; ?>>
					<td style="width: 150px"><?php echo $date; ?></td>
					<td style="width: 150px"><?php echo $ref; ?></td>
					<td><?php echo 'Credit' ?></td>
					<td style="width: 100px; text-align: right"><?php echo $tx->type == 'sale' ? number_format($tx->amount_credit,2) : ''; ?></td>
					<td style="width: 100px; text-align: right"></td>			
					<?php 
						$total_debit += $tx->type == 'sale' ? $tx->amount_credit : 0;
						$date = $ref = null;
					?>
				</tr>
				<?php endif; ?>
				
				<?php if ($tx->amount_cheque != 0): ?>
				<tr <?php echo $x%2 == 0 ? 'class="alt"' : ''; ; ?>>
					<td style="width: 150px"><?php echo $date; ?></td>
					<td style="width: 150px"><?php echo $ref; ?></td>
					<td><?php echo 'Cheque Payment' ?></td>
					<td style="width: 100px; text-align: right"><?php echo $tx->type == 'sale' ? number_format($tx->amount_cheque,2) : ''; ?></td>
					<td style="width: 100px; text-align: right"></td>			
					<?php 
						$total_debit += $tx->type == 'sale' ? $tx->amount_cheque : 0;
						$date = $ref = null;
					?>
				</tr>
				<?php endif; ?>


				<?php if ($tx->amount_cc != 0): ?>
				<tr <?php echo $x%2 == 0 ? 'class="alt"' : ''; ; ?>>
					<td style="width: 150px"><?php echo $date; ?></td>
					<td style="width: 150px"><?php echo $ref; ?></td>
					<td><?php echo 'Credit Card Payment'; ?></td>
					<td style="width: 100px; text-align: right"><?php echo $tx->type == 'sale' ? number_format($tx->amount_cc,2) : ''; ?></td>
					<td style="width: 100px; text-align: right"></td>			
					<?php 
						$total_debit += $tx->type == 'sale' ? $tx->amount_cc : 0;
						$date = $ref = null;
					?>
				</tr>
				<?php endif; ?>

					
				<?php endif; ?>
				<?php $x++; endforeach; ?>
				<tr class="total">
					<td style="text-align: right" colspan="3">Total</td>
					<td class="dark" style="text-align: center; width: 100px"><?php echo number_format($total_debit, 2); ?></td>
					<td class="dark" style="text-align: center; width: 100px"><?php echo number_format($total_credit, 2); ?></td>
				</tr>
				<tr class="balance">
					<td style="text-align: right" colspan="3">Balance</td>
					<td class="dark" colspan="2" style="text-align: center; width: 200px"><?php echo number_format($total_debit - $total_credit, 2); ?></td>
				</tr>
			</tbody>
		</table>
	</div>