<?php if (!$this->user->has_access('reports')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var reportOutput;
var reportID;

	$(document).ready(function(){
		
		$('a.back').click(function(){
			$(this).fadeOut();
			$('a.save').fadeOut();
			$('a.print').fadeOut();
			hideModalForm('save-report');
			$('div.report').slideUp(500, function(){
				$('div.report-controls').slideDown();
			});

		});
		
		$('a.print').click(function(){
			window.print();
		})
		
		$('a.save').click(function(){
			showModalForm('save-report');
			$('input.title').focus();
		});
		
		$('a.report-discard').click(function(){
			hideModalForm('save-report');
		});
		
		$('a.report-save').click(function(){
			var output = reportOutput;
			var notes = $('textarea.report-notes').val();
			var title = $('input.report-title').val();


			hideModalForm('save-report');			
			$('a.save').hide();
			
			$.ajax({
				url: base_url + 'reports/save_report',
				type: 'post',
				data: 'title='+encodeURIComponent(title)+'&notes='+encodeURIComponent(notes)+'&output='+encodeURIComponent(output)+'&id='+reportID,
				success: function(){
					showDialog('ok','Report Saved','Report has been saved as \''+title+'\'');
					$('textarea.report-notes').val('');
					$('input.report-title').val('');
				}
				
			})
		});
		
		$('a.generate-btn').click(function(){
			$('div.report').html('');
			
			var id = $(this).parents('div.global-module-box').attr('id');
			
			var queryString = 'submit=1';
			$(this).parents('div.global-module-box').find('input').each(function(){
				var field = $(this).attr('field');
				if (field){
					queryString += '&'+field+'=' + encodeURIComponent($(this).val());
				}
			});
			
			$(this).parents('div.global-module-box').find('select').each(function(){
				var field = $(this).attr('field');
				if (field){
					queryString += '&'+field+'=' + encodeURIComponent($(this).val());
				}				
			});
			
			$('div.report-controls').slideUp(500, function(){
				$('div.report').html('<p align="center" style="margin-top: 30px; vertical-align: middle" ><img style="vertical-align:middle" src="images/loading.gif"/> Generating Report...</p>').fadeIn();
				
				$.ajax({
				    url: base_url + 'reports/generate/'+id,
				    type: 'post',
				    data: queryString,
				    success: function(html){
				    	reportOutput = html;
				    	reportID = id;
				    	
				    	$('div.report').fadeOut(500, function(){
					    	$('div.report').html(html).fadeIn(500);
				    	})
				    	$('a.save').fadeIn();
				    	$('a.print').fadeIn();
				    	$('a.back').fadeIn();
				    }
				})

			});
			
		});
		
	});

</script>
<div id="save-report" class="global-modal-form" style="height: 160px; width: 350px">
	<div class="global-modal-form-body">
		<h3>Save Report</h3>
		<table class="grid-form grid-form-transparent">
			<tbody>
				<tr>
					<td class="label">Title</td>
					<td><input type="text" style="width: 80%" name="title" class="v-text report-title" /></td>
				</tr>
				<tr>
					<td class="label">Notes</td>
					<td><textarea class="v-textarea report-notes" name="notes"></textarea></td>
				</tr>
			</tbody>
		</table>
		<hr />
		<p class="align-right">
			<a class="v-dbtn report-save">Save</a>
			<a class="v-dbtn report-discard">Discard</a>
		</p>
	</div>
</div>
		<div class="toolbar">
			<h3 class="grid-title">
				<a class="v-dbtn float_right back" style="font-weight: normal; padding: 0px 25px; margin-top: -1px; display:none">Back</a>
				<?php if ($this->user->has_permission('to_save_report','Reports')): ?>
				<a class="v-btn float_right save" style="font-weight: normal; padding: 0px 25px; margin-top: -1px; margin-right: 5px; display:none">Save</a>
				<?php endif; ?>
				<a class="v-btn float_right print" style="font-weight: normal; padding: 0px 25px; margin-top: -1px; margin-right: 5px; display:none">Print</a>
				Reports
			</h3>
		</div>
		<div class="main_full">
			<div class="report-controls">
				<?php foreach ($reports as $report): if ($report->type != 'Widget'): ?>
				<div style="float:left; width: 50%">
					<div class="global-module-box" id="<?php echo $report->id; ?>" style="margin: 10px">
						<h3><?php echo $report->name; ?></h3>
						<hr />
						<span><?php echo $report->description; ?></span>
						<?php echo eval('?>'.$report->filters); ?>
		
					</div>
				</div>
				<?php endif; endforeach; ?>
				<br style="clear:both" />
			</div>
			<div class="report" style="padding: 15px">
				
			</div>

		</div>