<?php if (!$this->user->has_access('reports')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

$(document).ready(function(){

	$('div.filter input').keypress(function(e){
		
		if (e.which == 13) filterItems();
	});
	
	$('div.filter select').keypress(function(e){
		if (e.which == 13) filterItems();
	});
	
	$('a.filter-btn').click(function(){
		filter();
	});
});

function filter(){
	var date = $('input.filter-date').val();
	var warehouse = $('select.filter-warehouse').val();
	
	$('div.main_full').hide()
	$('div.status').html('<td colspan="7" style="text-align: center; padding: 20px"><img src="'+base_url+'images/loading.gif" /> Loading</td>').show();
	
	
	$.ajax({
		url: base_url + 'reports/sales',
		type: 'POST',
		data: 'date='+date+'&warehouse='+warehouse,
		success: function (result){
			$('#global-content').html(result);
			populateEvents();
		}
	});
}

</script>

	<div class="toolbar">
		<h3 class="grid-title">Daily Sales Report</h3>
		<div class="global-tabs filter" style="padding: 5px 5px; font-size: 10pt;">
			Date <input type="text" name="date" value="<?php echo $current_date ? $current_date : date('d/m/Y',strtotime($date)); ?>" class="v-text date filter-date" style="width: 80px;" />
			<span style="margin-left: 10px;">Warehouse</span> <?php echo form_dropdown('warehouse', $warehouses_dropdown, $current_warehouse, 'class="v-dropdown filter-warehouse" style="width: 130px; font-size: 10pt;"'); ?>
			<a class="v-btn filter-btn search">Filter</a>
		</div>
	</div>
	<div class="status">
	
	</div>

	<div class="main_full">
		<div class="report" style="padding: 15px">
		<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">Sales Report</h2>
		<p style="text-align: center; padding-bottom: 10px; margin-bottom: 20px; border-bottom: 1px solid #CCC">Date: <?php echo date('l, F j, Y',strtotime($date)); ?></p>

			
			<table style="width: 100%; margin-bottom: 20px;">
				<tr>
					<td style="width: 25%">Total Walk-in Sales<br />
						<strong style="font-size: 20pt"><?php echo $this->system->config('currency'); ?><?php echo number_format($sales->total_sales,2); ?></strong>
					</td>
					<td style="width: 25%">Total Invoiced Sales<br />
						<strong style="font-size: 20pt"><?php echo $this->system->config('currency'); ?><?php echo number_format($invoiced_sales->total_sales,2); ?></strong>
					</td>
					<td style="width: 25%">Total Online Sales<br />
						<strong style="font-size: 20pt"><?php echo $this->system->config('currency'); ?><?php echo number_format($online_sales->total_sales,2); ?></strong>
					</td>
					<td style="width: 25%">Total Items Sold<br />
						<strong style="font-size: 20pt"><?php echo number_format($item_qty->total_qty); ?></strong>
					</td>
				</tr>
			</table>
			
			<?php echo $sales_chart; ?>
			
			
			<h3 style="margin-top: 20px">Returns/Reverts</h3>
			<table class="grid">
				<thead>
					<tr>
						<th style="width: 150px">Employee</th>
						<th style="width: 150px">Supervisor</th>
						<th>Items</th>
						<th style="width: 100px">Returned (<?php echo $this->system->config('currency'); ?>)</th>
					</tr>
				</thead>
				<tbody>
					<?php foreach ($reverts as $revert): $sale_data = json_decode($revert->data); ?>
					<tr <?php echo $x%2 != 0 ? 'class="alt"' : ''; ?>>
						<td style="width: 150px"><?php echo $sale_data->sale->employee_username; ?></td>
						<td style="width: 150px"><?php echo $revert->performed_by; ?></td>
						<td><?php foreach ($sale_data->sale_items as $item): ?>
							<?php echo $item->qty; ?> x <?php echo $item->item_name; ?> - <?php echo $item->item_sku; ?><br />
							<?php endforeach; ?>
						</td>
						<td style="width: 100px; text-align: right"><?php echo number_format($sale_data->sale->amount,2); ?></td>
					</tr>
					<?php $x++; endforeach; ?>
				</tbody>
			</table>
			
			<h3 style="margin-top: 20px">POS Items Sold</h3>
			<table class="grid">
			<thead>
				<tr>
					<th style="width: 120px">Item SKU</th>
					<th>Item Name</th>
					<th style="width: 120px">Quantity</th>
					<th style="width: 120px">Amount</th>

				</tr>
			</thead>
			<tbody>
				<?php $x = 0; foreach ($pos_items as $item): ?>
				<tr <?php echo $x%2 != 0 ? 'class="alt"' : ''; ?>>
					<td style="width: 120px"><?php echo $item->item_sku; ?></td>
					<td><?php echo $item->item_name; ?></td>
					<td style="width: 120px; text-align: center;"><?php echo $item->total_qty; ?></td>
					<td style="width: 120px; text-align: right"><?php echo number_format($item->total_profit,2); ?></td>
			
				</tr>
				<?php $x++; $total_qty += $item->total_qty; $total_profit += $item->total_profit; endforeach; ?>
				<tr style="background: #EEE" class="total">
					<td style="border: none;" colspan="2"><strong>Total</strong></td>
					<td style="text-align: center; border: none"><strong><?php echo number_format($total_qty); ?></strong></td>
					<td style="text-align: right; border: none"><strong><?php echo number_format($total_profit,2); ?></strong></td>
				</tr>
			</tbody>
			</table>
			
			<h3 style="margin-top: 20px">Invoiced Items Sold</h3>
			<table class="grid">
			<thead>
				<tr>
					<th style="width: 120px">Item SKU</th>
					<th>Item Name</th>
					<th style="width: 120px">Quantity</th>
					<th style="width: 120px">Amount</th>

				</tr>
			</thead>
			<tbody>
				<?php $x = 0; foreach ($invoiced_items as $item): ?>
				<tr <?php echo $x%2 != 0 ? 'class="alt"' : ''; ?>>
					<td style="width: 120px"><?php echo $item->item_sku; ?></td>
					<td><?php echo $item->item_name; ?></td>
					<td style="width: 120px; text-align: center;"><?php echo $item->total_qty; ?></td>
					<td style="width: 120px; text-align: right"><?php echo number_format($item->total_profit,2); ?></td>
			
				</tr>
				<?php $x++; $total_qty += $item->total_qty; $total_profit += $item->total_profit; endforeach; ?>
				<tr style="background: #EEE" class="total">
					<td style="border: none;" colspan="2"><strong>Total</strong></td>
					<td style="text-align: center; border: none"><strong><?php echo number_format($total_qty); ?></strong></td>
					<td style="text-align: right; border: none"><strong><?php echo number_format($total_profit,2); ?></strong></td>
				</tr>
			</tbody>
			</table>
		</div>
		

	</div>