<?php if (!$this->user->has_access('reports')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

$(document).ready(function(){

	$('div.filter input').keypress(function(e){
		
		if (e.which == 13) filterItems();
	});
	
	$('div.filter select').keypress(function(e){
		if (e.which == 13) filterItems();
	});
	
	$('a.filter-btn').click(function(){
		filter();
	});
});

function filter(){
	var date_from = $('input.filter-date-from').val();
	var date_to = $('input.filter-date-to').val();

	$('div.main_full').hide()
	$('div.status').html('<td colspan="7" style="text-align: center; padding: 20px"><img src="'+base_url+'images/loading.gif" /> Loading</td>').show();
	
	
	$.ajax({
		url: base_url + 'reports/items',
		type: 'POST',
		data: 'date_from='+date_from+'&date_to='+date_to,
		success: function (result){
			$('#global-content').html(result);
			populateEvents();
		}
	});
}

</script>

	<div class="toolbar">
		<h3 class="grid-title">Stock as of <?php echo date('l, F j, Y'); ?></h3>
	</div>
	<div class="status">
	
	</div>

	<div class="main_full">		
		<div class="report" style="padding: 15px">
		<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">Stock</h2>
		<p style="text-align: center; padding-bottom: 10px; margin-bottom: 20px; border-bottom: 1px solid #CCC"><?php echo date('l, F j, Y'); ?></p>
		
		<table class="grid">
			<thead>
				<tr>
					<th style="text-align: center; width: 120px">Item SKU</th>
					<th style="text-align: center">Item name</th>
					<th style="text-align: center; width: 60px">Ordered</th>
					<th style="text-align: center; width: 60px">Allocated</th>
					<th style="text-align: center; width: 60px">Stock</th>
					<th style="text-align: center; width: 60px">Needed</th>
					<th style="text-align: center; width: 80px">Value (<?php echo $this->system->config('currency'); ?>)</th>
					<th style="text-align: center; width: 100px">Stock Value (<?php echo $this->system->config('currency'); ?>)</th>
					<th style="text-align: center; width: 100px">Retail Value (<?php echo $this->system->config('currency'); ?>)</th>
					<th style="text-align: center; width: 100px">Gross Profit (<?php echo $this->system->config('currency'); ?>)</th>
				</tr>
			</thead>
			<tbody>
				<?php $x = 0; foreach ($items as $item): ?>
				<tr <?php echo $x%2 != 0 ? 'class="alt"' : ''; ?>>
					<td style="width: 120px"><?php echo $item->sku; ?></td>
					<td><?php echo $item->name; ?></td>
					<td style="text-align: right; width: 60px"><?php echo number_format($item->ordered); ?></td>
					<td style="text-align: right; width: 60px"><?php echo number_format($item->alert_quantity); ?></td>
					<td style="text-align: right; width: 60px"><?php echo number_format($item->qty); ?></td>
					<?php
						$needed = $item->alert_quantity - $item->qty;
						if ($needed <= 0) $needed = '-';
					?>
					<td style="text-align: right; width: 60px"><?php echo number_format($needed); ?></td>
					<td style="text-align: right; width: 80px"><?php echo number_format($item->cost,4); ?></td>
					<td style="text-align: right; width: 100px"><?php echo number_format($value = $item->cost * $item->qty,4); ?></td>
					<td style="text-align: right; width: 100px"><?php echo number_format($retail_value = $item->price * $item->qty, 2); ?></td>
					<td style="text-align: right; width: 100px"><?php echo number_format($retail_value - $value, 2); ?></td>

				</tr>
				<?php $x++; $total += $item->total_qty; 
					$total_ordered += $item->ordered_quantity;
					$total_allocated += $item->alert_quantity;
					$total_qty += $item->qty;
					$total_needed += $needed;
					$total_value_pu += $item->cost;
					$total_value += $value;
					$total_retail_value += $retail_value;
					$total_gross_profit += $retail_value - $value;
				endforeach; ?>
				<tr style="background: #EEE" class="total">
					<td style="text-align: right; border: none; font-weight: bold" colspan="2"></td>
					<td style="text-align: right; border: none; font-weight: bold"><?php echo $total_ordered; ?></td>
					<td style="text-align: right; border: none; font-weight: bold"><?php echo $total_allocated; ?></td>
					<td style="text-align: right; border: none; font-weight: bold"><?php echo $total_qty; ?></td>
					<td style="text-align: right; border: none; font-weight: bold"><?php echo $total_needed; ?></td>
					<td style="text-align: right; border: none; font-weight: bold"><?php echo number_format($total_value_pu,4); ?></td>
					<td style="text-align: right; border: none; font-weight: bold"><?php echo number_format($total_value, 4); ?></td>
					<td style="text-align: right; border: none; font-weight: bold"><?php echo number_format($total_retail_value,2); ?></td>
					<td style="text-align: right; border: none; font-weight: bold"><?php echo number_format($total_gross_profit,2); ?></td>

				</tr>
			</tbody>
		</table>
		</div>
	</div>