<?php if (!$this->user->has_permission('to_create_credit_note','Sales')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var content;
var itemCount = 0;
var listItem = $('tr.order-item').clone();

function readyAdd(status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		showDialog('ok','New Credit Note','New credit note has been created.');
		$('input.extraCharges').val('0.00');
		$('input.adjustment').val('0.00');
		
		$('table.order-form tbody').html('');
		calculateTotal();
		form_warning = false;
	} else {
		showDialog('ok','Error','There has been an error adding the credit note.');
		$('div.main_full').show();
		$('div.status').hide();
	}
}

$(document).ready(function(){

	$('tr.order-item').remove();
	
	$('a.submit_btn').click(function(event){
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('a.target_dialog').live('click',function(e){
		e.preventDefault();
		
		var href = $(this).attr('href');
		$.ajax({
			url: base_url + href,
			success: function (res){
				$('#new-item div.global-modal-form-body').html(res);
				hideModalForm('product-search');
				showModalForm('new-item');
			}
		})
	})
	
	$('a.done-new-item').live('click',function(e){
		e.preventDefault();
		hideModalForm('new-item');
		showModalForm('product-search');
		$('a.search').click();
	})
	
	$('input.margin').live('change',function(){
		var margin = parseFloat($(this).val());
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = (100 * cost) / (100 - margin);
		
		$(this).parents('td').find('input.item_selling_price').val(selling.toFixed(2));
		
	});
	
	$('input.item_selling_price').live('change',function(){
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = parseFloat($(this).val());
		var gp = selling - cost;
		var margin = gp / selling * 100;
		
		$(this).parents('td').find('input.margin').val(margin.toFixed(2));	
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
		$('input[name=product_search]').keypress(function(e){
		var code = (e.keyCode ? e.keyCode : e.which);
		if (code == 13){
			var t = $('select[name=st]').val();
			var q = $(this).val();
			$('div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
			$.ajax({
				type: "POST",
				url: base_url + 'sales/search_product/' + q + '/' + t,
				success: function (html){
	
					$('div.modal-search-result table.grid_data').html(html);
				}			
			}); 
		}
	});
	
	$('a.search').click(function(){
		var t = $('select[name=st]').val();
		var q = $('input[name=product_search]').val();
		$('div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
		$.ajax({
			type: "POST",
			url: base_url + 'sales/search_product/' + q + '/' + t,
			success: function (html){
				$('div.modal-search-result table.grid_data').html(html);
			}			
		}); 
	});
		
	$('a.add-product').click(function(event){
		event.preventDefault();
		showModalForm('product-search');
	});
	
	$('a.add-product-item').click(function(event){
		event.preventDefault();
		$('input.product-items').each(function(){
			if ($(this).attr('checked')){
				addItem($(this).val(),'product');
			}
		});
		itemEvents();
		calculateTotal();
	});
	
	$('a.search-product-done').click(function(event){
		event.preventDefault();
		hideModalForm('product-search');
	});
	
	$('input.extraCharges').change(function(){
		calculateTotal();
	});

	$('input.adjustment').change(function(){
		calculateTotal();
	});
	
	
	
	$('select[name=adjustment_type]').change(function(){
		calculateTotal();
	});
		
	itemEvents();
	
	
	$('select.item-price-select').live('change',function(){
		$(this).parents('tr').find('span.selling-price').text($(this).val());
		$(this).parents('tr').find('span.product-price').text($(this).val());
	});
});

function calculateTotal(){
	var netTotal = parseFloat(0);
	var grandTotal = parseFloat(0);
	var taxable = 0.00;
	
	$('td.item_net_price').each(function(){
		netTotal = netTotal + parseFloat($(this).html());
	});
	
	netTotal = netTotal.toFixed(2);

	var charges = $('input.extraCharges').val();
	if (!charges) charges = 0;
	
	var adjustment = $('input.adjustment').val();
	if (!adjustment) adjustment = 0;

	var adjustmentType = $('select[name=adjustment_type]').val();	
	if (adjustmentType == "Add"){
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(charges) + parseFloat(adjustment);
	} else {
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(charges) - parseFloat(adjustment);
	}
	
	
	$('tr.order-item').each(function(){
		if ($(this).attr('taxable') == "1"){
			taxable += parseFloat($(this).find('td.item_net_price').html());
		}
	})
	taxable = taxable.toFixed(2);
	
	grandTotal = parseFloat(grandTotal).toFixed(2);
	
	var taxTotal = 0.00;
	$('input.tax').each(function(){
		var inclusive = $(this).attr('inclusive');
		var rel = $(this).attr('rel');
		var percentage = parseFloat($(this).attr('percentage'));
		if (inclusive == "0"){
			var val = parseFloat(taxable) * percentage / 100;
		} else {
			var val = parseFloat(taxable) * percentage / (100+percentage);
		}
		$(this).val(val.toFixed(2));
		if ($('input[name=tax_enabled_'+rel+']').attr('checked')){
			if (inclusive == "0"){
				taxTotal += parseFloat(val);
			}
		} else {
			$(this).val('0.00');
		}

	});


	$('td.final_net_total').html(netTotal);
	$('td.final_grand_total').html((parseFloat(grandTotal)+taxTotal).toFixed(2));
	$('input[name=grand_total]').val((parseFloat(grandTotal)+taxTotal).toFixed(2));

}

function addItem(itemId,type){


	form_warning = true;
	switch (type){
		case 'product':
			var itemNetPrice = $('tr[rel='+itemId+'] span.product-price').html();
			if (!itemNetPrice) itemNetPrice = '0.00';
			
			var itemSellingPrice = $('tr[rel='+itemId+'] span.selling-price').html();
			if (!itemSellingPrice) itemSellingPrice = '0.00';
			
			var itemName = $('tr[rel='+itemId+'] span.product-name').html();
			var desc = '';
			
			var qtyInStock = $('tr[rel='+itemId+'] span.quantity-in-stock').html();
			var qty = $('tr[rel='+itemId+'] input.qty').val();
			
			var itemTotalPrice = qty * itemNetPrice;
			itemTotalPrice = itemTotalPrice.toFixed(2);
			
			// if ($('tr[itemid='+itemId+']').hasClass('order-item')) return;
			
			var taxable = $('#product-search tr[rel='+itemId+']').attr('taxable');
			var tax_code = $('#product-search tr[rel='+itemId+']').attr('tax_code');
			
			newListItem = $(listItem).clone();
			
			$(newListItem).attr('taxable',taxable);
			
			$(newListItem).attr('itemid',itemId);
			$(newListItem).attr('rel',itemCount);
			$(newListItem).find('input.item_id').val(itemId);
			$(newListItem).find('input.item_type').val('product');
			$(newListItem).find('input.item_name').val(itemName);
			$(newListItem).find('input.item_qty').val(qty);
			$(newListItem).find('input.item_net_price').val(itemNetPrice);
			$(newListItem).find('input.item_list_price').val(itemNetPrice);
			$(newListItem).find('input.item_totalnet_price').val(itemTotalPrice);
			
			$(newListItem).find('input.taxable').val(taxable?taxable:'');
			$(newListItem).find('input.tax_code').val(tax_code);

			$(newListItem).find('td.item_name').html(itemName);
			$(newListItem).find('td.item_qty_in_stock').html(qtyInStock);
			$(newListItem).find('p.item_total_price').val(itemNetPrice);
			
						
			$('table.order-form tbody').append(newListItem);

			itemEvents();
					
			$('tr[rel='+itemCount+']').find('input.item_qty').change();
			itemCount++;
		break;
		case 'service':

		break;
	}
	
	renameDiscountFields();
}

function renameDiscountFields(){
	var x = 0;
	$('input.discount_type').each(function(){
		var n = Math.floor(x / 2);
		$(this).attr('name','item_discount_type['+n+']');
		
		x++;
	});
}

function itemEvents(){

	$('input.item_list_price').unbind('change');
	$('input.item_list_price').change(function(){
		$('input.item_qty').change();
	});
	
	$('input.item_qty').unbind('change');
	$('input.item_qty').change(function(){
		
		var itemNo 			= $(this).parents('tr').attr('rel');
		var itemQty 		= parseInt($(this).val());
		var itemPrice 		= $('tr[rel='+itemNo+']').find('input.item_list_price').val();
		
		var total 			= parseFloat(itemQty * itemPrice) + 0.00;
		var netTotal 		= 0;
		
		var discounted 		= 0;
		var discountType 	= $('tr[rel='+itemNo+']').find('input.discount_type:checked').val();
		var discountVal 	= $('tr[rel='+itemNo+']').find('input.item_discount').val();
		
		if (discountType == 'p'){
			var discounted = parseFloat(((discountVal) / 100) * total).toFixed(2);
			var netTotal = total - discounted;
		} else if (discountType == 'd'){
			var discounted = parseFloat(discountVal).toFixed(2);
			var netTotal = total - discounted;
		} else {
			var netTotal = total;
			var discounted = '0.00';
		}
		
		
		total = total.toFixed(2);
		netTotal = parseFloat(netTotal).toFixed(2);

		$('tr[rel='+itemNo+']').find('input.item_totalnet_price').val(total);
		$('tr[rel='+itemNo+']').find('p.item_total_price').html(total);
		$('tr[rel='+itemNo+']').find('p.item_price_discount').html('-'+discounted);
		$('tr[rel='+itemNo+']').find('td.item_net_price').html(netTotal);
		$('tr[rel='+itemNo+']').find('input.item_net_price').val(itemPrice);
		
		calculateTotal();
	});
	
	$('input.discount_type').unbind('change');
	$('input.discount_type').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('input.discount_type').unbind('change');
	$('input.item_discount').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	
	$('a.remove').unbind('click');
	$('a.remove').click(function(){
		$(this).parents('tr').remove();
		var x = 0;
		$('input.rdp').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});
		
		x = 0;
		$('input.rdd').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});

		itemCount = x;
		
		renameDiscountFields();
	});
	
}

</script>
	<div class="status">
	
	</div>
	<div id="product-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Item Search</h3>
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label" style="width: 50px; padding: 0;">Search</label>
					<td><input type="text" name="product_search" class="text v-text" /> in <?=form_dropdown('st',array('SKU'=>'SKU','Product Name'=>'Product Name'))?> <a class="v-btn search">Search</a></td>
				</tr>
			</table>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">Product Name</th>
						<th class="sortable" rel="2" style="width: 100px">Qty</th>
						<th class="sortable" rel="3" style="width: 60px">In Stock</th>
						<th class="sortable" rel="4" style="width: 100px">Cost (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 14px; padding: 0;"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll">
				<table class="grid grid_data">
					
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;"><a class="v-dbtn add-product-item">Add</a> <a class="v-dbtn search-product-done">Done</a></p>
		</div>
	</div>
	
			
	<div class="toolbar">
		<h3 class="grid-title"><a class="v-dbtn target_main" style="float:right; padding:0 25px; margin-top: -1px" href="sales/credit_notes">Back</a>New Credit Note</h3>
		<div class="global-tabs" style="padding: 5px">
			<a class="v-btn submit_btn">Save Credit Note</a>
		</div>
	</div>

	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">

		<form class="insert" method="post" action="<?=base_url()?>sales/cn_add/do" target="postframe">
			<h3 class="general-form-header">Credit Note Information</h3>
			<table class="general-form">
				<tr class="four">
					<td class="label">Credit Note Number</td>
					<td class="input"><input type="text" class="v-text" placeholder="Auto" name="txn_no" /></td>
					<td class="label">Contact <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('contact',$contacts_dropdown,'','class="v-dropdown" style="width: 100%"'); ?></td>

				</tr>
				<tr class="four">
					<td class="label">Date <span class="red">*</span></td>
					<td class="input"><input type="text" name="date" class="v-text date mandatory" /></td>
					<td class="label">Debit Note Number</td>
					<td class="input"><input type="text" name="dn_number" class="v-text" /></td>
				</tr>
				<tr class="four">
					<td class="label">Terms <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('terms',array('Credit'=>'Credit','Cash'=>'Cash'),'','class="v-dropdown" style="width: 100%"'); ?></td>
					<td class="label">Contact Person</td>
					<td class="input"><input value="<?php echo $this->user->data('firstname') . ' ' . $this->user->data('lastname'); ?>" type="text" name="contact_person" class="v-text" /></td>
				</tr>
			</table>
			
			
			
			<h3 class="general-form-title">Items</h3>
			<table class="order-form">
				<thead>
					<tr class="main-header">
						<th colspan="7">Item Details</th>
					</tr>
					<tr class="sub-header">
						<th style="width: 20px"><img src="<?=base_url()?>images/email-action.gif" alt="Action" /></th>
						<th>Item</th>
						<th style="width: 100px;">Qty in Stock</th>
						<th style="width: 100px">Quantity</th>
						<th style="width: 200px">List Price</th>
						<th style="width: 100px">Total</th>
						<th style="width: 100px">Price</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="7" style="padding: 10px 5px"><a class="add-product v-btn" href="#search-product">Add Item</a></td>
					</tr>
					<tr>
						<td class="final" colspan="6">Net Total</td>
						<td class="final final_net_total" style="width: 100px">0.00</td>
					</tr>
					<tr>
						<td class="final" colspan="6">(+) Shipping &amp; Handling Charges</td>
						<td class="final" style="width: 100px"><input type="text" style="text-align: right; width: 95px" name="sh_charges" class="extraCharges v-number-decimal" value="0.00" /></td>
					</tr>
					<?php foreach ($this->tax->get_enabled_charges() as $charge): ?>
					<tr>
						<td class="final" colspan="6"><input checked="checked" style="float: right; display: inline; width: auto !important; margin-left: 5px" type="checkbox" class="charge_enabled" name="charge_enabled_<?php echo $charge->id; ?>" value="0.00" /> <?php echo $charge->name; ?> (<?php echo $charge->percentage; ?>%) </td>
						<td class="final" style="width: 100px"><input type="text" style="text-align: right; width: 95px" name="charge[<?php echo $charge->id; ?>]" rel="<?php echo $charge->id; ?>" percentage="<?php echo $charge->percentage; ?>" class="charge v-number-decimal"  /></td>
					</tr>
					<?php endforeach; ?>
					<?php foreach ($this->tax->get_enabled_taxes() as $tax): ?>
					<tr>
						<td class="final" colspan="6"><input checked="checked" style="float: right; display: inline; width: auto !important; margin-left: 5px" type="checkbox" class="tax_enabled" name="tax_enabled_<?php echo $tax->id; ?>" value="0.00" /> <?php echo $tax->name; ?> <?php echo $tax->inclusive ? 'Included' : ''; ?> (<?php echo $tax->percentage; ?>%) </td>
						<td class="final" style="width: 100px"><input type="text" style="text-align: right; width: 95px" name="tax[<?php echo $tax->id; ?>]" inclusive="<?php echo $tax->inclusive ? '1' : '0'; ?>" rel="<?php echo $tax->id; ?>" percentage="<?php echo $tax->percentage; ?>" class="tax v-number-decimal"  /></td>
					</tr>
					<?php endforeach; ?>
					<tr>
						<td class="final" colspan="6">Adjustment <?=form_dropdown('adjustment_type',array('Add'=>'Add','Deduct'=>'Deduct'))?></td>
						<td class="final" style="width: 100px"><input type="text" style="text-align: right; width: 95px" name="adjustment" class="adjustment v-number-decimal" value="0.00" /></td>
					</tr>
					<tr>
						<td class="final" colspan="6"><strong>GRAND TOTAL</strong></td>
						<td class="final final_grand_total" style="width: 100px">0.00</td>
					</tr>

				</tfoot>
				<tbody>
			
			
			
	<tr class="order-item">	
		<td class="item_tool">
			<input type="hidden" class="taxable" name="taxable[]" />
			<input type="hidden" class="tax_code" name="tax_code[]" />
			<input type="hidden" class="item_id" name="item_id[]" />	
			<input type="hidden" class="item_type" name="item_type[]" value="product" />	
			<input type="hidden" class="item_name" name="item_name[]" />	
			<input type="hidden" class="item_qty_in_stock" name="item_qty_in_stock[]" />	
			<input type="hidden" class="item_net_price" name="item_net_price[]" />	
			<input type="hidden" class="item_totalnet_price" name="item_totalnet_price[]" />	
			<a class="remove grid-action grid-action-delete-tx" ><span>Remove Item</span></a>
		</td>	
		<td class="item_name"></td>	
		<td class="item_qty_in_stock"></td>	
		<td class="item_qty">
			<input style="width: 100px; text-align: center;" type="text" class="item_qty v-number" name="item_qty[]" />
		</td>	
		<td class="item_prices">	
			<div style="height: 30px">
				<input style="width: 90px; float:right; text-align: right" type="text" class="item_list_price v-number-decimal" value="0.00" />Price 
				<br style="clear:right" />
			</div>
			<div>
				<input style="width: 90px; float:right; text-align: right" type="text" class="item_discount v-number-decimal" name="item_discount[]" value="0" />	
				Discount
				<label style="display:inline" ><input type="radio" class="discount_type rdp" name="item_discount_type[]" value="p" style="display:inline; width: auto" />%</label>
				<label style="display:inline" ><input type="radio" class="discount_type rdd" name="item_discount_type[]" value="d" style="display:inline; width: auto" />-</label>
			
			</div>

		</td>	
		<td class="item_totals">	
			<p class="item_total_price" style="text-align: right">0.00</p>	
			<p class="item_price_discount" style="text-align: right">0.00</p>		
		</td>	
		<td class="item_net_price" style="text-align: right">0.00</td>
	</tr>			



				</tbody>
			</table>
			<input type="hidden" name="grand_total" />
			
			<h3>Tags</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Tags</td>
						<td class="input"><input value="<?php echo tagcomplete($cn->tags); ?>" type="text" class="v-text autocomplete-tag" name="tags" /></td>
					</tr>
				</tbody>
			</table>
			
			<h3 class="general-form-title">Remarks</h3>
			<table class="general-form">
				<tr>
					<td class="label">Remarks</td>
					<td class="input"><textarea name="remarks"></textarea></td>
				</tr>
			</table>
			
			
			<br />
		</form>
		</div>
	</div>
