<?php if (!$this->user->has_permission('to_view_credit_note','Sales')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var content;
var itemCount = 1;
var statusCallback;

function readyAdd(status){
	if (status == 1){
		showDialog('ok','Items Received','Credit note items received.', function(){
			setTimeout(function(){
				$('div.main_full').show();
				$('div.status').hide();

				statusCallback();
			}, 400);
		});
		if (!$('a.receiveBtn').hasClass('receiveBtn')){
			var unreceiveBtn = '<a class="v-btn target_main receiveBtn" style="padding: 3px 15px" href="inventory/dn_unreceive/<?php echo $cn->id; ?>">Unreceive Items</a>';
			$('div.control').append(unreceiveBtn);
		}
		
		$('table.order-form tbody').html('');
		form_warning = false;
		populateEvents();
	} else {
		showDialog('ok','Error','There has been an error receiving credit note items.');
		$('div.main_full').show();
		$('div.status').hide();
	}
}

$(document).ready(function(){

	$('input').attr('disabled',true).css('border','none');
	$('input.receipt_reference').attr('disabled',false).css('border','1px solid #DDD');
	$('input.receipt_date').attr('disabled',false).css('border','1px solid #DDD');
	$('textarea').attr('disabled',true).css('border','none');
	$('select').attr('disabled',true).hide();
	$('select[name=status]').attr('disabled',false).show();
	itemEvents();
	$('input.item_qty').change();
	
	$('input.received_qty').attr('disabled',false).css('border','1px solid #DDD');
	$('input.checkbox_done').attr('disabled',false);
	
	$('input.v-number-negative').live('keypress',function(event){
		var key = event.which;
		var keychar = String.fromCharCode(key);
		if ((key==null) || (key==0) || (key==8) ||  (key==9) || (key==13) || (key==27) ) return true;
		else if ((("0123456789-").indexOf(keychar) > -1)) return true;
		else event.preventDefault();
	});

	
	
	$('a.submit_btn').click(function(event){
		showDialog('yesno','Receive Items','Mark this Credit Note as <strong>Received</strong>?', function(){		
			statusCallback = function(){
				$('select[name=status]').val('Received');
				$('select[name=status]').change();
				statusCallback = null;
			}
			$('form').submit();
		}, function(){
			statusCallback = function(){
				$('select[name=status]').val('Partially Received');
				$('select[name=status]').change();
				statusCallback = null;
			}
			$('form').submit();
		})
		
		event.preventDefault();
	});	

	
	$('form').submit(function(){
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>').show();
	});
		
	
	$('a.set-paid').click(function(e){
		
		e.preventDefault();
		
		var href = $(this).attr('href');
		var receipt_reference = $('input.receipt_reference').val();
		var receipt_date = $('input.receipt_date').val();
		
		if (!receipt_reference){
			showDialog('ok','Error','Please enter reference no.');			
			return;
		}
		
		if (!receipt_date){
			showDialog('ok','Error','Please enter payment date.');			
			return;
		}

		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');

		$.ajax({
			url: base_url + href,
			data: 'receipt_reference=' + receipt_reference + '&receipt_date=' + receipt_date,
			type: 'POST',
			success: function (html){
				$('#global-content').html(html).show();
				$('div.status').hide();
				populateEvents();
			}
		})
	});
	
	$('select[name=status]').change(function(){
		var id = $(this).attr('rel');
		var status = $(this).val();
		
		if (status == 'Received'){
			$('.received-related').hide();
		} else {
			$('.received-related').show();
		}

		$.ajax({
			url: base_url + 'sales/cn_update_status/'+ id,
			type: 'POST',
			data: 'status='+status,
			success: function (){
				showDialog('ok','Status Update','Credit Note status has been set to ' + status + '.');
			}
		})
	})
		
	$('a.receive_same').click(function(){
		$('input.received_qty').each(function(){
			$(this).val($(this).attr('qty')).change();
		});
	});
	
	itemEvents();
	$('input.received_qty').change();

	var status = $('select[name=status]').val();
	if (status == 'Received'){
		$('.received-related').hide();
	} else {
		$('.received-related').show();
	}

});

function calculateTotal(){

}

function calculateTotalReceived(){
	var netTotal = parseFloat(0);
	var grandTotal = parseFloat(0);
	var charges = 0.00;
	
	$('td.item_net_price').each(function(){
		netTotal = netTotal + parseFloat($(this).html());
	});
	
	netTotal = netTotal.toFixed(2);
	var charges = $('input.extraCharges').val();
	if (!charges) charges = 0;
	var adjustmentType = $('select[name=adjustment_type]').val();
	var adjustment = $('input.adjustment').val();
	if (!adjustment) adjustment = 0;
	
	var totalTax = 0.00;
	$('td.tax').first().each(function(){
		var tax = parseFloat($(this).html());
		if ($(this).attr('inclusive') == '0'){
			totalTax += tax;
		}
	})
	


	if (adjustmentType == "Add"){
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(adjustment) + totalTax;
	} else {
		grandTotal = parseFloat(netTotal) + 0 - parseFloat(adjustment) + totalTax;
	}
	
	
	grandTotal = parseFloat(grandTotal).toFixed(2);
	$('td.final_net_total_received').html(netTotal);
	$('td.final_grand_total_received').html(grandTotal);
	$('input[name=grand_total_received]').val(grandTotal);
}


function itemEvents(){

	$('input.item_list_price').change(function(){
		$('input.item_qty').change();
	});
	
	$('input.item_qty').change(function(){
		
	});
	
	$('input.received_qty').change(function(){

		var discounted = 0;
		var netTotal = 0;
		var itemNo = $(this).parents('tr').attr('rel');
		var itemQty = parseInt($(this).val());
		var itemPrice = $('tr[rel='+itemNo+']').children('td.prices').children('input.item_list_price').val();
		var total = parseFloat(itemQty * itemPrice) + 0.00;
		var discountType = $('tr[rel='+itemNo+']').children('td.prices').children('label').children('input.discount_type:checked').val();
		var discountVal =  $('tr[rel='+itemNo+']').children('td.prices').children('input.item_discount').val();
		if (discountType == 'p'){
			var discounted = parseFloat(((discountVal) / 100) * total).toFixed(2);
			var netTotal = total - discounted;
		} else if (discountType == 'd'){
			var discounted = parseFloat(discountVal).toFixed(2);
			var netTotal = total - discounted;
		} else {
			var netTotal = total;
			var discounted = '0.00';
		}
		total = total.toFixed(2);
		netTotal = parseFloat(netTotal).toFixed(2);

		$('tr[rel='+itemNo+']').children('td.tool').children('input.item_totalnet_price').val(total);
		$('tr[rel='+itemNo+']').children('td.tool').children('input.item_net_price').val(netTotal);
		$('tr[rel='+itemNo+']').children('td.calculated').children('p.item_total_price').html(total);
		$('tr[rel='+itemNo+']').children('td.calculated').children('p.item_price_discount').html('-'+discounted);
		$('tr[rel='+itemNo+']').children('td.item_net_price').html(netTotal);

		calculateTotalReceived();
	});
	
	
	
	$('input.discount_type').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('input.item_discount').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	


	
	$('a.remove').click(function(){
		$(this).parents('tr').remove();
	});

}

</script>

<?php
	
$taxes = json_decode($cn->tax);
foreach ($taxes as $tax) $tax_n++;

$base = 16;

$tnc = nl2br($this->system->config('cn_tnc'));
$tnc_lines = explode('<br />', $tnc);
$lines = 1;
foreach ($tnc_lines as $line){
	$lines++;
	$lines += floor(strlen($line) / 140);
}

$footer = nl2br($this->system->config('cn_footer'));
$footer_lines = explode('<br />', $footer);
foreach ($footer_lines as $line){
	$lines++;
	$lines += floor(strlen($line) / 140);
}

$reduce = ceil($lines / 4);

$n = $base - $reduce;

$number_of_pages = ceil(count($cn->orders)/ $n);
if ($number_of_pages == 0) $number_of_pages = 1;

?>
			
	<div class="toolbar">
		<h3 class="grid-title">
			<a class="v-dbtn target_main" style="float:right; padding:0 25px; margin-top: -1px" href="sales/credit_notes">Back</a>Credit Note #<?php echo $cn->txn_no; ?>
			<a class="v-dbtn" style="float:right; padding:0 25px; margin-top: -1px; margin-right: 5px; font-weight: bold" href="javascript:window.print()">Print</a>
			<a class="v-dbtn" style="float:right; padding:0 25px; margin-top: -1px; margin-right: 5px; font-weight: bold" href="sales/cn_pdf/<?php echo $cn->id; ?>">Download PDF</a>
		</h3>
		<div class="global-tabs" style="padding: 5px 5px 3px 5px">
			<?php if ($this->user->has_permission('to_process_credit_note','Sales')): ?>
			<small>Status</small> <?php echo form_dropdown('status', array('Pending'=>'Pending','Partially Received'=>'Partially Received','Received'=>'Received'), $cn->status, 'rel="'.$cn->id.'" class="v-dropdown" style="margin-right: 10px; width: 130px; font-size: 10pt"'); ?>

			<a class="v-btn received-related receive_same">Quantity as To Receive</a>
			<a class="v-btn received-related submit_btn receive_btn">Receive Items</a>
			<?php endif; ?>
		</div>
		<div class="global-tabs" style="padding: 5px;">
		<?php if ($this->system->uses('Accounts')): ?>
			<?php if ($cn->payment_status == 'Paid'): ?>
				<?php if ($cn->payment_contra): ?>
					<small style="margin-right: 10px;">Contra on <strong><?php echo date('d/m/Y',strtotime($cn->payment_date)); ?></strong>. Reference No: <strong><a class="rc" rel="<?php echo $cn->id;?>">RC-<?php echo $cn->payment_contra; ?></a></strong></small>
					<a class="v-btn target_main set-unpaid" style="padding: 3px 15px" href="sales/CN_unpaid/<?php echo $cn->id; ?>">Set as Unpaid</a>			
				<?php else: ?>
					<small style="margin-right: 10px;">Paid on <strong><?php echo date('d/m/Y',strtotime($cn->payment_date)); ?></strong>. Reference No: <strong><a class="pv" rel="<?php echo $cn->id;?>">PV-<?php echo $cn->payment_reference; ?></a></strong></small>
					<a class="v-btn target_main set-unpaid" style="padding: 3px 15px" href="sales/CN_unpaid/<?php echo $cn->id; ?>">Set as Unpaid</a>
				<?php endif; ?>
			<?php else: ?>
				<small>Credit note is <strong>Unpaid</strong>.</small>
			<?php endif; ?>
		<?php else: ?>
			
			<?php if ($this->user->has_permission('to_process_credit_note','Sales')): ?>
				<?php if ($cn->payment_status == 'Paid'): ?>
						<small style="margin-right: 10px;">Paid on <strong><?php echo date('d/m/Y',strtotime($cn->payment_date)); ?></strong>. Reference No: <strong><?php echo $cn->payment_reference; ?></strong></small>			
						<a class="v-btn target_main set-unpaid" style="padding: 3px 15px" href="sales/cn_unpaid/<?php echo $cn->id; ?>">Set as Unpaid</a>			
				<?php else: ?>
						<small>Credit note is <strong>Unpaid</strong>. Payment Date <input type="text" name="p-date" class="receipt_date v-text date" style="width: 80px;" /> &nbsp; Reference No. <input type="text" class="v-text receipt_reference" name="receipt_reference" style="width: 80px;" /> <a class="v-btn set-paid" href="sales/cn_paid/<?php echo $cn->id; ?>">Set to Paid</a></small>					
				<?php endif; ?>	
			<?php endif; ?>
		
		<?php endif; ?>
		</div>
	</div>
	<div class="status">
	
	</div>

	<div class="main_full" style="background: #DDD">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>
		<div class="doc-pad" style="padding: 15px">
			<form method="post" action="<?php echo base_url(); ?>sales/cn_receive/<?php echo $cn->id; ?>" target="postframe">

			<div style="padding: 20px 0 10px 0; border-bottom: 1px solid #555; ">
				<h2 style="text-align: right; float: right; margin: 0; padding: 0">Credit Note<br /><small>Page 1 of <?php echo $number_of_pages; ?></small></h2>
				<?php if ($logo = $this->system->config('company_logo')): ?>
				<img src="<?php echo base_url(); ?>../assets/img/<?php echo $logo; ?>" style="float: left; margin-right: 10px; width: 180px; margin-right: 20px" />
				<?php endif; ?>
				
				<div style="padding-left: 200px">
					<strong><?php echo $this->system->config('company_name'); ?></strong><br />
					<?php echo nl2br($this->system->config('company_address')); ?><br />
					<?php echo nl2br($this->system->config('company_contact')); ?>
				</div>
				<div style="clear:left"></div>
			</div>
			
			<br class="clearboth" />

			


				<table class="noborder" style="font-size: 10pt; margin: 10px 0 15px 0; float: right !important; width: 250px !important">
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">Date</td>
						<td style="border-bottom: 1px solid #bbb" class="input"><?php echo date('d/m/Y',strtotime($cn->date)); ?></td>
	
					</tr>
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">CN Number</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo 'CN-' . $cn->txn_no; ?></td>
					</tr>
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">DN Number</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo $cn->dn_number; ?></td>
					</tr>
	
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">Contact Person</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo $cn->contact_person; ?></td>
					</tr>
				</table>
				
				
			
				
				<p style="margin: 10px 0; padding: 0">
				<strong>ATTN: <?php echo $contact->contact_person ? $contact->contact_person . '<br />' : ''; ?></strong>
	    		    <?php echo $contact->company_name ? $contact->company_name . '<br />' : ''; ?>
	    		    <?php $address = json_decode($cn->contact_address); ?>
	    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
	    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
	    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
	    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
	    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
	    		    <?php echo $address->country ? $address->country : ''; ?>
	    		</p>
				
				
				
				
				<table class="order-form-print" style="margin-bottom: 5px">
					<thead>
						<tr class="main-header">
							<th colspan="8">Item Details</th>
						</tr>
						<tr class="sub-header">
							<th style="width: 20px;">No</th>
							<th style="width: 40px;">Done</th>
							<th>Item</th>
							<th style="width: 95px;">Qty To Receive</th>
							<th style="width: 85px;">Qty Received</th>
							<th style="width: 80px;">List Price (<?php echo $this->system->config('currency'); ?>)</th>
							<th style="width: 90px;">Total (<?php echo $this->system->config('currency'); ?>)</th>
							<th style="width: 90px;">Net Price (<?php echo $this->system->config('currency'); ?>)</th>
						</tr>
					</thead>
					
	
	
					<tbody>
					<?php
						$products = $cn->products;
					?>
					<?php $y = 1; $x = 0; foreach($cn->orders as $order): ?>
<?php if ($x == $n): $y++; ?>
						
						</tbody>
					</table>
					
					<table style="font-size: 9pt; width: 100%; margin-top: 3px;" class="general noborder">
					<tbody>

						<tr>
							<td rowspan="5"><div class="form-box" style="padding: 10px; height: 50px; width: 300px; border: 1px solid #ddd;"><strong>Remarks</strong><br /><?php echo nl2br($cn->remarks); ?></div></td>
							<td style="text-align: right; padding-rigth: 10px" class="final">Total</td>
							<?php 
								$net_total = $cn->total + $cn->handling_charges;
								
								foreach($taxes as $tax){
									if($tax->inclusive){
										$taxamount	=	0;
									}else{
										$taxamount	=	$tax->amount;	
									}
									
								}
	
								if ($cn->adjustment_type == 'Add'){
									$net_total = $net_total - $cn->adjustment;
								} else {
									$net_total = $net_total + $cn->adjustment;
								}
								
								$net_total -= $cn->handling_charges;
								$net_total -= $taxamount;
								
							?>
							<td class="final_net_total_received_NULL" style="text-align: right; width: 90px"></td>
							<td class="final_net_total" style="text-align: right; width: 90px"><?php echo str_replace(',','',number_format($net_total,2)); ?></td>

						</tr>
						<tr>
							<td style="text-align: right; " class="final">(+) Shipping &amp; Handling Charges</td>
							<td><input type="text" name="sh_charges" class="extraCharges" style="text-align: right; width: 90px" value="<?=$cn->handling_charges?>" /></td>
							<td><input type="text" name="sh_charges" class="extraCharges" style="text-align: right; width: 90px" value="<?=$cn->handling_charges?>" /></td>
						</tr>
						<?php foreach ($taxes as $tax): $percentage = $tax->percentage; ?>
						<tr>
							<td style="text-align: right;" class="final"> <?php echo $tax->name; ?> <?php echo $tax->inclusive ? 'Inclusive' : ''; ?> (<?php echo number_format($tax->percentage); ?>%)</td>
							<td style="text-align: right; width: 90px"><?php echo number_format($tax->amount,2); ?></td>
							<td style="text-align: right; width: 90px" class="tax" inclusive="<?php echo $tax->inclusive ? '1' : '0'; ?>"><?php echo number_format($tax->amount,2); ?></td>
						</tr>
						<?php endforeach; ?>

						<tr>
							<td style="text-align: right;" class="final">Adjustment (<?php if ($adjustment_type == 'Add') echo '+'; else echo '-'?>)<?=form_dropdown('adjustment_type',array('Add'=>'Add','Deduct'=>'Deduct'), $cn->adjustment_type)?></td>
							<td><input type="text" name="adjustment" class="adjustment" style="text-align: right; width: 90px" value="<?=$cn->adjustment?>" /></td>
							<td><input type="text" name="adjustment" class="adjustment" style="text-align: right; width: 90px" value="<?=$cn->adjustment?>" /></td>
						</tr>
						<tr>
							<td style="text-align: right;" class="final"><strong>GRAND TOTAL</strong></td>

							<td class="final_grand_total_received_NULL" style="font-weight: bold; text-align: right; width: 90px; border-top: 2px solid #000"></td>
							<td class="final_grand_total" style="font-weight: bold; text-align: right; width: 90px; border-top: 2px solid #000;"><?=$cn->total?></td>
						</tr>
					</tbody>
				</table>
			
			<hr />
				
			<strong>Terms &amp; Conditions</strong>
			<p class="fineprint" style="font-size: 8pt; line-height: 100%"><?php echo $tnc; ?></p>
			<hr />
			<div style="font-size: 8pt; line-height: 100%;"><?php echo $footer; ?></div>
			
				
			<hr class="<?php if ($number_of_pages != 1) echo 'formfeed'; ?>" />
			
		
			<div style="margin: 50px 0; border-top: 3px dashed #EEE" class="no-print"></div>

					
					
			<div style="height: 30px" class="no-print"></div>		
			<div style="padding: 0px 0 10px 0; border-bottom: 1px solid #555; ">
				<h2 style="text-align: right; float: right; margin: 0; padding: 0">Credit Note<br /><small>Page 2 of <?php echo $number_of_pages; ?></small></h2>
								<?php if ($logo = $this->system->config('company_logo')): ?>
				<img src="<?php echo base_url(); ?>../assets/img/<?php echo $logo; ?>" style="float: left; margin-right: 10px; width: 180px; margin-right: 20px" />
				<?php endif; ?>
				
				<div style="padding-left: 200px">
					<strong><?php echo $this->system->config('company_name'); ?></strong><br />
					<?php echo nl2br($this->system->config('company_address')); ?><br />
					<?php echo nl2br($this->system->config('company_contact')); ?>
				</div>
				<div style="clear:left"></div>
			</div>
			
			<br class="clearboth" />

			


				<table class="noborder" style="font-size: 10pt; margin: 10px 0 15px 0; float: right !important; width: 250px !important">
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">Date</td>
						<td style="border-bottom: 1px solid #bbb" class="input"><?php echo date('d/m/Y',strtotime($cn->date)); ?></td>
	
					</tr>
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">CN Number</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo 'CN-' . $cn->txn_no; ?></td>
					</tr>
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">DN Number</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo $cn->dn_number; ?></td>
					</tr>
	
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">Contact Person</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo $cn->contact_person; ?></td>
					</tr>
				</table>
				
				
			
				
				<p style="margin: 10px 0; padding: 0">
				<strong>ATTN: <?php echo $contact->contact_person ? $contact->contact_person . '<br />' : ''; ?></strong>
	    		    <?php echo $contact->company_name ? $contact->company_name . '<br />' : ''; ?>
	    		    <?php $address = json_decode($cn->contact_address); ?>
	    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
	    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
	    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
	    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
	    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
	    		    <?php echo $address->country ? $address->country : ''; ?>
	    		</p>
					
					<table class="order-form-print" style="margin-bottom: 5px">
					<thead>
						<tr class="main-header">
							<th colspan="8">Item Details</th>
						</tr>
						<tr class="sub-header">
							<th style="width: 20px;">No</th>
							<th style="width: 40px;">Done</th>
							<th>Item</th>
							<th style="width: 95px;">Qty To Receive</th>
							<th style="width: 85px;">Qty Received</th>
							<th style="width: 80px;">List Price (<?php echo $this->system->config('currency'); ?>)</th>
							<th style="width: 90px;">Total (<?php echo $this->system->config('currency'); ?>)</th>
							<th style="width: 90px;">Net Price (<?php echo $this->system->config('currency'); ?>)</th>
						</tr>	
					</thead>
					<tbody>
					<?php endif; ?>
						
						
<?php if ($x%$n == 0 && $x != $n && $x != 0): $y++; ?>
						
	
					</tbody>
				</table>
					
			<table style="font-size: 9pt; width: 100%; margin-top: 3px;" class="general noborder">
					<tbody>

						<tr>
							<td rowspan="5"><div class="form-box" style="padding: 10px; height: 50px; width: 300px; border: 1px solid #ddd;"><strong>Remarks</strong><br /><?php echo nl2br($cn->remarks); ?></div></td>
							<td style="text-align: right; padding-rigth: 10px" class="final">Total</td>
							<?php 
								$net_total = $cn->total + $cn->handling_charges;
								
								foreach($taxes as $tax){
									if($tax->inclusive){
										$taxamount	=	0;
									}else{
										$taxamount	=	$tax->amount;	
									}
									
								}
	
								if ($cn->adjustment_type == 'Add'){
									$net_total = $net_total - $cn->adjustment;
								} else {
									$net_total = $net_total + $cn->adjustment;
								}
								
								$net_total -= $cn->handling_charges;
								$net_total -= $taxamount;
								
							?>
							<td class="final_net_total_received_NULL" style="text-align: right; width: 90px"></td>
							<td class="final_net_total" style="text-align: right; width: 90px"><?php echo str_replace(',','',number_format($net_total,2)); ?></td>

						</tr>
						<tr>
							<td style="text-align: right; " class="final">(+) Shipping &amp; Handling Charges</td>
							<td><input type="text" name="sh_charges" class="extraCharges" style="text-align: right; width: 90px" value="<?=$cn->handling_charges?>" /></td>
							<td><input type="text" name="sh_charges" class="extraCharges" style="text-align: right; width: 90px" value="<?=$cn->handling_charges?>" /></td>
						</tr>
						<?php foreach ($taxes as $tax): $percentage = $tax->percentage; ?>
						<tr>
							<td style="text-align: right;" class="final"> <?php echo $tax->name; ?> <?php echo $tax->inclusive ? 'Inclusive' : ''; ?> (<?php echo number_format($tax->percentage); ?>%)</td>
							<td style="text-align: right; width: 90px"><?php echo number_format($tax->amount,2); ?></td>
							<td style="text-align: right; width: 90px" class="tax" inclusive="<?php echo $tax->inclusive ? '1' : '0'; ?>"><?php echo number_format($tax->amount,2); ?></td>
						</tr>
						<?php endforeach; ?>

						<tr>
							<td style="text-align: right;" class="final">Adjustment (<?php if ($adjustment_type == 'Add') echo '+'; else echo '-'?>)<?=form_dropdown('adjustment_type',array('Add'=>'Add','Deduct'=>'Deduct'), $cn->adjustment_type)?></td>
							<td><input type="text" name="adjustment" class="adjustment" style="text-align: right; width: 90px" value="<?=$cn->adjustment?>" /></td>
							<td><input type="text" name="adjustment" class="adjustment" style="text-align: right; width: 90px" value="<?=$cn->adjustment?>" /></td>
						</tr>
						<tr>
							<td style="text-align: right;" class="final"><strong>GRAND TOTAL</strong></td>

							<td class="final_grand_total_received_NULL" style="font-weight: bold; text-align: right; width: 90px; border-top: 2px solid #000"></td>
							<td class="final_grand_total" style="font-weight: bold; text-align: right; width: 90px; border-top: 2px solid #000;"><?=$cn->total?></td>
						</tr>
					</tbody>
				</table>
			
			<hr />
				
			<strong>Terms &amp; Conditions</strong>
			<p class="fineprint" style="font-size: 8pt; line-height: 100%"><?php echo $tnc; ?></p>
			<hr />
			<div style="font-size: 8pt; line-height: 100%;"><?php echo $footer; ?></div>

				
			<hr class="<?php if ($number_of_pages != 1) echo 'formfeed'; ?>" />
			
		
			<div style="margin: 50px 0; border-top: 3px dashed #EEE" class="no-print"></div>

					
			<div style="height: 30px" class="no-print"></div>		
			<div style="padding: 0 0 10px 0; border-bottom: 1px solid #555; ">
				<h2 style="text-align: right; float: right; margin: 0; padding: 0">Credit Note<br /><small>Page <?php echo $y; ?> of <?php echo $number_of_pages; ?></small></h2>
								<?php if ($logo = $this->system->config('company_logo')): ?>
				<img src="<?php echo base_url(); ?>../assets/img/<?php echo $logo; ?>" style="float: left; margin-right: 10px; width: 180px; margin-right: 20px" />
				<?php endif; ?>
				
				<div style="padding-left: 200px">
					<strong><?php echo $this->system->config('company_name'); ?></strong><br />
					<?php echo nl2br($this->system->config('company_address')); ?><br />
					<?php echo nl2br($this->system->config('company_contact')); ?>
				</div>
				<div style="clear:left"></div>
			</div>
			
			<br class="clearboth" />

			


				<table class="noborder" style="font-size: 10pt; margin: 10px 0 15px 0; float: right !important; width: 250px !important">
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">Date</td>
						<td style="border-bottom: 1px solid #bbb" class="input"><?php echo date('d/m/Y',strtotime($cn->date)); ?></td>
	
					</tr>
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">CN Number</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo 'CN-' . $cn->txn_no; ?></td>
					</tr>
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">DN Number</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo $cn->dn_number; ?></td>
					</tr>
	
					<tr class="two">
						<td style="font-weight: bold; width: 100px" class="label">Contact Person</td>
						<td style="border-bottom: 1px solid #bbb" cclass="input"><?php echo $cn->contact_person; ?></td>
					</tr>
				</table>
				
				
			
				
				<p style="margin: 10px 0; padding: 0">
				<strong>ATTN: <?php echo $contact->contact_person ? $contact->contact_person . '<br />' : ''; ?></strong>
	    		    <?php echo $contact->company_name ? $contact->company_name . '<br />' : ''; ?>
	    		    <?php $address = json_decode($cn->contact_address); ?>
	    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
	    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
	    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
	    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
	    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
	    		    <?php echo $address->country ? $address->country : ''; ?>
	    		</p>
					
				<table style="margin-bottom: 2px; " class="order-form-print"  style="margin-bottom: 5px">
					<thead>
						<tr class="main-header">
							<th colspan="8">Item Details</th>
						</tr>
						<tr class="sub-header">
							<th style="width: 20px;">No</th>
							<th style="width: 40px;">Done</th>
							<th>Item</th>
							<th style="width: 95px;">Qty To Receive</th>
							<th style="width: 85px;">Qty Received</th>
							<th style="width: 80px;">List Price (<?php echo $this->system->config('currency'); ?>)</th>
							<th style="width: 90px;">Total (<?php echo $this->system->config('currency'); ?>)</th>
							<th style="width: 90px;">Net Price (<?php echo $this->system->config('currency'); ?>)</th>
						</tr>	
					</thead>
					<tbody>
	
	
						<?php endif; ?>
						
						<tr class="order-item" rel="<?=$x?>">
							<td style="text-align: center; width: 20px"><?php echo $x+1; ?></td>
							<td style="text-align: center; width: 40px"><input class="checkbox_done" type="checkbox" <?php if ($order->done) echo 'checked="checked"'; ?> name="done[<?php echo $order->id; ?>]" value="1" /></td>
							<td>																		
								<p class="item_name" style="padding: 2px 0; margin: 0; font-weight: bold"><?=$products[$order->item_id]->name ? $products[$order->item_id]->name  : $order->item_name; ?></p>										
								<p style="padding: 2px 0; margin: 0"><?=$products[$order->item_id]->sku?></p>
							</td>																		
							<td style="text-align: center; width: 95px">
								<input type="text" name="item_qty[<?=$x?>]" style="font-size: 9pt; width: 50px; text-align: center" class="item_qty" value="<?=$order->qty?>" /><br />
							</td>
							<td style="text-align: center; width: 85px">
								<input type="text" class="v-text received_qty" name="received_qty[<?=$order->id?>]" qty="<?=$order->qty?>" style="font-size: 9pt; width: 50px; text-align: center" value="<?= $cn->status == 'Received' ? ($cn->no_do ? $order->qty : $order->received) : 0?>" />
							</td>		
							<td class="prices" style="width:80px">															
								<input type="text" class="item_list_price" style="font-size: 9pt" value="<?=$order->price_per_unit?>" />	<br />	
								&nbsp;Discount 
								
								<label style="display:none" ><input type="radio" class="discount_type" name="item_discount_type[<?=$x?>]" value="p" <?php if ($order->discount_type == 'p') echo 'checked="checked"'?> style="display:inline;width: auto" /> (%)</label>				
								<label style="display:none" ><input type="radio" class="discount_type" name="item_discount_type[<?=$x?>]" value="d" <?php if ($order->discount_type == 'd') echo 'checked="checked"'?>style="display:inline;width: auto" /> (-)</label>
								<?php if ($order->discount_type == 'p') echo '%'; else '-'; ?>
								<input type="text" name="discount[<?=$x?>]" style="width: 30px" class="item_discount" value="<?=$order->discount?>" />					
							</td>																		
							<td class="calculated" style="width: 90px">
								<p class="item_total_price" style="padding: 2px 0; margin: 0; text-align: right"><?=$order->price?></p>				
								<p class="item_price_discount" style="padding: 2px 0; margin: 0; text-align: right">0.00</p>						
							</td>															
							<td class="item_net_price" style="text-align: right; width: 90px">0.00</td>						
						</tr>	
					<?php $x++; endforeach; ?>			
	
					</tbody>
				</table>
				<table style="font-size: 9pt; width: 100%; margin-top: 3px" class="general noborder">
					<tbody>
						<tr>
							<td rowspan="6"><div class="form-box" style="padding: 10px; height: 50px; width: 300px; border: 1px solid #ddd;"><strong>Remarks</strong><br /><?php echo str_replace("\r\n",'<br />', str_replace("\n",'<br />',$cn->remarks)); ?></div></td>
							<td></td>
							<td style="text-align: right; font-weight: bold">To Receive</td>
							<td style="text-align: right; font-weight: bold">Received</td>
						</tr>
						<tr>
							<td style="text-align: right; padding-rigth: 10px" class="final">Total</td>
							<?php 
								$net_total = $cn->total + $cn->handling_charges;
								
								foreach($taxes as $tax){
									if($tax->inclusive){
										$taxamount	=	0;
									}else{
										$taxamount	=	$tax->amount;	
									}
									
								}
	
								if ($cn->adjustment_type == 'Add'){
									$net_total = $net_total - $cn->adjustment;
								} else {
									$net_total = $net_total + $cn->adjustment;
								}
								
								$net_total -= $cn->handling_charges;
								$net_total -= $taxamount;
								
							?>
							<td class="final_net_total" style="text-align: right; width: 90px"><?php echo str_replace(',','',number_format($net_total,2)); ?></td>
							<td class="final_net_total_received" style="text-align: right; width: 90px">0.00</td>
						</tr>
						<tr>
							<td style="text-align: right; " class="final">(+) Shipping &amp; Handling Charges</td>
							<td><input type="text" name="sh_charges" class="extraCharges" style="text-align: right; width: 90px" value="<?=$cn->handling_charges?>" /></td>
							<td><input type="text" name="sh_charges" class="extraCharges" style="text-align: right; width: 90px" value="<?=$cn->handling_charges?>" /></td>
						</tr>
						<?php foreach ($taxes as $tax): $percentage = $tax->percentage; ?>
						<tr>
							<td style="text-align: right;" class="final"> <?php echo $tax->name; ?> <?php echo $tax->inclusive ? 'Inclusive' : ''; ?> (<?php echo number_format($tax->percentage); ?>%)</td>
							<td style="text-align: right; width: 90px"><?php echo number_format($tax->amount,2); ?></td>
							<td style="text-align: right; width: 90px" class="tax" inclusive="<?php echo $tax->inclusive ? '1' : '0'; ?>"><?php echo number_format($tax->amount,2); ?></td>
						</tr>
						<?php endforeach; ?>

						<tr>
							<td style="text-align: right;" class="final">Adjustment (<?php if ($adjustment_type == 'Add') echo '+'; else echo '-'?>)<?=form_dropdown('adjustment_type',array('Add'=>'Add','Deduct'=>'Deduct'), $cn->adjustment_type)?></td>
							<td><input type="text" name="adjustment" class="adjustment" style="text-align: right; width: 90px" value="<?=$cn->adjustment?>" /></td>
							<td><input type="text" name="adjustment" class="adjustment" style="text-align: right; width: 90px" value="<?=$cn->adjustment?>" /></td>
						</tr>
						<tr>
							<td style="text-align: right;" class="final"><strong>GRAND TOTAL</strong></td>
							<td class="final_grand_total" style="font-weight: bold; text-align: right; width: 90px; border-top: 2px solid #000;"><?=$cn->total?></td>
							<td class="final_grand_total_received" style="font-weight: bold; text-align: right; width: 90px; border-top: 2px solid #000"><?=$cn->total_delivered?></td>
						</tr>
					</tbody>
				</table>
				
				<hr />
				
				<strong>Terms &amp; Conditions</strong>
				<p class="fineprint" style="font-size: 8pt; line-height: 100%"><?php echo $tnc; ?></p>
				<hr />
				<div style="font-size: 8pt; line-height: 100%;"><?php echo $footer; ?></div>


				<input type="hidden" name="grand_total" />
				
				<hr />
				
				<table style="font-size: 9pt; width: 100%; margin-top: 10px;" class="noborder">
					<tr>
						<td style="width: 50%; text-align: center">Authorized by</td>
						<td style="width: 50%; text-align: center">Received by</td>
					</tr>
					<tr>
						<td style="text-align: center; vertical-align: top"><br /><br />.....................................................<br /><?php echo $this->system->config('company_name'); ?></td>
						<td style="text-align: center; vertical-align: top"><br /><br />......................................................</td>
					</tr>
	
				</table>
				

			</form>
		</div>
	</div>
