<?php 

$taxes = json_decode($invoice->tax);
foreach ($taxes as $tax) $tax_n++;

$base = 16;

$tnc = nl2br($this->system->config('do_tnc'));
$tnc_lines = explode('<br />', $tnc);
$lines = 1;
foreach ($tnc_lines as $line){
	$lines++;
	$lines += floor(strlen($line) / 140);
}
$footer = nl2br($this->system->config('do_footer'));
$footer_lines = explode('<br />', $footer);
foreach ($tnc_lines as $line){
	$lines++;
	$lines += floor(strlen($line) / 140);
}
$reduce = ceil($lines / 4);

$n = $base - $reduce;

$number_of_pages = ceil(count($invoice->orders)/ $n);
if ($number_of_pages == 0) $number_of_pages = 1;

?>
<html>
	
	<head>
		<base href="<?php echo base_url(); ?>" />
		<link rel="stylesheet" href="css/tables.css" />
		<style>
			
			body {
				font-family: Arial, sans-serif;
				font-size: 7.5pt;
			}
			
			table {
				font-size: 7.5pt !important;
			}
			
			h2 {
				font-size: 11pt !important;
			}
			
			.formfeed {
				page-break-after: always !important;
			}
			
			p.fineprint {
				font-size: 6pt !important;
			}
		
		</style>
	</head>
	
	<body>	
	
	<div class="main_full">



			<div style="padding: 0 0 10px 0; border-bottom: 1px solid #555; ">
				<table style="width: 100%">
					<tr>
						<td style="width: 200px">
							<?php if ($logo = $this->system->config('company_logo')): ?>
							<img src="../assets/img/<?php echo $logo; ?>" style="width: 180px;" />
							<?php endif; ?>

						</td>
						<td>
							<div>
								<strong><?php echo $this->system->config('company_name'); ?></strong><br />
								<?php echo nl2br($this->system->config('company_address')); ?><br />
								<?php echo nl2br($this->system->config('company_contact')); ?>
							</div>
							
						</td>
						<td>
							<h2 style="text-align: right; margin: 0; padding: 0">Deliver Order<br /><small>Page 1 of <?php echo $number_of_pages; ?></small></h2>
						</td>
					</tr>
				</table>
			</div>
			
			
			<table style="width: 100%">
				<tr>
					<td style="width: 33%; vertical-align: top">
						<p style="margin: 10px 0; padding: 0">
						<strong>ATTN: <?php echo $contact->contact_person ? $contact->contact_person . '<br />' : ''; ?></strong>
			    		    <?php echo $contact->company_name ? $contact->company_name . '<br />' : ''; ?>
			    		    <?php $address = json_decode($invoice->contact_address); ?>
			    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
			    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
			    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
			    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
			    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
			    		    <?php echo $address->country ? $address->country : ''; ?>
			    		</p>
					</td>
					<td style="width: 33%; vertical-align: top">
						<div class="delivery_to" style="margin: 10px 0; width: 250px !important;">
			    		    <?php $address = json_decode($invoice->delivery_address); ?>
							<strong>Delivery To:<br /><?php echo $address->name ? $address->name . '<br />' : ''; ?></strong>
							<?php echo $address->mobile ? 'Contact No: ' . $address->mobile . '<br />' : ''; ?>
			    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
			    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
			    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
			    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
			    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
			    		    <?php echo $address->country ? $address->country : ''; ?>
						</div>
					</td>

					<td style="width: 33%; vertical-align: top">
						<table class="noborder" style="font-size: 10pt; margin: 10px 0 15px 0; width: 100%">
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Date</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo date('d/m/Y',strtotime($invoice->date)); ?></td>
			
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">INV/DO Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo 'INV/DO-' . $invoice->txn_no; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">PO Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->po_number; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Contact Person</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->contact_person; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Shipping</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->shipping; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Tracking Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->delivery_tracking_no; ?></td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
				
				
				<table class="order-form-print" style="margin-bottom: 5px">
					<thead>
						<tr class="main-header">
							<th colspan="4">Item Details</th>
						</tr>
						<tr class="sub-header">
							<th style="width: 20px;">No</th>
							<th style="width: 40px;">Done</th>
							<th>Item</th>
							<th style="width: 85px;">Qty</th>
						</tr>		
					</thead>
					
	
	
					<tbody>
					<?php
						$products = $invoice->products;
					?>
					<?php $y = 1; $x = 0; foreach($invoice->orders as $order): ?>
<?php if ($x == $n): $y++; ?>
						
						</tbody>
					</table>
					
				
			
			<hr />
				
			<strong>Terms &amp; Conditions</strong>
			<p class="fineprint" style="font-size: 8pt; line-height: 100%"><?php echo $tnc; ?></p>
			<hr />
			<div style="font-size: 8pt; line-height: 100%;"><?php echo $footer; ?></div>

				
			<hr class="<?php if ($number_of_pages != 1) echo 'formfeed'; ?>" />
			
		
			<!-- <div style="margin: 50px 0; border-top: 3px dashed #EEE" class="no-print"></div> -->

					
			<div style="padding: 0 0 10px 0; border-bottom: 1px solid #555; ">
				<table style="width: 100%">
					<tr>
						<td style="width: 200px">
							<?php if ($logo = $this->system->config('company_logo')): ?>
							<img src="../assets/img/<?php echo $logo; ?>" style="width: 180px;" />
							<?php endif; ?>

						</td>
						<td>
							<div>
								<strong><?php echo $this->system->config('company_name'); ?></strong><br />
								<?php echo nl2br($this->system->config('company_address')); ?><br />
								<?php echo nl2br($this->system->config('company_contact')); ?>
							</div>
							
						</td>
						<td>
							<h2 style="text-align: right; margin: 0; padding: 0">Deliver Order<br /><small>Page 2 of <?php echo $number_of_pages; ?></small></h2>
						</td>
					</tr>
				</table>
			</div>
			
			<br class="clearboth" />			
			


			
			<table style="width: 100%">
				<tr>
				
					<td style="width: 33%; vertical-align: top">
						<p style="margin: 10px 0; padding: 0">
						<strong>ATTN: <?php echo $contact->contact_person ? $contact->contact_person . '<br />' : ''; ?></strong>
			    		    <?php echo $contact->company_name ? $contact->company_name . '<br />' : ''; ?>
			    		    <?php $address = json_decode($invoice->contact_address); ?>
			    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
			    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
			    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
			    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
			    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
			    		    <?php echo $address->country ? $address->country : ''; ?>
			    		</p>
					</td>
					<td style="width: 33%; vertical-align: top">
						<div class="delivery_to" style="margin: 10px 0; width: 250px !important;">
			    		    <?php $address = json_decode($invoice->delivery_address); ?>
							<strong>Delivery To:<br /><?php echo $address->name ? $address->name . '<br />' : ''; ?></strong>
							<?php echo $address->mobile ? 'Contact No: ' . $address->mobile . '<br />' : ''; ?>
			    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
			    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
			    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
			    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
			    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
			    		    <?php echo $address->country ? $address->country : ''; ?>
						</div>
					</td>
					
					<td style="width: 33%; vertical-align: top">
						<table class="noborder" style="font-size: 10pt; margin: 10px 0 15px 0; width: 100%">
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Date</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo date('d/m/Y',strtotime($invoice->date)); ?></td>
			
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">INV/DO Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo 'INV/DO-' . $invoice->txn_no; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">PO Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->po_number; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Contact Person</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->contact_person; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Shipping</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->shipping; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Tracking Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->delivery_tracking_no; ?></td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			
					
				<table class="order-form-print" style="margin-bottom: 5px">
					<thead>
						<tr class="main-header">
							<th colspan="4">Item Details</th>
						</tr>
						<tr class="sub-header">
							<th style="width: 20px;">No</th>
							<th style="width: 40px;">Done</th>
							<th>Item</th>
							<th style="width: 85px;">Qty</th>
						</tr>	
					</thead>
					<tbody>
					<?php endif; ?>
						
						
<?php if ($x%$n == 0 && $x != $n && $x != 0): $y++; ?>
						
	
					</tbody>
				</table>
					
				
			
			<hr />
				
			<strong>Terms &amp; Conditions</strong>
			<p class="fineprint" style="font-size: 8pt; line-height: 100%"><?php echo $tnc; ?></p>
			<hr />
			<div style="font-size: 8pt; line-height: 100%;"><?php echo $footer; ?></div>

				
			<hr class="<?php if ($number_of_pages != 1) echo 'formfeed'; ?>" />
			
		
			<!-- <div style="margin: 50px 0; border-top: 3px dashed #EEE" class="no-print"></div> -->

					
			<div style="padding: 0 0 10px 0; border-bottom: 1px solid #555; ">
				<table style="width: 100%">
					<tr>
						<td style="width: 200px">
							<?php if ($logo = $this->system->config('company_logo')): ?>
							<img src="../assets/img/<?php echo $logo; ?>" style="width: 180px;" />
							<?php endif; ?>

						</td>
						<td>
							<div>
								<strong><?php echo $this->system->config('company_name'); ?></strong><br />
								<?php echo nl2br($this->system->config('company_address')); ?><br />
								<?php echo nl2br($this->system->config('company_contact')); ?>
							</div>
							
						</td>
						<td>
							<h2 style="text-align: right; margin: 0; padding: 0">Deliver Order<br /><small>Page <?php echo $y; ?> of <?php echo $number_of_pages; ?></small></h2>
						</td>
					</tr>
				</table>
			</div>
			
			<br class="clearboth" />			
			

			
			<table style="width: 100%">
				<tr>
				
					<td style="width: 33%; vertical-align: top">
						<p style="margin: 10px 0; padding: 0">
						<strong>ATTN: <?php echo $contact->contact_person ? $contact->contact_person . '<br />' : ''; ?></strong>
			    		    <?php echo $contact->company_name ? $contact->company_name . '<br />' : ''; ?>
			    		    <?php $address = json_decode($invoice->contact_address); ?>
			    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
			    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
			    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
			    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
			    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
			    		    <?php echo $address->country ? $address->country : ''; ?>
			    		</p>
					</td>
					<td style="width: 33%; vertical-align: top">
						<div class="delivery_to" style="margin: 10px 0; width: 250px !important;">
			    		    <?php $address = json_decode($invoice->delivery_address); ?>
							<strong>Delivery To:<br /><?php echo $address->name ? $address->name . '<br />' : ''; ?></strong>
							<?php echo $address->mobile ? 'Contact No: ' . $address->mobile . '<br />' : ''; ?>
			    		    <?php echo $address->address1 ? $address->address1 . '<br />' : ''; ?>
			    		    <?php echo $address->address2 ? $address->address2 . '<br />' : ''; ?>
			    		    <?php echo $address->zipcode ? $address->zipcode : ''; ?>
			    		    <?php echo $address->city ? $address->city . '<br />' : ''; ?>
			    		    <?php echo $address->state ? $address->state . '<br />' : ''; ?>
			    		    <?php echo $address->country ? $address->country : ''; ?>
						</div>
					</td>
					
					<td style="width: 33%; vertical-align: top">
						<table class="noborder" style="font-size: 10pt; margin: 10px 0 15px 0; width: 100%">
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Date</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo date('d/m/Y',strtotime($invoice->date)); ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">INV/DO Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo 'INV/DO-' . $invoice->txn_no; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">PO Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->po_number; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Contact Person</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->contact_person; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Shipping</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->shipping; ?></td>
							</tr>
							<tr class="two">
								<td style="font-weight: bold; width: 100px" class="label">Tracking Number</td>
								<td style="border-bottom: 1px solid #bbb" class="input"><?php echo $invoice->delivery_tracking_no; ?></td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			
						
				<table style="margin-bottom: 2px; " class="order-form-print"  style="margin-bottom: 5px">
					<thead>
						<tr class="main-header">
							<th colspan="4">Item Details</th>
						</tr>
						<tr class="sub-header">
							<th style="width: 20px;">No</th>
							<th style="width: 40px;">Done</th>
							<th>Item</th>
							<th style="width: 85px;">Qty</th>
						</tr>		
					</thead>
					<tbody>
	
	
						<?php endif; ?>
						
						<?php if ($order->type == 'product'): ?>
						<tr class="order-item" rel="<?=$x?>">
							<td style="text-align: center; width: 20px"><?php echo $x+1; ?></td>
							<td style="text-align: center; width: 20px"></td>
							<td>																		
								<p class="item_name" style="padding: 2px 0; margin: 0; font-weight: bold"><?=$products[$order->item_id]->name ? $products[$order->item_id]->name  : $order->item_name; ?></p>
								<p style="padding: 2px 0; margin: 0"><?=$products[$order->item_id]->sku?></p>
							</td>																		
							<td style="text-align: center; width: 65px">
								<?= ($invoice->status == 'Delivered' || $invoice->status == 'Partially Delivered') ? ($invoice->no_do ? $order->qty : $order->delivered) : 0?>
							</td>
						</tr>
						<?php else: ?>
						<tr class="order-item" rel="<?=$x?>">
							<td style="text-align: center; width: 20px"><?php echo $x+1; ?></td>
							<td style="text-align: center; width: 40px"><input style="display:none" class="checkbox_done" type="checkbox" <?php if ($order->done) echo 'checked="checked"'; ?> name="done[<?php echo $order->id; ?>]" value="1" /></td>
							<td>																		
								<p class="item_name" style="padding: 2px 0; margin: 0; font-weight: bold"><?=$order->item_name; ?></p>	
								<p style="padding: 2px 0; margin: 0"><?=nl2br($order->item_description)	?></p>
							</td>																		

							<td style="text-align: center; width: 65px">
								<input type="text" readonly="readonly" class="v-text received_qty" name="received_qty[<?=$order->id?>]" qty="<?=$order->qty?>" style="font-size: 9pt; width: 50px; text-align: center; display:none" class="receive_qty" value="1" />
								N/A
							</td>		
											
						</tr>
						<?php endif; ?>
					<?php $x++; endforeach; ?>			
	
					</tbody>
				</table>
				
				
				<input type="hidden" name="grand_total" />
				
				<hr />
				
				<strong>Terms &amp; Conditions</strong>
				<p class="fineprint" style="font-size: 8pt; line-height: 100%"><?php echo $tnc; ?></p>
			<hr />
			<div style="font-size: 8pt; line-height: 100%;"><?php echo $footer; ?></div>

				
				<table style="font-size: 9pt; width: 100%; margin-top: 10px;" class="noborder">
					<tr>
						<td style="width: 50%; text-align: center">Authorized by</td>
						<td style="width: 50%; text-align: center">Received by</td>
					</tr>
					<tr>
						<td style="text-align: center; vertical-align: top"><br /><br />.....................................................<br /><?php echo $this->system->config('company_name'); ?></td>
						<td style="text-align: center; vertical-align: top"><br /><br />......................................................</td>
					</tr>
	
				</table>
				
				
				

	</div>
	
	</body>
	
</html>
