<?php if (!$this->user->has_permission('to_create_invoice','Sales')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var content;
var shipping_service = null;
var itemCount = 0;
var listItem = $('tr.order-item').clone();

function readyAdd(status){
	if (status == 1){
		$('div.main_full').show();
		$('div.status').hide();
		$('form').clearForm();
		
		$('input.extraCharges').val('0.00');
		$('input.adjustment').val('0.00');

		showDialog('ok','New Invoice','New invoice has been created.');
		
		$('table.order-form tbody').html('');
		calculateTotal();
		
		form_warning = false;
	} else {
		showDialog('ok','Error','There has been an error adding the invoice.');
		$('div.main_full').show();
		$('div.status').hide();
	}
}


function calculateShipping(){

	var totalWeight	= 0.00;
	var totalRate	= 0.00;
	var totalItems	= 0;
	
	try {
		console.log(shipping_service.id);
	} catch (e){
		console.log('No Shipping Found');
		return;
	}
	
	var service = shipping_service;


	$('table.order-form tbody tr').each(function(){
		var weight = parseFloat($(this).attr('weight'));
		if (!weight) weight = 0.0;
		var weightUnit = $(this).attr('weight_unit');
		var volume = parseFloat($(this).attr('volume'));
		if (!volume) volume = 0.0;
		var volumeUnit = $(this).attr('volume_unit');
		var qty = parseInt($(this).find('input.item_qty').val());
		
		console.log(weightUnit);
		
		if (service.measurements_type == 'Metric'){
			weight = __convertWeight(weight, weightUnit, 'kg');
			volume = __convertVolume(volume, volumeUnit, 'cm3');
			
			console.log(weight);
			console.log(volume);
			
			var volumetricWeight = volume / (parseFloat(service.shipping_factor) ? parseFloat(service.shipping_factor) : 0.000000000000001);
			
			console.log(volumetricWeight);
			
			weight = weight >= volumetricWeight ? weight : volumetricWeight;
			weight = weight * qty;
		
		} else {
			weight = __convertWeight(weight, weightUnit, 'lb');
			volume = __convertVolume(volume, volumeUnit, 'in3');
			
			var volumetricWeight = volume / (parseFloat(service.shipping_factor) ? parseFloat(service.shipping_factor) : 0.000000000000001);

			weight = weight >= volumetricWeight ? weight : volumetricWeight;		
			weight = weight * qty;
		}
		
		console.log(weight);
		
		totalItems += qty;
		totalWeight += weight;
		
		if (weight <= parseFloat(service.rate.first_weight)){
		    var shipping_rate = (parseFloat(service.rate.flat_rate) ? parseFloat(service.rate.flat_rate) : 0) + (parseFloat(service.rate.first_weight_rate) ? parseFloat(service.rate.first_weight_rate) : 0);
		} else if (weight >= parseFloat(service.rate.max_weight_rate)){
		    var shipping_rate = (parseFloat(service.rate.flat_rate) ? parseFloat(service.rate.flat_rate) : 0) + (parseFloat(service.rate.max_weight_rate) ? parseFloat(service.rate.max_weight_rate) : 0);
		} else {
			var subsequent_rate = Math.ceil((weight - parseFloat(service.rate.first_weight)) / parseFloat(service.rate.subsequent_weight)) * parseFloat(service.rate.subsequent_weight_rate);
		    var shipping_rate = parseFloat(service.rate.flat_rate) + parseFloat(service.rate.first_weight_rate) + subsequent_rate;
		}

		if (isNaN(shipping_rate)) shipping_rate = 0.0;
		
		totalRate += shipping_rate;
		
	});
	
	$('input[name=sh_charges]').val(totalRate.toFixed(2));
	
}

$(document).ready(function(){

	$('tr.order-item').remove();
	
	$('select.shipping').change(function(){
		var country = $('select.v-country').val();
		var zipcode = $('input.zipcode').val();
		var service = $(this).val();
		
		console.log('country='+country+'&zipcode='+zipcode+'&service='+service);
		
		$.ajax({
			url: base_url + 'settings/ajax/shipping_rate',
			type: 'post',
			data: 'country='+country+'&zipcode='+zipcode+'&service='+service,
			dataType: 'json',
			success: function(service_result){
				shipping_service = service_result
				calculateShipping();
				calculateTotal();
			}
		})
	})
	
	
	$('select.v-contact').change(function(){
		var id = $(this).val();
		$('input.name').val('Loading...').attr('disabled',true);
		$('input.mobile').val('');
		$('input.address1').val('');
		$('input.address2').val('');
		$('input.zipcode').val('');
		$('input.city').val('');

		$.ajax({
			url: base_url + 'sales/get_contact_address/' + id,
			dataType: 'json',
			success: function(data){
				$('input.name').val(data.name).attr('disabled',false);
				$('input.mobile').val(data.mobile);
				$('input.address1').val(data.address1);
				$('input.address2').val(data.address2);
				$('input.zipcode').val(data.zipcode);
				$('input.city').val(data.city);
				$('select.v-country').attr('state',data.state).val(data.country).change();
			}
		})
	});
	
	$('select.term').change(function(){
		if ($(this).val() == 'Cash'){
			$('input.duration').attr('disabled',true).val('N/A');
		} else {
			$('input.duration').attr('disabled',false).val('');
		}
	})
	
	$('select.term').change();
	
	
	$('a.submit_btn').click(function(event){
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('a.target_dialog').live('click',function(e){
		e.preventDefault();
		
		var href = $(this).attr('href');
		$.ajax({
			url: base_url + href,
			success: function (res){
				$('#new-item div.global-modal-form-body').html(res);
				hideModalForm('product-search');
				showModalForm('new-item');
			}
		})
	})
	
	$('a.done-new-item').live('click',function(e){
		e.preventDefault();
		hideModalForm('new-item');
		showModalForm('product-search');
		$('a.product_search').click();
	})
	
	$('a.done-new-service').live('click',function(e){
		e.preventDefault();
		hideModalForm('new-service');
		showModalForm('service-search');
		$('a.service_search').click();
	})
	
	$('input.margin').live('change',function(){
		var margin = parseFloat($(this).val());
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = (100 * cost) / (100 - margin);
		
		$(this).parents('td').find('input.item_selling_price').val(selling.toFixed(2));
		
	});
	
	$('input.item_selling_price').live('change',function(){
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = parseFloat($(this).val());
		var gp = selling - cost;
		var margin = gp / selling * 100;
		
		$(this).parents('td').find('input.margin').val(margin.toFixed(2));	
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
	$('input[name=product_search]').keypress(function(e){
		var code = (e.keyCode ? e.keyCode : e.which);
		if (code == 13){
			var t = $('#product-search select[name=st]').val();
			var q = $(this).val();
			var cid = $('select[name=contact]').val();
			

			$('#product-search div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
			$.ajax({
				type: "POST",
				url: base_url + 'sales/search_product/' + q + '/' + t + '/' + cid,
				success: function (html){
					$('#product-search div.modal-search-result table.grid_data').html(html);
					$('select.item-price-select').change();
				}			
			}); 
		}
	});
	
	$('a.product_search').click(function(){
		var t = $('#product-search select[name=st]').val();
		var q = $('input[name=product_search]').val();
		var cid = $('select[name=contact]').val();
			

		$('#product-search div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
		$.ajax({
			type: "POST",
			url: base_url + 'sales/search_product/' + q + '/' + t + '/' + cid,
			success: function (html){
				$('#product-search div.modal-search-result table.grid_data').html(html);
				$('select.item-price-select').change();
			}			
		}); 
	});
	
	$('select.product-search-type').keypress(function(e){
		if (code == 13){
			$('a.product_search').click();
		}		
	})	
	
	
	$('input[name=service_search]').keypress(function(e){
		var code = (e.keyCode ? e.keyCode : e.which);
		if (code == 13){
			var q = $(this).val();
			$('#service-search div.modal-search-result table tbody').html('<tr><td colspan="2"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
			$.ajax({
				type: "POST",
				url: base_url + 'sales/search_service/' + q,
				success: function (html){
	
					$('#service-search div.modal-search-result table.grid_data').html(html);
				}			
			}); 
		}
	});
	
	$('a.service_search').click(function(){
		var q = $('input[name=service_search]').val();
		$('#service-search div.modal-search-result table tbody').html('<tr><td colspan="2"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
		$.ajax({
			type: "POST",
			url: base_url + 'sales/search_service/' + q,
			success: function (html){
	
				$('#service-search div.modal-search-result table.grid_data').html(html);
			}			
		});
	});
	
	
	
	$('a.add-product').click(function(event){
		event.preventDefault();
		showModalForm('product-search');
	});
	
	$('a.add-product-item').click(function(event){
		event.preventDefault();
		$('input.product-items').each(function(){
			if ($(this).attr('checked')){
				addItem($(this).val(),'product');
			}
		});
		itemEvents();
		calculateTotal();
	});
	
	$('a.add-service').click(function(event){
		event.preventDefault();
		showModalForm('service-search');
	});
	
	$('a.add-service-item').click(function(event){
		event.preventDefault();
		$('input.service-items').each(function(){
			if ($(this).attr('checked')){
				addItem($(this).val(),'service');
			}
		});
		itemEvents();
		calculateTotal();
	});
	
	$('a.search-product-done').click(function(event){
		event.preventDefault();
		hideModalForm('product-search');
	});
	
	$('a.search-service-done').click(function(event){
		event.preventDefault();
		hideModalForm('service-search');
	});
	
	$('input.extraCharges').change(function(){
		calculateTotal();
	});

	$('input.adjustment').change(function(){
		calculateTotal();
	});
	
	$('select[name=adjustment_type]').change(function(){
		calculateTotal();
	});

	
	itemEvents();
	
	$('select.item-price-select').live('change',function(){
		$(this).parents('tr').find('span.selling-price').text($(this).val());
		$(this).parents('tr').find('span.product-price').text($(this).val());
	});
	
	$('input.tax_enabled').click(function(){
		calculateTotal();
	})
	
	$('input.charge_enabled').click(function(){
		calculateTotal();
	})

});

function calculateTotal(){
	calculateShipping();
	
	var netTotal = parseFloat(0);
	var grandTotal = parseFloat(0);
	var taxable = 0.00;
	
	$('td.item_net_price').each(function(){
		netTotal = netTotal + parseFloat($(this).html());

	});
	
	netTotal = netTotal.toFixed(2);

	var charges = parseFloat($('input.extraCharges').val());
	if (!charges) charges = 0;
	
	var adjustment = $('input.adjustment').val();
	if (!adjustment) adjustment = 0;
	
	
	$('input.charge').each(function(){
		var percentage = parseFloat($(this).attr('percentage'));
		var rel = $(this).attr('rel');

		if ($('input[name=charge_enabled_'+rel+']').attr('checked')){
			var val = parseFloat(netTotal) * percentage / 100;
			$(this).val(val.toFixed(2));
			charges += val;
		} else {
			$(this).val('0.00')
		}
	})
	
	taxable += charges;

	

	var adjustmentType = $('select[name=adjustment_type]').val();	
	if (adjustmentType == "Add"){
		grandTotal = parseFloat(netTotal) + 0 + charges + parseFloat(adjustment);
	} else {
		grandTotal = parseFloat(netTotal) + 0 + charges - parseFloat(adjustment);
	}
	

	$('tr.order-item').each(function(){
		if ($(this).attr('taxable') == "1"){
			taxable += parseFloat($(this).find('td.item_net_price').html());
		}
	})
	taxable = taxable.toFixed(2);
	
	alert(taxable);
	
	grandTotal = parseFloat(grandTotal).toFixed(2);
	
	var taxTotal = 0.00;
	$('input.tax').each(function(){
		var inclusive = $(this).attr('inclusive');
		var rel = $(this).attr('rel');
		var percentage = parseFloat($(this).attr('percentage'));
		if (inclusive == "0"){
			var val = parseFloat(taxable) * percentage / 100;
		} else {
			var val = parseFloat(taxable) * percentage / (100+percentage);
		}
		$(this).val(val.toFixed(2));
		if ($('input[name=tax_enabled_'+rel+']').attr('checked')){
			if (inclusive == "0"){
				taxTotal += parseFloat(val);
			}
		} else {
			$(this).val('0.00');
		}

	});

	$('td.final_net_total').html(netTotal);
	$('td.final_grand_total').html((parseFloat(grandTotal)+taxTotal).toFixed(2));
	$('input[name=grand_total]').val((parseFloat(grandTotal)+taxTotal).toFixed(2));

}

function addItem(itemId,type){
	form_warning = true;
	switch (type){
		case 'product':
			var weight = $('#product-search tr[rel='+itemId+']').attr('weight');
			var weightUnit = $('#product-search tr[rel='+itemId+']').attr('weight_unit');
			var volume = $('#product-search tr[rel='+itemId+']').attr('volume');
			var volumeUnit = $('#product-search tr[rel='+itemId+']').attr('volume_unit');
			
			var taxable = $('#product-search tr[rel='+itemId+']').attr('taxable');
			var tax_code = $('#product-search tr[rel='+itemId+']').attr('tax_code');
		
			var itemNetPrice = $('#product-search tr[rel='+itemId+'] span.product-price').html();
			if (!itemNetPrice) itemNetPrice = '0.00';
			
			var itemSellingPrice = $('#product-search tr[rel='+itemId+'] span.selling-price').html();
			if (!itemSellingPrice) itemSellingPrice = '0.00';
			
			var itemName = $('#product-search tr[rel='+itemId+'] span.product-name').html();
			var desc = '';
			
			var qtyInStock = $('#product-search tr[rel='+itemId+'] span.quantity-in-stock').html();
			var qty = $('#product-search tr[rel='+itemId+'] input.qty').val();
			
			var itemTotalPrice = qty * itemNetPrice;
			itemTotalPrice = itemTotalPrice.toFixed(2);
			
			// if ($('table.order-form tr.product[itemid='+itemId+']').hasClass('order-item')) return;
			
			var n = itemName.split('<br>');
			newListItem = $(listItem).clone();
			$(newListItem).attr('taxable',taxable);
			$(newListItem).addClass('product');			
			$(newListItem).attr('itemid',itemId);
			$(newListItem).attr('rel',itemCount);
			$(newListItem).attr('weight',weight);
			$(newListItem).attr('weight_unit',weightUnit);
			$(newListItem).attr('volume',volume);
			$(newListItem).attr('volume_unit',volumeUnit);
			$(newListItem).find('input.taxable').val(taxable?taxable:'');
			$(newListItem).find('input.tax_code').val(tax_code);
			$(newListItem).find('input.item_id').val(itemId);
			$(newListItem).find('input.item_type').val('product');
			$(newListItem).find('input.item_name').val(n[0]);
			$(newListItem).find('input.item_qty').val(qty);
			$(newListItem).find('input.item_net_price').val(itemNetPrice);
			$(newListItem).find('input.item_list_price').val(itemNetPrice);
			$(newListItem).find('input.item_totalnet_price').val(itemTotalPrice);
			// $(newListItem).find('td.item_name').prepend(itemName);

			$(newListItem).find('td.item_qty_in_stock').html(qtyInStock);
			$(newListItem).find('p.item_total_price').val(itemNetPrice);
			
						
			$('table.order-form tbody').append(newListItem);

			itemEvents();
					
			$('tr[rel='+itemCount+']').find('input.item_qty').change();
			itemCount++;
		break;
		case 'service':
			var servicePrice = $('#service-search tr[rel='+itemId+'] span.service-price').html();
			if (!servicePrice) servicePrice = '0.00';
						
			// if ($('table.order-form tr.service[itemid='+itemId+']').hasClass('order-item')) return;
			
			var serviceName = $('#service-search tr[rel='+itemId+'] span.service-name').text();
			var serviceDesc = $('#service-search tr[rel='+itemId+'] span.service-description').text();;

			
			newListItem = $(listItem).clone();
			$(newListItem).addClass('service');
			$(newListItem).attr('itemid',itemId);
			$(newListItem).attr('rel',itemCount);
			$(newListItem).find('input.item_id').val(itemId);
			$(newListItem).find('input.item_type').val('service');
			$(newListItem).find('input.item_name').val(serviceName);
			$(newListItem).find('input.item_qty').val(1).hide();			
			$(newListItem).find('input.item_net_price').val(servicePrice);
			$(newListItem).find('input.item_list_price').val(servicePrice);
			$(newListItem).find('input.item_totalnet_price').val(servicePrice);
			$(newListItem).find('td.item_name input.item_name').val(serviceName);
			$(newListItem).find('td.item_name textarea').val(serviceDesc);
			
			
			$(newListItem).find('td.item_qty').append('<p style="text-align: center">N/A</a>');
			$(newListItem).find('td.item_qty_in_stock').html('N/A');
			$(newListItem).find('p.item_total_price').val(servicePrice);
			
						
			$('table.order-form tbody').append(newListItem);

			itemEvents();
					
			$('tr[rel='+itemCount+']').find('input.item_qty').change();
			itemCount++;
		break;
	}
	
	renameDiscountFields();
}


function renameDiscountFields(){
	var x = 0;
	$('input.discount_type').each(function(){
		var n = Math.floor(x / 2);
		$(this).attr('name','item_discount_type['+n+']');
		
		x++;
	});
}

function itemEvents(){

	$('input.item_list_price').unbind('change');
	$('input.item_list_price').change(function(){
		$('input.item_qty').change();
	});
	
	$('input.item_qty').unbind('change');
	$('input.item_qty').change(function(){
		
		var itemNo 			= $(this).parents('tr').attr('rel');
		var itemQty 		= parseInt($(this).val());
		var itemPrice 		= $(this).parents('tr').find('input.item_list_price').val();
		
		var total 			= parseFloat(itemQty * itemPrice) + 0.00;
		var netTotal 		= 0;
		
		var discounted 		= 0;
		var discountType 	= $(this).parents('tr').find('input.discount_type:checked').val();
		var discountVal 	= $(this).parents('tr').find('input.item_discount').val();
		
		if (discountType == 'p'){
			var discounted = parseFloat(((discountVal) / 100) * total).toFixed(2);
			var netTotal = total - discounted;
		} else if (discountType == 'd'){
			var discounted = parseFloat(discountVal).toFixed(2);
			var netTotal = total - discounted;
		} else {
			var netTotal = total;
			var discounted = '0.00';
		}
		
		
		total = total.toFixed(2);
		netTotal = parseFloat(netTotal).toFixed(2);

		$(this).parents('tr').find('input.item_totalnet_price').val(total);
		$(this).parents('tr').find('p.item_total_price').html(total);
		$(this).parents('tr').find('p.item_price_discount').html('-'+discounted);
		$(this).parents('tr').find('td.item_net_price').html(netTotal);
		$(this).parents('tr').find('input.item_net_price').val(itemPrice);
		
		calculateTotal();
	});

	$('input.discount_type').unbind('change');
	$('input.discount_type').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('input.item_discount').unbind('change');
	$('input.item_discount').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('a.remove').unbind('click');
	$('a.remove').click(function(){
		$(this).parents('tr').remove();
		var x = 0;
		$('input.rdp').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});
		
		x = 0;
		$('input.rdd').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});

		itemCount = x;
		
		renameDiscountFields();
		calculateTotal();
	});
	

	
}



</script>
	<div class="status">
	
	</div>
	<div id="new-item" class="global-modal-form">
		<div class="global-modal-form-body">
		
		</div>		
	</div>
	
	<div id="service-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Service Search</h3>
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label" style="width: 50px; padding: 0;">Search</label>
					<td><input type="text" name="service_search" class="text" /> <a class="v-btn service_search">Search</a></td>
				</tr>
			</table>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">Service</th>
						<th class="sortable" rel="2" style="width: 100px">Price (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 14px; padding:0"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll">
				<table class="grid grid_data">
					
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;"><a class="v-dbtn add-service-item">Add</a> <a class="v-dbtn search-service-done">Done</a></p>
		</div>
	</div>
	
	<div id="product-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Item Search</h3>
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label" style="width: 50px; padding: 0;">Search</label>
					<td><input type="text" name="product_search" class="text" /> in <?=form_dropdown('st',array('SKU'=>'SKU','Product Name'=>'Product Name'))?> <a class="v-btn product_search">Search</a></td>
				</tr>
			</table>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">Product Name</th>
						<th class="sortable" rel="2" style="width: 100px">Qty</th>
						<th class="sortable" rel="3" style="width: 60px">In Stock</th>
						<th class="sortable" rel="4" style="width: 100px">Price (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 14px; padding:0"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll">
				<table class="grid grid_data">
					
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;"><a class="v-dbtn add-product-item">Add</a> <a class="v-dbtn search-product-done">Done</a></p>
		</div>
	</div>
	
			
	<div class="toolbar">
		<h3 class="grid-title"><a class="v-dbtn back_btn" style="float:right; padding:0 25px; margin-top: -1px" href="sales/invoices">Back</a>New Invoice</h3>
		<div class="global-tabs" style="padding: 5px">
			<a class="v-btn submit_btn">Save Invoice</a>		
		</div>
	</div>

	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">

		<form class="insert" method="post" action="<?=base_url()?>sales/invoice_add/do" target="postframe">
			<h3 class="general-form-header">Invoice Information</h3>
			<table class="general-form">
				<tr class="four">
					<td class="label">Invoice Number</td>
					<td class="input"><input type="text" class="v-text" placeholder="Auto" name="txn_no" /></td>
					<td class="label">Contact <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('contact',$contacts_dropdown,'','class="v-dropdown v-contact" style="width: 100%"'); ?></td>
				</tr>
				<tr class="four">
					<td class="label">Date <span class="red">*</span></td>
					<td class="input"><input type="text" name="date" class="v-text date mandatory" /></td>
					<td class="label">Purchase Order No.</td>
					<td class="input" colspan="3"><input type="text" name="po_number" class="v-text" /></td>
				</tr>
				<tr class="four">
					<td class="label">Terms <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('terms',array('Credit'=>'Credit','Cash'=>'Cash'),'','class="v-dropdown term" style="width: 100%"'); ?></td>
					<td class="label">Credit Duration (days)</td>
					<td class="input"><input type="text" name="duration" class="duration v-text" /></td>
				</tr>
				<tr class="four">
					<td class="label">Contact Person</td>
					<td class="input"><input type="text" name="contact_person" class="v-text v-contact-person" value="<?php echo $this->user->data('firstname') . ' ' . $this->user->data('lastname'); ?>" /></td>
					<td class="label">Referrer</td>
					<td class="input"><?=form_dropdown('referrer_contact_id',$contacts_dropdown,'','class="v-dropdown " style="width: 100%"'); ?></td>
				</tr>

			</table>
			
			
			<h3 class="general-form-header">Delivery Information</h3>
			
			<table class="general-form">
				<tr class="four">
					<td class="label">Recipient</td>
					<td class="input"><input type="text" name="delivery[name]" class="name v-text" />
					<td class="label">Contact No</td>
					<td class="input"><input type="text" name="delivery[mobile]" class="mobile v-text" />
				</tr>
				<tr class="four">
					<td class="label">Address 1</td>
					<td class="input"><input type="text" name="delivery[address1]" class="address1 v-text" />
					<td class="label">Address 2</td>
					<td class="input"><input type="text" name="delivery[address2]" class="address2 v-text" />
				</tr>
				<tr class="four">
					<td class="label">Zipcode</td>
					<td class="input"><input type="text" name="delivery[zipcode]" class="zipcode v-text" />
					<td class="label">City</td>
					<td class="input"><input type="text" name="delivery[city]" class="city v-text" />
				</tr>
				<tr class="four">
					<td class="label">State</td>
					<td class="input"><?php echo form_dropdown('delivery[state]',$this->system->state_list($this->system->config('country')), '', 'class="state v-city v-dropdown" style="width: 100%"'); ?></td>
					<td class="label">Country</td>
					<td class="input"><?php echo form_dropdown('delivery[country]',$this->system->country_list(), $this->system->config('country'),'class="country v-country v-dropdown" style="width: 100%"'); ?></td>				
				</tr>
			</table>
			
			
			<h3 class="general-form-title">Items</h3>
			<table class="order-form">
				<thead>
					<tr class="main-header">
						<th colspan="7">Item Details</th>
					</tr>
					<tr class="sub-header">
						<th style="width: 20px"><img src="<?=base_url()?>images/email-action.gif" alt="Action" /></th>
						<th>Item</th>
						<th style="width: 100px;">Qty in Stock</th>
						<th style="width: 100px">Quantity</th>
						<th style="width: 220px">List Price</th>
						<th style="width: 100px">Total</th>
						<th style="width: 100px">Price</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="7" style="padding: 10px 5px">
							<?php if ($this->system->uses('Inventory')): ?><a class="add-product v-btn" href="#search-product">Add Item</a><?php endif; ?>
							<?php if ($this->system->uses('Services')): ?><a class="add-service v-btn" href="#search-service">Add Service</a><?php endif; ?>
						</td>
					</tr>
					<tr>
						<td class="final" colspan="6">Net Total</td>
						<td class="final final_net_total" style="width: 100px">0.00</td>
					</tr>
					<tr>
						<td class="final" colspan="3">Shipping Service <?php echo form_dropdown('shipping_id',$shipping_dropdown,$invoice->shipping_id,'class="v-dropdown shipping" style="width: 100px"'); ?></td>
						<td class="final" colspan="3">(+) Shipping &amp; Handling Charges</td>
						<td class="final" style="width: 100px"><input type="text" style="text-align: right; width: 95px" name="sh_charges" class="extraCharges v-number-decimal" value="0.00" /></td>
					</tr>
					<?php foreach ($this->tax->get_enabled_charges() as $charge): ?>
					<tr>
						<td class="final" colspan="6"><input checked="checked" style="float: right; display: inline; width: auto !important; margin-left: 5px" type="checkbox" class="charge_enabled" name="charge_enabled_<?php echo $charge->id; ?>" value="0.00" /> <?php echo $charge->name; ?> (<?php echo $charge->percentage; ?>%) </td>
						<td class="final" style="width: 100px"><input type="text" style="text-align: right; width: 95px" name="charge[<?php echo $charge->id; ?>]" rel="<?php echo $charge->id; ?>" percentage="<?php echo $charge->percentage; ?>" class="charge v-number-decimal"  /></td>
					</tr>
					<?php endforeach; ?>
					<?php foreach ($this->tax->get_enabled_taxes() as $tax): ?>
					<tr>
						<td class="final" colspan="6"><input checked="checked" style="float: right; display: inline; width: auto !important; margin-left: 5px" type="checkbox" class="tax_enabled" name="tax_enabled_<?php echo $tax->id; ?>" value="0.00" /> <?php echo $tax->name; ?> <?php echo $tax->inclusive ? 'Included' : ''; ?> (<?php echo $tax->percentage; ?>%) </td>
						<td class="final" style="width: 100px"><input type="text" style="text-align: right; width: 95px" name="tax[<?php echo $tax->id; ?>]" inclusive="<?php echo $tax->inclusive ? '1' : '0'; ?>" rel="<?php echo $tax->id; ?>" percentage="<?php echo $tax->percentage; ?>" class="tax v-number-decimal"  /></td>
					</tr>
					<?php endforeach; ?>
					
					<tr>
						<td class="final" colspan="6">Adjustment <?=form_dropdown('adjustment_type',array('Add'=>'Add','Deduct'=>'Deduct'))?></td>
						<td class="final" style="width: 100px"><input type="text" style="text-align: right; width: 95px" name="adjustment" class="adjustment v-number-decimal" value="0.00" /></td>
					</tr>
					<tr>
						<td class="final" colspan="6"><strong>GRAND TOTAL</strong></td>
						<td class="final final_grand_total" style="width: 100px">0.00</td>
					</tr>

				</tfoot>
				<tbody>
			
			
			
	<tr class="order-item">	
		<td class="item_tool">	
			<input type="hidden" class="taxable" name="taxable[]" />
			<input type="hidden" class="tax_code" name="tax_code[]" />
			<input type="hidden" class="item_id" name="item_id[]" />	
			<input type="hidden" class="item_type" name="item_type[]" value="product" />	
			<input type="hidden" class="item_qty_in_stock" name="item_qty_in_stock[]" />	
			<input type="hidden" class="item_net_price" name="item_net_price[]" />	
			<input type="hidden" class="item_totalnet_price" name="item_totalnet_price[]" />	
			<a class="remove grid-action grid-action-delete-tx" ><span>Remove Item</span></a>
		</td>	
		<td class="item_name">
			<input type="text" class="v-text item_name" name="item_name[]" style="width: 98%" />
			<textarea class="item_description v-textarea" placeholder="Description" name="item_description[]" style="height: 60px; width: 98%;"></textarea>
			
		</td>	
		<td class="item_qty_in_stock"></td>	
		<td class="item_qty">
			<input style="width: 100px; text-align: center;" type="text" class="item_qty v-number" name="item_qty[]" />
		</td>	
		<td class="item_prices">	
			<div style="height: 30px">
				<input style="width: 90px; float:right; text-align: right" type="text" class="item_list_price v-number-decimal" value="0.00" />Price 
				<br style="clear:right" />
			</div>
			<div>
				<input style="width: 90px; float:right; text-align: right" type="text" class="item_discount v-number-decimal" name="item_discount[]" value="0" />	
				Discount
				<label style="display:inline" ><input type="radio" class="discount_type rdp" name="item_discount_type[]" value="p" style="display:inline; width: auto" />%</label>
				<label style="display:inline" ><input type="radio" class="discount_type rdd" name="item_discount_type[]" value="d" style="display:inline; width: auto" />-</label>
			
			</div>

		</td>	
		<td class="item_totals">	
			<p class="item_total_price" style="text-align: right">0.00</p>	
			<p class="item_price_discount" style="text-align: right">0.00</p>		
		</td>	
		<td class="item_net_price" style="text-align: right">0.00</td>
	</tr>			



				</tbody>
			</table>
			<input type="hidden" name="grand_total" />
			
			<h3>Tags</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Tags</td>
						<td class="input"><input value="<?php echo tagcomplete($invoice->tags); ?>" type="text" class="v-text autocomplete-tag" name="tags" /></td>
					</tr>
				</tbody>
			</table>
			
			<h3 class="general-form-title">Remarks</h3>
			<table class="general-form">
				<tr>
					<td class="label">Remarks</td>
					<td class="input"><textarea name="remarks"></textarea></td>
				</tr>
			</table>
			
			
			<br />
		</form>
		</div>
	</div>
