<?php if (!$this->user->has_permission('to_process_quotation','Sales')) die('You do not have the permissions to access this area.'); ?>
<script type="text/javascript">

var content;
var shipping_service = null;
var itemCount = 0;
var listItem = $('tr.order-item:first-child').clone();

function readyAdd(status, id){
	if (status == 1){	
		$('a.go-to-so').attr('href','sales/so_view/'+id);
		$('div.main_full').show();
		$('div.status').hide();
		showDialog('ok','Sales Order','Sales order has been created.',function(){
			$('a.go-to-so').click();
		});
		$('input.extraCharges').val('0.00');
		$('input.adjustment').val('0.00');
		calculateTotal();
		
		$('a.submit_btn').remove();
		
		form_warning = false;
	} else {
		showDialog('ok','Error','There has been an error saving the sales order.');
		$('div.main_full').show();
		$('div.status').hide();
	}
}

function calculateShipping(){

	var totalWeight	= 0.00;
	var totalRate	= 0.00;
	var totalItems	= 0;
	
	try {
		console.log(shipping_service.id);
	} catch (e){
		return;
	}
	
	var service = shipping_service;


	$('table.order-form tbody tr').each(function(){
		var weight = parseFloat($(this).attr('weight'));
		if (!weight) weight = 0.0;
		var weightUnit = $(this).attr('weight_unit');
		var volume = parseFloat($(this).attr('volume'));
		if (!volume) volume = 0.0;
		var volumeUnit = $(this).attr('volume_unit');
		var qty = parseInt($(this).find('input.item_qty').val());
		

		
		if (service.measurements_type == 'Metric'){
			weight = __convertWeight(weight, weightUnit, 'kg');
			volume = __convertVolume(volume, volumeUnit, 'cm3');
			
			
			var volumetricWeight = volume / (parseFloat(service.shipping_factor) ? parseFloat(service.shipping_factor) : 0.000000000000001);
			
			
			weight = weight >= volumetricWeight ? weight : volumetricWeight;
			weight = weight * qty;
		
		} else {
			weight = __convertWeight(weight, weightUnit, 'lb');
			volume = __convertVolume(volume, volumeUnit, 'in3');
			
			var volumetricWeight = volume / (parseFloat(service.shipping_factor) ? parseFloat(service.shipping_factor) : 0.000000000000001);

			weight = weight >= volumetricWeight ? weight : volumetricWeight;		
			weight = weight * qty;
		}
		
		
		totalItems += qty;
		totalWeight += weight;
		
		if (weight <= parseFloat(service.rate.first_weight)){
		    var shipping_rate = (parseFloat(service.rate.flat_rate) ? parseFloat(service.rate.flat_rate) : 0) + (parseFloat(service.rate.first_weight_rate) ? parseFloat(service.rate.first_weight_rate) : 0);
		} else if (weight >= parseFloat(service.rate.max_weight_rate)){
		    var shipping_rate = (parseFloat(service.rate.flat_rate) ? parseFloat(service.rate.flat_rate) : 0) + (parseFloat(service.rate.max_weight_rate) ? parseFloat(service.rate.max_weight_rate) : 0);
		} else {
			var subsequent_rate = Math.ceil((weight - parseFloat(service.rate.first_weight)) / parseFloat(service.rate.subsequent_weight)) * parseFloat(service.rate.subsequent_weight_rate);
		    var shipping_rate = parseFloat(service.rate.flat_rate) + parseFloat(service.rate.first_weight_rate) + subsequent_rate;
		}

		if (isNaN(shipping_rate)) shipping_rate = 0.0;
		
		totalRate += shipping_rate;
		
	});
	
	$('input[name=sh_charges]').val(totalRate.toFixed(2));
	
}


$(document).ready(function(){
	
	$('a.submit_btn').click(function(event){
		$('a.submit_btn').hide();
		$('form.insert').submit();
		event.preventDefault();
	});
	
	$('select.shipping').change(function(){
		var country = $('select.v-country').val();
		var zipcode = $('input.zipcode').val();
		var service = $(this).val();
		
		$.ajax({
			url: base_url + 'settings/ajax/shipping_rate',
			type: 'post',
			data: 'country='+country+'&zipcode='+zipcode+'&service='+service,
			dataType: 'json',
			success: function(service_result){
				shipping_service = service_result
				calculateShipping();
				calculateTotal();
			}
		})
	})

	
	$('a.target_dialog').live('click',function(e){
		e.preventDefault();
		
		var href = $(this).attr('href');
		$.ajax({
			url: base_url + href,
			success: function (res){
				$('#new-item div.global-modal-form-body').html(res);
				hideModalForm('product-search');
				showModalForm('new-item');
			}
		})
	})
	
	$('a.done-new-item').live('click',function(e){
		e.preventDefault();
		hideModalForm('new-item');
		showModalForm('product-search');
		$('a.search').click();
	})
	
	$('input.margin').live('change',function(){
		var margin = parseFloat($(this).val());
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = (100 * cost) / (100 - margin);
		
		$(this).parents('td').find('input.item_selling_price').val(selling.toFixed(2));
		
	});
	
	$('input.item_selling_price').live('change',function(){
		var cost = parseFloat($(this).parents('td').find('input.item_list_price').val());
		var selling = parseFloat($(this).val());
		var gp = selling - cost;
		var margin = gp / selling * 100;
		
		$(this).parents('td').find('input.margin').val(margin.toFixed(2));	
	});
	
	$('form').submit(function(){
	
		var ok = true;
		$('input.mandatory').each(function(){
			if (!$(this).val()) ok = false;
		});
		
		if (!ok){
			showDialog('ok','Error','Please make sure you have filled in the mandatory fields.');
			return false;
		}
		
		$('div.main_full').hide();
		$('div.status').html('<p><img src="'+base_url+'images/loading.gif" /> Loading</p>');
	});
	
$('input[name=product_search]').keypress(function(e){
		var code = (e.keyCode ? e.keyCode : e.which);
		if (code == 13){
			var t = $('#product-search select[name=st]').val();
			var q = $(this).val();
			var cid = $('select[name=contact]').val();
			

			$('#product-search div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
			$.ajax({
				type: "POST",
				url: base_url + 'sales/search_product/' + q + '/' + t + '/' + cid,
				success: function (html){
					$('#product-search div.modal-search-result table.grid_data').html(html);
					$('select.item-price-select').change();
				}			
			}); 
		}
	});
	
	$('a.product_search').click(function(){
		var t = $('#product-search select[name=st]').val();
		var q = $('input[name=product_search]').val();
		var cid = $('select[name=contact]').val();
			

		$('#product-search div.modal-search-result table tbody').html('<tr><td colspan="4"><img src="'+base_url+'images/loading.gif" /> Searching</td></tr>')
		$.ajax({
			type: "POST",
			url: base_url + 'sales/search_product/' + q + '/' + t + '/' + cid,
			success: function (html){
				$('#product-search div.modal-search-result table.grid_data').html(html);
				$('select.item-price-select').change();
			}			
		}); 
	});
	
	$('select.product-search-type').keypress(function(e){
		if (code == 13){
			$('a.product_search').click();
		}		
	})		
	
	$('a.add-product').click(function(event){
		event.preventDefault();
		showModalForm('product-search');
	});
	
	$('a.add-product-item').click(function(event){
		event.preventDefault();
		$('input.product-items').each(function(){
			if ($(this).attr('checked')){
				addItem($(this).val(),'product');
			}
		});
		itemEvents();
		calculateTotal();
	});
	
	$('a.search-product-done').click(function(event){
		event.preventDefault();
		hideModalForm('product-search');
	});
	
	$('input.extraCharges').change(function(){
		calculateTotal();
	});

	$('input.adjustment').change(function(){
		calculateTotal();
	});
	
	
	
	$('select[name=adjustment_type]').change(function(){
		calculateTotal();
	});
	
	
	$('input[name=copy]').click(function(){
		if ($(this).val() == 'shipping'){
			$('input[name=billing_address1]').val($('input[name=shipping_address1]').val());
			$('input[name=billing_address2]').val($('input[name=shipping_address2]').val());
			$('input[name=billing_city]').val($('input[name=shipping_city]').val());
			$('input[name=billing_postcode]').val($('input[name=shipping_postcode]').val());
			$('input[name=billing_state]').val($('input[name=shipping_state]').val());
			$('input[name=billing_country]').val($('input[name=shipping_country]').val());

		} else {
			$('input[name=shipping_address1]').val($('input[name=billing_address1]').val());
			$('input[name=shipping_address2]').val($('input[name=billing_address2]').val());
			$('input[name=shipping_city]').val($('input[name=billing_city]').val());
			$('input[name=shipping_postcode]').val($('input[name=billing_postcode]').val());
			$('input[name=shipping_state]').val($('input[name=billing_state]').val());
			$('input[name=shipping_country]').val($('input[name=billing_country]').val());
		
		}
	});

	
	itemEvents();
	
	$('input.item_qty').change();	
	
	$('select.item-price-select').live('change',function(){
		$(this).parents('tr').find('span.selling-price').text($(this).val());
		$(this).parents('tr').find('span.product-price').text($(this).val());
	});
	
	renameDiscountFields();
});

function calculateTotal(){
	calculateShipping();
	
	var netTotal = parseFloat(0);
	var grandTotal = parseFloat(0);
	
	$('td.item_net_price').each(function(){
		netTotal = netTotal + parseFloat($(this).html());
	});
	
	netTotal = netTotal.toFixed(2);

	var charges = $('input.extraCharges').val();
	if (!charges) charges = 0;
	
	var adjustment = $('input.adjustment').val();
	if (!adjustment) adjustment = 0;

	var adjustmentType = $('select[name=adjustment_type]').val();	
	if (adjustmentType == "Add"){
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(charges) + parseFloat(adjustment);
	} else {
		grandTotal = parseFloat(netTotal) + 0 + parseFloat(charges) - parseFloat(adjustment);
	}
	
	grandTotal = parseFloat(grandTotal).toFixed(2);

	$('td.final_net_total').html(netTotal);
	$('td.final_grand_total').html(grandTotal);
	$('input[name=grand_total]').val(grandTotal);

}

function addItem(itemId,type){
	form_warning = true;
	switch (type){
		case 'product':
			var weight = $('#product-search tr[rel='+itemId+']').attr('weight');
			var weightUnit = $('#product-search tr[rel='+itemId+']').attr('weight_unit');
			var volume = $('#product-search tr[rel='+itemId+']').attr('volume');
			var volumeUnit = $('#product-search tr[rel='+itemId+']').attr('volume_unit');				

			var itemNetPrice = $('#product-search tr[rel='+itemId+'] span.product-price').html();
			if (!itemNetPrice) itemNetPrice = '0.00';
			
			var itemSellingPrice = $('#product-search tr[rel='+itemId+'] span.selling-price').html();
			if (!itemSellingPrice) itemSellingPrice = '0.00';
			
			var itemName = $('#product-search tr[rel='+itemId+'] span.product-name').html();
			var desc = '';
			
			var qtyInStock = $('#product-search tr[rel='+itemId+'] span.quantity-in-stock').html();
			var qty = $('#product-search tr[rel='+itemId+'] input.qty').val();
			
			var itemTotalPrice = qty * itemNetPrice;
			itemTotalPrice = itemTotalPrice.toFixed(2);
			
			if ($('table.order-form tr.product[itemid='+itemId+']').hasClass('order-item')) return;
			
			newListItem = $(listItem).clone();
			$(newListItem).addClass('product');			
			$(newListItem).attr('itemid',itemId);
			$(newListItem).attr('rel',itemCount);
			$(newListItem).attr('weight',weight);
			$(newListItem).attr('weight_unit',weightUnit);
			$(newListItem).attr('volume',volume);
			$(newListItem).attr('volume_unit',volumeUnit);
			$(newListItem).find('input.item_id').val(itemId);
			$(newListItem).find('input.item_type').val('product');
			$(newListItem).find('input.item_name').val(itemName);
			$(newListItem).find('input.item_qty').val(qty);
			$(newListItem).find('input.item_net_price').val(itemNetPrice);
			$(newListItem).find('input.item_list_price').val(itemNetPrice);
			$(newListItem).find('input.item_totalnet_price').val(itemTotalPrice);
			$(newListItem).find('td.item_name').append(itemName);
			$(newListItem).find('td.item_name input.item_name').val(itemName).hide();
			$(newListItem).find('td.item_name textarea').hide();

			$(newListItem).find('td.item_qty_in_stock').html(qtyInStock);
			$(newListItem).find('p.item_total_price').val(itemNetPrice);
			
						
			$('table.order-form tbody').append(newListItem);

			itemEvents();
					
			$('tr[rel='+itemCount+']').find('input.item_qty').change();
			itemCount++;
		break;
		case 'service':
			var servicePrice = $('#service-search tr[rel='+itemId+'] span.service-price').html();
			if (!servicePrice) servicePrice = '0.00';
			
			// if ($('table.order-form tr.service[itemid='+itemId+']').hasClass('order-item')) return;
			
			var serviceName = $('#service-search tr[rel='+itemId+'] span.service-name').text();
			var serviceDesc = $('#service-search tr[rel='+itemId+'] span.service-description').text();;

			
			newListItem = $(listItem).clone();
			$(newListItem).addClass('service');
			$(newListItem).attr('itemid',itemId);
			$(newListItem).attr('rel',itemCount);
			$(newListItem).find('input.item_id').val(itemId);
			$(newListItem).find('input.item_type').val('service');
			$(newListItem).find('input.item_name').val(serviceName);
			$(newListItem).find('input.item_qty').val(1).hide();			
			$(newListItem).find('input.item_net_price').val(servicePrice);
			$(newListItem).find('input.item_list_price').val(servicePrice);
			$(newListItem).find('input.item_totalnet_price').val(servicePrice);
			$(newListItem).find('td.item_name input.item_name').val(serviceName);
			$(newListItem).find('td.item_name textarea').val(serviceDesc);
			
			
			$(newListItem).find('td.item_qty').append('<p style="text-align: center">N/A</a>');
			$(newListItem).find('td.item_qty_in_stock').html('N/A');
			$(newListItem).find('p.item_total_price').val(servicePrice);
			
						
			$('table.order-form tbody').append(newListItem);

			itemEvents();
					
			$('tr[rel='+itemCount+']').find('input.item_qty').change();
			itemCount++;
		break;
	}
	
	renameDiscountFields();
}


function renameDiscountFields(){
	var x = 0;
	$('input.discount_type').each(function(){
		var n = Math.floor(x / 2);
		$(this).attr('name','item_discount_type['+n+']');
		
		x++;
	});
}

function itemEvents(){

	$('input.item_list_price').unbind('change');
	$('input.item_list_price').change(function(){
		$('input.item_qty').change();
	});
	
	
	$('input.item_qty').unbind('change');
	$('input.item_qty').change(function(){
		
		var itemNo 			= $(this).parents('tr').attr('rel');
		var itemQty 		= parseInt($(this).val());
		var itemPrice 		= $('tr[rel='+itemNo+']').find('input.item_list_price').val();
		
		var total 			= parseFloat(itemQty * itemPrice) + 0.00;
		var netTotal 		= 0;
		
		var discounted 		= 0;
		var discountType 	= $('tr[rel='+itemNo+']').find('input.discount_type:checked').val();
		var discountVal 	= $('tr[rel='+itemNo+']').find('input.item_discount').val();
		
		if (discountType == 'p'){
			var discounted = parseFloat(((discountVal) / 100) * total).toFixed(2);
			var netTotal = total - discounted;
		} else if (discountType == 'd'){
			var discounted = parseFloat(discountVal).toFixed(2);
			var netTotal = total - discounted;
		} else {
			var netTotal = total;
			var discounted = '0.00';
		}
		
		
		total = total.toFixed(2);
		netTotal = parseFloat(netTotal).toFixed(2);

		$('tr[rel='+itemNo+']').find('input.item_totalnet_price').val(total);
		$('tr[rel='+itemNo+']').find('p.item_total_price').html(total);
		$('tr[rel='+itemNo+']').find('p.item_price_discount').html('-'+discounted);
		$('tr[rel='+itemNo+']').find('td.item_net_price').html(netTotal);
		$('tr[rel='+itemNo+']').find('input.item_net_price').val(itemPrice);
		
		calculateTotal();
	});
	
	$('input.discount_type').unbind('change');
	$('input.discount_type').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('input.item_discount').unbind('change');
	$('input.item_discount').change(function(){
		$('input.item_qty').change();
		calculateTotal();
	});
	
	$('a.remove').unbind('click');
	$('a.remove').click(function(){
		$(this).parents('tr').remove();
		var x = 0;
		$('input.rdp').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});
		
		x = 0;
		$('input.rdd').each(function(){
			$(this).attr('name','item_discount_type['+x+']');
			x++;
		});

		itemCount = x;
		
		renameDiscountFields();
		calculateTotal();
	});
	
}


</script>
	<div class="status">
	
	</div>
	<div id="service-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Service Search</h3>
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label" style="width: 50px; padding: 0;">Search</label>
					<td><input type="text" name="service_search" class="text" /> <a class="v-btn service_search">Search</a></td>
				</tr>
			</table>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">Service</th>
						<th class="sortable" rel="2" style="width: 60px">Price (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 14px; padding: 0"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll">
				<table class="grid grid_data">
					
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;"><a class="v-dbtn add-service-item">Add</a> <a class="v-dbtn search-service-done">Done</a></p>
		</div>
	</div>
	
	<div id="product-search" class="global-modal-form">
		<div class="global-modal-form-body">
			<h3>Item Search</h3>
			<table class="grid-form grid-form-transparent">
				<tr>
					<td class="label" style="width: 50px; padding: 0;">Search</label>
					<td><input type="text" name="product_search" class="text" /> in <?=form_dropdown('st',array('SKU'=>'SKU','Product Name'=>'Product Name'))?> <a class="v-btn product_search">Search</a></td>
				</tr>
			</table>
			<table class="grid">
				<thead>
					<tr>
						<th class="sortable" rel="1">Product Name</th>
						<th class="sortable" rel="2" style="width: 100px">Qty</th>
						<th class="sortable" rel="3" style="width: 60px">In Stock</th>
						<th class="sortable" rel="4" style="width: 100px">Price (<?php echo $this->system->config('currency'); ?>)</th>
						<th style="width: 14px; padding: 0"></th>
					</tr>
				</thead>
			</table>
			<div class="modal-search-result" style="overflow-y:scroll">
				<table class="grid grid_data">
					
				</table>
			</div>
			<hr />
			<p style="padding: 10px 0;"><a class="v-dbtn add-product-item">Add</a> <a class="v-dbtn search-product-done">Done</a></p>
		</div>
	</div>

		
	<div class="toolbar">
		<h3 class="grid-title"><a class="v-dbtn target_main" style="float:right; padding:0 25px; margin-top: -1px" href="sales/quote_view/<?php echo $so->id; ?>">Back</a>Convert to Sales Order</h3>
		<div class="global-tabs" style="padding: 5px">
			<a class="v-btn submit_btn">Save Sales Order</a>
			<a href="#" class="v-btn target_main go-to-so" style="display:none">Go to Sales Order</a>
		</div>

	</div>
	
	<div class="main_full">
		<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing/load/<?php echo mt_rand(10000,99999)?>" style="width:0;height:0;border:0px solid #fff;"></iframe>

		<div class="main-container">

		<form class="insert" method="post" action="<?=base_url()?>sales/so_add/do" target="postframe">
			<input type="hidden" name="quote_id" value="<?php echo $so->id; ?>" />
			<h3 class="general-form-header">Sales Order Information</h3>
			<table class="general-form">
				<tr class="four">
					<td class="label">Sales Order Number</td>
					<td class="input">AUTO</td>
					<td class="label">Date <span class="red">*</span></td>
					<td class="input"><input value="<?php echo date('d/m/Y',strtotime($so->date)); ?>" type="text" name="date" class="v-text date mandatory" /></td>
				</tr>
				<tr class="four">
					<td class="label">Purchase Order No.</td>
					<td class="input"><input type="text" name="po_number" class="v-text" value="QUO-<?php echo $so->id; ?>" /></td>
					<td class="label">Contact Person</td>
					<td class="input"><input type="text" name="contact_person" class="v-text v-contact-person" value="<?php echo $this->user->data('firstname') . ' ' . $this->user->data('lastname'); ?>" /></td>
				</tr>
				<tr class="four">
					<td class="label">Customer <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('contact',$contacts_dropdown,$so->contact_id,'class="v-dropdown" style="width: 100%"'); ?></td>

					<td class="label">Payment Status <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('payment_status',array('Unpaid'=>'Unpaid','Paid'=>'Paid'),'','class="v-dropdown" style="width: 100%"'); ?></td>				
				</tr>
				<tr class="four">
					<td class="label">Terms <span class="red">*</span></td>
					<td class="input"><?=form_dropdown('terms',array('Credit'=>'Credit','Cash'=>'Cash'),$so->terms,'class="v-dropdown" style="width: 100%"'); ?></td>
					<td class="label">Credit Duration (days)</td>
					<td class="input"><input value="<?php echo $so->duration; ?>" type="text" name="duration" class="v-text" /></td>
				</tr>
			</table>
			
			<input type="hidden" name="quote_id" value="<?php echo $so->id; ?>" />
			
			
			<h3 class="general-form-title">Items</h3>
			<table class="order-form">
				<thead>
					<tr class="main-header">
						<th colspan="7">Item Details</th>
					</tr>
					<tr class="sub-header">
						<th style="width: 20px"><img src="<?=base_url()?>images/email-action.gif" alt="Action" /></th>
						<th>Item</th>
						<th style="width: 100px;">Qty in Stock</th>
						<th style="width: 100px">Quantity</th>
						<th style="width: 200px">List Price</th>
						<th style="width: 100px">Total</th>
						<th style="width: 100px">Price</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="7" style="padding: 10px 5px">
							<?php if ($this->system->uses('Inventory')): ?><a class="add-product v-btn" href="#search-product">Add Item</a><?php endif; ?>
							<?php if ($this->system->uses('Services')): ?><a class="add-service v-btn" href="#search-service">Add Service</a><?php endif; ?>
						</td>
					</tr>
					<tr>
						<td class="final" colspan="6">Net Total</td>
						<td class="final final_net_total" style="width: 100px">0.00</td>
					</tr>
					<tr>
						<td class="final" colspan="3">Shipping Service <?php echo form_dropdown('shipping_id',$shipping_dropdown,$so->shipping_id,'class="v-dropdown shipping" style="width: 100px"'); ?></td>
						<td class="final" colspan="3">(+) Shipping &amp; Handling Charges</td>
						<td class="final" style="width: 100px"><input style="text-align: right" type="text" name="sh_charges" class="extraCharges v-number-decimal" value="<?php echo $so->handling_charges; ?>" /></td>
					</tr>
					<tr>
						<td class="final" colspan="6">Adjustment <?=form_dropdown('adjustment_type',array('Add'=>'Add','Deduct'=>'Deduct'), $so->adjustment_type)?></td>
						<td class="final" style="width: 100px"><input style="text-align: right" type="text" name="adjustment" class="adjustment v-number-decimal" value="<?php echo $so->adjustment; ?>" /></td>
					</tr>
					<tr>
						<td class="final" colspan="6"><strong>GRAND TOTAL</strong></td>
						<td class="final final_grand_total" style="font-weight: bold; width: 100px">0.00</td>
					</tr>

				</tfoot>
				<tbody>
					<?php 
						$products = $so->products;
						$i = -1;
						foreach ($so->orders as $order): $i++; 
					?>
					
<?php if ($order->type == 'product'): ?>
	<tr weight="<?php echo $products[$order->item_id]->weight; ?>" weight_unit="<?php echo $products[$order->item_id]->weight_unit; ?>" volume="<?php echo $products[$order->item_id]->volume; ?>" volume_unit="<?php echo $products[$order->item_id]->volume_unit; ?>"  class="order-item product" rel="<?php echo $order->item_id; ?>" itemid="<?php echo $order->item_id; ?>">
		<td class="item_tool">	
			<input type="hidden" class="item_id" name="item_id[]" value="<?php echo $order->item_id; ?>" />	
			<input type="hidden" class="item_type" name="item_type[]" value="product" />	
			<input type="hidden" class="item_name" name="item_name[]" value="<?php echo $order->item_name; ?>" />	
			<input type="hidden" class="item_qty_in_stock" name="item_qty_in_stock[]" />	
			<input type="hidden" class="item_net_price" name="item_net_price[]" value="<?php echo $order->price_per_unit; ?>" />
			<input type="hidden" class="item_totalnet_price" name="item_totalnet_price[]" value="<?php echo $order->price; ?>" />
			<a class="remove grid-action grid-action-delete-tx" ><span>Remove Item</span></a>
		</td>	
		<td class="item_name"><?php echo $products[$order->item_id]->name; ?><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong><?php echo $products[$order->item_id]->sku; ?></strong><textarea name="item_description[]" style="display:none"></textarea></td>
		<td class="item_qty_in_stock"><?php echo $products[$order->item_id]->qty; ?></td>	
		<td class="item_qty">
			<input style="width: 100px; text-align: center;" type="text" class="item_qty v-number" name="item_qty[]" value="<?php echo $order->qty; ?>" />
		</td>	
		<td class="item_prices">	
			<div style="height: 30px">
				<input style="width: 90px; float:right; text-align: right" type="text" class="item_list_price v-number-decimal" value="<?php echo $order->price_per_unit; ?>" />Price 
				<br style="clear:right" />
			</div>
			<div>
				<input style="width: 90px; float:right; text-align: right" type="text" class="item_discount v-number-decimal" name="item_discount[]" value="<?php echo $order->discount; ?>" />	
				Discount
				<label style="display:inline" ><input type="radio" class="discount_type rdp" name="item_discount_type[]" value="p" style="display:inline; width: auto" <?php if ($order->discount_type == 'p') echo 'checked="checked"'; ?> />%</label>
				<label style="display:inline" ><input type="radio" class="discount_type rdd" name="item_discount_type[]" value="d" style="display:inline; width: auto" <?php if ($order->discount_type == 'd') echo 'checked="checked"'; ?> />-</label>
			
			</div>

		</td>	
		<td class="item_totals">	
			<p class="item_total_price" style="text-align: right"><?php echo $order->price_per_unit; ?></p>	
			<p class="item_price_discount" style="text-align: right">0.00</p>		
		</td>	
		<td class="item_net_price" style="text-align: right"><?php echo $order->price; ?></td>
	</tr>
	
	<?php else: ?>
	
	<tr class="order-item service" rel="<?php echo $order->service_id; ?>" itemid="<?php echo $order->service_id; ?>">
		<td class="item_tool">	
			<input type="hidden" class="item_id" name="item_id[]" value="<?php echo $order->service_id; ?>" />	
			<input type="hidden" class="item_type" name="item_type[]" value="service" />	
			<input type="hidden" class="item_name" value="<?php echo $order->item_name; ?>" />	
			<input type="hidden" class="item_qty_in_stock" name="item_qty_in_stock[]" />	
			<input type="hidden" class="item_net_price" name="item_net_price[]" value="<?php echo $order->price_per_unit; ?>" />
			<input type="hidden" class="item_totalnet_price" name="item_totalnet_price[]" value="<?php echo $order->price; ?>" />
			<a class="remove grid-action grid-action-delete-tx" ><span>Remove Item</span></a>
		</td>	
		<td class="item_name">
			<input type="text" class="v-text item_name" name="item_name[]" value="<?php echo $order->item_name; ?>" />
			<textarea class="item_description v-textarea" name="item_description[]" style="height: 60px;"><?php echo $order->item_description; ?></textarea>
		</td>	
		<td class="item_qty_in_stock">N/A</td>	
		<td class="item_qty">
			<input style="width: 100px; text-align: center; display: none" type="text" class="item_qty v-number" name="item_qty[]" value="1"  /><p style="text-align: center">N/A</p>
		</td>	
		<td class="item_prices">	
			<div style="height: 30px">
				<input style="width: 90px; float:right; text-align: right" type="text" class="item_list_price v-number-decimal" value="<?php echo $order->price_per_unit; ?>" />Price 
				<br style="clear:right" />
			</div>
			<div>
				<input style="width: 90px; float:right; text-align: right" type="text" class="item_discount v-number-decimal" name="item_discount[]" value="<?php echo $order->discount; ?>" />	
				Discount
				<label style="display:inline" ><input type="radio" class="discount_type rdp" name="item_discount_type[]" value="p" style="display:inline; width: auto" <?php if ($order->discount_type == 'p') echo 'checked="checked"'; ?> />%</label>
				<label style="display:inline" ><input type="radio" class="discount_type rdd" name="item_discount_type[]" value="d" style="display:inline; width: auto" <?php if ($order->discount_type == 'd') echo 'checked="checked"'; ?> />-</label>
			
			</div>

		</td>	
		<td class="item_totals">	
			<p class="item_total_price" style="text-align: right"><?php echo $order->price_per_unit; ?></p>	
			<p class="item_price_discount" style="text-align: right">0.00</p>		
		</td>	
		<td class="item_net_price" style="text-align: right"><?php echo $order->price; ?></td>
	</tr>			

	
	
	<?php endif; ?>							
					
					<?php endforeach; ?>			
				</tbody>
			</table>
			<input type="hidden" name="grand_total" />
			
			<h3>Tags</h3>
			<table class="general-form">
				<tbody>
					<tr>
						<td class="label">Tags</td>
						<td class="input"><input value="<?php echo tagcomplete($quote->tags); ?>" type="text" class="v-text autocomplete-tag" name="tags" /></td>
					</tr>
				</tbody>
			</table>
			
			<h3 class="general-form-title">Remarks</h3>
			<table class="general-form">
				<tr>
					<td class="label">Remarks</td>
					<td class="input"><textarea name="remarks"></textarea></td>
				</tr>
			</table>
			


		</form>
		</div>
	</div>
