<script type="text/javascript">
var name;
var type;
var tax;
var effect;
var inclusive;
$(document).ready(function(){

	$('a.new-tax').click(function(event){
		event.preventDefault();
		hideModalForm('edit-tax');
		showModalForm('new-tax');
	});
	
	$('#new-tax form').submit(function(){
		if (!$('#new-tax input[name=name]').val()){
			$('#new-tax input[name=name]').focus();
			return false;
		}

		name		= $('#new-tax input[name=name]').val();
		tax			= parseFloat($('#new-tax input[name=percentage]').val());
		tax			= tax.toFixed(2);
		
		effect		= $('#new-tax input[name=enabled]:checked').val();
		inclusive 	= $('#new-tax input[name=inclusive]').attr('checked') ? 'Inclusive' : 'Standard';
		
		if (effect == 1) effect = 'Yes';
		else effect = 'No';

		hideModalForm('new-tax');
	});
	
	$('#edit-tax').submit(function(){
		if (!$('#edit-tax input[name=name]').val()){
			$('#edit-tax input[name=name]').focus();
			return false;
		}
		name 		= $('#edit-tax input[name=name]').val();
		tax 		= parseFloat($('#edit-tax input[name=percentage]').val());
		tax 		= tax.toFixed(3);
		
		effect 		= $('#edit-tax input[name=enabled]:checked').val();
		inclusive 	= $('#edit-tax input[name=inclusive]').attr('checked') ? 'Inclusive' : 'Standard';
		
		if (effect == 1) effect = 'Yes';
		else effect = 'No';
		
		hideModalForm('edit-tax');
	});
	
	populatePageActions();
});

function populatePageActions(){
	populateEvents();
	$('a.grid-action-edit-form').click(function(e){
		e.preventDefault();
	
		var rel = $(this).parents('tr').attr('rel');
		hideModalForm('new-tax');
		showModalForm('edit-tax');
		
		var name 		= $(this).parents('tr').children('td.name').text();
		var type 		= $(this).parents('tr').children('td.type').text();
		var percentage 	= $(this).parents('tr').children('td.percentage').text();
		var effect 		= $(this).parents('tr').children('td.effect').text();
		var inclusive 	= $(this).parents('tr').children('td.inclusive').text();
	

		$('#edit-tax form input[name=name]').val(name);

		if (type == 'Product and Services'){
			$('#edit-tax form select[name=type]').attr('selectedIndex','1');
		} else {
			$('#edit-tax form select[name=type]').attr('selectedIndex','0');		
		}
		
		$('#edit-tax form input[name=percentage]').val(percentage);
		
		if (effect == 'Yes'){
			$('#edit-tax form input[name=enabled][value=1]').attr('checked',true);
		} else {
			$('#edit-tax form input[name=enabled][value=0]').attr('checked',true);
		}
		
		if (inclusive == 'Inclusive'){
			$('#edit-tax form input[name=inclusive]').attr('checked',true);
		} else {
			$('#edit-tax form input[name=inclusive]').removeAttr('checked');
		}

		$('#edit-tax form input[name=id]').val(rel);		
	});
	
	$('a.tax-save').click(function(){
		$(this).parents('form').submit();
	});
	
	$('#new-tax a.tax-discard').click(function(){
		hideModalForm('new-tax');
		$('form.new-tax').clearForm();
	});
	
	$('#edit-tax a.tax-discard').click(function(){
		hideModalForm('edit-tax');
		$('form.edit-tax').clearForm();
	});

	
}

function readyAdd(state,id){
	if (state == 'success'){
		$('table.grid_data tbody').append("<tr class=\"list-item\" rel=\""+id+"\"><td class=\"name\">"+name+"</td><td style=\"width: 100px\" class=\"percentage\"><span>"+tax+"</span></td><td style=\"width: 100px\">"+effect+"</td><td rel=\"3\" style=\"width: 100px\" class=\"inclusive\">"+inclusive+"</td><td style=\"width: 50px; padding: 0\"><a class=\"grid-action grid-action-delete\" href=\"settings/delete_tax/"+id+"\"><span>Delete</span></a><a class=\"grid-action grid-action-edit target_main\" rel=\""+id+"\"><span>Edit</span></a></td></tr>");
		populatePageActions();
	} else {
		showDialog('ok','Error','There has been an error creating new tax.');
	}
}

function readyEdit(state, id){
	if (state == 'success'){
		$('table[rel=tax] tr[rel='+id+'] td.name').html(name);
		$('table[rel=tax] tr[rel='+id+'] td.percentage').html(tax);
		$('table[rel=tax] tr[rel='+id+'] td.type').html(type);
		$('table[rel=tax] tr[rel='+id+'] td.effect').html(effect);
		$('table[rel=tax] tr[rel='+id+'] td.inclusive').html(inclusive);
	} else {
		showDialog('ok','Error','There has been an error updating the tax.');
	}
}


</script>



	
	
<div id="edit-tax" class="global-modal-form" style="height: 180px; width: 350px">
	<div class="global-modal-form-body">
	<iframe id="postframe_edit" name="postframe_edit" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff; display:none"></iframe>
	<h3>Edit Tax</h3>
	<form class="edit_tax" action="settings/edit_tax/do" target="postframe_edit" method="post">
		<input type="hidden" name="id" />
		<table class="grid-form grid-form-transparent" style="font-size: 10pt">
			<tr>
				<td class="label tax-name">Tax Name</label>
				<td><input type="text" name="name" class="v-text" style="width: 100%" /></td>
			</tr>
			<tr>
				<td class="label">Tax Value</td>
				<td><input type="text" name="percentage" class="v-text v-number-decimal" /> %</td>
			</tr>
			<tr>
				<td class="label">Calculation</td>
				<td><input type="checkbox" name="inclusive" value="1" /> Inclusive Amount</td>
			</tr>
			<tr>
				<td class="label">Tax In Effect</td>
				<td>
					<label><input type="radio" name="enabled" value="1" /> Yes</label>
					<label><input type="radio" name="enabled" value="0" /> No</label>
				</td>
			</tr>
		</table>
		<hr />
		<p class="align-right action-button-all"><a class="v-dbtn tax-save">Save</a> <a class="v-dbtn tax-discard">Cancel</a></p>
		<p class="align-right action-button-cancel" style="display:none"><a class="v-dbtn tax-discard">Close</a></p>
	</form>
	</div>
</div>

<div id="new-tax" class="global-modal-form" style="height: 180px; width: 350px">
	<div class="global-modal-form-body">
	<iframe id="postframe" name="postframe" src="<?=base_url()?>nothing" style="width:0;height:0;border:0px solid #fff;"></iframe>
	<h3>New Tax</h3>
	<form class="add_tax" action="settings/add_tax/do" target="postframe" method="post">
		<input type="hidden" name="id" />
		<table class="grid-form grid-form-transparent" style="font-size: 10pt">
			<tr>
				<td class="label tax-name">Tax Name</label>
				<td><input type="text" name="name" class="v-text" style="width: 100%" /></td>
			</tr>
			<tr>
				<td class="label">Tax Value</td>
				<td><input type="text" name="percentage" class="v-text v-number-decimal" /> %</td>
			</tr>
			<tr>
				<td class="label">Calculation</td>
				<td><input type="checkbox" name="inclusive" value="1" /> Inclusive Amount</td>
			</tr>
			<tr>
				<td class="label">Tax In Effect</td>
				<td>
					<label><input type="radio" name="enabled" value="1" checked="checked" /> Yes</label>
					<label><input type="radio" name="enabled" value="0" /> No</label>
				</td>
			</tr>
		</table>
		<hr />
		<p class="align-right"><a class="v-dbtn tax-save">Save</a> <a class="v-dbtn tax-discard">Discard</a></p>
	</form>
	</div>
</div>
	
	
	
	<div class="toolbar">
		<h3 class="grid-title">
				<?php if ($this->user->has_permission('to_add','tax')): ?><a class="new-tax v-btn float_right" style="padding:0 10px; font-weight: normal">Add Tax</a><?php endif; ?>
			Tax Calculations
		</h3>
		<table class="grid">
			<thead>
				<tr>
					<th rel="0" class="sortable">Tax</th>
					<th rel="1" class="sortable" style="width: 100px">Value (%)</th>
					<th rel="2" class="sortable" style="width: 100px">In Effect</th>
					<th rel="3" class="sortable" style="width: 100px">Calculation</th>
					<th class="grid-action" style="text-align: center; width: 50px"><img src="<?=base_url()?>images/email-action.gif" alt="Action" /></th>
					<th style="width: 15px; padding: 0;"></th>
				</tr>
			</thead>
		</table>
	</div>
	<div class="main_full">

		<table rel="tax" class="grid grid_data">
			<tbody>
				<?php $x = 0; foreach ($taxes as $tax): $x++; ?>
				<tr <?php if ($x%2) echo ' class="alt"'; ?> rel="<?php echo $tax->id?>">
					<td rel="0" class="name"><?php echo $tax->name?></td>
					<td	rel="1" style="width: 100px" class="percentage"><?php echo number_format($tax->percentage,3)?></td>
					<td	rel="2" style="width: 100px" class="effect"><?php echo $tax->enabled ? 'Yes' : 'No'; ?></td>
					<td rel="3" style="width: 100px" class="inclusive"><?php echo $tax->inclusive ? 'Inclusive' : 'Standard'; ?></td>
					<td style="width: 50px; padding: 0">
						<a class="grid-action grid-action-delete" href="settings/delete_tax/<?=$tax->id?>"><span>Delete</span></a>	
						<a class="grid-action grid-action-edit-form" rel="<?=$tax->id?>"><span>Edit</span></a>
					</td>
				</tr>
				<?php endforeach; ?>
			</tbody>
		</table>					
	</div>
