
var scroller;
var profile_name;
var current_filename;
var current_profile_id;
var getFileXHR;

$(document).ready(function(){

	$('a.compile-project').click(function(){
		hideModalForm('compile');
	});
	
	$('a.compile-discard').click(function(){
		hideModalForm('compile');
	})


	rescaleFileList();

	$(window).resize(function(){
		rescaleFileList();
	})
	
 	scroller = $('div.box-wrap').antiscroll();
 	
 	$('a.close-profile').live('click',function(e){
 		e.preventDefault();
	 	$(this).hide();
	 	$('a.add-profile').show();
	 	
	 	current_filename = '';
	 	current_profile_id = '';
	 	$('div.text-editor').hide();
	 	$('div.profiles').show();
	 	$('h3.grid-title span').text('Editor Profiles');
	 	$('ul.file-list').html('<li class="no-select" style="text-align: center; padding-top: 10px">No files</li>');
	 	$('ul.file-tabs').html('');
	 	$('div.select').hide();
	 	$('div.no-file-selected').hide();
 	})

	$('div.profile').live('dblclick',function(){
		$('h3.grid-title span').text($(this).find('span').text());
		profile_name = $(this).find('span').text();
		openProfile($(this).attr('id'));
		$('a.close-profile').show();
		$('a.add-profile').hide();
	});
	
	$('div.profile').live('contextmenu', function(e){
		var id = $(this).attr('id');
		$(this).click();
		showMenu([
			{
				label: 'Edit',
				callback: function(){
						goTo('editor/edit/'+id);
					}
			},
			{
				label: 'Delete',
				callback: function(){
					showDialog('yesno','Delete Profile', 'Are you sure you want to delete this profile?', function(){

						$.ajax({
							url: base_url + 'editor/delete/' + id + '/do',
							success: function (res){
								if (res){
									$('div.profile[id='+id+']').fadeOut(500, function(){
										$(this).remove();
										});
								} else {
									showDialog('ok','Error','There was a problem deleting the profile. Plexedit could not proceed.');
								}
							}
						});

					}, function(){
						// do nothing
					});
				}
			},
			{
				label: '-'
			},
			{
				label: 'Compile',
				callback: function(){		
					showModalForm('compile');
				}
			}
		], e.pageX, e.pageY);

		return false;
	})

	
	$('html').click(function(){
		$('div.file-menu').fadeOut(100);
	});	
	
	$('div.file-list').live('contextmenu', function(e){
		showMenu([
			{
				label: 'New File',
				callback: function(){
						var path = '';
						$('ul.file-list').append('<li path="'+path+'" class="file"><input class="new-file-name" style="background: none; margin-left: 43px" type="text" value="untitled" /></li>');
						$('input.new-file-name').focus().attr('profile_id',$(item).attr('profile_id'));

					}
			},
			{
				label: 'New Folder',
				callback: function(){		
					}
			}
		], e.pageX, e.pageY);

		return false;
	})

	$('div.file-list li a').live('contextmenu', function(e){
		var item = $(this).parent('li');
		showMenu([
			{
				label: 'Get Info',
				callback: function(){				
					}
			},
			{
				label: '-'
			},
			{
				label: 'New File',
				callback: function(){
						if ($(item).hasClass('dir')){
							var path = $(item).attr('path');
							$(item).after('<li path="'+path+'" class="file"><input class="new-file-name" style="background: none; margin-left: 43px; border: none; width: auto;" type="text" value="untitled" /></li>');
							$('input.new-file-name').focus().attr('profile_id',$(item).attr('profile_id'));

						} else {
							var path = $(item).attr('path');
							var tokens = path.split('/');
							tokens[tokens.length - 1] = '';
							var path = tokens.join('/');
							
							$(item).after('<li path="'+path+'" class="file"><input class="new-file-name" style="background: none; margin-left: 43px; border: none; width: auto;" type="text" value="untitled" /></li>');
							$('input.new-file-name').focus().attr('profile_id',$(item).attr('profile_id'));
						}
					}
			},
			{
				label: 'New Folder',
				callback: function(){		
					}
			},
			{
				label: '-'
			},
			{
				label: 'Delete...',
				callback: function(){
						var path = $(item).attr('path');
						$(item).prepend('<img src="images/sidebar-loading.gif" style="right: 0; z-index: 1; margin-top: 2px; position: absolute" />');
						deleteFile(path, function(status){
							if (status == 'ok'){
								$(item).remove();
							}
						});
					}
			}
		], e.pageX, e.pageY);

		return false;
	});
	
	$('input.new-file-name').live('keypress',function(e){
		if (e.which == 13){
			$(this).blur();
		}
	})
	
	$('input.new-file-name').live('blur', function(){
		var path = $(this).parent('li').attr('path') + $(this).val();
		
		var conflict = false;
		$(this).parent('li').parent('ul').find('li').each(function(){
			if (path == $(this).attr('path')){
				conflict = true;
			}
		});
		
		$(this).parent('li').prepend('<img src="images/sidebar-loading.gif" style="right: 0; z-index: 1; margin-top: 2px; position: absolute" />');
		
		if (conflict){
			showDialog('ok','File Exists','Please use another file name.', function(){
				$('input.new-file-name').focus();
			});
		} else {
			var tokens = path.split('.');
			var ext = tokens[tokens.length-1];
			
			newFile(path, function(status){
				if (status == 'ok'){
					$('input.new-file-name').parent('li').attr('path',path).addClass('file-'+ext).html('<a>'+$('input.new-file-name').val()+'</a>');
				} else {
					$('input.new-file-name').parent('li').remove();
				}
			})
			

		}
		
	});
	
	
	$('div.file-list li a').live('click', function(){
		var offset = $(this).offset();
		var scrollTop = $('div.antiscroll-inner').scrollTop();
		
		var offsetHeader = $('#header').height();
		
		$('div.select').css('top',offset.top - offsetHeader + scrollTop).hide().fadeIn(100);
		setTimeout(function(){
			var scrollWidth = $('div.antiscroll-inner').get(0).scrollWidth;
			$('div.select').css('width',scrollWidth);
		},50);
		
		$('div.file-list li').removeClass('current-item');
		$(this).parent('li').addClass('current-item');
	});
	
	$('ul.file-tabs a').live('click',function(){
		try {
			getFileXHR.abort();
		} catch (e){
			// do nothing
		}
	
		var profile_id = $(this).attr('profile_id');
		var filename = $(this).attr('path');
		
		$('h3.grid-title span').html(profile_name + '<small style="font-weight:normal"> &raquo; ' + filename + '</small>');
		
		$('div.loading').show();

		getFile(profile_id, filename, function(data){
			$('div.loading').hide();
			
			var found = false;
	    	$('ul.file-tabs a').removeClass('current').each(function(){
				if ($(this).attr('path') == filename){
					$(this).addClass('current');
					found = true;
				}
			})
			if (!found) $('ul.file-tabs').append('<li class="opened"><a profile_id="'+profile_id+'" class="opened current" style="width: auto; padding: 2px 5px 0 10px" path="'+filename+'"><span class="close">x</span>'+file+'</a></li>');


		
	    	if (data.editor){
	    		current_filename = data.filename;
	    		
		    	editor.setOption('mode',data.mode);
	    		editor.setValue(data.contents);
	    		
	    		$('.file-related').removeClass('disabled');
	    		
	    		$('div.text-editor').show();
	    		$('div.no-file-selected').hide();
	    	} else {
	    		
	    	}
		});
	});

	$('li.file a').live('click', function(){
		try {
			getFileXHR.abort();
		} catch (e){
			// do nothing
		}
		
		var listItem = $(this).parent('li');
		var profile_id = $(listItem).attr('profile_id');
		var filename = $(this).parent('li').attr('path');
		var file = $(this).text();
		
		if (!$(listItem).hasClass('loading')){
			$(listItem).addClass('loading').prepend('<img src="images/sidebar-loading.gif" style="right: 0; z-index: 1; margin-top: 2px; position: absolute" />')
		}
		
		$('div.loading').show();

		getFile(profile_id, filename, function(data){
		
			$('div.loading').hide();
		
			$('h3.grid-title span').html(profile_name + '<small style="font-weight:normal"> &raquo; ' + filename + '</small>');
	    	
	    	current_filename = data.filename;
	    		
	    	$(listItem).removeClass('loading').find('img').remove();

	    	var found = false;
	    	$('ul.file-tabs a').removeClass('current').each(function(){
				if ($(this).attr('path') == filename){
					$(this).addClass('current');
					found = true;
				}
			})
			if (!found) $('ul.file-tabs').append('<li class="opened"><a profile_id="'+profile_id+'" class="opened current" style="width: auto; padding: 2px 5px 0 10px" path="'+filename+'"><span class="close">x</span>'+file+'</a></li>');

	    	if (data.editor){
		    	editor.setOption('mode',data.mode);
	    		editor.setValue(data.contents);
	    		$('.file-related').removeClass('disabled');
	    		
	    		$('div.text-editor').show();
	    		$('div.no-file-selected').hide();
	    	} else {
	    		
	    	}
		});	
	});
	
	$('li.dir span').live('click', function(){
		var listItem = $(this).parent('a').parent('li.dir');
		
		if ($(listItem).hasClass('opened')){
			$(this).html('&#x25BA');
			$(listItem).removeClass('opened').find('ul').hide();
			
		} else {
			
			$(listItem).addClass('opened');
			var profile_id = $(this).parents('li.dir').attr('profile_id');
			var path = $(listItem).attr('path');
			var that = listItem;
			
			if (!$(listItem).hasClass('loading')){
				$(listItem).addClass('loading').prepend('<img src="images/sidebar-loading.gif" style="float:right; z-index: 0; margin-top: 2px; position: relative" />')
			}
		
			getFileList(profile_id, path, function(data){
				$(listItem).removeClass('loading').find('img').remove();
					
				if (path.indexOf('/') == -1){ 
				    $(that).html('<a><span>&#x25BC;</span>'+path+'</a>');
				} else {
				    var x = path.split('/');
				    $(that).html('<a><span>&#x25BC;</span>'+x[x.length-1]+'</a>');
				}
				$(that).append('<ul class="subdir"></ul>');
				
				if (data.hasdir == 'true'){
				    for (var i = 0; i < (data.directories).length; i++){
				        var dir = data.directories[i];
				        $(that).find('ul.subdir').append('<li path="'+path+'/'+dir+'" profile_id="'+profile_id+'" class="dir"><a><span>&#x25BA;</span>'+dir+'</a></li>');
				    }
				}

				if (data.hasfile == 'true'){
				    for (var i = 0; i < (data.files).length; i++){
				        var file = data.files[i];
				        var type = null;
						if (file.indexOf('.') != -1){
							var parts = file.split('.');
							var type = parts[parts.length-1];
						}

				        $(that).find('ul.subdir').append('<li path="'+path+'/'+file+'" profile_id="'+profile_id+'" class="file file-'+type+'"><a>'+file+'</a></li>');
				    }
				}
				
				scroller = $('div.box-wrap').antiscroll();
			});
	
			
		}
	})
	
	
	// FILE TABS
	$('ul.file-tabs a').click(function(e){
		e.preventDefault();
		
	});
	
	$('ul.file-tabs').sortable({ axis: 'x', distance: 30 });
	
	$('ul.file-tabs span.close').live('click',function(){
	
		var nextTab = $(this).parents('li').next().hasClass('opened') ? $(this).parents('li').next() : ($(this).parents('li').prev().hasClass('opened') ? $(this).parents('li').prev() : false);
		$('.file-related').addClass('disabled');
	
		setTimeout(function(){
			getFileXHR.abort();
			$('div.loading').hide();
		}, 20);
		
		$(this).parent('a').fadeOut(200, function(){
			$(this).parents('li').remove();
			if (nextTab){
				$(nextTab).find('a').click();
			} else {
	    		$('div.no-file-selected').show();
			}
		});
	});
	
	
	// FUNCTIONS
	
	$('div.file-menu a').live('mouseover',function(){
		$(this).addClass('hover');
	});
	
	$('div.file-menu a').live('mouseout',function(){
		$(this).removeClass('hover');
	});
	
	
	$('a.file-save').click(function(e){
		e.preventDefault();
		if ($(this).hasClass('disabled')) return;
		
		saveFile(function(data){
			$('a.file-save').addClass('disabled');
		})
	})
	
	$('a.file-commit').click(function(e){
		e.preventDefault();
		if ($(this).hasClass('disabled')) return;

		commitFile(function(data){
			$('a.file-commit').addClass('disabled');
		})
		
	})
	
	$('a.file-revisions').click(function(e){
		e.preventDefault();
		if ($(this).hasClass('disabled')) return;

		getFileRevisions(function(data){

		})
		
	})

	
});

function showMenu(menu, x, y){
	$('div.file-menu ul').html('');
	for (var i = 0; i < menu.length; i++){
		var menuItem = menu[i];
		if (menuItem.label == '-'){
			$('div.file-menu ul').append('<li><hr /></li>');
		} else {
			$('div.file-menu ul').append('<li><a rel="'+i+'" class="menuItem">'+menuItem.label+'</a></li>');
			$('div.file-menu a[rel='+i+']').bind('click',menuItem.callback);
		}
	}
	
	setTimeout(function(){
		$('div.file-menu').css({
    		top: y+'px',
    		left: x+'px'
    	}).fadeIn(100);
    }, 200);

}

function rescaleFileList(){
	var offset = $('#header').height();
	$('#global-sidebar-list li').each(function(){
		offset += $(this).height();
	});
	var targetHeight = $(window).height() - offset;
	$('.box').css('height',targetHeight - 5);
	$('.antiscroll-inner').css('height',targetHeight - 5);
}

function openProfile(profile_id){
	$('div.profiles').hide();
	$('div.no-file-selected').show();


	$('div.file-list ul').html('<li style="padding: 20px 10px; text-align: center"><img  src="images/sidebar-loading.gif" /></li>');
	$.ajax({
		url: base_url + 'editor/ajax/open_profile',
		type: 'post',
		data: 'id='+profile_id,
		dataType: 'json',
		success: function (data){			
			$('ul.file-list').html('');
			
			current_profile_id = profile_id;
			
			if (data.hasdir == 'true'){
				for (var i = 0; i < (data.directories).length; i++){
					var dir = data.directories[i];
					$('ul.file-list').append('<li path="'+dir+'" profile_id="'+profile_id+'" class="dir"><a><span>&#x25BA;</span>'+dir+'</a></li>');
				}
			}

			if (data.hasfile == 'true'){
				for (var i = 0; i < (data.files).length; i++){
					var file = data.files[i];
					var type = null;
					if (file.indexOf('.') != -1){
						var parts = file.split('.');
						var type = parts[parts.length-1];
					}
					$('ul.file-list').append('<li path="'+file+'" profile_id="'+profile_id+'" class="file file-'+type+'"><a>'+file+'</a></li>');
				}
			}
			

			
			scroller = $('div.box-wrap').antiscroll();
			$('div.select').css('width','100%');

		}
	})
}

function getFileList(profile_id, path, callback){
	$.ajax({
		url: base_url + 'editor/ajax/file_list/',
		type: 'post',
		data: 'id='+profile_id+'&path='+encodeURIComponent(path),
		dataType: 'json',
		success: function (data){
			try {
				callback(data);
			} catch (e){
				// do nothing
			}
		}
	});
}

function getFile(profile_id, filename, callback){
	getFileXHR = $.ajax({
	    url: base_url + 'editor/ajax/get_file',
	    type: 'post',
	    data: 'filename='+filename+'&id='+profile_id,
	    dataType: 'json',
	    success: function (data){
	    	try {
		    	callback(data)
	    	} catch (e){
	    		// do nothing
	    	}
	    }
	})
}

function saveFile(callback){

	var filename = current_filename;
	var profile_id = current_profile_id;
	var contents = editor.getValue();

	$.ajax({
		url: base_url + 'editor/ajax/save_file',
		type: 'post',
		data: 'filename='+filename+'&id='+profile_id+'&contents='+encodeURIComponent(contents),
		dataType: 'json',
		success: function (data){
			console.log(data);
			try {
				callback(data);
			} catch (e){
				// do nothing
			}
		}
	})
}

function newFile(filename, callback){
	var profile_id = current_profile_id;
	
	$.ajax({
		url: base_url + 'editor/ajax/new_file',
		type: 'post',
		data: 'id='+profile_id+'&filename='+filename,
		dataType: 'json',
		success: function (res){
			if (res.status != 'ok'){
				showDialog('ok','File Error','Unable to create file.');
			}
			try {
				callback(res.status);
			} catch (e){
				// do nothing
			}
		}
	})		
}

function deleteFile(filename, callback){
	var profile_id = current_profile_id;
	alert(filename);
	$.ajax({
		url: base_url + 'editor/ajax/new_file',
		type: 'post',
		data: 'id='+profile_id+'&filename='+filename,
		dataType: 'json',
		success: function (res){
			if (res.status != 'ok'){
				showDialog('ok','File Error','Unable to delete file,')	;
			}
			try {
				callback(res.status);
			} catch (e){
				// do nothing
			}
		}
	});
}

