$(document).ready(function(){
	populateResizable();
})

function populateResizable(){

	$('div.toolbar table.grid').wrap('<div class="grid-header"></div>');
	$('div.toolbar table.grid').addClass('grid-header');
	
	$('th').each(function(){
		var html = $(this).html();
		$(this).html('<span>'+html+'</span>');
		$(this).prepend('<div class="resize-handle"></div>');
	});
	
	$('div.grid-header').prepend('<div class="tr-box"></div>');
	
	$('div.resize-handle').draggable({ 
		axis: "x",
		start: function(e){
			var offset = $(this).offset();
			$('body').append('<div class="resize-guide"></div>');
			$('div.resize-guide').css('left',e.pageX);
			$('div.resize-guide').css('top',offset.top);
		},
		drag: function(e){
			$('div.resize-guide').css('left',e.pageX);			
		},
		stop: function (e){
			$('div.resize-guide').remove();
			
			var offset	= $(this).parents('th').offset();
			var width	= e.pageX - offset.left;
			var mw 		= $(this).parents('th').find('span').width();
			
			if (width < mw) width = mw;

			var rel = $(this).parents('th').attr('rel');
			
			if (!rel) return;
			
			$(this).parents('th').css('width',width);
			$(this).css('left','auto');
			$('table.grid tbody td[rel='+rel+']').css('width',width);
			

			
		}
	});
	
	$('div.main_full').scroll(function(){
		var sl = $(this).scrollLeft();
		$('div.grid-header').scrollLeft(sl);
	});
	
}