# ************************************************************
# Sequel Pro SQL dump
# Version 4499
#
# http://www.sequelpro.com/
# https://github.com/sequelpro/sequelpro
#
# Host: localhost (MySQL 5.5.34)
# Database: plexcloud
# Generation Time: 2017-11-06 07:32:00 +0000
# ************************************************************


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


# Dump of table _files
# ------------------------------------------------------------

CREATE TABLE `_files` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `datetime` datetime DEFAULT NULL,
  `filename` text,
  `uploaded` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table _txn
# ------------------------------------------------------------

CREATE TABLE `_txn` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `datetime` datetime DEFAULT NULL,
  `sql` text,
  `done` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table account
# ------------------------------------------------------------

CREATE TABLE `account` (
  `account_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(11) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `subtype` varchar(128) DEFAULT NULL,
  `is_header` varchar(10) DEFAULT NULL,
  `is_subheader` varchar(10) DEFAULT NULL,
  `is_bank` varchar(10) DEFAULT NULL,
  `cash_postable` varchar(10) DEFAULT NULL,
  `description` text,
  `datetime` datetime DEFAULT NULL,
  `opening_balance` decimal(20,2) DEFAULT NULL,
  `balance` decimal(20,2) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `integrated` int(1) DEFAULT NULL,
  `integration_type` varchar(128) DEFAULT NULL,
  `default` int(1) DEFAULT NULL,
  `branch_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`account_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table account_bank_recon
# ------------------------------------------------------------

CREATE TABLE `account_bank_recon` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `account_id` int(11) DEFAULT NULL,
  `balance` decimal(20,2) DEFAULT NULL,
  `from_date` date DEFAULT NULL,
  `to_date` date DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(255) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table account_closure
# ------------------------------------------------------------

CREATE TABLE `account_closure` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `year_end_date` date DEFAULT NULL,
  `retained_earnings` decimal(20,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table account_payables
# ------------------------------------------------------------

CREATE TABLE `account_payables` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(255) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(255) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `net_amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  `reference` varchar(255) DEFAULT NULL,
  `description` text,
  `account_id` int(11) DEFAULT NULL,
  `account` varchar(255) DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `asset` varchar(255) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee` varchar(255) DEFAULT NULL,
  `void` int(1) DEFAULT '0',
  `void_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table account_receivables
# ------------------------------------------------------------

CREATE TABLE `account_receivables` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(255) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(255) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  `reference` varchar(255) DEFAULT NULL,
  `description` text,
  `account_id` int(11) DEFAULT NULL,
  `account` varchar(255) DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `asset` varchar(255) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee` varchar(255) DEFAULT NULL,
  `void` int(1) DEFAULT NULL,
  `void_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table account_transactions
# ------------------------------------------------------------

CREATE TABLE `account_transactions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `gl_id` int(11) DEFAULT NULL,
  `journal` varchar(128) DEFAULT NULL,
  `account_id` text,
  `account_name` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `reference` varchar(128) DEFAULT NULL,
  `description` varchar(128) DEFAULT NULL,
  `notes` varchar(128) DEFAULT NULL,
  `group` varchar(128) DEFAULT NULL,
  `closure_id` int(11) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table applicants
# ------------------------------------------------------------

CREATE TABLE `applicants` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `vacancy_id` int(11) DEFAULT NULL,
  `firstname` varchar(128) DEFAULT NULL,
  `lastname` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `gender` varchar(10) DEFAULT NULL,
  `dob` date DEFAULT NULL,
  `phone` varchar(128) DEFAULT NULL,
  `mobile` varchar(128) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table asset_depreciations
# ------------------------------------------------------------

CREATE TABLE `asset_depreciations` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(11) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `depreciation_amount` decimal(20,2) DEFAULT NULL,
  `current_value` decimal(20,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table assets
# ------------------------------------------------------------

CREATE TABLE `assets` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `product_name` varchar(128) DEFAULT NULL,
  `barcode` varchar(128) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `current_cost` decimal(20,2) DEFAULT NULL,
  `residual_cost` decimal(20,2) DEFAULT NULL,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `in_service_date` datetime DEFAULT NULL,
  `acquisition_date` datetime DEFAULT NULL,
  `amortization_date` datetime DEFAULT NULL,
  `evaluation_interval` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `reference` varchar(128) DEFAULT NULL,
  `pv_id` int(11) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table buffer_sale_item_sales
# ------------------------------------------------------------

CREATE TABLE `buffer_sale_item_sales` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `cc_cost` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(1) DEFAULT NULL,
  `discount` varchar(32) DEFAULT NULL,
  `discount_type` varchar(32) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,
  `cheque_received` int(1) DEFAULT NULL,
  `card_type` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `customer_phone` varchar(128) DEFAULT NULL,
  `payment` text,
  `member_id` int(11) DEFAULT NULL,
  `fnb` int(11) DEFAULT NULL,
  `sync` int(11) DEFAULT NULL,
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `pseudo_id` int(20) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxes` text,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `shipping` int(11) DEFAULT NULL,
  `shipping_name` varchar(128) DEFAULT NULL,
  `shipping_amount` decimal(20,2) DEFAULT NULL,
  `shipping_weight` decimal(20,4) DEFAULT NULL,
  `remarks` text,
  `added_on` datetime DEFAULT NULL,
  `clinic_consultation_status` varchar(128) DEFAULT NULL,
  `usid` varchar(128) DEFAULT NULL,
  `queue_no` int(5) DEFAULT NULL,
  `consultant_id` int(11) DEFAULT NULL,
  `is_consulted` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table buffer_sale_items
# ------------------------------------------------------------

CREATE TABLE `buffer_sale_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `member_id` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `pseudo_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_sku2` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_uom` varchar(128) DEFAULT NULL,
  `sku_select` int(11) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `qty_fraction` int(11) DEFAULT NULL,
  `unit` varchar(128) DEFAULT NULL,
  `price_per_unit` decimal(20,2) DEFAULT NULL,
  `margin` decimal(20,4) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `discount_type` varchar(10) DEFAULT NULL,
  `discount_value` decimal(20,2) DEFAULT NULL,
  `discount_amount` decimal(20,2) DEFAULT NULL,
  `global_discount` decimal(20,2) DEFAULT NULL,
  `global_discount_type` varchar(1) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(11) DEFAULT NULL,
  `points` int(11) DEFAULT NULL,
  `redeemed` int(1) DEFAULT '0',
  `serial_no` varchar(128) DEFAULT NULL,
  `fnb` int(1) DEFAULT NULL,
  `sync` int(11) DEFAULT '0',
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `clinic_dosage` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table buffer_sale_itemssales
# ------------------------------------------------------------

CREATE TABLE `buffer_sale_itemssales` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `cc_cost` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(1) DEFAULT NULL,
  `discount` varchar(32) DEFAULT NULL,
  `discount_type` varchar(32) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,
  `cheque_received` int(1) DEFAULT NULL,
  `card_type` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `customer_phone` varchar(128) DEFAULT NULL,
  `payment` text,
  `member_id` int(11) DEFAULT NULL,
  `fnb` int(11) DEFAULT NULL,
  `sync` int(11) DEFAULT NULL,
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `pseudo_id` int(20) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxes` text,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `shipping` int(11) DEFAULT NULL,
  `shipping_name` varchar(128) DEFAULT NULL,
  `shipping_amount` decimal(20,2) DEFAULT NULL,
  `shipping_weight` decimal(20,4) DEFAULT NULL,
  `remarks` text,
  `added_on` datetime DEFAULT NULL,
  `clinic_consultation_status` varchar(128) DEFAULT NULL,
  `usid` varchar(128) DEFAULT NULL,
  `queue_no` int(5) DEFAULT NULL,
  `consultant_id` int(11) DEFAULT NULL,
  `is_consulted` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table buffer_tax
# ------------------------------------------------------------

CREATE TABLE `buffer_tax` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `sale_id` int(11) DEFAULT NULL,
  `tax` varchar(128) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table calendar
# ------------------------------------------------------------

CREATE TABLE `calendar` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `allday` varchar(128) DEFAULT NULL,
  `start` datetime DEFAULT NULL,
  `end` datetime DEFAULT NULL,
  `repeat` varchar(20) DEFAULT NULL,
  `notes` text,
  `user` varchar(128) DEFAULT NULL,
  `priority` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `assigned_by` varchar(128) DEFAULT NULL,
  `division` varchar(128) DEFAULT NULL,
  `department` varchar(128) DEFAULT NULL,
  `broadcast` int(1) DEFAULT NULL,
  `new_to_user` int(1) DEFAULT '1',
  `new_to_assigner` int(1) DEFAULT '1',
  `module` varchar(128) DEFAULT NULL,
  `module_id` int(11) DEFAULT NULL,
  `module_type` varchar(128) DEFAULT NULL,
  `branch` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table calendar_task_logs
# ------------------------------------------------------------

CREATE TABLE `calendar_task_logs` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `task_id` int(11) DEFAULT NULL,
  `comments` text,
  `hidden` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table campaign
# ------------------------------------------------------------

CREATE TABLE `campaign` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `assigned_to` text,
  `division` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `target_audience` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `expected_close_date` date DEFAULT NULL,
  `expected_open_date` date DEFAULT NULL,
  `actual_open_date` date DEFAULT NULL,
  `actual_close_date` date DEFAULT NULL,
  `currency` varchar(128) DEFAULT NULL,
  `sponsor` text,
  `target_size` varchar(128) DEFAULT NULL,
  `product` varchar(128) DEFAULT NULL,
  `budget_cost` varchar(128) DEFAULT NULL,
  `actual_cost` varchar(128) DEFAULT NULL,
  `expected_response` varchar(128) DEFAULT NULL,
  `expected_revenue` varchar(128) DEFAULT NULL,
  `expected_sales_count` varchar(128) DEFAULT NULL,
  `actual_sales_count` varchar(128) DEFAULT NULL,
  `expected_response_count` varchar(128) DEFAULT NULL,
  `actual_response_count` varchar(128) DEFAULT NULL,
  `expected_roi` varchar(128) DEFAULT NULL,
  `actual_roi` varchar(128) DEFAULT NULL,
  `description` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table cash_count
# ------------------------------------------------------------

CREATE TABLE `cash_count` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee_username` varchar(128) DEFAULT NULL,
  `from` datetime DEFAULT NULL,
  `to` datetime DEFAULT NULL,
  `deposited` decimal(20,2) DEFAULT NULL,
  `discrepancy` decimal(20,2) DEFAULT NULL,
  `total_sales` decimal(20,2) DEFAULT NULL,
  `total_items` int(11) DEFAULT NULL,
  `sale_breakdown` text,
  `ip_address` varchar(32) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table charges
# ------------------------------------------------------------

CREATE TABLE `charges` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `percentage` decimal(20,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table config
# ------------------------------------------------------------

CREATE TABLE `config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `config` varchar(128) DEFAULT NULL,
  `value` text,
  `allow_branch_config` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table config_branch
# ------------------------------------------------------------

CREATE TABLE `config_branch` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `config` varchar(128) DEFAULT NULL,
  `value` text,
  `branch_id` int(11) DEFAULT NULL,
  `lastchange` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table contact_cases
# ------------------------------------------------------------

CREATE TABLE `contact_cases` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `contact_id` int(11) DEFAULT NULL,
  `subject` text,
  `description` text,
  `file_location` text,
  `reference_no` varchar(255) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `log_date` datetime DEFAULT NULL,
  `log_status` varchar(128) DEFAULT NULL,
  `log_user` varchar(128) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table contact_logs
# ------------------------------------------------------------

CREATE TABLE `contact_logs` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `contact_id` int(11) DEFAULT NULL,
  `case_id` int(11) DEFAULT NULL,
  `subject` varchar(128) DEFAULT NULL,
  `description` text,
  `status` varchar(128) DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `file` varchar(255) DEFAULT NULL,
  `current_file` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table contacts
# ------------------------------------------------------------

CREATE TABLE `contacts` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `is_customer` int(1) DEFAULT NULL,
  `is_supplier` int(1) DEFAULT NULL,
  `is_debtor` int(1) DEFAULT NULL,
  `is_creditor` int(1) DEFAULT NULL,
  `is_member` int(1) DEFAULT NULL,
  `is_stakeholder` int(1) DEFAULT NULL,
  `is_franchise` int(1) DEFAULT NULL,
  `is_franchisee` int(1) DEFAULT NULL,
  `is_agent` int(1) DEFAULT NULL,
  `is_prospect` int(1) DEFAULT NULL,
  `company_name` text,
  `company_registration` varchar(32) DEFAULT NULL,
  `contact_person` text,
  `contact_number` varchar(128) DEFAULT NULL,
  `credit_limit` decimal(20,2) DEFAULT NULL,
  `credit_term` int(11) DEFAULT NULL,
  `discount_limit` decimal(20,2) DEFAULT NULL,
  `rank` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `ic` varchar(128) DEFAULT NULL,
  `password` varchar(128) DEFAULT NULL,
  `introducer_ic` varchar(128) DEFAULT NULL,
  `address1` varchar(128) DEFAULT NULL,
  `address2` varchar(128) DEFAULT NULL,
  `city` varchar(128) DEFAULT NULL,
  `state` varchar(128) DEFAULT NULL,
  `zipcode` varchar(32) DEFAULT NULL,
  `country` varchar(128) DEFAULT NULL,
  `tel` varchar(128) DEFAULT NULL,
  `fax` varchar(128) DEFAULT NULL,
  `general_email` varchar(128) DEFAULT NULL,
  `terms` text,
  `description` text,
  `remarks` text,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `user_type` varchar(128) DEFAULT NULL,
  `user_verified` int(1) DEFAULT NULL,
  `loyalty_points` int(11) DEFAULT NULL,
  `current_session` varchar(128) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `facebook_id` varchar(128) DEFAULT NULL,
  `nationality` varchar(128) DEFAULT NULL,
  `lastchange` varchar(128) DEFAULT NULL,
  `tax_no` varchar(255) DEFAULT NULL,
  `notes` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table countries
# ------------------------------------------------------------

CREATE TABLE `countries` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `prefix` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table credit_cards
# ------------------------------------------------------------

CREATE TABLE `credit_cards` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `percentage` decimal(20,2) DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `enabled` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table credit_note_items
# ------------------------------------------------------------

CREATE TABLE `credit_note_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `credit_note_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_description` text,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `received` int(11) DEFAULT NULL,
  `received_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `division_id` int(128) DEFAULT NULL,
  `warehouse_id` int(128) DEFAULT NULL,
  `taxable` int(11) DEFAULT NULL,
  `tax_code` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table credit_notes
# ------------------------------------------------------------

CREATE TABLE `credit_notes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `dn_number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_received` decimal(20,2) DEFAULT NULL,
  `tax` text,
  `total_tax` decimal(20,2) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `paid_amount` decimal(20,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table customers
# ------------------------------------------------------------

CREATE TABLE `customers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `company_name` varchar(128) DEFAULT NULL,
  `reg_number` varchar(128) DEFAULT NULL,
  `address` text,
  `contact_person` varchar(128) DEFAULT NULL,
  `contact_no` varchar(128) DEFAULT NULL,
  `credit_limit` decimal(20,2) DEFAULT NULL,
  `status` varchar(32) DEFAULT NULL,
  `remarks` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table debit_note_items
# ------------------------------------------------------------

CREATE TABLE `debit_note_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `debit_note_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_description` text,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `received` int(11) DEFAULT NULL,
  `received_price` float(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxable` int(1) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table debit_notes
# ------------------------------------------------------------

CREATE TABLE `debit_notes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `cn_number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `supplier` varchar(128) DEFAULT NULL,
  `supplier_id` int(11) DEFAULT NULL,
  `supplier_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_received` decimal(20,2) DEFAULT NULL,
  `tax` text,
  `total_tax` decimal(20,2) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `paid_amount` decimal(20,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table department
# ------------------------------------------------------------

CREATE TABLE `department` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `description` text,
  `company_name` varchar(128) DEFAULT NULL,
  `company_registration` varchar(128) DEFAULT NULL,
  `logo` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table disposal_appreciation
# ------------------------------------------------------------

CREATE TABLE `disposal_appreciation` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(11) DEFAULT NULL,
  `asset_name` varchar(128) DEFAULT NULL,
  `asset_category` varchar(128) DEFAULT NULL,
  `asset_subcategory` varchar(128) DEFAULT NULL,
  `value_on_disposal` decimal(20,2) DEFAULT NULL,
  `disposed_value` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table disposal_depreciation
# ------------------------------------------------------------

CREATE TABLE `disposal_depreciation` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(11) DEFAULT NULL,
  `asset_name` varchar(128) DEFAULT NULL,
  `asset_category` varchar(128) DEFAULT NULL,
  `asset_subcategory` varchar(128) DEFAULT NULL,
  `value_on_disposal` decimal(20,2) DEFAULT NULL,
  `disposed_value` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table editor_compilations
# ------------------------------------------------------------

CREATE TABLE `editor_compilations` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `profile_id` int(11) DEFAULT NULL,
  `version` varchar(128) DEFAULT NULL,
  `build_no` varchar(128) DEFAULT NULL,
  `change_log` text,
  `version_type` varchar(128) DEFAULT NULL,
  `svn_url` text,
  `compiled_on` datetime DEFAULT NULL,
  `compiled_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table editor_live_contents
# ------------------------------------------------------------

CREATE TABLE `editor_live_contents` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `profile_id` int(11) DEFAULT NULL,
  `item` text,
  `contents` text,
  `datetime` datetime DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table editor_profiles
# ------------------------------------------------------------

CREATE TABLE `editor_profiles` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `hostname` varchar(128) DEFAULT NULL,
  `linker_file` text,
  `username` varchar(128) DEFAULT NULL,
  `password` varchar(128) DEFAULT NULL,
  `plexsvn_linker` varchar(128) DEFAULT NULL,
  `api_key` varchar(128) DEFAULT NULL,
  `root_url` text,
  `root_path` varchar(128) DEFAULT NULL,
  `root` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `ftp_protocol` varchar(16) DEFAULT NULL,
  `ftp_port` varchar(10) DEFAULT NULL,
  `ftp_server` varchar(128) DEFAULT NULL,
  `ftp_username` varchar(128) DEFAULT NULL,
  `ftp_password` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table editor_revisions
# ------------------------------------------------------------

CREATE TABLE `editor_revisions` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `profile_id` int(11) DEFAULT NULL,
  `item` text,
  `contents` text,
  `datetime` datetime DEFAULT NULL,
  `user` varchar(128) DEFAULT NULL,
  `commit` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table editor_sessions
# ------------------------------------------------------------

CREATE TABLE `editor_sessions` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `profile_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `last_change` varchar(128) DEFAULT NULL,
  `item` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table email_notifications
# ------------------------------------------------------------

CREATE TABLE `email_notifications` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `contact_id` int(11) DEFAULT NULL,
  `contact_email` varchar(128) DEFAULT NULL,
  `module` varchar(128) DEFAULT NULL,
  `transaction` varchar(128) DEFAULT NULL,
  `transaction_id` int(11) DEFAULT NULL,
  `remarks` text,
  `datetime` datetime DEFAULT NULL,
  `subject` text,
  `message` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table employee_cico
# ------------------------------------------------------------

CREATE TABLE `employee_cico` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `check_in` datetime DEFAULT NULL,
  `check_out` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employee_dependents
# ------------------------------------------------------------

CREATE TABLE `employee_dependents` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `relationship` varchar(128) DEFAULT NULL,
  `dob` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employee_documents
# ------------------------------------------------------------

CREATE TABLE `employee_documents` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `filename` varchar(128) DEFAULT NULL,
  `filetype` varchar(32) DEFAULT NULL,
  `size` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employee_education
# ------------------------------------------------------------

CREATE TABLE `employee_education` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `education` varchar(128) DEFAULT NULL,
  `major` varchar(128) DEFAULT NULL,
  `year` varchar(4) DEFAULT NULL,
  `gpa_score` varchar(128) DEFAULT NULL,
  `start_date` varchar(128) DEFAULT NULL,
  `end_date` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employee_emergency_contacts
# ------------------------------------------------------------

CREATE TABLE `employee_emergency_contacts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `relationship` varchar(128) DEFAULT NULL,
  `home_phone` varchar(128) DEFAULT NULL,
  `mobile` varchar(128) DEFAULT NULL,
  `work_phone` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employee_languages
# ------------------------------------------------------------

CREATE TABLE `employee_languages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `language` varchar(128) DEFAULT NULL,
  `fluency` varchar(128) DEFAULT NULL,
  `competency` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employee_licenses
# ------------------------------------------------------------

CREATE TABLE `employee_licenses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `start_date` varchar(128) DEFAULT NULL,
  `end_date` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employee_skills
# ------------------------------------------------------------

CREATE TABLE `employee_skills` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `skill` varchar(128) DEFAULT NULL,
  `years_of_experience` int(11) DEFAULT NULL,
  `remarks` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employee_work_experience
# ------------------------------------------------------------

CREATE TABLE `employee_work_experience` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` varchar(128) DEFAULT NULL,
  `employer` varchar(128) DEFAULT NULL,
  `start_date` date DEFAULT NULL,
  `end_date` date DEFAULT NULL,
  `job_title` varchar(128) DEFAULT NULL,
  `remarks` varchar(128) DEFAULT NULL,
  `internal` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employees
# ------------------------------------------------------------

CREATE TABLE `employees` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(128) DEFAULT NULL,
  `password` varchar(128) DEFAULT NULL,
  `firstname` varchar(128) DEFAULT NULL,
  `lastname` varchar(128) DEFAULT NULL,
  `gender` varchar(128) DEFAULT NULL,
  `nationality` varchar(128) DEFAULT NULL,
  `dob` date DEFAULT NULL,
  `marital_status` varchar(128) DEFAULT NULL,
  `race` varchar(128) DEFAULT NULL,
  `ic_no` varchar(128) DEFAULT NULL,
  `photo` text,
  `address1` text,
  `address2` text,
  `city` varchar(128) DEFAULT NULL,
  `stateprov` varchar(128) DEFAULT NULL,
  `zipcode` varchar(128) DEFAULT NULL,
  `country` varchar(128) DEFAULT NULL,
  `session` int(1) DEFAULT NULL,
  `active` int(1) DEFAULT NULL,
  `home_phone` varchar(128) DEFAULT NULL,
  `mobile` varchar(128) DEFAULT NULL,
  `work_phone` varchar(128) DEFAULT NULL,
  `work_email` varchar(128) DEFAULT NULL,
  `other_email` varchar(128) DEFAULT NULL,
  `employment_start_date` datetime DEFAULT NULL,
  `employment_end_date` datetime DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `division` varchar(128) DEFAULT NULL,
  `ip_address` varchar(32) DEFAULT NULL,
  `last_login` datetime DEFAULT NULL,
  `last_logout` datetime DEFAULT NULL,
  `remarks` text,
  `status` varchar(32) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `position` varchar(32) DEFAULT NULL,
  `is_manager` int(1) DEFAULT NULL,
  `is_cashier` int(1) DEFAULT NULL,
  `salary_category` varchar(32) DEFAULT NULL,
  `tax_id` varchar(255) DEFAULT NULL,
  `epf_id` varchar(255) DEFAULT NULL,
  `socso_id` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table employment
# ------------------------------------------------------------

CREATE TABLE `employment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `job_title` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `pay_grade` varchar(128) DEFAULT NULL,
  `pay_frequency` varchar(128) DEFAULT NULL,
  `minimum_salary` decimal(20,2) DEFAULT NULL,
  `maximum_salary` decimal(20,2) DEFAULT NULL,
  `basic_salary` decimal(20,2) DEFAULT NULL,
  `division` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fifo
# ------------------------------------------------------------

CREATE TABLE `fifo` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `item_id` int(11) DEFAULT NULL,
  `po_item_id` int(11) DEFAULT NULL,
  `po_id` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `from_qty` int(11) DEFAULT NULL,
  `to_qty` int(11) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_buffer_sale_items
# ------------------------------------------------------------

CREATE TABLE `fnb_buffer_sale_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` datetime DEFAULT NULL,
  `ss_terminal` varchar(128) DEFAULT NULL,
  `ss_code` varchar(128) DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `si_item_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `item_option` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `category` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `subcategory` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` float(10,2) DEFAULT NULL,
  `margin` float(10,4) DEFAULT NULL,
  `cost` float(10,4) DEFAULT NULL,
  `amount` float(10,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `printed` int(1) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `ordered_by` varchar(128) DEFAULT NULL,
  `ordered_time` datetime DEFAULT NULL,
  `serial` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxable` int(11) DEFAULT NULL,
  `tax_code` varchar(128) DEFAULT NULL,
  `instant_sale` int(1) DEFAULT NULL,
  `discount` decimal(20,1) DEFAULT NULL,
  `global_discount` decimal(20,1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_buffer_sales
# ------------------------------------------------------------

CREATE TABLE `fnb_buffer_sales` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `table_no` varchar(128) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee_username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `subtotal` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `amount_voucher` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_discount` varchar(128) DEFAULT NULL,
  `adjustment` decimal(10,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `payment` text,
  `verified` int(1) DEFAULT '1',
  `warehouse_Id` int(11) DEFAULT NULL,
  `taxes` text,
  `taxable_amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `cc_type` int(11) DEFAULT NULL,
  `cc_fee` decimal(20,2) DEFAULT NULL,
  `cc_name` varchar(32) DEFAULT NULL,
  `cc_percentage` decimal(20,2) DEFAULT NULL,
  `cc_tax_percentage` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `cc_amount` decimal(20,2) DEFAULT NULL,
  `no_of_pax` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(255) DEFAULT NULL,
  `service_charge` decimal(20,2) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  `table_card_no` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_cash_count
# ------------------------------------------------------------

CREATE TABLE `fnb_cash_count` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee_username` varchar(128) DEFAULT NULL,
  `from` datetime DEFAULT NULL,
  `to` datetime DEFAULT NULL,
  `deposited` float(10,2) DEFAULT NULL,
  `discrepancy` float(10,2) DEFAULT NULL,
  `total_sales` float(10,2) DEFAULT NULL,
  `total_items` int(11) DEFAULT NULL,
  `ip_address` varchar(32) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_category_options
# ------------------------------------------------------------

CREATE TABLE `fnb_category_options` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `options` text,
  `customer_options` text,
  `price` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_delivery_order_items
# ------------------------------------------------------------

CREATE TABLE `fnb_delivery_order_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `datetime` datetime DEFAULT NULL,
  `order_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_option` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` float(10,2) DEFAULT NULL,
  `margin` float(10,4) DEFAULT NULL,
  `cost` float(10,4) DEFAULT NULL,
  `amount` float(10,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `printed` int(1) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `ordered_by` varchar(128) DEFAULT NULL,
  `ordered_time` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_delivery_orders
# ------------------------------------------------------------

CREATE TABLE `fnb_delivery_orders` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `datetime` datetime DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `order_data` text,
  `type` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `online` int(1) DEFAULT NULL,
  `discount` varchar(128) NOT NULL DEFAULT '',
  `customer_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_inventory
# ------------------------------------------------------------

CREATE TABLE `fnb_inventory` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `subcategory` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `frontend_subcategory` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `name` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `frontend_name` varchar(128) DEFAULT NULL,
  `frontend_show` int(1) DEFAULT '1',
  `sku` varchar(128) DEFAULT NULL,
  `si_item_id` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT '0',
  `cost` decimal(20,2) NOT NULL,
  `item_price` decimal(20,2) DEFAULT NULL,
  `price` text,
  `has_options` int(1) DEFAULT NULL,
  `options` text,
  `customer_price` text,
  `customer_options` text,
  `has_customer_options` int(1) DEFAULT NULL,
  `description` text,
  `supplier` varchar(128) DEFAULT NULL,
  `remarks` text,
  `is_active` varchar(10) DEFAULT NULL,
  `is_consigned` varchar(10) DEFAULT NULL,
  `alert_quantity` int(11) DEFAULT NULL,
  `max_quantity` int(11) DEFAULT NULL,
  `ordered_quantity` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `quick` int(1) DEFAULT NULL,
  `enter_price` int(1) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `category_order` int(11) DEFAULT NULL,
  `iphone` int(1) DEFAULT NULL,
  `grouped` int(1) DEFAULT NULL,
  `printer` varchar(128) DEFAULT NULL,
  `purchase_tax_code` varchar(128) DEFAULT NULL,
  `purchase_taxable` varchar(128) DEFAULT NULL,
  `supply_tax_code` varchar(128) DEFAULT NULL,
  `supply_taxable` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_printer_map
# ------------------------------------------------------------

CREATE TABLE `fnb_printer_map` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `categories` tinytext,
  `subcategories` text,
  `printer_ip` varchar(32) DEFAULT NULL,
  `waiter_copy` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_reverts
# ------------------------------------------------------------

CREATE TABLE `fnb_reverts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `performed_by` varchar(128) DEFAULT NULL,
  `data` text,
  `datetime` datetime DEFAULT NULL,
  `revert` int(1) DEFAULT NULL,
  `remarks` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table fnb_sale_items
# ------------------------------------------------------------

CREATE TABLE `fnb_sale_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` datetime DEFAULT NULL,
  `ss_terminal` varchar(128) DEFAULT NULL,
  `ss_code` varchar(128) DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `si_item_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `item_option` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `category` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `subcategory` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` float(10,2) DEFAULT NULL,
  `margin` float(10,4) DEFAULT NULL,
  `cost` float(10,4) DEFAULT NULL,
  `amount` float(10,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `printed` int(1) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `ordered_by` varchar(128) DEFAULT NULL,
  `ordered_time` datetime DEFAULT NULL,
  `serial` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxable` int(11) DEFAULT NULL,
  `tax_code` varchar(128) DEFAULT NULL,
  `instant_sale` int(1) DEFAULT NULL,
  `discount` decimal(20,1) DEFAULT NULL,
  `global_discount` decimal(20,1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_sales
# ------------------------------------------------------------

CREATE TABLE `fnb_sales` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `table_no` varchar(128) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee_username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `subtotal` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `amount_voucher` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_discount` varchar(128) DEFAULT NULL,
  `adjustment` decimal(10,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `payment` text,
  `verified` int(1) DEFAULT '1',
  `warehouse_id` int(11) DEFAULT NULL,
  `taxes` text,
  `taxable_amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `cc_type` int(11) DEFAULT NULL,
  `cc_fee` decimal(20,2) DEFAULT NULL,
  `cc_name` varchar(32) DEFAULT NULL,
  `cc_percentage` decimal(20,2) DEFAULT NULL,
  `cc_tax_percentage` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `cc_amount` decimal(20,2) DEFAULT NULL,
  `no_of_pax` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(255) DEFAULT NULL,
  `service_charge` decimal(20,2) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  `table_card_no` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_self_service_map
# ------------------------------------------------------------

CREATE TABLE `fnb_self_service_map` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `terminal_id` int(11) DEFAULT NULL,
  `categories` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `printer` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_subcategory_options
# ------------------------------------------------------------

CREATE TABLE `fnb_subcategory_options` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `category` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `options` text,
  `customer_options` text,
  `price` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table fnb_table_cards
# ------------------------------------------------------------

CREATE TABLE `fnb_table_cards` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `card_no` varchar(255) DEFAULT NULL,
  `short_no` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table im
# ------------------------------------------------------------

CREATE TABLE `im` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subject` varchar(128) DEFAULT NULL,
  `division` varchar(128) DEFAULT NULL,
  `department` varchar(128) DEFAULT NULL,
  `priority` varchar(128) DEFAULT NULL,
  `from` varchar(128) DEFAULT NULL,
  `to` varchar(128) DEFAULT NULL,
  `message` text,
  `user_copy` int(1) DEFAULT '0',
  `datetime` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table inventory
# ------------------------------------------------------------

CREATE TABLE `inventory` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `primary_image` text,
  `image` text,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `brand` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `model_no` varchar(128) DEFAULT NULL,
  `warranty` varchar(128) DEFAULT NULL,
  `sku` varchar(128) DEFAULT NULL,
  `sku2` varchar(128) DEFAULT NULL,
  `sku3` varchar(128) DEFAULT NULL,
  `sku4` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT '0',
  `alert_quantity` int(11) DEFAULT NULL,
  `max_quantity` int(11) DEFAULT NULL,
  `cost` decimal(10,4) NOT NULL,
  `average_cost` decimal(10,4) DEFAULT NULL,
  `price` decimal(10,2) DEFAULT NULL,
  `price_2` decimal(10,2) DEFAULT NULL,
  `price_3` decimal(10,2) DEFAULT NULL,
  `price_4` decimal(10,2) DEFAULT NULL,
  `price2` decimal(10,2) DEFAULT NULL,
  `price2_2` decimal(10,2) DEFAULT NULL,
  `price2_3` decimal(10,2) DEFAULT NULL,
  `price2_4` decimal(10,2) DEFAULT NULL,
  `price3` decimal(10,2) DEFAULT NULL,
  `price3_2` decimal(10,2) DEFAULT NULL,
  `price3_3` decimal(10,2) DEFAULT NULL,
  `price3_4` decimal(10,2) DEFAULT NULL,
  `price4` decimal(10,2) DEFAULT NULL,
  `price4_2` decimal(10,2) DEFAULT NULL,
  `price4_3` decimal(10,2) DEFAULT NULL,
  `price4_4` decimal(10,2) DEFAULT NULL,
  `description` text,
  `supplier` varchar(128) DEFAULT NULL,
  `remarks` text,
  `ordered_quantity` int(11) DEFAULT NULL,
  `is_active` varchar(10) DEFAULT NULL,
  `is_consigned` varchar(10) DEFAULT NULL,
  `quick` int(1) DEFAULT NULL,
  `adjust_cost` int(1) NOT NULL DEFAULT '0',
  `enter_price` int(1) DEFAULT '0',
  `enter_serial` int(1) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `redeemable` int(1) DEFAULT NULL,
  `redeem_points` int(11) DEFAULT NULL,
  `current_po` int(11) DEFAULT NULL,
  `current_po_item` int(11) DEFAULT NULL,
  `uom1` varchar(128) DEFAULT NULL,
  `uom2` varchar(128) DEFAULT NULL,
  `uom3` varchar(128) DEFAULT NULL,
  `uom4` varchar(128) DEFAULT NULL,
  `loose_qty2` int(11) DEFAULT NULL,
  `loose_qty3` int(11) DEFAULT NULL,
  `loose_qty4` int(11) DEFAULT NULL,
  `weight` decimal(20,2) DEFAULT NULL,
  `weight_unit` varchar(10) DEFAULT NULL,
  `weight2` decimal(20,2) DEFAULT NULL,
  `weight3` decimal(20,2) DEFAULT NULL,
  `weight4` decimal(20,2) DEFAULT NULL,
  `volume` decimal(20,2) DEFAULT NULL,
  `volume_unit` varchar(10) DEFAULT NULL,
  `volume2` decimal(20,2) DEFAULT NULL,
  `volume3` decimal(20,2) DEFAULT NULL,
  `volume4` decimal(20,2) DEFAULT NULL,
  `min_cart_qty` int(11) DEFAULT NULL,
  `max_cart_qty` int(11) DEFAULT NULL,
  `ready_for_sale` int(1) DEFAULT NULL,
  `last_sold` datetime DEFAULT NULL,
  `isbn` varchar(128) DEFAULT NULL,
  `links` text,
  `linked` text,
  `author` text,
  `publisher` varchar(128) DEFAULT NULL,
  `lastchange` varchar(128) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `purchase_tax_code` varchar(32) DEFAULT NULL,
  `supply_tax_code` varchar(32) DEFAULT NULL,
  `purchase_taxable` int(1) DEFAULT NULL,
  `supply_taxable` int(1) DEFAULT NULL,
  `gl_account` int(11) DEFAULT NULL,
  `sale_account` int(11) DEFAULT NULL,
  `purchase_account` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table inventory_stock_quantities
# ------------------------------------------------------------

CREATE TABLE `inventory_stock_quantities` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `alert_quantity` int(11) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `last_sold` datetime DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table invoice_items
# ------------------------------------------------------------

CREATE TABLE `invoice_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `invoice_id` int(11) DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_name` text,
  `item_description` text,
  `item_id` int(11) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `margin` decimal(20,2) DEFAULT NULL,
  `delivered` int(11) DEFAULT NULL,
  `delivered_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `consignment` int(1) DEFAULT NULL,
  `taxable` int(11) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table invoices
# ------------------------------------------------------------

CREATE TABLE `invoices` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `quote_id` int(11) DEFAULT NULL,
  `sales_order_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `po_number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_address` text,
  `delivery_address` text,
  `delivery_tracking_no` varchar(128) DEFAULT NULL,
  `delivery_status` varchar(128) DEFAULT NULL,
  `delivery_date` datetime DEFAULT NULL,
  `shipping` varchar(128) DEFAULT NULL,
  `shipping_id` int(11) DEFAULT NULL,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_delivered` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,
  `paid_cash` int(1) DEFAULT NULL,
  `paid_cc` int(1) DEFAULT NULL,
  `paid_cheque` int(1) DEFAULT NULL,
  `paid_credit` int(1) DEFAULT NULL,
  `paid_bank_deposit` int(1) DEFAULT NULL,
  `tax` text,
  `total_tax` decimal(20,2) DEFAULT NULL,
  `sales_reference_id` int(11) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` int(11) DEFAULT NULL,
  `notification` text,
  `consignment` int(1) DEFAULT NULL,
  `referrer_contact_id` int(11) DEFAULT NULL,
  `paid_amount` decimal(20,2) DEFAULT '0.00',
  `charges` text,
  `total_charges` decimal(20,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table jobsheet
# ------------------------------------------------------------

CREATE TABLE `jobsheet` (
  `id` int(11) DEFAULT NULL,
  `job` varchar(128) DEFAULT NULL,
  `department` varchar(128) DEFAULT NULL,
  `priority` varchar(128) DEFAULT NULL,
  `deadline` datetime DEFAULT NULL,
  `start` datetime DEFAULT NULL,
  `end` datetime DEFAULT NULL,
  `note` text,
  `user` varchar(128) DEFAULT NULL,
  `assignee` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table journal
# ------------------------------------------------------------

CREATE TABLE `journal` (
  `id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `journal` varchar(128) DEFAULT NULL,
  `ref` varchar(128) DEFAULT NULL,
  `description` varchar(128) DEFAULT NULL,
  `credit_to` varchar(128) DEFAULT NULL,
  `debit_to` varchar(128) DEFAULT NULL,
  `currency` varchar(5) DEFAULT NULL,
  `amount` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table leads
# ------------------------------------------------------------

CREATE TABLE `leads` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `firstname` varchar(128) DEFAULT NULL,
  `lastname` varchar(128) DEFAULT NULL,
  `company` varchar(128) DEFAULT NULL,
  `title` varchar(128) DEFAULT NULL,
  `phone` varchar(128) DEFAULT NULL,
  `mobile` varchar(128) DEFAULT NULL,
  `fax` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `assigned_to` text,
  `division` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `source` varchar(128) DEFAULT NULL,
  `campaign` varchar(128) DEFAULT NULL,
  `campaign_name` varchar(128) DEFAULT NULL,
  `address1` varchar(128) DEFAULT NULL,
  `address2` varchar(128) DEFAULT NULL,
  `city` varchar(128) DEFAULT NULL,
  `zipcode` varchar(128) DEFAULT NULL,
  `state` varchar(128) DEFAULT NULL,
  `country` varchar(128) DEFAULT NULL,
  `web` varchar(128) DEFAULT NULL,
  `description` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table leave
# ------------------------------------------------------------

CREATE TABLE `leave` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `employee_id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `from` date DEFAULT NULL,
  `to` date DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table license
# ------------------------------------------------------------

CREATE TABLE `license` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `date_form` datetime DEFAULT NULL,
  `date_to` double DEFAULT NULL,
  `key` varchar(128) DEFAULT NULL,
  `vkey` varchar(128) DEFAULT NULL,
  `count` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table manufacturing_order
# ------------------------------------------------------------

CREATE TABLE `manufacturing_order` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `product_name` varchar(128) DEFAULT NULL,
  `bom_id` int(11) DEFAULT NULL,
  `quantity` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `progress_date` datetime DEFAULT NULL,
  `actual_progress_date` datetime DEFAULT NULL,
  `remarks` text,
  `end_date` datetime DEFAULT NULL,
  `actual_end_date` datetime DEFAULT NULL,
  `actual_quantity` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table manufacturing_order_components
# ------------------------------------------------------------

CREATE TABLE `manufacturing_order_components` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `component_id` int(11) DEFAULT NULL,
  `raw_material_id` int(11) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `uom` varchar(128) DEFAULT NULL,
  `remarks` text,
  `shelf_life` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table members
# ------------------------------------------------------------

CREATE TABLE `members` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `nric` varchar(32) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `tel` varchar(11) DEFAULT NULL,
  `address1` text,
  `address2` text,
  `zipcode` varchar(128) DEFAULT NULL,
  `points` int(11) DEFAULT NULL,
  `added_on` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `remarks` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table memo
# ------------------------------------------------------------

CREATE TABLE `memo` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` text,
  `memo` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` datetime DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table menu_items
# ------------------------------------------------------------

CREATE TABLE `menu_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `sku` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT '0',
  `cost` float(10,4) NOT NULL,
  `item_price` float(10,2) DEFAULT NULL,
  `price` text,
  `options` text,
  `description` text,
  `supplier` varchar(128) DEFAULT NULL,
  `remarks` text,
  `is_active` varchar(10) DEFAULT NULL,
  `is_consigned` varchar(10) DEFAULT NULL,
  `alert_quantity` int(11) DEFAULT NULL,
  `max_quantity` int(11) DEFAULT NULL,
  `ordered_quantity` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `quick` int(1) DEFAULT NULL,
  `enter_price` int(1) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `category_order` int(11) DEFAULT NULL,
  `iphone` int(1) DEFAULT NULL,
  `grouped` int(1) DEFAULT NULL,
  `printer` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table menu_printer_map
# ------------------------------------------------------------

CREATE TABLE `menu_printer_map` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `categories` tinytext,
  `printer_ip` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table modules
# ------------------------------------------------------------

CREATE TABLE `modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `controller_name` varchar(128) DEFAULT NULL,
  `tables` text,
  `common` varchar(128) DEFAULT NULL,
  `core` int(1) DEFAULT NULL,
  `actions` text,
  `action_names` text,
  `override` int(1) DEFAULT NULL,
  `enabled` int(11) DEFAULT NULL,
  `dependencies` text,
  `calendar_services` text,
  `custom_user_field` text,
  `custom_user_field_name` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table notifications
# ------------------------------------------------------------

CREATE TABLE `notifications` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `module` varchar(128) DEFAULT NULL,
  `user` varchar(128) DEFAULT NULL,
  `description` text,
  `link` text,
  `status` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `viewed_datetime` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table patient_history
# ------------------------------------------------------------

CREATE TABLE `patient_history` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `patient_id` int(11) DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `problem` text,
  `physical_examination` text,
  `diagnosis` text,
  `treatment` text,
  `meds` text,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `branch` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table patients
# ------------------------------------------------------------

CREATE TABLE `patients` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `contact_id` int(11) DEFAULT NULL,
  `marital_status` varchar(10) DEFAULT NULL,
  `weight` varchar(10) DEFAULT NULL,
  `height` varchar(10) DEFAULT NULL,
  `blood_type` varchar(5) DEFAULT NULL,
  `allergy` text,
  `spouse_ic` varchar(15) DEFAULT NULL,
  `gender` varchar(6) DEFAULT NULL,
  `emergency_contact` varchar(128) DEFAULT NULL,
  `ic` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `branch` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table payment_gateways
# ------------------------------------------------------------

CREATE TABLE `payment_gateways` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `namespace` varchar(128) DEFAULT NULL,
  `description` text,
  `initiate_script` text,
  `callback_script` text,
  `status` varchar(128) DEFAULT NULL,
  `percentage` decimal(10,2) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table payment_voucher_breakdown
# ------------------------------------------------------------

CREATE TABLE `payment_voucher_breakdown` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `pv_id` int(11) DEFAULT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `account` text,
  `account_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `description` text,
  `cc_charge` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `recon_id` int(11) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table payment_voucher_items
# ------------------------------------------------------------

CREATE TABLE `payment_voucher_items` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `pv_id` int(11) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `po_id` int(11) DEFAULT NULL,
  `cn_id` int(11) DEFAULT NULL,
  `dn_id` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `reference` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `description` text,
  `datetime` datetime DEFAULT NULL,
  `amount_payable` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(255) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table payment_vouchers
# ------------------------------------------------------------

CREATE TABLE `payment_vouchers` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(255) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `amount_payable` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `void_date` datetime DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  `tax_inclusive` int(1) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  `recon_id` int(11) DEFAULT NULL,
  `payee` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table permissions
# ------------------------------------------------------------

CREATE TABLE `permissions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_type` varchar(128) DEFAULT NULL,
  `module` text,
  `action` text,
  `divisions` text,
  `super` int(11) DEFAULT '0',
  `lastchange` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table pos_items_template
# ------------------------------------------------------------

CREATE TABLE `pos_items_template` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` text,
  `data` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table potentials
# ------------------------------------------------------------

CREATE TABLE `potentials` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `related_to` varchar(128) DEFAULT NULL,
  `lead_id` int(11) DEFAULT NULL,
  `currency` varchar(128) DEFAULT NULL,
  `amount` varchar(32) DEFAULT NULL,
  `assigned_to` text,
  `division` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `expected_close_date` date DEFAULT NULL,
  `lead_source` varchar(128) DEFAULT NULL,
  `next_step` varchar(128) DEFAULT NULL,
  `probability` varchar(128) DEFAULT NULL,
  `campaign` varchar(128) DEFAULT NULL,
  `campaign_name` varchar(128) DEFAULT NULL,
  `sales_stage` varchar(128) DEFAULT NULL,
  `description` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table product_reviews
# ------------------------------------------------------------

CREATE TABLE `product_reviews` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `status` varchar(128) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `review` text,
  `rating` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table purchase_order_items
# ------------------------------------------------------------

CREATE TABLE `purchase_order_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `purchase_order_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_description` text,
  `item_name` text,
  `item_id` int(11) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `received` int(11) DEFAULT NULL,
  `received_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxable` int(1) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table purchase_orders
# ------------------------------------------------------------

CREATE TABLE `purchase_orders` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `invoice_number` varchar(128) DEFAULT NULL,
  `pr_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `supplier` varchar(128) DEFAULT NULL,
  `supplier_id` int(11) DEFAULT NULL,
  `supplier_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_received` decimal(20,2) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `tax` text,
  `tax_inclusive` int(1) DEFAULT NULL,
  `total_tax` decimal(20,2) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `paid_amount` decimal(20,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table purchase_request_items
# ------------------------------------------------------------

CREATE TABLE `purchase_request_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `purchase_request_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_description` text,
  `item_name` text,
  `item_id` int(11) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `received` int(11) DEFAULT NULL,
  `received_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table purchase_requests
# ------------------------------------------------------------

CREATE TABLE `purchase_requests` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `po_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `supplier` varchar(128) DEFAULT NULL,
  `supplier_id` int(11) DEFAULT NULL,
  `supplier_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_received` decimal(20,2) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table quote_items
# ------------------------------------------------------------

CREATE TABLE `quote_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `quote_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_description` text,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table quotes
# ------------------------------------------------------------

CREATE TABLE `quotes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `quote_id` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `sales_order_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_address` text,
  `delivery_address` text,
  `shipping` varchar(128) DEFAULT NULL,
  `shipping_id` int(11) DEFAULT NULL,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_delivered` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table receipt_breakdown
# ------------------------------------------------------------

CREATE TABLE `receipt_breakdown` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `receipt_id` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_fees` decimal(20,2) DEFAULT NULL,
  `amount_effective` double(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `description` text,
  `cc_fees` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `cc_type` int(11) DEFAULT NULL,
  `cc_name` varchar(32) DEFAULT NULL,
  `recon_id` int(11) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table receipt_items
# ------------------------------------------------------------

CREATE TABLE `receipt_items` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `receipt_id` int(11) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `po_id` int(11) DEFAULT NULL,
  `cn_id` int(11) DEFAULT NULL,
  `dn_id` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `reference` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `description` text,
  `datetime` datetime DEFAULT NULL,
  `amount_receivable` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table receipts
# ------------------------------------------------------------

CREATE TABLE `receipts` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(255) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `amount_receivable` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_fees` double(20,2) DEFAULT NULL,
  `amount_effective` double(20,2) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `void_date` datetime DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  `tax_inclusive` int(1) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  `recon_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table report_to
# ------------------------------------------------------------

CREATE TABLE `report_to` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `supervisor_id` int(11) DEFAULT NULL,
  `supervisor` varchar(128) DEFAULT NULL,
  `subordinate_id` int(11) DEFAULT NULL,
  `subordinate` varchar(128) DEFAULT NULL,
  `reporting_method` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table reports
# ------------------------------------------------------------

CREATE TABLE `reports` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `description` text,
  `modules` text,
  `permissions` text,
  `process_script` text,
  `display_script` text,
  `script` text,
  `filters` text,
  `frontend` int(1) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table reports_saved
# ------------------------------------------------------------

CREATE TABLE `reports_saved` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(128) DEFAULT NULL,
  `title` varchar(128) DEFAULT NULL,
  `notes` text,
  `output` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table reverts
# ------------------------------------------------------------

CREATE TABLE `reverts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `performed_by` varchar(128) DEFAULT NULL,
  `data` text,
  `datetime` datetime DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `sync` int(1) DEFAULT NULL,
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `revert` int(11) DEFAULT NULL,
  `remarks` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table salary_deduction_table
# ------------------------------------------------------------

CREATE TABLE `salary_deduction_table` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `gross_from` decimal(20,2) DEFAULT NULL,
  `gross_to` decimal(20,2) DEFAULT NULL,
  `deduction_amount` decimal(20,2) DEFAULT NULL,
  `conditions` text,
  `type` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table salary_voucher
# ------------------------------------------------------------

CREATE TABLE `salary_voucher` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `datetime` datetime DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee` varchar(128) DEFAULT NULL,
  `ic_no` varchar(255) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_employer` decimal(20,2) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table salary_voucher_breakdown
# ------------------------------------------------------------

CREATE TABLE `salary_voucher_breakdown` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `sv_id` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table salary_voucher_format
# ------------------------------------------------------------

CREATE TABLE `salary_voucher_format` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `field_name` varchar(128) DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `percentage` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table salary_voucher_items
# ------------------------------------------------------------

CREATE TABLE `salary_voucher_items` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `sv_id` int(11) DEFAULT NULL,
  `field` varchar(128) DEFAULT NULL,
  `field_id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `description` text,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sale_items
# ------------------------------------------------------------

CREATE TABLE `sale_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `pseudo_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_sku2` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_uom` varchar(128) DEFAULT NULL,
  `sku_select` int(11) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `qty_fraction` int(11) DEFAULT NULL,
  `unit` varchar(128) DEFAULT NULL,
  `price_per_unit` decimal(20,2) DEFAULT NULL,
  `margin` decimal(20,4) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `discount_type` varchar(10) DEFAULT NULL,
  `discount_value` decimal(20,2) DEFAULT NULL,
  `discount_amount` decimal(20,2) DEFAULT NULL,
  `global_discount` decimal(20,2) DEFAULT NULL,
  `global_discount_type` varchar(1) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(11) DEFAULT NULL,
  `member_id` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `points` int(11) DEFAULT NULL,
  `redeemed` int(1) DEFAULT '0',
  `serial_no` varchar(128) DEFAULT NULL,
  `fnb` int(1) DEFAULT NULL,
  `sync` int(11) DEFAULT '0',
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `clinic_dosage` text,
  `tax_code` text,
  `taxable` int(11) DEFAULT NULL,
  `return` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sale_tax
# ------------------------------------------------------------

CREATE TABLE `sale_tax` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `sale_id` int(11) DEFAULT NULL,
  `tax` varchar(128) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sales
# ------------------------------------------------------------

CREATE TABLE `sales` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `cc_cost` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(1) DEFAULT NULL,
  `discount` varchar(32) DEFAULT NULL,
  `discount_type` varchar(32) DEFAULT NULL,
  `discount_amount` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,
  `amount_voucher` decimal(20,2) DEFAULT NULL,
  `cc_bank_amount` decimal(20,2) DEFAULT NULL,
  `cc_fees` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `cc_name` varchar(32) DEFAULT NULL,
  `subtotal` decimal(20,2) DEFAULT NULL,
  `cheque_received` int(1) DEFAULT NULL,
  `card_type` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `payment` text,
  `member_id` int(11) DEFAULT NULL,
  `customer_phone` varchar(128) DEFAULT NULL,
  `fnb` int(11) DEFAULT NULL,
  `sync` int(11) DEFAULT NULL,
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `pseudo_id` int(20) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxes` text,
  `taxable_amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `shipping` int(11) DEFAULT NULL,
  `shipping_name` varchar(128) DEFAULT NULL,
  `shipping_amount` decimal(20,2) DEFAULT NULL,
  `shipping_weight` decimal(20,4) DEFAULT NULL,
  `remarks` text,
  `added_on` datetime DEFAULT NULL,
  `clinic_consultation_status` varchar(128) DEFAULT NULL,
  `usid` varchar(128) DEFAULT NULL,
  `queue_no` bigint(20) DEFAULT NULL,
  `is_consulted` int(11) DEFAULT '0',
  `consultant_id` int(11) DEFAULT NULL,
  `service_charge` decimal(20,2) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sales_breakdown
# ------------------------------------------------------------

CREATE TABLE `sales_breakdown` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `sale_id` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT '',
  `contact_id` int(11) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sales_discount_item_rules
# ------------------------------------------------------------

CREATE TABLE `sales_discount_item_rules` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `rule_id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(256) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_price` decimal(20,2) DEFAULT NULL,
  `discount_percentage` decimal(10,2) DEFAULT NULL,
  `discount_price` decimal(20,2) DEFAULT NULL,
  `date_from` datetime DEFAULT NULL,
  `date_to` datetime DEFAULT NULL,
  `applies_to` varchar(128) DEFAULT NULL,
  `is_performance_based` int(1) DEFAULT NULL,
  `performance_limit` decimal(20,2) DEFAULT NULL,
  `performance_duration` int(20) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sales_discount_rules
# ------------------------------------------------------------

CREATE TABLE `sales_discount_rules` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `date_validity` int(1) DEFAULT NULL,
  `date_from` datetime DEFAULT NULL,
  `date_to` datetime DEFAULT NULL,
  `scope` varchar(128) DEFAULT NULL,
  `contact` int(11) DEFAULT NULL,
  `ranks` text,
  `applies_to` varchar(128) DEFAULT NULL,
  `is_performance_based` int(1) DEFAULT NULL,
  `performance_limit` decimal(20,2) DEFAULT NULL,
  `performance_duration` int(20) DEFAULT NULL,
  `remarks` text,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sales_order
# ------------------------------------------------------------

CREATE TABLE `sales_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `txn_no` varchar(32) DEFAULT NULL,
  `quote_id` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `pr_number` varchar(128) DEFAULT NULL,
  `po_number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_gateway` varchar(128) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `shipping` varchar(128) DEFAULT NULL,
  `shipping_id` int(11) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_delivered` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `paid_cash` int(1) DEFAULT NULL,
  `paid_cc` int(1) DEFAULT NULL,
  `paid_cheque` int(1) DEFAULT NULL,
  `paid_credit` int(1) DEFAULT NULL,
  `sales_reference_id` int(11) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `notification` text,
  `consignment` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sales_order_items
# ------------------------------------------------------------

CREATE TABLE `sales_order_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sales_order_id` int(11) DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_name` text,
  `item_description` text,
  `item_id` int(11) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `margin` decimal(20,2) DEFAULT NULL,
  `delivered` int(11) DEFAULT NULL,
  `delivered_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `consignment` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table sales_sessions
# ------------------------------------------------------------

CREATE TABLE `sales_sessions` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `identifier` varchar(128) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `logged_in_by` varchar(128) DEFAULT NULL,
  `logged_out_by` varchar(128) DEFAULT NULL,
  `from` datetime DEFAULT NULL,
  `to` datetime DEFAULT NULL,
  `status` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table services
# ------------------------------------------------------------

CREATE TABLE `services` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` text,
  `description` text,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `last_tendered` datetime DEFAULT NULL,
  `remarks` text,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table settlements
# ------------------------------------------------------------

CREATE TABLE `settlements` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` date DEFAULT NULL,
  `reference_no` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `amount` float(10,2) DEFAULT NULL,
  `remarks` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table shipping
# ------------------------------------------------------------

CREATE TABLE `shipping` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `measurements_type` varchar(128) DEFAULT NULL,
  `calculation_technique` varchar(128) DEFAULT NULL,
  `shipping_factor` varchar(128) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table shipping_international_zones
# ------------------------------------------------------------

CREATE TABLE `shipping_international_zones` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `description` text,
  `countries` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table shipping_local_zones
# ------------------------------------------------------------

CREATE TABLE `shipping_local_zones` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `description` text,
  `zipcode_from` varchar(128) DEFAULT NULL,
  `zipcode_to` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table shipping_rates
# ------------------------------------------------------------

CREATE TABLE `shipping_rates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `service_id` int(11) DEFAULT NULL,
  `zone_type` varchar(128) DEFAULT NULL,
  `zone_id` int(11) DEFAULT NULL,
  `flat_rate` float(10,2) DEFAULT NULL,
  `first_weight` varchar(32) DEFAULT NULL,
  `first_weight_rate` float(10,2) DEFAULT NULL,
  `subsequent_weight` varchar(32) DEFAULT NULL,
  `subsequent_weight_rate` float(10,2) DEFAULT NULL,
  `max_weight` varchar(32) DEFAULT NULL,
  `max_weight_rate` float(10,2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table states
# ------------------------------------------------------------

CREATE TABLE `states` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `country` varchar(250) COLLATE latin1_general_ci DEFAULT NULL,
  `state` varchar(250) COLLATE latin1_general_ci DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;



# Dump of table stock_adjustment
# ------------------------------------------------------------

CREATE TABLE `stock_adjustment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `datetime` datetime DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `previous_qty` int(11) DEFAULT NULL,
  `new_qty` int(11) DEFAULT NULL,
  `remarks` text,
  `warehouse_id` int(11) DEFAULT NULL,
  `performed_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table stock_count
# ------------------------------------------------------------

CREATE TABLE `stock_count` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `event` text,
  `date` datetime DEFAULT NULL,
  `remarks` text,
  `status` varchar(32) DEFAULT NULL,
  `positive_deviation` varchar(32) DEFAULT NULL,
  `negative_deviation` varchar(32) DEFAULT NULL,
  `total_positive_mismatch` int(11) DEFAULT NULL,
  `total_negative_mismatch` int(11) DEFAULT NULL,
  `total_counted` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table stock_count_items
# ------------------------------------------------------------

CREATE TABLE `stock_count_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `count_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_cost` decimal(20,2) DEFAULT NULL,
  `item_price` decimal(20,2) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `discrepancy` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `username` varchar(32) DEFAULT NULL,
  `processed_qty` int(11) DEFAULT NULL,
  `processed_discrepancy` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table subscription
# ------------------------------------------------------------

CREATE TABLE `subscription` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `from_date` date DEFAULT NULL,
  `to_date` date DEFAULT NULL,
  `key` varchar(128) DEFAULT NULL,
  `hash` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table system_transactions
# ------------------------------------------------------------

CREATE TABLE `system_transactions` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `module` varchar(128) DEFAULT NULL,
  `action` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `record_id` int(11) DEFAULT NULL,
  `record_data` text,
  `datetime` datetime DEFAULT NULL,
  `performed_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table tags
# ------------------------------------------------------------

CREATE TABLE `tags` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `user` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table tax
# ------------------------------------------------------------

CREATE TABLE `tax` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `percentage` varchar(128) DEFAULT NULL,
  `enabled` varchar(128) DEFAULT NULL,
  `inclusive` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table tax_codes_purchase
# ------------------------------------------------------------

CREATE TABLE `tax_codes_purchase` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table tax_codes_supply
# ------------------------------------------------------------

CREATE TABLE `tax_codes_supply` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;



# Dump of table terminals
# ------------------------------------------------------------

CREATE TABLE `terminals` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(32) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `ip` varchar(32) DEFAULT NULL,
  `printer_name` varchar(255) DEFAULT NULL,
  `printer_type` varchar(255) DEFAULT NULL,
  `printer_width` int(11) DEFAULT NULL,
  `printer_footer` text,
  `display_name` varchar(128) DEFAULT NULL,
  `drawer_name` varchar(128) DEFAULT NULL,
  `trigger_chars` varchar(128) DEFAULT NULL,
  `identifier` varchar(8) DEFAULT NULL,
  `key` varchar(8) DEFAULT NULL,
  `auth_key` varchar(128) DEFAULT NULL,
  `pd_welcome1` varchar(20) DEFAULT NULL,
  `pd_welcome2` varchar(20) DEFAULT NULL,
  `pd_thankyou` varchar(20) DEFAULT NULL,
  `till_deposit` decimal(20,2) DEFAULT NULL,
  `linked_with_warehouse` int(1) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `lastchange` int(20) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table transactions
# ------------------------------------------------------------

CREATE TABLE `transactions` (
  `id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `type_id` int(11) DEFAULT NULL,
  `debit_credit` int(11) DEFAULT NULL,
  `reference_no` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `details` text,
  `amount` decimal(20,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table users
# ------------------------------------------------------------

CREATE TABLE `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(128) DEFAULT NULL,
  `password` varchar(128) DEFAULT NULL,
  `dob` date DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `link_type` varchar(128) DEFAULT NULL,
  `link_with` int(11) DEFAULT NULL,
  `gender` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `firstname` varchar(128) DEFAULT NULL,
  `lastname` varchar(128) DEFAULT NULL,
  `phone` varchar(32) DEFAULT NULL,
  `mobile` varchar(32) DEFAULT NULL,
  `role` varchar(128) DEFAULT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `last_login` datetime DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `timeout` varchar(128) DEFAULT NULL,
  `active` int(1) DEFAULT NULL,
  `terminal_active` int(1) DEFAULT NULL,
  `terminal_type` varchar(128) DEFAULT NULL,
  `terminal_identifier` varchar(128) DEFAULT NULL,
  `terminal_key` varchar(128) DEFAULT NULL,
  `terminal_ip` varchar(32) DEFAULT NULL,
  `terminal_session` varchar(128) DEFAULT NULL,
  `terminal_last_login` datetime DEFAULT NULL,
  `terminal_id` int(11) DEFAULT NULL,
  `terminal_name` varchar(128) DEFAULT NULL,
  `terminal_lock` int(1) DEFAULT NULL,
  `flag` varchar(128) DEFAULT NULL,
  `hash` varchar(128) DEFAULT NULL,
  `status` varchar(32) DEFAULT NULL,
  `data` text,
  `division` varchar(128) DEFAULT NULL,
  `branch` int(11) DEFAULT NULL,
  `employee_id` int(11) DEFAULT '0',
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `lastchange` varchar(128) DEFAULT NULL,
  `keycard` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table vacancies
# ------------------------------------------------------------

CREATE TABLE `vacancies` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `job_title` varchar(128) DEFAULT NULL,
  `manager` int(11) DEFAULT NULL,
  `description` text,
  `closing_date` date DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table warehouse_movement_items
# ------------------------------------------------------------

CREATE TABLE `warehouse_movement_items` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `movement_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(256) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `from_warehouse` varchar(128) DEFAULT NULL,
  `from_warehouse_name` varchar(128) DEFAULT NULL,
  `to_warehouse` int(11) DEFAULT NULL,
  `to_warehouse_name` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `delivered_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table warehouse_movements
# ------------------------------------------------------------

CREATE TABLE `warehouse_movements` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `from_warehouse` int(11) DEFAULT NULL,
  `from_warehouse_name` varchar(128) DEFAULT NULL,
  `from_warehouse_address` text,
  `to_warehouse` int(11) DEFAULT NULL,
  `to_warehouse_name` varchar(128) DEFAULT NULL,
  `to_warehouse_address` text,
  `total_items` int(11) DEFAULT NULL,
  `delivered_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `remarks` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



# Dump of table warehouses
# ------------------------------------------------------------

CREATE TABLE `warehouses` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `address1` text,
  `address2` text,
  `city` varchar(128) DEFAULT NULL,
  `state` varchar(128) DEFAULT NULL,
  `zipcode` varchar(128) DEFAULT NULL,
  `country` varchar(128) DEFAULT NULL,
  `telephone` varchar(128) DEFAULT NULL,
  `tel` varchar(128) DEFAULT NULL,
  `fax` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `remarks` text,
  `tags` text,
  `type` varchar(128) DEFAULT NULL,
  `type_reference` int(11) DEFAULT NULL,
  `online_store` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;




/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
