<?php

class API extends Controller {

	function API(){
		parent::Controller();
		
		header('Content-type: application/json');
		header('Access-Control-Allow-Origin: *');

		$identifier = $this->input->post('_identifier');
		$key		= $this->input->post('_key');
		$auth_key	= $this->input->post('_auth_key');
		
		$query = $this->db->query("SELECT * FROM `terminals` WHERE `identifier` = ? AND `key` = ? AND `auth_key` = ?", array($identifier, $key, $auth_key));
		
		if ($query->num_rows()){
			$this->terminal = $query->row();
		} else {
			// die();
		}
		
	}
	
	function Secure_query(){
		
		$result_type 	= $this->input->post('result_type');
		$query			= $this->input->post('query');
		
		$q 				= $this->db->query($query);
		
		if ($result_type == 'row'){
			echo json_encode($q->row());
		} else {
			echo json_encode($q->result());			
		}
		
	}
	
	function Get_sales_data(){
		$from 	= $this->input->post('from') ? $this->input->post('from') : date('Y-m-d 00:00:00', time() - (60*60*24*30));
		$to		= $this->input->post('to') ? $this->input->post('to') : date('Y-m-d 23:59:59', time());
		
		
		
		$query 	= $this->db->query("SELECT COALESCE(SUM(`amount`),0) AS `amount`, COALESCE(SUM(`amount_cash`),0) AS `amount_cash`, COALESCE(SUM(`amount_cc`),0) AS `amount_cc`, COALESCE(SUM(`amount_cheque`),0) AS `amount_cheque`, COALESCE(SUM(`amount_bank_deposit`),0) AS `amount_bank_deposit`, COALESCE(SUM(`cost`),0) AS `cost`, COALESCE(SUM(`tax_amount`),0) AS `tax_amount` FROM `sales` WHERE `datetime` >= '$from' AND `datetime` <= '$to' AND `type` = 'history'");
		$retail = $query->row();
		
		$query 	= $this->db->query("SELECT COALESCE(SUM(`amount`),0) AS `amount`, COALESCE(SUM(`amount_cash`),0) AS `amount_cash`, COALESCE(SUM(`amount_cc`),0) AS `amount_cc`, COALESCE(SUM(`amount_cheque`),0) AS `amount_cheque`, COALESCE(SUM(`cost`),0) AS `cost` FROM (
								SELECT *  FROM `fnb_buffer_sales` WHERE `datetime` >= '$from' AND `datetime` <= '$to' AND `type` = 'history' UNION 
								SELECT * FROM `fnb_sales` WHERE `datetime` >= '$from' AND `datetime` <= '$to' AND `type` = 'history') AS T");
		$fnb 	= $query->row();
		
		
		$query 	= $this->db->query("SELECT SUM(`total`) AS `amount`, SUM(`total_tax`) AS `tax_amount` FROM `invoices` WHERE `date` >= '$from' AND `date` <= '$to'");
		$invoice= $query->row();
		
		
		
		$data->retail	= $retail;
		$data->fnb		= $fnb;
		$data->invoice	= $invoice;
		
		echo json_encode($data);
		
	}
	
	
	function Get_tables_sql(){
		$res = fopen('sql/tables.sql','r');
		$sql = fread($res, filesize('sql/tables.sql'));
		fclose($res);
		
		$data->status = 'OK';
		$data->result = $sql;
		
		echo json_encode($data);
	}

	function Get_table_data(){
		$table	= $this->input->post('table');
    	$buffer = $this->input->post('buffer') ? $this->input->post('buffer') : 50;
    	$i 		= $this->input->post('position') ? $this->input->post('position') : 0;
    	$branch = $this->input->post('branch');
    	
    	$offset = $buffer * $i;
    	
    	if (!$table) return false;
    	
    	if ($branch){
	    	if ($table == 'users'){
		    	$query = $this->db->query("SELECT * FROM `$table` WHERE `branch` = ? ORDER BY `id` LIMIT $offset, $buffer", array($branch_id));		    	
	    	} else {
		    	$query = $this->db->query("SELECT * FROM `$table` WHERE `warehouse_id` = ? ORDER BY `id` LIMIT $offset, $buffer", array($branch_id));		    	
	    	}

    	} else {
	    	$query = $this->db->query("SELECT * FROM `$table` ORDER BY `id` LIMIT $offset, $buffer");
    	}

    	$res->total	 = count($query->result());    	
    	$res->result = $query->result();
    	$res->status = 'ok';
    	
    	if ($query->num_rows() != $buffer) $res->complete = 'ok';
    	else $res->complete = 'false';
    	
    	echo json_encode($res);
	}
	
	function Get_delta_table_data(){
		$table		= $this->input->post('table');
    	$buffer 	= $this->input->post('buffer') ? $this->input->post('buffer') : 50;
    	$i 			= $this->input->post('position') ? $this->input->post('position') : 0;
		$lastchange	= $this->input->post('lastchange');
		
		
    	if ($branch){
	    	if ($table == 'users'){
		    	$query = $this->db->query("SELECT * FROM `$table` WHERE `lastchange` > ? AND `branch` = ? ORDER BY `id` LIMIT $offset, $buffer", array($lastchange, $branch_id));		    	
	    	} else {
		    	$query = $this->db->query("SELECT * FROM `$table` WHERE `lastchange` > ? AND `warehouse_id` = ? ORDER BY `id` LIMIT $offset, $buffer", array($lastchange, $branch_id));		    	
	    	}
	    } else {
			$query = $this->db->query("SELECT * FROM `$table` WHERE `lastchange` > ? ORDER BY `id` LIMIT $offset, $buffer", array($lastchange));
		}
		
    	$res->total	 = count($query->result());    	
    	$res->result = $query->result();
    	$res->status = 'ok';
    	
    	if ($query->num_rows() != $buffer) $res->complete = 'ok';
    	else $res->complete = null;
    	
    	echo json_encode($res);

	}


	function Push_sales_data(){
		$sales_data = json_decode($this->input->post('sales'));
    	
    	$sync_time = time();
    	
    	foreach ($sales_data as $sale){

    	    $sale->pseudo_id = $sale->id;
    	    unset($sale->id);
    	    
    	    $sale->sync = true;
    	    $sale->sync_time = $sync_time;
    	    
    	    $query = $this->db->query("SELECT * FROM `sales` WHERE `txn_no` = ?", array($sale->txn_no));
    	    
    	    if (!$query->num_rows()){
    	    	
    	    	$sale_items = $sale->sale_items;
    	    	unset($sale->sale_items);
	        	
	        	$query = $this->db->insert('sales', $sale);
	        	$id = $query->insert_id;
	        	
	        	foreach ($sale_items as $sale_item){
	        		unset($sale_item->sale_id);
	        		$sale_item->sale_id = $id;
	        		unset($sale_item->id);
	        		$this->db->insert('sale_items', $sale_item);
	        	}
	        	
    	    	// evalute cost accordingly 
    	    	
    	    } else {
    	    	$a_sale = $query->row();
    	    	
    	    	$sale_items = $sale->sale_items;
    	    	unset($sale->sale_items);
    	    	
	        	$query = $this->db->update('sales', $sale, "`id` = '{$a_sale->id}'");
    	    	
    	    	$this->db->query("DELETE FROM `sale_items` WHERE `sale_id` = ?", array($a_sale->id));
    	    	
    	    	foreach ($sale_items as $sale_item){
    	    		$sale_item->sale_id = $a_sale->id;
    	    		unset($sale_item->id);
    	    		$this->db->insert('sale_items',$sale_item);
    	    	}
    	    	
    	    	// evalute cost accordingly 
	        	
	        	$resync->id 		= $id;
	        	$resync->pseudo_id 	= $sale->pseudo_id;
	        	$resync->time		= $sync_time;
	        	
	        	$resyncs[] = $resync;
	        }

    	}
    	
    
    	    			
    	$data->result = $sync_time;
    	$data->status = 'ok';

		echo json_encode($data);
	}
	

	function Get_server_info_update(){
		$local_ts	= $this->input->post('result');
		$table		= $this->input->post('table');
		$buffer		= $this->input->post('buffer') ? $this->input->post('buffer') : 10;
		$query 		= $this->db->query("SELECT * FROM `$table` WHERE `lastchange` > ? ORDER BY `lastchange` LIMIT $buffer",array($local_ts));

    	$res->total	 = count($query->result());    	
    	$res->result = $query->result();
    	$res->status = 'ok';
    	  
    	echo json_encode($res);
	}
	

}