<?php

class Clinic extends Controller {
	
	function Clinic(){
		parent::Controller();
		
		if ($this->config->config['client_side']){
	  		$res = fopen('AUTHKEY','r');
	  		$key = fread($res,filesize('AUTHKEY'));
	  		fclose($res);
	  		
	  		$res = fopen('CONN','r');
	  		$conn = fread($res,filesize('CONN'));
	  		fclose($res);
	  		
		  	if (!$key || !$conn){
			 	redirect('terminal/activate');
		  	}
	  	}
		
    	$this->load->model('user');
    	$this->load->model('system');
    	$this->load->model('inv');
    	
    	if ($this->uri->segment(1) == 'pos' && $this->uri->segment(2) == 'terminal'){
    		// do nothing	
    		
    		if ($this->uri->segment(2) != 'terminal'){
	    		$ip = $_SERVER['REMOTE_ADDR'];
	    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));
	    		
	
	
	    		if (!$query->num_rows()){
	
	    			if ($terminal_id = get_cookie('PLEX_POS_TERM_ID',true)){
	    				$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));
	    				$terminal = $query->row();
	    				
	    				if (md5($terminal->key . get_cookie('PLEX_POS_TERM_SESSION',true)) != get_cookie('PLEX_POS_TERM_HASH',true)){
	    					show_error('Access denied for terminal identifier <strong>' . get_cookie('PLEX_POS_TERM_IDENTIFIER',true) . '</strong>. Check if your terminal identifier and key is correct.');
	    				}
	    				
	    			} else {
	    				show_error('Access denied for IP Address <strong>' . $_SERVER['REMOTE_ADDR'] . '</strong>. Check if your terminal is using Dynamic IP access.');
	    			}
	    		}
    		
    		}
    		
    			
    	} else {
    		$ip = $_SERVER['REMOTE_ADDR'];
    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));

    		if (!$query->num_rows()){

    			if ($terminal_id = get_cookie('PLEX_POS_TERM_ID',true)){
    				$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));
    				$terminal = $query->row();
    				
    				if (md5($terminal->key . get_cookie('PLEX_POS_TERM_SESSION',true)) != get_cookie('PLEX_POS_TERM_HASH',true)){
    					show_error('Access denied for terminal identifier <strong>' . get_cookie('PLEX_POS_TERM_IDENTIFIER',true) . '</strong>. Check if your terminal identifier and key is correct.');
    				}
    				
    			} else {
    				show_error('Access denied for IP Address <strong>' . $_SERVER['REMOTE_ADDR'] . '</strong>.');
    			}
    		}
    	}

	}
	
	function Index(){
    	if (!$this->user->check_session()) redirect('clinic/login');
    	if (!$this->user->has_permission('to_use_pis','Clinic')) redirect('clinic/login');
    	
		$this->load->view('clinic/main', $data);
		
	}
	
	
    function Login($err){
    	if ($this->user->check_session() && $this->user->has_permission('to_use_pis','Clinic')) redirect('clinic');
    	if ($err == 'err1') $this->d['notice'] = 'Incorrect username or password.';
    	if ($err == 'err2') $this->d['notice'] = 'User is already logged in.';
    	if ($err == 'err3') $this->d['notice'] = 'User is not authorized.';
    	
    	$this->load->view('clinic/login',$this->d);
    }
    
    function Auth(){
    	
    	$user = $this->user->get_user_by_username($this->input->post('username'));
    	if ($user->terminal_active == 1) redirect('clinic/login/err2');
    	
    	if ($user->password == md5($this->input->post('password'))){
			if (!$this->user->has_permission('to_use_pis','Clinic', $user)) redirect('clinic/login/err3');
		}
    	
    	if ($this->user->login()){
    		redirect('clinic');
    	}
    	else redirect('clinic/login/err1');
    }

	
	function Ajax($request){
    	if (!$this->user->check_session() || !$this->user->has_permission('to_use_pis','Clinic')) return;
    	
		switch ($request){
			
			case "get_queue_list":
			
				$query = $this->db->query("SELECT * FROM `sales` WHERE `type` = 'queue' AND `warehouse_id` = ? AND `consultant_id` = ? ORDER BY `txn_no` ASC", array($this->user->data('branch'), $this->user->data('id')));
				foreach ($query->result() as $queue){
					$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($queue->customer_id));
					$queue->contact = $query->row();
					
					$datetime = date('h:iA', strtotime($queue->added_on));
					if ($queue->contact && !$queue->clinic_consultation_status){
						$output .= "<li id=\"{$queue->id}\"><strong>{$queue->contact->contact_person}</strong><br />Scheduled on {$datetime}</li>";
					}
				}
				
				echo $output;
			
				break;
				
			case "get_history_list":
			
				$queue_id = $this->input->post('id');

				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));
				$queue = $query->row();
				
				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($queue->customer_id));
				$contact = $query->row();
				
				$query = $this->db->query("SELECT * FROM `patients` WHERE `ic` = ?", array($contact->ic));
				$patient = $query->row();

				$query = $this->db->query("SELECT * FROM `patient_history` WHERE `patient_id` = ? ORDER BY `datetime` ASC", array($id));
				$history = $query->result();
				
				echo json_encode($history);
			
				break;
				
			case "search_item":
				
				$name = $this->input->post('name');
				
				$query = $this->db->query("SELECT * FROM `inventory` WHERE `name` LIKE ? LIMIT 1", array($name.'%'));
				$item = $query->row();
				
				for ($i = 1; $i <= 4; $i++){
					if ($item->{'uom'.$i}){
						$uoms[$i] = $item->{'uom'.$i};
					}
				}
				
				$item->uoms = $uoms;
				
				echo json_encode($item);
			
				break;
			
			case "get_patient_information":
				$queue_id = $this->input->post('id');
				
				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));
				$queue = $query->row();
				
				
				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($queue->customer_id));
				$contact = $query->row();
				
				$query = $this->db->query("SELECT * FROM `patients` WHERE `ic` = ?", array($contact->ic));
				$patient = $query->row();
				
				$query = $this->db->query("SELECT * FROM `patient_history` WHERE `patient_id` = ? ORDER BY `added_on` DESC", array($patient->id));
				$history = $query->result();
				
				$patient->history = $history;
				$patient->contact = $contact;
				
				echo json_encode($patient);
				
				break;
				
			case "call_queue":
			
				$queue_id = $this->input->post('id');
				
				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));
				$queue = $query->result();
				
				if ($queue->is_consulted){
					$this->db->query("UPDATE `sales` SET `is_consulted` = 0 WHERE `id` = ?", array($queue_id));					
					echo 'off';
				} else {
					$this->db->query("UPDATE `sales` SET `is_consulted` = 1 WHERE `id` = ?", array($queue_id));
					echo 'on';
				}
				
				
				break;
				
			case "get_patient_history_list":
				$queue_id = $this->input->post('id');
				
				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));
				$queue = $query->row();
				
				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($queue->customer_id));
				$contact = $query->row();
				
				$query = $this->db->query("SELECT * FROM `patients` WHERE `ic` = ?", array($contact->ic));
				$patient = $query->row();
				
			
				break;
				
			case "new_consultation":
				$queue_id = $this->input->post('id');
				
				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));
				$queue = $query->row();
				
				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($queue->customer_id));
				$contact = $query->row();
				
				$query = $this->db->query("SELECT * FROM `patients` WHERE `ic` = ?", array($contact->ic));
				$patient = $query->row();
				
				echo 'ok';
				
				break;
				
				
			case "close_consultation":
			
				$meds 			= $this->input->post('meds');
				$meds_name 		= $this->input->post('meds_name');
				$meds_dosage 	= $this->input->post('meds_dosage');
				$meds_price 	= $this->input->post('meds_price');
				$meds_uom		= $this->input->post('meds_uom');
				$meds_qty		= $this->input->post('meds_qty');
				
				$queue_id = $this->input->post('id');
				
				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));
				$queue = $query->row();
				
				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($queue->customer_id));
				$contact = $query->row();
				
				$query = $this->db->query("SELECT * FROM `patients` WHERE `ic` = ?", array($contact->ic));
				$patient = $query->row();
				
				

				
				if (strpos($meds, ',')){
					$meds 			= explode(',',$meds);
					$meds_name 		= explode(',', $meds_name);
					$meds_dosage 	= explode(',', $meds_dosage);
					$meds_price 	= explode(',', $meds_price);
					$meds_uom		= explode(',', $meds_uom);
					$meds_qty		= explode(',', $meds_qty);
				} else {
					$meds			= array($meds);
					$meds_name		= array($meds_name);
					$meds_dosage	= array($meds_dosage);
					$meds_price		= array($meds_price);
					$meds_uom		= array($meds_uom);
					$meds_qty		= array($meds_qty);
				}
				
				$z = 0;
				foreach ($meds as $med){
					$med_item_name 	= $meds_name[$z];
					$med_dosage		= $meds_dosage[$z];
					$med_price		= $meds_price[$z];
					$med_uom		= $meds_uom[$z];
					$med_qty		= $meds_qty[$z];
					$z++;
					
	    			$sku = $med;
	    			$qty = $med_qty;
	    			
	    			if ($sku[0] == 'x' OR $sku[0] == 'X'){
	    				$qty = str_replace('X','',str_replace('x','',$sku)) - 1;
	    				$sku = $this->session->userdata('last_sku');
	    				if (!is_numeric($qty)) $sku = '';
	    			} else {
	    				$this->session->set_userdata(array('last_sku'=>$sku));
	    			}
	    			
	    			
	    			if ($med_uom != 1){
	    				// secondary SKU search

	    				$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($sku));
	    		    	if ($query->num_rows()){
	    		    		$item = $obj = $query->row();
	    		    		
	    		    		$qty = $qty * $item->{'loose_qty'.$med_uom};
	    		    		$qty_fraction = $item->{'loose_qty'.$med_uom};
	
	    		    		$sku = $item->sku;
	    		    		$sku2 = $item->{'sku'.$med_uom};
	    		    		
	    		    		$sku_select = $med_uom;
	    		    		$found = true;
	    		    	}

	    			} else {
		    			$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?",array($sku));
	    				$sku_select = 1;
	    				$qty_fraction = 1;
	    				$item = $obj = $query->row();
	    				$found = true;
	    			}
	    			
	    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));
	    			$sale = $query->row();
	    			
	    			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));
	    			if ($query->num_rows()){
	    				$customer = $query->row();
	    			} else {
	    				$customer = false;
	    			}
	    			
	    			if ($found){
	    			
	    				if ($sku_select == 1){
	    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `id` = ? AND `sku_select` = '1' AND `sale_id` = ?",array($id,$queue_id));
	    				} else {
	    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `item_sku2` = ? AND `sale_id` = ?",array($sku2,$queue_id));
	    				}
	    				
	    				if ($item->enter_price) $obj->enter_price = true;
	    				if ($item->enter_serial) $obj->enter_serial = true;
	    				
	    				$price_rules = json_decode($this->system->config('price_rules'));
	    				
	    				if (!$query->num_rows()){
	    					
	    					if ($this->system->config('cost_update_method') == 'fifo'){
	    						$item_cost = $this->inv->check_fifo_cost($item->id, $qty);
	    					} else {
	    						$item_cost = $item->cost * $qty;
	    					}
	    						
	    					if ($sku_select == 1){
	    						
	    						if ($customer->rank){
		    						$item_price = $item->{'price'.$price_rules->{str_replace(' ','_',$customer->rank)}};
		    					} else {
			    					$item_price = $item->price;
			    				}
	
	    						$margin = ($item_price * $qty) - $item_cost;
	    					} else {
	    						
	    						if ($customer->rank){
		    						$item_price = $item->{'price'.$sku_select.$price_rules->{str_replace(' ','_',$customer->rank)}};
		    					} else {
		    						$item_price = $item->{'price'.$sku_select};
			    				}
	
	
	    						$margin = ($item_price * $qty / $qty_fraction) - $item_cost;
	    					}
	    					
	    					$sql = $this->db->insert_string('sale_items',$med = array(
	    						'sale_id'		=> $queue_id,
	    						'item_id'		=> $item->id,
	    						'date'			=> date('Y-m-d'),
	    						'item_sku'		=> $item->sku,
	    						'item_sku2'		=> $sku2,
	    						'item_name'		=> $med_item_name,
	    						'unit'			=> $item->{'uom'.$sku_select},
	    						'qty'			=> $qty,
	    						'qty_fraction'	=> $qty_fraction,
	    						'sku_select'	=> $sku_select,
	    						'price_per_unit'=> $med_price / $qty,
	    						'cost'			=> $item_cost,
	    						'margin'		=> $margin,
	    						'terminal'		=> $this->user->terminal(),
	    						'points'		=> $item->redeem_points,
	    						'session'		=> $this->user->data('terminal_session'),
	    						'amount'		=> $med_price,
	    						'clinic_dosage'	=> $med_dosage,
	    						'warehouse_id'	=> $this->user->data('branch')
	    					));
	    					$query = $this->db->query($sql);
	
	    					
	    				} else {
	    					$existing_item = $query->row();
	    					
	    					if ($this->system->config('cost_update_method') == 'fifo'){
	    						$item_cost = $this->inv->get_fifo_cost($item->id, $qty);
	    					} else {
	    						$item_cost = $item->cost * $qty;
	    					}
	    					
	    					if ($sku_select == 1){
	    						$sql = $this->db->update_string('sale_items',array(
	    							'qty'			=> $existing_item->qty + $qty,
	    							'cost'			=> $existing_item->cost + ($item_cost),
	    							'margin'		=> $existing_item->margin + (($item->price - $item->cost) * $qty),
	    							'amount'		=> $existing_item->amount + ($item->price * $qty),
	    							'points'		=> $item->redeem_points
	    						),"`sale_id` = '$queue_id' AND `item_sku` = '{$sku}' AND `sku_select` = 1");
	    					} else {
	    						$item_price = $item->{'price'.$sku_select};
	    						$sql = $this->db->update_string('sale_items',array(
	    							'qty'			=> $existing_item->qty + $qty,
	    							'customer_id'	=> $customer->id,
	    							'cost'			=> $xcost = $existing_item->cost + ($item_cost),
	    							'amount'		=> $xamount = $existing_item->amount + ($item_price * ($qty / $qty_fraction)),
	    							'margin'		=> $xamount - $xcost,
	    							'points'		=> $item->redeem_points
	    						),"`sale_id` = '$queue_id' AND `item_sku2` = '{$sku2}'");
	    					}
	
	    					$this->db->query($sql);
	    				}
	    				
	    				$stored_meds[] = $med;
	    				
	    			} else {
	
	    			}
					
				}
			
				$this->db->update('sales', array(
					'clinic_consultation_status' => 'Completed'
				), "`id` = '{$queue_id}'");
				
				$this->db->insert('patient_history', array(
					'patient_id'			=> $patient->id,
					'sale_id'				=> $queue_id,
					'problem'				=> $this->input->post('problem'),
					'diagnosis'				=> $this->input->post('diagnosis'),
					'treatment'				=> $this->input->post('treatment'),
					'physical_examination'	=> $this->input->post('physical_examination'),
					'meds'					=> json_encode($stored_meds),
					'status'				=> 'Created',
					'added_on'				=> date('Y-m-d H:i:s'),
					'added_by'				=> $this->user->data('username'),
					'branch'				=> $this->user->data('branch')
				));
				
				echo 'ok';
				
				break;
				

			
		}
	}
	
	
	function Pos_session_data(){
    	$user = $this->user->data();
    	$session->logged_in_time = date('h:i:sA d/m/Y',strtotime($user->terminal_last_login));
    	
    	$time_duration = time() - strtotime($user->terminal_last_login);
    	$hours = floor($time_duration / (60 * 60));
    	$minutes = floor(($time_duration / 60) - ($hours * 60));
    	if ($hours){
    		$session->logged_in_duration = $hours . ' Hour(s) ' . $minutes . ' Minute(s)';
    	} else {
    		$session->logged_in_duration = $minutes . ' Minute(s)';
    	}
    	$session->time = date('h:iA');
    	$session->logged_in_as = $user->username;
    	
    	echo json_encode($session);
    }
    
    function Logout(){
	    $this->user->logout();
	    redirect('clinic');
	}
	    		
	function Show_queue(){	
		$this->load->view('clinic/queue');
	}
	
		
	function Check_queue(){

	
		$this->db->select('sales.queue_no as queue_no,sales.consultant_id as consultant_id,sales.id as sid, users.firstname as consultant_name');
		$this->db->from('sales');
		$this->db->join('users', 'sales.consultant_id= users.id');
		$this->db->where('sales.is_consulted',"1");
		$this->db->where('sales.clinic_consultation_status',NULL);
		$this->db->group_by("sales.consultant_id"); 
		$this->db->like('sales.added_on',date('Y-m-d'));
		$query = $this->db->get();
		$item = $query->result();	
		echo json_encode($item);		
				
		
	
	}
		
	
}