<?php

class Iphone extends Controller {
	
	// Constructor
	function Iphone(){
		parent::Controller();
		
		$this->start = microtime();
		
		//echo 'Delta Time: ' . ((microtime() - $this->start) / 1000) . "\n";

		// Load employee, system and order models
		$this->load->model('user');
		$this->load->model('system');
		$this->load->model('order');
		

		
		$this->load->helper('file');
		
		$this->load->library('user_agent');
		
		if ($agent = $this->agent->is_mobile()){
			if (strpos($_SERVER['HTTP_USER_AGENT'],'iPad')){
				$this->session->set_userdata(array('device'=>'ipad'));
				redirect('fnbpos');
			}
			
			if (strpos($_SERVER['HTTP_USER_AGENT'],'iPod') || strpos($_SERVER['HTTP_USER_AGENT'],'iPhone')) {
				$this->session->set_userdata(array('device'=>'iphone'));
			}
			// Redirect to iphone controller

		} else {
			$this->session->set_userdata(array('device'=>'terminal'));
			redirect('fnbpos');
		}
		
		if ($this->uri->segment(1) == 'iphone' && $this->uri->segment(2) == 'terminal'){
    		// do nothing	
    			
    	} else {
    		$ip = $_SERVER['REMOTE_ADDR'];
    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));

    		if (!$query->num_rows()){

    			if ($terminal_id = get_cookie('PLEX_POS_TERM_ID',true)){
    				$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));
    				$terminal = $query->row();
    				
    				if (md5($terminal->key . get_cookie('PLEX_POS_TERM_SESSION',true)) != get_cookie('PLEX_POS_TERM_HASH',true)){
    					show_error('Access denied for terminal identifier <strong>' . get_cookie('PLEX_POS_TERM_IDENTIFIER',true) . '</strong>. Check if your terminal identifier and key is correct.');
    				}
    				
    			} else {
    				show_error('Access denied for IP Address <strong>' . $_SERVER['REMOTE_ADDR'] . '</strong>. Check if your terminal is using Dynamic IP access.');
    			}
    		}
    	}

		header("Cache-Control: no-cache, must-revalidate");
	}
	
	function Terminal($identifier, $key){
    	$query = $this->db->query("SELECT * FROM `terminals` WHERE `identifier` = ? AND `key` = ?", array($identifier, $key));

    	if ($query->num_rows()){
    		$terminal = $query->row();
    		$term_session = time();
    		$expire = 60*60*24*6004; 

    		
    		set_cookie('PLEX_POS_TERM_ID',$terminal->id, $expire, $_SERVER['HTTP_HOST'], '/');
    		set_cookie('PLEX_POS_TERM_NAME', $terminal->name, $expire, $_SERVER['HTTP_HOST'], '/');
    		set_cookie('PLEX_POS_TERM_IDENTIFIER', $identifier, $expire, $_SERVER['HTTP_HOST'], '/');
    		set_cookie('PLEX_POS_TERM_HASH', md5($key . $term_session), $expire, $_SERVER['HTTP_HOST'], '/');
    		set_cookie('PLEX_POS_TERM_SESSION', $term_session, $expire, $_SERVER['HTTP_HOST'], '/');
    		
    		
    		redirect('iphone');
    	} else {			
    		show_error('Access denied for terminal identifier <strong>' . $identifier . '</strong>. Check if your terminal identifier and key is correct.');
    	}
    }
	
	// Index controller
	function Index(){
	
		// Check employee login session. If not logged in, redirect to login page
		if (!$this->user->check_session('iphone')) redirect('iphone/login');
		
		// Retrieve categories from inventory
		$query = $this->db->query("SELECT `category` FROM `fnb_inventory` WHERE `iphone` = 1 GROUP BY `category`");
		$cat = $query->result();
		
		// Loop for each category to store item and subcategory data
		foreach ($cat as $category){
			// Retrieve items by category
			$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `category` = ? AND `iphone` = 1 ORDER BY `order` ASC", array($category->category));
			$items = $query->result();
			
			$subcategories = null;
			
			// Store items into category object
			$category->items = $items;
	
			// Loop for each items to store in subcategory		
			foreach ($items as $item){
				$subcategories[$item->subcategory][] = $item;
			}
			
			// Store subcategories into category object
			$category->subcategories = $subcategories;
			
			// Store category into array
			$categories[] = $category;
		}
		
		// Store categories to interface variables
		$this->d['categories'] = $categories;
		
		$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `iphone` = 1 GROUP BY `category` ORDER BY `category_order` ASC ");
		$this->d['cd'] = $query->result();
		
		// Load iphone ordering interface
		$this->load->view('fnb/iphone',$this->d);
	}
	
	function Login($err){
	


		// Check employee login session. If logged in redirect to pos interface
		if ($this->user->check_session('iphone')) redirect('iphone');
		
		// If contains error, set error notice to interface variables
		if ($err == 'err1') $this->d['notice'] = 'Incorrect username or password.';
		if ($err == 'err2') $this->d['notice'] = 'User is already logged in.';
		
		// Load login interface
		$this->load->view('fnb/iphone-login',$this->d);
	}
	
	// Authentication controller
	
	function Auth(){
		
		// Retrieve input username and password
		$username = $this->input->post('username');
		$password = $this->input->post('password');
		
		// Get employee object
		$user = $this->user->get_user_by_username($username);
		
		if ($user->active){
			redirect('iphone/login/err2');	
		}
		
		// Check if employee is logged in. If logged in redirect to login interface with 'err2'
		if ($user->ip_address != '') redirect('iphone/login/err2');
		
		// Log in user. If succeed, redirect to pos interface. Otherwise redirect to login interface with 'err1'
		if ($this->user->login('iphone', $username, $password)) redirect('iphone');
		else redirect('iphone/login/err1');
	}
	
	// AJAX Controller for iPhone
	function Ajax($request){
		switch ($request){
			
			// Request to transfer table
			case "transfer_table":
				// Get table no
				$queue_id = $this->input->post('queue');
				$table_no = $this->input->post('table_no');
				$merge = $this->input->post('merge');
				
				$this->order->transfer_table($queue_id, $table_no, $merge);
				break;
				
			case "verify_order":
				$id = $this->input->post('id');
				
				$this->db->update('fnb_buffer_sales', array(
					'verified'	  => 1
				), "`id` = '{$id}'");
				
				$this->order->process_orders($id);

				$this->db->query("UPDATE `fnb_buffer_sale_items` SET `printed` = 1 WHERE `sale_id` = ?", array($id));
				
				$data->status = 'ok';
				
				echo json_encode($data);
				
				break;
				
			case "cancel_order":
				$id = $this->input->post('id');
				
				$this->db->query("DELETE FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? AND `printed` = 0", array($id));
				
				$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?", array($id));
				
				if (!$query->num_rows()){
				
					$this->db->query("DELETE FROM `fnb_buffer_sales` WHERE `id` = ?", array($id));
					
					$data->status = 'ok';
				
				} else {
					$this->db->query("UPDATE `fnb_buffer_sales` SET `verified` = 1 WHERE `id` = ?", array($id));
					
					$data->status = 'ok-noclear';
				}

				echo json_encode($data);
							
				break;
				
			case "create_table":
				$table_no = $this->input->post('table_no');
				$pax_no = $this->input->post('pax');
				$card_no = $this->input->post('card_no');
				// Create table number
				$this->order->create_table($table_no, $pax_no, $card_no);
				break;
		
			case "get_item_list":
				// Call item list
				$queue_id = $this->input->post('queue');
				$this->order->get_item_list($queue_id);
				
				break;
			
			case "active_tables":
				// Call active tables from order model
				$this->order->active_tables();
				
				break;
			case "check_table":
				$table_no = $this->input->post('table_no');
				
				$this->order->check_table($table_no);
				
				break;
			case "submit_order":
				// Submit order from order model
				$this->order->submit_order();
				
				break;
		
		}
	
	}
	
	function Logout(){
		$this->user->logout();
		redirect('iphone');
	}
	
	function Sync($request){
    	
    	
    	switch ($request){
    	
    		case "upsync_txn":
    			$sale = $this->input->post('sale');
    			$sale_items = $this->input->post('sale_items');
    			
    			
    			break;
    			
			
    		
    		case "users":
    			$query = $this->db->query("SELECT * FROM `permissions` WHERE `action` LIKE '%to_use_pos%'");

    			foreach ($query->result() as $perm){
	    			$query = $this->db->query("SELECT * FROM `users` WHERE `type` = ?", array($perm->user_type));
	    			foreach ($query->result() as $user){
	    				$users[] = $user;
	    			}
	    			
    			}
    			
    			$res->user_data = $users;
    			$res->status = 'ok';

    			echo json_encode($res);
    			
    			break;
    	
    		case "request_inventory":
    			$buffer = $this->input->post('buffer') ? $this->input->post('buffer') : 50;
    			$i = $this->input->post('position') ? $this->input->post('position') : 0;
    		
    			$offset = $buffer * $i;
    			
    			$query = $this->db->query("SELECT * FROM `fnb_inventory` ORDER BY `id` LIMIT $offset, $buffer");
    			
    			$res->results = $query->result();
    			$res->status = 'ok';

    			
    			if ($query->num_rows() != $buffer) $res->complete = true;
    			else $res->complete = false;
    			
    			echo json_encode($res);
    			break;			
    		case "session_sales_data":
    			$session = $this->user->data('terminal_session');
    		
    			$query = $this->db->query("SELECT * FROM `sales` WHERE `session` = ?", array($session));
    			$res->sales_data = $query->result();
    			
    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `session` = ?", array($session));
    			$res->sale_items_data = $query->result();
    			
    			$res->status = 'ok';
    			
    			echo json_encode($res);
    			
    			break;
    			
    		case "upstream_sync_sales":
    			
    			$sales_data = json_decode($this->input->post('sales'));
    			$sale_items_data = json_decode($this->input->post('sale_items'));
    			
    			
    			foreach ($sales_data as $sale){

    				$sale->pseudo_id = $sale->id;
    				unset($sale->id);
    				
    				$sale->sync = true;
    				$sale->sync_time = time();
    				
    				$query = $this->db->insert('sales', $sale);
    				$id = $query->insert_id;
    				
    				$client_pseudo_id[$sale->pseudo_id] = $id;
    				
    				$resync->id 		= $id;
    				$resync->pseudo_id 	= $sale->pseudo_id;
    				$resync->time		= time();
    				
    				$resyncs[] = $resync;
    			}
    			
    			foreach ($sale_items_data as $sale_item){
    				$sku = $sale_item->item_sku2 ? $sale_item->item_sku2 : $sale_item->item_sku;
    				$qty = $sale_item->qty;
    				$entered_amount  = $sale_item->amount;
    				$this->add_item($client_pseudo_id[$sale_item->sale_id], $sku, $qty, $entered_amount);
    				/*
    				unset($sale_item->id);
    				$sale_item->sale_id = $client_pseudo_id[$sale_item->sale_id];
    				$sale_item->sold = NULL;
    				$sale_item->sync = true;
    				$sale_item->sync_time = time();
    				
    				$this->db->insert('sale_items', $sale_item);
    				*/
    			}
    							
    			echo json_encode($resyncs);
    			
    			break;

    	}
    
    }

}