<?php

class Terminal extends Controller {

	function Terminal(){
	
		parent::Controller();
		
		$this->load->library('user_agent');
		$this->load->model('user');
		$this->load->model('system');
		
		if (!$this->config->config['client_side']){

			$ip = $_SERVER['REMOTE_ADDR'];
    		if ($ip == '::1') $ip = '127.0.0.1';
		   	$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));
		    			
		   	if (!$query->num_rows()){
		
		    	if ($terminal_id = get_cookie('PLEX_POS_TERM_ID',true)){
		    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));
		    		$terminal = $query->row();
		    				
		    		if (md5($terminal->key . get_cookie('PLEX_POS_TERM_SESSION',true)) != get_cookie('PLEX_POS_TERM_HASH',true)){
		    			show_error('Access denied for terminal identifier <strong>' . get_cookie('PLEX_POS_TERM_IDENTIFIER',true) . '</strong>. Check if your terminal identifier and key is correct.');
		    		}
		    				
		    	} else {
		   			show_error('Access denied for IP Address <strong>' . $ip . '</strong>. Check if your terminal is using Dynamic IP access.');
				}
	  		}
  		} else {
			$this->client_side = true;
			
	  		$res = fopen('AUTHKEY','r');
	  		$key = fread($res,filesize('AUTHKEY'));
	  		fclose($res);
	  		
	  		$res = fopen('CONN','r');
	  		$conn = fread($res,filesize('CONN'));
	  		fclose($res);
	  		
	  		
	  		if ($this->uri->segment(2) != 'activate' && $this->uri->segment(2) != 'authorize' && $this->uri->segment(2) != 'error'){
		  		if (!$key){
			  		redirect('terminal/activate');
		  		}
	  		}
  		}

	}
	
	function Index(){
		$this->load->view('terminal_select');
	}
	
	function Activate(){
		$this->load->view('client_authorize');				
	}
	
	function Error(){
		$data['msg'] = "Incorrect Access Information";
		$this->load->view('client_authorize', $data);
	}
	
	function Register($identifier, $key){
    	$query = $this->db->query("SELECT * FROM `terminals` WHERE `identifier` = ? AND `key` = ?", array($identifier, $key));

    	if ($query->num_rows()){
    		$terminal = $query->row();
    		$term_session = time();
    		$expire = 60*60*24*6004; 

    		
    		set_cookie('PLEX_POS_TERM_ID',$terminal->id, $expire, $_SERVER['HTTP_HOST'], '/');
    		set_cookie('PLEX_POS_TERM_NAME', $terminal->name, $expire, $_SERVER['HTTP_HOST'], '/');
    		set_cookie('PLEX_POS_TERM_IDENTIFIER', $identifier, $expire, $_SERVER['HTTP_HOST'], '/');
    		set_cookie('PLEX_POS_TERM_HASH', md5($key . $term_session), $expire, $_SERVER['HTTP_HOST'], '/');
    		set_cookie('PLEX_POS_TERM_SESSION', $term_session, $expire, $_SERVER['HTTP_HOST'], '/');
    		
    		
    		show_error('Access has been granted. <a href="'.base_url().'">Go to terminal page.</a>');
    	} else {			
    		show_error('Access denied for terminal identifier <strong>' . $identifier . '</strong>. Check if your terminal identifier and key is correct.');
    	}
    }
    
    function Authorize(){
	    $host 			= $this->input->post('host');
	    $terminal_name 	= $this->input->post('terminal_name');
	    $access_key		= $this->input->post('access_key');
	    
	    $postdata = http_build_query(
		    array(
		        'terminal_name' => $terminal_name,
		        'access_key'	=> $access_key
		    )
		);
		
		$opts = array('http' =>
		    array(
		        'method'  => 'POST',
		        'header'  => 'Content-type: application/x-www-form-urlencoded',
		        'content' => $postdata
		    )
		);
		
		$context  = stream_context_create($opts);
		
		$result = file_get_contents('http://'.$host.'/os/authorize/terminal', false, $context);
		
		if ($result != '0'){
			$res = fopen('CONN','w+');
			fwrite($res, $host . '|' . $terminal_name . '|' . $access_key);
			fclose($res);
		
			$res = fopen('AUTHKEY','w+');
			fwrite($res, $result);
			fclose($res);
			redirect('setup');
		} else {
			redirect('terminal/error');
		}
		
		echo $result;
		
    }
	
	
	function Reset(){
		unlink('AUTHKEY');
		unlink('CONN');
		unlink('INSTALLED');
		
		redirect('terminal');
	}
	
	
}