<?php

class Contact extends Model {

	function Get_total_credit($contact_id){
		$query = $this->db->query("SELECT SUM(`amount_credit`) AS `total_credit` FROM `sales` WHERE `customer_id` = ? GROUP BY `customer_id`", array($contact_id));
		$credit = $query->row();
		
		$query = $this->db->query("SELECT SUM(`amount`) AS `total_settlement` FROM `settlements` WHERE `customer_id` = ? GROUP BY `customer_id`", array($contact_id));
		$settlement = $query->row();
		
		return $settlement->total_settlement - $credit->total_credit;
	}
	
	function Get_credit_limit($contact_id){
		$contact = $this->Get_contact_by_id($contact_id);
		echo $contact->credit_limit;
	}
	
	function Get_credit_balance($contact_id){
		$contact = $this->Get_contact_by_id($contact_id);
		
		$query = $this->db->query("SELECT SUM(`total`-`paid_amount`) AS `total_credit` FROM `invoices` WHERE `contact_id` = ? ", array($contact_id));
		$credit = $query->row();		
		
		return $settlement->total_settlement + $contact->credit_limit - $credit->total_credit;
	
	}
	
	function Get_points_by_contact($id){
		$query = $this->db->query("SELECT SUM(FLOOR(`amount`)) AS `total_amount` FROM `sales` WHERE `customer_id` = ? AND `payment_status` <> 'Redeem' AND `type` = 'history'", array($id));
	    $point_sales = $query->row();
	    
	    $query = $this->db->query("SELECT SUM(FLOOR(`total_delivered`)) AS `total_amount` FROM `invoices` WHERE `contact_id` = ? AND `payment_status` = 'Paid'", array($id));
	    $point_invoices = $query->row();
	    
	    $total = $point_sales->total_amount + $point_invoices->total_amount;
	    
	    $amount = $this->system->config('member_minimum_amount');
	    $ppa = $this->system->config('member_minimum_point');
	    
	    $query = $this->db->query("SELECT SUM(`points`) AS `total_points` FROM `sale_items` WHERE `redeemed` = 1 AND `member_id` = ?", array($id));
	    $points_redeemed = $query->row();

	    return (floor($total / $amount) * $ppa) - $points_redeemed->total_points;
	}


	function Get_contacts($where){
		if ($where){
			$sql = "SELECT * FROM `contacts` $where";
		} else {
			$sql = "SELECT * FROM `contacts` ORDER BY `id` ASC";
		}
		
		$query = $this->db->query($sql);
		return $query->result();
	}
	
	function Get_contact_by_id($id){
		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($id));
		return $query->row();
	}

	function Get_contact_by_ic($ic){
		$query = $this->db->query("SELECT * FROM `contacts` WHERE `ic` = ?", array($ic));
		return $query->row();
	}

}