<?php

class Inv extends Model {

	function Inv(){
		parent::Model();
		
	}

	function Get_items($filter){
		$warehouse_id = $this->user->data('branch');
		
		$query = $this->db->query("SELECT `item_id`, `cost`, `qty` FROM `inventory_stock_quantities` WHERE `warehouse_id` = ?", array($warehouse_id));
		$stocks = $query->result();
					
		foreach ($stocks as $stock){
			$item_stock[$stock->item_id] = $stock->qty;
			$item_cost[$stock->item_id] = $stock->cost;
		}

		$query = $this->db->query("SELECT * FROM `inventory` $filter");
		foreach ($query->result() as $item){
			$item->qty = $item_stock[$item->id];
			$item->cost = $item_cost[$item->id];
			$items[] = $item;
		}
		return $items;
	}
		
	function Get_sale_count_by_date($item_id, $date){
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_qty` FROM `sale_items` WHERE `item_id` = ? AND `date` <= ? GROUP BY `item_id", array($item_id, $date));
		$row = $query->row();
		return $row->total_qty;
	}
	
		
	function Get_categories($dropdown = false){
		$query = $this->db->query("SELECT `category` FROM `inventory` GROUP BY `category` ORDER BY `category` ASC");
		if ($dropdown) $categories[] = "Select Category";
		foreach ($query->result() as $cat){
			$categories[$cat->category] = $cat->category;
		}
		return $categories;
	}
	
	function Get_subcategories($dropdown = false){
		$query = $this->db->query("SELECT `subcategory` FROM `inventory` GROUP BY `subcategory` ORDER BY `category` ASC");
		if ($dropdown) $categories[] = "Select Subcategory";
		foreach ($query->result() as $cat){
			$categories[$cat->subcategory] = $cat->subcategory;
		}
		return $categories;
	}
	
	function Get_item_by_id($id){
		$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($id));
		$item = $query->row();
		
		$query = $this->db->query("SELECT `item_id`, `cost`, `qty` FROM `inventory_stock_quantities` WHERE `warehouse_id` = ? AND `item_id` = ?", array($this->user->data('branch'), $id));
		$stock = $query->row();

		$item->qty = $stock->qty;
		$item->cost = $stock->cost;
		return $item;
	
	}
	
	function Get_item_by_sku($sku){
		$warehouse_id = $this->user->data('branch');
	
		if (!$this->system->config('warehouse_shared_inventory')){
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ? AND `warehouse_id` = ?", array($sku, $this->user->data('branch')));
		} else {
			$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?", array($sku));			
		}
		
		$item = $query->row();
		
		$query = $this->db->query("SELECT `item_id`, `cost`, `qty` FROM `inventory_stock_quantities` WHERE `warehouse_id` = ? AND `item_id` = ?", array($warehouse_id, $item->id));
		$stocks = $query->row();
					
		$item->qty = $stocks->qty;
		$item->cost = $stocks->cost;
		
		return $item;

	}
	
	
	function Get_items_by_category($category){
		$query = $this->db->query("SELECT * FROM `inventory` WHERE `category` = ?",array($category));
		return $query->result();
	}
	
	
	
	function Items_by_category(){
		$query = $this->db->query("SELECT COUNT(`category`) as `frequency`, `category` FROM `inventory` GROUP BY `category`");
		foreach($query->result() as $product){
			$data[$product->category] = $product->frequency;
		}
		return $data;
	}
	

	function Update_item_qty($item_id, $warehouse_id){
		if (!$warehouse_id) $warehouse_id = $this->user->data('branch');
    	
    	$query = $this->db->query("SELECT `id` FROM `inventory_stock_quantities` WHERE `item_id` = ? AND `warehouse_id` = ?", array($item_id, $warehouse_id));
    	if ($query->num_rows()){
    	    $isq = $query->row();
    	    
			$qty = $this->get_item_quantity($item_id, $warehouse_id);
    	    
    	    $this->db->update('inventory_stock_quantities', array(
    	    	'qty' 		=> $qty,
    	    	'last_sold'	=> date('Y-m-d H:i:s')
    	    ), "`id` = '{$isq->id}'");
    	} else {
			$item = $this->get_item_by_id($item_id);
			
			$qty = $this->get_item_quantity($item_id, $warehouse_id);
    	    
    	    $this->db->insert('inventory_stock_quantities', array(
    	    	'item_id'		=> $item->id,
    	    	'item_name'		=> $item->name,
    	    	'item_sku'		=> $item->sku,
    	    	'warehouse_id'	=> $warehouse_id,
    	    	'alert_quantity'=> $item->alert_quantity,
    	    	'qty'			=> $qty,
    	    	'last_sold'		=> date('Y-m-d H:i:s')
		    ));
		}			

	}
	
	function Check_fifo_cost($item_id, $warehouse_id){
	
		if (!$warehouse_id) $warehouse_id = $this->user->data('branch');

		$item = $this->get_item_by_id($item_id);

    	$fifo_cost = $item->cost; // defaulting
    	$fifo_qty = 0;
    	
    	$outbound = $this->get_outbound_quantity($item_id);
    	
    	$cont = true;
		
		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? AND `warehouse_id` = ? ORDER BY `date` ASC", array($item_id, $warehouse_id));	
    	
    	foreach ($query->result() as $fifo){
    		$fifo_qty += $fifo->received;
    		if ($fifo_qty < $outbound){
				// do nothing
    		} else {
    			if ($cont){
					$cost = $fifo->price_per_unit;
					$cont = false;
				}
			}
    	}
    	
		
		if (!$cost) $cost = $item->cost * 1;
    	
		$this->db->query("UPDATE `inventory_stock_quantities` SET `cost` = ? WHERE `item_id` = ? AND `warehouse_id` = ?", array($cost, $item_id, $warehouse_id));
		
    	return $cost;
	}
	
	function Update_item_cost($item_id, $warehouse_id){
	    
	    if (!$warehouse_id) $warehouse_id = $this->user->data('branch');
	    
	    $method = $this->system->config('cost_update_method');
	    
	    if ($method == 'average') return;
	    
		$query = $this->db->query("SELECT `date`, `received` AS `qty`, 'in' AS `type`, `received_price` AS `amount` FROM `purchase_order_items` WHERE `item_id` = ? AND `received` > 0 AND `warehouse_id` = ? UNION
							SELECT `date`, `qty`, 'out' AS `type`,`cost` AS `amount` FROM `sale_items` WHERE `item_id` = ? AND `sold` = '1' AND `warehouse_id` = ? UNION
							SELECT `date`, `qty`, 'out' AS `type`,`cost` AS `amount` FROM `fnb_sale_items` WHERE `si_item_id` = ? AND `sold` = '1' AND `warehouse_id` = ? UNION
							SELECT `date`, `qty`, 'out' AS `type`,`cost` AS `amount` FROM `fnb_buffer_sale_items` WHERE `si_item_id` = ? AND `sold` = '1' AND `warehouse_id` = ? UNION
							SELECT `date`, `delivered` AS `qty`, 'out' AS `type`, `cost` AS `amount` FROM `invoice_items` WHERE `item_id` = ? AND `delivered` > 0 AND `warehouse_id` = ? UNION
							SELECT `date`, `received` AS `qty`, 'out' AS `type`, `received_price` AS `amount` FROM `debit_note_items` WHERE `item_id` = ? AND `received` > 0 AND `warehouse_id` = ?
							ORDER BY `date` ASC", array($item_id, $warehouse_id, $item_id, $warehouse_id, $item_id, $warehouse_id, $item_id, $warehouse_id, $item_id, $warehouse_id, $item_id, $warehouse_id));
			
		foreach ($query->result() as $inout){
	    	if ($inout->type == 'in'){
	    		$cur_quantity += $inout->qty;
	    		$in_cost = $inout->amount;
	    		$value += $in_cost;
	    	} else {
	    		$cur_quantity -= $inout->qty;
	    		$out_cost = $inout->amount;
	    		$value -= $out_cost;
	    	}
	    }
	    
	    if ($method == 'fifo'){
    		$this->check_fifo_cost($item_id, 1, $this->user->data('branch'));
    	} elseif ($method == 'lifo'){
    		// get from last purchase order
    		$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? ORDER BY `date` DESC", array($item_id));
    		$po_item = $query->row();
    		
    		$this->db->query("UPDATE `inventory` SET `cost` = ? WHERE `id` = ?", array($po_item->price_per_unit, $item_id));    		
    	}
	}
	
	function Update_item_average_cost($item_id, $qty, $cost){
		$item = $this->get_item_by_id($item_id);
		$cost = (($qty * $cost) + ($item->qty * $item->cost)) / ($item->qty + $qty);
		$this->db->update('inventory', array(
			'cost'			=> $cost,
			'average_cost'	=> $cost
		),"`id` = '{$item->id}'");
		
	}
		
	function Get_item_quantity($item_id, $warehouse){
	
		if (!$warehouse) $warehouse = $this->user->data('branch');
		
		if ($warehouse == '*' || $warehouse == ''){
		
			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));
			$inbound = $query->row();
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));
			$returned = $query->row();
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));
			$c_returned = $query->row();
			
			$query = $this->db->query("SELECT SUM(`delivered`) AS `total_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `no_do` IS NULL GROUP BY `item_id`", array($item_id));
			$invoiced = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `sold` = 1  GROUP BY `item_id`", array($item_id));
			$outbound = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `fnb_sale_items` WHERE `si_item_id` = ? AND `sold` = 1  GROUP BY `si_item_id`", array($item_id));
			$fnb_outbound = $query->row();

			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `fnb_buffer_sale_items` WHERE `si_item_id` = ? AND `sold` = 1  GROUP BY `si_item_id`", array($item_id));
			$fnb_buffer_outbound = $query->row();


		} else {
		
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_inbound` FROM `warehouse_movement_items` WHERE `item_id` = ? AND `to_warehouse` = ? GROUP BY `item_id`", array($item_id, $warehouse));
			$inbound_movement = $query->row();
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));
			$inbound_po = $query->row();			
			
			$inbound->total_inbound = $inbound_movement->total_inbound + $inbound_po->total_inbound;
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));
			$returned = $query->row();
			
			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));
			$c_returned = $query->row();
			
			$query = $this->db->query("SELECT SUM(`delivered`) AS `total_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `warehouse_id` = ? AND `no_do` IS NULL GROUP BY `item_id`", array($item_id, $warehouse));
			$invoiced = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `warehouse_id` = ? AND `sold` = 1  GROUP BY `item_id`", array($item_id, $warehouse));
			$outbound = $query->row();
			
			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `fnb_sale_items` WHERE `si_item_id` = ? AND `warehouse_id` = ? AND `sold` = 1  GROUP BY `si_item_id`", array($item_id, $warehouse));
			$fnb_outbound = $query->row();

			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `fnb_buffer_sale_items` WHERE `si_item_id` = ? AND `warehouse_id` = ? AND `sold` = 1  GROUP BY `si_item_id`", array($item_id, $warehouse));
			$fnb_buffer_outbound = $query->row();

		}
		

		$qty = $inbound->total_inbound - $outbound->total_outbound - $invoiced->total_outbound - $returned->total_outbound + $c_returned->total_inbound - $fnb_buffer_outbound->total_outbound - $fnb_outbound->total_outbound;
		
		
		return $qty;
	}
	
	function Get_outbound_quantity($item_id){
		$query = $this->db->query("SELECT `id`, SUM(`delivered`) AS `total_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `no_do` != 1", array($item_id));
		$invoiced = $query->row();
		
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `sold` = 1", array($item_id));
		$outbound = $query->row();
		
		$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ?", array($item_id));
		$returned = $query->row();

		return $outbound->total_outbound + $invoiced->total_outbound + $returned->total_outbound;	
	}
	
	function Get_inbound_quantity($item_id){
		$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ? AND `purchase_order_id` <> 0", array($item_id));
		$inbound = $query->row();

		$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? AND `credit_note_id` <> 0", array($item_id));
		$returned = $query->row();

		return $inbound->total_inbound + $returned->total_inbound;	
	}
	
	function Get_isq_cost($item_id, $warehouse_id){
		if (!$warehouse_id) $warehouse_id = $this->user->data('branch');	
		
		$query = $this->db->query("SELECT * FROM `inventory_stock_quantities` WHERE `item_id` = ? AND `warehouse_id` = ?", array($item_id, $warehouse_id));
		$item = $query->row();
		
		return $item->cost;
	}

	function Get_fifo_cost($item_id, $qty, $warehouse_id){
	
		if (!$warehouse_id) $warehouse_id = $this->user->data('branch');

		if ($warehouse_id){
			$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? AND `warehouse_id` = ? ORDER BY `date` ASC", array($item_id, $warehouse_id));
		} else {
			$query = $this->db->query("SELECT * FROM `purchase_order_items` WHERE `item_id` = ? ORDER BY `date` ASC", array($item_id));				
		}

		
		$item = $this->get_item_by_id($item_id);

    	$fifo_cost = $item->cost; // defaulting
    	$fifo_qty = 0;
    	
    	$outbound = $this->get_outbound_quantity($item_id);
    	
    	$cont = true;
    	
    	$iqty = $qty;
    	
    	if (!$query->num_rows()) return $item->cost * $qty;

    	foreach ($query->result() as $fifo){
    		$fifo_qty += $fifo->received;
    		if ($fifo_qty >= $outbound && $cont){	
				if ($fifo_qty >= $outbound + $iqty){
					$cost += $qty * $fifo->price_per_unit;
	    			$cont = false;
				} else {

					$bal = $outbound + $iqty - $fifo_qty;
					$cost += ($qty - $bal) * $fifo->price_per_unit;
					$qty = $bal;
				}

    		}
    	}
    	

    	
    	return $cost;
	}


}