<?php

class Order extends Model {

	function Order(){
		// Retrieve print queue number from session
		parent::Model();
		$this->qn = $this->session->userdata('qn');
		$this->load->model('tax');
		$this->load->model('inv');

	}
	
	function Check_total_discounts($customer_id){
		$from = date('Y-m-1 00:00:00');
		$to = date('Y-m-t 23:59:59');
		
		$query = $this->db->query("SELECT SUM(`amount_discount`) AS `discount` FROM `fnb_buffer_sales` WHERE `customer_id` = ? AND `datetime` >= ? AND `datetime` <= ?", array($customer_id, $from, $to));
		$buffer_sales = $query->row();

		$query = $this->db->query("SELECT SUM(`amount_discount`) AS `discount` FROM `fnb_sales` WHERE `customer_id` = ? AND `datetime` >= ? AND `datetime` <= ?", array($customer_id, $from, $to));
		$sales = $query->row();
		
		
		return $buffer_sales->discount + $sales->discount;		
		
	}
	
	function Check_exceed_discount_limit($customer_id){
		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($customer_id));
		$customer = $query->row();
		if ($customer->discount_limit){
			if ($this->Check_total_discounts($customer_id) >= $customer->discount_limit) return true;
			return false;
		}
		return false;
		
	}
	
	function Toggle_takeaway($id){
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `id` = ?", array($id));
		$item = $query->row();
		
		if ($item->instant_sale){
			$this->db->query("UPDATE `fnb_buffer_sale_items` SET `instant_sale` = NULL WHERE `id` = ?", array($id));
		} else {
			$this->db->query("UPDATE `fnb_buffer_sale_items` SET `instant_sale` = 1 WHERE `id` = ?", array($id));			
		}
		
		$this->update_amount($$item->sale_id);
		
	}
	
	function Reprint_order($id){
		
		$cli = $this->system->config('fnbpos_print_cli');
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `id` = ?", array($id));
		$items[] = $query->row();
		
		/*
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `serial` = ?", array($item->serial));
		$items = $query->result();
		*/

		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($item->sale_id));
		$order = $query->row();
		
		
		foreach ($items as $item){
		
			$query = $this->db->query("SELECT * FROM `fnb_printer_map` WHERE FIND_IN_SET(?,`categories`)", array($item->category));
			$printers_data = $query->result();
			
			$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `id` = ?", array($item->item_id));
			$fb_item = $query->row();
			
			if ($this->system->config('fnb_print_items_individually')){
				$individual_items = true;	
			}
			
			foreach ($printers_data as $printer_data){			
				
				$i++;
				if ($individual_items){
					$snum = '#' . $i;
				}
				
				if (strpos($fb_item->printer, ',')){
					
					
					foreach (explode(',',$fb_item->printer) as $printer){
						if ($printer_data->waiter_copy){
							$copy_printer_item[$printer.$snum][] = $item;
						} else {
							$printer_item[$printer.$snum][] = $item;							
						}
					} 
					
				} else {
					
					if ($fb_item->printer){
						$printer_item[$fb_item->printer.$snum][] = $item;
					} else {
						if ($printer_data->waiter_copy){
							if ($printer_data->printer_ip) $copy_printer_item[$printer_data->printer_ip.$snum][] = $item;	
						} else {
							if ($printer_data->printer_ip) $printer_item[$printer_data->printer_ip.$snum][] = $item;
						}
						
						
					}
				}
			
			
			}
			
			
	
		}

		
		$order_data = null;
		
		
		$this->load->helper('dompdf');
		
		// Loop for each printer item by category
		foreach ($printer_item as $printer => $items){
			// Query printer map data by categores
				
			// Get computer name
			if ($individual_items){
				list($printer, $snum) = explode('#', $printer);
			}
			
			// Prepare printing content
			$content = date('H:i:s d/m/Y') . "\nTable no #" . $table_no . " - " . $employee->username  .  "\n";
			
			$order_data = null;
			$order_data_items = null;
			
			$order_data['table_no'] = $order->table_no;
			$order_data['employee'] = $item->ordered_by;
			$order_data['datetime'] = $item->ordered_time;
			
			// Loop for each items
			foreach ($items as $item){
				$order_data_item = null;
				
				// Add to content
				$content .= $item->qty . ' x ' . $item->item_name;
				if ($item->item_option) $content .= " - " . str_replace('_', ' ',$item->item_option) . ($item->instant_sale ? ' (Takeaway)' : '');
				$content .= "\n";
				
				$order_data_item->qty = $item->qty;
				$order_data_item->category = $item->category;
				$order_data_item->name = $item->item_name;
				if ($item->item_option) $order_data_item->option = str_replace('_', ' ',$item->item_option). ($item->instant_sale ? ' (Takeaway)' : '');
				
				$order_data_items[] = $order_data_item;
			}
			
			$order_data['items'] = $order_data_items;

			// Increment queue number
			$this->qn++;
				
			// Reset queue number if greater than 50
			if ($this->qn > 50){
				$this->qn = 0;
			}
			
			// Set the current queue number to session
			$this->session->set_userdata(array('qn'=>$this->qn));
			
			$ok = true;
			$order_data['reprint'] = true;
			$order_data['pax_no'] = $order->no_of_pax;
			
			if ($table_no == 'IS'){
				if ($this->system->config('print_is')){
					$ok = true;
				} else {
					$ok = false;
				}
			}
			

			if ($ok){
				// Write the file
				$content = $this->load->view('fnb/orderchit',$order_data,true);

					
				if ($cli[0] == '>' || $printer[0] == '>'){
					
					if ($printer){
						if ($printer[0] == '>'){
							list($cli, $printer) = explode('|', $printer);
						}
						
						$url = str_replace('>', '', $cli);
						
						
						$postdata = http_build_query(
						    array(
						        'content' 	=> str_replace('<body>',"<body>Kitchen's Copy",$content),
						        'printer'	=> $printer,
						        'paper_size'=> $paper_size,
						        'qn'		=> $this->qn
						    )
						);
						
						$opts = array('http' =>
						    array(
						        'method'  => 'POST',
						        'header'  => 'Content-type: application/x-www-form-urlencoded',
						        'content' => $postdata
						    )
						);
						
						$context  = stream_context_create($opts);
						

						$result = file_get_contents($url, false, $context);
						
						
						if ($prt = $this->system->config('fnbpos_reroute_wtc')){
							$printer = $prt;
							
							if ($printer == '%'){
								$printer = $this->user->terminal_data('printer_name');
							}

						}
						/*
						if (!in_array($content, $contents)){
							
							$contents[] = $content;
							
							$postdata = http_build_query(
							    array(
							        'content' 	=> str_replace('<body>',"<body>Waiter's Copy",$content),
							        'printer'	=> $printer,
							        'paper_size'=> $paper_size,
							        'qn'		=> $this->qn
							    )
							);
							
							$opts = array('http' =>
							    array(
							        'method'  => 'POST',
							        'header'  => 'Content-type: application/x-www-form-urlencoded',
							        'content' => $postdata
							    )
							);
							
							$context  = stream_context_create($opts);
							
	
							$result = file_get_contents($url, false, $context);
						}
						*/

					}

				} elseif (trim($cli)) {

					$data = pdf_create($content, ''.$this->qn, $paper_size, false);					

					if (write_file('./queues/queue'.$this->qn.'.pdf', $data)){
						// Send to print
						if ($printer){
							$exec_str = str_replace('%order%', 'queues\queue'.$this->qn.'.pdf', $cli);
							$exec_str = str_replace('%printer_name%', $printer, $exec_str);
							
							$this->system->set_config('last_cli', $exec_str);
							
							exec($exec_str);
						}
					
						

					}
					
					/*
					if ($prt = $this->system->config('fnbpos_reroute_wtc')){
						$printer = $prt;
						
						if ($printer == '%'){
							$printer = $this->user->terminal_data('printer_name');
						}
						
						$data = pdf_create(str_replace('<body>',"<body>Waiter's Copy",$content), ''.$this->qn, $paper_size, false);					
					}
					

					
					if (write_file('./queues/queue'.$this->qn.'_copy.pdf', $data)){
						// Send to print
						if ($printer){
							$exec_str = str_replace('%order%', 'queues\queue'.$this->qn.'_copy.pdf', $cli);
							$exec_str = str_replace('%printer_name%', $printer, $exec_str);
							
							$this->system->set_config('last_cli', $exec_str);
							
							exec($exec_str);
						}
					
					}
					*/
				} else {
					
					$port = "9100";
					$host = $printer;
					$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
					
					$this->load->helper('tp');
					
					$chit = process_chit($order_data);
							
					$res = fopen('queues/PRINT_DEBUG_'.$printer.'.txt', 'w+');
					fwrite($chit, strlen($chit));
					fclose($res);					
					
					if ($socket === false) {
						$error = 1;
					} else {
						$result = socket_connect($socket, $host, $port);
						if ($result === false) {
							$error = 2;
						} else {
							socket_write($socket, $chit, strlen($chit));
							socket_close($socket);
						}

					}
					
					/*
					$printer_host = $this->system->config('fnbpos_reroute_wtc');
					$res = fopen($printer_host,'w');
					fputs($res, $chit);
					fclose($res);
					*/
					
					
				}
			}


		}
		
		
		
		
		// Loop for each printer item by category
		foreach ($copy_printer_item as $printer => $items){
			// Query printer map data by categores
				
			// Get computer name
			
			if ($individual_items){
				list($printer, $snum) = explode('#', $printer);
			}

			
			
			// Prepare printing content
			$content = date('H:i:s d/m/Y') . "\nTable no #" . $table_no . " - " . $employee->username  .  "\n";
			
			$order_data = null;
			$order_data_items = null;
			
			$order_data['table_no'] = $order->table_no;
			$order_data['employee'] = $item->ordered_by;
			$order_data['datetime'] = $item->ordered_time;
			
			// Loop for each items
			foreach ($items as $item){
				$order_data_item = null;
				
				// Add to content
				$content .= $item->qty . ' x ' . $item->item_name;
				if ($item->item_option) $content .= " - " . str_replace('_', ' ',$item->item_option) . ($item->instant_sale ? ' (Takeaway)' : '');
				$content .= "\n";
				
				$order_data_item->qty = $item->qty;
				$order_data_item->category = $item->category;
				$order_data_item->name = $item->item_name;
				if ($item->item_option) $order_data_item->option = str_replace('_', ' ',$item->item_option). ($item->instant_sale ? ' (Takeaway)' : '');
				
				$order_data_items[] = $order_data_item;
			}
			
			$order_data['items'] = $order_data_items;

			// Increment queue number
			$this->qn++;
				
			// Reset queue number if greater than 50
			if ($this->qn > 50){
				$this->qn = 0;
			}
			
			// Set the current queue number to session
			$this->session->set_userdata(array('qn'=>$this->qn));
			
			$ok = true;
			$order_data['reprint'] = true;
			$order_data['pax_no'] = $order->no_of_pax;
			
			if ($table_no == 'IS'){
				if ($this->system->config('print_is')){
					$ok = true;
				} else {
					$ok = false;
				}
			}
			

			if ($ok){
				// Write the file
				$content = $this->load->view('fnb/orderchit',$order_data,true);

					
				if ($cli[0] == '>' || $printer[0] == '>'){
					
					if ($printer){
						if ($printer[0] == '>'){
							list($cli, $printer) = explode('|', $printer);
						}
						
						$url = str_replace('>', '', $cli);
						
						
						$postdata = http_build_query(
						    array(
						        'content' 	=> str_replace('<body>',"<body>Waiter's Copy",$content),
						        'printer'	=> $printer,
						        'paper_size'=> $paper_size,
						        'qn'		=> $this->qn
						    )
						);
						
						$opts = array('http' =>
						    array(
						        'method'  => 'POST',
						        'header'  => 'Content-type: application/x-www-form-urlencoded',
						        'content' => $postdata
						    )
						);
						
						$context  = stream_context_create($opts);
						

						$result = file_get_contents($url, false, $context);
						
						/*
						if ($prt = $this->system->config('fnbpos_reroute_wtc')){
							$printer = $prt;
							
							if ($printer == '%'){
								$printer = $this->user->terminal_data('printer_name');
							}

						}

						if (!in_array($content, $contents)){
							
							$contents[] = $content;
							
							$postdata = http_build_query(
							    array(
							        'content' 	=> str_replace('<body>',"<body>Waiter's Copy",$content),
							        'printer'	=> $printer,
							        'paper_size'=> $paper_size,
							        'qn'		=> $this->qn
							    )
							);
							
							$opts = array('http' =>
							    array(
							        'method'  => 'POST',
							        'header'  => 'Content-type: application/x-www-form-urlencoded',
							        'content' => $postdata
							    )
							);
							
							$context  = stream_context_create($opts);
							
	
							$result = file_get_contents($url, false, $context);
						}
						*/

					}

				} elseif (trim($cli)) {

						$data = pdf_create(str_replace('<body>',"<body>Waiter's Copy",$content), ''.$this->qn, $paper_size, false);					

					if (write_file('./queues/queue'.$this->qn.'.pdf', $data)){
						// Send to print
						if ($printer){
							$exec_str = str_replace('%order%', 'queues\queue'.$this->qn.'.pdf', $cli);
							$exec_str = str_replace('%printer_name%', $printer, $exec_str);
							
							$this->system->set_config('last_cli', $exec_str);
							
							exec($exec_str);
						}
					
						

					}
					
					/*
					if ($prt = $this->system->config('fnbpos_reroute_wtc')){
						$printer = $prt;
						
						if ($printer == '%'){
							$printer = $this->user->terminal_data('printer_name');
						}
						
						$data = pdf_create(str_replace('<body>',"<body>Waiter's Copy",$content), ''.$this->qn, $paper_size, false);					
					}
					

					
					if (write_file('./queues/queue'.$this->qn.'_copy.pdf', $data)){
						// Send to print
						if ($printer){
							$exec_str = str_replace('%order%', 'queues\queue'.$this->qn.'_copy.pdf', $cli);
							$exec_str = str_replace('%printer_name%', $printer, $exec_str);
							
							$this->system->set_config('last_cli', $exec_str);
							
							exec($exec_str);
						}
					
					}
					*/
				} else {
					
					$port = "9100";
					$host = $printer;
					$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
					
					$this->load->helper('tp');
					
					$chit = process_chit($order_data);
							
					$res = fopen('queues/PRINT_DEBUG_'.$printer.'.txt', 'w+');
					fwrite($chit, strlen($chit));
					fclose($res);					
					
					if ($socket === false) {
						$error = 1;
					} else {
						$result = socket_connect($socket, $host, $port);
						if ($result === false) {
							$error = 2;
						} else {
							socket_write($socket, $chit, strlen($chit));
							socket_close($socket);
						}

					}
					
					/*
					$printer_host = $this->system->config('fnbpos_reroute_wtc');
					$res = fopen($printer_host,'w');
					fputs($res, $chit);
					fclose($res);
					*/
					
					
				}
			}


		}
		
	}

	// Produce receipt
	function Receipt(){
	    // Retrieve queue id
	    $queue_id = $this->input->post('queue');
	    
	    // Get queue 
	    $query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?",array($queue_id));
	    $sale = $query->row();
	    
	    if (!$sale->id){
		    $query = $this->db->query("SELECT * FROM `fnb_sales` WHERE `id` = ?",array($queue_id));
		    $sale = $query->row();
		    $get_from_archive = true;
	    }
	    
	    // Create trailing zeroes for receipt no
	    for ($i = 0; $i < 6 - strlen($sale->id); $i++){
	    	$trailing_zeroes .= '0';
	    }

		$output .= "<p style=\"text-align: center\">GST ID No: ".$this->system->config('company_tax_no')."</p>";
	   
	    $output .= "
	    	<table style=\"border-collapse: collapse; width: 100%; font-size: 11px;\">
	    		<tr>
	    			<td>".date("h:iA d/m/Y", strtotime($sale->datetime))."</td>
	    			<td>Receipt No. </td>
	    			<td style=\"text-align:right\">".$sale->txn_no."</td>
	    		</tr>
	    		<tr>
	    			<td>Cashier: ".$this->user->data('username')."</td>
	    			<td>Table No.</td>
	    			<td style=\"text-align:right\">".$sale->table_no."</td>
	    		</tr>";
	    		
	    		
	    	if ($sale->customer_id){
	    	$output .= "
	    		<tr>
					<td colspan=\"3\">Customer:</td>	    
	    		</tr>
	    		<tr>
					<td colspan=\"3\">{$sale->customer}</td>	    
	    		</tr>";
	    	}
	    		
	    	$output .= "</table>";


	    $output .= "<table style=\"margin-top: 5px; border-collapse: collapse; width: 100%; font-size: 11px; border-top: 1px solid #000\">";
	    
	    // Get ordered items by queue id
	    if ($get_from_archive){
	    	$query = $this->db->query("SELECT * FROM `fnb_sale_items` WHERE `sale_id` = ?",array($queue_id));
	    } else {
	    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?",array($queue_id));
	    }
	    
	    // Prepare itemized output for each ordered items
	    foreach ($query->result() as $item){
			if ($item->item_option){
				$item_option = ' - ' . $item->item_option;
			} else {
				$item_option = '';
			}
			
			if ($item->discount){
				$item_discount = '<br />Discount ' . $item->discount . '%';
			} else {
				$item_discount = '';
			}
			
			if ($item->item_sku == '_SC'){
		    	$sc .= "<tr>
		    		<td style=\"width: 40%\"><strong style=\"font-size: 11px; font-weight: normal\">{$item->item_name}</strong> {$item_discount}</td>
		    		<td style=\"width: 22%; text-align: center;\"></td>
		    		<td style=\"width: 23%; text-align: right;\">{$item->amount}</td>
		    	</tr>";

			} else {
			
		    	$output .= "<tr>
		    		<td style=\"width: 40%\"><strong style=\"font-size: 11px; font-weight: normal\">{$item->item_name} {$item_option} [$item->tax_code]</strong> {$item_discount}</td>
		    		<td style=\"width: 22%; text-align: center;\">{$item->qty}</td>
		    		<td style=\"width: 23%; text-align: right;\">{$item->amount}</td>
		    	</tr>";
	    	
	    	}
	    	
	    	// Sum ordered item amount for grand total
	    	$grand_total += $item->amount;
	    }
	    
	    // Perform number formatting for amounts 
	    $grand_total_display 		= number_format($sale->amount,2);
	    $discount_display 			= number_format($sale->amount_discount,2);
	    $amount_tendered_display 	= number_format($sale->amount_tendered,2);
	    $amount_change_display 		= number_format($sale->amount_change,2);
	    
	    // Get discount
	    $discount = $sale->discount;
	    
	    
    									


 		$output .= "<tr style=\"border-top: 1px solid #000\">
    					<td colspan=\"2\">Subtotal</td>
    					<td style=\"text-align: right;\">{$sale->subtotal}</td>
    				</tr>";
    				    					
    	$output .= $sc;    	
	    
	    // If has discount, show discount row in receipt
	    if ($discount){
	    	$output .= "<tr>
	    				<td colspan=\"2\">Discount ({$sale->discount}%)</td>
	    				<td style=\"width: 23%; text-align: right;\">{$discount_display}</td>
	    			</tr>";
	    }
	    
	    

	    
		$tax_breakdown = json_decode($sale->taxes);
		foreach ($tax_breakdown as $tax){
			if ($tax->inclusive) $included = "Included";
			else $included = '';
			
			$output .= "<tr>
    					<td colspan=\"2\">{$tax->name} {$included} ({$tax->percentage}%)</td>
    					<td style=\"text-align: right;\">{$tax->amount}</td>
    				</tr>";
    	}
    	
		$output .=  "<tr>
    					<td colspan=\"2\">Adjustment</td>
    					<td style=\"text-align: right;\">{$sale->adjustment}</td>
    				</tr>";	
    				
	    // Show grand total, tendered and change amount in receipt
	    $output .= "<tr style=\"border-top: 1px solid #000\">
	    				<td colspan=\"2\"><strong>Grand Total</strong></td>
	    				<td style=\"width: 23%; font-weight: bold; font-size: 16pt; text-align: right;\">{$grand_total_display}</td>
	    			</tr>
	    			<tr>
	    				<td colspan=\"2\">Amount Tendered</td>
	    				<td style=\"width: 23%; text-align: right;\">{$amount_tendered_display}</td>
	    			</tr>
	    			<tr>
	    				<td colspan=\"2\">Change</td>
	    				<td style=\"width: 23%; text-align: right;\">{$amount_change_display}</td>
	    			</tr>
	    			<tr>
	    				<td colspan=\"3\" style=\"border-top: 1px solid #000\"></td>
	    			</tr>";
	    			
	    if ($sale->amount_cash != 0){
			$output .= "<tr>
	    			<td colspan=\"2\">Cash</td>
	    			<td style=\"width: 23%; text-align: right;\">{$sale->amount_cash}</td>
	    		</tr>";	
	   	}
	    if ($sale->amount_cc != 0){
			$output .= "<tr>
	    				<td colspan=\"2\">Credit Card ({$sale->cc_name})</td>
	    				<td style=\"width: 23%; text-align: right;\">{$sale->amount_cc}</td>
	    			</tr>";
	    }
	    
	    if ($sale->amount_voucher != 0){
			$output .= "<tr>
	    				<td colspan=\"2\">Voucher</td>
	    				<td style=\"width: 23%; text-align: right;\">{$sale->amount_voucher}</td>
	    			</tr>";
	    }
	    
	    if ($sale->amount_cheque != 0){
			$output .= "<tr>
	    				<td colspan=\"2\">Cheque</td>
	    				<td style=\"width: 23%; text-align: right;\">{$sale->amount_cheque}</td>
	    			</tr>";
	    }
	    
		
		$output .= "</table>";
	    
		$width = $this->user->terminal_data('printer_width');
    				
    	$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($this->user->data('branch')));
    	$branch = $query->row();
    					
    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?",array($queue_id));
    	$sale_items = $query->result();
    					
    					
    	$data->top_header 	= 'TAX INVOICE';
		$data->company_data	= $branch;
		$data->txn_no		= $trailing_zeroes . $sale->id;
		$data->table_no		= $sale->table_no;
		$data->date			= date("h:iA d/m/Y", strtotime($sale->datetime));
		$data->cashier		= $this->user->data('username');
		$data->customer		= $contact;
		$data->items		= $sale_items;
		$data->sale			= $sale;
		

    	if ($sale->amount_cc){
	   		$query = $this->db->query("SELECT * FROM `credit_cards` WHERE `id` = ?", array($sale->card_type));
	   		$card = $query->row();
	   		$data->card = $card;
   		}

    	$data->currency		= $this->system->config('currency');
   		$data->footer		= $this->user->terminal_data('printer_footer');
    					
	  	$rawdata = urlencode($this->print_processor($data, $width));



	    
	    // Set object status as success and html output				
	    $obj['status'] 	= 'Success';
	    $obj['html'] 	= $output;
	    $obj['rawdata']	= $rawdata;
	    
	    // Encode as json string and output
		echo json_encode($obj);
	    

	}
	
	
	function Bill(){
	    // Retrieve queue id
	    $queue_id = $this->input->post('queue');
	    
	    // Get queue 
	    $query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?",array($queue_id));
	    $sale = $query->row();
	    
	    // Create trailing zeroes for receipt no
	    for ($i = 0; $i < 6 - strlen($sale->id); $i++){
	    	$trailing_zeroes .= '0';
	    }
	    
	    
	    

		$output .= "<p style=\"text-align: center\">GST ID No: ".$this->system->config('company_tax_no')."</p>";
	
	   
	    $output .= "
	    	<table style=\"border-collapse: collapse; width: 100%; font-size: 11px;\">
	    		<tr>
	    			<td>".date("h:iA d/m/Y", strtotime($sale->datetime))."</td>
	    			<td>Bill No. </td>
	    			<td style=\"text-align:right\">".$trailing_zeroes . $sale->id."</td>
	    		</tr>
	    		<tr>
	    			<td></td>
	    			<td>Table No.</td>
	    			<td style=\"text-align:right\">".$sale->table_no."</td>
	    		</tr>
	    	</table>
	    ";


	    $output .= "<table style=\"margin-top: 5px; border-collapse: collapse; width: 100%; font-size: 11px; border-top: 1px solid #000\">";
	    
	    // Get ordered items by queue id
	    $query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? ORDER BY `id` DESC",array($queue_id));
	    
	    
	    // Prepare itemized output for each ordered items
	    foreach ($query->result() as $item){
			if ($item->item_option){
				$item_option = ' - ' . $item->item_option;
			} else {
				$item_option = '';
			}
			
			if ($item->discount){
				$item_discount = '<br />Discount ' . $item->discount . '%';
			} else {
				$item_discount = '';
			}
			
			if ($item->item_sku == '_SC'){
		    	$sc .= "<tr>
		    		<td style=\"width: 40%\"><strong style=\"font-size: 11px; font-weight: normal\">{$item->item_name}</strong> {$item_discount}</td>
		    		<td style=\"width: 22%; text-align: center;\"></td>
		    		<td style=\"width: 23%; text-align: right;\">{$item->amount}</td>
		    	</tr>";

			} else {
			
		    	$output .= "<tr>
		    		<td style=\"width: 40%\"><strong style=\"font-size: 11px; font-weight: normal\">{$item->item_name} {$item_option} [$item->tax_code]</strong> {$item_discount}</td>
		    		<td style=\"width: 22%; text-align: center;\">{$item->qty}</td>
		    		<td style=\"width: 23%; text-align: right;\">{$item->amount}</td>
		    	</tr>";
	    	
	    	}
	    	
	    	// Sum ordered item amount for grand total
	    	$grand_total += $item->amount;
	    }
	    
	    // Perform number formatting for amounts 
	    $grand_total_display 		= number_format($sale->amount,2);
	    $discount_display 			= number_format($sale->amount_discount,2);
	    $amount_tendered_display 	= number_format($sale->amount_tendered,2);
	    $amount_change_display 		= number_format($sale->amount_change,2);
	    
	    // Get discount
	    $discount = $sale->discount;
	    
 		$output .= "<tr style=\"border-top: 1px solid #000\">
    					<td colspan=\"2\">Subtotal</td>
    					<td style=\"text-align: right;\">{$sale->subtotal}</td>
    				</tr>";    					
    								
    				
	    
    	$output .= $sc;		
	    
	    // If has discount, show discount row in receipt
	    if ($discount){
	    	$output .= "<tr>
	    				<td colspan=\"2\">Discount ({$sale->discount}%)</td>
	    				<td style=\"width: 23%; text-align: right;\">{$discount_display}</td>
	    			</tr>";
	    }
	    

    						

	    
		$tax_breakdown = json_decode($sale->taxes);
		foreach ($tax_breakdown as $tax){
			if ($tax->inclusive) $included = "Included";
			else $included = '';

			$output .= "<tr>
    					<td colspan=\"2\">{$tax->name} {$included} ({$tax->percentage}%)</td>
    					<td style=\"text-align: right;\">{$tax->amount}</td>
    				</tr>";
    	}
    	
		$output .=  "<tr>
    					<td colspan=\"2\">Adjustment</td>
    					<td style=\"text-align: right;\">{$sale->adjustment}</td>
    				</tr>";	
	    
	    // Show grand total, tendered and change amount in receipt
	    $output .= "<tr style=\"border-top: 1px solid #000\">
	    				<td colspan=\"2\"><strong>Grand Total</strong></td>
	    				<td style=\"width: 23%; font-weight: bold; font-size: 16pt; text-align: right;\">{$grand_total_display}</td>
	    			</tr>";





		$width = $this->user->terminal_data('printer_width');
    				
    	$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($this->user->data('branch')));
    	$branch = $query->row();
    					
    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?",array($queue_id));
    	$sale_items = $query->result();
    					
    					
    	$data->top_header 	= 'BILL';
		$data->company_data	= $branch;
		$data->txn_no		= $trailing_zeroes . $sale->id;
		$data->table_no		= $sale->table_no;
		$data->date			= date("h:iA d/m/Y", strtotime($sale->datetime));
		$data->cashier		= $this->user->data('username');
		$data->customer		= $contact;
		$data->items		= $sale_items;
		$data->sale			= $sale;
		

    	if ($sale->amount_cc){
	   		$query = $this->db->query("SELECT * FROM `credit_cards` WHERE `id` = ?", array($sale->card_type));
	   		$card = $query->row();
	   		$data->card = $card;
   		}

    	$data->currency		= $this->system->config('currency');
   		$data->footer		= $this->user->terminal_data('printer_footer');
    					
	  	$rawdata = urlencode($this->print_processor($data, $width));

	    
	    // Set object status as success and html output				
	    $obj['status'] 	= 'Success';
	    $obj['html'] 	= $output;
	    $obj['rawdata']	= $rawdata;
	    
	    // Encode as json string and output
		echo json_encode($obj);

	}
	
	
	function Cancel_delivery(){
		if ($this->system->config('revert_level') == 'Manager'){
	    	$username = $_REQUEST['username'];
	    	$password = $_REQUEST['password'];
	    	$manager = true;
	    }
	    
	    $user = $this->user->get_user_by_username($username);
    	$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));
    	$permission = $query->row();
    	
    	$action = json_decode($permission->action);
    	
    	if ($manager){
    	    if (!$this->user->has_permission('to_supervise_pos','Sales',$user->username)){
    	    	$obj->status = 'Failed';
    	    	echo json_encode($obj);
    	    	return;
    	    } else {
    	    	if ($user->password !== md5($password)){
    	    		$obj->status = 'Failed';
    	    		echo json_encode($obj);
    	    		return;
    	    	}
    	    }
    	}
	    
	    /*
	    $employee = $this->user->get_user_by_username($username);
	    if ($manager){
	    	if ($employee->position != 'Manager'){
	    		$obj->status = 'Failed';
	    		echo json_encode($obj);
	    		return;
	    	} else {
	    		if ($employee->password !== $password){
	    			$obj->status = 'Failed';
	    			echo json_encode($obj);
	    			return;
	    		}
	    	}
	    }
	    */
	    
	    $queue_id = $this->input->post('queue');
	    
	    $query = $this->db->query("SELECT * FROM `fnb_delivery_orders` WHERE `id` = ?", array($queue_id));
	    $sale = $query->row();
	    
	    $query = $this->db->query("SELECT * FROM `fnb_delivery_order_items` WHERE `order_id` = ?", array($queue_id));
	    $sale_items = $query->result();
	    
	    $data->sale = $sale;
	    $data->sale_items = $sale_items;

	    
	    $this->db->query("DELETE FROM `fnb_delivery_orders` WHERE `id` = ?", array($queue_id));
	    $this->db->query("DELETE FROM `fnb_delivery_order_items` WHERE `order_id` = ?", array($queue_id));
	    
	    $sql = $this->db->insert_string('fnb_reverts',array(
	    	'performed_by'  => $manager ? $username : $employee->username,
	    	'data'			=> json_encode($data),
	    	'datetime'		=> date('Y-m-d H:i:s'),
	    	'remarks'		=> $this->input->post('reason')
	    ));
	    
	    $this->db->query($sql);
	    
	    $obj->status = 'Success';
	    echo json_encode($obj);
	}
	
	
	function Revert_sale(){
		$queue_id = $this->input->post('queue_id');
		
		if ($this->system->config('revert_level') == 'Manager'){
	    	$username = $_REQUEST['username'];
	    	$password = $_REQUEST['password'];
	    	
	    	if (!$username){
		    	$keycard = $password;
	    	}

		    
	    	$manager = true;
	    } else {
	    	$manager = false;
	    }
	    
    	if (!$keycard){	    
		    $user = $this->user->get_user_by_username($username);
	    } else {
		    $user = $this->user->get_user_by_keycard($keycard);		    
	    }


    	$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));
    	$permission = $query->row();
    	
    	$action = json_decode($permission->action);
    	
    	if ($manager){
    	    if (!$this->user->has_permission('to_supervise_pos','Sales',$user->username)){
    	    	$obj->status = 'Failed';
    	    	$obj->error = 1;
    	    	echo json_encode($obj);
    	    	return;
    	    } else {
	    	    if (!$keycard){
	    	    	if ($user->password !== md5($password)){
	    	    		$obj->status = 'Failed';
						$obj->error = 2;
	    	    		echo json_encode($obj);
	    	    		return;
	    	    	}
    	    	} else {
	    	    	if (!$user->id){
		    	    	$obj->status = 'Failed';
						$obj->error = 2;
	    	    		echo json_encode($obj);
	    	    		return;
	    	    	}
    	    	}
    	    }
    	}
		
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
	    $sale = $query->row();
	    
	    $query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?", array($queue_id));
	    $sale_items = $query->result();
	    
	    $data->sale = $sale;
	    $data->sale_items = $sale_items;
	    
	    
		$this->db->query("UPDATE `fnb_buffer_sales` SET `type` = 'queue', `payment_status` = 'Unpaid' WHERE `id` = ?", array($queue_id));
		


	    
	    $sql = $this->db->insert_string('fnb_reverts',array(
	    	'performed_by'  => $manager ? $username : $employee->username,
	    	'data'			=> json_encode($data),
	    	'datetime'		=> date('Y-m-d H:i:s'),
	    	'revert'		=> 1,
	    	'remarks'		=> $this->input->post('reason')
	    ));
	    
	    $this->db->query($sql);
	    $obj->queue_id = $queue_id;
	    $obj->status = 'Success';
	    echo json_encode($obj);

	}

	
	function Cancel(){
		if ($this->system->config('revert_level') == 'Manager'){
	    	$username = $_REQUEST['username'];
	    	$password = $_REQUEST['password'];
	    	$manager = true;
	    	
	      	if (!$username){
		    	$keycard = $password;
	    	}

	    }
	    
	    if (!$keycard){	    
		    $user = $this->user->get_user_by_username($username);
	    } else {
		    $user = $this->user->get_user_by_keycard($keycard);		    
	    }
	    
    	$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));
    	$permission = $query->row();
    	
    	$action = json_decode($permission->action);
    	
    	if ($manager){
    	    if (!$this->user->has_permission('to_supervise_pos','Sales',$user->username)){
    	    	$obj->status = 'Failed';
    	    	echo json_encode($obj);
    	    	return;
    	    } else {
	    	    if (!$keycard){
	    	    	if ($user->password !== md5($password)){
	    	    		$obj->status = 'Failed';
	    	    		echo json_encode($obj);
	    	    		return;
	    	    	}
    	    	} else {
	    	    	if (!$user->id){
		    	    	$obj->status = 'Failed';
						$obj->error = 2;
	    	    		echo json_encode($obj);
	    	    		return;
	    	    	}
    	    	}
    	    }
    	}
	    
	    /*
	    $employee = $this->user->get_user_by_username($username);
	    if ($manager){
	    	if ($employee->position != 'Manager'){
	    		$obj->status = 'Failed';
	    		echo json_encode($obj);
	    		return;
	    	} else {
	    		if ($employee->password !== $password){
	    			$obj->status = 'Failed';
	    			echo json_encode($obj);
	    			return;
	    		}
	    	}
	    }
	    */
	    
	    $queue_id = $this->input->post('queue');
	    
	    $query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
	    $sale = $query->row();
	    
	    $query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?", array($queue_id));
	    $sale_items = $query->result();
	    
	    $data->sale = $sale;
	    $data->sale_items = $sale_items;

	    
	    $this->db->query("DELETE FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
	    $this->db->query("DELETE FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?", array($queue_id));
	    
	    $sql = $this->db->insert_string('fnb_reverts',array(
	    	'performed_by'  => $manager ? $username : $employee->username,
	    	'data'			=> json_encode($data),
	    	'datetime'		=> date('Y-m-d H:i:s'),
	    	'remarks'		=> $this->input->post('reason')
	    ));
	    
	    $this->db->query($sql);
	    
	    $obj->status = 'Success';
	    echo json_encode($obj);
	}
	
	// Create table
	function Create_table($a,$b){
	
		// write_file('./queues/queue'.$this->qn.'.txt', $content);
		    
		// Retrieve table no 
		$instant = false;
		
		if ($this->input->post('instant')) $instant = true;
		if (!$this->input->post('table_no') && !$instant){

		    // Return error if no table no entered
			$obj->status = 'Failed';
			echo json_encode($obj);
		    return;
		}
		
		if (strlen($a) >= 6){
			$query = $this->db->query("SELECT * FROM `fnb_table_cards` WHERE `card_no` = ?", array($a));

			
			if ($query->num_rows()){
				$table_card = $query->row();				
				$table_no = $table_card->short_no;
				$card_no = $table_card->short_no;
			}
			
		} else {
			
			$query = $this->db->query("SELECT * FROM `fnb_table_cards` WHERE `short_no` = ?", array($a));
			if ($query->num_rows()){
				$card_no = $a;
				$table_no = $a;
			} else { 
				$card_no = $this->input->post('card_no');
				$table_no = $this->input->post('table_no');
			}
		}

		// Select queue from table no
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `table_no` = ? AND `type` = 'queue'", array($this->input->post('table_no')));
		
		// Check if table exist
		if ($query->num_rows() && !$instant){
		    // If table already exist, return failed
		    $obj->status = 'Failed';
		    
		    // Encode as json string and output
		    echo json_encode($obj);
		    
		} else {
			
			if ($card_no){
				
				$query = $this->db->query("SELECT * FROM `fnb_table_cards` WHERE `short_no` = ?",array($card_no));
				if (!$query->num_rows()){
					$obj->status = 'Failed';
					$obj->code	 = 2;
					echo json_encode($obj);
					return;	
				}			
				
				$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `table_card_no` = ? AND `type` = 'queue'", array($card_no));
				if ($query->num_rows()){
					$obj->status = 'Failed';
					$obj->code	 = 1;
					echo json_encode($obj);
					return;
				}
			}
			
		    // Otherwise create queue entry
		    $sql = $this->db->insert_string('fnb_buffer_sales',array(
		    	'type'				=> 'queue',
		    	'payment_status' 	=> 'Unpaid',
		    	'table_no'			=> $table_no,
		    	'no_of_pax'			=> $this->input->post('pax'),
		    	'table_card_no'		=> $card_no,
		    	'username'			=> $this->user->data('username'),
		    	'user_id'			=> $this->user->data('id'),
		    	'terminal'			=> $this->user->terminal(),
		    	'session'			=> $this->user->data('terminal_session'),
		    	'datetime'			=> date('Y-m-d H:i:s')
		    ));
		    $query = $this->db->query($sql);
		    
		    // Get created queue id
		    $id = $query->insert_id;
		    
		    if ($instant){
				$sql = $this->db->update_string('fnb_buffer_sales',array(
			    	'table_no'	=> 'IS',
			    	'no_of_pax'	=> 1
			    ),"`id` = '$id'");
			    $this->db->query($sql);
		    }
		    
		    // Get the created queue by queue id
		    $query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?",array($id));
		    
			if ($sc = $this->system->config('fnbpos_service_charge')){
			    if ($instant){
				    if (!$this->system->config('fnbpos_no_sc_is')){
					    
						$this->db->insert('fnb_buffer_sale_items',array(
			    	    	'sale_id'		=> $id,
			    	    	'item_id'		=> 0,
			    	    	'si_item_id'	=> 0,
			    	    	'date'			=> date('Y-m-d H:i:s'),
			    	    	'item_sku'		=> '_SC',
			    	    	'item_name'		=> 'Service Charge (' . $sc . '%)',
			    	    	'item_option'	=> '',
			    	    	'category'		=> 'SERVICE CHARGE',
			    	    	'subcategory'	=> 'SERVICE CHARGE',
			    	    	'qty'			=> 1,
			    	    	'price_per_unit'=> 0,
			    	    	'printed'		=> 1,
			    	    	'terminal'		=> $this->user->terminal(),
			    	    	'ordered_by'	=> $this->user->data('username'),
			    	    	'ordered_time'	=> date('Y-m-d H:i:s'),
			    	    	'cost'			=> 0,
			    	    	'margin'		=> 0,
			    	    	'amount'		=> 0,
			    	    	'serial'		=> 0,
			    	    	'taxable'		=> 1,
			    	    	'tax_code'		=> 'SR',
			    	    	'warehouse_id'	=> $this->user->data('branch')
			    	    ));
			    	    
				    }
			    } else {
				    
				    $this->db->insert('fnb_buffer_sale_items',array(
			        	'sale_id'		=> $id,
			        	'item_id'		=> 0,
			        	'si_item_id'	=> 0,
			        	'date'			=> date('Y-m-d H:i:s'),
			        	'item_sku'		=> '_SC',
			        	'item_name'		=> 'Service Charge (' . $sc . '%)',
			        	'item_option'	=> 'SERVICE CHARGE',
			        	'category'		=> 'SERVICE CHARGE',
			        	'subcategory'	=> '',
			        	'qty'			=> 1,
			        	'price_per_unit'=> 0,
			        	'printed'		=> 1,
			        	'terminal'		=> $this->user->terminal(),
			        	'ordered_by'	=> $this->user->data('username'),
			        	'ordered_time'	=> date('Y-m-d H:i:s'),
			        	'cost'			=> 0,
			        	'margin'		=> 0,
			        	'amount'		=> 0,
			        	'serial'		=> 0,
			        	'taxable'		=> 1,
			        	'tax_code'		=> 'SR',
			        	'warehouse_id'	=> $this->user->data('branch')
			        ));
				    
			    }
		    }
		    
		    // Store queue in obj
		    $obj = $query->row();
		    if ($instant) $obj->table_no = 'IS' . $id;
		    
		    $obj->queue_id = $id;
		    $obj->status = 'Success';
		    
		    // Encode as json string and output
		    echo json_encode($obj);
		}
		
	}
	
	// Enter custom price
	function Enter_price($id, $price, $qty){


    	// Get ordered item by id
    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `id` = ?", array($id));
    	$sale_item = $query->row();
    	
    	// Get item from inventory by item id
    	$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `id` = ?", array($sale_item->item_id));
    	$item = $query->row();
    	
    	
    	// Calculate amount and price per unit for the ordered item
    	$sale_item->amount += ($price * $qty) - ($item->price * $qty);
    	$sale_item->price_per_unit = $sale_item->amount / $sale_item->qty;	
    
    	// Update ordered item entry	
    	$this->db->query($this->db->update_string('fnb_buffer_sale_items', array(
    		'amount'		=> $sale_item->amount,
    		'price_per_unit'=> $sale_item->price_per_unit,
    		'item_option'	=> $this->system->config('currency') . number_format($sale_item->price_per_unit,2)
    	), "`id` = '$id' AND `sold` IS NULL"));
    	
    	// Update queue amount by queue id
    	$this->update_amount($sale_item->sale_id);

	}
	
	function Add_ss_item($sku, $qty, $option, $price){
		
			
	}
	
	// Add item into table order
	function Add_item($queue_id, $sku, $qty, $option, $price){
	
		
		// Get print queues
		$prints = $this->session->userdata('prints');
		
		// Split option list into array
		$option_array = explode('|', $option);
		
		// Sort option array for option matching
		sort($option_array);
		
		// Join to form identifiable option string
		$option = implode(',',$option_array);
		
		
		// Get queue from queue id
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?",array($queue_id));
		$sale = $query->row();

		// Query for item from item code
		$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `sku` = ?",array($sku));
		
		// If item exists
		if ($query->num_rows()){
		    
		    // Get item
		    $item = $obj = $query->row();
		    
		    // If item has customer price, set enter_price flag to 1 for json return object
		    if ($item->enter_price) $obj->enter_price = 1;
		    
		    // Set json object price from item price
		    $obj->price = $item->item_price;

		    
		    // Query for identical order based on item code and option in the queue
		    $has_row = false;
		    if ($qty == 1) {
		    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `item_sku` = ? AND `sale_id` = ? AND `item_option` = ?",array($sku,$queue_id,trim($option)));
		    	if ($query->num_rows()) $has_row = true;
		    } 
		    

		    // Check if identical order exists
		    if (!$has_row){
			    

		    	
		    	// Create new order if identical order does not exists
		    	$sql = $this->db->insert_string('fnb_buffer_sale_items',array(
		    		'sale_id'		=> $queue_id,
		    		'item_id'		=> $item->id,
		    		'date'			=> date('Y-m-d'),
		    		'item_sku'		=> $sku,
		    		'item_name'		=> $item->name,
		    		'item_option'	=> $option,
		    		'category'		=> $item->category,
		    		'subcategory'	=> $item->subcategory,
		    		'qty'			=> $qty,
		    		'price_per_unit'=> $price,
		    		'terminal'		=> $this->user->terminal(),
		    		'amount'		=> $price * $qty,
		    		'taxable'		=> $item->supply_taxable,
		    		'tax_code'		=> $item->supply_tax_code
		    	));
		    	$query = $this->db->query($sql);
		    	
		    	// Get the new order id
		    	$iid = $query->insert_id;
		    	
		    	// Prepare json return object
		    	$obj->status = 'Success';
		    	$obj->amount = number_format($price * $qty,2);
		    	$obj->qty = $qty;
		    	$obj->outstanding = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : '0.00' ;
		    	
		    	// Add print queue for the order
		    	$prints[$iid]['name'] 		= $item->name;
		    	$prints[$iid]['table_no'] 	= $sale->table_no;
		    	$prints[$iid]['qty'] 		= $qty;
		    	$prints[$iid]['option'] 	= $option;
		    	$prints[$iid]['category'] 	= $item->category;
		    	$prints[$iid]['subcategory']= $item->subcategory;
		    	$prints[$iid]['printer']	= $item->printer;
		
		    	
		    } else {
		    
		    	// Get the identicial order if exists
		    	$existing_item = $query->row();
		    	
		    	// Update with new qty and amount identical order entry
		    	$sql = $this->db->update_string('fnb_buffer_sale_items',array(
		    		'qty'			=> $existing_item->qty + $qty,
		    		'amount'		=> $price * ($existing_item->qty + $qty)
		    	),"`id` = '{$existing_item->id}'");

		    	$this->db->query($sql);
		    	
		    	// Get identical order id
		    	$iid = $existing_item->id;
		    	
		    	// Prepare json return object
		    	$obj->status = 'Success';
		    	$obj->amount = number_format($price * $qty,2);
		    	$obj->qty = $qty;
		    	$obj->outstanding = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : '0.00' ;
		    	
		    	// Update print queue for the order
		    	$prints[$iid]['name'] 		= $item->name;
		    	$prints[$iid]['table_no'] 	= $sale->table_no;
		    	$prints[$iid]['qty'] 		= $existing_item->qty + $qty;
		    	$prints[$iid]['option'] 	= $option;
		    	$prints[$iid]['category'] 	= $item->category;
		    	$prints[$iid]['subcategory']= $item->subcategory;
		    	$prints[$iid]['printer']	= $item->printer;

		    }
		
		    // Update printing queue to session
		    $this->session->set_userdata(array('cq_print'=>$queue_id));
		    $this->session->set_userdata(array('prints'=>$prints));
			
			
	
		} else {
		    // If no object found, return outstanding and fail status
		    $obj['outstanding'] = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : '0.00' ;
		    $obj['status'] = 'Failed';
		}
		
	    $this->db->update('fnb_buffer_sales', array(
		   'datetime' 	=> date('Y-m-d H:i:s')
	    ),"`id` = '{$queue_id}'");
		
		// Encode as json string and output
		echo json_encode($obj);
	}
	
	
	function Filter_history(){
		$table_no = $this->input->post('table');
		
		// Within 24 hours 
		$then = date('Y-m-d H:i:s',time() - (24 * 60 * 60));
		$now = date('Y-m-d H:i:s');
	
		// Query completed table queue and order by date and time
		if ($table_no){
			$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `table_no` LIKE ? AND `type` = 'history' AND `datetime` >= ? AND `datetime` <= ? ORDER BY CAST(`table_no` AS SIGNED) ASC",array('%'.$table_no.'%', $then,$now));
		} else {
			$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `type` = 'history' AND `datetime` >= ? AND `datetime` <= ? ORDER BY CAST(`table_no` AS SIGNED) ASC",array($then,$now));
		}
		
		// Loop for each table queue
		foreach ($query->result() as $queue){
			// Prepare output for table queue history list
    		$time = date('h:iA',strtotime($queue->datetime));
    		$total_items = $this->get_total_items($queue->id);
    		
    		$output .= "<li id=\"{$queue->id}\">
    				<strong>{$queue->table_no}</strong><span class=\"gt\">{$queue->amount}</span><br />{$time}
    			</li>";
    	}
    	
    	// Return result and list
    	$obj['status'] = 'Success';
    	$obj['html'] = $output;
    	
    	echo json_encode($obj);

	}
	
	// Void item
	function Void_item($queue_id, $queue_item_id, $qty = 1){

		if ($this->system->config('revert_level') == 'Manager'){
	    	$username = $_REQUEST['username'];
	    	$password = $_REQUEST['password'];
	    	
	    	if (!$username){
		    	$keycard = $password;
	    	}
	    	
	    	$manager = true;
	    } else {
	    	$manager = false;
	    }

		if (!$keycard){	    
		    $user = $this->user->get_user_by_username($username);
	    } else {
		    $user = $this->user->get_user_by_keycard($keycard);		    
	    }
	    
    	$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));
    	$permission = $query->row();
    	
    	$action = json_decode($permission->action);
    	
    	if ($manager){
    	    if (!$this->user->has_permission('to_supervise_pos','Sales',$user->username)){
    	    	$obj->status = 'Failed';
    	    	$obj->error = 1;
    	    	echo json_encode($obj);
    	    	return;
    	    } else {
	    	    if (!$keycard){
	    	    	if ($user->password !== md5($password)){
	    	    		$obj->status = 'Failed';
						$obj->error = 2;
	    	    		echo json_encode($obj);
	    	    		return;
	    	    	}
    	    	} else {
	    	    	if (!$user->id){
		    	    	$obj->keycard = $keycard;
		    	    	$obj->status = 'Failed';
						$obj->error = 2;
	    	    		echo json_encode($obj);
	    	    		return;
	    	    	}
    	    	}
    	    }
    	}

		// Get print queue
		$prints = $this->session->userdata('prints');
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
		$queue = $query->row();
		
		if ($queue->type == 'history') return;
		
		
		$data['void_item'] = $queue;

		


		
		
		// Loop for matching item to be voided from queue
		foreach ($prints as $id => $print){
		    if ($id != $queue_item_id) $new_prints[] = $print;
		}
		
		// Update printing queue
		$this->session->set_userdata(array('prints'=>$new_prints));
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `id` = ?", array($queue_item_id));
		$item = $query->row();
		$new_qty = $item->qty - $qty;
		
		$void_item = $item;
		$void_item->qty = $qty;
		$data['void_item'] = $void_item;
		
	    $sql = $this->db->insert_string('fnb_reverts',array(
	    	'performed_by'  => $manager ? $username : $employee->username,
	    	'data'			=> json_encode($data),
	    	'datetime'		=> date('Y-m-d H:i:s'),
	    	'remarks'		=> $this->input->post('reason')
	    ));
	    
	    $this->db->query($sql);

		
		if ($new_qty < 1){	
			// Remove item from table queue 
			$this->db->query("DELETE FROM `fnb_buffer_sale_items` WHERE `id` = ?",array($queue_item_id));
		} else {
			$sql = $this->db->update_string('fnb_buffer_sale_items',array(
				'qty'	=> $new_qty,
				'amount'=> $item->price_per_unit * $new_qty
			), "`id` = '$queue_item_id'");
			
			$this->db->query($sql);
		}
		
		// Update table amount of queue id
		$this->update_amount($queue_id);
		
		// Return object
		$obj['status'] = 'Success';
		$obj['qty'] = $qty;
		echo json_encode($obj);
		
	}
	
	// Cash checkout
	function Cash_checkout($queue_id, $amount_tendered, $discount){
		
	
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
		$queue = $query->row();
		
		
		if ($queue->amount <= 0){
			$obj['status'] = 'Error';					
			$obj['reason'] = 'Checkout cannot be equal or less than 0.00';
			echo json_encode($obj);		
			return;
		}
		
		
		if ($queue->amount_discount != 0){
			if ($queue->customer_id){
				if ($this->Check_exceed_discount_limit($queue->customer_id)){
					$obj['status'] = 'Error';					
					$obj['reason'] = 'Checkout exceeded discount limit';
					echo json_encode($obj);		
					return;
				}
			}
		}
		

		// Separate decimals
		list($ones, $decimals) = explode('.',$amount);

		// Rounding adjustment 
		if ($decimals[1] <= 2){
		    $newDec = 0;
		    $addition = 0;
		} else if ($decimals[1] <= 7){
		    $newDec = 5;
		    $addition = 0;
		} else if ($decimals[1] <= 9){
		    $newDec = 0;
		    $addition = 0.1;
		}
		
		$start = microtime();
		
		
		// Get the updated amount for the queue
		$amount = $this->update_amount($queue_id);
		
		$query = $this->db->query("SELECT COUNT(`id`) AS `total` FROM `fnb_sales`");
		$count = $query->row();

		$query = $this->db->query("SELECT COUNT(`id`) AS `total` FROM `fnb_buffer_sales` WHERE `type` = 'history'");
		$buffer_count = $query->row();
		
		$n = $count->total + $buffer_count->total + 1;
		
		$benchmark .= "A: " . ((microtime() - $start)) . '\n';
		
		
		$cash		= $this->input->post('amount_cash');
		$voucher 	= $this->input->post('amount_voucher');
		$cheque		= $this->input->post('amount_cheque');
		

		
		
		if (trim($this->input->post('pm')) == 'Credit Card'){
			$cc = $this->credit_cards->Get_card_option_by_id($this->input->post('cc_type'));
			
			$cc_fee 	= $amount * $cc->percentage / 100;
			$cc_tax 	= $cc_fee * $cc->tax / 100;
			$cc_amount	= $amount - ($cc_fee + $cc_tax);
			
			$amount_cash = 0;
			$amount_cc 	= $amount - $voucher - $cheque;
			
		} elseif (trim($this->input->post('pm')) == 'Credit Card and Cash') {
			$cc = $this->credit_cards->Get_card_option_by_id($this->input->post('cc_type'));
			
			$amount_cash = $cash;
			$amount_cc	= $amount - $cash;
			
			$cc_fee 	= $amount_cc * $cc->percentage / 100;
			$cc_tax 	= $cc_fee * $cc->tax / 100;
			$cc_amount	= $amount_cc - ($cc_fee + $cc_tax);
			
			
		} else {
			$amount_cash = $amount - $voucher - $cheque;
		}	
		
		$amount = str_replace(',','', number_format($amount,2));
				
		
		// Save sales data
		$sql = $this->db->update_string('fnb_buffer_sales',array(
		    'type'				=> 'history',
		    'txn_no'			=> 100000 + $n,
		    'payment_status'	=> 'Paid',
		    'amount_tendered'	=> $amount_tendered + $voucher + $cheque,
		    'amount_change'		=> $amount_tendered - $amount + $voucher + $cheque,
		    'amount_voucher'	=> $voucher,
		    'amount_cheque'		=> $cheque,
		    'amount_cash'		=> $amount_cash,
		    'amount_cc'			=> $amount_cc,
		    'payment_method'	=> trim($this->input->post('pm')),
		    'cc_type'			=> $cc->id,
		    'cc_name'			=> $cc->name,
		    'cc_percentage'		=> $cc->percentage,
		    'cc_tax_percentage'	=> $cc->tax_percentage,
		    'cc_fee'			=> $cc_fee,
		    'cc_tax'			=> $cc_tax,
		    'cc_amount'			=> $cc_amount,
		    'datetime'			=> date('Y-m-d H:i:s'),
		    'terminal'			=> $this->user->data('terminal_id'),
		    'session'			=> $this->user->data('terminal_session')
		    
		),"`id` = '$queue_id'");
		$this->db->query($sql);
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
		$e_sale = $query->row();
		
		$benchmark .= "B: " . ((microtime() - $start)) . '\n';
		
		// Update ordered item data
		$sql = $this->db->update_string('fnb_buffer_sale_items', array(
		    'sold'				=> 1,
		    'global_discount'	=> $e_sale->discount,
		    'session'			=> $this->user->data('terminal_session')
		),"`sale_id` = '$queue_id'");
		$this->db->query($sql);
		
		$benchmark .= "C: " . ((microtime() - $start)) . '\n';
		
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?", array($queue_id));
		foreach ($query->result() as $sale_item){
			if ($sale_item->si_item_id){
				$this->inv->update_item_cost($sale_item->si_item_id, $this->user->data('branch'));
				$this->inv->update_item_qty($sale_item->si_item_id, $this->user->data('branch')); 
			}
		}
		
		$benchmark .= "D: " . ((microtime() - $start)) . '\n';
		
		// Return amount tendered and change
		$obj['queue_id'] = $queue_id;
		$obj['tendered'] = number_format($amount_tendered+$voucher+$cheque,2);
		$obj['change'] = number_format($amount_tendered - $amount + $voucher + $cheque,2);
		$obj['status'] = 'Success';
		$obj['discount'] = $this->input->post('discount');
		$obj['bench']	= $benchmark;
		
		echo json_encode($obj);		
	}
	
	
	
	// Cash checkout
	function Cash_checkout_delivery($queue_id, $amount_tendered, $discount){
		
		// Get the updated amount for the queue
		$amount = $this->update_delivery_amount($queue_id);
		
		// Formatting with two decimals and calculate discount
		$amount = str_replace(',','',number_format($amount * ((100 - $discount) / 100),2));
		
		// Separate decimals
		list($ones, $decimals) = explode('.',$amount);
		
		// Rounding adjustment 
		if ($decimals[1] <= 2){
		    $newDec = 0;
		    $addition = 0;
		} else if ($decimals[1] <= 7){
		    $newDec = 5;
		    $addition = 0;
		} else if ($decimals[1] <= 9){
		    $newDec = 0;
		    $addition = 0.1;
		}
		
		// Rounding result
		$discounted = $ones . '.' . $decimals[0] . $newDec;
		$discounted += $addition;
		
		// Save sales data
		$sql = $this->db->update_string('fnb_delivery_orders',array(
		    'type'				=> 'history',
		    'status'			=> 'Delivered',
		    'payment_status'	=> 'Paid',
		    'amount_tendered'	=> $amount_tendered,
		    'amount_change'		=> $amount_tendered - $discounted,
		    'amount'			=> $discounted,
		    'payment_method'	=> 'Cash',
		    'discount'			=> $discount,
		    'datetime'			=> date('Y-m-d H:i:s'),
		    'session'			=> $this->user->data('terminal_session')
		    
		),"`id` = '$queue_id'");
		$this->db->query($sql);
		
		// Update ordered item data
		$sql = $this->db->update_string('fnb_delivery_order_items', array(
		    'sold'				=> 1,
		    'session'			=> $this->user->data('terminal_session')
		),"`order_id` = '$queue_id'");
		$this->db->query($sql);
		
		// Return amount tendered and change
		$obj['queue_id'] = $queue_id;
		$obj['tendered'] = number_format($amount_tendered,2);
		$obj['change'] = number_format($amount_tendered - $discounted,2);
		$obj['status'] = 'Success';
		
		
		echo json_encode($obj);		
	}
	
	// Get table queue ist
	function Get_queue_list(){
		
		
		$query = $this->db->query("SELECT * FROM `fnb_table_cards`");
		foreach ($query->result() as $card){
			$cards[$card->short_no] = $card->card_no;
		}
		
		// Query table queue and order by table no ascending
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `type` = 'queue' ORDER BY CAST(`table_no` AS SIGNED) ASC", array());
		
		$currency = $this->system->config('currency');
		$duration = $this->system->config('fnbpos_idle_table_duration');
		

		
		// Loop for each table queue
		foreach ($query->result() as $queue){
			// Prepare output for table queue list
			
			$verified 	= $queue->verified ? '' : 'unverified';

			$style = '';
			
			$delta = time() - strtotime($queue->datetime);
			if ($delta / 60 > $duration){
				$style = 'style="background: #ffcdcd"';
			}
			
			$style 	= $queue->verified ? $style : 'style="background:#ffeab4"';
			
			if ($queue->no_of_pax){
				$pax = ''. $queue->no_of_pax . ' Pax<br />';
			} else {
				$pax = 'N/A<br />';
			}
			
			$table_card_no = $cards[$queue->table_card_no];
			
			if (!$queue->table_card_no) $queue->table_card_no = 'N/A';
			
		    if ($queue->amount){
			    $subtotal = $queue->amount;
			    $output .= "<li id=\"{$queue->id}\" cardno=\"{$table_card_no}\" tableno=\"{$queue->table_no}\" class=\"{$verified}\" {$style}>
		    		<strong>{$queue->table_no}</strong>{$pax}{$currency}<span class=\"gt\">{$subtotal}</span><br /><span style=\"color: #888\">#{$queue->table_card_no}</span>
		    	</li>";
		    } else {
			    $output .= "<li id=\"{$queue->id}\" cardno=\"{$table_card_no}\" tableno=\"{$queue->table_no}\" class=\"{$verified}\" {$style}>
		    		<strong>{$queue->table_no}</strong>{$pax}{$currency}<span class=\"gt\">0.00</span><br /><span style=\"color: #555\">#{$queue->table_card_no}</span>
		    	</li>";
		    }
		}
		// Return result and list
		$obj['status'] = 'Success';
		$obj['html'] = $output;
		
		echo json_encode($obj);

	}
	
	
	function New_online_order($data){

		$order_data->name = $data->name;
		$order_data->email = $data->email;
		$order_data->mobile = $data->mobile;
		$order_data->address = $data->address;
		
		$this->db->insert('fnb_delivery_orders', array(
			'order_data'	=> json_encode($order_data),
			'status'		=> 'Order Placed',
			'datetime'		=> date('Y-m-d H:i:s')
		));
		
		
		foreach ($order->data->items as $item){
		
			$skus = $this->input->post('sku');
			$options = $this->input->post('option');
			$prices = $this->input->post('price');
			$qtys = $this->input->post('qty');
			$sale_id = $this->input->post('sale_id');
		
		}
		
	}
	
	function Process_online_orders(){
		
	}
	
	// New delivery
	
	function Create_delivery($name, $mobile, $address){
	
		$order_data->name = $name;
		$order_data->email = $email;
		$order_data->mobile = $mobile;
		$order_data->address = $address;
		
		$this->db->insert('fnb_delivery_orders', array(
			'order_data'	=> json_encode($order_data),
			'status'		=> 'Order Placed',
			'datetime'		=> date('Y-m-d H:i:s')
		));
		
	}
	
	
	// Process order
	function Submit_delivery_order($status, $online, $order_id){
		// Retrieve all data from iphone order submission
		
		if ($online){
		
		} else {
			$skus = $this->input->post('sku');
			$options = $this->input->post('option');
			$prices = $this->input->post('price');
			$qtys = $this->input->post('qty');
			$sale_id = $this->input->post('sale_id');
		}
		
		if (!$skus) return;

		
		// Check if there are multiple items
		if (strpos($skus,',')){
			// Populate in arrays
			$skus_array = explode(',', $skus);
			$options_array = explode('|',$options);
			$prices_array = explode(',', $prices);
			$qtys_array = explode(',', $qtys);
		} else {
			// Populate in array
			$skus_array[0] = $skus;
			$options_array[0] = $options;
			$prices_array[0] = $prices;
			$qtys_array[0] = $qtys;
			
		}
		
		// Loop for each item array
		for ($i = 0; $i < count($skus_array); $i++){
			
			$sku = $skus_array[$i];
			$option = trim($options_array[$i]);
			$price = $prices_array[$i];
			$qty = $qtys_array[$i];
			
			// Split item options
			$option_array = explode(',', $option);
			
			// Sort the options 
			sort($option_array);
			
			// Join the array into string to obtain identifiable option name
			$option = implode(',',$option_array);
			
			// Get item from items database
			$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `sku` = ?",array($sku));
			$item = $obj = $query->row();

			
			// If item exists
			if ($query->num_rows()){
	    		// Check if already ordered
	    		$query = $this->db->query("SELECT * FROM `fnb_delivery_order_items` WHERE `item_sku` = ? AND `order_id` = ? AND `item_option` = ?",array($sku,$sale_id,trim($option)));
	    		$has_rows = false;
	    		if ($qty == 1){
			    	$query = $this->db->query("SELECT * FROM `fnb_delivery_order_items` WHERE `item_sku` = ? AND `order_id` = ? AND `item_option` = ?",array($sku,$sale_id,trim($option)));
			    	if ($query->num_rows()) $has_rows = true;
			    	$has_rows = false;
	    		}
	    		$has_rows = false;
	    		if (!$has_rows){
		    		// If not yet ordered, create new order entry
	    			$sql = $this->db->insert_string('fnb_delivery_order_items',array(
	    				'order_id'		=> $sale_id,
	    				'item_id'		=> $item->id,
	    				'datetime'		=> date('Y-m-d H:i:s'),
	    				'item_sku'		=> $sku,
	    				'item_name'		=> $item->name,
	    				'item_option'	=> $option,
	    				'qty'			=> $qty,
	    				'price_per_unit'=> $price,
	    				'printed'		=> 1,
	    				'terminal'		=> $this->user->terminal(),
	    				'ordered_by'	=> $this->user->data('username'),
	    				'ordered_time'	=> date('Y-m-d H:i:s'),
	    				'amount'		=> $price * $qty
	    			));
	    			$this->db->query($sql);
	    			
	    		} else {
	    			// If already ordered, retrieve the ordered item
	    			$existing_item = $query->row();
					// Update the amount and quantity
	    			$sql = $this->db->update_string('fnb_delivery_order_items',array(
	    				'qty'			=> $existing_item->qty + $qty,
	    				'amount'		=> $price * ($existing_item->qty + $qty)
	    			),"`id` = '{$existing_item->id}'");

	    			$this->db->query($sql);
	    		}
	    	}
	    	
	    	// If table number is unknown
	    	if (!$table_no){
	    		// Query from table queue
		    	$query = $this->db->query("SELECT * FROM `fnb_delivery_order_items` WHERE `id` = ?", array($sale_id));
				$sale = $query->row();
				$table_no = $sale->table_no;
			}
			
			// Add to printing queue by category
			$item->qty = $qty;
			$item->option = $option;
			
			$query = $this->db->query("SELECT * FROM `fnb_printer_map` WHERE FIND_IN_SET(?,`categories`)", array($item->category));
			$printer_data = $query->row();
			
			if ($item->printer){
				$printer_item[$item->printer][] = $item;
			} else {
				$printer_item[$printer_data->printer_ip][] = $item;
			}
			
		}
		
		$employee = $this->user->check_session();
		

		
		// Loop for each printer item by category
		foreach ($printer_item as $printer => $items){
			// Query printer map data by categores
				
			// Get computer name
			// $comp_name = gethostbyaddr($_SERVER['SERVER_ADDR']); 
			
			// Prepare printing content
			$content = date('H:i:s d/m/Y') . "\nTable no #" . $table_no . " - " . $employee->username  .  "\n";
			
			// Loop for each items
			foreach ($items as $item){
				// Add to content
				$content .= $item->qty . ' x ' . $item->name;
				if ($item->option) $content .= " - " . str_replace('_', ' ',$item->option);
				$content .= "\n";
			}

			// Increment queue number
			$this->qn++;
				
			// Reset queue number if greater than 50
			if ($this->qn > 50){
				$this->qn = 0;
			}
			
			// Set the current queue number to session
			$this->session->set_userdata(array('qn'=>$this->qn));
			
			

			if ($table_no != 'IS'){
				// Write the file
				if (write_file('./queues/queue'.$this->qn.'.txt', $content)){
					// Send to print
					$exec_str = "print /d:\\\\".$comp_name."\\".$printer. ' C:\xampp\htdocs\fnb\queues\queue'.$this->qn.'.txt';
					echo $exec_str;
					exec($exec_str);
				}
			}


		}
		// Update the amount
		$this->Update_amount($sale_id);
		
	}
	
	
	// Get online order list
	function Get_delivery_list(){
		// Within 24 hours 
		$then = date('Y-m-d H:i:s',time() - (24 * 60 * 60));
		$now = date('Y-m-d H:i:s');
	
		// Query completed table queue and order by date and time
		$query = $this->db->query("SELECT * FROM `fnb_delivery_orders` WHERE `status` <> 'Delivered' ORDER BY `datetime` ASC",array($then,$now));
		
		$currency = $this->system->config('currency');
		
		// Loop for each table queue
		foreach ($query->result() as $queue){
			// Prepare output for table queue history list
    		$time = date('h:iA',strtotime($queue->datetime));
    		// $total_items = $this->get_total_items($queue->id);
    		
    		$data = json_decode($queue->order_data);
    		
    		$online = $queue->online ? 'Online ' : '';
    		
    		$output .= "<li id=\"{$queue->id}\" style=\"width: 95%\">
    				<strong>{$online}Order #{$queue->id}</strong>
    				<table>
    					<tr>
    						<td style=\"vertical-align: top; width: 100px\"><b>Amount</b></td>
    						<td style=\"vertical-align: top\">{$currency}{$queue->amount}</td>
    					</tr>
    					<tr>
    						<td style=\"vertical-align: top\"><b>Time</b></td>
    						<td style=\"vertical-align: top\">{$time}</td>
    					</tr>
    					<tr>
    						<td style=\"vertical-align: top\"><b>Customer</b></td>
    						<td style=\"vertical-align: top\">{$data->name} ({$data->email})</td>
    					</tr>
    					<tr>
    						<td style=\"vertical-align: top\"><b>Mobile</b></td>
    						<td style=\"vertical-align: top\">{$data->mobile}</td>
    					</tr> 
    					<tr>
    						<td style=\"vertical-align: top\"><b>Address</b></td>
    						<td style=\"vertical-align: top\">{$data->address}, {$data->zipcode} {$data->city}, {$data->state}</td>
    					</tr>	
    				</table>


    			</li>";
    	}
    	
    	// Return result and list
    	$obj['status'] = 'Success';
    	$obj['html'] = $output;
    	
    	echo json_encode($obj);
	}
	
	// Get history list
	function Get_history_list(){
		// Within 24 hours 
		if ($date = $this->input->post('date')){
			$then = date('Y-m-d H:i:s', strtotime($date . ' 00:00:00'));
			$now = date('Y-m-d H:i:s', strtotime($date . ' 23:59:59'));
			
		} else {		
			$then = date('Y-m-d H:i:s',time() - (24 * 60 * 60));
			$now = date('Y-m-d H:i:s');
		}
		
		$currency = $this->system->config('currency');
	
		// Query completed table queue and order by date and time
		$query = $this->db->query("
				SELECT * FROM `fnb_buffer_sales` WHERE `type` = 'history' AND `datetime` >= ? AND `datetime` <= ?
			UNION
				SELECT * FROM `fnb_sales` WHERE `type` = 'history' AND `datetime` >= ? AND `datetime` <= ?
			ORDER BY `datetime` DESC",array($then,$now, $then, $now));
		
		// Loop for each table queue
		foreach ($query->result() as $queue){
			// Prepare output for table queue history list
    		$time = date('h:iA',strtotime($queue->datetime));
    		// $total_items = $this->get_total_items($queue->id);
    		
    		$output .= "<li id=\"{$queue->id}\">
    				<strong>{$queue->table_no}</strong><span class=\"gt\">{$currency}{$queue->amount}</span><br />{$time}
    			</li>";
    	}
    	
    	// Return result and list
    	$obj['status'] = 'Success';
    	$obj['html'] = $output;
    	
    	echo json_encode($obj);
	}
	
	function Check_table($table_no){
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `table_no` = ? AND `type` = 'queue'", array($table_no));
		if ($query->num_rows()){
			$sale = $query->row();
			$obj['exists'] = true;
			$obj['sale_id'] = $sale->id;
		} else {
			$obj['exists'] = false;
		}
		
		$obj['status'] = 'Success';
		echo json_encode($obj);
	}

	
	// Get item list by queue id
	function Get_item_list($queue_id){
		
		if (!$queue_id || $queue_id == 0){
			$obj['amount'] 			= str_replace(',','',number_format($amt,2));	
		    $obj['table_no'] 		= '';
		    $obj['status'] 			= 'Success';
		    $obj['subtotal']		= 0.00;
		    $obj['amount']			= 0.00;
		    $obj['discounted']		= '';
	    	$obj['discount']		= '';
			$obj['discount_type'] 	= '';
			$obj['tax_breakdown']	= json_decode($sale->taxes);
			$obj['taxes']			= 0;
			$obj['adjustment'] 		= 0;
		    $obj['html'] 			= '';
		    $obj['customer']		= '';
		    
			echo json_encode($obj);	
			
			return;
		}
		
	    $amt = $this->Update_amount($queue_id);

		// Query queue by id
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?",array($queue_id));
		$sale = $query->row();
		
	    // Queue ordered items by queue id
	    $query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? ORDER BY `id` DESC",array($queue_id));
	    
		if (!$sale->id){
			$query = $this->db->query("SELECT * FROM `fnb_sales` WHERE `id` = ?",array($queue_id));
			$sale = $query->row();
			
			$query = $this->db->query("SELECT * FROM `fnb_sale_items` WHERE `sale_id` = ? ORDER BY `id` DESC",array($queue_id));			
		}
	    

	    
	    // Loop for each ordered item
	    


	    foreach ($query->result() as $item){
		    
		    
		    
		    
			$no_item = false;
			
	    	if ($item->item_sku == '_SC'){
			    $item->item_option = '';
	    	}
	    	
	    	if ($item->discount != 0){
		    	$discount = ' -' . $item->discount . '%';
	    	} else {
		    	$discount = '';
	    	}

			// Prepare item display
	    	if ($item->item_option){
		    	if ($item->instant_sale){
			    	$takeaway = ' (Takeaway)';
		    	} else {
			    	$takeaway = '';
		    	}
	    		$display_name = $item->item_name . ' - ' . str_replace('_',' ', $item->item_option) . $takeaway . $discount;
	    	} else {
		    	if ($item->instant_sale){
			    	$takeaway = ' (Takeaway)';
		    	} else {
			    	$takeaway = '';
		    	}
	    		$display_name = $item->item_name . $takeaway . $discount;					
	    	}
	    	
	    	$printed = $item->printed ? '' : 'unverified';
	    	
	    	// Check device for different output
	    	if ($this->session->userdata('device') == 'iphone'){
	    		// iPhone output
	    		
	    		if ($item->item_sku == '_SC'){
		    		
					$sc .= "<li id=\"{$item->id}\" class=\"{$printed}\">
						<span style=\"float:right; font-weight: bold\">{$item->qty}</span>
						{$display_name}
					</li>";

		    		
	    		} else {

					$output .= "<li id=\"{$item->id}\" class=\"{$printed}\">
						<span style=\"float:right; font-weight: bold\">{$item->qty}</span>
						{$display_name}
					</li>";
				}

	    	} else {
	    		// Terminal output
	    		
	    		if ($item->item_sku == '_SC'){
		    		$time = date('h:iA d/m/Y',strtotime($item->ordered_time));
			    	$sc .= "<li price=\"{$item->amount}\" title=\"Ordered by {$item->ordered_by} at {$time}\" id=\"{$item->id}\" rel=\"{$item->id}\" class=\"main {$printed}\">
			    		<table class=\"vui-dt-row\">
			    			<tr>
				    			<td class=\"item-name\" style=\"width: 55%\"><strong style=\"font-size: 10pt\">{$display_name}</strong></td>
				    			<td class=\"item-qty\" style=\"width: 22%; text-align: center;\">{$item->qty}</td>
				    			<td class=\"item-amount\" style=\"width: 23%; text-align: right;\">{$item->amount}</td>
				    		</tr>
			    		</table>
			    		</li>";
		    		
		    	} else {
			    	$time = date('h:iA d/m/Y',strtotime($item->ordered_time));
			    	$output .= "<li price=\"{$item->amount}\" title=\"Ordered by {$item->ordered_by} at {$time}\" id=\"{$item->id}\" rel=\"{$item->id}\" class=\"main {$printed}\">
			    		<table class=\"vui-dt-row\">
			    			<tr>
				    			<td class=\"item-name\" style=\"width: 55%\"><strong style=\"font-size: 10pt\">{$display_name}</strong></td>
				    			<td class=\"item-qty\" style=\"width: 22%; text-align: center;\">{$item->qty}</td>
				    			<td class=\"item-amount\" style=\"width: 23%; text-align: right;\">{$item->amount}</td>
				    		</tr>
			    		</table>
			    		</li>";

		    	}
		    }
	    }
	    
	    $output .= $sc;
	    
	    // Return result
		$obj['amount'] 			= str_replace(',','',number_format($amt,2));
		
		// Query queue by id
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?",array($queue_id));
		$sale = $query->row();

	    $obj['table_no'] 		= $sale->table_no;
	    $obj['table_card_no'] 	= $sale->table_card_no;
	    $obj['status'] 			= 'Success';
	    $obj['subtotal']		= str_replace(',','',number_format($sale->subtotal,2));
	    $obj['amount']			= $sale->amount;
	    $obj['discounted']		= $sale->amount_discount;
    	$obj['discount']		= $d = $sale->discount == 'undefined' ? 0 : $sale->discount;
		$obj['discount_type'] 	= $d ? $sale->discount_type : '';
		$obj['tax_breakdown']	= json_decode($sale->taxes);
		$obj['taxes']			= $sale->tax_amount;
		$obj['adjustment'] 		= $sale->adjustment;
	    $obj['html'] 			= $output;
	    $obj['customer']		= $sale->customer;

	    echo json_encode($obj);
	}
	
	
	function Get_delivery_item_list($queue_id){

		// Query queue by id
		$query = $this->db->query("SELECT * FROM `fnb_delivery_orders` WHERE `id` = ?",array($queue_id));
		$sale = $query->row();
	    
	    // Queue ordered items by queue id
	    $query = $this->db->query("SELECT * FROM `fnb_delivery_order_items` WHERE `order_id` = ?",array($queue_id));
	    
	    // Loop for each ordered item

	    foreach ($query->result() as $item){
			$no_item = false;
			// Prepare item display
	    	if ($item->item_option){
	    		$display_name = $item->item_name . ' - ' . str_replace('_',' ', $item->item_option);
	    	} else {
	    		$display_name = $item->item_name;					
	    	}
	    	
	    	// Check device for different output
	    	if ($this->session->userdata('device') == 'iphone'){
	    		// iPhone output
				$output .= "<li id=\"{$item->id}\">
						<span style=\"float:right; font-weight: bold\">{$item->qty}</span>
						{$display_name}
					</li>";

	    	} else {
	    		// Terminal output
	    		$time = date('h:iA d/m/Y',strtotime($item->ordered_time));
		    	$output .= "<li title=\"Ordered by {$item->ordered_by} at {$time}\" id=\"{$item->id}\" rel=\"{$item->id}\" class=\"main\"><table class=\"vui-dt-row\"><tr>
			    		<td class=\"item-name\" style=\"width: 55%\"><strong style=\"font-size: 10pt\">{$display_name}</strong></td>
		    			<td class=\"item-qty\" style=\"width: 22%; text-align: center;\">{$item->qty}</td>
			    		<td class=\"item-amount\" style=\"width: 23%; text-align: right;\">{$item->amount}</td>
		    		</tr></table></li>";
		    }
	    }
	    
	    // Return result
	    $obj['table_no'] = $sale->table_no;
	    $obj['status'] = 'Success';
	    $obj['amount_discount'] = $sale->amount_discount;
	    $obj['discount'] = $sale->discount;
	    $obj['amount'] = $sale->amount;
	    $obj['html'] = $output;
	    
	    echo json_encode($obj);
	}

	
	// Checkout split bill
	function Checkout_split_bill($queue_id, $ids, $qtys, $prices, $amount_tendered, $discount){
		
	    // Check if discount is not set. Set to 0 if null
	    if (!$discount) $discount = 0;
	    				
	    // Query queue from queue_id
	    $query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?",array($queue_id));
	    $queue = $query->row();
	    
		$this->db->update('fnb_buffer_sales', array(
			'table_no'	=> str_replace('(S)', '', $queue->table_no) . '(S)'
		), array(
			'id'		=> $queue_id
		));
	    
	    // Create new queue from the same table number
	    $sql = $this->db->insert_string('fnb_buffer_sales',array(
	    	'type'				=> 'queue',
	    	'payment_status' 	=> 'Unpaid',
	    	'table_no'			=> str_replace('(S)', '', $queue->table_no) . '(S)',
	    	'username'			=> $this->user->data('username'),
	    	'user_id'			=> $this->user->data('id'),
	    	'terminal'			=> $this->user->terminal(),
	    	'session'			=> $this->user->data('terminal_session')
	    ));
	    $query = $this->db->query($sql);
	    
	    // Get the new queue id
	    $new_queue_id = $query->insert_id;
	    
	    // Check split items, quantities and prices
	    if (strpos($ids, ',')){
	    	$id_array = explode(',',$ids);
	    	$qty_array = explode(',',$qtys);
	    	$price_array = explode(',', $prices);
	    } else {
	    	$id_array[0] = $ids;
	    	$qty_array[0] = $qtys;
	    	$price_array[0] = $prices;
	    }
	    
	    // Loop for each split items
	    for ($i = 0; $i < count($id_array); $i++){
	    	// Get the quantity, item id and price
	    	$qty = $qty_array[$i];
	    	$id = $id_array[$i];
	    	$price = $price_array[$i];
	    	
	    	// Query the ordered item by id
	    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `id` = ?", array($id));
	    	$sale_item = $query->row();
	    	
	    	// Query the item from items database
	    	$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `sku` = ?",array($sale_item->item_sku));
	    	$item = $query->row();

	    	// Create new ordered item for the new queue
	    	$sql = $this->db->insert_string('fnb_buffer_sale_items', array(
	    		'sale_id'		=> $new_queue_id,
	    		'item_id'		=> $sale_item->item_id,
	    		'date'			=> date('Y-m-d'),
	    		'item_sku'		=> $sale_item->item_sku,
	    		'item_name'		=> $sale_item->item_name,
	    		'item_option'	=> $sale_item->item_option,
	    		'si_item_id'	=> $sale_item->si_item_id,
	    		'category'		=> $item->category,
	    		'subcategory'	=> $item->subcategory,
	    		'qty'			=> $qty,
	    		'printed'		=> $sale_item->printed,
	    		'price_per_unit'=> $sale_item->price_per_unit,
	    		'terminal'		=> $this->user->terminal(),
	    		'ordered_by'	=> $sale_item->ordered_by,
	    		'ordered_time'	=> $sale_item->ordered_time,
	    		'serial'		=> $sale_item->serial,
	    		'taxable'		=> $sale_item->taxable,
	    		'tax_code'		=> $sale_item->tax_code,
	    		'amount'		=> $price,
	    		'warehouse_id'	=> $sale_item->warehouse_id,
	    		'instant_sale'	=> $sale_item->instant_sale,
	    		'discount'		=> $sale_item->discount
	    	));
	    	$this->db->query($sql);
	    	
	    	// New quantity after deduction from the main queue
	    	$new_qty = $sale_item->qty - $qty;
	    	
			// Check if new queue is 0
	    	if ($new_qty == 0){
	    		// If 0 then remove from the previous queue as it is already been paid from the split bill
	    		$this->db->query("DELETE FROM `fnb_buffer_sale_items` WHERE `id` = ?", array($id));
	    	
	    	} else {
	    		// If not 0, update the quantity
	    		$sql = $this->db->update_string('fnb_buffer_sale_items',array(
	    			'qty'			=> $new_qty,
	    			'terminal'		=> $this->user->terminal(),
	    			'amount'		=> $sale_item->amount - $price
	    		),"`id` = '$id'");
	    	
	    		$this->db->query($sql);
	    	
	    	}
	    }
	    
	    
	    // Update the split table queue amount
	    $amount = $this->update_amount($new_queue_id, true);
	    

	    // Save sale transaction
	    $sql = $this->db->update_string('fnb_buffer_sales',array(
	    	'datetime'			=> date('Y-m-d H:i:s')
	    ),"`id` = '$new_queue_id'");
	    $this->db->query($sql);
	    
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?", array($queue_id));
		if (!$query->num_rows()){
			$this->db->query("DELETE FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
			$obj['cleared'] = true;
		}

		
	    // Update the table queue amount after split
	    $this->update_amount($queue_id, true);

		
	    $obj['amount'] 		= $amount;
	    $obj['tendered'] 	= number_format($amount_tendered,2);
	    $obj['change'] 		= number_format($amount_tendered - $discounted,2);
	    $obj['status'] 		= 'Success';
	    $obj['queue_id'] 	= $new_queue_id;
	    echo json_encode($obj);

	}
	
	// Update the amount of the table queue
	function Update_amount($queue_id, $split){
		
		if ($split){
			$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `item_sku` = '_SC' AND `sale_id` = ?", array($queue_id));
			if (!$query->num_rows()){
				$sc = $this->system->config('fnbpos_service_charge');
				
				if ($sc){
				
				$this->db->insert('fnb_buffer_sale_items',array(
					'sale_id'		=> $queue_id,
					'item_id'		=> 0,
					'si_item_id'	=> 0,
					'date'			=> date('Y-m-d H:i:s'),
					'item_sku'		=> '_SC',
					'item_name'		=> 'Service Charge (' . $sc . '%)',
					'item_option'	=> '',
					'category'		=> 'SERVICE CHARGE',
					'subcategory'	=> 'SERVICE CHARGE',
					'qty'			=> 1,
					'price_per_unit'=> 0,
					'printed'		=> 1,
					'terminal'		=> $this->user->terminal(),
					'ordered_by'	=> $this->user->data('username'),
					'ordered_time'	=> date('Y-m-d H:i:s'),
					'cost'			=> 0,
					'margin'		=> 0,
					'amount'		=> 0,
					'serial'		=> 0,
					'taxable'		=> 1,
					'tax_code'		=> 'SR',
					'warehouse_id'	=> $this->user->data('branch')
				));
				
				}
			}
			
		}
		
		// Query the amount
		$query = $this->db->query("SELECT SUM(`amount`) AS `total`, SUM(`cost`) AS `total_cost` FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? AND `item_sku` != '_SC' GROUP BY `sale_id`", array($queue_id));
		$items_amount = $query->row();
		
		$query = $this->db->query("SELECT SUM(`amount`) AS `total`, SUM(`cost`) AS `total_cost` FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? AND `item_sku` != '_SC' AND `instant_sale` IS NULL GROUP BY `sale_id`", array($queue_id));
		$items_amount_is = $query->row();


		if ($sc = $this->system->config('fnbpos_service_charge')){
			if ($this->system->config('fnbpos_no_sc_is')){
				$src = $items_amount_is->total * $sc / 100;											
			} else {
				$src = $items_amount->total * $sc / 100;				
			}

			$this->db->query("UPDATE `fnb_buffer_sale_items` SET `price_per_unit` = ?, `amount` = ? WHERE `sale_id` = ? AND `item_sku` = '_SC'", array($src, $src, $queue_id));
		}
		
	
		$query = $this->db->query("SELECT SUM(`amount`) AS `total`, SUM(`cost`) AS `total_cost` FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? GROUP BY `sale_id`", array($queue_id));
		$amount = $query->row();
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
		$sale = $query->row();
		
	   	$query = $this->db->query("SELECT SUM(`amount`) AS `total` FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? AND `taxable` = 1 GROUP BY `sale_id`", array($queue_id));
    	$taxable = $query->row();
		
		$discount = $sale->discount;
    	$dtype = $sale->discount_type;

		$final = $amount->total;
		
		$amount = $final;
		
    	$subtotal = $final;

    	if ($discount){
    		if ($dtype == 'p'){
    			$discount_amount = str_replace(',','',number_format($final * $discount / 100,2));
    			$final -= $discount_amount;
    			$taxable->total = str_replace(',','',number_format($taxable->total * ((100 - $discount) / 100),2));
    		} else {
    			$final = str_replace(',','',number_format($final - $discount,2));
    			$discount_amount = str_replace(',','',number_format($discount,2));
    			$taxable->total = str_replace(',','',number_format($taxable->total - $discount_amount,2));
    		}
    	}

		$taxes = $this->tax->get_enabled_taxes();
    	
    	foreach ($taxes as $tax){
		
	    	if ($tax->name == 'GST' || $tax->name == 'VAT'){
		    	if ($tax->inclusive){
	    			$sale_tax->amount = number_format($tax_amount = ($tax->percentage / (100+$tax->percentage) * $taxable->total), 2);
	    		} else {
		    		$sale_tax->amount = number_format($tax_amount = ($tax->percentage / 100 * $taxable->total), 2);
	    		}
	    		$sale_tax->name = $tax->name;
				$sale_tax->percentage = $tax->percentage;
				$sale_tax->id = $tax->id;
				$sale_tax->inclusive = $tax->inclusive;

				$taxes_amount += $tax_amount;				
				if (!$tax->inclusive){
					$add_amount += $tax_amount;
				}
	    	} else {
		    	
				$sale_tax->amount = number_format($tax_amount = ($tax->percentage / 100 * $final), 2);
				$sale_tax->name = $tax->name;
				$sale_tax->percentage = $tax->percentage;
				$sale_tax->id = $tax->id;
				$sale_tax->inclusive = $tax->inclusive;
				
				$taxes_amount += $tax_amount;
				
				if (!$tax->inclusive){
					$add_amount += $tax_amount;
				}
				
	    	}
	    	
	    	$sale_taxes[] = $sale_tax;

    	}
    	
    	$final = $final + $add_amount;
    	
    	if ($this->system->config('rounding_adjust')){
    		list($ones, $cents) = explode('.',str_replace(',','',number_format($final,2)));
    		
    		if ($cents[1] == 1){
    			$cents -= 1;
    			$adjustment = -1;
    		} elseif ($cents[1] == 2){
    			$cents -= 2;
    			$adjustment = -2;
    		} elseif ($cents[1] == 3){
    			$cents += 2;
    			$adjustment = 2;
    		} elseif ($cents[1] == 4){
    			$cents += 1;
    			$adjustment = 1;
    		} elseif ($cents[1] == 6){
    			$cents -= 1;
    			$adjustment = -1;
    		} elseif ($cents[1] == 7){
    			$cents -= 2;
    			$adjustment = -2;
    		} elseif ($cents[1] == 8){
    			$cents += 2;
    			$adjustment = 2;
    		} elseif ($cents[1] == 9){
    			$cents += 1;
    			$adjustment = 1;
    		} else {
    			$adjustment = 0;
    		}
    	} else {
    		$adjustment = 0;
    	}
    	
    	$final = $final + ($adjustment / 100);
		
		// Update the amount
		$sql = $this->db->update_string('fnb_buffer_sales',array(
			'subtotal'			=> $items_amount->total,
			'amount'			=> $final,
			'amount_discount'	=> $discount_amount,
    		'taxes'				=> json_encode($sale_taxes),
    		'taxable_amount'	=> $taxable_amount->total,
    		'tax_amount'		=> $taxes_amount,
    		'cost'				=> $amount->total_cost,
    		'adjustment'		=> $adjustment / 100
		),"`id` = '$queue_id'");
		$this->db->query($sql);
		
		// Return the amount
		return $final;
	}
	
	function Update_delivery_amount($queue_id){
		// Query the amount
		$query = $this->db->query("SELECT SUM(`amount`) AS `total` FROM `fnb_delivery_order_items` WHERE `order_id` = ? GROUP BY `order_id`", array($queue_id));
		$amount = $query->row();
		
		// Update the amount
		$sql = $this->db->update_string('fnb_delivery_orders',array(
			'amount'	=> $amount->total
		),"`id` = '$queue_id'");
		$this->db->query($sql);
		
		// Return the amount
		return $amount->total;
	}

	
	// Get total items by table queue
	function Get_total_items($queue_id){
		// Query all ordered items
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ?",$queue_id);
		return $query->num_rows();
	}
	
	// Get active tables
	function Active_tables(){
	
		// Retrieve battery level 
		$battery_level = $this->input->post('battery_level');

	
		// Query all table queues that are still active
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `type` = 'queue' AND `table_no` != 'IS' ORDER BY `verified` ASC, `table_no` ASC", array());
		
		$currency = $this->system->config('currency');
		$display_mode = $this->system->config('fnbpos_mtd_mode');
		
		if ($display_mode == 'numeric'){
			$regex = '/^[0-9]+/';
		} elseif ($display_mode == 'alphanumeric'){
			$regex = '/^((?=.*[0-9])(?=.*[a-zA-Z])([a-zA-Z0-9]+))|([0-9]+)$/';
		}
		
		

		// Prepare output
		foreach ($query->result() as $queue){
		
			if ($display_mode == 'any' || !$display_mode){
				$passed = true;
			} else {
				if (preg_match($regex, $queue->table_no)){
					$passed = true;
				} else {
					$passed = false;
				}
			}
			
			
			if ($passed){
				$unverified = $queue->verified ? '' : 'unverified';
				
				if ($queue->table_no == $queue->table_card_no){
					$queue->table_no = '<button class="assign-card" rel="'.$queue->id.'" style="width: 70px; margin-top: -7px; margin-right: 10px; float: left">Assign</button> Card ' . $queue->table_no;					
				} else {
					$queue->table_no = 'Table ' . $queue->table_no;
				}
			
				if ($queue->amount){
					
					$output .= "<li id=\"{$queue->id}\" class=\"{$unverified}\">
						<span class=\"price\">{$currency}{$queue->amount}</span>
						<strong>{$queue->table_no}</strong> 
						</li>";
				} else {
					$output .= "<li id=\"{$queue->id}\" class=\"{$unverified}\">
						<span class=\"price\">{$currency}0.00</span>
						<strong>{$queue->table_no}</strong>
						</li>";
				}
			}
		}
		
			
		// Return result
		$obj['status'] = 'Success';
		$obj['html'] = $output;
				
		echo json_encode($obj);
	}

	// Process order
	function Submit_order($sku, $option, $price, $qty, $sale_id){
		
		session_start();
		
		$r = $_REQUEST;
		
		unset($r['PHPSESSID']);
		unset($r['_ga']);
		unset($r['ci_session']);
		unset($r['serial']);
		
		$sid = md5(json_encode($r));
		
		
		$last_sid = $_SESSION['last_sid'];
		$last_sid_time = $_SESSION['last_sid_time'];
		
		echo $sid . "\n";
		echo $last_sid . "\n";
		echo time() - $last_sid_time . "\n";
		
		
		if ($last_sid == $sid){
			if (time() - $last_sid_time < 15){
				return;
			}
		}
		
		$_SESSION['last_sid'] = $sid;
		$_SESSION['last_sid_time'] = time();


		
		
		// Retrieve all data from iphone order submission
		if (!$sku) $skus = $this->input->post('sku');
		else $skus = $sku;
		
		if (!$option) $options = $this->input->post('option');
		else $options = $option;
		
		if (!$price) $prices = $this->input->post('price');
		else $prices = $price;
		
		if (!$qty) $qtys = $this->input->post('qty');
		else $qtys = $qty;
		
		if (!$sale_id) $sale_id = $this->input->post('sale_id');
		
		$serial = $this->user->data('username') . '-' . $this->user->data('terminal_session') . '-' .  $this->input->post('serial');
				
		if (!$skus) return;

		$fcli = $cli = $this->system->config('fnbpos_print_cli');
		$paper_size = $this->system->config('fnbpos_print_paper_size');
		
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?",array($sale_id));
		$sale = $query->row();


		
		
		// Check if there are multiple items
		if (strpos($skus,',')){
			// Populate in arrays
			$skus_array = array_reverse(explode(',', $skus));
			$options_array = array_reverse(explode('|',$options));
			$prices_array = array_reverse(explode(',', $prices));
			$qtys_array = array_reverse(explode(',', $qtys));
		} else {
			// Populate in array
			$skus_array[0] = $skus;
			$options_array[0] = $options;
			$prices_array[0] = $prices;
			$qtys_array[0] = $qtys;
			
		}
		

		
		$this->load->helper('dompdf');

		
		// Loop for each item array
		for ($i = 0; $i < count($skus_array); $i++){
		

			
			$sku = $skus_array[$i];
			$option = trim($options_array[$i]);
			$price = $prices_array[$i];
			$qty = $qtys_array[$i];
			
			// Split item options
			$option_array = explode(',', $option);
			
			// Sort the options 
			sort($option_array);
			
			// Join the array into string to obtain identifiable option name
			$option = implode(',',$option_array);
			
			// Get item from items database
			$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `sku` = ?",array($sku));
			$item = $obj = $query->row();
			

									
			// If item exists
			if ($query->num_rows()){
	    		// Check if already ordered
	    		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `item_sku` = ? AND `sale_id` = ? AND `item_option` = ?",array($sku,$sale_id,trim($option)));
	    		$has_rows = false;
	    		if ($qty == 1){
			    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `item_sku` = ? AND `sale_id` = ? AND `item_option` = ?",array($sku,$sale_id,trim($option)));
			    	if ($query->num_rows()) $has_rows = true;
			    	$has_rows = false;
	    		}
	    		
	    		if ($item->si_item_id){
		    		$query = $this->db->query("SELECT * FROM `inventory_stock_quantities` WHERE `item_id` = ?", array($item->si_item_id));
		    		$inv_item = $query->row();
		    		
		    		$inv_item_ids[] = $inv_item->item_id;
		    		
    				if ($this->system->config('cost_update_method') == 'fifo'){
    					$item_cost = $this->inv->get_fifo_cost($item->id, $qty);
    				} else {
    					$item_cost = $this->inv->get_isq_cost($item->id) * $qty;
    				}

	    		} else {
		    		$item_cost = 0;
	    		}

	    		
	    		$has_rows = false;
	    		if (!$has_rows){
		    		// If not yet ordered, create new order entry
		    		if ($sale->table_no == 'IS'){
			    		$instant_sale = 1;
		    		} else {
			    		$instant_sale = null;
		    		}
		    		
		    		$sql = $this->db->insert_string('fnb_buffer_sale_items',array(
		    	    	'sale_id'		=> $sale_id,
		    	    	'item_id'		=> $item->id,
		    	    	'si_item_id'	=> $item->si_item_id,
		    	    	'date'			=> date('Y-m-d H:i:s'),
		    	    	'item_sku'		=> $sku,
		    	    	'item_name'		=> $item->name,
		    	    	'item_option'	=> $option,
		    	    	'category'		=> $item->category,
		    	    	'subcategory'	=> $item->subcategory,
		    	    	'qty'			=> $qty,
		    	    	'price_per_unit'=> $price,
		    	    	'printed'		=> 1,
		    	    	'terminal'		=> $this->user->terminal(),
		    	    	'ordered_by'	=> $this->user->data('username'),
		    	    	'ordered_time'	=> date('Y-m-d H:i:s'),
		    	    	'cost'			=> $item_cost,
		    	    	'margin'		=> ($price * $qty) - $item_cost,
		    	    	'amount'		=> $price * $qty,
		    	    	'serial'		=> $serial,
		    	    	'taxable'		=> $item->supply_taxable,
		    	    	'tax_code'		=> $item->supply_tax_code,
		    	    	'warehouse_id'	=> $this->user->data('branch'),
		    	    	'instant_sale'	=> $instant_sale
		    	    ));
		    	    $this->db->query($sql);
		    			
	    			
	    			
	    		} else {
	    			// If already ordered, retrieve the ordered item
	    			$existing_item = $query->row();
					// Update the amount and quantity
	    			$sql = $this->db->update_string('fnb_buffer_sale_items',array(
	    				'qty'			=> $existing_item->qty + $qty,
	    				'amount'		=> $price * ($existing_item->qty + $qty)
	    			),"`id` = '{$existing_item->id}'");

	    			$this->db->query($sql);
	    		}
	    	}
	    	
	    	// If table number is unknown
	    	if (!$table_no){
	    		// Query from table queue
		    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($sale_id));
				$sale = $query->row();
				$table_no = $sale->table_no;
			}
			
			// Add to printing queue by category
			$item->qty = $qty;
			$item->item_sku = $sku;
			$item->option = $option;
			
			$query = $this->db->query("SELECT * FROM `fnb_printer_map` WHERE FIND_IN_SET(?,`categories`)", array($item->category));
			$printers_data = $query->result();
			
			if ($this->system->config('fnb_print_items_individually')){
				$individual_items = true;	
			}

			
			foreach ($printers_data as $printer_data){
				
				$xv++;
				
				if ($individual_items){
					$snum = '#' . $xv;
				} else {
					$snum = '';
				}
				
				
				if (strpos($item->printer, ',')){
					foreach (explode(',',$item->printer) as $printer){
						if ($printer_data->waiter_copy){
							$copy_printer_item[$printer.$snum][] = $item;
						} else {
							$printer_item[$printer.$snum][] = $item;							
						}
					} 
				} else {
					if ($item->printer){
						$printer_item[$item->printer][] = $item;
					} else {
						if ($printer_data->waiter_copy){
							if ($printer_data->printer_ip) $copy_printer_item[$printer_data->printer_ip.$snum][] = $item;	
						} else {
							if ($printer_data->printer_ip) $printer_item[$printer_data->printer_ip.$snum][] = $item;
						}
					}
				}
			}
			
		}
		
		
		print_r($printer_item);
		
		
		
		
		$employee = $this->user->check_session();
		
		// Update the amount
		$this->Update_amount($sale_id);

		$order_data = null;
		
				
		// Loop for each printer item by category
		foreach ($printer_item as $printer => $items){
			// Query printer map data by categores
				
			// Get computer name
			if ($individual_items){
				list($printer, $snum) = explode('#', $printer);
			}
			
			// Prepare printing content
			$content = date('H:i:s d/m/Y') . "\nTable no #" . $table_no . " - " . $employee->username  .  "\n";
			
			$order_data = null;
			$order_data_items = null;
			
			$order_data['table_no'] = $table_no;
			$order_data['employee'] = $employee->username;
			$order_data['datetime'] = date('H:i:s d/m/Y');
			$order_data['pax_no'] 	= $sale->no_of_pax;
			
			// Loop for each items
			foreach ($items as $item){
				$order_data_item = null;
				
				// Add to content
				$content .= $item->qty . ' x ' . $item->name;
				if ($item->option) $content .= " - " . str_replace('_', ' ',$item->option)  . ($item->instant_sale ? ' (Takeaway)' : '');;
				$content .= "\n";
				
				$order_data_item->qty = $item->qty;
				$order_data_item->category = $item->category;
				$order_data_item->name = $item->name;
				$order_data_item->sku = $item->sku;
				if ($item->option) $order_data_item->option = str_replace('_', ' ',$item->option)  . ($item->instant_sale ? ' (Takeaway)' : '');;
				
				$order_data_items[] = $order_data_item;
			}
			
			$order_data['items'] = $order_data_items;

			// Increment queue number
			$this->qn++;
				
			// Reset queue number if greater than 50
			if ($this->qn > 50){
				$this->qn = 0;
			}
			
			// Set the current queue number to session
			$this->session->set_userdata(array('qn'=>$this->qn));
			
			$ok = true;
			
			if ($table_no == 'IS'){
				if ($this->system->config('print_is')){
					$ok = true;
				} else {
					$ok = false;
				}
			}

			if ($ok){
				// Write the file
				$content = $this->load->view('fnb/orderchit',$order_data,true);

					
				if ($cli[0] == '>' || $printer[0] == '>'){
					
					if ($printer){
						if ($printer[0] == '>'){
							list($cli, $printer) = explode('|', $printer);
						}
						
						$url = str_replace('>', '', $cli);						
						
						$postdata = http_build_query(
						    array(
						        'content' 	=> str_replace('<body>',"<body>Kitchen's Copy",$content),
						        'printer'	=> $printer,
						        'paper_size'=> $paper_size,
						        'qn'		=> $this->qn
						    )
						);
						
						$opts = array('http' =>
						    array(
						        'method'  => 'POST',
						        'header'  => 'Content-type: application/x-www-form-urlencoded',
						        'content' => $postdata
						    )
						);
						
						$context  = stream_context_create($opts);
						

						$result = file_get_contents($url, false, $context);
						

					}

				} elseif (trim($cli)) {
					
					$data = pdf_create($content, ''.$this->qn, $paper_size, false);

					if (write_file('./queues/queue'.$this->qn.'.pdf', $data)){
						// Send to print
						if ($printer){
							
							$fcli = $this->system->config('fnbpos_print_cli');
							
							$exec_str = str_replace('%order%', 'queues\queue'.$this->qn.'.pdf', $fcli);
							$exec_str = str_replace('%printer_name%', $printer, $exec_str);
							
							if ($table_no == 'TEST'){
								write_file('./queues/'.$printer.'debug_cli.txt', $content);
							}							
							
							
							$this->system->set_config('last_cli', $exec_str);							
							exec($exec_str);
							

						}
					}
					
	
					

				
				} else {
					
					if (strpos($printer, '?')){
						list($printer, $opt) = explode('?', $printer);
						
						parse_str($opt);
						
						$host = $printer;
					} else {
						$host = $printer;						
					}
					
					$port = "9100";

					$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
					

					$this->load->helper('tp');
					

					$chit = process_chit($order_data, $width);
							
					$res = fopen('queues/printdebug_'.$printer.'.txt', 'w+');
					fwrite($res, $chit);
					fclose($res);	

					if ($socket === false) {
						$error = 1;
					} else {
						$result = socket_connect($socket, $host, $port);
						if ($result === false) {
							$error = 2;
						} else {
							socket_write($socket, $chit, strlen($chit));
							socket_close($socket);
						}

					}
					
				}
			}


		}
		
		
		$order_data_items = null;
		
		// Loop for each printer item by category
		foreach ($copy_printer_item as $printer => $items){
		// Query printer map data by categores
				
			// Get computer name
			
			if ($individual_items){
				list($printer, $snum) = explode('#', $printer);
			}

			
			
			// Prepare printing content
			$content = date('H:i:s d/m/Y') . "\nTable no #" . $table_no . " - " . $employee->username  .  "\n";
			
			$order_data = null;
			$order_data_items = null;
			
			$order_data['table_no'] = $table_no;
			$order_data['employee'] = $employee->username;
			$order_data['datetime'] = date('H:i:s d/m/Y');
			$order_data['pax_no'] 	= $sale->no_of_pax;
			
			// Loop for each items
			foreach ($items as $item){
				$order_data_item = null;
				
				// Add to content
				$content .= $item->qty . ' x ' . $item->name;
				if ($item->option) $content .= " - " . str_replace('_', ' ',$item->option)  . ($item->instant_sale ? ' (Takeaway)' : '');;
				$content .= "\n";
				
				$order_data_item->qty = $item->qty;
				$order_data_item->category = $item->category;
				$order_data_item->name = $item->name;
				$order_data_item->sku = $item->sku;
				if ($item->option) $order_data_item->option = str_replace('_', ' ',$item->option)  . ($item->instant_sale ? ' (Takeaway)' : '');;
				
				$order_data_items[] = $order_data_item;
			}
			
			$order_data['items'] = $order_data_items;

			// Increment queue number
			$this->qn++;
				
			// Reset queue number if greater than 50
			if ($this->qn > 50){
				$this->qn = 0;
			}
			
			// Set the current queue number to session
			$this->session->set_userdata(array('qn'=>$this->qn));
			
			$ok = true;
			
			if ($table_no == 'IS'){
				if ($this->system->config('print_is')){
					$ok = true;
				} else {
					$ok = false;
				}
			}
			
			$fcli = $this->system->config('fnbpos_print_cli');

			if ($ok){
				// Write the file
				$content = $this->load->view('fnb/orderchit',$order_data,true);

					
				if ($fcli[0] == '>' || $printer[0] == '>'){
					
					if ($printer){
						
						$ap = $printer;
							
						if ($printer[0] == '>'){
							list($uri, $printer) = explode('|', $printer);
						}
						
						$url = str_replace('>', '', $uri);
						
						$postdata = http_build_query(
						    array(
						        'content' 	=> str_replace('<body>',"<body>Waiter's Copy",$content),
						        'printer'	=> $printer,
						        'paper_size'=> $paper_size,
						        'qn'		=> $this->qn
						    )
						);
						
						$opts = array('http' =>
						    array(
						        'method'  => 'POST',
						        'header'  => 'Content-type: application/x-www-form-urlencoded',
						        'content' => $postdata
						    )
						);
						
						$context  = stream_context_create($opts);
						
						
						if ($table_no == 'TEST'){
							write_file('./queues/'.$printer.'debug_cli_copy.txt', str_replace('<body>',"<body>Waiter's Copy",$content));
						}	

						$result = file_get_contents($url, false, $context);
						

					}

				} elseif (trim($fcli) && !strpos($printer, '\\')) {
					
					$data = pdf_create(str_replace('<body>',"<body>Waiter's Copy",$content), ''.$this->qn, $paper_size, false);

					if (write_file('./queues/cqueue'.$this->qn.'.pdf', $data)){
						// Send to print
						
						if ($printer){
							
							
							
							$exec_str = str_replace('%order%', 'queues\cqueue'.$this->qn.'.pdf', $fcli);
							$exec_str = str_replace('%printer_name%', $printer, $exec_str);
							
							$this->system->set_config('last_cli', $exec_str);
							
							
							
							if ($table_no == 'TEST'){
								write_file('./queues/'.$printer.'debug_cli_copy.txt', str_replace('<body>',"<body>Waiter's Copy TEST $exec_str $fcli",$content));
							}							
							exec($exec_str);
							
							
						}
					}
					
	
					

				
				} else {
					
					if (strpos($printer, '?')){
						list($printer, $opt) = explode('?', $printer);
						
						parse_str($opt);
						
						$host = $printer;
					} else {
						$host = $printer;						
					}
					
					$port = "9100";

					$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
					

					$this->load->helper('tp');
					

					$chit = process_chit($order_data, $width);
							
					$res = fopen('queues/printdebug_'.$printer.'.txt', 'w+');
					fwrite($res, $chit);
					fclose($res);	

					if ($socket === false) {
						$error = 1;
					} else {
						$result = socket_connect($socket, $host, $port);
						if ($result === false) {
							$error = 2;
						} else {
							socket_write($socket, $chit, strlen($chit));
							socket_close($socket);
						}

					}
					
				}
			}


		}		
		echo 'ok';

		
	}
	
	
	
	// Process order
	function Submit_self_service_order(){
		// Retrieve all data from iphone order submission
		$skus		= $this->input->post('sku');
		$options 	= $this->input->post('option');
		$prices 	= $this->input->post('price');
		$qtys 		= $this->input->post('qty');
		$terminal 	= $this->input->post('terminal');
		
		$mtime = microtime();
		$mtime = explode(' ', $mtime);
		$mtime = $mtime[1] + $mtime[0];
		
		$barcode	= sha1(str_replace('.','',str_replace(',','',number_format($mtime,3))));
		$barcode	= mt_rand(10,99) . mt_rand(10,99) . mt_rand(10,99);
		
		$serial = $this->user->data('username') . '-' . $this->user->data('terminal_session') . '-' .  $this->input->post('serial');
				
		if (!$skus) return;

		$cli = $this->system->config('fnbpos_print_cli');
		$paper_size = $this->system->config('fnbpos_print_paper_size');
		

		
		
		// Check if there are multiple items
		if (strpos($skus,',')){
			// Populate in arrays
			$skus_array = array_reverse(explode(',', $skus));
			$options_array = array_reverse(explode('|',$options));
			$prices_array = array_reverse(explode(',', $prices));
			$qtys_array = array_reverse(explode(',', $qtys));
		} else {
			// Populate in array
			$skus_array[0] = $skus;
			$options_array[0] = $options;
			$prices_array[0] = $prices;
			$qtys_array[0] = $qtys;
			
		}
		

		
		$this->load->helper('dompdf');

		
		// Loop for each item array
		for ($i = 0; $i < count($skus_array); $i++){
		

			
			$sku = $skus_array[$i];
			$option = trim($options_array[$i]);
			$price = $prices_array[$i];
			$qty = $qtys_array[$i];
			
			// Split item options
			$option_array = explode(',', $option);
			
			// Sort the options 
			sort($option_array);
			
			// Join the array into string to obtain identifiable option name
			$option = implode(',',$option_array);
			
			// Get item from items database
			$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `sku` = ?",array($sku));
			$item = $obj = $query->row();
			

									
			// If item exists
			if ($query->num_rows()){
	    		// Check if already ordered
	    		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `item_sku` = ? AND `sale_id` = ? AND `item_option` = ?",array($sku,$sale_id,trim($option)));
	    		$has_rows = false;
	    		if ($qty == 1){
			    	$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `item_sku` = ? AND `sale_id` = ? AND `item_option` = ?",array($sku,$sale_id,trim($option)));
			    	if ($query->num_rows()) $has_rows = true;
			    	$has_rows = false;
	    		}
	    		
	    		if ($item->si_item_id){
		    		$query = $this->db->query("SELECT * FROM `inventory_stock_quantities` WHERE `item_id` = ?", array($item->si_item_id));
		    		$inv_item = $query->row();
		    		
		    		$inv_item_ids[] = $inv_item->item_id;
		    		
    				if ($this->system->config('cost_update_method') == 'fifo'){
    					$item_cost = $this->inv->get_fifo_cost($item->id, $qty);
    				} else {
    					$item_cost = $this->inv->get_isq_cost($item->id) * $qty;
    				}

	    		} else {
		    		$item_cost = 0;
	    		}

	    		
	    		$has_rows = false;
	    		if (!$has_rows){
		    		// If not yet ordered, create new order entry
		    		
		    		
		    		$sql = $this->db->insert_string('fnb_buffer_sale_items',array(
		    	    	'sale_id'		=> $sale_id,
		    	    	'item_id'		=> $item->id,
		    	    	'si_item_id'	=> $item->si_item_id,
		    	    	'date'			=> date('Y-m-d H:i:s'),
		    	    	'ss_terminal'	=> $this->user->terminal_data('name'),
		    	    	'ss_code'		=> $barcode,
		    	    	'item_sku'		=> $sku,
		    	    	'item_name'		=> $item->name,
		    	    	'item_option'	=> $option,
		    	    	'category'		=> $item->category,
		    	    	'subcategory'	=> $item->subcategory,
		    	    	'qty'			=> $qty,
		    	    	'price_per_unit'=> $price,
		    	    	'printed'		=> 1,
		    	    	'terminal'		=> $this->user->terminal(),
		    	    	'ordered_by'	=> $this->user->data('username'),
		    	    	'ordered_time'	=> date('Y-m-d H:i:s'),
		    	    	'cost'			=> $item_cost,
		    	    	'margin'		=> ($price * $qty) - $item_cost,
		    	    	'amount'		=> $price * $qty,
		    	    	'serial'		=> $serial
		    	    ));
		    	    $this->db->query($sql);
		    			
	    			
	    			
	    		} else {
	    			// If already ordered, retrieve the ordered item
	    			$existing_item = $query->row();
					// Update the amount and quantity
	    			$sql = $this->db->update_string('fnb_buffer_sale_items',array(
	    				'qty'			=> $existing_item->qty + $qty,
	    				'amount'		=> $price * ($existing_item->qty + $qty)
	    			),"`id` = '{$existing_item->id}'");

	    			$this->db->query($sql);
	    		}
	    	}
	    	

			// Add to printing queue by category
			$item->qty = $qty;
			$item->option = $option;
			
			$query = $this->db->query("SELECT * FROM `fnb_self_service_map` WHERE `terminal_id` = ?", array($this->user->terminal_data('id')));
			$printer_data = $query->row();
			
			if ($item->printer){
				$printer_item[$item->printer][] = $item;
			} else {
				if ($printer_data->printer) $printer_item[$printer_data->printer][] = $item;
			}
			
		}
		

		
		$comp_name = gethostbyaddr($_SERVER['SERVER_ADDR']);
		
		
		$employee = $this->user->check_session();
		
		// Update the amount
		$this->Update_amount($sale_id);

		$order_data = null;
		
		// Loop for each printer item by category
		foreach ($printer_item as $printer => $items){
			// Query printer map data by categores
				
			// Get computer name
			
			
			// Prepare printing content
			$content = date('H:i:s d/m/Y') . "\nTable no #" . $table_no . " - " . $employee->username  .  "\n";
			
			$order_data = null;
			$order_data_items = null;
			
			$order_data['table_no'] = $table_no;
			$order_data['code']		= $barcode;
			$order_data['employee'] = $employee->username;
			$order_data['datetime'] = date('H:i:s d/m/Y');
			
			// Loop for each items
			foreach ($items as $item){
				$order_data_item = null;
				
				// Add to content
				$content .= $item->qty . ' x ' . $item->name;
				if ($item->option) $content .= " - " . str_replace('_', ' ',$item->option);
				$content .= "\n";
				
				$order_data_item->qty = $item->qty;
				$order_data_item->name = $item->name;
				if ($item->option) $order_data_item->option = str_replace('_', ' ',$item->option);
				
				$order_data_items[] = $order_data_item;
			}
			
			$order_data['items'] = $order_data_items;

			// Increment queue number
			$this->qn++;
				
			// Reset queue number if greater than 50
			if ($this->qn > 50){
				$this->qn = 0;
			}
			
			// Set the current queue number to session
			$this->session->set_userdata(array('qn'=>$this->qn));
			
				$paper_size = '50mm';
				
				// Write the file
				$content = $this->load->view('fnb/orderchit-ss',$order_data,true);
				$data = pdf_create($content, ''.$this->qn, $paper_size, false);


				if (write_file('./queues/sst-queue'.$this->qn.'.pdf', $data)){
					// Send to print
					if ($printer){
						$exec_str = str_replace('%order%', 'queues\sst-queue'.$this->qn.'.pdf', $cli);
						$exec_str = str_replace('%printer_name%', $printer, $exec_str);
						
						$this->system->set_config('last_cli', $exec_str);
						
						exec($exec_str);
					}
				}



		}
		
		$res->status = 'ok';
		
		echo json_encode($res);
		
		
	}


	function Move_items(){
		$code 		= $this->input->post('code');
		$sale_id 	= $this->input->post('queue');
		
		$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `sku` = ?", array($code));
				
		$this->db->query("UPDATE `fnb_buffer_sale_items` SET `sale_id` = ? WHERE `ss_code` = ?", array($sale_id, $code));
	
		
		$this->update_amount($sale_id);
		
		$res->status = 'ok';
		
		echo json_encode($res);
	}
	
		// Process order
	function Process_orders($id){	    
	
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? AND `printed` = 0", array($id));
		
		foreach ($query->result() as $item){
		
		
			$query = $this->db->query("SELECT * FROM `fnb_printer_map` WHERE FIND_IN_SET(?,`categories`)", array($item->category));
			$printer_data = $query->row();
			
			if ($item->printer){
				$printer_item[$item->printer][] = $item;
			} else {
				if ($printer_data->printer_ip) $printer_item[$printer_data->printer_ip][] = $item;
			}		
		}
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($id));
		$sale = $query->row();
		
		$employee = $this->user->check_session();
		
		$order_data = null;
		
		$this->load->helper('dompdf');
		
		// Loop for each printer item by category
		foreach ($printer_item as $printer => $items){
			// Query printer map data by categores
				
			// Get computer name
			
			
			// Prepare printing content
			$content = date('H:i:s d/m/Y') . "\nTable no #" . $table_no . " - " . $employee->username  .  "\n";
			
			$order_data = null;
			$order_data_items = null;
			
			$order_data['table_no'] = $sale->table_no;
			$order_data['employee'] = 'Customer. Verified by ' . $employee->username;
			$order_data['datetime'] = date('H:i:s d/m/Y');
			
			// Loop for each items
			foreach ($items as $item){
				$order_data_item = null;
				
				$order_data_item->qty = $item->qty;
				$order_data_item->name = $item->item_name;
				if ($item->option) $order_data_item->option = $item->item_option;
				
				$order_data_items[] = $order_data_item;
			}
			
			$order_data['items'] = $order_data_items;

			// Increment queue number
			$this->qn++;
				
			// Reset queue number if greater than 50
			if ($this->qn > 50){
				$this->qn = 0;
			}
			
			// Set the current queue number to session
			$this->session->set_userdata(array('qn'=>$this->qn));
			
			

			if ($table_no != 'IS'){
				// Write the file
				$content = $this->load->view('fnb/orderchit',$order_data,true);
				$data = pdf_create($content, ''.$this->qn, $paper_size, false);


				if (write_file('./queues/queue'.$this->qn.'.pdf', $data)){
					// Send to print
					if ($printer){
						$exec_str = str_replace('%order%', 'queues\queue'.$this->qn.'.pdf', $cli);
						$exec_str = str_replace('%printer_name%', $printer, $exec_str);
						
						exec($exec_str);
					}
				}
			}


		}
		
		$this->db->query("UPDATE `fnb_buffer_sale_items` SET `printed` = 1 WHERE `sale_id` = ?", array($id));
		
	}


	
	function Transfer_table($queue_id, $table_number, $merge){
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `table_no` = ? AND `type` = 'queue'", array($table_number));
		if ($query->num_rows()){
			if ($merge){
				$new_table = $query->row();
				
				$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
				$old_table = $query->row();
				
				$sql = $this->db->update_string('fnb_buffer_sale_items', array(
					'sale_id'	=> $new_table->id,
				), "`sale_id` = '$queue_id'");
				$this->db->query($sql);
				
				
				$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `item_sku` = '_SC' AND `sale_id` = ?", array($new_table->id));
				$scs = $query->result();
				
				if ($query->num_rows() > 1){
					if ($scs[1]->id > $scs[0]->id){
						$sc = $scs[1];	
					} else {
						$sc = $scs[0];	
					}

					$this->db->query("DELETE FROM `fnb_buffer_sale_items` WHERE `id` = ?", array($sc->id));
				}
				
				
				
				$this->db->update('fnb_buffer_sales', array(
					'no_of_pax'	=> $new_table->no_of_pax + $old_table->no_of_pax
				),"`id` = $new_table->id");
				
				$this->db->query("DELETE FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
				
				$this->Update_amount($new_table->id);
				
				$obj['status'] = 'Success';
				$obj['queue_id'] = $new_table->id;
			} else {
				$new_table = $query->row();
				
				$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
				$old_table = $query->row();
				
				$ok = true;
				
				/*
				if (strpos($old_table->table_no, '(S)')){
					$obj['status'] = 'Split';
					$ok = false;
				}

				if (strpos($new_table->table_no, '(S)')){
					$obj['status'] = 'Split';
					$ok = false;
				}
				*/

				if ($ok){
					if (strtolower(trim($old_table->table_no)) == strtolower(trim($table_number))){
						$obj['status'] = 'Invalid';
					} else {
						$obj['status'] = 'Error';
					}
				}
			}
		} else {
			
			$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
			$old_table = $query->row();

			$ok = true;
			
			/*
			if (strpos($old_table->table_no, '(S)')){
				$obj['status'] = 'Split';
				$ok = false;
			}
			*/


			if ($ok){
				$sql = $this->db->update_string('fnb_buffer_sales', array(
					'table_no'	=> $table_number
				),"`id` = '$queue_id'");
				$this->db->query($sql);
				
				$obj['status'] = 'Success';
			}
			

			$obj['queue_id'] = $queue_id;
		}
		
		echo json_encode($obj);
	}
	
	
	
	function Enter_discount(){
		
		$queue_id	= $this->input->post('queue_id');
		$type		= $this->input->post('discount_type');
		$value		= $this->input->post('discount_value');	
		
		$query = $this->db->query("SELECT * FROM `fnb_buffer_sales` WHERE `id` = ?", array($queue_id));
		$sale = $query->row();
		
		
		if ($this->system->config('fnbpos_discount_with_customer')){
			if (!$sale->customer_id){
				return;
			}
		}
		
		if ($this->system->config('fnbpos_discount_no_amount')){
			$value = str_replace('%', '', $value);
			if ($value){
				$value = $value . '%';
			}
		}
		
		if (strpos($value, '%')){
			$type = 'p';	
			$value = str_replace('%', '', $value);
		} else {			
			$type = 'd';
		}
		
		$sql = $this->db->update_string('fnb_buffer_sales', array(
			'discount_type'	=> $type,
			'discount'		=> $value
		), "`id` = '{$queue_id}'");
		
		$this->db->query($sql);
		    			
	}
	
	
	function Print_processor($sd, $width){
	
		$this->load->helper('tp');
	
		define("CR", chr(0x0D));
		define("LF", chr(0x0A));
		define("SP", chr(0x20));
		define("HT", chr(0x09));
		define("ESC", chr(0x1B));
		define("GS", chr(0x1D));
		define("FS", chr(0x1C));
		
		$lines .= right_align($sd->top_header, floor($width)) . "\n";
		$lines .= center_align(stripslashes($sd->company_data->name), floor($width)) . "\n";
		$lines .= center_align(stripslashes($sd->company_data->address1 . ', ' . $sd->company_data->address2), $width) . "\n";
		$lines .= center_align(stripslashes($sd->company_data->zipcode . ' ' . $sd->company_data->city . ', ' . $sd->company_data->state), $width) . "\n\n";
		$lines .= center_align("GST ID NO: " . $this->system->config('company_tax_no'), $width) . "\n\n";

		foreach ($sd->items as $item){
			if ($item->discount_type == 'p'){
				$disc = ' - ' . $item->discount_value . '%';	
			} elseif ($item->discount_type == 'd'){
				$disc = ' - ' . $sd->currency . $item->discount_value;
			} else {
				$disc = '';
			}
			$i_array[] = array($item->item_name . ' ['.$item->tax_code.'] ' . $disc, $item->qty, $item->amount);
			if ($item->item_sku){
				$i_array[] = array($item->item_sku,'','');
			}
			$xsubtotal += $item->amount;
		}

		$lines .= rstr('*',$width) . "\n";
		$lines .= "DATE: " . $sd->date . "\n";
		$lines .= "RCPT NO: " . $sd->txn_no . "\n";
		$lines .= "TABLE NO: " . $sd->table_no . "\n";
		$lines .= "CASHIER: " . $sd->sale->username . "\n";

				
		$lines .= rstr('*',$width) . "\n";
		
		$bal_n = $width - 12;

		$lines .= columns($i_array, array(
				  	0 => array("align"=>"left","length"=>$bal_n),
				  	1 => array("align"=>"left","length"=>6),
				  	2 => array("align"=>"right","length"=>6)
				  )) . "\n";
		$lines .= rstr('*',$width) . "\n";
		
		$subtotal = $sd->sale->amount - $sd->sale->adjustment;

		$lines .= right_align("SUBTOTAL: " . $sd->currency . number_format($xsubtotal,2), $width, 0) . "\n";
	
		if ($sd->sale->discount != 0){
			if ($sd->sale->discount_type == 'p'){
				$disc_amount = number_format(($sd->sale->discount * $xsubtotal) / 100,2);
				$perc = $sd->sale->discount;
				$lines .= right_align("DISCOUNT {$perc}%: " . $sd->currency . $disc_amount, $width, 0) . "\n";
			}
			if ($sd->sale->discount_type == 'd'){
				$disc_amount = number_format($sd->sale->discount,2);
				$lines .= right_align("DISCOUNT: " .  $sd->currency . $disc_amount, $width, 0) . "\n";
			}
		}
		
		
		$lines .= right_align("GST: " . $sd->currency . number_format($sd->sale->tax_amount,2), $width, 0) . "\n";
		
		if ($sd->sale->adjustment != 0){
			$lines .= right_align("ROUNDING ADJUST: " . $sd->currency . number_format($sd->sale->adjustment,2), $width, 0) . "\n";			
		}
		

		$lines .= right_align("TOTAL: " . $sd->currency . number_format($sd->sale->amount,2), $width, 0) . "\n";

		/*
		$lines .= right_align("TENDERED: " . $sd->currency . number_format($sd->sale->amount_tendered,2), $width, 0) . "\n";
		$lines .= right_align("CHANGE: " . $sd->currency . number_format($sd->sale->amount_change,2), $width, 0) . "\n";
		*/
		$lines .= "\n";
		
		
		$contact = $sd->customer;
		
		if ($contact){
	    	$lines .= "\nMEMBER: ";
	    	$lines .= strtoupper($contact->company_name ? $contact->company_name : $contact->contact_person);
	    	$lines .= "\nMEMBER ID: " . $contact->ic;
	    	$lines .= "\n\n";
	    }

		if ($sd->top_header != 'BILL'){
			if ($sd->sale->amount_cash != $sd->sale->amount){
				
				$lines .= center_align("* * PAYMENT BREAKDOWN * *", $width, 0) . "\n\n";
				
				if ($sd->sale->amount_cash){
					$lines .= left_align("CASH: " . $sd->currency . number_format($sd->sale->amount_cash,2), $width, 0) . "\n";
				}
			
				if ($sd->sale->amount_cc){
					$lines .= left_align("CREDIT CARD (".$sd->card->name . "): " . $sd->currency . number_format($sd->sale->amount_cc,2), $width, 0) . "\n";
				}
		
				if ($sd->sale->amount_bank_deposit){
					$lines .= left_align("BANK DEPOSIT: " . $sd->currency . number_format($sd->sale->amount_bank_deposit,2), $width, 0) . "\n";
				}
	
				if ($sd->sale->amount_voucher){
					$lines .= left_align("VOUCHER: " . $sd->currency . number_format($sd->sale->amount_voucher,2), $width, 0) . "\n";
				}
				
				
			
			} 
	
			$lines .= "\n";
							
			$lines .= $sd->footer;
		}
		
		$lines .= "\n\n\n\n\n\n\n\n";
		$lines .= GS . chr(0x56) . chr(0x00); // Partial cut

				
		return $lines;
	}
	
	function Print_chit($printer, $content){


		$cli = $this->system->config('fnbpos_print_cli');

		if ($cli[0] == '>' || $printer[0] == '>'){
					
			if ($printer){
				if ($printer[0] == '>'){
					list($cli, $printer) = explode('|', $printer);
				}
				
				$url = str_replace('>', '', $cli);						
				
				$postdata = http_build_query(
				    array(
				        'content' 	=> str_replace('<body>',"<body>Kitchen's Copy",$content),
				        'printer'	=> $printer,
				        'paper_size'=> $paper_size,
				        'qn'		=> $this->qn
				    )
				);
				
				$opts = array('http' =>
				    array(
				        'method'  => 'POST',
				        'header'  => 'Content-type: application/x-www-form-urlencoded',
				        'content' => $postdata
				    )
				);
				
				$context  = stream_context_create($opts);
				

				$result = file_get_contents($url, false, $context);
				

			}

		} elseif (trim($cli)) {
			
			$data = pdf_create($content, ''.$this->qn, $paper_size, false);

			if (write_file('./queues/queue'.$this->qn.'.pdf', $data)){
				// Send to print
				if ($printer){
					$exec_str = str_replace('%order%', 'queues\queue'.$this->qn.'.pdf', $cli);
					$exec_str = str_replace('%printer_name%', $printer, $exec_str);
					
					if ($table_no == 'TEST'){
						write_file('./queues/debug_cli.txt', $exec_str);
					}							
					
					
					$this->system->set_config('last_cli', $exec_str);
					
					exec($exec_str);
					
					if ($table_no == 'TEST'){
						write_file('./queues/debug_cli.txt', 'SUCCESS ' . $exec_str);
					}							

				}
			}
			

			

		
		} else {
			
			if (strpos($printer, '?')){
				list($printer, $opt) = explode('?', $printer);
				
				parse_str($opt);
				
				$host = $printer;
			} else {
				$host = $printer;						
			}
			
			$port = "9100";

			$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
			

			$this->load->helper('tp');
			

			$chit = process_chit($order_data, $width);
					
			$res = fopen('queues/printdebug_'.$printer.'.txt', 'w+');
			fwrite($res, $chit);
			fclose($res);	

			if ($socket === false) {
				$error = 1;
			} else {
				$result = socket_connect($socket, $host, $port);
				if ($result === false) {
					$error = 2;
				} else {
					socket_write($socket, $chit, strlen($chit));
					socket_close($socket);
				}

			}
			
		}		
	}

}