<?php

class Report extends Model {
	
	function Report(){
		parent::Model();
		
		$this->load->model('user');
		$this->load->model('system');
	}

	function Get_reports($filters){
		$query = $this->db->query("SELECT * FROM `reports` {$filters}");
		return $query->result();
	}
	
	function Get_report_by_id($id){
		$query = $this->db->query("SELECT * FROM `reports` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Add(){
		
		$this->db->insert('reports', array(
			'name'			=> $this->input->post('name'),
			'description'	=> $this->input->post('description'),
			'modules'		=> json_encode($this->input->post('modules')),
			'permissions'	=> $this->input->post('permissions'),
			'process_script'=> stripslashes($_REQUEST['process_script']),
			'display_script'=> stripslashes($_REQUEST['display_script']),
			'filters'		=> stripslashes($_REQUEST['filters']),
			'type'			=> $this->input->post('type'),
			'added_by'		=> $this->user->data('username'),
			'added_on'		=> date('Y-m-d H:i:s')
		));
	}
	
	function Edit($id){
		
		$this->db->update('reports', array(
			'name'			=> $this->input->post('name'),
			'description'	=> $this->input->post('description'),
			'modules'		=> json_encode($this->input->post('modules')),
			'permissions'	=> $this->input->post('permissions'),
			'process_script'=> stripslashes($_REQUEST['process_script']),
			'display_script'=> stripslashes($_REQUEST['display_script']),
			'filters'		=> stripslashes($_REQUEST['filters']),
			'type'			=> $this->input->post('type'),
			'modified_by'	=> $this->user->data('username'),
			'modified_on'	=> date('Y-m-d H:i:s')
		), "`id` = '{$id}'");
		
	}
	
	function Delete($id){
		$this->db->query("DELETE FROM `reports` WHERE `id` = ?", array($id));		
	}
	
	function Check_script($code){
		$pattern = '((\w+|\{\$\w+\}|\{"\w+"\}|{"[A-Za-z0-9_\$]+"\}|\{\'\w+\'\})(\s+\(|\())';

		preg_match_all($pattern, $code, $matches);
		$matching_funcs = $matches[0];
		
		
	
	    $cs = array("print","echo","require","include","if","else","while","for","switch","exit","break","die");    
	    $whitelist = array("str_replace","substr","pow","tan"); 
	
	    $allowed_list = array_merge($cs, $whitelist);
	    
	    $status = 1;
	    foreach ($matching_funcs as $func){
		    if (!in_array(trim(str_replace('(','', $func)), $allowed_list)){
		    	$status = 0;
		    }
		}
		
		return $status;

	}
	
	function Get_saved_reports($filters){
		$query = $this->db->query("SELECT * FROM `reports_saved` WHERE {$filters}");
		return $query->result();
	}
	
	function Get_saved_report_by_id($id){
		$query = $this->db->query("SELECT * FROM `reports_saved` WHERE `id` = ?", array($id));
		return $query->row();
	}
	
	function Save_generated_report(){
		$id = $this->input->post('id');
		
		$report = $this->get_report_by_id($id);
		
		$this->db->insert('reports_saved', array(
			'title'		=> $this->input->post('title'),
			'type'		=> $report->name,
			'notes'		=> $this->input->post('notes'),
			'output'	=> $_REQUEST['output'],
			'added_on'	=> date('Y-m-d H:i:s'),
			'added_by'	=> $this->user->data('username')
		));
		
		$this->load->helper('file');
		
		echo 'Report Saved';
		
		write_file('./reports/' . $this->input->post('title') . '.html', $_REQUEST['output']);
	}
	
	function Delete_generated_report($id){
		$this->db->query("DELETE FROM `reports_saved` WHERE `id` = ?", array($id));
	}


	function safe_eval($code,&$status) { //status 0=failed,1=all clear 
	    //Signs 
	        //Can't assign stuff 
	    $bl_signs = array("="); 
	
	    //Language constructs 
	    $bl_constructs = array("print","echo","require","include","if","else", 
	"while","for","switch","exit","break");    
	
	    //Functions 
	    $funcs = get_defined_functions(); 
	    $funcs = array_merge($funcs['internal'],$funcs['user']); 
	
	    //Functions allowed        
	        //Math cant be evil, can it? 
	    $whitelist = array("pow","exp","abs","sin","cos","tan"); 
	    
	    //Remove whitelist elements 
	    foreach($whitelist as $f) { 
	        unset($funcs[array_search($f,$funcs)]);    
	    } 
	    //Append '(' to prevent confusion (e.g. array() and array_fill()) 
	    foreach($funcs as $key => $val) { 
	        $funcs[$key] = $val."("; 
	    } 
	    $blacklist = array_merge($bl_signs,$bl_constructs,$funcs); 
	    
	    //Check 
	    $status=1; 
	    foreach($blacklist as $nono) { 
	        if(strpos($code,$nono) !== false) { 
	            $status = 0; 
	            return 0; 
	        } 
	    } 
	
	    //Eval 
	    return @eval($code); 
	} 
	
	function Get_reports_dropdown($dropdown){
		if ($dropdown) $array[] = "Select";
		
		$query = $this->db->query("SELECT * FROM `reports` ORDER BY `name` ASC");
		foreach ($query->result() as $report){
			$array[$report->id] = $report->name;
		}
		
		return $array;
	}
	
	function Get_widgets(){
		$query = $this->db->query("SELECT * FROM `reports` WHERE `type` = 'widget'");
		return $query->result();
	}
	
	

	
	
}