<?php

class Shipping extends Model {
	
	function Shipping(){
		parent::Model();
	}
	
	function Get_delivery_services(){
		$query = $this->db->query("SELECT * FROM `shipping`");
		$services[] = "Select";
		foreach ($query->result() as $shipping){
			$services[$shipping->id] = $shipping->name;
		}
		return $services;
	}
	
	function Get_delivery_charges($id, $country, $zipcode, $items){
		
		$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($id));
		$service = $query->row();
		
		
		if ($country == $this->system->config('country')){
			// local zone
			$query = $this->db->query("SELECT * FROM `shipping_local_zones` WHERE `zipcode_from` <= ? AND `zipcode_to` >= ?", array($zipcode, $zipcode));
			$zone = $query->row();
			
			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = 'Local'", array($service->id, $zone->id));
			$rate = $query->row();
						
		} else {

			$query = $this->db->query("SELECT * FROM `shipping_international_zones` WHERE FIND_IN_SET(?, `countries`)", array($country));
			$zone = $query->row();
			
			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = 'International'", array($service->id, $zone->id));
			$rate = $query->row();

		}

		foreach ($items as $item){

			$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($item->id));
			$xitem = $query->row();
			

			if ($service->measurements_type == 'Metric'){
				
				$item_weight = $this->__convertWeight($xitem->weight, $xitem->weight_unit, 'kg');
				$item_volume = $this->__convertVolume($xitem->volume, $xitem->volume_unit, 'cm3');
				$item_volumetric_weight = $item_volume / $service->shipping_factor;
				

				$weight = $item_weight >= $item_volumetric_weight ? $item_weight : $item_volumetric_weight;
				$weight *= $item->qty;
				
			} else {
				
				$item_weight = $this->__convertWeight($xitem->weight, $xitem->weight_unit, 'lb');
				$item_volume = $this->__convertVolume($xitem->volume, $xitem->volume_unit, 'in3');
				$item_volumetric_weight = $item_volume / $service->shipping_factor;
				
				$weight = $item_weight >= $item_volumetric_weight ? $item_weight : $item_volumetric_weight;
				$weight *= $item->qty;
				
			}
			
			$total_items += $item->qty;
			$total_weight += $weight;		
			

			
			if ($weight <= $rate->first_weight){
			    $shipping_rate = $rate->flat_rate + $rate->first_weight_rate;
			} elseif ($weight >= $rate->max_weight_rate){
			    $shipping_rate = $rate->flat_rate + $rate->max_weight_rate;
			} else {
				$subsequent_rate = ceil(($weight - $rate->first_weight) / $rate->subsequent_weight) * $rate->subsequent_weight_rate;
			    $shipping_rate = $rate->flat_rate + $rate->first_weight_rate + $subsequent_rate;
			}
			

			$total_rates += $shipping_rate;

		}

		$data->total_rate = $total_rates ? $total_rates : 0;
		$data->total_weight = $total_weight ? $total_weight : 0;
		$data->total_items = $total_items ? $total_items : 0;
		$data->weight_unit = $service->measurements_type == 'Metric' ? 'kg' : 'lb';
		
		return $data;
		
	}
	
	function __convertWeight($value, $from, $to){
		$unit_ratios = array(
			'g'		=> 1,
			'kg'	=> 0.001,
			'oz'	=> 0.035273962,
			'lb'	=> 0.0022046226
		);
		
		return ($value / $unit_ratios[$from]) * $unit_ratios[$to];
	}
	
	function __convertVolume($value, $from, $to){
		$unit_ratios = array(
			'cm3'	=> 1,
			'l'		=> 0.001,
			'in3'	=> 0.0610237441
		);
		return ($value / $unit_ratios[$from]) * $unit_ratios[$to];
	}

	
}