<?php


class System extends Model {

	function System(){
		parent::Model();
		
		$this->load->model('user');
	}
	
	function Is_local_ip(){
		$ip = $_SERVER['REMOTE_ADDR'];
		if ($ip == '::1') return true;
		if ($ip == '127.0.0.1') return true;
		if (strpos($ip, '192.168') !== false) return true;
	}

	function Config($field = null, $branch){
	
		if (!$branch){
			$user_branch = $this->user->data('branch');
			if (!$user_branch){
				$branch = 1;
			} else {
				$branch = $user_branch;
			}
		}
	
		if ($field){
		
			$query = $this->db->query("SELECT * FROM `config` WHERE `config` = ?", array($field));
			
			if ($query->num_rows() > 0){
				$config = $query->row();
				if ($config->allow_branch_config && $branch != 1){
					$query = $this->db->query("SELECT * FROM `config_branch` WHERE `config` = ? AND `branch_id` = ?", array($field, $branch));
					if ($query->num_rows() > 0){
						$branch_config = $query->row();
						if ($branch_config->value)	return $branch_config->value;
					} 
				}
				return $config->value;
			}
			
			return false;
			
		} else {
		
			$query = $this->db->query("SELECT * FROM `config`");
			$result = $query->result();
			
			foreach ($result as $config){
				$system->{$config->config} = $config->value;
			}
			
			return $system;
			
		}
		
	}
	
	function Set_config($config, $value, $branch){
	
		if (!$branch){
			$user_branch = $this->user->data('branch');
			if (!$user_branch){
				$branch = 1;
			} else {
				$branch = $user_branch;
			}
		}	
	
		$query = $this->db->query("SELECT * FROM `config` WHERE `config` = ?", array($config));
		
		if ($query->num_rows()){
			
			if ($branch == 1){
				$query = $this->db->query("UPDATE `config` SET `value` = ? WHERE `config` = ?", array($value, $config));
			} else {
				$query = $this->db->query("SELECT * FROM `config_branch` WHERE `config` = ? AND `branch_id` = ?", array($config, $branch));
				
				if ($query->num_rows()){
					$query = $this->db->query("UPDATE `config_branch` SET `value` = ? WHERE `config` = ? AND `branch_id` = ?", array($value, $config, $branch));
				} else {
					$sql = $this->db->insert_string('config_branch',array(
						'config'	=> $config,
						'value'		=> $value,
						'branch_id'	=> $branch
					));
					$this->db->query($sql);
				}
			}

			
		} else {
		
			if ($row->allow_branch_config && $branch != 1){

				$sql = $this->db->insert_string('config',array(
					'config'	=> $config,
					'value'		=> $value
				));
				$this->db->query($sql);
				
			} else {
		
				$sql = $this->db->insert_string('config_branch',array(
					'config'	=> $config,
					'value'		=> $value,
					'branch_id'	=> $branch
				));
				$this->db->query($sql);
			
			}
			
		}
	}
	
	function Uses($module_name){
	
		$query = $this->db->query("SELECT * FROM `modules` WHERE `name` = ?", array($module_name));
		$module = $query->row();
		
		if ($module->enabled) return true;

		return false;
	}

	
	function Country_list($select = true){
		$query = $this->db->query("SELECT * FROM `countries`");
		if ($select) $countries[] = "Select Country";
		foreach ($query->result() as $country){
			$countries[$country->name] = $country->name;
		}
		
		return $countries;
	}

	
	function State_list($country){
		if ($country){
			$query = $this->db->query("SELECT * FROM `states` WHERE `country` = ? ORDER BY `state` ASC",array($country));
			foreach ($query->result() as $state){
				$states[$state->state] = $state->state;
			}
			return $states;
		}
		return false;		
	}
	
	function Event_log($module, $action, $type, $record_id, $record_data){
	
		$sql = $this->db->insert_string('system_transactions',array(
			'module'		=> $module,
			'action'		=> $action,
			'type'			=> $type,
			'record_id'		=> $record_id,
			'record_data'	=> json_encode($record_data),
			'datetime'		=> date('Y-m-d H:i:s'),
			'performed_by'	=> $this->user->data('username')
		));
		
		$this->db->query($sql);
		
	}
	
}


