<?php 

class User extends Model {

	function Employee(){
		parent::Model();
		
	}

	function Check_session(){
	
		if ($terminal_id = get_cookie('PLEX_POS_TERM_ID')){
			$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));
			$terminal = $query->row();
			
			$query = $this->db->query("SELECT * FROM `users` WHERE `terminal_identifier` = ? AND `terminal_id` = ? AND `terminal_key` = ?", array(get_cookie('PLEX_POS_TERM_IDENTIFIER'), get_cookie('PLEX_POS_TERM_ID'), get_cookie('PLEX_POS_TERM_KEY')));
			if ($query->num_rows()) return $query->row();

		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
			
			if ($ip == '::1'){
				$ip = '127.0.0.1';
			}
			
			$query = $this->db->query("SELECT * FROM `users` WHERE `terminal_ip` = ? AND `terminal_active` = 1", array($ip));
			
			if ($query->num_rows()) return $query->row();
		}


		
		return false;
		
	}
	
	function Check_password($username, $password){
		if ($username && $password){
			
			
			$password = md5($password);			
		} else {
		
			$username = $this->input->post('username');
			$password = md5($this->input->post('password'));
		}

		$query = $this->db->query("SELECT * FROM `users` WHERE `username` = ? AND `password` = ?", array($username, $password));
		if ($query->num_rows()) return true;
		else return false;
	}
	
	
	
	function Login(){
		$ip = $_SERVER['REMOTE_ADDR'];
		$username = $this->input->post('username');
		$password = md5($this->input->post('password'));
		$keycard = $_REQUEST['password'];
		
		if ($ip == '::1'){
			$ip = '127.0.0.1';
		}
		
		

		if ($username){
			$query = $this->db->query("SELECT * FROM `users` WHERE `username` = ?", array($username));			
			$user = $query->row();
			
			if ($user->password != $password) return false;			
		} else {
			$user = $this->user->Get_user_by_keycard($keycard);
		}

		
		if ($user->id){
			
			$this->user_data = $user;

		
			$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));
			$terminal = $query->row();
			
			$session = time();
			
			
			$sql = $this->db->update_string('users', array(
				'terminal_active'		=> 1,
				'terminal_type'			=> $terminal->type,
				'terminal_last_login'	=> date('Y-m-d H:i:s'),
				'terminal_ip'			=> $ip,
				'terminal_session'		=> $session,
				'terminal_identifier'	=> $terminal->identifier,
				'terminal_key'			=> $key,
				'terminal_id'			=> $terminal->id,
				'terminal_name'			=> $terminal->name
			), "`id` = '{$user->id}'");
			$this->db->query($sql);
			
			$sql = $this->db->insert_string('sales_sessions', array(
				'identifier'		=> $session,
				'logged_in_by'		=> $user->username,
				'from'				=> date('Y-m-d H:i:s'),
				'status'			=> 'Active'
			));
			$this->db->query($sql);
			
			
			$session_module_data = json_decode($user->data);
			foreach ($session_module_data as $module => $data){
				foreach ($data as $key => $value){
					$this->session->set_userdata(array(strtolower($module.'_'.$key) => $value));
				}
			}
			
			return true;
		}
		return false;
	}
	
	function Get_user_by_username($username){
		$query = $this->db->query("SELECT * FROM `users` WHERE `username` = ?", array($username));
		return $query->row();
	}
	
	function Get_user_by_keycard($key){
		$query = $this->db->query("SELECT * FROM `users` WHERE STRCMP(`keycard`,?) = 0 AND (`keycard` IS NOT NULL AND `keycard` != '')", array($key));			
		return $query->row();
	}
	
	function Logout(){
		$user = $this->check_session();
		
		// Log out employee session
		$sql = $this->db->update_string('users', array(
				'terminal_active'		=> '',
				'terminal_type'			=> '',
				'terminal_last_login'	=> '',
				'terminal_ip'			=> '',
				'terminal_session'		=> '',
				'terminal_identifier'	=> ''
		), "`id` = '{$user->id}'");
		
		$this->db->query($sql);

	}

	
	function Cashout(){
		
		$user = $this->check_session();
		
		$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total_cash`, SUM(`amount_cc`) AS `total_cc`, SUM(`amount_cheque`) AS `total_cheque`, SUM(`amount_credit`) AS `total_credit` FROM `sales` WHERE `session` = ? GROUP BY `session`",array($user->session));
		$in = $query->row();
		
		$query = $this->db->query("SELECT SUM(`qty`) AS `total_qty`  FROM `sale_items` WHERE `session` = ? GROUP BY `session` LIMIT 1",array($user->terminal_session));
		$out = $query->row();
		
		$expected 	= $this->input->post('expected');
		$counted	= $this->input->post('counted');
		$deposited	= $this->input->post('deposited');
		$discrepancy= $this->input->post('discrepancy');

		
		$sql = $this->db->insert_string('cash_count', array(
			'user_id'			=> $user->id,
			'username'			=> $user->username,
			'from'				=> $user->terminal_last_login,
			'to'				=> date('Y-m-d H:i:s'),
			'deposited'			=> $counted,
			'discrepancy'		=> $discrepancy,
			'total_sales'		=> $expected - $deposited,
			'total_items'		=> $out->total_qty,
			'ip_address'		=> $_SERVER['REMOTE_ADDR'],
			'sale_breakdown'	=> json_encode($in),
			'terminal'			=> $this->terminal_data('id'),
			'session'			=> $user->terminal_session

		));
			
		$this->db->query($sql);
		
		$sql = $this->db->update_string('sales_sessions', array(
			'to'				=> date('Y-m-d H:i:s'),
			'status'			=> 'Closed',
			'logged_out_by'		=> $user->username
		),"`session` = '{$user->session}'");
		
		$this->db->query($sql);
		
		$this->db->query("DELETE FROM `sales` WHERE `type` = 'queue' AND `session` = ?",array($user->session));
		
		$sql = $this->db->update_string('users', array(
			'terminal_active'		=> '',
			'terminal_type'			=> '',
			'terminal_last_login'	=> '',
			'terminal_ip'			=> '',
			'terminal_session'		=> '',
			'terminal_identifier'	=> ''
		), "`id` = '{$user->id}'");
		
		$this->db->query($sql);
		
		$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total_cash`, SUM(`amount`) AS `total_sales`, SUM(`taxes`) AS `total_tax` FROM `sales` WHERE `type` = 'history' AND `session` = ? GROUP BY `session`", array($user->session));		
		$sale = $query->row();

		$user->last_login	= $user->terminal_last_login;
		$user->last_logout	= date('Y-m-d H:i:s');
		$user->total_cash	= $sale->total_cash;
		$user->total_sales	= $sale->total_sales;
		$user->total_tax	= $sale->total_tax;
		$user->deposited	= $this->input->post('deposited');
		$user->discrepancy	= $this->input->post('discrepancy');
		
		return $user;
		
	}
	
	
	function FNB_Cashout($deposited, $discrepancy, $total_sales){
	
		$user = $this->check_session();
		
		$sql = $this->db->insert_string('fnb_cash_count', array(
			'user_id'			=> $user->id,
			'username'			=> $user->username,
			'session'			=> $user->terminal_session,
			'terminal'			=> $this->terminal,
			'from'				=> $user->terminal_last_login,
			'to'				=> date('Y-m-d H:i:s'),
			'deposited'			=> $deposited,
			'discrepancy'		=> $discrepancy,
			'total_sales'		=> $total_sales,
			'total_items'		=> $out->total_qty,
			'ip_address'		=> $_SERVER['REMOTE_ADDR']
		));
			
		$this->db->query($sql);

		
		$sql = $this->db->update_string('sales_sessions', array(
			'to'				=> date('Y-m-d H:i:s'),
			'status'			=> 'Closed',
			'logged_out_by'		=> $user->username
		),"`session` = '{$user->session}'");
		
		$this->db->query($sql);
		
		
		$sql = $this->db->update_string('users', array(
			'terminal_active'		=> '',
			'terminal_type'			=> '',
			'terminal_last_login'	=> '',
			'terminal_ip'			=> '',
			'terminal_session'		=> '',
			'terminal_identifier'	=> ''
		), "`id` = '{$user->id}'");
		
		$this->db->query($sql);
		
		$user->last_login = $user->terminal_last_login;
		$user->last_logout = date('Y-m-d H:i:s');
		$user->total_sales = $sale->total_cash;
		$user->deposited = $this->input->post('deposited');
		$user->discrepancy = $this->input->post('discrepancy');
		
		return $user;
		
	}

	
	function Data($field){
		$user = $this->check_session();
		if ($field) return $user->$field;
		return $user;
	}
	
	function Terminal(){
		if ($this->config->config['client_side']){
	  		$res = fopen('CONN','r');
	  		$conn = fread($res,filesize('CONN'));
	  		fclose($res);
	  		
	  		list($host, $terminal_name, $terminal_key) = explode('|', $conn);
	  		
	  		$query = $this->db->query("SELECT * FROM `terminals` WHERE `name` = ?", array($terminal_name));
    		$terminal = $query->row();

		} else {	
			if ($terminal_id = get_cookie('PLEX_POS_TERM_ID',true)){
		    	$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));
		    	$terminal = $query->row();
			} else {
				$ip = $_SERVER['REMOTE_ADDR'];
				if ($ip == '::1'){
					$ip = '127.0.0.1';
				}

				$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));
				$terminal = $query->row();
			}
		}
		return $terminal->id;
	}
	
	function Terminal_data($field){
		if ($this->config->config['client_side']){
	  		$res = fopen('CONN','r');
	  		$conn = fread($res,filesize('CONN'));
	  		fclose($res);
	  		
	  		list($host, $terminal_name, $terminal_key) = explode('|', $conn);
	  		
	  		$query = $this->db->query("SELECT * FROM `terminals` WHERE `name` = ?", array($terminal_name));
    		$terminal = $query->row();

		} else {	
	
			if ($terminal_id = get_cookie('PLEX_POS_TERM_ID',true)){
		    	$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));
		    	$terminal = $query->row();
			} else {
				$ip = $_SERVER['REMOTE_ADDR'];
				if ($ip == '::1'){
					$ip = '127.0.0.1';
				}

				$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));
				$terminal = $query->row();
			}
		}
		
		if ($field) return $terminal->$field;
		return $terminal;
	}
	
	function Terminal_ip(){
		return $_SERVER['REMOTE_ADDR'];
	}
	
	function Verify_authentication($username, $password){
		$query = $this->db->query("SELECT * FROM `users` WHERE `username` = ?", array($username));
		if ($query->num_rows()){
			$user = $query->row();
			if ($user->employee_id && strtoupper(md5($password)) == strtoupper($user->password)) return $user->employee_id;
		}
		return false;
	}
	
	function Clock_in($user_id){
		$this->db->query("UPDATE `employee_cico` SET `status` = 'Uncleared' WHERE `status` = 'Pending' AND `employee_id` = ?", array($user_id));	
	
		$sql = $this->db->insert_string('employee_cico',array(
			'check_in'		=> date('Y-m-d H:i:s'),
			'employee_id'	=> $user_id,
			'status'		=> 'Pending'
		));
		
		$this->db->query($sql);
		
		return true;
	}
	
	function Clock_out($user_id){
		$query = $this->db->query("SELECT * FROM `employee_cico` WHERE `status` = 'Pending' AND `employee_id` = ?", array($user_id));
		if ($query->num_rows()){
			$cico = $query->row();
			$sql = $this->db->update_string('employee_cico',array(
				'check_out'	=> date('Y-m-d H:i:s'),
				'status'	=> 'Cleared'
			),"`id` = '{$cico->id}'");
			
			$this->db->query($sql);
			return true;
		} 
		return false;
	}
	
	
	function Has_permission($action_type, $module, $user = null){
	
		if ($user){
			$query = $this->db->query("SELECT * FROM `users` WHERE `username` = ?", array($user));
			$user_data = $query->row();
			if ($this->check_superadmin($user_data->id)) return true;
		} else {
			if ($this->is_super_admin()) return true;			
			$user_data = $this->data();
		}
		
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = '{$user_data->type}'");
		$permission = $query->row();


		if ($permission->super) return true;
		
		if ($permission->module == '*') return true;
		
		$modules = explode(',', $permission->module);
		
		if (!in_array($module,$modules)) return false;

		$actions = json_decode($permission->action);
		$p_action = $actions->{$module};
		
		
		if ($p_action->{$action_type}) return true;
		return false;		
	}
	
	function Is_super_admin(){

		$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));
		$permission = $query->row();
				
		if ($permission->super) return true;
		else return false;
	}
	
	function Check_superadmin($id){
		$query = $this->db->query("SELECT * FROM `users` WHERE `id` = ?", array($id));
		$user = $query->row();
		
		$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));
		$permission = $query->row();
		
		if ($permission->super) return true;
		else return false;
	}
	
	// Get terminal battery indicators
	function Indicators(){
		// Query employee iphone terminals
		$query = $this->db->query("SELECT * FROM `users` WHERE `terminal_active` = 1");
		
	    $output = '';
	    
		// Loop for each device and prepare indicator output
		foreach ($query->result() as $device){
			if ($device->username != $this->user->data('username')){
		    	$output .= "<div class=\"device\" style=\"margin-top: 10px;\"><div class=\"indicator\" style=\"width: {$device->battery_level}px\"></div>{$device->battery_level}%<br />{$device->username}<br /><button empid=\"{$device->id}\" class=\"vui-btn btn-logout\" style=\"width: 100%; margin-top: 10px\">Logout</button></div>";
	    	}
	    }
	    

	    
	    // Return object
	    $obj['status'] = 'Success';
	    $obj['html'] = $output;
	    
	    echo json_encode($obj);
	}


}