<!DOCTYPE HTML>
<html>

	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<meta http-equiv="Cache-Control" content="no-cache" />
		<meta http-equiv="Pragma" content="no-cache" />

		<base href="<?php echo base_url(); ?>" />
		<title><?php echo $this->system->config('company_name'); ?></title>
		<link rel="stylesheet" href="css/clinic/style.css" />
		<script type="text/javascript" src="js/clinic/jquery-1.4.3.min.js"></script>
		<script type="text/javascript" src="js/clinic/session.js"></script>
		<script type="text/javascript">
		
			KEY_CODES = {
			  37: 'left',
			  38: 'up',
			  39: 'right',
			  40: 'down'
			}
		 
			KEY_STATUS = { keyDown:false };
			for (code in KEY_CODES) {
			  KEY_STATUS[KEY_CODES[code]] = false;
			}
			
			
			var xhr = null;
			var meds = [];
			var curMed = null;
			
			$(document).ready(function(){
				$(window).resize(function(){
					$('div.container').css('height',$(window).height() - 171);
					$('ul.patient-visits').css('height',$(window).height() - 200);
					$('div.patient-information').css('height',$(window).height() - 215);
					$('div.patient-history').css('height',$(window).height() - 215);
				});
				
				$('#logout-btn').click(function(){
					window.location.href = 'clinic/logout';
				});
				
				$('ul.vui-card-tab li').click(function(){
					$(this).parents('ul').children('li').addClass('vui-current-tab');
					$(this).removeClass('vui-current-tab');
				});

				
				$('button.complete-consultation').click(function(){
					completeConsultation();
				})
				
				$('ul.tab li').click(function(){
					$('ul.tab li').removeClass('current');
					$(this).addClass('current');
				});
				
				$('ul.list li').live('click',function(e){
					$(this).parent('ul.list').find('li').removeClass('current');
					$(this).addClass('current');
					
					$('div.no-queue-selected').hide();
					$('div.queue-details').show();
					
					getPatientInformation($(this).attr('id'));
				})
				
				$(window).resize();
				
				$('#btn-new-consultation').click(function(){
					showModalForm('#add-consultation');
					
					$('textarea.problem').val('');
					$('textarea.physical_examination').val('');
					$('textarea.diagnosis').val('');
					$('textarea.treatment').val('');
					$('input.medicine-search').val('');
					$('ul.medicine-list').html('');
				});
				
				$('#btn-call-queue').click(function(){
					if (!$(this).hasClass('disabled')){
						var xid = $('ul.patient-visits li.current').attr('id');
						$.ajax({
							url: 'clinic/ajax/call_queue',
							type: 'post',
							data: 'id='+xid,
							success: function (res){
								if (res == 'on'){
									$('#btn-call-queue').addClass('call-on');
								} else {
									$('#btn-call-queue').removeClass('call-on');
								}
								$('#btn-call-queue').removeClass('disabled');
							}
						})
					}
				});
				
				$('#btn-cancel-consultation').click(function(){
					hideModalForm('#add-consultation');
				})
				
				getQueueList();
				
				routine();
				
				$('ul.view-tab li').click(function(){
					$('div.tab-view').hide();
					var rel = $(this).attr('rel');
					
					$('div.'+rel).show();
				})
				
				$('a.medicine-cancel').live('click',function(){
					$(this).parents('li').remove();
				});
				
				$('input.medicine-search').blur(function(){
					$('span.overlay').text('').attr('id','');;					
				});
				
				$('input.dosage').live('keypress',function(e){
					if (e.which == 13){
						$(this).parent('li').find('input.price').focus();
						$('span.overlay').text('').attr('id', '').val('');
					}
				});
				
				$('input.quantity').live('keypress',function(e){
					if (e.which == 13){
						$(this).parent('li').find('input.uom').focus();
						$('span.overlay').text('').attr('id', '').val('');
					}
					
				});
				
				$('input.quantity').live('keyup', function(){
					var price = parseFloat($(this).parent('li').find('input.uom').attr('price'));
					var total = price * parseFloat($(this).val() ? $(this).val() : 0);
					
					$(this).parent('li').find('input.price').val(total.toFixed(2));	
				})
				
				$('input.uom').live('keypress',function(e){
					if (e.which == 13){
						$(this).parent('li').find('input.dosage').focus();
						$('span.overlay').text('').attr('id', '').val('');
					}
					

				});
				
				$('input.price').live('keypress', function(e){
					if (e.which == 13){
						var val = parseFloat($(this).val());
						$(this).val(val.toFixed(2));
						$('input.medicine-search').focus();
						$('span.overlay').text('').attr('id', '').val('');
					}					
				});
				
				$('input.uom').live('blur', function(){
					var selected 	= $('div.uom li.current');
					var price 		= parseFloat($(selected).attr('price'));
					var qty 		= $(this).parent('li').find('input.quantity').val();
					
					$(this).val($(selected).text());
					$(this).attr('uom', $(selected).attr('uom'));
					$(this).attr('price', price);
					
					var total = price * parseFloat(qty ? qty : 0);
					
					$(this).parent('li').find('input.price').val(total.toFixed(2));	
					$(this).parent('li').find('div.uom').remove();
				});
				
				$('input.uom').live('keydown',function(e){
					if (e.keyCode == 40){
						var next = $('div.uom ul li.current').next();
						if (next[0]){
							$('div.uom li').removeClass('current');
							$(next).addClass('current');
							
							$('input.uom').val($(next).text()).each(function(){
								this.select()
							});

						}
					}
					if (e.keyCode == 38){
						var prev = $('div.uom ul li.current').prev();
						if (prev[0]){
							$('div.uom li').removeClass('current');
							$(prev).addClass('current');
							
							$('input.uom').val($(prev).text()).each(function(){
								this.select()
							});
						}						
					}
					
					if (e.keyCode == 13){
						var selected 	= $('div.uom li.current');
						var price 		= parseFloat($(selected).attr('price'));
						var qty 		= $(this).parent('li').find('input.quantity').val();
						
						$(this).val($(selected).text());
						$(this).attr('uom', $(selected).attr('uom'));
						$(this).attr('price', price);
						
						var total = price * parseFloat(qty ? qty : 0);
						
						$(this).parent('li').find('input.price').val(total.toFixed(2));	
						$(this).parent('li').find('div.uom').remove();
					}
				});
				
				
				
				$('input.uom').live('focus',function(){
					var id = $(this).parent('li').attr('id');
					var med = meds[id];
					$(this).parent('li').find('div.uom').remove();					
					$(this).parent('li').prepend('<div class="uom" style="position: absolute; background: #FFF; border-radius: 5px 5px 0 0; padding: 1px; box-shadow: 0 -1px 2px rgba(0,0,0,0.5)"><ul class="autocomplete"></ul></div>')
					
					var curUOM = $(this).attr('uom') ? $(this).attr('uom') : 1;
					
					for (var i = 1; i <= 4; i++){
						eval('var uom = med.uom'+i);
						
						if (i == 1) x = '';
						else x = i;
						
						eval('var uomPrice = med.price'+x);
						
						if (uom){
							if (i == curUOM) $('div.uom ul').append('<li uom="'+i+'" class="current" price="'+uomPrice+'">'+uom+'</li>');
							else $('div.uom ul').append('<li uom="'+i+'" price="'+uomPrice+'">'+uom+'</li>');
						} else {
							if (i == 1){
								$('div.uom ul').append('<li uom="1" class="current" price="'+med.price+'">unit</li>');
							}
						}
					}
					
					var topOffset = $('div.uom').height();
					
					$('div.uom').css('margin-top',1 - topOffset);
					$('div.uom').css('margin-left', 328);
					$('div.uom').css('width',76);
				});

				
				$('input.medicine-search').keyup(function(e){
					var name = $(this).val();
					
					if (e.which == 13){
						
						var id 		= $(this).attr('id');

						if (id && name == $('span.overlay').text()){

							meds[id] = curMed;

							var price 	= $('span.overlay').attr('price');
							if (curMed.uom1) uom = curMed.uom1;
							else uom = 'unit';
							$('ul.medicine-list').append('<li id="'+id+'"><a style="margin-left: 5px" class="medicine-cancel"><span>x</span></a><input style="width: 160px" type="text" class="text name" value="'+name+'" /> &nbsp; Quantity <input type="text" style="width: 40px" class="text quantity" /> <input type="text" style="width: 80px" class="uom" price="'+curMed.price+'" value="'+uom+'" />  &nbsp; Dosage <input style="width: 120px" type="text" class="dosage" value="" /> &nbsp; Price <input style="width: 70px; text-align: right" type="text" class="price" value="'+price+'" /></li>');
							$(this).val('');
							$(this).attr('id', '');
							$('span.overlay').text('');
							
							$('ul.medicine-list li[id='+id+']').find('input.quantity').val(1).each(function(){ this.select(); });
							

							
							curMed = null;
							
						} else {
							$(this).attr('id', $('span.overlay').attr('id'));
							$(this).val($('span.overlay').attr('name'));
							$('span.overlay').text($('span.overlay').attr('name'));
							
							$(this).each(function(){
								this.select();
							})
						}
						
						var scrollHeight = 0;
						$('div.consultation-form').each(function(){
							scrollHeight = this.scrollHeight;
						});
						
						$('div.consultation-form').scrollTop(scrollHeight);
						
						return;
					}
				
					$('span.overlay').text('').attr('id','');;					

					
					try {
						xhr.abort();
					} catch (e){
						// do nothing
					}
					xhr = $.ajax({
						url: 'clinic/ajax/search_item',
						type: 'post',
						data: 'name='+name,
						dataType: 'json',
						success: function (item){
							curMed = item;
							if (item.name){
								var name = $('input.medicine-search').val();
								var medname = '';
								for (var i = 0; i < item.name.length; i++){
									if (name.charAt(i)){
										medname = medname + '' + name.charAt(i);
									} else {
										medname = medname + '' + item.name.charAt(i);
									}
								}
								console.log(medname);
								$('span.overlay').text(medname).attr('id',item.id).attr('name',item.name).attr('price',item.price);
							}
						}
					});
				})
				
			});
			
			function getQueueList(){
				$.ajax({
					url: 'clinic/ajax/get_queue_list',
					success: function (res){
						var id = $('ul.patient-visits li.current').attr('id');
						$('ul.patient-visits').html(res);
						$('ul.patient-visits li[id='+id+']').addClass('current');
					}
				})
			}
			
			function getPatientInformation(id){
			
				$('td.patient-id').text('');
				$('h3.patient-name').text('');
				$('td.patient-gender').text('');
				$('td.patient-height').text('');
				$('td.patient-weight').text('');
				$('td.patient-age').text('');
				$('td.patient-blood_type').text('');
				$('td.patient-emergency_contact').text('');
				$('td.patient-allergy').text('');
				

			
				$.ajax({
					url: 'clinic/ajax/get_patient_information',
					type: 'post',
					data: 'id='+id,
					dataType: 'json',
					success: function (patient){
						console.log(patient);
						$('td.patient-id').text(patient.ic);
						$('h3.patient-name').text(patient.contact.contact_person);
						$('td.patient-gender').text(patient.gender);
						$('td.patient-height').text(patient.height);
						$('td.patient-weight').text(patient.weight);
						$('td.patient-blood_type').text(patient.blood_type);
						$('td.patient-emergency_contact').text(patient.emergency_contact);
						$('td.patient-allergy').text(patient.allergy);
						
						$('div.patient-history').html('');
						if (patient.history){
							for (var i = 0; i < patient.history.length; i++){
								var history = patient.history[i];
								$('div.patient-history').append('<p style="text-align: right">'+history.added_on+'</p>');
								$('div.patient-history').append('<table class="at"><tr><td class="label"><h3>Problem</h3></td><td>'+history.problem+'</td></tr><tr><td class="label"><h3>Physical Examination</h3></td><td>'+history.physical_examination+'</td></tr><tr><td class="label"><h3>Diagnosis</h3></td><td>'+history.diagnosis+'</td></tr><tr><td class="label"><h3>Treatment</h3></td><td>'+history.treatment+'</td></tr></table><hr />');
							}
						}
						
					
					}
				})
			}
			
			function getPatientHistoryList(id){
				
			}
			
			function completeConsultation(){
				var xid = $('ul.patient-visits li.current').attr('id');
				var x = 0;
				
				var meds = '';
				var meds_name = '';
				var meds_dosage = '';
				var meds_price = '';
				
				$('ul.medicine-list li').each(function(){
					var id 		= $(this).attr('id');
					var name 	= $(this).find('input.name').val();
					var dosage 	= $(this).find('input.dosage').val();
					var price 	= $(this).find('input.price').val();
					var uom		= $(this).find('input.uom').attr('uom');
					var qty		= $(this).find('input.quantity').val();
					
					if (x == 0){
						meds 		= id;
						meds_name 	= name;
						meds_dosage = dosage;
						meds_price 	= price;
						meds_uom	= uom;
						meds_qty	= qty;
					} else {
						meds 		+= ','+id
						meds_name 	+= ','+name;
						meds_dosage += ','+dosage;
						meds_price 	+= ','+price;
						meds_uom	+= ','+uom;
						meds_qty	+= ','+qty;
					}
					x++;
				});
				
				$.ajax({
					url: 'clinic/ajax/close_consultation',
					type: 'post',
					data: 'id='+xid+
						'&problem='+$('textarea.problem').val()+
						'&diagnosis='+$('textarea.diagnosis').val()+
						'&treatment='+$('textarea.treatment').val()+
						'&physical_examination='+$('textarea.physical_examination').val()+
						'&meds='+ meds+
						'&meds_name='+meds_name+
						'&meds_dosage='+meds_dosage+
						'&meds_price='+meds_price+
						'&meds_uom='+meds_uom+
						'&meds_qty='+meds_qty,
					success: function(){
						hideModalForm('#add-consultation');
						getQueueList();
						
						$('textarea.problem').val('');
						$('textarea.diagnosis').val('');
						$('textarea.treatment').val('');
						$('textarea.physical_examination').val('');
						$('ul.patient-visits ').html('');
						
						$('div.no-queue-selected').show();
						$('div.queue-details').hide();

					}
					
				})
			}
			
			function showModalForm(id){
				var left = ($(window).width() / 2) - ($(id).width() / 2);
				var top = ($(window).height() / 2) - ($(id).height() / 2) - 20;
				$('div.overlay').show();
				$(id).show().css('position','absolute').css('left',left).css('top',top);
			}
			
			function hideModalForm(id){
				$('div.overlay').hide();
				$(id).hide();
			}
			
			function routine(){
				getQueueList();
				setTimeout(function(){
					routine();
				}, 3000);
			}
		</script>
	</head>
	<body>
		<div class="overlay"></div>
		<div class="forms">
			<div id="add-consultation" style="padding: 0" class="card">
				<div class="header">
					<button style="margin-top: -2px; margin-right: -5px" id="btn-cancel-consultation" class="vui-btn fr">Cancel</button>
					<h2>New Consultation</h2>
				</div>
				<div class="consultation-form scroll" style="margin: 2px 5px; height: 80%; position: relative">
					<table class="at consultation-form">
						<tr>
				    		<td class="label"><h3>Problem</h3></td>
				    		<td>
				    			<textarea class="problem"></textarea>
				    		</td>
				    	</tr>
				    	<tr>
				    		<td class="label"><h3>Physical Examination</h3></td>
				    		<td>
				    			<textarea class="physical_examination"></textarea>
				    		</td>
				    	</tr>
				    	<tr>
				    		<td class="label"><h3>Diagnosis</h3></td>
				    		<td>
				    			<textarea class="diagnosis"></textarea>
				    		</td>
				    	</tr>
				    	<tr>
				    		<td class="label"><h3>Treatment</h3></td>
				    		<td>
				    			<textarea class="treatment"></textarea>
				    		</td>
				    	</tr>
				    	<tr>
				    		<td class="label"><h3>Medicine</h3><h3>
				    		<td>
				    			<span class="overlay"></span>
				    			<input type="text" class="medicine-search" />
				    		</td>
				    	</tr>
				    	<tr>
				    		<td colspan="2">
				    			<ul class="list medicine-list">
				    			
				    			</ul>				    		
				    		</td>
				    	</tr>
				    </table>
				</div>
				<hr style="margin: 0 5px" />
				<div style="text-align: right; padding-right: 5px;">

				    <button class="vui-btn complete-consultation">Done</button>
				</div>
			</div>
		</div>
		<div style="padding: 0 31px">
			<div class="status">
				<table style="border-collapse: collapse">
					<tr>
						<td style="width: 245px; text-align: center">
							<img src="logo.png" style="margin-top: 5px;" />					
						</td>
						<td>Time<br /><strong class="session_time"> </strong></td>
						<td>Logged in as <strong class="session_logged_in_as"></strong> at <strong class="session_logged_in_time"></strong><br />Duration <strong class="session_logged_in_duration"></strong></td>
						<td style="text-align: right"><button class="vui-btn" id="logout-btn" style="width:100px">Log<u>o</u>ut</button></td>
					</tr>
				</table>
			</div>
		</div>

		<div class="container">
		
			<div class="sidebar-list">
				<div class="placeholder card" style="padding: 0 0 20px 0">
					<ul class="vui-card-tab">
						<li style="width: 100%" class="queues-tab">Queues</li>
					</ul>
					<br style="clear:both;" />
					<div style="padding: 0 10px">
						<ul class="list patient-visits">
							<?php foreach ($queues as $queue): ?>
							<li></li>
							<?php endforeach; ?>
						</ul>
					</div>
				</div>
			</div>
			<div class="main">
				<div class="placeholder card" style="padding: 0 0 20px 0">
					<div class="no-queue-selected">
						<h2 style="color: #AAA; text-align: center; padding-top: 170px; font-size: 30pt; text-shadow: 0 1px 0 rgb(255,255,255)">No Queue Selected</h2>
					</div>
					<div class="queue-details" style="display:none">
						<div class="header">
							<button id="btn-new-consultation" class="vui-btn vui-btn-dark fr" style="margin-top: -2px; margin-right: -3px">New Consultation</button>
							<button id="btn-call-queue" class="vui-btn vui-btn-dark fr" style="margin-top: -2px; margin-right: 5px">Call Queue</button>
							<ul class="view-tab tab" rel="tab1">
								<li rel="patient-information" class="current">Patient Information</li>
								<li rel="patient-history">Patient History</li>
							</ul>
						</div>
						<div class="tab-view patient-information" style="margin: 5px 5px 5px 10px;" rel="tab1">
							<h3 style="font-size: 18pt; margin-top: 10px; margin-left: 10px" class="patient-name"></h3>
							<table class="grid-form">
								<tr>
									<td class="label">Patient ID</td>
									<td class="patient-id"></td>
								</tr>
								<tr>
									<td class="label">Gender</td>
									<td class="patient-gender"></td>
								</tr>
								<tr>
									<td class="label">Age</td>
									<td class="patient-age"></td>
								</tr>
								<tr>
									<td class="label">Height</td>
									<td class="patient-height"></td>
								</tr>
								<tr>
									<td class="label">Weight</td>
									<td class="patient-weight"></td>
								</tr>
								<tr>
									<td class="label">Blood Type</td>
									<td class="patient-blood_type"></td>
								</tr>
								<tr>
									<td class="label">Emergency Contact</td>
									<td class="patient-emergency_contact"></td>
								</tr>
								<tr>
									<td class="label">Allergy</td>
									<td class="patient-allergy"></td>
								</tr>
							</table>
						</div>
	
						<div class="tab-view patient-history" rel="tab1" style="display:none; margin: 5px; padding-right: 10px">
							
						</div>
					</div>
				</div>
				
			</div>
		</div>
		
	
	</body>

</html>