// Keyboard keycodes

KEY_CODES = {
	  37: 'left',
	  38: 'up',
	  39: 'right',
	  40: 'down'
}
 
KEY_STATUS = { keyDown:false };
for (code in KEY_CODES) {
  KEY_STATUS[KEY_CODES[code]] = false;
}

// Globals

var inventoryOpen = false;
var payCallback;

var currentCustom = 0;
var currentQueue = 0;
var currentItem = 0;
var currentQueueType = 'queue';
var currentTab = 'queues';
var currentTable = 0;
var currentTextObject = null;
var currentItemPrice = 0.00;
var currentItemName = '';
var currentItemOptionList = '';

var doPrint = false;
var newQueue = false;
var continueTxn = false;
var quickScan = false;
var total = 0.00;

var enterPriceID = null;
var enterPriceDisplay = '';
var enterPriceQty = 0;
var enterReplace = false;

var managerRequest = null;
var managerRequestData = null;
var managerPerform = null;


var callback = null;

var itemOption = '';
var itemPrice = 0.00;
var itemQty = 1;
var actualPrice = 0.00;
var splitCheckout = false;
var mainCheckout = false;

var instantSale = false;
var instantCheckout = false;

var filterTableQueue = false;

$(window).load(function(){
	$.ajax({
		url: base_url + 'fnbpos/ajax/init/',
		type: 'post',
		data: 'sst='+sst,
		dataType: 'json',
		success: function(result){
			$('div.item-options').html(result.options);
			if (sst){
				$('#inventory-sst').html(result.items);
			} else {
				$('#inventory').html(result.items);
			}
			
			$('#init').hide();
		}
	});
});

// Events population when 
$(document).ready(function(){

	$('#verify-order').mouseup(function(){
		$('#verify-order').hide();
		$('#cancel-order').hide();
				
		$.ajax({
			url: base_url + 'fnbpos/ajax/verify_order',
			type: 'post',
			data: 'id='+currentQueue,
			dataType: 'json',
			success: function(res){
				getItemList();
				
				$('#verify-order').hide();
				$('#cancel-order').hide();

			}
		})
	});
	
	$('#cancel-order').mouseup(function(){
		$('#verify-order').hide();
		$('#cancel-order').hide();

		$.ajax({
			url: base_url + 'fnbpos/ajax/cancel_order',
			type: 'post',
			data: 'id='+currentQueue,
			dataType: 'json',
			success: function(res){
				if (res.status == 'ok-noclear'){
					getItemList();
					getQueueList();
				} else {
					currentQueue = null;
					getQueueList();
					getItemList();
				}
			}
		})
	});


	$('#discount-percent').keyup(function(){
		if ($(this).val() == ''){
			$('#discount-input').val('');
			return;
		}

		var due = parseFloat($('td.pay-total').text());
		var percent = parseFloat($(this).val());
		var discount = (due * (percent / 100));
		var discounted = (due - discount).toFixed(2);
		var amt = parseFloat(discounted);
		var addition = 0.00;		
		var split = discounted.split('.');
		var decimals = split[1];

		if (decimals.charAt(1) <= 2){
			var newDec = '0';
		} else if (decimals.charAt(1) <= 7){
			var newDec = '5';
		} else if (decimals.charAt(1) <= 9){
			var newDec = '0';
			addition = 0.1;
		}

		discounted = parseFloat(split[0] + '.' + decimals[0] + newDec) + addition;
		
		var adjustment = discounted - amt;
	
		$('td.amount-subtotal').text(amt.toFixed(2));
		$('td.rounding-adjust').text(adjustment.toFixed(2));

		$('#discount-input').val(discount.toFixed(2));
		
		$('td.pay-amount-due').text(discounted.toFixed(2));
		
		$('#amount-tendered-input').val(discounted.toFixed(2));
	});
	
	$('#discount-input').keyup(function(){
		if ($(this).val() == ''){
			$('#discount-percent').val('');
			return;
		}
	
		var due 		= parseFloat($('td.pay-total').text());
		var discount	= parseFloat($(this).val());
		var discounted	= (due - discount).toFixed(2);

		var addition = 0.00;		
		var split = discounted.split('.');
		var decimals = split[1];

		if (decimals.charAt(1) <= 2){
			var newDec = '0';
		} else if (decimals.charAt(1) <= 7){
			var newDec = '5';
		} else if (decimals.charAt(1) <= 9){
			var newDec = '0';
			addition = 0.1;
		}

		discounted = parseFloat(split[0] + '.' + decimals[0] + newDec) + addition;

		
		var percent = (discount / due) * 100;
		
		$('#discount-percent').val(percent.toFixed(2));
		
		$('td.pay-amount-due').text(discounted.toFixed(2));
	})

	$('#new-delivery').live('touchstart',function(){
		showDialog('delivery');
	});
	
	$('#cancel-new-delivery').live('touchstart',function(){
		hideDialog('delivery');
		$('input.delivery-name').val('');
		$('input.delivery-mobile').val('');
		$('input.delivery-address').val('');
	});
	
	$('#add-delivery').live('touchstart',function(){
		var name 	= $('input.delivery-name').val();
		var mobile	= $('input.delivery-mobile').val();
		var address	= $('input.delivery-address').val();
		
		

		$.ajax({
			url: base_url + 'fnbpos/ajax/new_delivery',
			type: 'post',
			data: 'name='+name+'&mobile='+mobile+'&address='+address,
			success: function (res){
				hideDialog('delivery');
				$('input.delivery-name').val('');
				$('input.delivery-mobile').val('');
				$('input.delivery-address').val('');

				getDeliveryList();
				
			}
		})
	});
	
	$('button.option-back').live('touchend',function(){
		$(this).parents('div.item-option').hide();
		itemOption = '';
		itemPrice = 0.00;
		$('small.cur-item-option').text('');
		$('li.option').removeClass('selected').removeClass('vui-selected');
		$('small.cur-item-price').text(actualPrice.toFixed(2));

	});
	


	$('#verify-access-btn').live('touchstart',function(){
		var username = $('#access-username').val();
		var password = $('#access-password').val();

		qty = $('#void-qty').val();

		managerRequestData += '&username=' + username + '&password=' + password + '&qty=' + qty;
		$.ajax({
			url: base_url + managerRequest,
			type: 'post',
			data: managerRequestData,
			dataType: 'json',
			success: function(res){
				if (res.status == 'Success'){
					hideDialog('permission');
					managerPerform();

					hideDialog('keypad');
				} else {
					$('#access-alert').text('Invalid username or password.');
					$('#access-password').each(function(){
						this.select();
					});

				}
			}
		});
	});
	
	$('#cancel-permission').live('touchstart',function(){
		hideDialog('permission');
		$('tr.void-qty').hide();
	});
	
	$('#cancel-enter-price').live('touchstart',function(){
		hideDialog('enter-price');
		hideDialog('keypad');
	});

	$('#return-queue').live('touchstart',function(){
		if (revert_level == 'Manager'){
			managerRequest = 'fnbpos/ajax/cancel';
			managerRequestData = 'queue=' + currentQueue;
			managerPerform = function(){
					currentQueueType = 'queue';
					$('#queues-tab').mouseup();
			};
			showDialog('permission');
			if ($('#access-username').val()){
		    	$('#access-password').focus();				
			} else {
				$('#access-username').focus();
			}

	    	$('#access-password').val('');
	    	$('#access-alert').text('');
		} else {
			$.ajax({
				url: base_url + 'fnbpos/ajax/cancel',
				type: 'post',
				data: 'queue=' + currentQueue,
				success: function(html){
					currentQueueType = 'queue';
					$('#queues-tab').mouseup();
				}
			});
		}
	});
	
	
	
	$('#cancel-delivery').live('touchstart',function(){
		if (revert_level == 'Manager'){
			managerRequest = 'fnbpos/ajax/cancel_delivery';
			managerRequestData = 'queue=' + currentQueue;
			managerPerform = function(){
					currentQueueType = 'delivery';
					$('#delivery-queues-tab').mouseup();
			};
			showDialog('permission');
	    	$('#access-username').focus();

		} else {
			$.ajax({
				url: base_url + 'fnbpos/ajax/cancel_delivery',
				type: 'post',
				data: 'queue=' + currentQueue,
				success: function(html){
					currentQueueType = 'delivery';
					$('#delivery-queues-tab').mouseup();
				}
			});
		}
	});



	// Start javascript application routine
	setInterval(function(){ updateRoutine(); } ,2000);
	
	// Terminals button mouse up
	$('#order-terminals').live('touchstart',function(){
		// Get indicators data
		$.ajax({
			url: base_url + 'fnbpos/ajax/indicators',
			dataType: 'json',
			success: function (json){
				if (json.status == 'Success'){
					// Populate indicator data and show
					$('div.indicator-content').html(json.html + '<br class="clearboth" />');
					showDialog('indicators');
				}
			}
		});

	});
	
	// Close indicator button
	$('#close-indicators').live('touchend',function(){
		hideDialog('indicators');
	});
	
	// Add quantity button
	$('button.qty-add').live('touchend',function(){
		itemQty = itemQty + 1;
		$('small.cur-item-qty').text(itemQty);
	});
	
	// Deduct quantity button
	$('button.qty-deduct').live('touchend',function(){
		itemQty = itemQty - 1;
		if (itemQty < 1) itemQty = 1;
		$('small.cur-item-qty').text(itemQty);
	
	});
	
	// Custom price per unit entry field keyup event
	$('#enter-item-price-pu').keyup(function(){
		var price = parseFloat($(this).val()) * parseInt(enterPriceQty);
		if (!price) price = 0.00;
		$('#enter-item-price').val(price.toFixed(2));
	});

	// Custom price entry field keyup event
	$('#enter-item-price').keyup(function(){
		var price = parseFloat($(this).val()) / parseInt(enterPriceQty);
		if (!price) price = 0.00;
		$('#enter-item-price-pu').val(price.toFixed(2));
	})
	
	// Split bill button event
	$('button.checkout-split').live('touchend',function(){
		hideDialog('split-bill');
		splitCheckout = true;
		payCallback = true;
		$('#checkout').mouseup();
	});
	
	// Checkout button event
	$('button.checkout-main').live('touchend',function(){
		hideDialog('split-bill');
		mainCheckout = true;
		payCallback = true;
		$('#checkout').mouseup();
	});
	
	// Cancel split bill button event
	$('button.cancel-split').live('touchend',function(){
		hideDialog('split-bill');
		splitChecout = false;
		mainCheckout = false;

		$('#split-list').html('');
	});
	
	$('#print_bill').live('touchstart',function(){
		window.print();
	})
	
	
	$('#main-list li').live('touchend',function(){
		$('#split-list li').removeClass('vui-selected');
		
		var amount = parseFloat($(this).find('.item-amount').text());
		var name = $(this).find('.item-name').text();
		var qty = parseInt($(this).find('.item-qty').text());
		var rel = $(this).attr('rel');
		var ppu = amount / qty;
		
		
		if (!name) return;
		
		if ($('li.split-item[rel='+rel+']').hasClass('split-item')){
			var splitItem = $('li.split-item[rel='+rel+']');
			var hasSplitItem = true;
		} else {
			var hasSplitItem = false;
		}
		if (qty == 1){
			$(this).remove();
			var newQty = 0;
			var newAmount = 0.00;

			if (hasSplitItem){
				var curQty = parseInt($(splitItem).find('.item-qty').text());
				var curAmount = parseFloat($(splitItem).find('.item-amount').text());
				newQty = curQty + 1;
				newAmount = curAmount + amount;
				
				
				$(splitItem).find('.item-qty').text(newQty);
				$(splitItem).find('.item-amount').text(newAmount.toFixed(2));
			} else {
				newQty = 1;
				newAmount = amount;
				var newSplitItem = '<li rel="'+rel+'" class="split-item"><table class="vui-dt-row"><tr><td class="item-name" style="width: 55%"><strong style="font-size: 10pt">'+name+'</strong></td><td class="item-qty" style="width: 22%; text-align: center;">'+newQty+'</td><td class="item-amount" style="width: 23%; text-align: right;">'+newAmount.toFixed(2)+'</td></tr></table></li>';
				$('#split-list').append(newSplitItem);
	
			}
			

		} else {
			var newPrice = amount - ppu;
			$(this).find('.item-qty').text(qty-1);
			$(this).find('.item-amount').text(newPrice.toFixed(2));
			
			if (hasSplitItem){
				var curQty = parseInt($(splitItem).find('.item-qty').text());
				var curAmount = parseFloat($(splitItem).find('.item-amount').text());
				newQty = curQty + 1;
				newAmount = newQty * ppu;
				
				$(splitItem).find('.item-qty').text(newQty);
				$(splitItem).find('.item-amount').text(newAmount.toFixed(2));

			} else {
				newQty = 1;
				newAmount = ppu;
				var newSplitItem = '<li rel="'+rel+'" class="split-item"><table class="vui-dt-row"><tr><td class="item-name" style="width: 55%"><strong style="font-size: 10pt">'+name+'</strong></td><td class="item-qty" style="width: 22%; text-align: center;">'+newQty+'</td><td class="item-amount" style="width: 23%; text-align: right;">'+newAmount.toFixed(2)+'</td></tr></table></li>';
				$('#split-list').append(newSplitItem);

			}			
			
		}
		
		calculateSplitTotal();


	});
	
	$('#split-list li').live('touchend',function(){
		$('#main-list li').removeClass('vui-selected');

		var amount = parseFloat($(this).find('.item-amount').text());
		var name = $(this).find('.item-name').text();
		var qty = parseInt($(this).find('.item-qty').text());
		var rel = $(this).attr('rel');
		var ppu = amount / qty;
				
		
		if (!name) return;
		
		if ($('#main-list li[rel='+rel+']').hasClass('main')){
			var mainItem = $('#main-list li[rel='+rel+']');
			var hasMainItem = true;
		} else {
			var hasMainItem = false;
		}
		
		if (qty == 1){
			$(this).remove();
			var newQty = 0;
			var newAmount = 0.00;

			if (hasMainItem){
				var curQty = parseInt($(mainItem).find('.item-qty').text());
				var curAmount = parseFloat($(mainItem).find('.item-amount').text());
				newQty = curQty + 1;
				newAmount = curAmount + amount;
				
				
				$(mainItem).find('.item-qty').text(newQty);
				$(mainItem).find('.item-amount').text(newAmount.toFixed(2));
			} else {
				newQty = 1;
				newAmount = amount;
				var newMainItem = '<li rel="'+rel+'" class="main"><table class="vui-dt-row"><tr><td class="item-name" style="width: 55%"><strong style="font-size: 10pt">'+name+'</strong></td><td class="item-qty" style="width: 22%; text-align: center;">'+newQty+'</td><td class="item-amount" style="width: 23%; text-align: right;">'+newAmount.toFixed(2)+'</td></tr></table></li>';
				$('#main-list').append(newMainItem);
			}
			

		} else {
			var newPrice = amount - ppu;
			$(this).find('.item-qty').text(qty-1);
			$(this).find('.item-amount').text(newPrice.toFixed(2));
			
			if (hasMainItem){
				var curQty = parseInt($(mainItem).find('.item-qty').text());
				var curAmount = parseFloat($(mainItem).find('.item-amount').text());
				newQty = curQty + 1;
				newAmount = newQty * ppu;
				
				$(mainItem).find('.item-qty').text(newQty);
				$(mainItem).find('.item-amount').text(newAmount.toFixed(2));

			} else {
				newQty = 1;
				newAmount = ppu;
				var newMainItem = '<li rel="'+rel+'" class="main"><table class="vui-dt-row"><tr><td class="item-name" style="width: 55%"><strong style="font-size: 10pt">'+name+'</strong></td><td class="item-qty" style="width: 22%; text-align: center;">'+newQty+'</td><td class="item-amount" style="width: 23%; text-align: right;">'+newAmount.toFixed(2)+'</td></tr></table></li>';
				$('#main-list').append(newMainItem);

			}			
			
		}
		
		calculateSplitTotal();

	});	
	
	$('#enter-price-btn').live('touchstart',function(){
		enterPrice();
	});
	
	$('#enter-item-price').keypress(function(e){
		if (e.which == 13){
			enterPrice();
		}
	});
	
	$('#item-code').live('keydown',function(e){

		if (e.which == 27){
			$('#inventory-close').mouseup();
		}

		if (e.which == 13){
			var code = $(this).val();
			moveItems(code);
		}
		
		
	});
	
	$('#enter-item-price-pu').keypress(function(e){
		if (e.which == 13){
			enterPrice();
		}
	});
	
	
	
	$('#split').live('touchstart',function(){
		if (countItems()){
			$('#split-list').html('');
			showDialog('split-bill');					
			$.ajax({
				url: base_url + 'fnbpos/ajax/get_item_list',
				type: 'POST',
				data: 'queue='+currentQueue,
				success: function (json){
					showDialog('split-bill');
					if (json.status == 'Success'){
						$('#main-list').html(json.html);
						calculateMainTotal();
					}
				}
			});
		}
	});

	$('button.done-select').live('touchend',function(){
		$(this).parents('div.item-option').hide();

		addItem(itemOption, itemPrice);
		$('li.option').removeClass('selected').removeClass('vui-selected');

	});
	
	$('button.clear-option').live('touchend',function(){
		itemOption = '';
		itemPrice = 0.00;
		$('small.cur-item-option').text('');
		$('li.option').removeClass('selected').removeClass('vui-selected');
		$('small.cur-item-price').text(actualPrice.toFixed(2));
	});


	$('#confirm-done').live('touchend',function(){
		$(this).mouseup();
		
	});
	
	$('#table-back').live('touchstart',function(){
		hideDialog('newtable');
		hideDialog('keypad');
		$('#table-number-input').val('B');
		$('p.table-error').text('');
	});
	
	$('#transfer-back').live('touchstart',function(){
		hideDialog('transfertable');
		hideDialog('keypad');	
		$('#transfer-number-input').val('');
		$('p.transfer-error').text('');
	});

	$('input.count-den').change(function(){
		countDenominations();
	});

	$('#verify-btn').live('touchstart',function(){
		cashCountConfirm();
	});

	$('#confirmation-print-receipt').live('touchstart',function(){
		window.print();
	});
	
	$('#logout-btn').live('touchstart',function(){
		cashCount();
	});
	
	$('#cancel-logout').live('touchstart',function(){
		hideDialog('keypad');
		hideDialog('logout');
	});


	$('#void-queue').live('touchstart',function(){
		$('#item-list').html('');
		$('span.grand-total').text('0.00');
		voidQueue();

	});
	
	$('#void-item').live('touchstart',function(){
		voidItem();
	});

	$('#queues-tab').live('touchstart',function(){
		currentTab = 'queues';	
		
		$('ul.item-list').html('');
		getQueueList();

		$('#queue-current').show();
		$('#delivery-queue-current').hide();
		$('#queue-history').hide();
		$('span.grand-total').text('0.00');
				
	});
	
	$('#history-tab').live('touchstart',function(){
		currentTab = 'history';
		
		$('ul.item-list').html('');
		getHistoryList();

		$('#queue-current').hide();
		$('#delivery-queue-current').hide();
		$('#queue-history').show();
		$('#void-item').hide();
	});
	
	$('#delivery-queues-tab').live('touchstart',function(){
		currentTab = 'delivery';
	
		$('ul.item-list').html('');
		getDeliveryList();

		$('#queue-current').hide();
		$('#delivery-queue-current').show();
		$('#queue-history').hide();
		$('#void-item').hide();
	});


	$('ul.vui-card-tab li').live('touchstart',function(){
		$(this).parents('ul').children('li').addClass('vui-current-tab');
		$(this).removeClass('vui-current-tab');
	});
	
	$('#item-list li').live('dblclick',function(){
		showDialog('custom-price');
		currentCustom = $(this).attr('id');
		var total_price = parseFloat($(this).find('td.item-amount').text());
		var price = parseFloat($(this).attr('price'));
		
		$('#enter-item-custom-price-pu').val(price.toFixed(2));
		showDialog('keypad');
		
		$('#enter-item-custom-price-pu').each(function(){
			this.select();
		});
	});
	
	$('#cancel-custom-price').live('touchstart',function(){
		hideDialog('keypad');
		hideDialog('custom-price');
	});
	
	$('#enter-item-custom-price-pu').keypress(function(e){
		if (e.which == 13){
			$('#custom-price-btn').mouseup();
		}
	});
	
	$('#custom-price-btn').live('touchstart',function(){
		
		var ppu = parseFloat($('#enter-item-custom-price-pu').val());
		if (!ppu){
			alert('Price cannot be left empty.');
			$('#enter-item-custom-price-pu').each(function(){
				this.select();
			});
		} 
		var qty = parseInt($('#'+currentCustom).find('td.item-qty').text());
		var price = parseFloat(qty * ppu);
		
		
		$('#'+currentCustom).attr('price',price);
		$('#'+currentCustom).find('td.item-amount').text(price.toFixed(2));
		hideDialog('keypad');
		hideDialog('custom-price');
	});
	
	$('#item-list li').live('touchend',function(){
		currentItem = $(this).attr('id');
		if (!inventoryOpen){
			$('#void-item').show();
		} else {
			if ($(this).hasClass('voidable')){
				$('#void-item').show();
			} else {
				$('#void-item').hide();
			}
		}
	});
	
	$('#queue-current li').live('touchstart', function(){
		currentQueue = $(this).attr('id');
	})

	
	$('#queue-current li').live('touchend',function(){
		currentQueue = $(this).attr('id');
		currentTable = $(this).find('strong').text();
		
		
		getItemList();
		
		reprintBill();
		$('#void-item').hide();
	});
	
	$('#delivery-queue-current li').live('touchend',function(){
		currentQueue = $(this).attr('id');
		currentTable = $(this).find('strong').text();
		getDeliveryItemList();
		$('#void-item').hide();
	});

	
	$('#queue-current li').live('dblclick',function(){
		$('#add-item').mouseup();
	});
		
	$('#queue-history li').live('touchend',function(){
		currentQueue = $(this).attr('id');
		$('#reprint-receipt').show();
		getItemList();
	});
	
	$('#categories li').live('touchend',function(){
		var rel = $(this).attr('rel');
		$('ul.subcat').hide();
		$('ul.subcat[rel='+rel+']').show();
		$('li.subcat').show();
		$('ul.item').hide();
	});
	
	$('li.subcat').live('touchend',function(){
		var rel = $(this).attr('rel');
		$(this).parents('ul.subcat').find('li.subcat').hide();
		$('ul.item').hide();
		$('ul.item[rel='+rel+']').show();
	});

	$(window).resize(function(){
		var targetHeight = $(window).height() - 190;
		$('#queues').height(targetHeight + 70);
		$('#items').height(targetHeight + 70);
		$('ul.queue-list').height(targetHeight - 60 + 70);
		
		if (!sst){
			$('ul.item-list').height(targetHeight - 145 + 70);
		} else {
			$('ul.item-list').height(targetHeight - 480);
			$('#items').height(targetHeight - 380);
		}

		$('#inventory').height(targetHeight);
		$('#inventory').css('top',20);
		
		$('#pay').height(targetHeight - 100);
		$('#pay').css('top',100);

		$('#confirmation').height(targetHeight - 100);
		$('#confirmation').css('top',100);
		
		$('#add-ok').css('top',20);
		$('#add-failed').css('top',20);

		if (!sst){
			$('ul.category-list').height(targetHeight - 155);
			$('ul.browse-list').height(targetHeight - 155);
			$('ul.option-list').height(targetHeight - 223);
		}

		
	});
	
	
	
	$(window).resize();
	
	$('ul.vui-select-list li').live('touchstart', function(){
		$(this).css('opacity',0.5)
	});
	
	$('ul.vui-select-list li').live('touchstart', function(){
		$(this).css('opacity',1);
	});


	$('ul.item-list li').live('touchstart', function(){
		if (!$(this).hasClass('stay')) $(this).parents('ul').children('li').removeClass('vui-selected');
		$(this).addClass('vui-selected');
	});
	

	$('ul.queue-list li').live('touchstart', function(){
		if (!$(this).hasClass('stay')) $(this).parents('ul').children('li').removeClass('vui-selected');
		$(this).addClass('vui-selected');
	});
	
	
	$('#queues').live('touchend',function(){
		
	});

	$('#items').live('touchend',function(){

	});
	
	$('#inventory-close').live('touchstart',function(e){
		
		$('li.temp').remove();
		
		if (sst){
			processOrders();

		} else {
			processOrders();
			if (!countItems()){
				$.ajax({
					url: base_url + 'fnbpos/ajax/cancel_instant_sale',
					type: 'post',
					data: 'queue='+currentQueue,
					success: function (){
						getQueueList();
					}
				});
			}
			
			if (instantSale){
				instantCheckout = true;
			}
			
			inventoryOpen = false;
			
			$('div.item-option').hide();
			if (currentTab == 'queues') $('#queues-tab').mouseup();
			else $('#delivery-queues-tab').mouseup();
			hideDialog('keypad');
			hideDialog('inventory');
			hideAlert('add-ok');
			hideAlert('add-failed');
			quickScan = true;
			
			if (currentTab == 'queues') $('#queue-current #'+currentQueue).addClass('vui-selected');
			else if (currentTab == 'delivery')  $('#delivery-queue-current #'+currentQueue).addClass('vui-selected');
		}
	});
	
	$('#inventory-add').live('touchstart',function(e){
		if (currentQueueType == 'queue'){

			hideAlert('add-ok');
			hideAlert('add-failed');
			addItem();
			$('#inventory-sku').val('');
			$('#inventory-qty').val(1);
			$('span.qty').text('x 1');
			
		}
	});
	
	$('#transfer').live('touchstart',function(e){
		showDialog('transfertable');
		showDialog('keypad');
		$('button.clear').hide();
		$('#transfer-number-input').focus();
	})
	
	$('#add-queue').live('touchstart',function(e){
		showDialog('newtable');
		showDialog('keypad');
		$('button.clear').hide();
		$.ajax({
			url: base_url + 'fnbpos/ajax/bnumber',
			success: function (n){
				$('#table-number-input').focus().val('B'+n).each(function(){
					this.select();
				});
			}
		})
		$('#table-number-input').focus().each(function(){
			this.select();
		});
	});
	
	$('#add-new-table').live('touchstart',function(){
		
		addQueue();
	});
	
	$('button.btn-logout').live('touchend',function(){

		var id = $(this).attr('empid');
		$.ajax({
			url: base_url + 'fnbpos/ajax/logout_device',
			type: 'post',
			data: 'id='+id,
			success: function (){
				$.ajax({
					url: base_url + 'fnbpos/ajax/indicators',
					dataType: 'json',
					success: function (json){
						if (json.status == 'Success'){
							$('div.indicator-content').html(json.html + '<br class="clearboth" />');
						}
					}
				});

			}
		})
	});
	
	$('#instant-sale').live('touchstart',function(){
		instantSale = true;
		$.ajax({
			url: base_url + 'fnbpos/ajax/create_table/',
			type: 'POST',
			data: 'table_no=0&instant=true',
			datatype: 'json',
			success: function (json){
				if (json.status == 'Success'){
					currentQueue = json.queue_id;
					$('ul.queue-current li#'+currentQueue).click();
					newQueue = true;
					$('#queues-tab').mouseup();
					hideDialog('newtable');
					hideDialog('keypad');
					$('p.table-error').text('');
					$('#table-number-input').val('B');
					$('#add-item').mouseup();

				} else {
					$('p.table-error').text('Table number already exists.');
				}
			}
		});
	});
	
	$('#transfer-table').live('touchstart',function(){
		transferTable();
	});
	
	$('input').focus(function(){
		$(this).addClass('first');
		currentTextObject = $(this);
	});
	
	$('#add-item').live('touchstart',function(e){
		inventoryOpen = true;
		if (currentQueue != 0){
			quickScan = false;

			setTimeout(function(){
				$('#item-code').focus();
			}, 300)

			showDialog('inventory');
			hideDialog('');
			$('#inventory-qty').val(1);
			$('#inventory-sku').val('');
			

		} else {
			
		}
	});


	$('#add-delivery-item').live('touchstart',function(e){
		inventoryOpen = true;

		if (currentQueue != 0){
			quickScan = false;
			showDialog('inventory');
			hideDialog('')
			$('#inventory-qty').val(1);
			$('#inventory-sku').val('');
		} else {
			
		}
	});
	


	
	$('input.vui-number').keypress(function(event){
		var key = event.which;
		var keychar = String.fromCharCode(key);
		if ((key==null) || (key==0) || (key==8) ||  (key==9) || (key==13) || (key==27) ) return true;
		else if ((("0123456789").indexOf(keychar) > -1)) return true;
		else event.preventDefault();
	});
	
	$('input.vui-number-decimal').keypress(function(event){
		var key = event.which;
		var keychar = String.fromCharCode(key);
		if ((key==null) || (key==0) || (key==8) ||  (key==9) || (key==13) || (key==27) ) return true;
		else if ((("0123456789").indexOf(keychar) > -1)) return true;
		else if (keychar == "."){
			var value = $(this).val();
			if (value.indexOf('.') > -1){
				event.preventDefault()
			}
			return true;
		}
		else event.preventDefault();
	});
	
	$('input.vui-number-decimal-money').blur(function(){
		
		var val = $(this).val();
		if (val){
			val = parseFloat($(this).val());
			$(this).val(val.toFixed(2));
		}
	});


	$('#checkout').live('touchstart',function(e){
		
		if (currentQueueType == 'queue'){
			if (countItems()){
				showDialog('pay');
				$('div.payment-cash').show();
				$('div.payment-credit-card').hide();
				$('div.payment-method').hide();
				$('#pay-cash').mouseup();
			}
		}
	});
	
	$('#checkout-delivery').live('touchstart',function(e){
		
		if (currentQueueType == 'delivery'){
			if (countItems()){
				showDialog('pay');
				$('div.payment-cash').show();
				$('div.payment-credit-card').hide();
				$('div.payment-method').hide();
				$('#pay-cash').mouseup();
			}
		}
	});

	
	
	$('#pay-cancel').live('touchstart',function(e){
		splitChecout = false;
		mainCheckout = false;

		hideDialog('pay');
		$('#keypad').hide();
	});
	
	$('#pay-cash').live('touchstart',function(e){
		$('#discount-input').val('');
		$('#discount-percent').val('');
	
		var targetLeft = ($(window).width() / 2) - 435; 
		$('#pay').css({'left':targetLeft});
		showDialog('keypad');
		$('button.clear').show();
		total = calculateGrandTotal();
		
		if (splitCheckout){
			total = calculateSplitTotal();
		} else if (mainCheckout){
			total = calculateMainTotal();
		}
		
		$('td.pay-amount-due').text(total);
		$('td.pay-total').text(total);
		$('div.payment-method').hide();
		$('div.payment-cash').show();
		$('#pay-back').show().css('left',0);
		
		customerDisplay('Total Amount Due',currency + total);
		
		
		$('#amount-tendered-input').focus().val(total);
		
		$('#amount-tendered-input').each(function(){
			this.select();
		});
		

	});
	
	$('#pay-credit-card').live('touchstart',function(e){
		$('td.pay-amount-due').text(calculateGrandTotal());
		$('div.payment-method').hide();
		$('div.payment-credit-card').show();
		$('#pay-back').show();
	});
	
	
	
	
	$('#amount-tendered-input').keypress(function(e){
		$('#amount-tendered-input').css({'background-color':'#FFFFFF','color':'#333333'});
	});
	
	$('#pay-back').live('touchstart',function(e){
		$('#pay-cancel').mouseup();
		$('div.payment-cash').hide();
		$('div.payment-credit-card').hide();
		$('div.payment-method').show();
		$('#pay-back').hide();
		$('#keypad').hide();
		splitCheckout = false;
		mainCheckout = false;
	});
	
	$('#pay-process-cash').live('touchstart',function(e){
		payProcessCash();
	});
	
	$('#pay-process-credit-card').live('touchstart',function(e){
		hideDialog('pay');
		payCreditCard();
		$('tr.confirmation-credit-card').show();
		$('#confirm-done').css('margin-top',170);
	});
	
	$('#confirm-done').live('touchstart',function(e){
		$(this).blur();
		hideDialog('confirmation');

		if (currentQueueType == 'queue'){
			getQueueList();
			getItemList();
		} else if (currenctQueueType == 'delivery'){
			getDeliveryList();			
			getDeliveryItemList();
		}

				
		$('#keypad').hide();
		
		$('#split-list').html('');
		
		customerDisplay(msg_welcome_1,msg_welcome_2);

		if (payCallback){
			$('#split').mouseup();
			payCallback = false;
		} else {
			// currentQueue = 0;
			
		}
				
	});
	
	
	
	$('#inventory-sku').keydown(function (e) {
		
	 	if (e.which == 13){
 			$('#inventory-add').mouseup();
		}
		if (e.which == 27){
			$('#inventory-close').mouseup();
		}
		KEY_STATUS.keyDown = true; 

		if (KEY_CODES[e.keyCode]) {
		  	if(e.keyCode == 40){
				var qty = parseInt($('#inventory-qty').val());
				qty--;
				if (qty > 0) $('#inventory-qty').val(qty);
				event.preventDefault();
	  		} else if(e.keyCode == 38){
				var qty = parseInt($('#inventory-qty').val());
				qty++;
				if (qty > 0) $('#inventory-qty').val(qty);
				event.preventDefault();
			}
		}

	}).keyup(function (e) {
		return true;
	});
	
	
	$('#sku').keydown(function (e) {
		
	 	if (e.which == 13){
	 		quickScan = true;
	 		$('#inventory-sku').val($(this).val());
 			$('#inventory-add').mouseup();
 			$('#amount-tendered-input').css({'background-color':'#FFFFFF','color':'#333333'});
 			$(this).val('');
		}
		if (e.which == 27){
			$('#inventory-close').mouseup();
		}
		KEY_STATUS.keyDown = true; 

		if (KEY_CODES[e.keyCode]) {
		  	if(e.keyCode == 40){
				var qty = parseInt($('#inventory-qty').val());
				qty--;
				if (qty > 0){
					$('#inventory-qty').val(qty);
					$('span.qty').text('x ' + qty);
				}
				event.preventDefault();
	  		} else if(e.keyCode == 38){
				var qty = parseInt($('#inventory-qty').val());
				qty++;
				if (qty > 0){
					$('#inventory-qty').val(qty);
					$('span.qty').text('x ' + qty);
				}
				event.preventDefault();
			}
		}

	}).keyup(function (e) {
		return true;
	});
	
	$('#reprint-receipt').live('touchstart',function(){
		window.print();
	});
	
	
	$('button.touch-numpad').live('touchstart',function(){
		if ($(this).val() == '+'){
			var qty = parseInt($('#inventory-qty').val());
			qty++;
			if (qty > 0) $('#inventory-qty').val(qty);
			$(currentTextObject).focus();
			
		} else if ($(this).val() == '-'){
			var qty = parseInt($('#inventory-qty').val());
			qty--;
			if (qty > 0) $('#inventory-qty').val(qty);
			$(currentTextObject).focus();		
			
		} else if ($(this).val() == 'delete'){
			var val = $(currentTextObject).val();
			var newVal = '';
			
			if ($(currentTextObject).hasClass('first')){
				$(currentTextObject).val('').removeClass('first');				
			}

			$(currentTextObject).val('').focus();
			$(currentTextObject).removeClass('first');
			
		} else if ($(this).val() == 'return'){
			
			$(currentTextObject).parents('div.vui-card').find('button.return-default').mouseup().click();
			$(currentTextObject).focus();
		} else {
			if ($(this).hasClass('clear')){
				$(currentTextObject).val($(this).val()).focus();

			} else {
				if ($(currentTextObject).hasClass('first')){
					$(currentTextObject).val('').removeClass('first');
				}

				var newVal = $(currentTextObject).val() + $(this).val();
				$(currentTextObject).val(newVal).focus();
				$(currentTextObject).removeClass('first');
			}
		}
		
		$(currentTextObject).change();

	});
	
	
	getQueueList();
	
	
	$('#till-count').change(function(){
		tillCount();
	});
	
	$('input').keypress(function(e){
		if (e.which == 13){
			$(this).parents('div.vui-card').find('.return-default').mouseup().click();
		}
	});
	
	$('input.filter-table-queue').keypress(function(e){
		var table = $(this).val();
		
		if (e.which == 13){
			filterTableQueue = true;
			$('li[tableno='+table+']').click();
			
			$(this).val('');
			
			
		}
	});
	
	
	$('input.filter-table').keypress(function(e){
		var table = $(this).val();
		if (e.which == 13){
			$.ajax({
				url: base_url + 'fnbpos/ajax/filter_history',
				type: 'post',
				data: 'table='+table,
				success: function (json){
					if (json.status == 'Success'){
						$('#queue-history').html(json.html);
						$('input.filter-table').each(function(){
							this.select();
						});
					}			
				}
			})
		}
	});
	
	
	$('#till-deposited').change(function(){
		tillCount();
	});
	
	$('li.item').live('touchstart',function(){
		var sku = $(this).attr('sku');
		currentItemName = $(this).text();
		currentItemPrice = parseFloat($(this).attr('price'));
		itemPrice = parseFloat($(this).attr('price'));
		if (!itemPrice) itemPrice = 0.00;
		actualPrice = itemPrice;
		if ($(this).hasClass('no-option')){
			$('#inventory-sku').val(sku);
			$('ul.browse-list li').removeClass('vui-selected');
			if ($(this).hasClass('enter-price')){
				showDialog('enter-price');
				showDialog('keypad');
				$('button.clear').show();
				$('#enter-item-price-pu').focus();
			} else {
				addItem('',itemPrice);
			}
		} else {
			
			$('small.cur-item-price').text(itemPrice.toFixed(2));
			$('#inventory-sku').val(sku);
			$('ul.browse-list li').removeClass('vui-selected');
			
			$('div.item-option[rel=item'+sku+']').show();
			$('div.item-option[rel=item'+sku+'] ul').sortable({distance: 5});
			$('li.option').removeClass('selected');		
		}
		
	});
	
	$("#cancel-enter-option").live('touchstart', function(){
		hideDialog('enter-option');
	})	
	
	$('#enter-option-btn').live('touchstart', function(){
		var option = $('#enter-item-option').val();
		var price = parseFloat($('#enter-item-option-price').val());
		$(currentItemOptionList).find('ul').append('<li class="temp selected vui-selected option stay" option="'+option+'" price="'+price.toFixed(2)+'">'+option+'</li>');
		hideDialog('enter-option');
		
		
		itemPrice = parseFloat(actualPrice);
			
		$('small.cur-item-option').text('');
		$('small.cur-item-price').text('');
			
		var x = 0;			
		$(currentItemOptionList).find('ul').find('li.selected').each(function(){
			var price = parseFloat($(this).attr('price'));
			if (!price) price = 0.00;
			var option = $(this).text();

			itemPrice = itemPrice + price;

			if (x == 0){					
				itemOption = option;
			} else {
				itemOption = itemOption + ',' + option;
			}
			x++;
		})
			
		$('small.cur-item-option').text(itemOption);			
		$('small.cur-item-price').text(itemPrice.toFixed(2));

	});
	
	$('div.item-option li.option').live('touchend',function(){
	
		if ($(this).hasClass('custom-option')){
			showDialog('enter-option')
			$('#enter-item-option').focus();
			$('#enter-option input').val('');
			
			currentItemOptionList = $(this).parents('div.item-option');

			return;
		}
	
		if (!$(this).hasClass('selected')){
		

	
			if ($(this).hasClass('nonoverlap')){
				var overlapOption = $(this).attr('nonoverlap');
				$(this).parents('ul').find('li[nonoverlap='+overlapOption+']').removeClass('selected').removeClass('vui-selected');
			}
			
			$(this).addClass('selected').addClass('vui-selected');
		
			itemPrice = parseFloat(actualPrice);
			
			$('small.cur-item-option').text('');
			$('small.cur-item-price').text('');
			
			var x = 0;			
			$(this).parents('ul').find('li.selected').each(function(){
				var price = parseFloat($(this).attr('price'));
				if (!price) price = 0.00;
				var option = $(this).text();

				itemPrice = itemPrice + price;

				if (x == 0){					
					itemOption = option;
				} else {
					itemOption = itemOption + ',' + option;
				}
				x++;
			})
			
			$('small.cur-item-option').text(itemOption);			
			$('small.cur-item-price').text(itemPrice.toFixed(2));

		} else {
			$(this).removeClass('selected').removeClass('vui-selected');
			itemOption = '';
			itemPrice = actualPrice;
			
			$(this).parents('ul.item-option').find('li.selected').each(function(){
				if (itemOption == ''){
					itemOption = $(this).text();
				} else {
					itemOption = itemOption + ',' + $(this).text();
				}

				var price = parseFloat($(this).attr('price'));
				if (!price) price = 0.00;
				itemPrice += price;
			});
			
			$('small.cur-item-option').text(itemOption);
			$('small.cur-item-price').text(itemPrice.toFixed(2));

		}
		
		currentItemPrice = itemPrice;
	});
		


});

function payProcessCash(){
	var amt = parseFloat($('#amount-tendered-input').val());
    var amtDue = parseFloat($('td.pay-amount-due').text());
    
    amtDue = Math.floor(amtDue*100)/100;
    
    if (amt < amtDue.toFixed(2) || !amt){
    	$('#amount-tendered-input').css({'background-color':'#aa0000','color':'#FFFFFF'}).focus();

    } else {
    	hideDialog('pay');
    	payCash();
    	$('tr.confirmation-credit-card').hide();
    	$('#confirm-done').css('margin-top',110);
    	$('#keypad').hide();
    }
	
}

function enterPrice(){
	var price = parseFloat($('#enter-item-price-pu').val());
	currentItemPrice = price;
	itemPrice = price;
	
	if (!price) return;
	
	customerDisplay(enterPriceDisplay, currency + price.toFixed(2));

	addItem(currency+price.toFixed(2), price);
	$('#enter-item-price-pu').val('');
	hideDialog('enter-price');
	hideDialog('keypad');
}

function moveItems(code){
	
	$('#item-code').each(function(){
		this.select();
	})
	
	$.ajax({
		url: base_url + 'fnbpos/ajax/move_items',
		type: 'post',
		data: 'code='+code+'&queue='+currentQueue,
		dataType: 'json',
		success: function(res){
			if (res.status == 'ok'){
				getItemList(true);
				$('#item-code').val('');
			}
		}
	});
}


function showDialog(id){
	if (id == 'inventory'){
		$('ul.browse-list li').removeClass('vui-selected');
		var targetLeft = 10; 
		var targetHeight = $(window).height() - 200;
		$('#'+id).css('top',20).css('height',targetHeight);
		$(window).resize();
	} else {
		var targetLeft = ($(window).width() / 2) - ($('#'+id).width() / 2);	
	}
	$('div.overlay').show();
	$('#'+id).css('left',targetLeft).show();

}

function hideDialog(id){
	$('div.overlay').hide();
	$('#'+id).hide();
}

function showAlert(id){
	var targetLeft = ($(window).width()) - ($('#'+id).width()) - 15; 
	// $('#'+id).css('left',targetLeft).show();
}

function hideAlert(id){
	$('#'+id).hide();
}


function addQueue(){
	$('p.table-error').text('');
	var table_no = $('#table-number-input').val();
	$.ajax({
		url: base_url + 'fnbpos/ajax/create_table/',
		type: 'POST',
		datatype: 'json',
		data: 'table_no='+table_no,
		success: function (json){
			if (json.status == 'Success'){
				currentQueue = json.queue_id;
				$('ul.queue-current li#'+currentQueue).click();
				newQueue = true;
				$('#queues-tab').mouseup();
				hideDialog('newtable');
				hideDialog('keypad');
				$('p.table-error').text('');
				$('#table-number-input').val('B');
				showDialog('inventory');
				inventoryOpen = true;
				hideDialog('');

			} else {
				$('p.table-error').text('Table number already exists.');
			}
		}
	});
}

function transferTable(){
	var table_no = $('#transfer-number-input').val();
	if ($('p.transfer-error').text() == 'Table number already exists. Merge table?'){
		var tableMerge = '1';
	} else {
		var tableMerge = '0'
	}

	var postdata = 'table_no='+table_no+'&merge='+tableMerge+'&queue='+currentQueue;
	

	$.ajax({
		url: base_url + 'fnbpos/ajax/transfer_table/',
		type: 'POST',
		datatype: 'json',
		data: postdata,
		success: function (json){
			if (json.status == 'Success'){
				currentQueue = json.queue_id;
				$('ul.queue-current li#'+currentQueue).click();
				newQueue = true;
				$('#queues-tab').mouseup();
				hideDialog('transfertable');
				hideDialog('keypad');
				$('p.transfer-error').text('');
				$('#transfer-number-input').val('');
			} else if (json.status == 'Invalid'){
				$('p.transfer-error').text('Invalid table number. You cannot transfer to the same table.');
			} else {
				$('p.transfer-error').text('Table number already exists. Merge table?');
			}
		}
	});
}

function voidQueue(){
	$.ajax({
		url: base_url + 'fnbpos/ajax/void_queue',
		type: 'POST',
		data: 'queue='+currentQueue,
		success: function (json){
			if (json.status == 'success'){
				$('#queues-tab').mouseup();
				currentQueue = 0;
				currentItem = 0;
			}
		}
	});
}

function addItem(option,price){
	itemOption = '';
	itemPrice = 0.00;

	
	$('small.cur-item-option').text('');
	$('small.cur-item-qty').text('1');
		
	var sku = $('#inventory-sku').val();
	qty = itemQty;
	
	itemQty = 1;
	
	if (sku == ''){
		$('#checkout').mouseup();
		return;
	}
	var displayPrice = price * qty;
	var id = sku + '-' + option.replace(' ','_');
	
	var trueState = true;
//	if (!$('#'+id).hasClass('main')){
	if (trueState){
		var ppu = price;
		if (option){
			var displayName = currentItemName+' - '+option;
		} else {
			var displayName = currentItemName;
		}
		$('#item-list').prepend('<li id="'+id+'" sku="'+sku+'" option="'+option+'" price="'+ppu+'" class="main voidable"><table class="vui-dt-row"><tr><td class="item-name" style="width: 55%"><strong style="font-size: 10pt">'+displayName+'</strong></td><td class="item-qty" style="width: 22%; text-align: center;">'+qty+'</td><td class="item-amount" style="width: 23%; text-align: right;">'+displayPrice.toFixed(2)+'</td></tr></table></li>');
	} else {
		var cur_qty = parseInt($('#'+id).find('td.item-qty').text());
		var cur_price = parseFloat($('#'+id).find('td.item-amount').text());
		displayPrice += cur_price;
		$('#'+id).find('td.item-qty').text(cur_qty + qty);
		$('#'+id).find('td.item-amount').text(displayPrice.toFixed(2));
	}
	
	var total = calculateGrandTotal();
	$('#added-item').text(currentItemName);
	$('#added-amount').text(displayPrice.toFixed(2));
	$('td.outstanding-total').text(total);
	showAlert('add-ok');
	
	
	/*
	
	$.ajax({
		url: base_url + 'fnbpos/ajax/add_item',
		type: 'POST',
		data: 'queue='+currentQueue+'&sku='+sku+'&qty='+qty+'&option='+option+'&price='+price,
		success: function (json){
			if (json.status == 'Success'){
				if (quickScan){
					$('span.founditem').show().fadeOut(500);
					getItemList();
				} else {
					showAlert('add-ok');
				}
				
				if (json.enter_price == 1){
					hideDialog('inventory');
					hideAlert('add-ok');
					showDialog('enter-price');
					showDialog('keypad');
					enterPriceID = json.id;
					enterPriceQty = qty;
					
					var totalPrice = parseFloat(json.price) * qty;
		
					$('p.enter-price-item').html(json.name + ' - ' + currency + json.price + '<br />Quantity: ' + qty);
					$('#enter-item-price-pu').val(json.price).focus().each(function(){ this.select() });
					$('#enter-item-price').val(totalPrice.toFixed(2));
					
					callback = function (){
						showDialog('inventory');
						hideDialog('');
					}
				} else {
				
				}
				
				$('#added-item').text(json.qty + ' x ' + json.name);
				$('#added-amount').text(json.amount);
				$('td.outstanding-total').text(json.outstanding);
				getQueueList();
			} else {
				if (quickScan){
					$('span.noitem').show().fadeOut(500);
				} else {
					showAlert('add-failed');			
				}
				$('td.outstanding-total').text(json.outstanding);
			}
		}
	});
	
	*/
	
}

function voidItem(){
		

	
	if ($('#items li.vui-selected').hasClass('voidable')){
		var qty = $('#items li.vui-selected').find('td.item-qty').text();
		var price = $('#items li.vui-selected').find('td.item-amount').text();
		
		var ppu = price / qty;
		
		if (qty == 1){
			$('#items li.vui-selected').remove();
			$('#void-item').hide();
		} else {
			var displayPrice = ppu * (qty - 1);
			
			$('#items li.vui-selected').find('td.item-qty').text(qty-1);
			$('#items li.vui-selected').find('td.item-amount').text(displayPrice.toFixed(2));
		
		}
		
	
		return;
	}
	


	if (revert_level == 'Manager'){
		$('tr.void-qty').show();
		managerRequest = 'fnbpos/ajax/void_item';
    	managerRequestData = 'queue='+currentQueue+'&item='+currentItem;
    	managerPerform = function(){
			getItemList();
			$('tr.void-qty').hide();
    	};
    	showDialog('permission');
    	$('#void-qty').val(1);
    		
		if ($('#access-username').val()){
	    	$('#access-password').focus();				
		} else {
			$('#access-username').focus();
		}

	   	$('#access-password').val('');
	   	$('#access-alert').text('');
    } else {
		if (currentQueueType == 'queue'){

			$.ajax({
				url: base_url + 'fnbpos/ajax/void_item',
				type: 'POST',
				dataType: 'json',
				data: 'queue='+currentQueue+'&item='+currentItem+'&qty='+qty,
				success: function (json){
					console.log(json);
					if (json.status == 'Success'){
						currentItem = 0;
					}
					getItemList();
				}
			});
		}
    }
	
	
}


function payCash(){
	var amountTendered = $('#amount-tendered-input').val();
	var discount = $('#discount-input').val();
	
	
	$('#discount-input').val('');
	
	if (splitCheckout || mainCheckout){
		var x = 0;
		var ids = '';
		var qtys = ''
		var prices = '';
		
		if (splitCheckout) var list = 'split-list';
		else var list = 'main-list';
					
		$('#' + list +  ' li').each(function(){
			var id = $(this).attr('rel');
			var qty = $(this).find('.item-qty').text();
			var price = $(this).find('.item-amount').text();

			if (x == 0){
				ids = id;
				qtys = qty;
				prices = price;
			} else {
				qtys = '' + qtys + ',' + qty;
				ids = '' + ids + ',' + id;
				prices = '' + prices + ',' + price;
			}
			x++;
		});
		
		
				
		$.ajax({
			url: base_url + 'fnbpos/ajax/checkout_split_bill/',
			data: 'queue='+currentQueue+'&ids='+ids+'&qtys='+qtys+'&prices='+prices+'&tendered='+amountTendered+'&discount='+discount,
			type: 'post',
			success: function (json){
				$('td.pay-amount-tendered').text(json.tendered);
				$('td.pay-amount-change').text(json.change);
				triggerDrawer();
				currentItem = 0;
				
				
				customerDisplay(msg_thankyou, 'Change: ' + currency + json.change);

				
				reprintReceipt(json.queue_id);
				if (json.cleared){
					payCallback = false;
				}
								
				showDialog('confirmation');
				$('#confirm-done').focus();
				doPrint = false;			
				
				
				splitCheckout = false;
				mainCheckout = false;
				
			}
		});

	} else {

		$.ajax({
			url: base_url + 'fnbpos/ajax/cash_checkout',
			type: 'POST',
			data: 'queue='+currentQueue+'&amount_tendered='+amountTendered+'&discount='+discount+'&type='+currentQueueType,
			success: function (json){
				$('td.pay-amount-tendered').text(json.tendered);
				$('td.pay-amount-change').text(json.change);
				
				customerDisplay(msg_thankyou, 'Change: ' + currency + json.change);
								
				triggerDrawer();
				currentItem = null;
				currentQueue = null;
				reprintReceipt(json.queue_id);
				showDialog('confirmation');
				$('#confirm-done').focus();
				doPrint = false;			
				
				splitCheckout = false;
				mainCheckout = false;
				
				$('div.grand-total span.grand-total').text('');
				
				

			}
		});
	}			

}

function payCreditCard(){
	var ccName = $('#ccname').val();
	var ccNumber = $('#ccnumber').val();
	var ccExpiry = $('#ccexpiry').val();
	var ccVerify = $('#ccverify').val();
	$.ajax({
		url: base_url + 'fnbpos/ajax/credit_card_checkout',
		type: 'POST',
		data: 'queue='+currentQueue+'&ccname='+ccName+'&ccnumber='+ccNumber+'&ccexpiry='+ccExpiry+'&ccverify='+ccVerify,
		success: function (json){
			$('td.pay-amount-tendered').text(json.tendered);
			$('td.pay-amount-change').text(json.change);
			currentItem = 0;
			showDialog('confirmation');
			getHistoryList();
			getItemList();
		}
	});

}

function reprintReceipt(x){
	if (x) queue = x;
	else queue = currentQueue;
	
	$('#receipt > span').text('OFFICIAL RECEIPT');
	
	$.ajax({
		url: base_url + 'fnbpos/ajax/receipt',
		type: 'POST',
		data: 'queue='+queue,
		success: function (json){
			if (json.status == 'Success'){
				$('#receipt-container').html(json.html);
				if (doPrint){
					printReceipt();
					doPrint = false;
				}
			}

		}
	});
}

function reprintBill(x){
	if (x) queue = x;
	else queue = currentQueue;
	
	$('#receipt > span').text('BILL');
	
	$.ajax({
		url: base_url + 'fnbpos/ajax/bill',
		type: 'POST',
		data: 'queue='+queue,
		success: function (json){
			if (json.status == 'Success'){
				$('#receipt-container').html(json.html);
				if (doPrint){
					printReceipt();
					doPrint = false;
				}
			}

		}
	});
}


function refreshItemList(){

}

function getQueueList(){

	$('div.qb').show();
	$('div.hb').hide();
	$('div.db').hide();
	
	$.ajax({
		url: base_url + 'fnbpos/ajax/get_queue_list',
		type: 'POST',
		success: function (json){
		
			if (json.status == 'Success'){
				$('#queue-current').html(json.html);
				if (currentQueue == 0){
					currentQueueType = 'queue';
					$('#table-number-input').val('B');
				} else {
					if (currentQueueType == 'history'){
						if (countTxn()) $('#queue-current li:first').click();
					} else {
						$('#queue-current li[id='+currentQueue+']').click();
					}
					$('#table-number-input').focus();
				}
				currentQueueType = 'queue';
				

			}

		}
	});
}

function getHistoryList(){
	currentQueueType = 'history';

	$('div.hb').show();
	$('div.qb').hide();
	$('div.db').hide();
		
	$.ajax({
		url: base_url + 'fnbpos/ajax/get_history_list',
		type: 'POST',
		success: function (json){
			if (json.status == 'Success'){
				$('#queue-history').html(json.html);
			}
		}
	});
}


function getDeliveryList(){
	currentQueueType = 'delivery';

	$('div.db').show();
	$('div.qb').hide();
	$('div.hb').hide();
	
	$.ajax({
		url: base_url + 'fnbpos/ajax/get_delivery_list',
		type: 'POST',
		success: function (json){
			if (json.status == 'Success'){
				$('#delivery-queue-current').html(json.html);
				if (currentQueue == 0){
					if (countTxn()) $('#delivery-queue-current li:first').click();
					currentQueueType = 'delivery';
				} else {
					$('#delivery-queue-current li#'+currentQueue).click();
				}
				currentQueueType = 'delivery';
			}
		}
	});
}

function getDeliveryItemList(){

	if (inventoryOpen){
	 return;
	}
	
	// $('#item-list').html('Loading...');
	// $('td.item-amount').remove();
	$.ajax({
		url: base_url + 'fnbpos/ajax/get_delivery_item_list',
		type: 'POST',
		data: 'queue='+currentQueue,
		success: function (json){
			if (json.status == 'Success'){
				$('#item-list').html(json.html);
				if (currentQueueType == 'history'){
					if (json.discount && json.discount != '0'){
						$('span.grand-total').text(json.discount + '% - ' + json.amount);
					} else {
						$('span.grand-total').text(json.amount);
					}
					
					reprintReceipt();
				} else {
					calculateGrandTotal();
				}

				if (instantCheckout){
					instantSale = false;
					instantCheckout = false;
	
					if (countItems()){
						showDialog('pay');
						$('div.payment-cash').show();
						$('div.payment-credit-card').hide();
						$('div.payment-method').hide();
						$('#pay-cash').mouseup();
					}
		
				}


			}
			
			if (filterTableQueue){
				$('#checkout').mouseup();
				filterTableQueue = false;
			}
			
			
		}
	});


}

function getItemList(ignore){

	if (!ignore){
		if (inventoryOpen){
			return;
		}
	}
	
	if ($('#'+currentQueue).hasClass('unverified')){
		$('#verify-order').show();
		$('#cancel-order').show();
	} else {
		$('#verify-order').hide();
		$('#cancel-order').hide();			
	}
	

	
	// $('#item-list').html('Loading...');
	// $('td.item-amount').remove();
	$.ajax({
		url: base_url + 'fnbpos/ajax/get_item_list',
		type: 'POST',
		data: 'queue='+currentQueue,
		success: function (json){
			if (json.status == 'Success'){
				$('#item-list').html(json.html);

				if (currentQueueType == 'history'){
					if (json.discount && json.discount != '0'){

						var percent = (parseFloat(json.discount) / json.amount) * 100;
						var discount = '(-' + (parseFloat(json.discount)).toFixed(2) + ')';
						$('span.grand-total').html('<small style="font-size: 11pt; float: left; margin-top: 10px; margin-right: 10px; ">Discount ' + discount + '</small> - ' + json.amount);
					} else {
						$('span.grand-total').text(json.amount);
					}
					
					reprintReceipt();
				} else {
					calculateGrandTotal();
				}

				if (instantCheckout){
					instantSale = false;
					instantCheckout = false;
	
					if (countItems()){
						showDialog('pay');
						$('div.payment-cash').show();
						$('div.payment-credit-card').hide();
						$('div.payment-method').hide();
						$('#pay-cash').mouseup();
					}
		
				}


			}
			
			if (filterTableQueue){
				$('#checkout').mouseup();
				filterTableQueue = false;
			}
			
			
		}
	});
	

}

function calculateGrandTotal(){
	var grandTotal = 0.00;
	$('#items td.item-amount').each(function(){
		grandTotal += parseFloat($(this).text());
	});
	
	$('span.grand-total').text(grandTotal.toFixed(2));
	return grandTotal.toFixed(2);
}

function printReceipt(){

}


function cashCount(){

	getTillCountData();
	var targetLeft = ($(window).width() / 2) - 535; 

	showDialog('logout');
	$('#logout').css('left',targetLeft);
	
	showDialog('keypad');
	$('#till-count').focus();
	
	triggerDrawer();
			
}

function cashCountConfirm(){
	var username = $('#verify-username').val();
	var password = $('#verify-password').val();
	var deposited = $('#till-deposited').val();
	var discrepancy = $('#till-discrepancy').text();
	var expected = $('#till-expected').text();
	var counted = $('#till-counted').val();
	
	showDialog();

	$.ajax({
		url: base_url + 'fnbpos/logout',
		data: 'username='+username+'&password='+password+'&deposited='+deposited+'&counted='+counted+'&expected='+expected+'&discrepancy='+discrepancy,
		type: 'POST',
		dataType: 'json',
		success: function (res){

			if (res.response == 'false1' ){
				var targetLeft = ($(window).width() / 2) - 535; 
			
				showDialog('logout');
				$('#logout').css('left',targetLeft);
				
				showDialog('keypad');
				$('#till-count').focus();			
			
				$('td.errMsg').text('Invalid username or password.');
			} else if (res.response == 'false2'){
				var targetLeft = ($(window).width() / 2) - 535; 
			
				showDialog('logout');
				$('#logout').css('left',targetLeft);
				
				showDialog('keypad');
				$('#till-count').focus();
			
			
				$('td.errMsg').text('This user may not verify cash count.');
			} else {
				
				$('div.cashcount').hide();
				$('div.cashcount-logout').show();
				printReport();
				hideDialog('keypad');
				showDialog('logout');

	
			}
		}
	});
}

function tillCount(){
	var expected = parseFloat($('#till-expected').text());
	var count = parseFloat($('#till-count').val());
	var deposited = parseFloat($('#till-deposited').val());
	
	if (!count) count = 0.00;
	if (!deposited) deposited = 0.00;
	

	var discrepancy = parseFloat(count - expected);
	var remaining = parseFloat(count - deposited);
	
	$('#till-discrepancy').text(discrepancy.toFixed(2));
	$('#till-remaining').text(remaining.toFixed(2));
}

function verifyCashCount(){
	var username = $('#verify-username').val();
	var password = $('#verify-password').val();
	var tillCounted = $('#till-counted').val();
	var tillDeposited = $('#till-deposited').val();
}

function logout(){
	window.location = base_url + 'fnbpos';
}

function countTxn(){
	var x = 0;
	$('#queue-current li').each(function(){
		x++;
	});
	return x;
}

function countItems(){
	var x = 0;
	$('ul.item-list li').each(function(){
		x++;
	});
	return x;
}

function triggerDrawer(){
	$.ajax({
		url: trigger_url,
		success: function(){}
	});
}

function printReport(){
	var html = $('#report').html();
	$('#receipt').html(html);

	// window.print();
	setTimeout('logout()',3000);
}

function countDenominations(){
	var denTotal = 0.00;
	$('input.count-den').each(function(){
		var denVal = parseFloat($(this).attr('key'));
		var denQty = parseInt($(this).val());
		if (!denQty) denQty = 0;
		denTotal += (denVal * denQty);
	})
	
	$('#till-count').val(denTotal.toFixed(2)).change();
}

function updateRoutine(){
	if (currentQueueType == 'queue'){
		
		$.ajax({
			url: base_url + 'fnbpos/ajax/get_queue_list',
			type: 'POST',
			success: function (json){
	
				if (inventoryOpen) return;
				if (json.status == 'Success'){
					$('#queue-current').html(json.html);
					if (currentQueue == 0){
						currentQueueType = 'queue';
					} else {
						if (!currentQueue) return;
						$('#queue-current #'+currentQueue).addClass('vui-selected');
						
						if ($('#queue-current #'+currentQueue).find('span.gt').text() != $('div.grand-total span.grand-total').text()){
							$('#queue-current #'+currentQueue).click();
						}
						if (currentQueueType == 'history'){
	
						} else {
	
						}
					}
					currentQueueType = 'queue';				
					
	
				}
	
			}
		});
		
		
	} else if (currentQueueType == 'delivery'){
		
		$.ajax({
			url: base_url + 'fnbpos/ajax/get_delivery_list',
			type: 'POST',
			success: function (json){
	
				if (inventoryOpen) return;
				if (json.status == 'Success'){
					$('#delivery-queue-current').html(json.html);
					if (currentQueue == 0){
						currentQueueType = 'delivery';
					} else {
						if (!currentQueue) return;
						$('#delivery-queue-current #'+currentQueue).addClass('vui-selected');
						
						if ($('#delivery-queue-current #'+currentQueue).find('span.gt').text() != $('div.grand-total span.grand-total').text()){
							$('#delivery-queue-current #'+currentQueue).click();
						}
						if (currentQueueType == 'history'){
	
						} else {
	
						}
					}
					currentQueueType = 'delivery';				
					
	
				}
	
			}
		});
		
		
	}

	
	$.ajax({
		url: base_url + 'fnbpos/ajax/indicators',
		dataType: 'json',
		success: function (json){
			if (json.status == 'Success'){
				$('div.indicator-content').html(json.html + '<br class="clearboth" />');
			}
		}
	});

}


function calculateSplitTotal(){
	var amount = 0.00;
	var totalMain = 0.00;
	var totalSplit = 0.00;
	$('#main-list li').each(function(){
		amount = parseFloat($(this).find('.item-amount').text());
		if (!amount) amount = 0.00;
		totalMain += amount;
	});
	
	$('#split-list li').each(function(){
		amount = parseFloat($(this).find('.item-amount').text());
		if (!amount) amount = 0.00;
		totalSplit += amount;
	});
	
	$('span.main-grand-total').text(totalMain.toFixed(2));
	$('span.split-grand-total').text(totalSplit.toFixed(2));

	return totalSplit.toFixed(2);

}

function calculateMainTotal(){
	var amount = 0.00;
	var totalMain = 0.00;
	var totalSplit = 0.00;
	$('#main-list li').each(function(){
		amount = parseFloat($(this).find('.item-amount').text());
		if (!amount) amount = 0.00;
		totalMain += amount;
	});
	
	
	$('#split-list li').each(function(){
		amount = parseFloat($(this).find('.item-amount').text());
		if (!amount) amount = 0.00;
		totalSplit += amount;
	});
	
	$('span.main-grand-total').text(totalMain.toFixed(2));
	$('span.split-grand-total').text(totalSplit.toFixed(2));
	
	return totalMain.toFixed(2);

}


function processSplit(){
	var x = 0;
	var ids = '';
	var qtys = ''
	var prices = '';
	var main_tendered = $('input.split-tendered').val();
	
	$('#split-list li').each(function(){
		var id = $(this).attr('rel');
		var qty = $(this).find('.item-qty').text();
		var price = $(this).find('.item-amount').text();
		
		if (x == 0){
			ids = id;
			qtys = qty;
			prices = price;
		} else {
			qtys = qtys + ',' + qty;
			ids = ids + ',' + id;
			prices = prices + ',' + price;
		}
		
		$.ajax({
			url: base_url + 'fnbpos/ajax/checkout_split_bill/',
			data: 'queue='+currentQueue+'&ids='+ids+'&qtys='+qtys+'&prices='+prices+'&tendered='+main_tendered,
			type: 'post',
			success: function (){
				
				$('#split-list').html('');
				$('#split').mouseup();
			}
		})
		
		
	});
}

function processOrders(){
	if (sst){
		submitOrder();
	} else {
		if (currentTab == 'queues') submitOrder();
		else if (currentTab == 'delivery') submitDeliveryOrder();
	}
}




function submitDeliveryOrder(){
	// Post data variables
	var sku = '';
	var price = '';
	var option = '';
	var qty = '';
	
	// Loop increment default
	var x = 0;
	
	// Loop through all unsubmitted items from order list
	$('#item-list').find('li.voidable').each(function(){
		if (x == 0){
			// Initially set the the post data variable with the values directly
			sku = $(this).attr('sku');
			price = $(this).attr('price');
			option = $(this).attr('option');
			qty = $(this).find('td.item-qty').text();
		} else {
			// After initial item, append with a separator
			var curOpt = $(this).attr('option');
			if (!curOpt) curOpt = ' ';
			sku = sku + ',' + $(this).attr('sku');
			price = price + ',' + $(this).attr('price');
			option = option + '|' + curOpt;
			qty = qty + ',' + $(this).find('td.item-qty').text();
		}
		// Increment
		x++;
	});
	
	// If the increment equals to 0
	if (x == 0){
		// There are no items to submit therefore alert the user
		return;
	}
	
	// Prepare the post data
	var postData = 'sale_id='+currentQueue+'&sku='+sku+'&price='+price+'&option='+option+'&qty='+qty

	// Perform ajax
	$.ajax({
		url: base_url + 'fnbpos/ajax/submit_delivery_order/',
		type: 'post',
		data: postData,
		success: function (){

		}
	})
	

}

function submitOrder(){
	// Post data variables
	var sku = '';
	var price = '';
	var option = '';
	var qty = '';
	
	// Loop increment default
	var x = 0;
	
	// Loop through all unsubmitted items from order list
	$('#item-list').find('li.voidable').each(function(){
		if (x == 0){
			// Initially set the the post data variable with the values directly
			sku = $(this).attr('sku');
			price = $(this).attr('price');
			option = $(this).attr('option');
			qty = $(this).find('td.item-qty').text();
		} else {
			// After initial item, append with a separator
			var curOpt = $(this).attr('option');
			if (!curOpt) curOpt = ' ';
			sku = sku + ',' + $(this).attr('sku');
			price = price + ',' + $(this).attr('price');
			option = option + '|' + curOpt;
			qty = qty + ',' + $(this).find('td.item-qty').text();
		}
		// Increment
		x++;
	});
	
	// If the increment equals to 0
	if (x == 0){
		// There are no items to submit therefore alert the user
		return;
	}
	
	// Prepare the post data
	
	var serial = new Date().getTime() + '' + Math.floor((Math.random()*99)+1) + '' + Math.floor((Math.random()*99)+1);
	
	var postData = 'sale_id='+currentQueue+'&sku='+sku+'&price='+price+'&option='+option+'&qty='+qty+'&serial='+serial;

	if (sst){

		// Perform ajax
		$.ajax({
			url: base_url + 'fnbpos/ajax/submit_sst_order/',
			type: 'post',
			data: postData,
			dataType: 'json',
			success: function (res){

				if (res.status == 'ok'){
					$('#item-list').html('');					
				}
				

			}
		})
		
	} else {
		// Perform ajax
		$.ajax({
			url: base_url + 'fnbpos/ajax/submit_order/',
			type: 'post',
			data: postData,
			success: function (){
	
			}
		})
		
	}
	

}


function customerDisplay(line1, line2){
	if (display_url){
		$.ajax({
			url: display_url,
			data: 'line1='+line1+'&line2='+line2,
			type: 'post',
			success: function(res){
				console.log('DIS CALLED');
				console.log('DIS LINE 1: ' + line1);
				console.log('DIS LINE 2: ' + line2);
			}
		});
	}
}
