$(document).ready(function(){
	
	$('#audit-card').click(function(){
		$(this).text('Loading...');
		var that = this;
		$.ajax({
			url: 'fnbpos/ajax/card_audit_start',
			success: function(){
				$('.audit-form').show(); 
				$(that).hide()				
			}
		})
		
		
	})
	
	$('#audit-scan').keypress(function(e){
				
		if (e.keyCode == '13'){
			
			var card_no = $(this).val();
			
			$('#audit-scan').val('Submitting...');
			
			$.ajax({
				url: 'fnbpos/ajax/card_audit_scan',
				type: 'post',
				data: {
					card_no: card_no
				},
				success: function(){
					reloadList();
					
					$('#audit-scan').val('');
				}
			})
		
		}
	})
	
	$('#card-view').click(function(){
		$('#card-view').toggleClass('vui-btn-blue');
		$('.card-layout').toggle();
		reloadList();
	})
	
	$('#add-card').click(function(){
		var card_no = $('input.card-no').val();
		if (!card_no){
			popupAlert('Error','Please enter card number');
			return;
		}
		
		var short_no = $('input.card-short-no').val();
		if (!short_no){
			popupAlert('Error','Please enter short number');
			return;
		}
		
		if (short_no.trim().length < 4){
			popupAlert('Error','Short number must be at least 4 characters long');
			return;
		}
		
		$.ajax({
			url: 'fnbpos/ajax/card_add',
			type: 'post',
			data: 'card_no='+card_no+'&short_no='+short_no,
			dataType: 'json',
			success: function(json){
				if (json.status == 'invalid1'){
					
					popupAlert('Error','Short number is already used');
					$('input.card-short-no')[0].select();
					return;
				}
				
				if (json.status == 'invalid2'){
					popupAlert('Error','Card number is already used');					
					$('input.card-no')[0].select();
					return;
				}
				
				$('input.card-no').val('');
				$('input.card-short-no').val('');
				
				reloadList();
			}
		})
	})
	
	
})


function reloadList(){
	$.ajax({
		url: 'fnbpos/ajax/card_list',
		type: 'post',
		dataType: 'json',
		success: function(json){
			$('#card-list tbody').html(json.html);
			var h = $(window).height() - 300;
			$('#card-list-container').css('height',h);
		}
	})
}

function deleteCard(id){
	
	popupConfirm('Delete Card', 'Are you sure you want to delete this card?',function(){
		$.ajax({
			url: 'fnbpos/ajax/card_delete',
			type: 'post',
			data: 'id='+id,
			dataType: 'json',
			success: function(json){
				reloadList();
			}
		})
		
	})
}