var inventorySynchronized = false;
var itemSyncBuffer = 200;

var db = window.openDatabase("plexcloud", "", "plexcloud",  1000 * 1024);



$(document).ready(function(){

	sysAlert('Initializing...', 'EXPLICIT');
	
	if (localStorage.getItem('dbInitialized') != 1){
		clearDB(function(){
			initDB();
			localStorage.setItem('dbInitialized', 1);
		})
	} else {
		setTimeout(function(){
			sysAlert('Completed', 'EXPLICIT');
			fadeSysAlert();
			$('#home').show();
		}, 500);
	}

	
});

function resyncDB(){
	sysAlert('Resync Data', 'EXPLICIT');
	clearDB(function(){
		initDB();		
	})
}


function syncTime(){
	var start = Date.now();
	$.ajax({
		url: 'pos/sync/time',
		type: 'post',
		data: 'time='+start.getTime(),
		success: function(){
			
		}
	})
}

function clearDB(callback){
	db.transaction(function(tx){
		tx.executeSql("DROP TABLE IF EXISTS cache");
		tx.executeSql("DROP TABLE IF EXISTS inventory",[],function(){

			try {
				callback();
			} catch (err){
				// do nothing
			}
		});
	});
}

var __table_inventory = { 
	name: 'inventory',
	fields: {
		id				: 'INT',
		category		: 'TEXT',
		subcategory		: 'TEXT',
		frontend_subcategory : 'TEXT',
		frontend_name		 : 'TEXT',
		frontend_show		 : 'TEXT',
		location		: 'TEXT',
		name			: 'TEXT',
		sku				: 'TEXT',
		si_item_id		: 'INT',
		qty				: 'INT',
		cost			: 'TEXT',
		item_price		: 'TEXT',
		price			: 'TEXT',
		has_options		: 'TEXT',
		has_customer_options: 'TEXT',
		customer_price	: 'TEXT',
		customer_options: 'TEXT',
		options			: 'TEXT',
		supplier		: 'TEXT',
		description		: 'TEXT',
		remarks			: 'TEXT',
		is_active		: 'TEXT',
		is_consigned	: 'TEXT',
		alert_quantity	: 'INT',
		max_quantity	: 'INT',
		ordered_quantity: 'INT',
		added_on		: 'TEXT',
		added_by		: 'TEXT',
		modified_on		: 'TEXT',
		modified_by		: 'TEXT',
		quick			: 'INT',
		enter_price		: 'INT',
		order			: 'INT',
		category_order	: 'INT',
		iphone			: 'INT',
		grouped			: 'INT',
		printer			: 'TEXT',
		purchase_tax_code	: 'TEXT',
		purchase_taxable	: 'TEXT',
		supply_tax_code		: 'TEXT',
		supply_taxable		: 'TEXT'
	}
};


var __table_cache = {
	name: 'cache',
	fields: {
		info			: 'TEXT',
		values			: 'TEXT'
	}
};


function dbCreateTable(tableData){
	var sql = 'CREATE TABLE IF NOT EXISTS ' + tableData.name + '(';
	
	var x = 0;
	for (var field in tableData.fields){
		if (x == 0) sql += '`' + field + '` ' + tableData.fields[field];
		else sql += ', `' + field + '` ' + tableData.fields[field];
		
		x++;
	}
	sql += ')';
	
	console.log(sql);
	
	
	db.transaction(function(tx){
		tx.executeSql(sql);
	});
}


function initDB(){
	
	dbCreateTable(__table_cache);
	dbCreateTable(__table_inventory);
	    	
    setTimeout(function(){
    	synchronizeInventory(0);
    }, 200);
		

}


function synchronizeInventory(i){
	
	sysAlert('SYNC: REQUESTING INVENTORY DATA', 'IMPLICIT');
	sysAlert('Requesting Inventory Data', 'EXPLICIT');
	
	$.ajax({
		url: base_url + 'iphone/sync/request_inventory',
		data: 'buffer='+itemSyncBuffer+'&position='+i,
		type: 'post',
		dataType: 'json',
		success: function(res){
			
			console.log('REQUESTED 2');
			
			if (i != 0) base = i * itemSyncBuffer;
			else base = 0;
			
			sysAlert('SYNC: SYNCRHONIZING INVENTORY DATA BUFFER:' + i, 'IMPLICIT');
			sysAlert('SYNC: ITEMS BUFFER - ' + (res.results).length, 'IMPLICIT');


			
			for (var x = 0; x < (res.results).length; x++){
				sysAlert('SYNC: ITEM - ' + (base + x + 1), 'IMPLICIT');
				sysAlert('Synchronizing Item ' +  (base + x + 1), 'EXPLICIT');
				var item = res.results[x];

				getData('inventory','id = ' + item.id,function(res,xitem){
					if (!res) insertData('inventory', xitem);
				}, item);
			}
			
			if (!res.complete) synchronizeInventory(i+1);
			else {
				sysAlert('Synchronization Complete!', 'EXPLICIT');
				fadeSysAlert();
				$('#home').show();
			}
		}
	});
	
}

function synchronizeUsers(){
	sysAlert('SYNC: REQUESTING USER DATA', 'IMPLICIT');
	sysAlert('Requesting User Data', 'EXPLICIT');
	
	var request = $.ajax({
		url: base_url + 'pos/sync/users',
		dataType: 'json',
		success: function (res){
			sysAlert('SYNC: SYNCRHONIZING USER DATA', 'IMPLICIT');
			
			for (var x = 0; x < (res.user_data).length; x++){
				sysAlert('SYNC: USER - ' + (x + 1), 'IMPLICIT');
				var user_data = res.user_data[x] ;
				
				getData('users','id = ' + user_data.id, function(res, xuser_data){

					if (!res){
						insertData('users',xuser_data, function(){
							sysAlert('SYNC: ADDED USER', 'IMPLICIT');					
						});
					} else {
						updateData('users', xuser_data, 'id = '+ xuser_data.id, function(){
							sysAlert('SYNC: UPDATED USER', 'IMPLICIT');
						});
					}
				}, user_data);
			}
		}
		
	})
}

function synchronizeSalesSession(){
	sysAlert('SYNC: REQUESTING SALES SESSION DATA', 'IMPLICIT');
	sysAlert('Requesting Session Sales Data', 'EXPLICIT');
	
	var request = $.ajax({
		url: base_url + 'pos/sync/session_sales_data',
		dataType: 'json',
		success: function(res){
			sysAlert('SYNC: SYNCRHONIZING SESSION SALES DATA', 'IMPLICIT');
			
			for (var x = 0; x < (res.sales_data).length; x++){
				sysAlert('SYNC: SALE - ' + (x + 1), 'IMPLICIT');
				sysAlert('Synchronizing Sale Entry ' + (x + 1), 'EXPLICIT');
				var sale_data = res.sales_data[x];

				getData('sales','id = ' + sale_data.id,function(res, xsale_data){
					if (!res) insertData('sales',xsale_data);
				}, sale_data);
			}

			for (var x = 0; x < (res.sale_items_data).length; x++){
				sysAlert('SYNC: SALE ITEM - ' + (x + 1), 'IMPLICIT');
				sysAlert('Synchronizing Sale Items Entry ' + (x + 1), 'EXPLICIT');
				var sale_item_data = res.sale_items_data[x];

				getData('sale_items','id = ' + sale_item_data.id,function(res, xsale_item_data){
					if (!res) insertData('sale_items',xsale_item_data);
				}, sale_item_data);
			}
			
			sysAlert('Synchronization Complete!', 'EXPLICIT');
			fadeSysAlert();

		}
	})
}


function upSync(){
	
	db.transaction(function(tx){
		console.log('UP SYNC LEVEL 1');
		tx.executeSql("SELECT * FROM sales WHERE type = 'history' AND sync = '0'", [], function(tx,res){
			console.log('UP SYNC LEVEL 2');
			syncSales = [];
			syncSaleItems = [];
			
			
			if (!res.rows.length) return;
			for (var i = 0; i < res.rows.length; i++){
				syncSales[i] = res.rows.item(i);;
			}
			
			tx.executeSql("SELECT * FROM sale_items WHERE sold = '1' AND sync = '0'", [], function(tx,res){
				console.log('UP SYNC LEVEL 3');
				
				if (!res.rows.length) return;	
				for (var i = 0; i < res.rows.length; i++){
					syncSaleItems[i] = res.rows.item(i);
				}
				
				var sales = JSON.stringify(syncSales);
				var sale_items = JSON.stringify(syncSaleItems);
				

				$.ajax({
					url: base_url + 'pos/sync/upstream_sync_sales',
					type: 'post',
					data: 'sales='+encodeURIComponent(sales)+'&sale_items='+encodeURIComponent(sale_items),
					dataType: 'json',
					success: function (data){
						console.log(data);
						
						for (var i = 0; i < data.length; i++){
							var sale = data[i];
							console.log('SERIALIZE ' + sale.pseudo_id);
							reserializeSync(sale.id, sale.pseudo_id, sale.time);
						}
						
						sysAlert('Synchronized', 'EXPLICIT');
						fadeSysAlert();
					}
					
				})
				
			});
			
		});
		
	})
}

function reserializeSync(id, pseudo_id, time){
	db.transaction(function(tx){

		tx.executeSql("UPDATE sales SET id = ?, sync_time = ?, sync = '1' WHERE pseudo_id = ?", [id, time, pseudo_id], function(tx,res){
			console.log('RESERIALIZE SALE ' + pseudo_id + ' TO ' + id + ' TIME ' + time);
		});
		
		tx.executeSql("UPDATE sale_items SET sale_id = ? WHERE pseudo_id = ?",[id, pseudo_id], function(tx,res){
			console.log('RESERIALIZE SALE ITEMS ' + pseudo_id + ' TO ' + id + ' TIME ' + time);
		});

	});

}





function sysAlert(alertText, type){
	switch (type){
		case "EXPLICIT":
			$('div.explicit').html(alertText).show();
			$('div.overlay').show();
			break;
		case "IMPLICIT":
			// 	console.log(alertText);
			break;
		case "SUBTLE":
			$('div.explicit').html(alertText).show();
			break;
		default: 
			alert(alertText);
			break;
	}
}

function fadeSysAlert(){
	$('div.overlay').hide();
	setTimeout(function(){
		$('div.explicit').hide();
	}, 400);
}

function getData(table, where, callback, xitem){

	db.transaction(function(tx){
	    tx.executeSql('SELECT * FROM ' + table + ' WHERE ' + where,[], function(tx, res){
	    	if (res.rows.length){
	    		try {
	    			callback(res.rows.item(0), xitem);
	    		} catch (err){
	    			// do nothing
	    		}
	    	} else {
	    		try {
	    			callback(false, xitem);
	    		} catch (err){
	    			// do nothing
	    		}
	    	} 
	    })
	});
}

function insertData(table, data, callback){
	setTimeout(function(){
		db.transaction(function(tx){	
			var fields = '';
			var values = '';
			for (var field in data){
				if (!fields) fields += '`' + field + '`';
				else fields += ', `' + field + '`';
				
				var escapedValue = (data[field] + '').replace("'","\'");
				
				if (!values) values += "'" + escapedValue + "'";
				else values += ', ' + "'" + escapedValue + "'";
			}
			
			var sqlString = 'INSERT INTO ' + table;
			sqlString += ' (' + fields + ') ';
			sqlString += ' VALUES (' + values + ')';
			
	
			tx.executeSql(sqlString,[],function(){
				try {
					callback();
				} catch(err) {
					// do nothing{
				}
			});
		});
	}, 1);
}

function updateData(table, data, where, callback){
	setTimeout(function(){
		db.transaction(function(tx){	
	
			var set = '';
			for (var field in data){
				
				var escapedValue = (data[field] + '').replace("'","\'");
				
				if (!set) set += field + " = '"  + escapedValue + "'";
				else set += ', ' + field + " = '"  + escapedValue + "'";
			}
			
			var sqlString = 'UPDATE ' + table;
			sqlString += ' SET ' + set;
			sqlString += ' WHERE ' + where;
			
	
			tx.executeSql(sqlString,[],function(){
				try {
					callback();
				} catch (err) {
					// do nothing
				}
			});
		});
	}, 1);
}

function deleteRow(table, where, callback){
	db.transaction(function(tx){
		var sqlString = 'DELETE FROM ' + table;
		sqlString += ' WHERE ' + where;
		
		tx.executeSql(sqlString);
		
		try {
			callback()
		} catch(err) {
			// do nothing
		}
	});
}


JSON.stringify = JSON.stringify || function (obj) {
    var t = typeof (obj);
    if (t != "object" || obj === null) {
        // simple data type
        if (t == "string") obj = '"'+obj+'"';
        return String(obj);
    }
    else {
        // recurse array or object
        var n, v, json = [], arr = (obj && obj.constructor == Array);
        for (n in obj) {
            v = obj[n]; t = typeof(v);
            if (t == "string") v = '"'+v+'"';
            else if (t == "object" && v !== null) v = JSON.stringify(v);
            json.push((arr ? "" : '"' + n + '":') + String(v));
        }
        return (arr ? "[" : "{") + String(json) + (arr ? "]" : "}");
    }
};
