var navHistory = new Array();

$(document).ready(function(){
	goto(currentScreen);
	
	// Back button tap event
	$('#btn-back').live('touchend',function(){
		// Navigate back
		back();
	});
	
	// Tabs item tap event
	$('ul.tab li').live('touchend',function(){
		// Remove tabs 'current' state
		$(this).parents('ul.tab').children('li').removeClass('current');
		
		// Set 'current' state to the tapped tab
		$(this).addClass('current');
	});

	// Selectable list touch start event 
	$('ul.select-list li').live('touchstart',function(){
		
		// Remove list item 'current' state
		if (!$(this).hasClass('stay')) $(this).parents('ul').children('li').removeClass('current');
		
		// Set 'current' state to the touched start list item
		$(this).addClass('current');
	});
	
	
});


// Screen navigate function
// param: String screen

function goto(screen){
	// Hide all topbar button
	$('div.topbar button').hide();
	
	// Show topbar buttons related to current screen
	$('div.topbar button[rel='+screen+']').show();
	
	// Hide all screens
	$('div.screen').hide();
	
	// Show specified screen
	$('#'+screen).show();
	
	// Check if screen allows to navigate back
	if ($('#'+screen).hasClass('allow-back')){
		// If allow, show back button
		$('#btn-back').show();
	}

	navHistory.push(currentScreen);
}

// Screen navigate back function

function back(){
	// Get previous navigation screen 
	var x = navHistory.pop();

	// Hide all topbar buttons
	$('div.topbar button').hide();
	
	// Show topbar button related to previous screen
	$('div.topbar button[rel='+x+']').show();
	
	// Hide all screens
	$('div.screen').hide();
	
	// Show previous screen
	$('#'+x).show();
	
	// Check if screen allows to navigate back
	if ($('#'+x).hasClass('allow-back')){
		// If allow, show back button
		$('#btn-back').show();
	}	
}

// Set top bar title function
// param: String title

function title(title){
	$('span.topbar-title').text(title);
}

// Show overlay screen function
// param: String screen

function show(screen){
	$('div.overlay').show();
	$('#'+screen).show();
}

// Hide overlay screen function
// param: String screen

function hide(screen){
	$('div.overlay').hide();
	$('#'+screen).hide();
}