var layoutDesignMode = false;
var layoutTable = 0;

$(document).ready(function(){
	
	$('#table-view').mouseup(function(){
		toggleLayout();
	});
	
	$('#layout-close').click(function(){
		toggleLayout();
		$(this).toggleClass('vui-btn-blue');
	})
	
	$('#layout-design').click(function(){
		if ($(this).hasClass('design-mode')){
			designDone();
			$(this).text('Design').removeClass('design-mode').removeClass('vui-btn-green');
		} else {
			designTable();
			$(this).text('Done').addClass('design-mode').addClass('vui-btn-green');
			
		}
	})
	
	$('#layout-delete-table').mouseup(function(){
		$('.layout-current').remove();
		saveLayout();
	})

	
	$('#layout-add-table').mouseup(function(){
		showDialog('newtablelayout');
		$('#layout-table-number-input').val('').focus();
	})
	
	$('#layout-table-number-input').keypress(function(e){
		if (e.keyCode == 13){
			$('#layout-add-new-table').mouseup();
		}
	})
	
	$('.layout-unit').live('dblclick',function(){
		var table = ($(this).text()).trim();
		if ($('li[tableno='+table+']').length == 0){
			showDialog('newtable');
			showDialog('keypad');
			$('button.clear').hide();
			$('#table-number-input').val(table);
			$('#table-pax-input').val('').focus();
			toggleLayout();
		} else {
			$('li[tableno='+table+']').click();
			toggleLayout();
			$('#tableaction h3').text('Table ' + table);
			showDialog('tableaction');
			layoutTable = table;
		}
	})
	
	$('#action-checkout').mouseup(function(){
		hideDialog('tableaction');
		$('#checkout').mouseup();
		$('#checkout').trigger('touchend');
	})
	
	$('#action-split').mouseup(function(){
		hideDialog('tableaction');
		$('#split').mouseup();
		$('#split').trigger('touchend');
	})
	
	$('#action-discount').mouseup(function(){
		hideDialog('tableaction');
		$('#discount').mouseup();
		$('#discount').trigger('touchend');
	})
	
	$('#action-bill').mouseup(function(){
		hideDialog('tableaction');
		setTimeout(function(){
			$('#print_bill').mousedown();
			$('#print_bill').trigger('touchend');
		}, 10);
	})
	
	
	$('#action-transfer').mouseup(function(){
		hideDialog('tableaction');
		setTimeout(function(){
			$('#transfer').mouseup();
			$('#transfer').trigger('touchend');
		}, 10);
	})
	

	
	$('#action-add-item').mouseup(function(){
		hideDialog('tableaction');
		$('li[tableno='+layoutTable+']').dblclick();
	})
	
	
	$('#layout-table-back').mouseup(function(){
		hideDialog('newtablelayout');
	})
	
	$('#layout-add-new-table').mouseup(function(){
		var table = $('#layout-table-number-input').val();
		$('.table-layout').append('<div class="layout-unit">'+table+'</div>');
		popolateDraggables();
		hideDialog('newtablelayout');
	});
	
	$('.layout-unit').live('mousedown',function(){
		if (layoutDesignMode){
			$('.layout-unit').removeClass('layout-current')
			$(this).addClass('layout-current');
		}
	})
	
})

function designTable(){
	layoutDesignMode = true;
	$('.design-btn').show();
	popolateDraggables();
}

function popolateDraggables(){
	$('.layout-unit').draggable({
		containment: "#layout-container",
		grid: [ 15, 10 ] ,
		stop: function(){
			saveLayout();
		}
	})
}

function designDone(){
	layoutDesignMode = false;
	$('.design-btn').hide();
	$('.layout-unit').removeClass('layout-current')
	$( ".layout-unit" ).draggable("destroy");
	
}

function saveLayout(){
	var tables = [];
	
	$('.layout-unit').each(function(){
		var table = {
			table: ($(this).text()).trim(),
			position: $(this).position()
		}
		
		tables.push(table);
	})
	
	$.ajax({
		url: 'fnbpos/ajax/save_layout',
		type: 'post',
		data: 'layout='+ encodeURIComponent(JSON.stringify(tables)),
		success: function(){
			// do nothing
		}
	})

	
	
}

function toggleLayout(){
	$('#table-view').toggleClass('vui-btn-blue');
	$('.table-layout').toggle();		
}

function checkTables(){
	
	$('.layout-unit').each(function(){
		var table = ($(this).text()).trim();
		if ($('li[tableno='+table+']').length == 0){
			$(this).removeClass('occupied-table');			
		} else {
			$(this).addClass('occupied-table');
		}
	})
}

setInterval(function(){
	checkTables();
}, 1000);