var inventorySynchronized = false;
var saleSynchronized = false;
var itemSyncBuffer = 200;
var syncSales = [];
var syncSaleItems = [];
var db; 



function syncRoutine(){
	
	setInterval(function(){
		upSync();
	}, 10000);
	
}

function syncTime(){
	var start = Date.now();
	$.ajax({
		url: 'pos/sync/time',
		type: 'post',
		data: 'time='+start.getTime(),
		success: function(){
			
		}
	})
}

function clearDB(callback){
	db.transaction(function(tx){
		tx.executeSql("DROP TABLE IF EXISTS inventory");
		tx.executeSql("DROP TABLE IF EXISTS sales");
		tx.executeSql("DROP TABLE IF EXISTS sale_items");
		tx.executeSql("DROP TABLE IF EXISTS employees",[],function(){

			try {
				callback();
			} catch (err){
				// do nothing
			}
		});
	});
}

var __table_inventory = { 
	name: 'inventory',
	fields: {
		id				: 'INT',
		image			: 'TEXT',
		primary_image	: 'TEXT',
		category		: 'TEXT',
		subcategory		: 'TEXT',
		brand			: 'TEXT',
		location		: 'TEXT',
		name 			: 'TEXT',
	    model_no 		: 'TEXT',
	    warranty 		: 'TEXT',
	    sku 			: 'TEXT',
	    sku2 			: 'TEXT',
	    sku3 			: 'TEXT',
	    sku4 			: 'TEXT',
	    qty 			: 'TEXT',
	    alert_quantity 	: 'TEXT',
	    max_quantity 	: 'TEXT',
	    cost 			: 'TEXT',
	    average_cost 	: 'TEXT',
	    price 			: 'TEXT',
	    price_2 		: 'TEXT',
	    price_3 		: 'TEXT',
	    price2 			: 'TEXT',
	    price2_2 		: 'TEXT',
	    price2_3 		: 'TEXT',
	    price3 			: 'TEXT',
	    price3_2 		: 'TEXT',
	    price3_3 		: 'TEXT',
	    price4 			: 'TEXT',
	    price4_2 		: 'TEXT',
	    price4_3 		: 'TEXT',
	    description 	: 'TEXT',
	    supplier 		: 'TEXT',
	    remarks 		: 'TEXT',
	    ordered_quantity: 'TEXT',
	    is_active		: 'TEXT',
	    is_consigned	: 'TEXT',
	    quick			: 'TEXT',
	    adjust_cost		: 'TEXT',
	    enter_price		: 'TEXT',
	    enter_serial	: 'TEXT',
	    tags 			: 'TEXT',
	    added_on		: 'TEXT',
	    added_by 		: 'TEXT',
	    modified_on 	: 'TEXT',
	    modified_by 	: 'TEXT',
	    redeemable 		: 'TEXT',
	    redeem_points 	: 'TEXT',
	    current_po 		: 'TEXT',
	    current_po_item : 'TEXT',
	    uom1 			: 'TEXT',
	    uom2 			: 'TEXT',
	    uom3 			: 'TEXT',
	    uom4 			: 'TEXT',
	    loose_qty2 		: 'TEXT',
	    loose_qty3 		: 'TEXT',
	    loose_qty4 		: 'TEXT',
	    weight 			: 'TEXT',
	    weight_unit 	: 'TEXT',
	    weight2			: 'TEXT',
	    weight3			: 'TEXT',
	    weight4			: 'TEXT',
	    volume 			: 'TEXT',
	    volume_unit 	: 'TEXT',
	    volume2			: 'TEXT',
	    volume3			: 'TEXT',
	    volume4			: 'TEXT',
	    min_cart_qty 	: 'TEXT',
	    max_cart_qty 	: 'TEXT',
	    ready_for_sale 	: 'TEXT',
	    last_sold 		: 'TEXT',
	    isbn 			: 'TEXT',
	    links 			: 'TEXT',
	    linked 			: 'TEXT',
	    author 			: 'TEXT',
	    publisher 		: 'TEXT',
	    lastchange 		: 'TEXT',
	    order			: 'TEXT',
	    warehouse_id	: 'TEXT'
	}
};

var __table_sales = {
	name: 'sales',
	fields: {
		id 				: 'INT',
	   	user_id			: 'INT',
	   	username 		: 'TEXT',
	   	type 			: 'TEXT',
	   	datetime 		: 'TEXT',
	   	payment_status 	: 'TEXT',
	   	cost 			: 'TEXT',
	   	cc_cost 		: 'TEXT',
	   	amount 			: 'TEXT',
	   	amount_tendered : 'TEXT',
	   	amount_change 	: 'TEXT',
	   	payment_method 	: 'TEXT',
	   	payment_details : 'TEXT',
	   	terminal 		: 'TEXT',
	   	session 		: 'TEXT',
	   	discount 		: 'TEXT',
	   	discount_type 	: 'TEXT',
	   	adjustment 		: 'TEXT',
	   	amount_cc 		: 'TEXT',
	   	amount_cheque 	: 'TEXT',
	   	amount_credit 	: 'TEXT',
	   	amount_cash 	: 'TEXT',
	   	cheque_received : 'TEXT',
	   	card_type 		: 'TEXT',
	   	customer_id 	: 'INT',
	   	customer 		: 'TEXT',
	   	payment 		: 'TEXT',
	   	member_id 		: 'TEXT',
	   	customer_phone 	: 'TEXT',
	   	fnb 			: 'TEXT',
	   	sync 			: 'TEXT',
	   	sync_time 		: 'TEXT',
	   	pseudo_id 		: 'INT',
	   	client_sync_time: 'TEXT',
	   	warehouse_id 	: 'INT'
	}
};

var __table_sale_items = {
	name: 'sale_items',
	fields:  {
		id 				: 'INT',
	    date 			: 'TEXT',
	    sale_id 		: 'INT',
	    pseudo_id 		: 'INT',
	    item_id 		: 'INT',
	    item_sku 		: 'TEXT',
	    item_sku2 		: 'TEXT',
	    item_name 		: 'TEXT',
	    sku_select 		: 'TEXT',
	    qty 			: 'INT',
	    qty_fraction 	: 'TEXT',
	    unit 			: 'TEXT',
	    price_per_unit 	: 'TEXT',
	    margin 			: 'TEXT',
	    cost 			: 'TEXT',
	    discount_type 	: 'TEXT',
	    discount_value 	: 'TEXT',
	    discount_amount : 'TEXT',
	    global_discount : 'TEXT',
	    amount 			: 'TEXT',
	    tax 			: 'TEXT',
	    sold 			: 'TEXT',
	    terminal 		: 'TEXT',
	    session 		: 'TEXT',
	    is_redemption 	: 'TEXT',
	    member_id 		: 'TEXT',
	    points 			: 'TEXT',
	    redeemed 		: 'TEXT',
	    serial_no 		: 'TEXT',
	    fnb 			: 'TEXT',
	    sync 			: 'TEXT',
	    sync_time 		: 'TEXT',
	    client_sync_time: 'TEXT',
	    warehouse_id 	: 'TEXT',
	    global_discount_type : 'TEXT'
	}
};

var __table_users = {
	name: 'users',
	fields: {
		id 				: 'INT',
		username 		: 'TEXT',
		password 		: 'TEXT',
		dob 			: 'TEXT',
		type 			: 'TEXT',
		gender 			: 'TEXT',
		email 			: 'TEXT',
		firstname 		: 'TEXT',
		lastname 		: 'TEXT',
		phone 			: 'TEXT',
		mobile 			: 'TEXT',
		role 			: 'TEXT',
		ip 				: 'TEXT',
		last_login 		: 'TEXT',
		session  		: 'TEXT',
		timeout 		: 'TEXT',
		active 			: 'TEXT',
		terminal_active		: 'TEXT',
		terminal_type		: 'TEXT',
		terminal_identifier	: 'TEXT',
		terminal_ip			: 'TEXT',
		terminal_session	: 'TEXT',
		terminal_last_login	: 'TEXT',
		terminal_id			: 'TEXT',
		terminal_name		: 'TEXT',
		flag 			: 'TEXT',
		hash 			: 'TEXT',
		status 			: 'TEXT',
		data 			: 'TEXT',
		division		: 'TEXT',
		added_on 		: 'TEXT',
		added_by 		: 'TEXT',
		modified_on 	: 'TEXT',
		modified_by 	: 'TEXT'
	}
};



var __table_cache = {
	name: 'cache',
	fields: {
		info			: 'TEXT',
		values			: 'TEXT'
	}
};


function createTable(tableData){
	var sql = 'CREATE TABLE IF NOT EXISTS ' + tableData.name + '(';
	
	var x = 0;
	for (var field in tableData.fields){
		if (x == 0) sql += field + ' ' + tableData.fields[field];
		else sql += ', ' + field + ' ' + tableData.fields[field];
		
		x++;
	}
	sql += ')';
	
	
	db.transaction(function(tx){
		tx.executeSql(sql);
	});
}


function initDB(){

	createTable(__table_cache);
	createTable(__table_inventory);
	createTable(__table_sales);
	createTable(__table_sale_items);
	createTable(__table_users);
	    	
    setTimeout(function(){
    	synchronizeInventory(0);
    	synchronizeUsers();
    }, 200);
		

}


function synchronizeInventory(i){
	
	sysAlert('SYNC: REQUESTING INVENTORY DATA', 'IMPLICIT');
	sysAlert('Requesting Inventory Data', 'EXPLICIT');
	
	var request = $.ajax({
		url: base_url + 'pos/sync/request_inventory/',
		data: 'buffer='+itemSyncBuffer+'&position='+i,
		type: 'post',
		dataType: 'json',
		success: function(res){
			
			if (i != 0) base = i * itemSyncBuffer;
			else base = 0;
			
			sysAlert('SYNC: SYNCRHONIZING INVENTORY DATA BUFFER:' + i, 'IMPLICIT');
			sysAlert('SYNC: ITEMS BUFFER - ' + (res.results).length, 'IMPLICIT');


			
			for (var x = 0; x < (res.results).length; x++){
				sysAlert('SYNC: ITEM - ' + (base + x + 1), 'IMPLICIT');
				sysAlert('Synchronizing Item ' +  (base + x + 1), 'EXPLICIT');
				var item = res.results[x];
				getData('inventory','id = ' + item.id,function(res,xitem){
					if (!res) insertData('inventory', xitem);
				}, item);
			}
			
			if (!res.complete) synchronizeInventory(i+1);
			else synchronizeSalesSession();
		}
	});
	
}

function synchronizeUsers(){
	sysAlert('SYNC: REQUESTING USER DATA', 'IMPLICIT');
	sysAlert('Requesting User Data', 'EXPLICIT');
	
	var request = $.ajax({
		url: base_url + 'pos/sync/users',
		dataType: 'json',
		success: function (res){
			sysAlert('SYNC: SYNCRHONIZING USER DATA', 'IMPLICIT');

			console.log(res);
			
			for (var x = 0; x < (res.user_data).length; x++){
				sysAlert('SYNC: USER - ' + (x + 1), 'IMPLICIT');
				var user_data = res.user_data[x] ;
				
				getData('users','id = ' + user_data.id, function(res, xuser_data){
					if (!res){
						insertData('users',xuser_data, function(){
							sysAlert('SYNC: ADDED USER', 'IMPLICIT');					
						});
					} else {
						updateData('users', xuser_data, 'id = '+ xuser_data.id, function(){
							sysAlert('SYNC: UPDATED USER', 'IMPLICIT');
						});
					}
				}, user_data);
			}
		}
		
	})
}

function synchronizeSalesSession(){
	sysAlert('SYNC: REQUESTING SALES SESSION DATA', 'IMPLICIT');
	sysAlert('Requesting Session Sales Data', 'EXPLICIT');
	
	var request = $.ajax({
		url: base_url + 'pos/sync/session_sales_data',
		dataType: 'json',
		success: function(res){
			sysAlert('SYNC: SYNCRHONIZING SESSION SALES DATA', 'IMPLICIT');
			
			for (var x = 0; x < (res.sales_data).length; x++){
				sysAlert('SYNC: SALE - ' + (x + 1), 'IMPLICIT');
				sysAlert('Synchronizing Sale Entry ' + (x + 1), 'EXPLICIT');
				var sale_data = res.sales_data[x];

				getData('sales','id = ' + sale_data.id,function(res, xsale_data){
					if (!res) insertData('sales',xsale_data);
				}, sale_data);
			}

			for (var x = 0; x < (res.sale_items_data).length; x++){
				sysAlert('SYNC: SALE ITEM - ' + (x + 1), 'IMPLICIT');
				sysAlert('Synchronizing Sale Items Entry ' + (x + 1), 'EXPLICIT');
				var sale_item_data = res.sale_items_data[x];

				getData('sale_items','id = ' + sale_item_data.id,function(res, xsale_item_data){
					if (!res) insertData('sale_items',xsale_item_data);
				}, sale_item_data);
			}
			
			sysAlert('Synchronization Complete!', 'EXPLICIT');
			fadeSysAlert();
			getQueueList();

		}
	})
}


function upSync(){
	
	db.transaction(function(tx){
		console.log('UP SYNC LEVEL 1');
		tx.executeSql("SELECT * FROM sales WHERE type = 'history' AND sync = '0'", [], function(tx,res){
			console.log('UP SYNC LEVEL 2');
			syncSales = [];
			syncSaleItems = [];
			
			
			if (!res.rows.length) return;
			for (var i = 0; i < res.rows.length; i++){
				syncSales[i] = res.rows.item(i);;
			}
			
			tx.executeSql("SELECT * FROM sale_items WHERE sold = '1' AND sync = '0'", [], function(tx,res){
				console.log('UP SYNC LEVEL 3');
				
				if (!res.rows.length) return;	
				for (var i = 0; i < res.rows.length; i++){
					syncSaleItems[i] = res.rows.item(i);
				}
				
				var sales = JSON.stringify(syncSales);
				var sale_items = JSON.stringify(syncSaleItems);
				

				$.ajax({
					url: base_url + 'pos/sync/upstream_sync_sales',
					type: 'post',
					data: 'sales='+encodeURIComponent(sales)+'&sale_items='+encodeURIComponent(sale_items),
					dataType: 'json',
					success: function (data){
						console.log(data);
						
						for (var i = 0; i < data.length; i++){
							var sale = data[i];
							console.log('SERIALIZE ' + sale.pseudo_id);
							reserializeSync(sale.id, sale.pseudo_id, sale.time);
						}
						
						sysAlert('Synchronized', 'EXPLICIT');
						fadeSysAlert();
					}
					
				})
				
			});
			
		});
		
	})
}

function reserializeSync(id, pseudo_id, time){
	db.transaction(function(tx){

		tx.executeSql("UPDATE sales SET id = ?, sync_time = ?, sync = '1' WHERE pseudo_id = ?", [id, time, pseudo_id], function(tx,res){
			console.log('RESERIALIZE SALE ' + pseudo_id + ' TO ' + id + ' TIME ' + time);
		});
		
		tx.executeSql("UPDATE sale_items SET sale_id = ? WHERE pseudo_id = ?",[id, pseudo_id], function(tx,res){
			console.log('RESERIALIZE SALE ITEMS ' + pseudo_id + ' TO ' + id + ' TIME ' + time);
		});

	});

}





function sysAlert(alertText, type){
	switch (type){
		case "EXPLICIT":
			$('div.explicit').html('<strong>System Alert</strong><br />'+alertText).fadeIn();
			$('div.overlay').show();
			break;
		case "IMPLICIT":
			console.log(alertText);
			break;
		case "SUBTLE":
			$('div.explicit').html('<strong>System Alert</strong><br />'+alertText).fadeIn();
			break;
		default: 
			alert(alertText);
			break;
	}
}

function fadeSysAlert(){
	$('div.overlay').hide();
	setTimeout(function(){
		$('div.explicit').fadeOut();
	}, 1500);
}

function getData(table, where, callback, xitem){

	db.transaction(function(tx){
	    tx.executeSql('SELECT * FROM ' + table + ' WHERE ' + where,[], function(tx, res){
	    	if (res.rows.length){
	    		try {
	    			callback(res.rows.item(0), xitem);
	    		} catch (err){
	    			// do nothing
	    		}
	    	} else {
	    		try {
	    			callback(false, xitem);
	    		} catch (err){
	    			// do nothing
	    		}
	    	} 
	    })
	});
}

function insertData(table, data, callback){
	setTimeout(function(){
		db.transaction(function(tx){	
			var fields = '';
			var values = '';
			for (var field in data){
				if (!fields) fields += field;
				else fields += ', ' + field;
				
				var escapedValue = (data[field] + '').replace("'","\'");
				
				if (!values) values += "'" + escapedValue + "'";
				else values += ', ' + "'" + escapedValue + "'";
			}
			
			var sqlString = 'INSERT INTO ' + table;
			sqlString += ' (' + fields + ') ';
			sqlString += ' VALUES (' + values + ')';
			
	
			tx.executeSql(sqlString,[],function(){
				try {
					callback();
				} catch(err) {
					// do nothing{
				}
			});
		});
	}, 1);
}

function updateData(table, data, where, callback){
	setTimeout(function(){
		db.transaction(function(tx){	
	
			var set = '';
			for (var field in data){
				
				var escapedValue = (data[field] + '').replace("'","\'");
				
				if (!set) set += field + " = '"  + escapedValue + "'";
				else set += ', ' + field + " = '"  + escapedValue + "'";
			}
			
			var sqlString = 'UPDATE ' + table;
			sqlString += ' SET ' + set;
			sqlString += ' WHERE ' + where;
			
	
			tx.executeSql(sqlString,[],function(){
				try {
					callback();
				} catch (err) {
					// do nothing
				}
			});
		});
	}, 1);
}

function deleteRow(table, where, callback){
	db.transaction(function(tx){
		var sqlString = 'DELETE FROM ' + table;
		sqlString += ' WHERE ' + where;
		
		tx.executeSql(sqlString);
		
		try {
			callback()
		} catch(err) {
			// do nothing
		}
	});
}


JSON.stringify = JSON.stringify || function (obj) {
    var t = typeof (obj);
    if (t != "object" || obj === null) {
        // simple data type
        if (t == "string") obj = '"'+obj+'"';
        return String(obj);
    }
    else {
        // recurse array or object
        var n, v, json = [], arr = (obj && obj.constructor == Array);
        for (n in obj) {
            v = obj[n]; t = typeof(v);
            if (t == "string") v = '"'+v+'"';
            else if (t == "object" && v !== null) v = JSON.stringify(v);
            json.push((arr ? "" : '"' + n + '":') + String(v));
        }
        return (arr ? "[" : "{") + String(json) + (arr ? "]" : "}");
    }
};
